/**
 * Modules in this bundle
 * @license
 *
 * thin-hook:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   author: Tetsuya Mori <t2y3141592@gmail.com>
 *   homepage: https://github.com/t2ym/thin-hook#readme
 *   version: 0.4.0-alpha.61
 *
 * acorn:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   maintainers: Marijn Haverbeke <marijnh@gmail.com>, Ingvar Stepanyan <me@rreverser.com>
 *   contributors: List of Acorn contributors. Updated before every release., Adrian Heine, Adrian Heine né Lang, Adrian Rakovsky, Alistair Braidwood, Amila Welihinda, Andres Suarez, Angelo, Aparajita Fishman, Arian Stolwijk, Artem Govorov, Bradley Heinz, Brandon Mills, Charles Hughes, Charmander, Conrad Irwin, Daniel Tschinder, David Bonnet, Domenico Matteo, ehmicky, Felix Maier, Forbes Lindesay, Gilad Peleg, impinball, Ingvar Stepanyan, Jackson Ray Hamilton, Jesse McCarthy, Jiaxing Wang, Joel Kemp, Johannes Herr, John-David Dalton, Jordan Klassen, Jürg Lehni, Kai Cataldo, keeyipchan, Keheliya Gallaba, Kevin Irish, Kevin Kwok, krator, laosb, Marek, Marijn Haverbeke, Martin Carlberg, Mat Garcia, Mathias Bynens, Mathieu 'p01' Henri, Matthew Bastien, Max Schaefer, Max Zerzouri, Mihai Bazon, Mike Rennie, naoh, Nicholas C. Zakas, Nick Fitzgerald, Olivier Thomann, Oskar Schöldström, Paul Harper, Peter Rust, PlNG, Prayag Verma, ReadmeCritic, r-e-d, Richard Gibson, Rich Harris, Sebastian McKenzie, Shahar Soel, Simen Bekkhus, Teddy Katz, Timothy Gu, Toru Nagashima, Victor Homyakov, Wexpo Lyu, zsjforcn
 *   homepage: https://github.com/acornjs/acorn
 *   version: 5.3.0
 *
 * acorn-dynamic-import:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Jordan Gensler <jordangens@gmail.com>
 *   homepage: https://github.com/kesne/acorn-dynamic-import
 *   version: 2.0.2
 *
 * acorn-jsx:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   maintainers: Ingvar Stepanyan <me@rreverser.com>
 *   homepage: https://github.com/RReverser/acorn-jsx
 *   version: 3.0.1
 *
 * base64-js:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: T. Jameson Little <t.jameson.little@gmail.com>
 *   homepage: https://github.com/beatgammit/base64-js
 *   version: 1.5.1
 *
 * buffer:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Feross Aboukhadijeh <feross@feross.org>
 *   contributors: Romain Beauxis <toots@rastageeks.org>, James Halliday <mail@substack.net>
 *   homepage: https://github.com/feross/buffer
 *   version: 5.7.1
 *
 * convert-source-map:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Thorsten Lorenz <thlorenz@gmx.de>
 *   homepage: https://github.com/thlorenz/convert-source-map
 *   version: 1.9.0
 *
 * core-util-is:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Isaac Z. Schlueter <i@izs.me>
 *   homepage: https://github.com/isaacs/core-util-is#readme
 *   version: 1.0.3
 *
 * dom-serializer:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Felix Boehm <me@feedic.com>
 *   homepage: https://github.com/cheeriojs/dom-renderer#readme
 *   version: 0.2.2
 *
 * domelementtype:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   author: Felix Boehm <me@feedic.com>
 *   homepage: https://github.com/fb55/domelementtype#readme
 *   version: 1.3.1
 *
 * domhandler:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   author: Felix Boehm <me@feedic.com>
 *   homepage: https://github.com/fb55/DomHandler#readme
 *   version: 2.4.2
 *
 * domutils:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   author: Felix Boehm <me@feedic.com>
 *   homepage: https://github.com/FB55/domutils#readme
 *   version: 1.7.0
 *
 * entities:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   author: Felix Boehm <me@feedic.com>
 *   homepage: https://github.com/fb55/entities#readme
 *   version: 1.1.2
 *
 * escodegen:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   maintainers: Yusuke Suzuki <utatane.tea@gmail.com>
 *   homepage: http://github.com/estools/escodegen
 *   version: 1.9.0
 *
 * espree:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   author: Nicholas C. Zakas <nicholas+npm@nczconsulting.com>
 *   homepage: https://github.com/eslint/espree
 *   version: 3.5.2
 *
 * estraverse:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   maintainers: Yusuke Suzuki <utatane.tea@gmail.com>
 *   homepage: https://github.com/estools/estraverse
 *   version: 4.3.0
 *
 * esutils:
 *   license: BSD-2-Clause (http://opensource.org/licenses/BSD-2-Clause)
 *   maintainers: Yusuke Suzuki <utatane.tea@gmail.com>
 *   homepage: https://github.com/estools/esutils
 *   version: 2.0.3
 *
 * events:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Irakli Gozalishvili <rfobic@gmail.com>
 *   homepage: https://github.com/Gozala/events#readme
 *   version: 1.1.1
 *
 * he:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Mathias Bynens
 *   homepage: https://mths.be/he
 *   version: 1.2.0
 *
 * htmlparser2:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Felix Boehm <me@feedic.com>
 *   homepage: https://github.com/fb55/htmlparser2#readme
 *   version: 3.9.2
 *
 * ieee754:
 *   license: BSD-3-Clause (http://opensource.org/licenses/BSD-3-Clause)
 *   author: Feross Aboukhadijeh <feross@feross.org>
 *   contributors: Romain Beauxis <toots@rastageeks.org>
 *   homepage: https://github.com/feross/ieee754#readme
 *   version: 1.2.1
 *
 * inherits:
 *   license: ISC (http://opensource.org/licenses/ISC)
 *   homepage: https://github.com/isaacs/inherits#readme
 *   version: 2.0.4
 *
 * isarray:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Julian Gruber <mail@juliangruber.com>
 *   homepage: https://github.com/juliangruber/isarray
 *   version: 1.0.0
 *
 * pako:
 *   license: MIT (http://opensource.org/licenses/MIT) AND Zlib (http://opensource.org/licenses/Zlib)
 *   contributors: Andrei Tuputcyn, Vitaly Puzrin, Friedel Ziegelmayer, Kirill Efimov, Jean-loup Gailly, Mark Adler
 *   homepage: https://github.com/nodeca/pako
 *   version: 1.0.11
 *
 * path-browserify:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: James Halliday <mail@substack.net>
 *   homepage: https://github.com/substack/path-browserify
 *   version: 0.0.1
 *
 * process:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Roman Shtylman <shtylman@gmail.com>
 *   homepage: https://github.com/shtylman/node-process#readme
 *   version: 0.11.10
 *
 * process-nextick-args:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   homepage: https://github.com/calvinmetcalf/process-nextick-args
 *   version: 2.0.1
 *
 * readable-stream:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   homepage: https://github.com/nodejs/readable-stream#readme
 *   version: 2.3.8
 *
 * safe-buffer:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Feross Aboukhadijeh <feross@feross.org>
 *   homepage: https://github.com/feross/safe-buffer
 *   version: 5.2.1
 *
 * sha.js:
 *   license: MIT (http://opensource.org/licenses/MIT) AND BSD-3-Clause (http://opensource.org/licenses/BSD-3-Clause)
 *   author: Dominic Tarr <dominic.tarr@gmail.com>
 *   homepage: https://github.com/crypto-browserify/sha.js
 *   version: 2.4.11
 *
 * source-map:
 *   license: BSD-3-Clause (http://opensource.org/licenses/BSD-3-Clause)
 *   author: Nick Fitzgerald <nfitzgerald@mozilla.com>
 *   contributors: Tobias Koppers <tobias.koppers@googlemail.com>, Duncan Beevers <duncan@dweebd.com>, Stephen Crane <scrane@mozilla.com>, Ryan Seddon <seddon.ryan@gmail.com>, Miles Elam <miles.elam@deem.com>, Mihai Bazon <mihai.bazon@gmail.com>, Michael Ficarra <github.public.email@michael.ficarra.me>, Todd Wolfson <todd@twolfson.com>, Alexander Solovyov <alexander@solovyov.net>, Felix Gnass <fgnass@gmail.com>, Conrad Irwin <conrad.irwin@gmail.com>, usrbincc <usrbincc@yahoo.com>, David Glasser <glasser@davidglasser.net>, Chase Douglas <chase@newrelic.com>, Evan Wallace <evan.exe@gmail.com>, Heather Arthur <fayearthur@gmail.com>, Hugh Kennedy <hughskennedy@gmail.com>, David Glasser <glasser@davidglasser.net>, Simon Lydell <simon.lydell@gmail.com>, Jmeas Smith <jellyes2@gmail.com>, Michael Z Goddard <mzgoddard@gmail.com>, azu <azu@users.noreply.github.com>, John Gozde <john@gozde.ca>, Adam Kirkton <akirkton@truefitinnovation.com>, Chris Montgomery <christopher.montgomery@dowjones.com>, J. Ryan Stinnett <jryans@gmail.com>, Jack Herrington <jherrington@walmartlabs.com>, Chris Truter <jeffpalentine@gmail.com>, Daniel Espeset <daniel@danielespeset.com>, Jamie Wong <jamie.lf.wong@gmail.com>, Eddy Bruël <ejpbruel@mozilla.com>, Hawken Rives <hawkrives@gmail.com>, Gilad Peleg <giladp007@gmail.com>, djchie <djchie.dev@gmail.com>, Gary Ye <garysye@gmail.com>, Nicolas Lalevée <nicolas.lalevee@hibnet.org>
 *   homepage: https://github.com/mozilla/source-map
 *   version: 0.5.7
 *
 * stream-browserify:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: James Halliday <mail@substack.net>
 *   homepage: https://github.com/browserify/stream-browserify
 *   version: 2.0.2
 *
 * string_decoder:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   homepage: https://github.com/rvagg/string_decoder
 *   version: 1.0.3
 *
 * timers-browserify:
 *   licenses: MIT (http://opensource.org/licenses/MIT)
 *   author: J. Ryan Stinnett <jryans@gmail.com>
 *   contributors: Guy Bedford <guybedford@gmail.com>, Ionut-Cristian Florescu <ionut.florescu@gmail.com>, James Halliday <mail@substack.net>, Jan Schär <jscissr@gmail.com>, Johannes Ewald <johannes.ewald@peerigon.com>, Jonathan Prins <jon@blip.tv>, Matt Esch <matt@mattesch.info>
 *   homepage: https://github.com/jryans/timers-browserify
 *   version: 1.4.2
 *
 * util-deprecate:
 *   license: MIT (http://opensource.org/licenses/MIT)
 *   author: Nathan Rajlich <nathan@tootallnate.net>
 *   homepage: https://github.com/TooTallNate/util-deprecate
 *   version: 1.0.2
 *
 * This header is generated by licensify (https://github.com/twada/licensify)
 */
(function(f){if(typeof exports==='object'&&typeof module!=='undefined'){module.exports=f();}else if(typeof define==='function'&&define.amd){define([],f);}else{var g;if(typeof window!=='undefined'){g=window;}else if(typeof global!=='undefined'){g=global;}else if(typeof self!=='undefined'){g=self;}else{g=this;}Object.defineProperty(g,'hook',{configurable:g.constructor.name==='ServiceWorkerGlobalScope',enumerable:false,writable:false,value:f()});Object.defineProperty(g,'$hook$',{configurable:g.constructor.name==='ServiceWorkerGlobalScope',enumerable:false,writable:false,value:g.hook});if(g.constructor.name==='ServiceWorkerGlobalScope'){for(let h in hook.serviceWorkerHandlers){g.addEventListener(h,hook.serviceWorkerHandlers[h]);}}if(g.constructor.name==='Window'){hook.registerServiceWorker();}}}(function(){var define,module,exports;const _global_=new Function("return this")();const Reflect=_global_.Reflect,String=_global_.String,Array=_global_.Array,RegExp=_global_.RegExp,Object=_global_.Object,Uint8Array=_global_.Uint8Array,RangeError=_global_.RangeError,parseInt=_global_.parseInt,parseFloat=_global_.parseFloat,ArrayBuffer=_global_.ArrayBuffer,Symbol=_global_.Symbol,setTimeout=_global_.setTimeout,clearTimeout=_global_.clearTimeout,URL=_global_.URL,console=_global_.console,JSON=_global_.JSON;return function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c='function'==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error('Cannot find module \''+i+'\'');throw a.code='MODULE_NOT_FOUND',a;}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r);},p,p.exports,r,e,n,t);}return n[i].exports;}for(var u='function'==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o;}return r;}()({1:[function(require,module,exports){const espree=require('espree');const escodegen=require('escodegen');const htmlparser=require('htmlparser2');const createHash=require('sha.js');const convert=require('convert-source-map');const he=require('he');const zlib=require('pako');const {parseFromString}=require('import-maps/reference-implementation/lib/parser.js');const {resolve}=require('import-maps/reference-implementation/lib/resolver.js');const preprocess=require('./lib/preprocess.js')(espree,escodegen,htmlparser,createHash,convert,he);const hook=preprocess.hook;const serviceWorker=require('./lib/service-worker.js')(hook,preprocess);const contextGenerators=require('./lib/context-generator.js')(hook);const hookCallbacks=require('./lib/hook-callback.js')(hook,preprocess);const nativeWrappers=require('./lib/native-wrapper.js')(hook,preprocess,he);module.exports=Object.freeze(Object.assign(hook,preprocess.public,hookCallbacks,contextGenerators,serviceWorker,nativeWrappers,{utils:{createHash:createHash,HTMLParser:htmlparser,zlib:zlib,importMaps:{parseFromString:parseFromString,resolve:resolve}},parameters:{}}));},{'./lib/context-generator.js':2,'./lib/hook-callback.js':3,'./lib/native-wrapper.js':4,'./lib/preprocess.js':5,'./lib/service-worker.js':6,'convert-source-map':15,'escodegen':44,'espree':46,'he':61,'htmlparser2':69,'import-maps/reference-implementation/lib/parser.js':71,'import-maps/reference-implementation/lib/resolver.js':72,'pako':76,'sha.js':97}],2:[function(require,module,exports){module.exports=function(hook){function generateAstPathContext(astPath){return astPath.map(([path,node])=>node&&node.type?'['+path+']'+node.type+(node.id&&node.id.name?':'+node.id.name:node.key&&node.key.name?':'+(node.kind==='get'||node.kind==='set'?node.kind+' ':node.static?'static ':'')+node.key.name:''):path).join(',');}function generateOldMethodContext(astPath){return astPath.map(([path,node],index)=>node&&node.type?node.id&&node.id.name?node.id.name:node.key&&node.key.name?(node.kind==='get'||node.kind==='set'?node.kind+' ':node.static?'static ':'')+node.key.name:'':index===0?path:'').filter(p=>p).join(',');}function generateMethodContext(astPath){let result;let i;let p,n,l=astPath.length;for(i=l-1;i>=0;i--){p=astPath[i];n=p[1];result=p[3];if(result){break;}else{p[2]=i>0?n.id&&n.id.name?n.__moved__?'':n.id.name:n.key&&(n.key.name||n.key.value)&&(!n.computed||n.computed&&(n.key.type==='Identifier'||n.key.type==='Literal'))?(n.kind==='get'||n.kind==='set'?n.kind+' ':n.static?'static ':'')+(n.key.name||n.key.value):'':p[0];}}if(!result){i=0;result=astPath[0][3]=astPath[0][2];}for(i++;i<l;i++){p=astPath[i];if(p[2]){result+=','+p[2];}p[3]=result;}return result;}function generateCachedMethodDebugContext(astPath){let oldMethod=generateOldMethodContext(astPath);let result=generateMethodContext(astPath);if(result!==method){console.warn('generateCachedMethodDebugContext: \noldMethod    = '+method+'\ncachedMethod = '+result);}return result;}if(typeof self!=='undefined'&&self.constructor.name==='ServiceWorkerGlobalScope'){console.warn('[context-generator compatibility] Please be warned that "cachedMethod" is renamed as "method" and the old "method" is renamed as "oldMethod"');}return Object.freeze({contextGenerators:{'null':()=>'','astPath':generateAstPathContext,'method':generateMethodContext,'cachedMethod':generateMethodContext,'cachedMethodDebug':generateCachedMethodDebugContext,'oldMethod':generateOldMethodContext}});};},{}],3:[function(require,module,exports){module.exports=function(hook,preprocess){function __hook_except_properties__(f,thisArg,args,context,newTarget){return newTarget?Reflect.construct(f,args):thisArg?f.apply(thisArg,args):f(...args);}const _global=new Function('return this')();class StrictModeWrapper{static['#.'](o,p){return o[p];}static['#[]'](o,p){return o[p];}static['#*'](o){return o;}static['#in'](o,p){return p in o;}static['#()'](o,p,a){return o[p](...a);}static['#p++'](o,p){return o[p]++;}static['#++p'](o,p){return++o[p];}static['#p--'](o,p){return o[p]--;}static['#--p'](o,p){return--o[p];}static['#delete'](o,p){return delete o[p];}static['#='](o,p,v){return o[p]=v;}static['#+='](o,p,v){return o[p]+=v;}static['#-='](o,p,v){return o[p]-=v;}static['#*='](o,p,v){return o[p]*=v;}static['#/='](o,p,v){return o[p]/=v;}static['#%='](o,p,v){return o[p]%=v;}static['#**='](o,p,v){return o[p]**=v;}static['#<<='](o,p,v){return o[p]<<=v;}static['#>>='](o,p,v){return o[p]>>=v;}static['#>>>='](o,p,v){return o[p]>>>=v;}static['#&='](o,p,v){return o[p]&=v;}static['#^='](o,p,v){return o[p]^=v;}static['#|='](o,p,v){return o[p]|=v;}static['#.='](o,p){return{set ['='](v){o[p]=v;},get ['='](){return o[p];}};}}function __hook__(f,thisArg,args,context,newTarget,contextSymbol){contextSymbol=context;context=__hook__[context];let normalizedThisArg=thisArg;if(newTarget===false){let varName=args[0];let __with__=thisArg;let scope=_global;let _scope;let i;for(i=0;i<__with__.length;i++){_scope=__with__[i];if(Reflect.has(_scope,varName)){if(_scope[Symbol.unscopables]&&_scope[Symbol.unscopables][varName]){continue;}else{scope=_scope;break;}}}thisArg=normalizedThisArg=scope;}let result;let args1=args[1];function*gen(){}async function asf(){}let GeneratorFunction=gen.constructor;let AsyncFunction=asf.constructor;switch(f){case Function:args=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args);break;case AsyncFunction:args=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args,false,true);break;case GeneratorFunction:args=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args,true,false);break;case'()':case'#()':switch(thisArg){case Reflect:switch(args[0]){case'construct':if(args[1]){switch(args[1][0]){case Function:args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1])];if(args[1][2]){args1.push(args[1][2]);}break;case AsyncFunction:args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1],false,true)];if(args[1][2]){args1.push(args[1][2]);}break;case GeneratorFunction:args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1],true,false)];if(args[1][2]){args1.push(args[1][2]);}break;default:if(Function.isPrototypeOf(args[1][0])){args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1],GeneratorFunction.isPrototypeOf(args[1][0]),AsyncFunction.isPrototypeOf(args[1][0]))];if(args[1][2]){args1.push(args[1][2]);}}break;}}break;case'apply':if(args[1]){switch(args[1][0]){case Function:args1=[args[1][0],args[1][1],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][2])];break;case AsyncFunction:args1=[args[1][0],args[1][1],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][2],false,true)];break;case GeneratorFunction:args1=[args[1][0],args[1][1],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][2],true,false)];break;default:if(Function.isPrototypeOf(args[1][0])){args1=[args[1][0],args[1][1],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][2],GeneratorFunction.isPrototypeOf(args[1][0]),AsyncFunction.isPrototypeOf(args[1][0]))];}break;}}break;default:break;}break;case Function:switch(args[0]){case'apply':args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1])];break;case'call':args1=[args[1][0],...hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1].slice(1))];break;default:break;}break;case AsyncFunction:switch(args[0]){case'apply':args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1],false,true)];break;case'call':args1=[args[1][0],...hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1].slice(1),false,true)];break;default:break;}break;case GeneratorFunction:switch(args[0]){case'apply':args1=[args[1][0],hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1][1],true,false)];break;case'call':args1=[args[1][0],...hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1].slice(1),true,false)];break;default:break;}break;case undefined:break;default:if(args[0]==='constructor'){if(thisArg instanceof GeneratorFunction){args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1],true,false);}else if(thisArg instanceof AsyncFunction){args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1],false,true);}else if(thisArg instanceof Function){args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1]);}}else{switch(thisArg[args[0]]){case Function:args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1]);break;case AsyncFunction:args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1],false,true);break;case GeneratorFunction:args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1],true,false);break;default:break;}}break;}break;case's()':switch(args[2](args[0])){case Function:args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1]);break;case AsyncFunction:args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1],false,true);break;case GeneratorFunction:args1=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args[1],true,false);break;default:break;}break;default:if(typeof f==='function'){if(Function.isPrototypeOf(f)&&newTarget){args=hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args,GeneratorFunction.isPrototypeOf(f),AsyncFunction.isPrototypeOf(f));}else if(newTarget===''){if(Function.isPrototypeOf(args[0])){args=[args[0],...hook.FunctionArguments(Symbol.for('__hook__'),[[context,{}]],'method',args.slice(1),GeneratorFunction.isPrototypeOf(args[0]),AsyncFunction.isPrototypeOf(args[0]))];}}}break;}if(typeof f!=='string'){result=newTarget?Reflect.construct(f,args):thisArg?f.apply(thisArg,args):f(...args);}else{switch(f){case'.':case'[]':result=thisArg[args[0]];break;case'*':result=thisArg;break;case'in':result=args[0]in thisArg;break;case'()':result=thisArg[args[0]](...args1);break;case'p++':result=thisArg[args[0]]++;break;case'++p':result=++thisArg[args[0]];break;case'p--':result=thisArg[args[0]]--;break;case'--p':result=--thisArg[args[0]];break;case'delete':result=delete thisArg[args[0]];break;case'=':result=thisArg[args[0]]=args[1];break;case'+=':result=thisArg[args[0]]+=args[1];break;case'-=':result=thisArg[args[0]]-=args[1];break;case'*=':result=thisArg[args[0]]*=args[1];break;case'/=':result=thisArg[args[0]]/=args[1];break;case'%=':result=thisArg[args[0]]%=args[1];break;case'**=':result=thisArg[args[0]]**=args[1];break;case'<<=':result=thisArg[args[0]]<<=args[1];break;case'>>=':result=thisArg[args[0]]>>=args[1];break;case'>>>=':result=thisArg[args[0]]>>>=args[1];break;case'&=':result=thisArg[args[0]]&=args[1];break;case'^=':result=thisArg[args[0]]^=args[1];break;case'|=':result=thisArg[args[0]]|=args[1];break;case'.=':result={set ['='](v){thisArg[args[0]]=v;},get ['='](){return thisArg[args[0]];}};break;case'#.':case'#[]':result=StrictModeWrapper['#.'](thisArg,args[0]);break;case'#*':result=StrictModeWrapper['#*'](thisArg);break;case'#in':result=StrictModeWrapper['#in'](thisArg,args[0]);break;case'#()':result=StrictModeWrapper['#()'](thisArg,args[0],args1);break;case'#p++':result=StrictModeWrapper['#p++'](thisArg,args[0]);break;case'#++p':result=StrictModeWrapper['#++p'](thisArg,args[0]);break;case'#p--':result=StrictModeWrapper['#p--'](thisArg,args[0]);break;case'#--p':result=StrictModeWrapper['#--p'](thisArg,args[0]);break;case'#delete':result=StrictModeWrapper['#delete'](thisArg,args[0]);break;case'#=':result=StrictModeWrapper['#='](thisArg,args[0],args[1]);break;case'#+=':result=StrictModeWrapper['#+='](thisArg,args[0],args[1]);break;case'#-=':result=StrictModeWrapper['#-='](thisArg,args[0],args[1]);break;case'#*=':result=StrictModeWrapper['#*='](thisArg,args[0],args[1]);break;case'#/=':result=StrictModeWrapper['#/='](thisArg,args[0],args[1]);break;case'#%=':result=StrictModeWrapper['#%='](thisArg,args[0],args[1]);break;case'#**=':result=StrictModeWrapper['#**='](thisArg,args[0],args[1]);break;case'#<<=':result=StrictModeWrapper['#<<='](thisArg,args[0],args[1]);break;case'#>>=':result=StrictModeWrapper['#>>='](thisArg,args[0],args[1]);break;case'#>>>=':result=StrictModeWrapper['#>>>='](thisArg,args[0],args[1]);break;case'#&=':result=StrictModeWrapper['#&='](thisArg,args[0],args[1]);break;case'#^=':result=StrictModeWrapper['#^='](thisArg,args[0],args[1]);break;case'#|=':result=StrictModeWrapper['#|='](thisArg,args[0],args[1]);break;case'#.=':result=StrictModeWrapper['#.='](thisArg,args[0]);break;case's.':case's[]':result=args[1](args[0]);break;case's()':result=args[2](args[0]).apply(thisArg,args1);break;case's++':case'++s':case's--':case'--s':result=args[1].apply(thisArg,args);break;case's=':case's+=':case's-=':case's*=':case's/=':case's%=':case's**=':case's<<=':case's>>=':case's>>>=':case's&=':case's^=':case's|=':result=args[2].apply(thisArg,args);break;case'w.':case'w[]':result=args[1]();break;case'w()':result=args[2](...args[1]);break;case'wnew':result=args[2](...args[1]);break;case'w++':case'++w':case'w--':case'--w':result=args[1]();break;case'wtypeof':case'wdelete':result=args[1]();break;case'w.=':result=args[1];break;case'w=':case'w+=':case'w-=':case'w*=':case'w/=':case'w%=':case'w**=':case'w<<=':case'w>>=':case'w>>>=':case'w&=':case'w^=':case'w|=':result=args[2](args[1]);break;default:f();result=null;break;}}return result;}function hookCallbackCompatibilityTest(hookCallback=_global[preprocess.getHookNameForServiceWorker()],throwError=true,checkTypeError=true){let result=true;let reason='Unknown';let value;let error;do{if(!hookCallback){result=false;reason='hook: hook callback is undefined';break;}if(typeof hookCallback!=='function'){result=false;reason='hook: hook callback is not a function';break;}const stringContext='hook.hookCallbackCompatibilityTest';const c=Symbol();hookCallback[c]=stringContext;let tests=[[()=>[(a,b)=>a+b],p=>[p[0],null,[1,2],c],(v,p)=>v===3],[()=>[function f1(a,b){return this.a+a+b;},{a:2}],p=>[p[0],p[1],[2,3],c],(v,p)=>v===7],[()=>[class c1{constructor(a,b){this.r=a+b;}}],p=>[p[0],null,[2,3],c,true],(v,p)=>v instanceof p[0]&&v.r===5],[()=>[{a:2}],p=>['.',p[0],['a'],c],(v,p)=>v.a===p.a],[()=>[{a:2}],p=>['*',p[0],[],c],(v,p)=>v===p[0]],[()=>[{a:2}],p=>['in',p[0],['a'],c],(v,p)=>v===true],[()=>[class c2{static m(a,b){return a+b;}}],p=>['()',p[0],['m',[1,3]],c],(v,p)=>v===4],[()=>[{a:2}],p=>['p++',p[0],['a'],c],(v,p)=>v===2&&p[0].a===3],[()=>[{a:2}],p=>['++p',p[0],['a'],c],(v,p)=>v===3&&p[0].a===3],[()=>[{a:2}],p=>['p--',p[0],['a'],c],(v,p)=>v===2&&p[0].a===1],[()=>[{a:2}],p=>['--p',p[0],['a'],c],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['delete',p[0],['a'],c],(v,p)=>v===true&&!Reflect.has(p[0],'a')],[()=>[{a:2}],p=>['=',p[0],['a',5],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:2}],p=>['+=',p[0],['a',5],c],(v,p)=>v===7&&p[0].a===7],[()=>[{a:2}],p=>['-=',p[0],['a',5],c],(v,p)=>v===-3&&p[0].a===-3],[()=>[{a:2}],p=>['*=',p[0],['a',5],c],(v,p)=>v===10&&p[0].a===10],[()=>[{a:10}],p=>['/=',p[0],['a',2],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['%=',p[0],['a',3],c],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['**=',p[0],['a',3],c],(v,p)=>v===8&&p[0].a===8],[()=>[{a:2}],p=>['<<=',p[0],['a',3],c],(v,p)=>v===16&&p[0].a===16],[()=>[{a:16}],p=>['>>=',p[0],['a',2],c],(v,p)=>v===4&&p[0].a===4],[()=>[{a:-1}],p=>['>>>=',p[0],['a',1],c],(v,p)=>v===2147483647&&p[0].a===2147483647],[()=>[{a:10}],p=>['&=',p[0],['a',7],c],(v,p)=>v===2&&p[0].a===2],[()=>[{a:10}],p=>['^=',p[0],['a',15],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['|=',p[0],['a',7],c],(v,p)=>v===15&&p[0].a===15],[()=>[{a:2}],p=>['s.',p[0],['a',prop=>p[0][prop]],c],(v,p)=>v===2],[()=>[{a:2,m(a,b){return this.a+a+b;}}],p=>['s()',p[0],['m',[2,3],prop=>p[0][prop]],c],(v,p)=>v===7],[()=>[{a:2}],p=>['s++',p[0],['a',prop=>p[0][prop]++],c],(v,p)=>v===2&&p[0].a===3],[()=>[{a:2}],p=>['++s',p[0],['a',prop=>++p[0][prop]],c],(v,p)=>v===3&&p[0].a===3],[()=>[{a:2}],p=>['s--',p[0],['a',prop=>p[0][prop]--],c],(v,p)=>v===2&&p[0].a===1],[()=>[{a:2}],p=>['--s',p[0],['a',prop=>--p[0][prop]],c],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['s=',p[0],['a',5,(prop,value)=>p[0][prop]=value],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:2}],p=>['+=',p[0],['a',5,(prop,value)=>p[0][prop]+=value],c],(v,p)=>v===7&&p[0].a===7],[()=>[{a:2}],p=>['-=',p[0],['a',5,(prop,value)=>p[0][prop]-=value],c],(v,p)=>v===-3&&p[0].a===-3],[()=>[{a:2}],p=>['*=',p[0],['a',5,(prop,value)=>p[0][prop]*=value],c],(v,p)=>v===10&&p[0].a===10],[()=>[{a:10}],p=>['/=',p[0],['a',2],c,(prop,value)=>p[0][prop]/=value],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['%=',p[0],['a',3],c,(prop,value)=>p[0][prop]%=value],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['**=',p[0],['a',3],c,(prop,value)=>p[0][prop]**=value],(v,p)=>v===8&&p[0].a===8],[()=>[{a:2}],p=>['<<=',p[0],['a',3],c,(prop,value)=>p[0][prop]<<=value],(v,p)=>v===16&&p[0].a===16],[()=>[{a:16}],p=>['>>=',p[0],['a',2],c,(prop,value)=>p[0][prop]>>=value],(v,p)=>v===4&&p[0].a===4],[()=>[{a:-1}],p=>['>>>=',p[0],['a',1],c,(prop,value)=>p[0][prop]>>>=value],(v,p)=>v===2147483647&&p[0].a===2147483647],[()=>[{a:10}],p=>['&=',p[0],['a',7,(prop,value)=>p[0][prop]&=value],c],(v,p)=>v===2&&p[0].a===2],[()=>[{a:10}],p=>['^=',p[0],['a',15,(prop,value)=>p[0][prop]^=value],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['|=',p[0],['a',7,(prop,value)=>p[0][prop]|=value],c],(v,p)=>v===15&&p[0].a===15],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w.',p[0],['b',()=>p[1].b],c,false],(v,p)=>v===3],[()=>[[{a:true},{m:true}],{a:2,m(a,b){return a+b;}}],p=>['w()',p[0],['m',[2,3],(...args)=>p[1].m(...args),p[1].m],c,false],(v,p)=>v===5],[()=>[[{a:true},{m:true}],class c2{constructor(a,b){this.r=a+b;}}],p=>['wnew',p[0],['m',[2,3],(...args)=>new p[1](...args),p[1]],c,false],(v,p)=>v.r===5],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w++',p[0],['b',()=>p[1].b++],c,false],(v,p)=>v===3&&p[1].b===4],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['++w',p[0],['b',()=>++p[1].b],c,false],(v,p)=>v===4&&p[1].b===4],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w--',p[0],['b',()=>p[1].b--],c,false],(v,p)=>v===3&&p[1].b===2],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['--w',p[0],['b',()=>--p[1].b],c,false],(v,p)=>v===2&&p[1].b===2],[()=>[[{a:true},{b:true}],{a:2,b:true}],p=>['wtypeof',p[0],['b',()=>typeof p[1].b],c,false],(v,p)=>v==='boolean'],[()=>[[{a:true},{b:true}],{a:2,b:true}],p=>['wdelete',p[0],['b',()=>delete p[1].b],c,false],(v,p)=>v===true&&!Reflect.has(p[1],'b')],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w.=',p[0],['b',{set ['='](v){p[1].b=v;},get ['='](){return p[1].b;}}],c,false],(v,p)=>(v['=']=4)===4&&v['=']===4&&p[1].b===4],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w=',p[0],['b',5,v=>p[1].b=v],c,false],(v,p)=>v===5&&p[1].b===5],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w+=',p[0],['b',5,v=>p[1].b+=v],c,false],(v,p)=>v===8&&p[1].b===8],[()=>[[{a:true},{b:true}],{a:2,b:3}],p=>['w-=',p[0],['b',5,v=>p[1].b-=v],c,false],(v,p)=>v===-2&&p[1].b===-2],[()=>[[{a:true},{b:true}],{a:2,b:10}],p=>['w/=',p[0],['b',2,v=>p[1].b/=v],c,false],(v,p)=>v===5&&p[1].b===5],[()=>[[{a:true},{b:true}],{a:2,b:10}],p=>['w%=',p[0],['b',3,v=>p[1].b%=v],c,false],(v,p)=>v===1&&p[1].b===1],[()=>[[{a:true},{b:true}],{a:2,b:2}],p=>['w%=',p[0],['b',3,v=>p[1].b**=v],c,false],(v,p)=>v===8&&p[1].b===8],[()=>[[{a:true},{b:true}],{a:2,b:2}],p=>['w<<=',p[0],['b',3,v=>p[1].b<<=v],c,false],(v,p)=>v===16&&p[1].b===16],[()=>[[{a:true},{b:true}],{a:2,b:16}],p=>['w>>=',p[0],['b',2,v=>p[1].b>>=v],c,false],(v,p)=>v===4&&p[1].b===4],[()=>[[{a:true},{b:true}],{a:2,b:-1}],p=>['w>>>=',p[0],['b',1,v=>p[1].b>>>=v],c,false],(v,p)=>v===2147483647&&p[1].b===2147483647],[()=>[[{a:true},{b:true}],{a:2,b:10}],p=>['w&=',p[0],['b',7,v=>p[1].b&=v],c,false],(v,p)=>v===2&&p[1].b===2],[()=>[[{a:true},{b:true}],{a:2,b:10}],p=>['w^=',p[0],['b',15,v=>p[1].b^=v],c,false],(v,p)=>v===5&&p[1].b===5],[()=>[[{a:true},{b:true}],{a:2,b:10}],p=>['w|=',p[0],['b',7,v=>p[1].b|=v],c,false],(v,p)=>v===15&&p[1].b===15],[()=>[{a:2,b:3}],p=>['.=',p[0],['b'],c],(v,p)=>(v['=']=4)===4&&v['=']===4&&p[0].b===4],[()=>[{a:2}],p=>['#.',p[0],['a'],c],(v,p)=>v.a===p.a],[()=>[{a:2}],p=>['#*',p[0],[],c],(v,p)=>v===p[0]],[()=>[{a:2}],p=>['#in',p[0],['a'],c],(v,p)=>v===true],[()=>[class c2{static m(a,b){return a+b;}}],p=>['#()',p[0],['m',[1,3]],c],(v,p)=>v===4],[()=>[{a:2}],p=>['#p++',p[0],['a'],c],(v,p)=>v===2&&p[0].a===3],[()=>[{a:2}],p=>['#++p',p[0],['a'],c],(v,p)=>v===3&&p[0].a===3],[()=>[{a:2}],p=>['#p--',p[0],['a'],c],(v,p)=>v===2&&p[0].a===1],[()=>[{a:2}],p=>['#--p',p[0],['a'],c],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['#delete',p[0],['a'],c],(v,p)=>v===true&&!Reflect.has(p[0],'a')],[()=>[{a:2}],p=>['#=',p[0],['a',5],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:2}],p=>['#+=',p[0],['a',5],c],(v,p)=>v===7&&p[0].a===7],[()=>[{a:2}],p=>['#-=',p[0],['a',5],c],(v,p)=>v===-3&&p[0].a===-3],[()=>[{a:2}],p=>['#*=',p[0],['a',5],c],(v,p)=>v===10&&p[0].a===10],[()=>[{a:10}],p=>['#/=',p[0],['a',2],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['#%=',p[0],['a',3],c],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['#**=',p[0],['a',3],c],(v,p)=>v===8&&p[0].a===8],[()=>[{a:2}],p=>['#<<=',p[0],['a',3],c],(v,p)=>v===16&&p[0].a===16],[()=>[{a:16}],p=>['#>>=',p[0],['a',2],c],(v,p)=>v===4&&p[0].a===4],[()=>[{a:-1}],p=>['#>>>=',p[0],['a',1],c],(v,p)=>v===2147483647&&p[0].a===2147483647],[()=>[{a:10}],p=>['#&=',p[0],['a',7],c],(v,p)=>v===2&&p[0].a===2],[()=>[{a:10}],p=>['#^=',p[0],['a',15],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['#|=',p[0],['a',7],c],(v,p)=>v===15&&p[0].a===15],[()=>[{a:2}],p=>['#+=',p[0],['a',5,(prop,value)=>p[0][prop]+=value],c],(v,p)=>v===7&&p[0].a===7],[()=>[{a:2}],p=>['#-=',p[0],['a',5,(prop,value)=>p[0][prop]-=value],c],(v,p)=>v===-3&&p[0].a===-3],[()=>[{a:2}],p=>['#*=',p[0],['a',5,(prop,value)=>p[0][prop]*=value],c],(v,p)=>v===10&&p[0].a===10],[()=>[{a:10}],p=>['#/=',p[0],['a',2],c,(prop,value)=>p[0][prop]/=value],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['#%=',p[0],['a',3],c,(prop,value)=>p[0][prop]%=value],(v,p)=>v===1&&p[0].a===1],[()=>[{a:2}],p=>['#**=',p[0],['a',3],c,(prop,value)=>p[0][prop]**=value],(v,p)=>v===8&&p[0].a===8],[()=>[{a:2}],p=>['#<<=',p[0],['a',3],c,(prop,value)=>p[0][prop]<<=value],(v,p)=>v===16&&p[0].a===16],[()=>[{a:16}],p=>['#>>=',p[0],['a',2],c,(prop,value)=>p[0][prop]>>=value],(v,p)=>v===4&&p[0].a===4],[()=>[{a:-1}],p=>['#>>>=',p[0],['a',1],c,(prop,value)=>p[0][prop]>>>=value],(v,p)=>v===2147483647&&p[0].a===2147483647],[()=>[{a:10}],p=>['#&=',p[0],['a',7,(prop,value)=>p[0][prop]&=value],c],(v,p)=>v===2&&p[0].a===2],[()=>[{a:10}],p=>['#^=',p[0],['a',15,(prop,value)=>p[0][prop]^=value],c],(v,p)=>v===5&&p[0].a===5],[()=>[{a:10}],p=>['#|=',p[0],['a',7,(prop,value)=>p[0][prop]|=value],c],(v,p)=>v===15&&p[0].a===15],[()=>[{a:2,b:3}],p=>['#.=',p[0],['b'],c],(v,p)=>(v['=']=4)===4&&v['=']===4&&p[0].b===4]];for(let i=0;i<tests.length;i++){let test=tests[i];let params=test[0]();let args=test[1](params);try{value=error=undefined;value=hookCallback(...args);}catch(e){error=e;}finally{if(error||!test[2](value,params)){result=false;reason='hook: hook callback cannot handle ('+JSON.stringify(args,null,0)+')';if(error){reason+=': '+error.message;}else{reason+=': returned value = '+(typeof value!=='symbol'?value:'Symbol');}break;}}}if(!result){break;}if(checkTypeError){try{hookCallback({},null,[],c);}catch(e){if(e.name!=='TypeError'){result=false;reason='hook: hook callback does not throw TypeError on calling a non-callable object';break;}}try{hookCallback('invalid operator',null,[],c);}catch(e){if(e.name!=='TypeError'){result=false;reason='hook: hook callback does not throw TypeError on calling a non-callable object';break;}}}}while(false);if(!result){if(throwError){throw new Error(reason);}else{console.error(reason);return false;}}else{return true;}}return Object.freeze({__hook__:__hook__,__hook_except_properties__:__hook_except_properties__,hookCallbackCompatibilityTest:hookCallbackCompatibilityTest});};},{}],4:[function(require,module,exports){(function(global){(function(){module.exports=function(hook,preprocess,he){const _Symbol=Symbol;const _global=typeof window==='object'?window:typeof global==='object'?global:typeof self==='object'?self:this;const _native={Function:_global.Function,GeneratorFunction:function*(){}.constructor,eval:_global.eval,setTimeout:_global.setTimeout,setInterval:_global.setInterval,HTMLScriptElement:_global.HTMLScriptElement,HTMLIFrameElement:_global.HTMLIFrameElement,HTMLObjectElement:_global.HTMLObjectElement,HTMLEmbedElement:_global.HTMLEmbedElement,Node:_global.Node,Element:_global.Element,SVGElement:_global.SVGElement,HTMLAnchorElement:_global.HTMLAnchorElement,HTMLAreaElement:_global.HTMLAreaElement,Document:typeof document==='object'?Object.getOwnPropertyDescriptor(Object.getPrototypeOf(Object.getPrototypeOf(document)).constructor.prototype,'write')?Object.getPrototypeOf(Object.getPrototypeOf(document)).constructor:Object.getPrototypeOf(document).constructor:null,importScripts:typeof _global.importScripts==='function'?_global.importScripts:undefined};const _nativeMethods={Node:{static:{},proto:{textContent:_native.Node?Object.getOwnPropertyDescriptor(_native.Node.prototype,'textContent'):{}}},Element:{static:{},proto:{innerHTML:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'innerHTML'):{},setAttribute:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'setAttribute'):{},setAttributeNS:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'setAttributeNS'):{},removeAttribute:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'removeAttribute'):{},removeAttributeNS:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'removeAttributeNS'):{},toggleAttribute:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'toggleAttribute'):{},attachShadow:_native.Element?Object.getOwnPropertyDescriptor(_native.Element.prototype,'attachShadow'):{}}},HTMLAnchorElement:{static:{},proto:{href:_native.HTMLAnchorElement?Object.getOwnPropertyDescriptor(_native.HTMLAnchorElement.prototype,'href'):{}}},HTMLAreaElement:{static:{},proto:{href:_native.HTMLAreaElement?Object.getOwnPropertyDescriptor(_native.HTMLAreaElement.prototype,'href'):{}}},HTMLScriptElement:{static:{},proto:{type:_native.HTMLScriptElement?Object.getOwnPropertyDescriptor(_native.HTMLScriptElement.prototype,'type'):{},src:_native.HTMLScriptElement?Object.getOwnPropertyDescriptor(_native.HTMLScriptElement.prototype,'src'):{},text:_native.HTMLScriptElement?Object.getOwnPropertyDescriptor(_native.HTMLScriptElement.prototype,'text'):{}}},HTMLIFrameElement:{static:{},proto:{srcdoc:_native.HTMLIFrameElement?Object.getOwnPropertyDescriptor(_native.HTMLIFrameElement.prototype,'srcdoc'):{},src:_native.HTMLIFrameElement?Object.getOwnPropertyDescriptor(_native.HTMLIFrameElement.prototype,'src'):{},onload:_native.HTMLIFrameElement?Object.getOwnPropertyDescriptor(_native.HTMLIFrameElement.prototype,'onload'):{}}},HTMLObjectElement:{static:{},proto:{data:_native.HTMLObjectElement?Object.getOwnPropertyDescriptor(_native.HTMLObjectElement.prototype,'data'):{}}},HTMLEmbedElement:{static:{},proto:{src:_native.HTMLEmbedElement?Object.getOwnPropertyDescriptor(_native.HTMLEmbedElement.prototype,'src'):{}}},Document:{static:{},proto:{write:_native.Document?Object.getOwnPropertyDescriptor(_native.Document.prototype,'write'):{},writeln:_native.Document?Object.getOwnPropertyDescriptor(_native.Document.prototype,'writeln'):{}}}};const _freeze={Function:{static:[],proto:['apply','call','bind','arguments']}};const selfConstructorName=typeof self==='object'?self.constructor.name:'';function normalizeHookName(hookName){if(selfConstructorName==='Window'){if(typeof hookName==='symbol'){return Symbol.keyFor(hookName);}else{throw new Error('unknown error');}}else{if(typeof hookName==='symbol'){return Symbol.keyFor(hookName);}else{return hookName;}}}function hookFunctionArguments(hookName,initialContext=[['Function',{}]],contextGenerator=preprocess.getContextGeneratorName(),args,isGenerator=false,isAsync=false){if(args.length>=1){let params=args.slice(0,args.length-1).join(',');let original=args[args.length-1];let match=original.match(new RegExp('^[s]*(\'use strict\';)?[s]*void ?\'params=([^\']*)\';[s]*void ?\'original=([^\']*)\''));let skip=false;if(match){if(match[2]===params){skip=true;}else{original=decodeURIComponent(atob(match[3]));}}if(!skip){let context=initialContext[0][0];let hooked=hook('('+(isAsync?'async ':'')+'function '+(isGenerator?'*':'')+'('+(args.length?args.slice(0,args.length-1).join(','):'')+') {'+original+'})',hookName,initialContext,contextGenerator,true,preprocess.getHookProperty(),null,false,preprocess.getCompact(),preprocess.getHookGlobal(),preprocess.getHookPrefix(),{arguments:true});let useStrict=hooked.indexOf('\'use strict\';');let contextMapper=hooked.substring(0,hooked.indexOf(']);')+3);let firstReturn=isGenerator?hooked.indexOf('yield*'):hooked.indexOf('return ');hooked=(useStrict>=0&&useStrict<firstReturn?'\'use strict\';'+'void \'params='+params+'\';'+'void \'original='+btoa(encodeURIComponent(original))+'\';':'void \'params='+params+'\';'+'void \'original='+btoa(encodeURIComponent(original))+'\';')+contextMapper+hooked.substr(firstReturn).replace(/\n/g,'\0').replace(/^(.*)[^\}]*\}[^\}]*$/m,'$1').replace(/\0/g,'\n');args=args.slice();args[args.length-1]=hooked;}}return args;}function hookFunction(hookName,initialContext=[['Function',{}]],contextGenerator=preprocess.getContextGeneratorName(),isGenerator=false,isAsync=false){let f;if(isGenerator){f=function GeneratorFunction(...args){if(args.length>=1){let params=args.slice(0,args.length-1).join(',');let original=args[args.length-1];let match=original.match(new RegExp('^[s]*(\'use strict\';)?[s]*void ?\'params=([^\']*)\';[s]*void ?\'original=([^\']*)\''));let skip=false;if(match){if(match[2]===params){skip=true;}else{original=decodeURIComponent(atob(match[3]));}}if(!skip){let context=initialContext[0][0];let hooked=hook('('+(isAsync?'async ':'')+'function* ('+(args.length?args.slice(0,args.length-1).join(','):'')+') {'+original+'})',hookName,initialContext,contextGenerator,true,preprocess.getHookProperty(),null,false,preprocess.getCompact(),preprocess.getHookGlobal(),preprocess.getHookPrefix(),{arguments:true});let useStrict=hooked.indexOf('\'use strict\';');let contextMapper=hooked.substring(0,hooked.indexOf(']);')+3);let firstReturn=hooked.indexOf('yield*');hooked=(useStrict>=0&&useStrict<firstReturn?'\'use strict\';'+'void \'params='+params+'\';'+'void \'original='+btoa(encodeURIComponent(original))+'\';':'void \'params='+params+'\';'+'void \'original='+btoa(encodeURIComponent(original))+'\';')+contextMapper+hooked.substr(firstReturn).replace(/\n/g,'\0').replace(/^(.*)[^\}]*\}[^\}]*$/m,'$1').replace(/\0/g,'\n');args=args.slice();args[args.length-1]=hooked;}}return Reflect.construct(_native.GeneratorFunction,args);};Object.defineProperty(f,Symbol.species,{value:_native.GeneratorFunction});Object.defineProperty(f,Symbol.hasInstance,{value:function(instance){return instance instanceof _native.GeneratorFunction;}});Object.setPrototypeOf(f,_native.GeneratorFunction);Object.setPrototypeOf(f.prototype,_native.GeneratorFunction.prototype);}else{f=function Function(...args){if(args.length>=1){let params=args.slice(0,args.length-1).join(',');let original=args[args.length-1];let match=original.match(new RegExp('^[s]*(\'use strict\';)?[s]*void ?\'params=([^\']*)\';[s]*void ?\'original=([^\']*)\''));let skip=false;if(match){if(match[2]===params){skip=true;}else{original=decodeURIComponent(atob(match[3]));}}if(!skip){let context=initialContext[0][0];let hooked=hook('('+(isAsync?'async ':'')+'function ('+(args.length?args.slice(0,args.length-1).join(','):'')+') {'+original+'})',hookName,initialContext,contextGenerator,true,preprocess.getHookProperty(),null,false,preprocess.getCompact(),preprocess.getHookGlobal(),preprocess.getHookPrefix(),{arguments:true});let useStrict=hooked.indexOf('\'use strict\';');let contextMapper=hooked.substring(0,hooked.indexOf(']);')+3);let firstReturn=hooked.indexOf('return ');hooked=(useStrict>=0&&useStrict<firstReturn?'\'use strict\';'+'void \'params='+params+'\';'+'void \'original='+btoa(encodeURIComponent(original))+'\';':'void \'params='+params+'\';'+'void \'original='+btoa(encodeURIComponent(original))+'\';')+contextMapper+hooked.substr(firstReturn).replace(/\n/g,'\0').replace(/^(.*)[^\}]*\}[^\}]*$/m,'$1').replace(/\0/g,'\n');args=args.slice();args[args.length-1]=hooked;}}return Reflect.construct(_native.Function,args);};Object.defineProperty(f,Symbol.species,{value:_native.Function});Object.defineProperty(f,Symbol.hasInstance,{value:function(instance){return instance instanceof _native.Function;}});Object.setPrototypeOf(f,_native.Function);Object.setPrototypeOf(f.prototype,_native.Function.prototype);}return f;}function hookEval(hookName,initialContext=[['eval',{}]],contextGenerator,initialScope={}){let _eval=function(script,evalWrapper=new Function('return (script, _eval) => _eval(script)')()){if(!evalWrapper||typeof evalWrapper!=='function'||evalWrapper.toString().replace(/ /g,'')!=='(script,eval)=>eval(script)'&&evalWrapper.toString().replace(/ /g,'')!=='(script,_eval)=>_eval(script)'){console.error('hook.eval: invalid eval wrapper function "'+evalWrapper.toString()+'"');evalWrapper=(script,_eval)=>_eval(script);script='/* invalidated eval script due to invalid eval wrapper function */';}else if(typeof script==='string'){if(initialScope['$use_strict$']){script='\'use strict\';'+script;}script=hook(script,hookName,initialContext,contextGenerator,true,preprocess.getHookProperty(),null,false,preprocess.getCompact(),preprocess.getHookGlobal(),preprocess.getHookPrefix(),initialScope);}return _global[normalizeHookName(hookName)](evalWrapper,this,[script,_native.eval],getContextSymbol(_global[normalizeHookName(hookName)],'eval'));};Object.defineProperty(_eval,'name',{configurable:false,writable:false,enumerable:false,value:'eval'});return _eval;}let contextToSymbols={};function getContextSymbol(hookCallback,context){let symbol;if(Reflect.has(contextToSymbols,context)){symbol=contextToSymbols[context];}else{symbol=contextToSymbols[context]=_Symbol();hookCallback[symbol]=context;}return symbol;}function hookSetTimeout(hookName,initialContext,contextGenerator){return function setTimeout(...args){if(typeof args[0]==='string'){args[0]=hook('(() => { '+args[0]+' })()',hookName,initialContext,contextGenerator);}return _global[normalizeHookName(hookName)](_native.setTimeout,_global,args,getContextSymbol(_global[normalizeHookName(hookName)],'setTimeout'));};}function hookSetInterval(hookName,initialContext=[['setInterval',{}]],contextGenerator){return function setInterval(...args){if(typeof args[0]==='string'){args[0]=hook('(() => { '+args[0]+' })()',hookName,initialContext,contextGenerator);}return _global[normalizeHookName(hookName)](_native.setInterval,_global,args,getContextSymbol(_global[normalizeHookName(hookName)],'setInterval'));};}function hookImportScripts(){return function importScripts(...args){let _args=args.map(arg=>{let path=(''+arg).trim();if(path.match(/^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*[.]m?js)(\?([^#]*))?(#(.*))?$/)){return arg;}else{return'!!! invalid url !!!';}});return _global[preprocess.getHookNameForServiceWorker()](_native.importScripts,_global,_args,getContextSymbol(_global[preprocess.getHookNameForServiceWorker()],'importScripts'));};}const jsMimeTypes=['','application/ecmascript','application/javascript','application/x-ecmascript','application/x-javascript','text/ecmascript','text/javascript','text/javascript1.0','text/javascript1.1','text/javascript1.2','text/javascript1.3','text/javascript1.4','text/javascript1.5','text/jscript','text/livescript','text/x-ecmascript','text/x-javascript','module'];const hookedScripts=new Set();function hookNode(hookName,initialContext=[['Node',{random:true}]],contextGenerator){if(_native.Node&&Object.getOwnPropertyDescriptor(_native.Node.prototype,'textContent').configurable){Object.defineProperty(_native.Node.prototype,'textContent',{configurable:false,enumerable:_nativeMethods.Node.proto.textContent.enumerable,get:_nativeMethods.Node.proto.textContent.get,set:function(value){if(this instanceof _native.HTMLScriptElement){if(!hookedScripts.has(value)){value=hook(value,hookName,initialContext,contextGenerator);hookedScripts.add(value);}}return _global[normalizeHookName(hookName)](_nativeMethods.Node.proto.textContent.set,this,[value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set textContent'));}});}return _native.Node;}function hookElement(hookName,initialContext=[['Element',{}]],contextGenerator){if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'setAttribute').configurable){Object.defineProperty(_native.Element.prototype,'setAttribute',{configurable:false,enumerable:_nativeMethods.Element.proto.setAttribute.enumerable,writable:false,value:function setAttribute(name,value){let doHook=false;let _name=name?name.toLowerCase():'';let _value=typeof value==='string'?value.trim():'';let _valueLowerCase;switch(_name){case'type':if(this instanceof _native.HTMLScriptElement&&jsMimeTypes.indexOf(_value.toLowerCase())>=0&&jsMimeTypes.indexOf(this.type?this.type.toLowerCase():'')<0){doHook=true;}break;case'src':if(this instanceof _native.HTMLScriptElement){if(_value){let srcUrl=new URL(_value,'https://localhost/');switch(srcUrl.protocol){case'https:':case'http:':if(!srcUrl.pathname.match(/[.]m?js$/)){value='';}break;case'data:':if(preprocess._getScriptHashes()){if(value.startsWith('data:text/javascript;charset=utf-8,')){let decodedInlineScript=decodeURIComponent(value.substring('data:text/javascript;charset=utf-8,'.length));let match=decodedInlineScript.match(/(\n\/\/# sourceURL=.*\n)$/);if(match){let inlineScript=decodedInlineScript.substring(0,decodedInlineScript.length-match[1].length);let {isHooked,isValidated,raw,hooked,ctx,embeddedRaw}=preprocess._parseHookedInlineScript(inlineScript);if(isHooked){if(!isValidated){let hookedForVerification=hook(raw,hookName,[[ctx,{}]],contextGenerator,true,preprocess.getHookProperty());if(hooked===hookedForVerification){}else{console.error('native-wrapper.js: failed in setting data URL for script ctx ',ctx);value='';}}}else{console.error('native-wrapper.js: setting data URL for a non-hooked script');value='';}}else{console.error('native-wrapper.js: setting data URL without source URL at the tail');value='';}}else{console.error('native-wrapper.js: setting data URL not from HTML Imports polyfill');value='';}}else{value='';}break;case'blob:':case'javascript:':default:value='';break;}}else{value='';}if(!value){_nativeMethods.Element.proto.removeAttribute.value.call(this,'src');return;}}else if(this instanceof _native.HTMLIFrameElement){if(_value){let url=new URL(hook.parameters.baseURI||location);let srcUrl=new URL(_value,location);if(hook.parameters.revertVirtualBlobUrl){srcUrl=hook.parameters.revertVirtualBlobUrl(srcUrl);}switch(srcUrl.protocol){case'https:':case'http:':break;case'data:':{let scriptHashes=preprocess._getScriptHashes();if(scriptHashes){let dataURL=srcUrl.pathname.match(/^([a-zA-Z\/+]*)(;[^, ]*)?,(.*)$/);if(dataURL&&dataURL[1]==='text/html'){let body;if(dataURL[2]===';base64'){body=decodeURIComponent(escape(atob(dataURL[3])));}else{body=dataURL[3];}if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));let srcDecoded=body+(hook.parameters.bootstrap||'');value+='&content='+btoa(encodeURIComponent(srcDecoded)).replace(/[+]/g,'-').replace(/[/]/g,'_');}else{value='';}}else if(dataURL&&dataURL[1]==='image/svg+xml'){value='';}else{}}else{let dataURL=srcUrl.pathname.match(/^([a-zA-Z\/+]*)(;[^, ]*)?,(.*)$/);if(dataURL&&dataURL[1]==='text/html'){let body;if(dataURL[2]===';base64'){body=decodeURIComponent(escape(atob(dataURL[3])));}else{body=dataURL[3];}if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));}let srcDecoded=body+(hook.parameters.bootstrap||'');let onload='event.target.contentDocument.write(`'+srcDecoded.replace(/`/g,'\\`')+'`);';if(hook.parameters.onloadWrapper&&this.hasAttribute('onload')){onload+=hook.parameters.onloadWrapper.replace('$onload$',this.getAttribute('onload'));}_nativeMethods.Element.proto.setAttribute.value.call(this,'onload',onload);}else if(dataURL&&dataURL[1]==='image/svg+xml'){value='';}else{}}}break;case'blob:':{let scriptHashes=preprocess._getScriptHashes();if(scriptHashes){if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));value+='&blob='+encodeURIComponent(srcUrl.href);}else{value='';}}else{if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));}let onload='let iframe = this; '+'fetch(new Request("'+srcUrl.href+'")).then(response => response.blob())'+'.then(blob => { let reader = new FileReader(); if (blob.type === "text/html") {'+'reader.addEventListener("loadend", () => { '+'iframe.contentDocument.write(reader.result + `'+hook.parameters.bootstrap+'`); }); '+'reader.readAsText(blob); } else if (blob.type !== "image/svg+xml") { '+'reader.addEventListener("loadend", () => { iframe.src = reader.result; iframe.removeAttribute("onload"); }); '+'reader.readAsDataURL(blob); }});';if(hook.parameters.onloadWrapper&&this.hasAttribute('onload')&&!this.getAttribute('onload').startsWith('let iframe = this; fetch(new Request(')){onload+=hook.parameters.onloadWrapper.replace('$onload$',this.getAttribute('onload'));}_nativeMethods.Element.proto.setAttribute.value.call(this,'onload',onload);}}break;case'javascript:':default:value='';break;}}else{value='';}if(!value){_native.setTimeout.call(_global,function(){this.removeAttribute('src');}.bind(this),0);return;}}else if(this instanceof _native.HTMLEmbedElement){let url=new URL(hook.parameters.baseURI||location);let _srcUrl=new URL(value,url);switch(_srcUrl.protocol){case'https:':case'http:':value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(hook.parameters.emptySvg.replace('$location$',_srcUrl.origin===url.origin?_srcUrl.href.substring(url.origin.length):_srcUrl.href).replace('$origin$',url.origin))));break;case'data:':if(value&&value.startsWith('data:image/svg+xml;base64,')&&typeof hook.parameters.emptySvg==='string'){let svgLoader=decodeURIComponent(escape(atob(value.substring('data:image/svg+xml;base64,'.length))));let emptySvgLocationIndex=hook.parameters.emptySvg.indexOf('$location$');let emptySvgStartsWith=hook.parameters.emptySvg.substring(0,emptySvgLocationIndex);let emptySvgEndsWith=hook.parameters.emptySvg.substring(emptySvgLocationIndex+'$location$'.length);if(svgLoader.startsWith(emptySvgStartsWith)&&svgLoader.endsWith(emptySvgEndsWith)){svgLoader=svgLoader.replace('$origin$',url.origin);value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(svgLoader)));}else{console.error('native-wrapper.js: invalid embed src="data:image/svg+xml;base64,..."',svgLoader);value='';}}else{value='';}break;case'blob:':case'javascript:':default:value='';break;}if(!value){_nativeMethods.Element.proto.removeAttribute.value.call(this,'src');return;}}break;case'srcdoc':if(this instanceof _native.HTMLIFrameElement){let scriptHashes=preprocess._getScriptHashes();if(scriptHashes){if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname;let srcdocDecoded=he.decode(_value+(hook.parameters.bootstrap||''),{isAttributeValue:true});if(scriptHashes.attachBaseURI){let url=new URL(this.baseURI);_emptySrc+='?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));_emptySrc+='&content='+btoa(encodeURIComponent(srcdocDecoded)).replace(/[+]/g,'-').replace(/[/]/g,'_');}else{_emptySrc+='?content='+btoa(encodeURIComponent(srcdocDecoded)).replace(/[+]/g,'-').replace(/[/]/g,'_');}_nativeMethods.Element.proto.setAttribute.value.call(this,'src',_emptySrc);name='src';value=_emptySrc;}}else{if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname;_nativeMethods.Element.proto.setAttribute.value.call(this,'src',_emptySrc);}let srcdocDecoded=he.decode(_value+(hook.parameters.bootstrap||''),{isAttributeValue:true});name='onload';value='event.target.contentDocument.write(`'+srcdocDecoded.replace(/`/g,'\\`')+'`);';if(hook.parameters.onloadWrapper&&this.getAttribute('onload')&&!this.getAttribute('onload').startsWith('event.target.contentDocument.write(')){value+=hook.parameters.onloadWrapper.replace('$onload$',this.getAttribute('onload'));}}}break;case'href':_valueLowerCase=_value.toLowerCase();if(this instanceof _native.SVGElement){switch(new URL(value,location).protocol){case'http:':case'https:':break;default:value='';break;}}else{if(_valueLowerCase.startsWith('javascript:')){if(!_value.match(/^javascript:const __[0-9a-z]*__=\$hook\$[.]\$/)){value='javascript:'+hook('(() => { '+_value.substr(11)+' })()',hookName,[[this.constructor.name+',setAttribute,'+_name,{}]],contextGenerator);}}else if(_valueLowerCase.startsWith('blob:')){if(!this.hasAttribute('download')){value='';}}}break;case'data':if(this instanceof _native.HTMLObjectElement){let url=new URL(hook.parameters.baseURI||location);let _dataUrl=new URL(value,url);switch(_dataUrl.protocol){case'https:':case'http:':value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(hook.parameters.emptySvg.replace('$location$',_dataUrl.origin===url.origin?_dataUrl.href.substring(url.origin.length):_dataUrl.href).replace('$origin$',url.origin))));break;case'data:':if(value&&value.startsWith('data:image/svg+xml;base64,')&&typeof hook.parameters.emptySvg==='string'){let svgLoader=decodeURIComponent(escape(atob(value.substring('data:image/svg+xml;base64,'.length))));let emptySvgLocationIndex=hook.parameters.emptySvg.indexOf('$location$');let emptySvgStartsWith=hook.parameters.emptySvg.substring(0,emptySvgLocationIndex);let emptySvgEndsWith=hook.parameters.emptySvg.substring(emptySvgLocationIndex+'$location$'.length);if(svgLoader.startsWith(emptySvgStartsWith)&&svgLoader.endsWith(emptySvgEndsWith)){svgLoader=svgLoader.replace('$origin$',url.origin);value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(svgLoader)));}else{console.error('native-wrapper.js: invalid object data="data:image/svg+xml;base64,..."',svgLoader);value='';}}else{value='';}break;case'blob:':case'javascript:':default:value='';break;}if(!value){_nativeMethods.Element.proto.removeAttribute.value.call(this,'data');return;}}break;default:if(_name.match(/^on[a-z]{1,}$/)){value=hook('(() => { '+value+' })()',hookName,[[this.constructor.name+',setAttribute,'+_name,{}]],contextGenerator,true,preprocess.getHookProperty(),null,false,preprocess.getCompact(),preprocess.getHookGlobal(),preprocess.getHookPrefix(),{event:true});let insertReturnAt=preprocess.getCompact()?value.indexOf('\']);')+4:value.indexOf('\'\n]);\n')+6;value=value.substring(0,insertReturnAt)+'return '+value.substring(insertReturnAt);}break;}let result=_global[normalizeHookName(hookName)](_nativeMethods.Element.proto.setAttribute.value,this,[name,value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',setAttribute'));if(doHook){this.textContent=this.textContent;}return result;}});}if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'setAttributeNS').configurable){Object.defineProperty(_native.Element.prototype,'setAttributeNS',{configurable:false,enumerable:_nativeMethods.Element.proto.setAttributeNS.enumerable,writable:false,value:function setAttributeNS(namespace,name,value){if(this instanceof _native.SVGElement){switch(name){case'href':switch(namespace){case'http://www.w3.org/1999/xlink':case null:switch(new URL(value,location).protocol){case'http:':case'https:':break;default:value='';break;}break;default:break;}break;default:break;}return _global[normalizeHookName(hookName)](_nativeMethods.Element.proto.setAttributeNS.value,this,[namespace,name,value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',setAttributeNS'));}else{return this.setAttribute(name,value);}}});}if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'removeAttribute').configurable){Object.defineProperty(_native.Element.prototype,'removeAttribute',{configurable:false,enumerable:_nativeMethods.Element.proto.removeAttribute.enumerable,writable:false,value:function removeAttribute(name){if(this instanceof _native.HTMLAnchorElement||this instanceof _native.HTMLAreaElement){switch(name){case'download':if(this.href){switch(new URL(this.href).protocol){case'blob:':_nativeMethods.Element.proto.removeAttribute.value.call(this,'href');break;default:break;}}break;default:break;}}return _global[normalizeHookName(hookName)](_nativeMethods.Element.proto.removeAttribute.value,this,[name],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',removeAttribute'));}});}if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'removeAttributeNS').configurable){Object.defineProperty(_native.Element.prototype,'removeAttributeNS',{configurable:false,enumerable:_nativeMethods.Element.proto.removeAttributeNS.enumerable,writable:false,value:function removeAttributeNS(namespace,name){if(this instanceof _native.HTMLAnchorElement||this instanceof _native.HTMLAreaElement){switch(name){case'download':if(this.href){switch(new URL(this.href).protocol){case'blob:':_nativeMethods.Element.proto.removeAttribute.value.call(this,'href');break;default:break;}}break;default:break;}}return _global[normalizeHookName(hookName)](_nativeMethods.Element.proto.removeAttributeNS.value,this,[namespace,name],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',removeAttributeNS'));}});}if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'toggleAttribute').configurable){Object.defineProperty(_native.Element.prototype,'toggleAttribute',{configurable:false,enumerable:_nativeMethods.Element.proto.toggleAttribute.enumerable,writable:false,value:function toggleAttribute(name,force){let result=_global[normalizeHookName(hookName)](_nativeMethods.Element.proto.toggleAttribute.value,this,[name,force],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',toggleAttribute'));if(this instanceof _native.HTMLAnchorElement||this instanceof _native.HTMLAreaElement){switch(name){case'download':if(this.href){switch(new URL(this.href).protocol){case'blob:':if(!result){_nativeMethods.Element.proto.removeAttribute.value.call(this,'href');}break;default:break;}}break;default:break;}}return result;}});}if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'innerHTML').configurable){Object.defineProperty(_native.Element.prototype,'innerHTML',{configurable:false,enumerable:_nativeMethods.Element.proto.innerHTML.enumerable,get:_nativeMethods.Element.proto.innerHTML.get,set:function(value){let processed=preprocess._preprocessHtml(value,hookName,new URL(document.location),_global.location.hostname!==document.location.hostname,contextGenerator,[],false,true,0,preprocess.getHookProperty());if(hook.parameters.innerHTMLTracker){hook.parameters.innerHTMLTracker(this,value,processed);}return _global[normalizeHookName(hookName)](_nativeMethods.Element.proto.innerHTML.set,this,[processed],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set innerHTML'));}});}if(_native.Element&&Object.getOwnPropertyDescriptor(_native.Element.prototype,'attachShadow').configurable){if(hook.parameters.mutationObserver&&hook.parameters.mutationObserverConfig){Object.defineProperty(_native.Element.prototype,'attachShadow',{configurable:false,enumerable:_nativeMethods.Element.proto.attachShadow.enumerable,writable:false,value:function attachShadow(shadowRootInit){let result=_nativeMethods.Element.proto.attachShadow.value.call(this,shadowRootInit);hook.parameters.mutationObserver.observe(result,hook.parameters.mutationObserverConfig);return result;}});}}return _native.Element;}function hookHTMLScriptElement(hookName,initialContext=[['HTMLScriptElement',{}]],contextGenerator){hookNode(hookName,initialContext,contextGenerator);hookElement(hookName,initialContext,contextGenerator);if(_native.HTMLScriptElement&&Object.getOwnPropertyDescriptor(_native.HTMLScriptElement.prototype,'type').configurable){Object.defineProperty(_native.HTMLScriptElement.prototype,'type',{configurable:false,enumerable:_nativeMethods.HTMLScriptElement.proto.type.enumerable,get:_nativeMethods.HTMLScriptElement.proto.type.get,set:function(value){let doHook=false;if(this instanceof _native.HTMLScriptElement&&jsMimeTypes.indexOf(value?value.toLowerCase():'')>=0&&jsMimeTypes.indexOf(this.type?this.type.toLowerCase():'')<0){doHook=true;}let result=_global[normalizeHookName(hookName)](_nativeMethods.HTMLScriptElement.proto.type.set,this,[value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set type'));if(doHook){this.textContent=this.textContent;}return result;}});}if(_native.HTMLScriptElement&&Object.getOwnPropertyDescriptor(_native.HTMLScriptElement.prototype,'src').configurable){Object.defineProperty(_native.HTMLScriptElement.prototype,'src',{configurable:false,enumerable:_nativeMethods.HTMLScriptElement.proto.type.enumerable,get:_nativeMethods.HTMLScriptElement.proto.src.get,set:function(value){let doHook=false;if(this instanceof _native.HTMLScriptElement){let _value=typeof value==='string'?value.trim():'';if(_value){let srcUrl=new URL(_value,location);switch(srcUrl.protocol){case'https:':case'http:':if(!srcUrl.pathname.match(/[.]m?js$/)){value='';}break;case'data:':case'blob:':case'javascript:':default:value='';break;}}else{value='';}if(!value){_nativeMethods.Element.proto.removeAttribute.value.call(this,'src');return;}}let result=_global[normalizeHookName(hookName)](_nativeMethods.HTMLScriptElement.proto.src.set,this,[value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set src'));return result;}});}if(_native.HTMLScriptElement&&Object.getOwnPropertyDescriptor(_native.HTMLScriptElement.prototype,'text').configurable){Object.defineProperty(_native.HTMLScriptElement.prototype,'text',{configurable:false,enumerable:_nativeMethods.HTMLScriptElement.proto.text.enumerable,get:_nativeMethods.HTMLScriptElement.proto.text.get,set:function(value){if(this instanceof _native.HTMLScriptElement){if(!hookedScripts.has(value)){value=hook(value,hookName,initialContext,contextGenerator);hookedScripts.add(value);}}return _global[normalizeHookName(hookName)](_nativeMethods.HTMLScriptElement.proto.text.set,this,[value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set text'));}});}return _native.HTMLScriptElement;}function hookHTMLIFrameElement(hookName,initialContext=[['HTMLIFrameElement',{}]],contextGenerator){hookElement(hookName,initialContext,contextGenerator);if(_native.HTMLIFrameElement&&Object.getOwnPropertyDescriptor(_native.HTMLIFrameElement.prototype,'srcdoc').configurable){Object.defineProperty(_native.HTMLIFrameElement.prototype,'srcdoc',{configurable:false,enumerable:_nativeMethods.HTMLIFrameElement.proto.srcdoc.enumerable,get:_nativeMethods.HTMLIFrameElement.proto.srcdoc.get,set:function(value){this.setAttribute('srcdoc',value);}});}if(_native.HTMLIFrameElement&&Object.getOwnPropertyDescriptor(_native.HTMLIFrameElement.prototype,'src').configurable){Object.defineProperty(_native.HTMLIFrameElement.prototype,'src',{configurable:false,enumerable:_nativeMethods.HTMLIFrameElement.proto.src.enumerable,get:_nativeMethods.HTMLIFrameElement.proto.src.get,set:function(value){if(value){let url=new URL(hook.parameters.baseURI||location);let srcUrl=new URL(value,location);if(hook.parameters.revertVirtualBlobUrl){srcUrl=hook.parameters.revertVirtualBlobUrl(srcUrl);}switch(srcUrl.protocol){case'https:':case'http:':break;case'data:':{if(preprocess._getScriptHashes()){let dataURL=srcUrl.pathname.match(/^([a-z\/]*)(;[^, ]*)?,(.*)$/);if(dataURL&&dataURL[1]==='text/html'){let body;if(dataURL[2]===';base64'){body=decodeURIComponent(escape(atob(dataURL[3])));}else{body=dataURL[3];}if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));let srcDecoded=body+(hook.parameters.bootstrap||'');value+='&content='+btoa(encodeURIComponent(srcDecoded)).replace(/[+]/g,'-').replace(/[/]/g,'_');}else{value='';}}else if(dataURL&&dataURL[1]==='image/svg+xml'){value='';}else{}}else{let dataURL=srcUrl.pathname.match(/^([a-z\/]*)(;[^, ]*)?,(.*)$/);if(dataURL&&dataURL[1]==='text/html'){let body;if(dataURL[2]===';base64'){body=decodeURIComponent(escape(atob(dataURL[3])));}else{body=dataURL[3];}if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));}let srcDecoded=body+(hook.parameters.bootstrap||'');let onload='event.target.contentDocument.write(`'+srcDecoded.replace(/`/g,'\\`')+'`);';if(hook.parameters.onloadWrapper&&this.hasAttribute('onload')){onload+=hook.parameters.onloadWrapper.replace('$onload$',this.getAttribute('onload'));}_nativeMethods.Element.proto.setAttribute.value.call(this,'onload',onload);}else if(dataURL&&dataURL[1]==='image/svg+xml'){value='';}else{}}}break;case'blob:':{if(preprocess._getScriptHashes()){if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));value+='&blob='+encodeURIComponent(srcUrl.href);}else{value='';}}else{if(hook.parameters.emptyDocumentUrl){value=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(this.id?'@'+this.id:''));}let onload='let iframe = this; '+'fetch(new Request("'+srcUrl.href+'")).then(response => response.blob())'+'.then(blob => { let reader = new FileReader(); if (blob.type === "text/html") {'+'reader.addEventListener("loadend", () => { '+'iframe.contentDocument.write(reader.result + `'+hook.parameters.bootstrap+'`); }); '+'reader.readAsText(blob); } else { '+'reader.addEventListener("loadend", () => { iframe.src = reader.result; iframe.removeAttribute("onload"); }); '+'reader.readAsDataURL(blob); }});';if(hook.parameters.onloadWrapper&&this.hasAttribute('onload')&&!this.getAttribute('onload').startsWith('let iframe = this; fetch(new Request(')){onload+=hook.parameters.onloadWrapper.replace('$onload$',this.getAttribute('onload'));}_nativeMethods.Element.proto.setAttribute.value.call(this,'onload',onload);}}break;case'javascript:':default:value='';break;}}else{value='';}if(!value){_nativeMethods.Element.proto.removeAttribute.value.call(this,'src');return;}_global[normalizeHookName(hookName)](_nativeMethods.HTMLIFrameElement.proto.src.set,this,[value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set src'));}});}return _native.HTMLIFrameElement;}function hookHTMLObjectElement(hookName,initialContext=[['HTMLObjectElement',{}]],contextGenerator){hookElement(hookName,initialContext,contextGenerator);if(_native.HTMLObjectElement&&Object.getOwnPropertyDescriptor(_native.HTMLObjectElement.prototype,'data').configurable){Object.defineProperty(_native.HTMLObjectElement.prototype,'data',{configurable:false,enumerable:_nativeMethods.HTMLObjectElement.proto.data.enumerable,get:_nativeMethods.HTMLObjectElement.proto.data.get,set:function(value){this.setAttribute('data',value);}});}return _native.HTMLObjectElement;}function hookHTMLEmbedElement(hookName,initialContext=[['HTMLEmbedElement',{}]],contextGenerator){hookElement(hookName,initialContext,contextGenerator);if(_native.HTMLEmbedElement&&Object.getOwnPropertyDescriptor(_native.HTMLEmbedElement.prototype,'src').configurable){Object.defineProperty(_native.HTMLEmbedElement.prototype,'src',{configurable:false,enumerable:_nativeMethods.HTMLEmbedElement.proto.src.enumerable,get:_nativeMethods.HTMLEmbedElement.proto.src.get,set:function(value){this.setAttribute('src',value);}});}return _native.HTMLEmbedElement;}function hookHrefProperty(hookName,target,contextGenerator){if(_native[target]&&Object.getOwnPropertyDescriptor(_native[target].prototype,'href').configurable){Object.defineProperty(_native[target].prototype,'href',{configurable:false,enumerable:_nativeMethods[target].proto.href.enumerable,get:_nativeMethods[target].proto.href.get,set:function href(value){let doHook=false;let _value=typeof value==='string'?value.trim():'';let _valueLowerCase=_value.toLowerCase();if(_valueLowerCase.startsWith('javascript:')){if(!_value.match(/^javascript:const __[0-9a-z]*__=\$hook\$[.]\$/)){value='javascript:'+hook('(() => { '+_value.substr(11)+' })()',hookName,[[this.constructor.name+',set href',{}]],contextGenerator);}}else if(_valueLowerCase.startsWith('blob:')){if(!this.hasAttribute('download')){value='';}}return _global[normalizeHookName(hookName)](_nativeMethods[target].proto.href.set,this,[value],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',set href'));}});}return _native[target];}function hookHTMLAnchorElement(hookName,initialContext=[['HTMLAnchorElement',{}]],contextGenerator){return hookHrefProperty(hookName,'HTMLAnchorElement',contextGenerator);}function hookHTMLAreaElement(hookName,initialContext=[['HTMLAreaElement',{}]],contextGenerator){return hookHrefProperty(hookName,'HTMLAreaElement',contextGenerator);}function hookDocument(hookName,initialContext=[['Document',{}]],contextGenerator,calculateScriptOffset=false){let writeDesc,writelnDesc;if(_native.Document&&(writeDesc=Object.getOwnPropertyDescriptor(_native.Document.prototype,'write'))&&writeDesc.configurable){Object.defineProperty(_native.Document.prototype,'write',{configurable:false,enumerable:_nativeMethods.Document.proto.write.enumerable,writable:false,value:function write(markup){let scriptOffset=0;if(calculateScriptOffset){for(let i=0;i<this.childNodes.length;i++){let node=this.childNodes[i];let innerHTML=node.innerHTML;let textContent=node.textContent;if(innerHTML){scriptOffset+=innerHTML.length;}else if(textContent){scriptOffset+=textContent.length;if(node.nodeType===node.COMMENT_NODE){scriptOffset+=7;}}}}let url=new URL(this.location);if(hook.parameters.emptyDocumentUrl){if(url.origin===hook.parameters.emptyDocumentUrl.origin&&url.pathname===hook.parameters.emptyDocumentUrl.pathname){if(url.searchParams.has('url')){url=new URL(url.searchParams.get('url'),hook.parameters.emptyDocumentUrl.origin);}}}let processed=preprocess._preprocessHtml(markup,hookName,url,_global.location.hostname!==this.location.hostname,contextGenerator,[],false,true,scriptOffset,preprocess.getHookProperty());return _global[normalizeHookName(hookName)](_nativeMethods.Document.proto.write.value,this,[processed],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',write'));}});}if(_native.Document&&(writelnDesc=Object.getOwnPropertyDescriptor(_native.Document.prototype,'writeln'))&&writelnDesc.configurable){Object.defineProperty(_native.Document.prototype,'writeln',{configurable:false,enumerable:_nativeMethods.Document.proto.writeln.enumerable,writable:false,value:function writeln(markup){let scriptOffset=0;if(calculateScriptOffset){for(let i=0;i<this.childNodes.length;i++){let node=this.childNodes[i];let innerHTML=node.innerHTML;let textContent=node.textContent;if(innerHTML){scriptOffset+=innerHTML.length;}else if(textContent){scriptOffset+=textContent.length;if(node.nodeType===node.COMMENT_NODE){scriptOffset+=7;}}}}let url=new URL(this.location);if(hook.parameters.emptyDocumentUrl){if(url.origin===hook.parameters.emptyDocumentUrl.origin&&url.pathname===hook.parameters.emptyDocumentUrl.pathname){if(url.searchParams.has('url')){url=new URL(url.searchParams.get('url'),hook.parameters.emptyDocumentUrl.origin);}}}let processed=preprocess._preprocessHtml(markup,hookName,url,_global.location.hostname!==this.location.hostname,contextGenerator,[],false,true,scriptOffset,preprocess.getHookProperty());return _global[normalizeHookName(hookName)](_nativeMethods.Document.proto.writeln.value,this,[processed],getContextSymbol(_global[normalizeHookName(hookName)],this.constructor.name+',writeln'));}});}return _native.Document;}let _globalPrototypes=[];{let o=_global;while(o){_globalPrototypes.push(o);o=Object.getPrototypeOf(o);}}function hookGlobal(hookCallback,context,name,type){let proxy=_global;let status='undefined';let descriptor;let proxyDescriptor;let newProxyDescriptor;let _hookPrefix=preprocess.getHookPrefix();let strictModePrefix='';let symbolContext=context;if(typeof symbolContext!=='symbol'){return undefined;}context=hookCallback[symbolContext];if(!context){return undefined;}let wrapperProperty;let wrapperPropertySymbolMap;let wrapperPropertySymbol;let i;if(type[0]==='#'){strictModePrefix='#';_hookPrefix='S'+_hookPrefix;type=type.substr(1);}for(i=0;!descriptor&&i<_globalPrototypes.length;i++){descriptor=Object.getOwnPropertyDescriptor(_globalPrototypes[i],name);}if(descriptor){status='var';}wrapperProperty=_hookPrefix+name+';'+context;wrapperPropertySymbolMap=hookGlobal[symbolContext];if(!wrapperPropertySymbolMap){return undefined;}wrapperPropertySymbol=wrapperPropertySymbolMap[wrapperProperty];if(type!=='delete'&&type!=='#delete'&&!wrapperPropertySymbol){return undefined;}proxyDescriptor=Object.getOwnPropertyDescriptor(proxy,wrapperPropertySymbol);if(!proxyDescriptor){newProxyDescriptor={configurable:false,enumerable:false,get:function get(){return hookCallback(strictModePrefix+'.',_global,[name],symbolContext);},set:function set(value){return hookCallback(strictModePrefix+'=',_global,[name,value],symbolContext);}};}switch(status+'-'+type){case'undefined-get':throw new ReferenceError(name+' is not defined');break;case'undefined-var':case'undefined-function':case'undefined-let':case'undefined-class':hookCallback(strictModePrefix+'()',Object,['defineProperty',[_global,name,{configurable:false,enumerable:true,writable:true,value:undefined}]],symbolContext);if(newProxyDescriptor){Object.defineProperty(proxy,wrapperPropertySymbol,newProxyDescriptor);}break;case'undefined-set':if(strictModePrefix){throw new ReferenceError(name+' is not defined');}else{hookCallback(strictModePrefix+'()',Object,['defineProperty',[_global,name,{configurable:true,enumerable:true,writable:true,value:undefined}]],symbolContext);if(newProxyDescriptor){Object.defineProperty(proxy,wrapperPropertySymbol,newProxyDescriptor);}}break;case'undefined-const':Object.defineProperty(proxy,wrapperPropertySymbol,{configurable:false,enumerable:false,get:function(){return hookCallback('.',_global,[name],symbolContext);},set:function(value){hookCallback(strictModePrefix+'=',_global,[name,value],symbolContext);hookCallback(strictModePrefix+'()',Object,['defineProperty',[_global,name,{configurable:false,enumerable:true,writable:false,value:value}]],symbolContext);}});break;case'undefined-typeof':case'var-var':case'var-function':case'var-get':case'var-set':case'var-typeof':if(newProxyDescriptor){Object.defineProperty(proxy,wrapperPropertySymbol,newProxyDescriptor);}break;case'var-let':case'var-const':case'var-class':throw new SyntaxError('Identifier \''+name+'\' has already been declared status = '+status+' type = '+type);break;case'undefined-delete':case'var-delete':proxy=hookCallback(strictModePrefix+'delete',_global,[name],symbolContext);break;default:console.error('hook.global: unknown status-type pair',status,type);break;}return proxy;}function hookWith(...scopes){let scope=scopes[0];scope[preprocess.getHookWith()]=scopes;return scope;}function contextSymbolGenerator(symbolToContext,contexts){let result=[];let contextToSymbol={};let hookGlobal=hook.global;for(let i=0;i<contexts.length;i++){symbolToContext[result[i]=_Symbol()]=contexts[i];contextToSymbol[contexts[i]]=result[i];hookGlobal[result[i]]=contextToSymbol;}return result;}function _freezeProperties(target){function _freezeProperty(target,prop){let desc=Object.getOwnPropertyDescriptor(target,prop);if(desc&&desc.configurable){desc.configurable=false;if(desc.writable){desc.writable=false;}Object.defineProperty(target,prop,desc);}}_freeze[target.name]&&_freeze[target.name].static&&_freeze[target.name].static.forEach(prop=>{_freezeProperty(target,prop);});_freeze[target.name]&&_freeze[target.name].proto&&_freeze[target.name].proto.forEach(prop=>{_freezeProperty(target.prototype,prop);});}function hookPlatform(...targets){let platform=_global;targets.forEach(target=>{switch(target.name){case'setTimeout':case'setInterval':Object.defineProperty(target,'toString',{value:function toString(){return'function '+target.name+'() { [native code] }';},configurable:false,enumerable:false,writable:false});_freezeProperties(target);Object.defineProperty(platform,target.name,{value:target,configurable:false,enumerable:false,writable:false});break;case'HTMLScriptElement':_freezeProperties(target);Object.defineProperty(platform,target.name,{value:target,configurable:false,enumerable:false,writable:false});break;case'eval':_freezeProperties(target);Object.defineProperty(platform,target.name,{value:target,configurable:false,enumerable:false,writable:false});break;case'importScripts':_freezeProperties(target);Object.defineProperty(platform,target.name,{value:target,configurable:false,enumerable:false,writable:false});break;case'write':default:break;}});}return Object.freeze({hook:hookPlatform,global:hookGlobal,Function:hookFunction,FunctionArguments:hookFunctionArguments,eval:hookEval,setTimeout:hookSetTimeout,setInterval:hookSetInterval,Node:hookNode,Element:hookElement,HTMLAnchorElement:hookHTMLAnchorElement,HTMLAreaElement:hookHTMLAreaElement,HTMLScriptElement:hookHTMLScriptElement,HTMLIFrameElement:hookHTMLIFrameElement,HTMLObjectElement:hookHTMLObjectElement,HTMLEmbedElement:hookHTMLEmbedElement,Document:hookDocument,with:hookWith,importScripts:hookImportScripts,$:contextSymbolGenerator});};}.call(this));}.call(this,typeof global!=='undefined'?global:typeof self!=='undefined'?self:typeof window!=='undefined'?window:{}));},{}],5:[function(require,module,exports){module.exports=function(espree,escodegen,htmlparser,createHash,convert,he){const _Map=Map;let _crypto;const espreeOptionsForTarget={loc:true,range:true,tokens:true,comment:true,ecmaVersion:9,ecmaFeatures:{experimentalObjectRestSpread:true}};const espreeOptionsForTargetCompact={loc:false,range:false,tokens:false,comment:false,ecmaVersion:9,ecmaFeatures:{experimentalObjectRestSpread:true}};const espreeOptions={loc:false,range:false,tokens:false,comment:false,ecmaVersion:9,ecmaFeatures:{experimentalObjectRestSpread:true}};const espreeModuleOptions={loc:true,range:true,tokens:true,comment:true,ecmaVersion:9,sourceType:'module',ecmaFeatures:{experimentalObjectRestSpread:true}};const espreeModuleOptionsCompact={loc:false,range:false,tokens:false,comment:false,ecmaVersion:9,sourceType:'module',ecmaFeatures:{experimentalObjectRestSpread:true}};let configurationsJSON='{"hookNameForServiceWorker":"__hook__","contextGeneratorName":"method","discardHookErrors":true,"hookProperty":true,"hookGlobal":true,"hookPrefix":"_p_","compact":false,"noHookAuthorizationPreValidated":[],"contextGeneratorScripts":[]}';let configurations=JSON.parse(configurationsJSON);function getConfigurations(){return configurations;}function setConfigurations(_configurations){if(typeof URL==='function'&&_configurations instanceof URL){let srcUrl=_configurations;if(srcUrl.searchParams.has('hook-name')){setHookNameForServiceWorker(srcUrl.searchParams.get('hook-name')||'__hook__');}if(srcUrl.searchParams.has('context-generator-name')){setContextGeneratorName(srcUrl.searchParams.get('context-generator-name')||'method');}if(srcUrl.searchParams.has('discard-hook-errors')){setDiscardHookErrors(srcUrl.searchParams.get('discard-hook-errors')==='true');}if(srcUrl.searchParams.has('hook-property')){setHookProperty(srcUrl.searchParams.get('hook-property')==='true');}if(srcUrl.searchParams.has('hook-global')){setHookGlobal(srcUrl.searchParams.get('hook-global')==='true');}if(srcUrl.searchParams.has('hook-prefix')){setHookPrefix(srcUrl.searchParams.get('hook-prefix'));}if(srcUrl.searchParams.has('compact')){setCompact(srcUrl.searchParams.get('compact')==='true');}if(srcUrl.searchParams.has('no-hook-authorization')){let noHookAuthorization=srcUrl.searchParams.get('no-hook-authorization').split(/,/);hook.parameters.noHookAuthorizationPreValidated=hook.parameters.noHookAuthorizationPreValidated||{};noHookAuthorization.forEach(ticket=>{hook.parameters.noHookAuthorizationPreValidated[ticket]=true;});noHookAuthorization=[];for(let ticket in hook.parameters.noHookAuthorizationPreValidated){noHookAuthorization.push(ticket);}setNoHookAuthorizationPreValidated(noHookAuthorization);}return configurations;}else{return configurations=_configurations;}}function getHookNameForServiceWorker(){return configurations.hookNameForServiceWorker;}function setHookNameForServiceWorker(_hookName){return configurations.hookNameForServiceWorker=_hookName;}function getHookWith(){return'__with__';}function setHookWith(_hookWith){return'__with__';}function getContextGeneratorName(){return configurations.contextGeneratorName;}function setContextGeneratorName(_contextGeneratorName){return configurations.contextGeneratorName=_contextGeneratorName;}function getDiscardHookErrors(){return configurations.discardHookErrors;}function setDiscardHookErrors(_discardHookErrors){return configurations.discardHookErrors=_discardHookErrors;}function getHookProperty(){return configurations.hookProperty;}function setHookProperty(_hookProperty){return configurations.hookProperty=_hookProperty;}function getHookGlobal(){return configurations.hookGlobal;}function setHookGlobal(_hookGlobal){return configurations.hookGlobal=_hookGlobal;}function getHookPrefix(){return configurations.hookPrefix;}function setHookPrefix(_hookPrefix){return configurations.hookPrefix=_hookPrefix;}function getCompact(){return configurations.compact;}function setCompact(_compact){return configurations.compact=_compact;}function getNoHookAuthorizationPreValidated(){return configurations.noHookAuthorizationPreValidated;}function setNoHookAuthorizationPreValidated(_noHookAuthorizationPreValidated){return configurations.noHookAuthorizationPreValidated=_noHookAuthorizationPreValidated;}function getContextGeneratorScripts(){return configurations.contextGeneratorScripts;}let hookWorkers=[];let hookWorkerCount=4;function getHookId(seed){let hash=createHash('sha256');hash.update(Math.random()+seed);return hash.digest('hex');}function getHookWorkers(){return hookWorkers;}function setHookWorkers(_hookWorkers){hookWorkers=_hookWorkers;console.log('setHookWorkers',hookWorkers);hookWorkers.forEach(function(worker){worker.tasks={};worker.port.onmessage=function(event){let message=JSON.parse(event.data);let id=message[0];let status=message[1];if(typeof worker.tasks[id]==='object'){if(status==='success'){let result=message[2];worker.tasks[id].status=status;worker.tasks[id].result=result;worker.tasks[id].callback(worker.tasks[id]);}else{let error=message[2];worker.tasks[id].status=status;worker.tasks[id].error=error;console.error('response from Hook Worker for '+id+':'+status+':'+error);worker.tasks[id].callback(worker.tasks[id]);}}else{console.error('response with unknown id '+id+' from Hook Worker');}};});}function setupHookWorkers(){if(hookWorkers.length===0&&hook.parameters.hookWorker){let transferChannels=[];let serviceWorkerInitiator=new URL(location.href).pathname;let noHookAuthorization=new URL(top.document.querySelector('script').src,top.location).searchParams.has('no-hook-authorization')?new URL(top.document.querySelector('script').src,top.location).searchParams.get('no-hook-authorization'):null;for(let i=0;i<hookWorkerCount;i++){let worker={worker:new Worker(hook.parameters.hookWorker+'&service-worker-initiator='+serviceWorkerInitiator+(noHookAuthorization?'&no-hook-authorization='+noHookAuthorization:'')),channel:new MessageChannel()};worker.worker.postMessage('channel',[worker.channel.port2]);hookWorkers.push(worker);transferChannels.push(worker.channel.port1);}navigator.serviceWorker.controller.postMessage('channel',transferChannels);addEventListener('unload',function(event){navigator.serviceWorker.controller.postMessage('unload');});}}function getBestHookWorker(){let worker=null;if(Array.isArray(hookWorkers)&&hookWorkers.length>0){let minIndex=0;let minTaskQueueSize=hookWorkers[minIndex].taskQueueSize;for(let i=minIndex;i<hookWorkers.length;i++){if(hookWorkers[i].taskQueueSize<minTaskQueueSize){minIndex=i;minTaskQueueSize=hookWorkers[i].taskQueueSize;}}worker=hookWorkers[minIndex];}return worker;}function mutateScriptConfigurationsJSON(script,url){if(url.href.match(/\/hook[.]min[.]js/)&&!url.searchParams.has('service-worker-initiator')&&url.searchParams.get('service-worker-ready')!=='false'){let mutatedScript=script.replace(/('{"hookNameForServiceWorker":")(__hook__)(","contextGeneratorName":")(method)(","discardHookErrors":)(true)(,"hookProperty":)(true)(,"hookGlobal":)(true)(,"hookPrefix":")(_p_)(","compact":)(false)(,"noHookAuthorizationPreValidated":\[\],"contextGeneratorScripts":\[\]}')/,'$1'+getHookNameForServiceWorker()+'$3'+getContextGeneratorName()+'$5'+getDiscardHookErrors()+'$7'+getHookProperty()+'$9'+getHookGlobal()+'$11'+getHookPrefix()+'$13'+getCompact()+'$15');script=mutatedScript;}return script;}function _trimStartEndRaw(ast){if(ast&&typeof ast==='object'){delete ast.start;delete ast.end;delete ast.raw;}for(let target in ast){if(ast[target]){if(Array.isArray(ast[target])){for(let i=0;i<ast[target].length;i++){let item=ast[target][i];if(item&&typeof item==='object'){_trimStartEndRaw(ast[target][i]);}}}else if(typeof ast[target]==='object'){_trimStartEndRaw(ast[target]);}}}return ast;}let _espreeCache={};const baseHookName='_X_hookName_X_';const baseContext='X_X_XcontextX_X_X';function _espreeParse(code,hookName,context){if(!_espreeCache[code]){_espreeCache[code]=_trimStartEndRaw(espree.parse(code,espreeOptions).body[0]);}let result={};let stack=[result,_espreeCache[code]];let cursor=stack.length;let ast,_ast;let prop,value;while(cursor>0){ast=stack[--cursor];_ast=stack[--cursor];for(prop in ast){value=ast[prop];if(Array.isArray(value)){stack[cursor++]=_ast[prop]=[];stack[cursor++]=value;}else if(value&&typeof value==='object'){stack[cursor++]=_ast[prop]={};stack[cursor++]=value;}else if(value===baseHookName){_ast[prop]=hookName;}else if(value===baseContext){_ast[prop]=context;}else{_ast[prop]=value;}}}return result;}function _clone(sourceAst){let result={};let stack=[result,sourceAst];let cursor=stack.length;let ast,_ast;let prop,value;while(cursor>0){ast=stack[--cursor];_ast=stack[--cursor];for(prop in ast){value=ast[prop];if(Array.isArray(value)){stack[cursor++]=_ast[prop]=[];stack[cursor++]=value;}else if(value&&typeof value==='object'&&!(value instanceof String)){stack[cursor++]=_ast[prop]={};stack[cursor++]=value;}else{_ast[prop]=value;}}}return result;}const functionScopeTypes={FunctionDeclaration:true,FunctionExpression:true,ArrowFunctionExpression:true,ClassDeclaration:true,VariableDeclaration_var:true,ImportDeclaration:true,ExportNamedDeclaration:true};const scopes={__scope__:true,moduleDependencies:true,$block$:true,$function$:true};const S_STRICT=Symbol('use strict');const parameterTypes={Identifier:true,AssignmentPattern:true,ArrayPattern:true,ObjectPattern:true,RestElement:true};const arrayPatternElementTypes={Identifier:true,AssignmentPattern:true,ArrayPattern:true,ObjectPattern:true,RestElement:true,MemberExpression:true};const objectPatternValueTypes={Identifier:true,AssignmentPattern:true,ArrayPattern:true,ObjectPattern:true,MemberExpression:true};const variableDeclaratorIdTypes={Identifier:true,ArrayPattern:true,ObjectPattern:true};const nonOverridableIdentifiers=new Map();['undefined','NaN','Infinity'].forEach(v=>{nonOverridableIdentifiers.set(v,'__unexpected_overridden_declaration_of_'+v+'__');});function _analyzeScope(ast,blockScope,functionScope,moduleScope,hookName,hookWith){let target,child,t,index,i,l,item,type,scope,_scope,params;type=ast.type;switch(type){case'FunctionDeclaration':case'FunctionExpression':case'ArrowFunctionExpression':case'CatchClause':switch(type){case'FunctionDeclaration':if(ast.__scope__){scope=ast.__scope__;}else{scope=type;}if(ast.id&&ast.id.name){if(nonOverridableIdentifiers.has(ast.id.name)){ast.id.name=nonOverridableIdentifiers.get(ast.id.name);}if(moduleScope===blockScope&&(_scope=blockScope[ast.id.name])&&_scope.status==='variable_not_declared_yet'){blockScope[ast.id.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===blockScope&&scope.type&&!blockScope[ast.id.name]){blockScope[ast.id.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.id.name});}else{blockScope[ast.id.name]=scope;}}blockScope=Object.create(blockScope);functionScope=blockScope;blockScope.arguments='VariableDeclaration_var';params=ast.params;if(ast.body&&Array.isArray(ast.body.body)&&ast.body.body.length>0&&(item=ast.body.body[0])&&Reflect.has(item,'type')&&item.type==='ExpressionStatement'&&item.expression&&item.expression.type==='Literal'&&item.expression.value==='use strict'){functionScope[S_STRICT]='Literal';}break;case'FunctionExpression':blockScope=Object.create(blockScope);functionScope=blockScope;if(ast.id&&ast.id.name){if(nonOverridableIdentifiers.has(ast.id.name)){ast.id.name=nonOverridableIdentifiers.get(ast.id.name);}functionScope[ast.id.name]=type;}blockScope.arguments='VariableDeclaration_var';params=ast.params;if(ast.body&&Array.isArray(ast.body.body)&&ast.body.body.length>0&&(item=ast.body.body[0])&&Reflect.has(item,'type')&&item.type==='ExpressionStatement'&&item.expression&&item.expression.type==='Literal'&&item.expression.value==='use strict'){functionScope[S_STRICT]='Literal';}break;case'ArrowFunctionExpression':blockScope=Object.create(blockScope);functionScope=blockScope;params=ast.params;break;case'CatchClause':blockScope=Object.create(blockScope);functionScope=blockScope;if(ast.param){params=[ast.param];}else{params=[];}break;default:break;}for(index=0;index<params.length;index++){if(parameterTypes[params[index].type]){params[index].__scope__=type;}else{console.error(type+': Unknown Param Type '+params[index].type);}}break;case'Identifier':switch(ast.name){case hookName:ast.name='__unexpected_access_to_hook_callback_function__';break;case hookWith:ast.name='__unexpected_access_to_hook_with_object__';break;case'$hook$':ast.name='__unexpected_access_to_hook_alias_object__';break;default:break;}scope=ast.__scope__;if(scope){if(ast.name){if(nonOverridableIdentifiers.has(ast.name)){ast.name=nonOverridableIdentifiers.get(ast.name);}if(functionScopeTypes[scope]){if(moduleScope===functionScope&&(_scope=functionScope[ast.name])&&_scope.status==='variable_not_declared_yet'){functionScope[ast.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===functionScope&&scope.type&&!functionScope[ast.name]){functionScope[ast.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.name});}else{functionScope[ast.name]=scope;}}else{if(moduleScope===blockScope&&(_scope=blockScope[ast.name])&&_scope.status==='variable_not_declared_yet'){blockScope[ast.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===blockScope&&scope.type&&!blockScope[ast.name]){blockScope[ast.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.name});}else{blockScope[ast.name]=scope;}}if(functionScopeTypes[scope]&&functionScope===moduleScope&&hookWith&&blockScope[hookWith]){if(!moduleScope.hasOwnProperty(Symbol.for('__with__'))){moduleScope[Symbol.for('__with__')]={};}moduleScope[Symbol.for('__with__')][ast.name]=scope;}}}break;case'AssignmentPattern':scope=ast.__scope__;if(scope){if(ast.left.name){if(nonOverridableIdentifiers.has(ast.left.name)){ast.left.name=nonOverridableIdentifiers.get(ast.left.name);}if(functionScopeTypes[scope]){if(moduleScope===functionScope&&(_scope=functionScope[ast.left.name])&&_scope.status==='variable_not_declared_yet'){functionScope[ast.left.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===functionScope&&scope.type&&!functionScope[ast.left.name]){functionScope[ast.left.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.left.name});}else{functionScope[ast.left.name]=scope;}}else{if(moduleScope===blockScope&&(_scope=blockScope[ast.left.name])&&_scope.status==='variable_not_declared_yet'){blockScope[ast.left.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===blockScope&&scope.type&&!blockScope[ast.left.name]){blockScope[ast.left.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.left.name});}else{blockScope[ast.left.name]=scope;}}if(functionScopeTypes[scope]&&functionScope===moduleScope&&hookWith&&blockScope[hookWith]){if(!moduleScope.hasOwnProperty(Symbol.for('__with__'))){moduleScope[Symbol.for('__with__')]={};}moduleScope[Symbol.for('__with__')][ast.left.name]=scope;}}}break;case'ArrayPattern':scope=ast.__scope__;if(scope){for(i=0;i<ast.elements.length;i++){if(ast.elements[i]){if(arrayPatternElementTypes[ast.elements[i].type]){ast.elements[i].__scope__=scope;}else{console.error(type+': Unknown Element Type '+ast.elements[i].type);}}}}break;case'ObjectPattern':scope=ast.__scope__;if(scope){for(i=0;i<ast.properties.length;i++){if(ast.properties[i]){if(ast.properties[i].value){if(ast.properties[i].shorthand&&ast.properties[i].key===ast.properties[i].value&&ast.properties[i].value.type==='Identifier'){ast.properties[i].key=_clone(ast.properties[i].key);}if(objectPatternValueTypes[ast.properties[i].value.type]){ast.properties[i].value.__scope__=scope;}else{console.error(type+': Unknown Property Type '+ast.properties[i].type);}}else if(ast.properties[i].argument&&ast.properties[i].type==='ExperimentalRestProperty'){ast.properties[i].__scope__=scope;}}}}break;case'RestElement':scope=ast.__scope__;if(scope){if(ast.argument){switch(ast.argument.type){case'Identifier':if(ast.argument.name){if(nonOverridableIdentifiers.has(ast.argument.name)){ast.argument.name=nonOverridableIdentifiers.get(ast.argument.name);}if(functionScopeTypes[scope]){if(moduleScope===functionScope&&(_scope=functionScope[ast.argument.name])&&_scope.status==='variable_not_declared_yet'){functionScope[ast.argument.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===functionScope&&scope.type&&!functionScope[ast.argument.name]){functionScope[ast.argument.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.argument.name});}else{functionScope[ast.argument.name]=scope;}}else{if(moduleScope===blockScope&&(_scope=blockScope[ast.argument.name])&&_scope.status==='variable_not_declared_yet'){blockScope[ast.argument.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===blockScope&&scope.type&&!blockScope[ast.argument.name]){blockScope[ast.argument.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.argument.name});}else{blockScope[ast.argument.name]=scope;}}if(functionScopeTypes[scope]&&functionScope===moduleScope&&hookWith&&blockScope[hookWith]){if(!moduleScope.hasOwnProperty(Symbol.for('__with__'))){moduleScope[Symbol.for('__with__')]={};}moduleScope[Symbol.for('__with__')][ast.argument.name]=scope;}}break;case'ArrayPattern':ast.argument.__scope__=scope;break;default:console.error(type+': Unknown argument type '+ast.argument.type);break;}}else{console.error(type+': Missing Argument');}}break;case'ExperimentalRestProperty':scope=ast.__scope__;if(scope){if(ast.argument){switch(ast.argument.type){case'Identifier':if(ast.argument.name){if(nonOverridableIdentifiers.has(ast.argument.name)){ast.argument.name=nonOverridableIdentifiers.get(ast.argument.name);}if(functionScopeTypes[scope]){if(moduleScope===functionScope&&(_scope=functionScope[ast.argument.name])&&_scope.status==='variable_not_declared_yet'){functionScope[ast.argument.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===functionScope&&scope.type&&!functionScope[ast.argument.name]){functionScope[ast.argument.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.argument.name});}else{functionScope[ast.argument.name]=scope;}}else{if(moduleScope===blockScope&&(_scope=blockScope[ast.argument.name])&&_scope.status==='variable_not_declared_yet'){blockScope[ast.argument.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===blockScope&&scope.type&&!blockScope[ast.argument.name]){blockScope[ast.argument.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.argument.name});}else{blockScope[ast.argument.name]=scope;}}if(functionScopeTypes[scope]&&functionScope===moduleScope&&hookWith&&blockScope[hookWith]){if(!moduleScope.hasOwnProperty(Symbol.for('__with__'))){moduleScope[Symbol.for('__with__')]={};}moduleScope[Symbol.for('__with__')][ast.argument.name]=scope;}}break;default:ast.argument.__scope__=scope;break;}}else{console.error(type+': Missing Argument');}}break;case'SpreadElement':scope=ast.__scope__;if(scope){if(ast.argument){ast.argument.__scope__=scope;}else{console.error(type+': Missing Argument');}}break;case'ClassDeclaration':if(ast.__scope__){scope=ast.__scope__;}else{scope=type;}if(nonOverridableIdentifiers.has(ast.id.name)){ast.id.name=nonOverridableIdentifiers.get(ast.id.name);}if(moduleScope===blockScope&&(_scope=blockScope[ast.id.name])&&_scope.status==='variable_not_declared_yet'){blockScope[ast.id.name]=objectAssign(new String(scope),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported});}else if(moduleScope===blockScope&&scope.type&&!blockScope[ast.id.name]){blockScope[ast.id.name]=objectAssign(new String(scope),{type:scope.type,specifierType:type,exported:ast.id.name});}else{blockScope[ast.id.name]=scope;}blockScope=Object.create(blockScope);functionScope=blockScope;break;case'ClassExpression':blockScope=Object.create(blockScope);functionScope=blockScope;if(ast.id&&ast.id.name){if(nonOverridableIdentifiers.has(ast.id.name)){ast.id.name=nonOverridableIdentifiers.get(ast.id.name);}functionScope[ast.id.name]=type;}break;case'ClassBody':blockScope=Object.create(blockScope);functionScope=blockScope;functionScope[S_STRICT]='Literal';break;case'VariableDeclaration':if(ast.__scope__){scope=ast.__scope__;}else{scope=type+'_'+ast.kind;}for(index=0;index<ast.declarations.length;index++){if(ast.declarations[index]&&ast.declarations[index].type==='VariableDeclarator'){ast.declarations[index].__scope__=scope;}}break;case'VariableDeclarator':scope=ast.__scope__;if(scope){if(ast.id&&ast.id.type){if(variableDeclaratorIdTypes[ast.id.type]){ast.id.__scope__=scope;}else{console.error(type+': Unknown Id Type '+ast.id.type);}}}break;case'ImportDeclaration':for(index=0;index<ast.specifiers.length;index++){if(ast.specifiers[index]){let imported;switch(ast.specifiers[index].type){case'ImportDefaultSpecifier':imported='default';break;case'ImportNamespaceSpecifier':imported='*';break;case'ImportSpecifier':imported=ast.specifiers[index].imported?ast.specifiers[index].imported.name:undefined;break;default:break;}if(imported){if(ast.specifiers[index].local&&ast.specifiers[index].local.type==='Identifier'&&ast.specifiers[index].local.name){let local=ast.specifiers[index].local;if(nonOverridableIdentifiers.has(local.name)){local.name=nonOverridableIdentifiers.get(local.name);}if((_scope=moduleScope[local.name])&&_scope.status==='variable_not_declared_yet'){moduleScope[local.name]=objectAssign(new String(_scope.type),{type:_scope.type,specifierType:_scope.specifierType,exported:_scope.exported,exportedList:moduleScope[local.name].exportedList,importSpecifierType:ast.specifiers[index].type,imported:imported,source:ast.source.value,sourceAst:ast});}else{moduleScope[local.name]=objectAssign(new String(type),{type:type,specifierType:ast.specifiers[index].type,imported:imported,source:ast.source.value,sourceAst:ast});}}}}}if(ast.specifiers.length===0){let virtualName=ast.source.value+',';while(Reflect.has(moduleScope,virtualName)){virtualName+='+';}moduleScope[virtualName]=objectAssign(new String(type),{type:type,source:ast.source.value,sourceAst:ast});}break;case'ExportNamedDeclaration':if(ast.declaration){switch(ast.declaration.type){case'VariableDeclaration':ast.declaration.__scope__=objectAssign(new String(ast.declaration.type+'_'+ast.declaration.kind),{type:type});break;case'FunctionDeclaration':case'ClassDeclaration':ast.declaration.__scope__=objectAssign(new String(ast.declaration.type),{type:type});break;default:break;}}for(index=0;index<ast.specifiers.length;index++){if(ast.specifiers[index]){switch(ast.specifiers[index].type){case'ExportSpecifier':if(ast.specifiers[index].local&&ast.specifiers[index].local.type==='Identifier'&&ast.specifiers[index].local.name){let local=ast.specifiers[index].local;if(nonOverridableIdentifiers.has(local.name)){local.name=nonOverridableIdentifiers.get(local.name);}if(ast.source){moduleScope[ast.source.value+','+local.name]=objectAssign(new String(type),{type:type,specifierType:ast.specifiers[index].type,imported:local.name,exported:ast.specifiers[index].exported?ast.specifiers[index].exported.name:local.name,source:ast.source.value,sourceAst:ast});}else{if(moduleScope[local.name]){switch(moduleScope[local.name].type){case'ImportDeclaration':moduleScope[local.name]=objectAssign(new String(type),{type:type,specifierType:ast.specifiers[index].type,exported:ast.specifiers[index].exported?ast.specifiers[index].exported.name:local.name,importSpecifierType:moduleScope[local.name].specifierType,imported:moduleScope[local.name].imported,source:moduleScope[local.name].source,sourceAst:moduleScope[local.name].sourceAst,status:moduleScope[local.name].status});break;case'ExportNamedDeclaration':let exportedList=moduleScope[local.name].exportedList||{[moduleScope[local.name].exported]:true};exportedList[ast.specifiers[index].exported?ast.specifiers[index].exported.name:local.name]=true;moduleScope[local.name]=objectAssign(new String(type),{type:type,specifierType:ast.specifiers[index].type,exported:ast.specifiers[index].exported?ast.specifiers[index].exported.name:local.name,exportedList:exportedList,importSpecifierType:moduleScope[local.name].specifierType,imported:moduleScope[local.name].imported,source:moduleScope[local.name].source,sourceAst:moduleScope[local.name].sourceAst,status:moduleScope[local.name].status});break;default:moduleScope[local.name]=objectAssign(new String(moduleScope[local.name]),{type:type,specifierType:ast.specifiers[index].type,exported:ast.specifiers[index].exported?ast.specifiers[index].exported.name:local.name});break;}}else{moduleScope[local.name]=objectAssign(new String(type),{type:type,specifierType:ast.specifiers[index].type,exported:ast.specifiers[index].exported?ast.specifiers[index].exported.name:local.name,status:'variable_not_declared_yet'});}}}break;default:break;}}}break;case'ExportDefaultDeclaration':moduleScope['*,default']=objectAssign(new String(type),{type:type,specifierType:type,exported:'default'});break;case'ExportAllDeclaration':moduleScope[ast.source.value+',*']=objectAssign(new String(type),{type:type,specifierType:type,exported:'*',source:ast.source.value,sourceAst:ast});break;case'ForStatement':case'ForInStatement':case'ForOfStatement':case'BlockStatement':blockScope=Object.create(blockScope);if(ast.__with_body__){ast.__with_body__=undefined;blockScope[hookWith]=true;blockScope=Object.create(blockScope);}break;case'WithStatement':if(hookWith&&ast.body){ast.body.__with_body__=true;}break;case'Program':if(ast.sourceType==='module'){blockScope=Object.create(blockScope);functionScope=blockScope;moduleScope=blockScope;functionScope[S_STRICT]='Literal';}else if(Array.isArray(ast.body)&&ast.body.length>0&&(item=ast.body[0])&&typeof item==='object'&&Reflect.has(item,'type')&&item.type==='ExpressionStatement'&&item.expression&&item.expression.type==='Literal'&&item.expression.value==='use strict'){functionScope[S_STRICT]='Literal';}break;default:break;}ast.$block$=blockScope;ast.$function$=functionScope;for(target in ast){if(scopes[target]){continue;}child=ast[target];if(child){if(Array.isArray(child)){for(t=child,index=0,l=t.length;index<l;index++){item=t[index];if(item instanceof Object&&typeof item.type==='string'){_analyzeScope(item,blockScope,functionScope,moduleScope,hookName,hookWith);}}}else if(child instanceof Object&&typeof child.type==='string'){_analyzeScope(child,blockScope,functionScope,moduleScope,hookName,hookWith);}}}}function _logAst(ast){let o=ast.$block$;let scope='';while(o&&o!==Object.prototype){scope+=(o===ast.$function$?'*':'')+'['+Object.entries(o).map(([k,v])=>k+'('+v+')').join(',')+']';o=Object.getPrototypeOf(o);}console.log(ast.type,ast.name||'',scope);}function _nonGlobalScope(blockScope,globalScope){let o=blockScope;let list={};while(o&&o!==globalScope){Object.assign(list,o);o=Object.getPrototypeOf(o);}return list;}function _nonGlobalWithScope(blockScope,globalScope,hookWith){let o=blockScope;let list={};while(o&&o!==globalScope){Object.assign(list,o);if(o.hasOwnProperty(hookWith)){break;}o=Object.getPrototypeOf(o);}return list;}function _isWithScoped(blockScope,name,hookWith){if(blockScope[hookWith]){if(blockScope[name]){for(let o=blockScope;!o.hasOwnProperty(hookWith);o=Object.getPrototypeOf(o)){if(o.hasOwnProperty(name)){return false;}}}return true;}else{return false;}}function _logScope(ast){let target,child,t,index,i,l,item,type,scope;_logAst(ast);for(target in ast){if(scopes[target]){continue;}child=ast[target];if(child){if(Array.isArray(child)){for(t=child,index=0,l=t.length;index<l;index++){item=t[index];if(item instanceof Object&&typeof item.type==='string'){_logScope(item);}}}else if(child instanceof Object&&typeof child.type==='string'){_logScope(child);}}}}function objectAssign(target,src){let p;for(p in src){if(typeof src[p]!=='undefined'){target[p]=src[p];}}return target;}function _getModuleContext(_scope,moduleDependencies){let namespace;let moduleContext;let name;let isExport=false;switch(_scope.type){case'ImportDeclaration':moduleContext=_scope.resolvedSource;switch(_scope.specifierType){case'ImportDefaultSpecifier':case'ImportNamespaceSpecifier':case'ImportSpecifier':if(moduleDependencies[moduleContext]){namespace=moduleDependencies[moduleContext][1];name=_scope.imported;}break;default:break;}break;case'ExportNamedDeclaration':switch(_scope.toString()){case'VariableDeclaration_let':case'VariableDeclaration_const':case'VariableDeclaration_var':case'FunctionDeclaration':case'ClassDeclaration':moduleContext=moduleDependencies['*'][3];namespace=moduleDependencies['*'][1];name=_scope.exported;isExport=true;break;case'ExportNamedDeclaration':if(_scope.resolvedSource){moduleContext=_scope.resolvedSource;namespace=moduleDependencies[moduleContext][1];name=_scope.imported;}break;default:break;}break;default:moduleContext='';namespace='';name='';break;}return{moduleContext,name,namespace,isExport};}function _preprocess(ast,hookName,astPath,contextGeneratorName,contextGenerator,metaHooking,_hookProperty,_sourceMap,_hookGlobal,_hookPrefix,hookWith,blockScope,functionScope,globalScope,globalObjectScope,globalClassScope){let context,template,f,params,body,useStrict,wrapper,target,child,t,index,l,item,__hooked__;blockScope=ast.$block$||blockScope;functionScope=ast.$function$||functionScope;ast.$block$=blockScope;ast.$function$=functionScope;__hooked__=ast.__hooked__;switch(ast.type){case'VariableDeclaration':if(ast.__hooked__){break;}else if(_hookProperty&&_hookGlobal&&Array.isArray(ast.declarations)&&ast.declarations.length>0&&globalScope===(ast.kind==='var'?functionScope:blockScope)){if(ast.__for__&&ast.declarations.length===1&&(ast.declarations[0].id.type==='Identifier'||ast.declarations[0].id.type==='ArrayPattern'||ast.declarations[0].id.type==='ObjectPattern')&&!ast.declarations[0].init){switch(ast.declarations[0].id.type){case'Identifier':if(!blockScope[ast.declarations[0].id.name]){context=contextGenerator(astPath).replace(/\'/g,'\\\'');body=ast.declarations[0].id;t=functionScope[S_STRICT];template=_espreeParse(t?'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'name\', \'#var\')[X_X_XcontextX_X_X[0]]':'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'name\', \'var\')[X_X_XcontextX_X_X[0]]',hookName,astPath[0][4]).expression;template.object.arguments[1].property.value=astPath[0][5](context);template.object.arguments[1].__hooked__=true;template.object.arguments[2].value=body.name;template.object.__hooked__=true;template.object.callee.__hooked__=true;template.object.callee.object.__hooked__=true;template.object.callee.property.__hooked__=true;if(t){template.property.property.value=astPath[0][5]('S'+_hookPrefix+body.name+';'+context);}else{template.property.property.value=astPath[0][5](_hookPrefix+body.name+';'+context);}template.property.__hooked__=true;template.__hooked__=true;ast.declarations=undefined;ast.kind=undefined;objectAssign(ast,template);}break;case'ArrayPattern':template=ast.declarations[0].id;template.__global__=ast.kind;template.__LHS__=true;ast.declarations=undefined;ast.kind=undefined;objectAssign(ast,template);for(index=0,l=ast.elements.length;index<l;index++){if(ast.elements[index]){switch(ast.elements[index].type){case'Identifier':case'AssignmentPattern':case'ArrayPattern':case'ObjectPattern':case'RestElement':case'MemberExpression':ast.elements[index].__LHS__=ast.__LHS__;ast.elements[index].__global__=ast.__global__;break;default:console.error(ast.type+': Unknown Element Type '+ast.elements[index].type);break;}}}ast.__LHS__=undefined;ast.__global__=undefined;break;case'ObjectPattern':template=ast.declarations[0].id;template.__global__=ast.kind;template.__LHS__=true;ast.declarations=undefined;ast.kind=undefined;objectAssign(ast,template);for(index=0,l=ast.properties.length;index<ast.properties.length;index++){if(ast.properties[index]){if(ast.properties[index].value){switch(ast.properties[index].value.type){case'Identifier':case'AssignmentPattern':case'ArrayPattern':case'ObjectPattern':case'MemberExpression':if(ast.properties[index].shorthand&&ast.properties[index].value.type==='Identifier'){if(!blockScope[ast.properties[index].value.name]){ast.properties[index].shorthand=false;ast.properties[index].key=_clone(ast.properties[index].key);}}ast.properties[index].value.__LHS__=ast.__LHS__;ast.properties[index].value.__global__=ast.__global__;break;default:console.error(type+': Unknown Property Type '+ast.properties[index].type);break;}}else if(ast.properties[index].argument&&ast.properties[index].type==='ExperimentalRestProperty'){ast.properties[index].__LHS__=ast.__LHS__;ast.properties[index].__global__=ast.__global__;}}}ast.__LHS__=undefined;ast.__global__=undefined;break;default:break;}}else{template=_espreeParse('1,2','','');template.expression.expressions=ast.declarations;for(index=0,l=template.expression.expressions.length;index<l;index++){if(template.expression.expressions[index].id.type==='Identifier'&&!template.expression.expressions[index].init){template.expression.expressions[index]=template.expression.expressions[index].id;}template.expression.expressions[index].__global__=ast.kind;template.expression.expressions[index].__LHS__=true;}ast.declarations=undefined;ast.kind=undefined;objectAssign(ast,ast.__for__?template.expression:template);}}break;case'VariableDeclarator':if(_hookProperty&&ast.id&&typeof ast.id==='object'){ast.id.__LHS__=ast.type;if(ast.init){switch(ast.id.type){case'ObjectPattern':case'ArrayPattern':ast.init.__iteration__=true;break;default:break;}if(ast.init.type==='Identifier'&&ast.init.name){if(blockScope[ast.init.name]&&blockScope[ast.init.name].type){ast.init.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.init.__with__='get';}else if(_hookGlobal&&!blockScope[ast.init.name]){ast.init.__global__='get';}}if(_hookGlobal){if(ast.__global__){template=_espreeParse('id = init','','').expression;template.left=ast.id;template.left.__global__=ast.__global__;template.right=ast.init;ast.id=undefined;ast.init=undefined;ast.__global__=undefined;objectAssign(ast,template);}}}}break;case'ClassExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty){if(ast.superClass&&ast.superClass.type==='Identifier'&&ast.superClass.name){if(blockScope[ast.superClass.name]&&blockScope[ast.superClass.name].type){ast.superClass.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.superClass.__with__='get';}else if(_hookGlobal&&!blockScope[ast.superClass.name]){ast.superClass.__global__='get';}}}break;case'ClassDeclaration':if(ast.__hooked__){ast.__hooked__=undefined;}else{if(_hookProperty){if(ast.superClass&&ast.superClass.type==='Identifier'&&ast.superClass.name){if(blockScope[ast.superClass.name]&&blockScope[ast.superClass.name].type){ast.superClass.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.superClass.__with__='get';}else if(_hookGlobal&&!blockScope[ast.superClass.name]){ast.superClass.__global__='get';}}if(_hookGlobal&&Object.getPrototypeOf(functionScope)===globalScope){context=contextGenerator(astPath).replace(/\'/g,'\\\'');t=functionScope[S_STRICT];template=_espreeParse(t?'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'cname\', \'#class\')[X_X_XcontextX_X_X[0]] = class cname {}':'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'cname\', \'class\')[X_X_XcontextX_X_X[0]] = class cname {}',hookName,astPath[0][4]);template.expression.left.object.arguments[1].property.value=astPath[0][5](context);template.expression.left.object.arguments[1].__hooked__=true;template.expression.left.object.arguments[2].value=ast.id.name;template.expression.left.object.__hooked__=true;template.expression.left.object.callee.__hooked__=true;if(t){template.expression.left.property.property.value=astPath[0][5]('S'+_hookPrefix+ast.id.name+';'+context);}else{template.expression.left.property.property.value=astPath[0][5](_hookPrefix+ast.id.name+';'+context);}template.expression.left.property.__hooked__=true;template.expression.left.__hooked__=true;objectAssign(template.expression.right,ast);template.expression.right.type='ClassExpression';template.expression.right.__hooked__=true;template.expression.right.__moved__=true;template.expression.__hooked__=true;ast.id=undefined;ast.superClass=undefined;ast.body=undefined;objectAssign(ast,template);}}}break;case'MemberExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty&&typeof ast.object==='object'&&typeof ast.property==='object'){if(ast.object.type==='Super'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'s.\', this, [\'p\', p => super[p]], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;if(ast.computed){params[0]=ast.property;if(params[0].type==='Identifier'&&blockScope[params[0].name]&&blockScope[params[0].name].type){params[0].__module__='get';}}else{params[0].value=ast.property.name;if(_sourceMap){params[0].start=ast.property.start;params[0].end=ast.property.end;}params[0].raw=undefined;}params[1].__hooked__=true;params[1].body.__hooked__=true;params[1].$block$=params[1].$function$=Object.create(blockScope);params[1].$block$.p=true;ast.object=undefined;ast.property=undefined;ast.computed=undefined;objectAssign(ast,f);}else{if(hookWith&&blockScope[hookWith]){if(ast.object.type==='Identifier'){ast.object.__with__='get';}}if(ast.__LHS__){context=contextGenerator(astPath).replace(/\'/g,'\\\'');t=functionScope[S_STRICT];template=_espreeParse(t?'_X_hookName_X_(\'#.=\', o, [\'p\'], X_X_XcontextX_X_X[0])[\'=\']':'_X_hookName_X_(\'.=\', o, [\'p\'], X_X_XcontextX_X_X[0])[\'=\']',hookName,astPath[0][4]);f=template.expression.object;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[1]=ast.object;if(ast.object.type==='Identifier'&&blockScope[ast.object.name]&&blockScope[ast.object.name].type){ast.object.__module__='get';}else if(_hookGlobal&&f.arguments[1].type==='Identifier'&&!blockScope[f.arguments[1].name]){f.arguments[1].__global__='get';}if(ast.computed){params[0]=ast.property;if(ast.property.type==='Identifier'&&blockScope[ast.property.name]&&blockScope[ast.property.name].type){ast.property.__module__='get';}}else{params[0].value=ast.property.name;if(_sourceMap){params[0].start=ast.property.start;params[0].end=ast.property.end;}params[0].raw=undefined;}template.expression.__hooked__=true;f.callee.__hooked__=true;f.__hooked__=true;ast.object=undefined;ast.property=undefined;ast.computed=undefined;ast.__LHS__=undefined;objectAssign(ast,template.expression);}else{context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'_X_hookName_X_(\'#.\', o, [\'p\'], X_X_XcontextX_X_X[0])':'_X_hookName_X_(\'.\', o, [\'p\'], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[1]=ast.object;if(ast.object.type==='Identifier'&&blockScope[ast.object.name]&&blockScope[ast.object.name].type){ast.object.__module__='get';}else if(_hookGlobal&&f.arguments[1].type==='Identifier'&&!blockScope[f.arguments[1].name]){f.arguments[1].__global__='get';}if(ast.computed){params[0]=ast.property;if(ast.property.type==='Identifier'&&blockScope[ast.property.name]&&blockScope[ast.property.name].type){ast.property.__module__='get';}}else{params[0].value=ast.property.name;if(_sourceMap){params[0].start=ast.property.start;params[0].end=ast.property.end;}params[0].raw=undefined;}ast.object=undefined;ast.property=undefined;ast.computed=undefined;objectAssign(ast,f);}}}break;case'UpdateExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty&&typeof ast.operator==='string'&&typeof ast.prefix==='boolean'&&typeof ast.argument==='object'){switch(ast.argument.type){case'MemberExpression':if(ast.argument.object.type==='Super'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', this, [\'p\', p => super[p]++], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value=ast.prefix?ast.operator+'s':'s'+ast.operator;if(ast.argument.computed){params[0]=ast.argument.property;}else{params[0].value=ast.argument.property.name;params[0].raw=undefined;}params[1].body.operator=ast.operator;params[1].body.prefix=ast.prefix;params[1].body.argument.__hooked__=true;params[1].body.__hooked__=true;params[1].__hooked__=true;params[1].$block$=params[1].$function$=Object.create(blockScope);params[1].$block$.p=true;ast.operator=undefined;ast.prefix=undefined;ast.argument=undefined;objectAssign(ast,f);}else{if(hookWith&&blockScope[hookWith]){if(ast.argument.object.type==='Identifier'){ast.argument.object.__with__='get';}}if(ast.argument.object.type==='Identifier'&&blockScope[ast.argument.object.name]&&blockScope[ast.argument.object.name].type){ast.argument.object.__module__='get';}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', o, [\'p\'], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;if(functionScope[S_STRICT]){f.arguments[0].value=ast.prefix?'#'+ast.operator+'p':'#p'+ast.operator;}else{f.arguments[0].value=ast.prefix?ast.operator+'p':'p'+ast.operator;}f.arguments[1]=ast.argument.object;if(ast.argument.computed){params[0]=ast.argument.property;}else{params[0].value=ast.argument.property.name;params[0].raw=undefined;}ast.operator=undefined;ast.prefix=undefined;ast.argument=undefined;objectAssign(ast,f);}break;case'Identifier':if(hookWith&&blockScope[hookWith]){if(!_isWithScoped(blockScope,ast.argument.name,hookWith)){break;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', '+hookWith+', [\'p\', () => foo++], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value=ast.prefix?ast.operator+'w':'w'+ast.operator;f.arguments[1].__hooked__=true;params[0].value=ast.argument.name;params[1].body.argument.name=ast.argument.name;params[1].body.operator=ast.operator;params[1].body.prefix=ast.prefix;params[1].body.__hooked__=true;params[1].__hooked__=true;ast.operator=undefined;ast.prefix=undefined;ast.argument=undefined;objectAssign(ast,f);}else if(astPath[1][1].moduleDependencies&&blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let _scope=ast.$block$[ast.argument.name];let moduleDependencies=astPath[1][1].moduleDependencies;let {moduleContext,name,namespace,isExport}=_getModuleContext(_scope,moduleDependencies);let _context=name==='*'?moduleContext:moduleContext+','+name;template=_espreeParse('_X_hookName_X_(\'op\', m, [X_X_XcontextX_X_X[0], () => foo++], X_X_XcontextX_X_X[0], null)',hookName,astPath[0][4]);f=template.expression;f.arguments[1].name=ast.argument.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value=ast.prefix?ast.operator+'m':'m'+ast.operator;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;params[1].body.argument.name=ast.argument.name;params[1].body.operator=ast.operator;params[1].body.prefix=ast.prefix;params[1].body.__hooked__=true;params[1].__hooked__=true;ast.operator=undefined;ast.prefix=undefined;ast.argument=undefined;objectAssign(ast,f);}else if(_hookGlobal&&ast.argument.name&&!blockScope[ast.argument.name]){ast.argument.__global__='set';}break;default:break;}}break;case'UnaryExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty&&typeof ast.argument==='object'){switch(ast.argument.type){case'MemberExpression':if(ast.operator==='delete'){if(hookWith&&blockScope[hookWith]){if(ast.argument.object.type==='Identifier'){ast.argument.object.__with__='get';}}else if(ast.argument.object.type==='Identifier'&&blockScope[ast.argument.object.name]&&blockScope[ast.argument.object.name].type){ast.argument.object.__module__='get';}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', o, [\'p\'], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;if(functionScope[S_STRICT]){f.arguments[0].value='#'+ast.operator;}else{f.arguments[0].value=ast.operator;}f.arguments[1]=ast.argument.object;if(ast.argument.computed){params[0]=ast.argument.property;}else{params[0].value=ast.argument.property.name;params[0].raw=undefined;}ast.operator=undefined;ast.prefix=undefined;ast.argument=undefined;objectAssign(ast,f);}break;case'Identifier':switch(ast.operator){case'delete':if(hookWith&&blockScope[hookWith]){if(!_isWithScoped(blockScope,ast.argument.name,hookWith)){break;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'wdelete\', '+hookWith+', [\'p\', () => delete p], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[1].__hooked__=true;params[0].value=ast.argument.name;params[1].body.argument.name=ast.argument.name;params[1].body.argument.__hooked__=true;params[1].body.__hooked__=true;params[1].__hooked__=true;ast.argument=undefined;ast.operator=undefined;ast.prefix=undefined;objectAssign(ast,f);}else if(_hookGlobal&&ast.argument.name&&!blockScope[ast.argument.name]){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'name\', \'#delete\')':'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'name\', \'delete\')',hookName,astPath[0][4]);template.expression.arguments[1].property.value=astPath[0][5](context);template.expression.arguments[1].__hooked__=true;template.expression.arguments[2].value=ast.argument.name;template.expression.__hooked__=true;template.expression.callee.__hooked__=true;ast.argument=undefined;objectAssign(ast,template.expression);}break;case'typeof':if(hookWith&&blockScope[hookWith]){if(!_isWithScoped(blockScope,ast.argument.name,hookWith)){break;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'wtypeof\', '+hookWith+', [\'p\', () => typeof p], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[1].__hooked__=true;params[0].value=ast.argument.name;params[1].body.argument.name=ast.argument.name;params[1].body.argument.__hooked__=true;params[1].body.__hooked__=true;params[1].__hooked__=true;ast.argument=undefined;ast.operator=undefined;ast.prefix=undefined;objectAssign(ast,f);}else if(astPath[1][1].moduleDependencies&&blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let _scope=ast.$block$[ast.argument.name];let moduleDependencies=astPath[1][1].moduleDependencies;let {moduleContext,name,namespace,isExport}=_getModuleContext(_scope,moduleDependencies);let _context=name==='*'?moduleContext:moduleContext+','+name;template=_espreeParse('_X_hookName_X_(\'mtypeof\', m, [X_X_XcontextX_X_X[0], () => typeof p], X_X_XcontextX_X_X[0], null)',hookName,astPath[0][4]);f=template.expression;f.arguments[1].name=ast.argument.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;params[1].body.argument.name=ast.argument.name;params[1].body.argument.__hooked__=true;params[1].body.__hooked__=true;params[1].__hooked__=true;ast.argument=undefined;ast.operator=undefined;ast.prefix=undefined;objectAssign(ast,f);}else if(_hookGlobal&&ast.argument.name&&!blockScope[ast.argument.name]){ast.argument.__global__='typeof';}break;default:if(blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){ast.argument.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.argument.__with__='get';}else if(_hookGlobal&&ast.argument.name&&!blockScope[ast.argument.name]){ast.argument.__global__='get';}break;}break;default:break;}}break;case'AssignmentExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty&&typeof ast.operator==='string'&&typeof ast.left==='object'&&typeof ast.right==='object'){if(ast.right.type==='Identifier'){if(blockScope[ast.right.name]&&blockScope[ast.right.name].type){ast.right.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.right.__with__='get';}else if(_hookGlobal&&!blockScope[ast.right.name]){ast.right.__global__='get';}}switch(ast.left.type){case'MemberExpression':if(ast.left.object.type==='Super'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', this, [\'p\', v, (p, v) => super[p] = v], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value='s'+ast.operator;f.arguments[0].raw=undefined;if(ast.left.computed){params[0]=ast.left.property;}else{params[0].value=ast.left.property.name;if(_sourceMap){params[0].start=ast.left.property.start;params[0].end=ast.left.property.end;}params[0].raw=undefined;}params[1]=ast.right;params[2].body.operator=ast.operator;params[2].body.left.__hooked__=true;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.p=true;params[2].$block$.v=true;if(_sourceMap){f.callee.start=ast.left.start;f.callee.end=ast.left.end;f.callee.loc=ast.left.loc;f.callee.range=ast.left.range;}ast.operator=undefined;ast.left=undefined;ast.right=undefined;objectAssign(ast,f);}else{context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', o, [\'p\', v], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value=functionScope[S_STRICT]?'#'+ast.operator:ast.operator;f.arguments[0].raw=undefined;f.arguments[1]=ast.left.object;if(f.arguments[1].type==='Identifier'&&blockScope[f.arguments[1].name]&&blockScope[f.arguments[1].name].type){f.arguments[1].__module__='get';}if(ast.left.computed){params[0]=ast.left.property;}else{params[0].value=ast.left.property.name;if(_sourceMap){params[0].start=ast.left.property.start;params[0].end=ast.left.property.end;}params[0].raw=undefined;}params[1]=ast.right;if(_sourceMap){f.callee.start=ast.left.start;f.callee.end=ast.left.end;f.callee.loc=ast.left.loc;f.callee.range=ast.left.range;}ast.operator=undefined;ast.left=undefined;ast.right=undefined;objectAssign(ast,f);}break;case'Identifier':if(hookWith&&blockScope[hookWith]){if(!_isWithScoped(blockScope,ast.left.name,hookWith)){break;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'op\', '+hookWith+', [\'p\', v, (v) => p = v], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value='w'+ast.operator;f.arguments[0].raw=undefined;params[0].value=ast.left.name;params[0].raw=undefined;params[1]=ast.right;params[2].body.left.name=ast.left.name;params[2].body.left.__hooked__=true;params[2].body.operator=ast.operator;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.v=true;if(_sourceMap){params[0].start=ast.start;params[0].end=ast.end;f.callee.start=ast.left.start;f.callee.end=ast.left.end;f.callee.loc=ast.left.loc;f.callee.range=ast.left.range;}ast.operator=undefined;ast.left=undefined;ast.right=undefined;objectAssign(ast,f);}else if(astPath[1][1].moduleDependencies&&blockScope[ast.left.name]&&blockScope[ast.left.name].type){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let _scope=ast.$block$[ast.left.name];let moduleDependencies=astPath[1][1].moduleDependencies;let {moduleContext,name,namespace,isExport}=_getModuleContext(_scope,moduleDependencies);let _context=name==='*'?moduleContext:moduleContext+','+name;template=_espreeParse('_X_hookName_X_(\'op\', m, [X_X_XcontextX_X_X[0], v, (v) => p = v], X_X_XcontextX_X_X[0], null)',hookName,astPath[0][4]);f=template.expression;f.arguments[1].name=ast.left.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[0].value='m'+ast.operator;f.arguments[0].raw=undefined;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;params[1]=ast.right;params[2].body.left.name=ast.left.name;params[2].body.left.__hooked__=true;params[2].body.operator=ast.operator;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.v=true;f.__hooked__=true;if(_sourceMap){params[0].start=ast.start;params[0].end=ast.end;f.callee.start=ast.left.start;f.callee.end=ast.left.end;f.callee.loc=ast.left.loc;f.callee.range=ast.left.range;}ast.operator=undefined;ast.left=undefined;ast.right=undefined;objectAssign(ast,f);}else if(_hookGlobal&&!blockScope[ast.left.name]){ast.left.__global__='set';}break;case'ArrayPattern':case'ObjectPattern':ast.left.__LHS__=true;if(hookWith&&blockScope[hookWith]){ast.left.__with__='set';}else if(_hookGlobal){ast.left.__global__='set';}ast.right.__iteration__=true;break;default:break;}}break;case'MethodDefinition':if(_hookProperty){if(ast.computed&&ast.key&&ast.key.type==='Identifier'&&ast.key.name){if(blockScope[ast.key.name]&&blockScope[ast.key.name].type){ast.key.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.key.__with__='get';}else if(_hookGlobal&&!blockScope[ast.key.name]){ast.key.__global__='get';}}}break;case'FunctionDeclaration':case'FunctionExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(typeof ast.body==='object'&&!Array.isArray(ast.body)&&ast.body.type==='BlockStatement'&&ast.body.body&&Array.isArray(ast.body.body)){params=ast.params;body=ast.body.body;if(body[0]&&body[0].type==='ExpressionStatement'&&body[0].expression&&body[0].expression.type==='Literal'&&body[0].expression.value==='use strict'){useStrict=body.shift();}else{useStrict=null;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');t=ast.params[0]&&ast.params[0].type==='ArrayPattern';template=_espreeParse(t?ast.generator?'function * f(...args) { yield * _X_hookName_X_(function * () {}, this, args, X_X_XcontextX_X_X[0]); }':'function f(...args) { return _X_hookName_X_(() => {}, null, args, X_X_XcontextX_X_X[0]); }':ast.generator?'function * f() { yield * _X_hookName_X_(function * () {}, this, arguments, X_X_XcontextX_X_X[0]); }':'function f() { return _X_hookName_X_(() => {}, null, arguments, X_X_XcontextX_X_X[0]); }',hookName,astPath[0][4]);if(ast.generator){template.body.body[0].expression.argument.arguments[3].property.value=astPath[0][5](context);template.body.body[0].expression.argument.arguments[3].__hooked__=true;}else{template.body.body[0].argument.arguments[3].property.value=astPath[0][5](context);template.body.body[0].argument.arguments[3].__hooked__=true;}f=ast.generator?template.body.body[0].expression.argument.arguments[0]:template.body.body[0].argument.arguments[0];f.async=ast.async;f.params=ast.params;f.body.body=body;f.__hooked__=true;if(ast.generator){template.body.body[0].expression.argument.callee.__hooked__=true;template.body.body[0].expression.argument.__hooked__=true;}else{template.body.body[0].argument.callee.__hooked__=true;template.body.body[0].argument.__hooked__=true;}let __iteration__=false;FUNCTION_PARAMS_FOR_LOOP:for(let i=0;i<ast.params.length;i++){switch(ast.params[i].type){case'ObjectPattern':case'ArrayPattern':__iteration__=true;break FUNCTION_PARAMS_FOR_LOOP;default:break;}}if(__iteration__){template.body.body.unshift({'type':'ForOfStatement','left':{'type':'VariableDeclaration','declarations':[{'type':'VariableDeclarator','id':{'type':'Identifier','name':'arg','__hooked__':true},'init':null,'__hooked__':true}],'kind':'let','__hooked__':true},'right':{'type':'Identifier','name':'arguments','__hooked__':true},'body':{'type':'ExpressionStatement','expression':{'type':'CallExpression','callee':{'type':'Identifier','name':hookName,'__hooked__':true},'arguments':[{'type':'Literal','value':functionScope[S_STRICT]?'#*':'*','__hooked__':true},{'type':'Identifier','name':'arg','__hooked__':true},{'type':'ArrayExpression','elements':[],'__hooked__':true},{'type':'MemberExpression','object':{'type':'Identifier','name':astPath[0][4],'__hooked__':true},'property':{'type':'Literal','value':astPath[0][5](context),'__hooked__':true},'computed':true,'__hooked__':true}],'__hooked__':true},'__hooked__':true},'__hooked__':true});}if(useStrict){template.body.body.unshift(useStrict);}ast.params=t?template.params:params.map(function _trim(param){return param&&(param.type==='ArrayPattern'?{type:param.type,elements:param.elements.map(element=>_trim(element))}:param.type==='AssignmentPattern'?param.left:param.type==='ObjectPattern'?{type:'ObjectPattern',properties:param.properties.map(prop=>prop.value&&prop.value.type==='AssignmentPattern'?((p,v)=>(p.value=v,p))(objectAssign({},prop),prop.value.left):prop.value&&prop.value.type==='ObjectPattern'?((p,v)=>(p.value=v,p))(objectAssign({},prop),_trim(prop.value)):prop)}:param);});if(_sourceMap){template.body.start=ast.body.start;template.body.end=ast.body.end;template.body.loc=ast.body.loc;template.body.range=ast.body.range;}ast.body=template.body;if(_hookProperty&&_hookGlobal&&ast.type==='FunctionDeclaration'&&Object.getPrototypeOf(functionScope)===globalScope){t=functionScope[S_STRICT];template=_espreeParse(t?'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'fname\', \'#function\')[X_X_XcontextX_X_X[0]] = function fname() {}':'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'fname\', \'function\')[X_X_XcontextX_X_X[0]] = function fname() {}',hookName,astPath[0][4]);template.expression.left.object.arguments[1].property.value=astPath[0][5](context);template.expression.left.object.arguments[1].__hooked__=true;template.expression.left.object.arguments[2].value=ast.id.name;template.expression.left.object.__hooked__=true;template.expression.left.object.callee.__hooked__=true;if(t){template.expression.left.property.property.value=astPath[0][5]('S'+_hookPrefix+ast.id.name+';'+context);}else{template.expression.left.property.property.value=astPath[0][5](_hookPrefix+ast.id.name+';'+context);}template.expression.left.property.__hooked__=true;template.expression.left.__hooked__=true;objectAssign(template.expression.right,ast);template.expression.right.type='FunctionExpression';template.expression.right.__hooked__=true;template.expression.right.__moved__=true;template.expression.__hooked__=true;ast.id=undefined;ast.generator=undefined;ast.expression=undefined;ast.async=undefined;ast.params=undefined;ast.body=undefined;objectAssign(ast,template);}}break;case'ArrowFunctionExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else{if(typeof ast.body==='object'&&!Array.isArray(ast.body)){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(ast.body.type==='BlockStatement'?'(...args) => _X_hookName_X_(p => { return p; }, null, args, X_X_XcontextX_X_X[0])':ast.body.type==='ObjectExpression'?'(...args) => _X_hookName_X_(p => ({ p: p }), null, args, X_X_XcontextX_X_X[0])':'(...args) => _X_hookName_X_(p => p, null, args, X_X_XcontextX_X_X[0])',hookName,astPath[0][4]).expression;f=template.body.arguments[0];template.body.arguments[3].property.value=astPath[0][5](context);template.body.arguments[3].__hooked__=true;f.async=ast.async;f.params=ast.params;f.body=ast.body;f.__hooked__=true;template.body.__hooked__=true;template.body.callee.__hooked__=true;let __iteration__=false;PARAMS_FOR_LOOP:for(let i=0;i<ast.params.length;i++){switch(ast.params[i].type){case'ObjectPattern':case'ArrayPattern':__iteration__=true;break PARAMS_FOR_LOOP;default:break;}}if(__iteration__){template.body.arguments[2]={'type':'CallExpression','callee':{'type':'MemberExpression','object':{'type':'Identifier','name':'args','__hooked__':true},'property':{'type':'Identifier','name':'map','__hooked__':true},'computed':false,'__hooked__':true},'arguments':[{'type':'ArrowFunctionExpression','id':null,'generator':false,'expression':true,'async':false,'params':[{'type':'Identifier','name':'arg','__hooked__':true}],'body':{'type':'CallExpression','callee':{'type':'Identifier','name':hookName,'__hooked__':true},'arguments':[{'type':'Literal','value':functionScope[S_STRICT]?'#*':'*','__hooked__':true},{'type':'Identifier','name':'arg','__hooked__':true},{'type':'ArrayExpression','elements':[],'__hooked__':true},{'type':'MemberExpression','object':{'type':'Identifier','name':template.body.arguments[3].object.name,'__hooked__':true},'property':{'type':'Literal','value':template.body.arguments[3].property.value,'__hooked__':true},'computed':true,'__hooked__':true}],'__hooked__':true},'__hooked__':true}],'__hooked__':true};}ast.params=template.params;ast.body=template.body;}}break;case'NewExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty){if(hookWith&&blockScope[hookWith]&&ast.callee.type==='Identifier'&&_isWithScoped(blockScope,ast.callee.name,hookWith)){if(ast.callee.name){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'wnew\', '+hookWith+', [\'p\', [], (...args) => new p(...args), p], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].value=ast.callee.name;params[1].elements=ast.arguments;params[2].body.callee.name=ast.callee.name;f.arguments[1].__hooked__=true;params[2].params[0].__hooked__=true;params[2].params[0].argument.__hooked__=true;params[2].body.callee.__hooked__=true;params[2].body.arguments[0].__hooked__=true;params[2].body.arguments[0].argument.__hooked__=true;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.args=true;params[3].name=ast.callee.name;params[3].__hooked__=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}else if(astPath[1][1].moduleDependencies&&ast.callee.type==='Identifier'&&blockScope[ast.callee.name]&&blockScope[ast.callee.name].type){if(ast.callee.name){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let _scope=ast.$block$[ast.callee.name];let moduleDependencies=astPath[1][1].moduleDependencies;let {moduleContext,name,namespace,isExport}=_getModuleContext(_scope,moduleDependencies);let _context=name==='*'?moduleContext:moduleContext+','+name;template=_espreeParse('_X_hookName_X_(\'mnew\', m, [X_X_XcontextX_X_X[0], [], (...args) => new p(...args)], X_X_XcontextX_X_X[0], null)',hookName,astPath[0][4]);f=template.expression;f.arguments[1].name=ast.callee.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;params[1].elements=ast.arguments;params[2].body.callee.name=ast.callee.name;params[2].params[0].__hooked__=true;params[2].params[0].argument.__hooked__=true;params[2].body.callee.__hooked__=true;params[2].body.arguments[0].__hooked__=true;params[2].body.arguments[0].argument.__hooked__=true;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.args=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}else{context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(ctor, null, [], X_X_XcontextX_X_X[0], true)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[0]=ast.callee;if(_hookGlobal&&f.arguments[0].type==='Identifier'&&!blockScope[f.arguments[0].name]){f.arguments[0].__global__='get';}f.arguments[2].elements=ast.arguments;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}break;case'CallExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(metaHooking&&ast.callee&&ast.callee.type==='Identifier'&&(ast.callee.name==='setTimeout'||ast.callee.name==='setInterval')&&ast.arguments&&ast.arguments[0]&&ast.arguments[0].type!=='FunctionExpression'&&ast.arguments[0].type!=='ArrowFunctionExpression'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('$hook$.'+ast.callee.name+'(Symbol.for(\'_X_hookName_X_\'), [[\'X_X_XcontextX_X_X\', {}]], \''+contextGeneratorName+'\')',hookName,context).expression;template.arguments[0].__hooked__=true;template.arguments[0].callee.__hooked__=true;template.callee.__hooked__=true;template.__hooked__=true;ast.callee=template;}else if(metaHooking&&ast.callee&&ast.callee.type==='Identifier'&&ast.callee.name==='eval'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('$hook$.'+ast.callee.name+'(Symbol.for(\'_X_hookName_X_\'), [[\'X_X_XcontextX_X_X\', {}]], \''+contextGeneratorName+'\', {v:true})',hookName,context).expression;template.arguments[0].__hooked__=true;template.arguments[0].callee.__hooked__=true;wrapper=functionScope[S_STRICT]?_espreeParse('(script, _eval) => _eval(script)',hookName,context).expression:_espreeParse('(script, eval) => eval(script)',hookName,context).expression;t=template.arguments[3].properties.pop();let nonGlobalScope=_nonGlobalScope(blockScope,globalScope);for(let v in nonGlobalScope){item=_clone(t);item.key.name=v;template.arguments[3].properties.push(item);}if(functionScope[S_STRICT]){item=_clone(t);item.key.name='$use_strict$';template.arguments[3].properties.push(item);}if(_sourceMap){_trimStartEndRaw(template);}template.callee.__hooked__=true;template.__hooked__=true;ast.callee=template;if(ast.arguments.length===1){wrapper.__hooked__=true;wrapper.body.__hooked__=true;ast.arguments.push(wrapper);}}else if(_hookProperty&&ast.callee&&ast.callee.type==='MemberExpression'){if(ast.callee.object.type==='Super'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'s()\', this, [\'p\', [], p => super[p]], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;if(ast.callee.computed){params[0]=ast.callee.property;if(params[0].type==='Identifier'&&blockScope[params[0].name]&&blockScope[params[0].name].type){params[0].__module__='get';}}else{params[0].value=ast.callee.property.name;params[0].raw=undefined;}params[1]={'type':'ArrayExpression','elements':ast.arguments};params[2].__hooked__=true;params[2].body.__hooked__=true;params[2].$block$=params[1].$function$=Object.create(blockScope);params[2].$block$.p=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}else{if(hookWith&&blockScope[hookWith]){if(ast.callee.object.type==='Identifier'){ast.callee.object.__with__='get';}}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'_X_hookName_X_(\'#()\', o, [\'p\', args], X_X_XcontextX_X_X[0])':'_X_hookName_X_(\'()\', o, [\'p\', args], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[1]=ast.callee.object;if(f.arguments[1].type==='Identifier'&&blockScope[f.arguments[1].name]&&blockScope[f.arguments[1].name].type){f.arguments[1].__module__='get';}else if(_hookGlobal&&f.arguments[1].type==='Identifier'&&!blockScope[f.arguments[1].name]){f.arguments[1].__global__='get';}if(ast.callee.computed){params[0]=ast.callee.property;if(params[0].type==='Identifier'&&blockScope[params[0].name]&&blockScope[params[0].name].type){params[0].__module__='get';}}else{params[0].value=ast.callee.property.name;params[0].raw=undefined;}params[1]={'type':'ArrayExpression','elements':ast.arguments};if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}else if(_hookProperty){if(ast.callee.type==='Super'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_((newTarget,...args) => super(...args), null, [], X_X_XcontextX_X_X[0], \'\')',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;ast.arguments.unshift({type:'MetaProperty',meta:{type:'Identifier',name:'new'},property:{type:'Identifier',name:'target'}});f.arguments[2].elements=ast.arguments;f.__hooked__=true;f.callee.__hooked__=true;f.arguments[0].__hooked__=true;f.arguments[0].body.__hooked__=true;f.arguments[0].body.callee.__hooked__=true;f.arguments[0].body.arguments[0].__hooked__=true;f.arguments[0].body.arguments[0].argument.__hooked__=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}else if(ast.callee.type==='Import'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_((Import,ImportSpecifier) => import(ImportSpecifier), null, [], X_X_XcontextX_X_X[0], NaN)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;ast.arguments.unshift({type:'Literal',value:'import()'});if(astPath[1][1].sourceType==='module'&&hook.parameters.importMapper){if(astPath[1][1].moduleDependencies[astPath[0][0]].resolvedSource){ast.arguments.push({'type':'ObjectExpression','properties':[{'type':'Property','method':false,'shorthand':false,'computed':false,'key':{'type':'Identifier','name':'url'},'value':{'type':'Literal','value':astPath[0][0]},'kind':'init'}]});}else{ast.arguments.push({__hooked__:true,type:'MetaProperty',meta:{type:'Identifier',name:'import'},property:{type:'Identifier',name:'meta'}});}}f.arguments[2].elements=ast.arguments;f.__hooked__=true;f.callee.__hooked__=true;f.arguments[0].__hooked__=true;f.arguments[0].body.__hooked__=true;f.arguments[0].body.callee.__hooked__=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}else{let isInitialImportScripts=ast.callee.name==='importScripts'&&ast.arguments[0]&&ast.arguments[0].type==='Literal'&&typeof ast.arguments[0].value==='string'&&ast.arguments[0].value.indexOf('/hook.min.js?')>=0;if(isInitialImportScripts){for(let i=0;i<ast.arguments.length;i++){if(ast.arguments[i].type==='Literal'&&typeof ast.arguments[i].value==='string'&&ast.arguments[i].value.trim().match(/^(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*[.]m?js)(\?([^#]*))?(#(.*))?$/)){}else{ast.arguments[i].type='Literal';ast.arguments[i].value='!!! invalid url !!!';}}}else{if(hookWith&&blockScope[hookWith]&&ast.callee.type==='Identifier'&&_isWithScoped(blockScope,ast.callee.name,hookWith)){if(ast.callee.name){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'w()\', '+hookWith+', [\'p\', [], (...args) => p(...args), p], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].value=ast.callee.name;params[1].elements=ast.arguments;f.arguments[1].__hooked__=true;params[2].body.callee.name=ast.callee.name;params[2].body.callee.__hooked__=true;params[2].params[0].__hooked__=true;params[2].params[0].argument.__hooked__=true;params[2].body.arguments[0].__hooked__=true;params[2].body.arguments[0].argument.__hooked__=true;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.args=true;params[3].name=ast.callee.name;params[3].__hooked__=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}else if(astPath[1][1].moduleDependencies&&ast.callee.type==='Identifier'&&blockScope[ast.callee.name]&&blockScope[ast.callee.name].type){if(ast.callee.name){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let _scope=ast.$block$[ast.callee.name];let moduleDependencies=astPath[1][1].moduleDependencies;let {moduleContext,name,namespace,isExport}=_getModuleContext(_scope,moduleDependencies);let _context=name==='*'?moduleContext:moduleContext+','+name;template=_espreeParse('_X_hookName_X_(\'m()\', m, [X_X_XcontextX_X_X[0], [], (...args) => p(...args)], X_X_XcontextX_X_X[0], null)',hookName,astPath[0][4]);f=template.expression;f.arguments[1].name=ast.callee.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;params[1].elements=ast.arguments;f.arguments[1].__hooked__=true;params[2].body.callee.name=ast.callee.name;params[2].body.callee.__hooked__=true;params[2].params[0].__hooked__=true;params[2].params[0].argument.__hooked__=true;params[2].body.arguments[0].__hooked__=true;params[2].body.arguments[0].argument.__hooked__=true;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.args=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}else if(ast.callee.name==='require'&&Reflect.has(blockScope,'require')&&ast.arguments[0]&&ast.arguments[0].type==='Literal'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let targetContext=ast.arguments[0].value;let targetContextIndex=context.indexOf('|');if(targetContextIndex>0){targetContext=context.substring(targetContextIndex+1);context=context.substring(0,targetContextIndex);}template=_espreeParse('_X_hookName_X_(() => require(\'module.js\'), null, [], X_X_XcontextX_X_X[0], NaN)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[0].body.arguments[0].value=ast.arguments[0].value;ast.arguments.unshift({type:'Literal',value:'require'});ast.arguments[2]={type:'Literal',value:targetContext};f.arguments[2].elements=ast.arguments;f.__hooked__=true;f.callee.__hooked__=true;f.arguments[0].__hooked__=true;f.arguments[0].body.__hooked__=true;f.arguments[0].body.callee.__hooked__=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}else{context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(f, null, [], X_X_XcontextX_X_X[0], 0)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[0]=ast.callee;if(_hookGlobal&&f.arguments[0].type==='Identifier'&&!blockScope[f.arguments[0].name]){f.arguments[0].__global__='get';}f.arguments[2].elements=ast.arguments;f.__hooked__=true;f.callee.__hooked__=true;if(_sourceMap){f.callee.start=ast.callee.start;f.callee.end=ast.callee.end;f.callee.loc=ast.callee.loc;f.callee.range=ast.callee.range;}ast.callee=undefined;ast.arguments=undefined;objectAssign(ast,f);}}}}break;case'MetaProperty':ast.meta=ast.meta.name;ast.property=ast.property.name;if(ast.__hooked__){ast.__hooked__=undefined;}else{if(ast.meta==='import'&&ast.property==='meta'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(() => import.meta, null, [\'import.meta\'], X_X_XcontextX_X_X[0], NaN)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.__hooked__=true;f.callee.__hooked__=true;f.arguments[0].__hooked__=true;f.arguments[0].body.__hooked__=true;if(_sourceMap){f.callee.start=ast.start;f.callee.end=ast.end;f.callee.loc=ast.loc;f.callee.range=ast.range;}ast.meta=undefined;ast.property=undefined;objectAssign(ast,f);}}break;case'Identifier':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty){if(_hookGlobal&&ast.__global__&&ast.__LHS__&&ast.name&&!blockScope[ast.name]&&hookWith&&blockScope[hookWith]&&globalScope.hasOwnProperty(Symbol.for('__with__'))&&globalScope[Symbol.for('__with__')][ast.name]){ast.__with__='set';}if(ast.__with__){switch(ast.__with__){case'get':if(!_isWithScoped(blockScope,ast.name,hookWith)){break;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'w.\', '+hookWith+', [\'p\', () => p], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].value=ast.name;params[0].raw=undefined;params[1].body.name=ast.name;params[1].body.__hooked__=true;params[1].__hooked__=true;params[1].$block$=params[1].$function$=Object.create(blockScope);f.arguments[1].__hooked__=true;f.__hooked__=true;if(_sourceMap){params[0].start=ast.start;params[0].end=ast.end;f.callee.start=ast.start;f.callee.end=ast.end;f.callee.loc=ast.loc;f.callee.range=ast.range;}ast.name=undefined;ast.__with__=undefined;objectAssign(ast,f);break;case'set':if(!_isWithScoped(blockScope,ast.name,hookWith)){break;}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'w.=\', '+hookWith+', [\'p\', { set [\'=\'](v) { p = v; }, get [\'=\']() { return p; } }], X_X_XcontextX_X_X[0], false)[\'=\']',hookName,astPath[0][4]);f=template.expression.object;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].value=ast.name;params[0].raw=undefined;params[1].properties[0].value.body.body[0].expression.left.name=ast.name;params[1].properties[0].value.body.body[0].expression.left.__hooked__=true;params[1].properties[0].value.body.body[0].expression.right.__hooked__=true;params[1].properties[0].value.body.body[0].expression.__hooked__=true;params[1].properties[0].value.params[0].__hooked__=true;params[1].properties[0].value.__hooked__=true;params[1].properties[0].value.$block$=params[1].properties[0].value.$function$=Object.create(blockScope);params[1].properties[0].value.$block$.v=true;params[1].properties[1].value.body.body[0].argument.name=ast.name;params[1].properties[1].value.body.body[0].argument.__hooked__=true;params[1].properties[1].value.__hooked__=true;params[1].properties[1].value.$block$=params[1].properties[1].value.$function$=Object.create(blockScope);params[1].__hooked__=true;template.expression.__hooked__=true;template.expression.object.__hooked__=true;if(_sourceMap){params[0].start=ast.start;params[0].end=ast.end;f.callee.start=ast.start;f.callee.end=ast.end;f.callee.loc=ast.loc;f.callee.range=ast.range;}ast.name=undefined;ast.__with__=undefined;objectAssign(ast,template.expression);break;default:ast.__with__=undefined;break;}}else if(ast.__module__&&astPath[1][1].moduleDependencies){context=contextGenerator(astPath).replace(/\'/g,'\\\'');let _scope=ast.$block$[ast.name];let moduleDependencies=astPath[1][1].moduleDependencies;let {moduleContext,name,namespace,isExport}=_getModuleContext(_scope,moduleDependencies);let _context=name==='*'?moduleContext:moduleContext+','+name;switch(ast.__module__){case'get':template=_espreeParse('_X_hookName_X_(\'m\', m, [X_X_XcontextX_X_X[0]], X_X_XcontextX_X_X[0], null)',hookName,astPath[0][4]);f=template.expression;f.arguments[1].name=ast.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;f.__hooked__=true;if(_sourceMap){f.arguments[1].start=ast.start;f.arguments[1].end=ast.end;f.callee.start=ast.start;f.callee.end=ast.end;f.callee.loc=ast.loc;f.callee.range=ast.range;}ast.name=undefined;ast.__module__=undefined;objectAssign(ast,f);break;case'set':template=_espreeParse('_X_hookName_X_(\'m.=\', m, [X_X_XcontextX_X_X[0], cb => ({ set [\'=\'](v) { a = v; cb(v); }, get [\'=\']() { return a; } })], X_X_XcontextX_X_X[0], null)[\'=\']',hookName,astPath[0][4]);f=template.expression.object;f.arguments[1].name=ast.name;f.arguments[1].__hooked__=true;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].property.value=astPath[0][5](_context);params[0].__hooked__=true;params[1].params[0].__hooked__=true;params[1].body.properties[0].value.body.body[0].expression.left.name=ast.name;params[1].body.properties[0].value.body.body[0].expression.left.__hooked__=true;params[1].body.properties[0].value.body.body[0].expression.right.__hooked__=true;params[1].body.properties[0].value.body.body[0].expression.__hooked__=true;params[1].body.properties[0].value.body.body[1].expression.callee.__hooked__=true;params[1].body.properties[0].value.body.body[1].expression.arguments[0].__hooked__=true;params[1].body.properties[0].value.body.body[1].expression.__hooked__=true;params[1].body.properties[0].value.params[0].__hooked__=true;params[1].body.properties[0].value.__hooked__=true;params[1].body.properties[0].value.$block$=params[1].body.properties[0].value.$function$=Object.create(blockScope);params[1].body.properties[0].value.$block$.v=true;params[1].body.properties[1].value.body.body[0].argument.name=ast.name;params[1].body.properties[1].value.body.body[0].argument.__hooked__=true;params[1].body.properties[1].value.__hooked__=true;params[1].body.properties[1].value.$block$=params[1].body.properties[1].value.$function$=Object.create(blockScope);params[1].body.__hooked__=true;params[1].__hooked__=true;template.expression.__hooked__=true;template.expression.object.__hooked__=true;f.__hooked__=true;if(_sourceMap){params[0].start=ast.start;params[0].end=ast.end;f.callee.start=ast.start;f.callee.end=ast.end;f.callee.loc=ast.loc;f.callee.range=ast.range;}ast.name=undefined;ast.__module__=undefined;objectAssign(ast,template.expression);break;default:ast.__module__=undefined;break;}}else if(_hookGlobal&&ast.__global__&&ast.name&&!blockScope[ast.name]){context=contextGenerator(astPath).replace(/\'/g,'\\\'');t=functionScope[S_STRICT];template=_espreeParse(t?'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'name\', \'#var\')[X_X_XcontextX_X_X[0]]':'$hook$.global(_X_hookName_X_, X_X_XcontextX_X_X[0], \'name\', \'var\')[X_X_XcontextX_X_X[0]]',hookName,astPath[0][4]);template.expression.object.arguments[1].property.value=astPath[0][5](context);template.expression.object.arguments[1].__hooked__=true;template.expression.object.arguments[2].value=ast.name;template.expression.object.arguments[3].value=t?'#'+ast.__global__:ast.__global__;template.expression.object.__hooked__=true;template.expression.object.callee.__hooked__=true;template.expression.object.callee.object.__hooked__=true;template.expression.object.callee.property.__hooked__=true;template.expression.property.property.value=astPath[0][5](t?'S'+_hookPrefix+ast.name+';'+context:_hookPrefix+ast.name+';'+context);template.expression.property.__hooked__=true;template.expression.__hooked__=true;ast.name=undefined;ast.__global__=undefined;objectAssign(ast,ast.__hoisted__?template.expression.object:template.expression);ast.__hoisted__=undefined;}}break;case'ArrayPattern':if(_hookProperty){for(index=0,l=ast.elements.length;index<l;index++){if(ast.elements[index]){switch(ast.elements[index].type){case'Identifier':if(ast.__LHS__==='VariableDeclarator'){}else if(blockScope[ast.elements[index].name]&&blockScope[ast.elements[index].name].type){if(ast.__LHS__){ast.elements[index].__module__='set';}else{ast.elements[index].__module__='get';}}case'AssignmentPattern':case'ArrayPattern':case'ObjectPattern':case'RestElement':case'MemberExpression':if(ast.__LHS__){ast.elements[index].__LHS__=ast.__LHS__;}if(hookWith&&ast.__with__){ast.elements[index].__with__=ast.__with__;}if(_hookGlobal&&ast.__global__){ast.elements[index].__global__=ast.__global__;}break;default:console.error(ast.type+': Unknown Element Type '+ast.elements[index].type);break;}}}ast.__LHS__=undefined;ast.__with__=undefined;ast.__global__=undefined;}break;case'ArrayExpression':if(_hookProperty){for(index=0,l=ast.elements.length;index<l;index++){let element=ast.elements[index];if(element&&element.type==='Identifier'){if(blockScope[element.name]&&blockScope[element.name].type){element.__module__='get';}else if(hookWith&&blockScope[hookWith]){element.__with__='get';}else if(_hookGlobal&&!blockScope[element.name]){element.__global__='get';}}}}break;case'ObjectExpression':if(_hookProperty){for(index=0,l=ast.properties.length;index<l;index++){let property=ast.properties[index];if(property.type==='Property'&&property.value.type==='Identifier'){if(blockScope[property.value.name]&&blockScope[property.value.name].type){if(property.shorthand){property.shorthand=false;property.key=_clone(property.key);}property.value.__module__='get';}}}}break;case'RestElement':if(_hookProperty){if(ast.__LHS__){ast.argument.__LHS__=ast.__LHS__;}if(ast.argument.__LHS__!=='VariableDeclarator'&&ast.argument.type==='Identifier'&&blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){ast.argument.__module__=ast.__LHS__?'set':'get';}else if(hookWith&&ast.__with__){if(ast.argument){ast.argument.__with__=ast.__with__;}}else if(_hookGlobal&&ast.__global__){if(ast.argument){ast.argument.__global__=ast.__global__;}}ast.__LHS__=undefined;ast.__with__=undefined;ast.__global__=undefined;}break;case'SpreadElement':if(_hookProperty){if(ast.argument.type==='Identifier'){if(blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){ast.argument.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.argument.__with__='get';}else if(_hookGlobal&&!blockScope[ast.argument.name]){ast.argument.__global__='get';}}ast.__with__=undefined;ast.__global__=undefined;}break;case'ObjectPattern':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty){for(index=0,l=ast.properties.length;index<ast.properties.length;index++){if(ast.properties[index]){if(ast.properties[index].value){switch(ast.properties[index].value.type){case'Identifier':if(ast.__LHS__!=='VariableDeclarator'&&blockScope[ast.properties[index].value.name]&&blockScope[ast.properties[index].value.name].type){if(ast.properties[index].shorthand){ast.properties[index].shorthand=false;ast.properties[index].key=_clone(ast.properties[index].key);}if(ast.__LHS__){ast.properties[index].value.__module__='set';}else{ast.properties[index].value.__module__='get';}}case'AssignmentPattern':if(ast.__LHS__&&ast.__LHS__!=='VariableDeclarator'&&ast.properties[index].value.type==='AssignmentPattern'){if(ast.properties[index].shorthand){ast.properties[index].shorthand=false;ast.properties[index].key=_clone(ast.properties[index].key);}}case'ArrayPattern':case'ObjectPattern':case'MemberExpression':if(ast.properties[index].shorthand&&ast.properties[index].value.type==='Identifier'){if(hookWith&&ast.__with__||_hookGlobal&&ast.__global__&&!blockScope[ast.properties[index].value.name]){ast.properties[index].shorthand=false;ast.properties[index].key=_clone(ast.properties[index].key);}}if(ast.__LHS__){ast.properties[index].value.__LHS__=ast.__LHS__;}if(hookWith&&ast.__with__){ast.properties[index].value.__with__=ast.__with__;}if(_hookGlobal&&ast.__global__){ast.properties[index].value.__global__=ast.__global__;}break;default:console.error(type+': Unknown Property Type '+ast.properties[index].type);break;}}else if(ast.properties[index].argument&&ast.properties[index].type==='ExperimentalRestProperty'){ast.properties[index].__LHS__=ast.__LHS__;ast.properties[index].__with__=ast.__with__;ast.properties[index].__global__=ast.__global__;}}}ast.__LHS__=undefined;ast.__with__=undefined;ast.__global__=undefined;}break;case'Property':if(_hookProperty){if(ast.computed&&ast.key&&ast.key.type==='Identifier'&&ast.key.name){if(blockScope[ast.key.name]&&blockScope[ast.key.name].type){ast.key.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.key.__with__='get';}else if(_hookGlobal&&!blockScope[ast.key.name]){ast.key.__global__='get';}}if(ast.value&&ast.value.type==='Identifier'&&ast.value.name){if(!ast.value.__with__&&!ast.value.__global__&&!ast.value.__LHS__&&!ast.value.__module__){if(blockScope[ast.value.name]&&blockScope[ast.value.name].type){if(ast.shorthand){ast.key=_clone(ast.key);ast.shorthand=false;}ast.value.__module__='get';}else if(hookWith&&blockScope[hookWith]){if(ast.shorthand){ast.key=_clone(ast.key);ast.shorthand=false;}ast.value.__with__='get';}else if(_hookGlobal&&!blockScope[ast.value.name]){if(ast.shorthand){ast.key=_clone(ast.key);ast.shorthand=false;}ast.value.__global__='get';}}}}break;case'ExperimentalSpreadProperty':if(_hookProperty){if(ast.argument&&ast.argument.type==='Identifier'&&ast.argument.name){if(blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){ast.argument.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.argument.__with__='get';}else if(_hookGlobal&&!blockScope[ast.argument.name]){ast.argument.__global__='get';}}context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'_X_hookName_X_(\'#*\', o, [], X_X_XcontextX_X_X[0])':'_X_hookName_X_(\'*\', o, [], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[1]=ast.argument;f.callee.__hooked__=true;f.__hooked__=true;ast.argument=f;}break;case'ExperimentalRestProperty':if(_hookProperty){if(ast.__LHS__){ast.argument.__LHS__=ast.__LHS__;}if(ast.argument.__LHS__!=='VariableDeclarator'&&ast.argument.type==='Identifier'&&blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){ast.argument.__module__=ast.argument.__LHS__?'set':'get';}else if(hookWith&&ast.__with__){if(ast.argument){ast.argument.__with__=ast.__with__;}}else if(_hookGlobal&&ast.__global__){if(ast.argument){ast.argument.__global__=ast.__global__;}}ast.__LHS__=undefined;ast.__with__=undefined;ast.__global__=undefined;}break;case'AssignmentPattern':if(_hookProperty){if(ast.__LHS__){ast.left.__LHS__=ast.__LHS__;}if(ast.left.__LHS__!=='VariableDeclarator'&&ast.left.type==='Identifier'&&blockScope[ast.left.name]&&blockScope[ast.left.name].type){ast.left.__module__='set';}else if(hookName&&ast.__with__){ast.left.__with__=ast.__with__;}else if(_hookGlobal&&ast.__global__){ast.left.__global__=ast.__global__;}ast.__LHS__=undefined;ast.__with__=undefined;ast.__global__=undefined;if(ast.right&&ast.right.type==='Identifier'&&ast.right.name){if(blockScope[ast.right.name]&&blockScope[ast.right.name].type){ast.right.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.right.__with__='get';}else if(_hookGlobal&&!blockScope[ast.right.name]){ast.right.__global__='get';}}}break;case'ExpressionStatement':if(_hookProperty){if(ast.expression&&ast.expression.type==='Identifier'&&ast.expression.name){if(blockScope[ast.expression.name]&&blockScope[ast.expression.name].type){ast.expression.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.expression.__with__='get';}else if(_hookGlobal&&!blockScope[ast.expression.name]){ast.expression.__global__='get';}}}break;case'BinaryExpression':if(_hookProperty){if(ast.left&&ast.left.type==='Identifier'&&ast.left.name){if(blockScope[ast.left.name]&&blockScope[ast.left.name].type){ast.left.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.left.__with__='get';}else if(_hookGlobal&&!blockScope[ast.left.name]){ast.left.__global__='get';}}if(ast.right&&ast.right.type==='Identifier'&&ast.right.name){if(blockScope[ast.right.name]&&blockScope[ast.right.name].type){ast.right.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.right.__with__='get';}else if(_hookGlobal&&!blockScope[ast.right.name]){ast.right.__global__='get';}}if(ast.operator==='in'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'_X_hookName_X_(\'#in\', o, [\'p\'], X_X_XcontextX_X_X[0])':'_X_hookName_X_(\'in\', o, [\'p\'], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;f.arguments[1]=ast.right;params[0]=ast.left;f.callee.__hooked__=true;f.__hooked__=true;ast.left=undefined;ast.right=undefined;ast.op=undefined;objectAssign(ast,f);}}break;case'LogicalExpression':if(_hookProperty){if(ast.left&&ast.left.type==='Identifier'&&ast.left.name){if(blockScope[ast.left.name]&&blockScope[ast.left.name].type){ast.left.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.left.__with__='get';}else if(_hookGlobal&&!blockScope[ast.left.name]){ast.left.__global__='get';}}if(ast.right&&ast.right.type==='Identifier'&&ast.right.name){if(blockScope[ast.right.name]&&blockScope[ast.right.name].type){ast.right.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.right.__with__='get';}else if(_hookGlobal&&!blockScope[ast.right.name]){ast.right.__global__='get';}}}break;case'ConditionalExpression':if(_hookProperty){if(ast.test&&ast.test.type==='Identifier'&&ast.test.name){if(blockScope[ast.test.name]&&blockScope[ast.test.name].type){ast.test.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.test.__with__='get';}else if(_hookGlobal&&!blockScope[ast.test.name]){ast.test.__global__='get';}}if(ast.consequent&&ast.consequent.type==='Identifier'&&ast.consequent.name){if(blockScope[ast.consequent.name]&&blockScope[ast.consequent.name].type){ast.consequent.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.consequent.__with__='get';}else if(_hookGlobal&&!blockScope[ast.consequent.name]){ast.consequent.__global__='get';}}if(ast.alternate&&ast.alternate.type==='Identifier'&&ast.alternate.name){if(blockScope[ast.alternate.name]&&blockScope[ast.alternate.name].type){ast.alternate.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.alternate.__with__='get';}else if(_hookGlobal&&!blockScope[ast.alternate.name]){ast.alternate.__global__='get';}}}break;case'IfStatement':case'DoWhileStatement':case'WhileStatement':if(_hookProperty){if(ast.test&&ast.test.type==='Identifier'&&ast.test.name){if(blockScope[ast.test.name]&&blockScope[ast.test.name].type){ast.test.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.test.__with__='get';}else if(_hookGlobal&&!blockScope[ast.test.name]){ast.test.__global__='get';}}}break;case'ImportDeclaration':case'ExportAllDeclaration':if(ast.__hooked__){ast.__hooked__=undefined;}else if(ast.source&&(ast.source.type!=='Literal'||typeof ast.source.value!=='string'||!(ast.resolvedSource||ast.source.value).match(/^\s*(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*[.]m?js)(\?([^#]*))?(#(.*))?\s*$/))){ast.source.type='Literal';ast.source.value='!!! invalid script url !!!';}else if(ast.resolvedSource){context=contextGenerator(astPath).replace(/\'/g,'\\\'');ast.source.value=ast.resolvedSource;}break;case'ExportNamedDeclaration':if(ast.source){for(index=0;index<ast.specifiers.length;index++){if(ast.specifiers[index]){ast.specifiers[index].__hooked__=true;}}if(ast.source.type!=='Literal'||typeof ast.source.value!=='string'||!(ast.resolvedSource||ast.source.value).match(/^\s*(([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*[.]m?js)(\?([^#]*))?(#(.*))?\s*$/)){ast.source.type='Literal';ast.source.value='!!! invalid script url !!!';}else if(ast.resolvedSource){context=contextGenerator(astPath).replace(/\'/g,'\\\'');ast.source.value=ast.resolvedSource;}}break;case'ExportDefaultDeclaration':if(_hookProperty){if(ast.declaration&&ast.declaration.type==='Identifier'&&ast.declaration.name){if(blockScope[ast.declaration.name]&&blockScope[ast.declaration.name].type){ast.declaration.__module__='get';}else if(_hookGlobal&&!blockScope[ast.declaration.name]){ast.declaration.__global__='get';}}}break;case'ExportSpecifier':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty&&_hookGlobal){if(ast.local&&ast.local.type==='Identifier'&&ast.local.name&&(!blockScope[ast.local.name]||blockScope[ast.local.name].status==='variable_not_declared_yet')){if(blockScope[ast.local.name]){blockScope[ast.local.name]=undefined;}console.warn('hook: unexpected export of global variable '+ast.local.name+' is replaced with undefined');ast.local.name='undefined';}}break;case'ForStatement':if(_hookProperty){if(ast.init){switch(ast.init.type){case'Identifier':if(ast.init.name){if(blockScope[ast.init.name]&&blockScope[ast.init.name].type){ast.init.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.init.__with__='get';}else if(_hookGlobal&&!blockScope[ast.init.name]){ast.init.__global__='get';}}break;case'VariableDeclaration':if(_hookGlobal){ast.init.__for__=true;}break;default:break;}}if(ast.test&&ast.test.type==='Identifier'&&ast.test.name){if(blockScope[ast.test.name]&&blockScope[ast.test.name].type){ast.test.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.test.__with__='get';}else if(_hookGlobal&&!blockScope[ast.test.name]){ast.test.__global__='get';}}if(ast.update&&ast.update.type==='Identifier'&&ast.update.name){if(blockScope[ast.update.name]&&blockScope[ast.update.name].type){ast.update.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.update.__with__='get';}else if(_hookGlobal&&!blockScope[ast.update.name]){ast.update.__global__='get';}}}break;case'ForInStatement':case'ForOfStatement':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty){if(ast.left){switch(ast.left.type){case'Identifier':if(ast.left.name){if(blockScope[ast.left.name]&&blockScope[ast.left.name].type){ast.left.__module__='set';}else if(hookWith&&blockScope[hookWith]){ast.left.__with__='set';}else if(_hookGlobal&&!blockScope[ast.left.name]){ast.left.__global__='set';}}break;case'ArrayPattern':case'ObjectPattern':if(hookWith&&blockScope[hookWith]){ast.left.__with__='set';}else if(_hookGlobal&&globalScope===functionScope){ast.left.__global__='set';ast.left.__for__=true;}ast.left.__LHS__=true;break;case'VariableDeclaration':if(_hookGlobal){ast.left.__for__=true;}break;default:break;}}if(ast.right&&ast.right.type==='Identifier'&&ast.right.name){if(blockScope[ast.right.name]&&blockScope[ast.right.name].type){ast.right.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.right.__with__='get';}else if(_hookGlobal&&!blockScope[ast.right.name]){ast.right.__global__='get';}}if(ast.right){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'_X_hookName_X_(\'#*\', o, [], X_X_XcontextX_X_X[0])':'_X_hookName_X_(\'*\', o, [], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[1]=ast.right;f.callee.__hooked__=true;f.__hooked__=true;ast.right=f;}}break;case'SwitchStatement':if(_hookProperty){if(ast.discriminant&&ast.discriminant.type==='Identifier'&&ast.discriminant.name){if(blockScope[ast.discriminant.name]&&blockScope[ast.discriminant.name].type){ast.discriminant.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.discriminant.__with__='get';}else if(_hookGlobal&&!blockScope[ast.discriminant.name]){ast.discriminant.__global__='get';}}}break;case'SwitchCase':if(_hookProperty){if(ast.test&&ast.test.type==='Identifier'&&ast.test.name){if(blockScope[ast.test.name]&&blockScope[ast.test.name].type){ast.test.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.test.__with__='get';}else if(_hookGlobal&&!blockScope[ast.test.name]){ast.test.__global__='get';}}}if(_sourceMap){ast.start=undefined;ast.end=undefined;ast.loc=undefined;ast.range=undefined;}break;case'TaggedTemplateExpression':if(ast.__hooked__){ast.__hooked__=undefined;}else if(_hookProperty){if(ast.tag&&ast.tag.type==='Identifier'&&ast.tag.name){if(blockScope[ast.tag.name]&&blockScope[ast.tag.name].type){ast.tag.__module__='get';}else if(hookWith&&_isWithScoped(blockScope,ast.tag.name,hookWith)){ast.tag.__with__='get';}else if(_hookGlobal&&!blockScope[ast.tag.name]){ast.tag.__global__='get';}}if(ast.tag.__with__==='get'){context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(\'w()\', '+hookWith+', [\'p\', [], (...args) => p(...args), p], X_X_XcontextX_X_X[0], false)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;params=f.arguments[2].elements;params[0].value=ast.tag.name;params[1].elements.push({'type':'CallExpression','callee':{'type':'ArrowFunctionExpression','id':null,'generator':false,'expression':false,'async':false,'params':[{'type':'Identifier','name':'s',__hooked__:true},{'type':'Identifier','name':'r',__hooked__:true}],'body':{'type':'BlockStatement','body':[{'type':'ExpressionStatement','expression':{'type':'AssignmentExpression','operator':'=','left':{'type':'MemberExpression','object':{'type':'Identifier','name':'s',__hooked__:true},'property':{'type':'Identifier','name':'raw',__hooked__:true},'computed':false,__hooked__:true},'right':{'type':'Identifier','name':'r',__hooked__:true},__hooked__:true},__hooked__:true},{'type':'ReturnStatement','argument':{'type':'Identifier','name':'s',__hooked__:true},__hooked__:true}],__hooked__:true},__hooked__:true},'arguments':[{'type':'ArrayExpression','elements':[],__hooked__:true},{'type':'ArrayExpression','elements':[],__hooked__:true}],__hooked__:true});for(let element of ast.quasi.quasis){if(element.type==='TemplateElement'){params[1].elements[0].arguments[0].elements.push({'type':'Literal','value':element.value.cooked,__hooked__:true});params[1].elements[0].arguments[1].elements.push({'type':'Literal','value':element.value.raw,__hooked__:true});}}params[1].elements.splice(1,0,...ast.quasi.expressions);f.__hooked__=true;f.callee.__hooked__=true;f.arguments[1].__hooked__=true;params[2].body.callee.name=ast.tag.name;params[2].body.callee.__hooked__=true;params[2].params[0].__hooked__=true;params[2].params[0].argument.__hooked__=true;params[2].body.arguments[0].__hooked__=true;params[2].body.arguments[0].argument.__hooked__=true;params[2].body.__hooked__=true;params[2].__hooked__=true;params[2].$block$=params[2].$function$=Object.create(blockScope);params[2].$block$.args=true;params[3].name=ast.tag.name;params[3].__hooked__=true;if(_sourceMap){f.callee.start=ast.tag.start;f.callee.end=ast.tag.end;f.callee.loc=ast.tag.loc;f.callee.range=ast.tag.range;}ast.tag=undefined;ast.quasi=undefined;objectAssign(ast,f);}else{context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse('_X_hookName_X_(f, null, [], X_X_XcontextX_X_X[0], 0)',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[0]=ast.tag;f.arguments[2].elements.push({'type':'CallExpression','callee':{'type':'ArrowFunctionExpression','id':null,'generator':false,'expression':false,'async':false,'params':[{'type':'Identifier','name':'s',__hooked__:true},{'type':'Identifier','name':'r',__hooked__:true}],'body':{'type':'BlockStatement','body':[{'type':'ExpressionStatement','expression':{'type':'AssignmentExpression','operator':'=','left':{'type':'MemberExpression','object':{'type':'Identifier','name':'s',__hooked__:true},'property':{'type':'Identifier','name':'raw',__hooked__:true},'computed':false,__hooked__:true},'right':{'type':'Identifier','name':'r',__hooked__:true},__hooked__:true},__hooked__:true},{'type':'ReturnStatement','argument':{'type':'Identifier','name':'s',__hooked__:true},__hooked__:true}],__hooked__:true},__hooked__:true},'arguments':[{'type':'ArrayExpression','elements':[],__hooked__:true},{'type':'ArrayExpression','elements':[],__hooked__:true}],__hooked__:true});for(let element of ast.quasi.quasis){if(element.type==='TemplateElement'){f.arguments[2].elements[0].arguments[0].elements.push({'type':'Literal','value':element.value.cooked,__hooked__:true});f.arguments[2].elements[0].arguments[1].elements.push({'type':'Literal','value':element.value.raw,__hooked__:true});}}f.arguments[2].elements.splice(1,0,...ast.quasi.expressions);f.__hooked__=true;f.callee.__hooked__=true;if(_sourceMap){f.callee.start=ast.tag.start;f.callee.end=ast.tag.end;f.callee.loc=ast.tag.loc;f.callee.range=ast.tag.range;}ast.tag=undefined;ast.quasi=undefined;objectAssign(ast,f);}}break;case'SequenceExpression':case'TemplateLiteral':if(_hookProperty){for(index=0,l=ast.expressions.length;index<l;index++){if(ast.expressions[index]&&!ast.expressions[index].__global__&&ast.expressions[index].type==='Identifier'){if(blockScope[ast.expressions[index].name]&&blockScope[ast.expressions[index].name].type){ast.expressions[index].__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.expressions[index].__with__='get';}else if(_hookGlobal&&!blockScope[ast.expressions[index].name]){ast.expressions[index].__global__='get';}}}}break;case'AwaitExpression':case'ReturnStatement':case'ThrowStatement':case'YieldExpression':if(_hookProperty){if(ast.argument&&ast.argument.type==='Identifier'&&ast.argument.name){if(blockScope[ast.argument.name]&&blockScope[ast.argument.name].type){ast.argument.__module__='get';}else if(hookWith&&blockScope[hookWith]){ast.argument.__with__='get';}else if(_hookGlobal&&!blockScope[ast.argument.name]){ast.argument.__global__='get';}}}break;case'WithStatement':if(_hookProperty){if(ast.object&&ast.object.type==='Identifier'&&ast.object.name){if(hookWith&&blockScope[hookWith]){ast.object.__with__='get';}else if(_hookGlobal&&!blockScope[ast.object.name]){ast.object.__global__='get';}}if(hookWith){if(ast.object){let outerScope=_nonGlobalWithScope(blockScope,globalScope,hookWith);context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(outerScope[hookWith]?'$hook$.with(obj, { v: true }, ...'+hookWith+')':'$hook$.with(obj, { v: true })',hookName,context);f=template.expression;f.arguments[0]=ast.object;delete outerScope[hookWith];t=f.arguments[1].properties.shift();for(let v in outerScope){item=_clone(t);item.key.name=v;f.arguments[1].properties.push(item);}if(f.arguments[2]){f.arguments[2].__hooked__=true;f.arguments[2].argument.__hooked__=true;}f.callee.__hooked__=true;f.__hooked__=true;ast.object=f;}}}break;case'BlockStatement':if(_sourceMap){ast.start=undefined;ast.end=undefined;ast.loc=undefined;ast.range=undefined;}break;case'Program':context=contextGenerator(astPath).replace(/\'/g,'\\\'');let mapName;if(astPath[0][1].random){let random=new Uint32Array(8);_crypto=_crypto||crypto;_crypto.getRandomValues(random);mapName='__';for(var i=0;i<random.length;i++){mapName+=random[i].toString(16).padStart(8,'0');}mapName+='__';}else if(astPath[0][1].static&&typeof astPath[0][1].static==='string'){mapName=astPath[0][1].static;}else{const hash=createHash('sha256');hash.update(context+ast.__code__);mapName='__'+hash.digest('hex')+'__';}let spliceIndex=0;blockScope[mapName]=true;f=_espreeParse('const X_X_XcontextX_X_X = $hook$.$(_X_hookName_X_, []);',hookName,mapName);{astPath[0][4]=mapName;const map=new _Map();const contexts=f.declarations[0].init.arguments[1].elements;astPath[0][5]=function getContextIndex(context){let idx;if(map.has(context)){idx=map.get(context);}else{idx=contexts.length;contexts[idx]={type:'Literal',value:context};map.set(context,idx);}return idx;};}f.__hooked__=true;f.declarations[0].__hooked__=true;f.declarations[0].init.__hooked__=true;f.declarations[0].init.callee.__hooked__=true;f.declarations[0].init.arguments[0].__hooked__=true;if(Array.isArray(ast.body)&&ast.body.length>0&&(item=ast.body[0])&&typeof item==='object'&&Reflect.has(item,'type')&&item.type==='ExpressionStatement'&&item.expression&&item.expression.type==='Literal'&&item.expression.value==='use strict'){spliceIndex=1;}else{spliceIndex=0;}if((item=ast.body[spliceIndex])&&typeof item==='object'&&Reflect.has(item,'type')&&item.type==='ExpressionStatement'&&item.expression&&item.expression.type==='CallExpression'&&item.expression.callee.type==='Identifier'&&item.expression.callee.name==='importScripts'){spliceIndex++;}if(ast.body.length>0){ast.body.splice(spliceIndex,0,f);spliceIndex++;}if(ast.moduleDependencies){let idx=0;let _exportStatement=_espreeParse('_X_hookName_X_(() => {}, null, [\'export\', X_X_XcontextX_X_X[0], namespace ], X_X_XcontextX_X_X[0], NaN);',hookName,mapName);let _export=_exportStatement.expression;_export.arguments[3].property.value=astPath[0][5](context);_export.arguments[3].__hooked__=true;_export.arguments[2].elements[1].__hooked__=true;_export.arguments[2].elements[2].__hooked__=true;_export.arguments[2].__hooked__=true;_export.arguments[0].__hooked__=true;_export.arguments[0].body.__hooked__=true;_export.callee.__hooked__=true;_export.__hooked__=true;let _importDeclaration;let _importStatement=_espreeParse('_X_hookName_X_(() => {}, null, [\'import\', {} ], X_X_XcontextX_X_X[0], NaN);',hookName,mapName);let _import=_importStatement.expression;_import.arguments[3].property.value=astPath[0][5](context);_import.arguments[3].__hooked__=true;_import.arguments[2].elements[0].__hooked__=true;_import.arguments[2].elements[1].__hooked__=true;_import.arguments[2].__hooked__=true;_import.arguments[0].__hooked__=true;_import.arguments[0].body.__hooked__=true;_import.callee.__hooked__=true;_import.__hooked__=true;let _index;let name;let _module;let _imported={};let _importedVariables;for(name in ast.$block$){let _scope=ast.$block$[name];if(_scope.imported&&_scope.resolvedSource){_module=_scope.resolvedSource;if(ast.moduleDependencies[_module]){if(!_imported[_module]){_imported[_module]=new Set();}_imported[_module].add(_scope.imported);}else{console.error(`Program ast.moduleDependencies["${_module}"] is inexistent`);}}}if(hook.parameters.moduleDependencies){let dependencies;let moduleContext=ast.moduleContext;if(!Reflect.has(hook.parameters.moduleDependencies,moduleContext)){hook.parameters.moduleDependencies[moduleContext]={'imports':Object.create(null),'exports':Object.create(null)};}dependencies=hook.parameters.moduleDependencies[moduleContext];for(_module in ast.moduleDependencies){if(ast.moduleDependencies[_module][0]==='import'){if(!Reflect.has(dependencies.imports,_module)){dependencies.imports[_module]=Object.create(null);}}}for(let _name in ast.$block$){let _scope=ast.$block$[_name];if(_scope.imported&&_scope.resolvedSource){_module=_scope.resolvedSource;if(ast.moduleDependencies[_module]){if(!Reflect.has(dependencies.imports,_module)){dependencies.imports[_module]=Object.create(null);}if(!Reflect.has(dependencies.imports[_module],_scope.imported)){dependencies.imports[_module][_scope.imported]=[];}if(_name.indexOf(',')>=0){dependencies.imports[_module][_scope.imported].push(true);}else{dependencies.imports[_module][_scope.imported].push(_name);}}}}for(let _name in ast.$block$){let _scope=ast.$block$[_name];if(_scope.exported){let __name;if(_scope.resolvedSource&&_scope.imported){if(_scope.imported==='*'){__name=_scope.resolvedSource;}else{__name=_scope.resolvedSource+','+_scope.imported;}}else if(_scope.exported==='default'){if(_name==='*,default'){__name=true;}else{__name=_name;}}else if(_scope.exported==='*'){dependencies.exports[_scope.resolvedSource+',*']=_scope.resolvedSource;if(!Reflect.has(dependencies.imports[_scope.resolvedSource],'*')){dependencies.imports[_scope.resolvedSource]['*']=[];}dependencies.imports[_scope.resolvedSource]['*'].push('*');}else{__name=_name;}if(__name){if(_scope.exportedList){for(let _exported in _scope.exportedList){dependencies.exports[_exported]=__name;}}else{dependencies.exports[_scope.exported]=__name;}}}}}for(_module in ast.moduleDependencies){name=mapName+'module_namespace_'+idx;_importDeclaration={type:'ImportDeclaration',specifiers:[{type:'ImportNamespaceSpecifier',local:{type:'Identifier',name:name},__hooked__:true}],source:{type:'Literal',value:ast.moduleDependencies[_module].resolvedSource||_module},__hooked__:true};switch(ast.moduleDependencies[_module][0]){case'export':ast.body.splice(spliceIndex,0,_importDeclaration);spliceIndex++;ast.$block$[name]=true;_export.arguments[2].elements[2].name=name;_export.arguments[2].elements[1].property.value=_index=astPath[0][5](_module);ast.moduleDependencies[_module].push(name);ast.moduleDependencies[_module].push(_index);ast.moduleDependencies[_module].push(_module);ast.moduleDependencies['*']=ast.moduleDependencies[_module];break;case'import':ast.body.splice(spliceIndex,0,_importDeclaration);spliceIndex++;ast.$block$[name]=true;_importedVariables=[{type:'Identifier',name:name,__hooked__:true}];if(_imported[_module]){for(let v of _imported[_module]){_importedVariables.push({type:'Literal',value:v,__hooked__:true});}}_import.arguments[2].elements[1].properties.push({type:'Property',method:false,shorthand:false,computed:true,key:{type:'MemberExpression',object:{type:'Identifier',name:mapName,__hooked__:true},property:{type:'Literal',value:_index=astPath[0][5](_module),__hooked__:true},computed:true,__hooked__:true},value:{type:'ArrayExpression',elements:_importedVariables},kind:'init',__hooked__:true});ast.moduleDependencies[_module].push(name);ast.moduleDependencies[_module].push(_index);break;default:break;}idx++;}if(_import.arguments[2].elements[1].properties.length>0){ast.body.splice(spliceIndex,0,_importStatement);spliceIndex++;}ast.body.push(_exportStatement);}if(globalScope[Symbol.for('__with__')]){let template={'type':'VariableDeclaration','declarations':[],'kind':'var'};for(let v in globalScope[Symbol.for('__with__')]){if(globalScope[Symbol.for('__with__')][v]==='VariableDeclaration_var'){template.declarations.push({'type':'VariableDeclarator','id':{'type':'Identifier','name':v,__hoisted__:true},'init':null});}else{console.error('unknown declaration type in a with scope for ',v,globalScope[Symbol.for('__with__')][v]);}}if(ast.body.length>0){ast.body.splice(spliceIndex,0,template);}}break;default:break;}if(!__hooked__){if(ast.__iteration__){ast.__iteration__=undefined;context=contextGenerator(astPath).replace(/\'/g,'\\\'');template=_espreeParse(functionScope[S_STRICT]?'_X_hookName_X_(\'#*\', o, [], X_X_XcontextX_X_X[0])':'_X_hookName_X_(\'*\', o, [], X_X_XcontextX_X_X[0])',hookName,astPath[0][4]);f=template.expression;f.arguments[3].property.value=astPath[0][5](context);f.arguments[3].__hooked__=true;f.arguments[1]=objectAssign({},ast);f.arguments[1].__hooked__=true;f.callee.__hooked__=true;f.__hooked__=true;for(let p in ast){ast[p]=undefined;}objectAssign(ast,f);}}for(target in ast){if(scopes[target]){continue;}child=ast[target];if(child){astPath.push([target,child]);if(Array.isArray(child)){for(t=child,index=0,l=t.length;index<l;index++){item=t[index];if(item&&typeof item==='object'&&typeof item.type==='string'){astPath.push([index,item]);_preprocess(item,hookName,astPath,contextGeneratorName,contextGenerator,metaHooking,_hookProperty,_sourceMap,_hookGlobal,_hookPrefix,hookWith,blockScope,functionScope,globalScope,globalObjectScope,globalClassScope);astPath.pop();}}}else if(typeof child==='object'&&typeof child.type==='string'){_preprocess(child,hookName,astPath,contextGeneratorName,contextGenerator,metaHooking,_hookProperty,_sourceMap,_hookGlobal,_hookPrefix,hookWith,blockScope,functionScope,globalScope,globalObjectScope,globalClassScope);}astPath.pop();}}}function _validateNoHookScript(script,url,isContextGeneratorValidation=false){let hash=createHash('sha256');hash.update(script);let ticket=hash.digest('hex');hook.parameters.noHookAuthorizationPassed=hook.parameters.noHookAuthorizationPassed||{};if(hook.parameters.noHookAuthorizationPreValidated||hook.parameters.noHookAuthorization&&!hook.parameters.noHookAuthorization['*']){if((!hook.parameters.noHookAuthorization||hook.parameters.noHookAuthorization&&!hook.parameters.noHookAuthorization[ticket])&&(hook.parameters.noHookAuthorization&&!hook.parameters.noHookAuthorizationPreValidated||hook.parameters.noHookAuthorizationPreValidated&&!hook.parameters.noHookAuthorizationPreValidated[ticket])){if(hook.parameters.noHookAuthorization||isContextGeneratorValidation){console.error('invalidate no-hook for '+url.href+' ticket = '+ticket,script);hook.parameters.noHookAuthorizationFailed=hook.parameters.noHookAuthorizationFailed||{};hook.parameters.noHookAuthorizationFailed[ticket]=true;console.error('hook.parameters.noHookAuthorizationFailed = ',JSON.stringify(hook.parameters.noHookAuthorizationFailed,null,2));}script='/* invalidated unauthorized no-hook script */';}else if(hook.parameters.noHookAuthorizationPreValidated&&hook.parameters.noHookAuthorizationPreValidated['log-no-hook-authorization']){console.log('validate no-hook for '+url.href+' ticket = '+ticket,script.substr(0,100));}}else{hook.parameters.noHookAuthorizationPassed[ticket]=true;if(hook.parameters.noHookAuthorization&&hook.parameters.noHookAuthorization['*']){console.warn('no hooking ticket for '+url.href+' = '+ticket,script.substr(0,100));console.warn('hook.parameters.noHookAuthorizationPassed = ',JSON.stringify(hook.parameters.noHookAuthorizationPassed,null,2));}}return script;}function _getScriptHashes(){return hook.parameters.scriptHashes;}function _parseHookedInlineScript(inlineScript){let scriptHashes=_getScriptHashes();if(!scriptHashes){return{isHooked:false,isValidated:false,raw:inlineScript,hooked:null,ctx:null,embeddedRaw:null};}let match=inlineScript.match(/^\/\* ctx:(["'])([a-zA-Z0-9+/=]*)["'] raw:["']([a-zA-Z0-9+/=]*)["'] \*\/((.*\n?)*)$/);if(match){let isValidated=false;let ctx=decodeURIComponent(atob(match[2]));const hash=hook.utils.createHash('sha256');hash.update(inlineScript);let digest=hash.digest('hex');if(scriptHashes[digest]===ctx){isValidated=true;}return{isHooked:true,isValidated:isValidated,raw:decodeURIComponent(atob(match[3])),hooked:match[4],ctx:ctx,embeddedRaw:`/* ctx:${match[1]}${match[2]}${match[1]} raw:${match[1]}${match[3]}${match[1]} */`};}else{return{isHooked:false,isValidated:false,raw:inlineScript,hooked:null,ctx:null,embeddedRaw:null};}}function _preprocessHtml(html,hookName,url,cors,contextGenerator,contextGeneratorScripts,isDecoded,metaHooking=true,scriptOffset=0,_hookProperty=true,asynchronous=false,isSrcdoc=false){if(asynchronous){let worker=getBestHookWorker();if(worker){return new Promise(function(resolve,reject){let id=getHookId(html);let size=html.length;if(url instanceof URL){url=url.href;}worker.tasks[id]={status:'requesting'};worker.taskQueueSize+=size;worker.tasks[id].callback=function callback(task){delete worker.tasks[id];worker.taskQueueSize-=size;if(task.status==='success'){resolve(task.result);}else{reject(task.error);}};let message=[id,'text/html',html,hookName,url,cors,contextGenerator,contextGeneratorScripts,isDecoded,metaHooking,scriptOffset,_hookProperty,false,false];worker.port.postMessage(JSON.stringify(message,null,0));});}else{return new Promise(function(resolve,reject){try{resolve(_preprocessHtml(html,hookName,url,cors,contextGenerator,contextGeneratorScripts,isDecoded,metaHooking,scriptOffset,_hookProperty,false,false));}catch(e){reject(e);}});}}else{let processed='';let inScript=false;let inCDATA=false;let inSVG=false;let lastIndex=0;const STATE_IN_SELF_CLOSING_TAG=3;const STATE_IN_CLOSING_TAG_NAME=5;let omitSuperfluousClosingHtmlTags=hook.parameters.omitSuperfluousClosingHtmlTags;let noHook=false;let contextGeneratorAttr=false;let src='';let inlineScript='';let isBootstrapProcessed=false;let isSVG=false;let scriptHashes=_getScriptHashes();let firstTag;let xlinkNS='xlink';let xlinkNSAttributeExists=false;if(typeof url==='string'){url=new URL(url);}let stream=new htmlparser.WritableStream({onskip(){if(omitSuperfluousClosingHtmlTags&&stream._parser.startIndex-lastIndex>0){processed+=stream._parser._tokenizer._buffer.substring(lastIndex,stream._parser.startIndex)[inSVG?'valueOf':'toLowerCase']();}},onprocessinginstruction(name,data){if(omitSuperfluousClosingHtmlTags){this.onskip();lastIndex=(stream._parser.endIndex||stream._parser._tokenizer._index)+1;}processed+='<'+data+'>';},onopentag(rawName,rawAttributes){let name;let attributes;let rawAttributeNames={};if(omitSuperfluousClosingHtmlTags){this.onskip();name=rawName.toLowerCase();attributes={};for(let rawAttr in rawAttributes){attributes[rawAttr.toLowerCase()]=rawAttributes[rawAttr];rawAttributeNames[rawAttr.toLowerCase()]=rawAttr;}}else{name=rawName;attributes=rawAttributes;}let attrs='';let attrNoHook=typeof attributes['no-hook']==='string';let _attr,_value;if(!firstTag){firstTag=name;if(firstTag==='svg'){isSVG=true;}}if(omitSuperfluousClosingHtmlTags){if(name==='svg'){inSVG=true;stream._parser._options.xmlMode=true;}}else{inSVG=isSVG;}for(let attr in attributes){_attr=undefined;_value=undefined;if(inSVG&&name==='svg'){if(attr.startsWith('xmlns:')){if(attributes[attr]==='http://www.w3.org/1999/xlink'){xlinkNS=attr.substring(6);xlinkNSAttributeExists=true;}}}if(attr.match(/^on[a-z]{1,}$/)&&attributes[attr]){if(name==='iframe'&&attr==='onload'){if(scriptHashes){if(typeof attributes['src']==='string'){let _src=attributes['src'].trim().toLowerCase();if(_src.startsWith('blob:')||_src.startsWith('data:')){continue;}}}else{if(typeof attributes['srcdoc']==='string'){continue;}else if(typeof attributes['src']==='string'){let _src=attributes['src'].trim().toLowerCase();if(_src.startsWith('blob:')||_src.startsWith('data:')){continue;}}}}let _attrNoHook=attrNoHook;if(_attrNoHook){let originalScript=attributes[attr];_value=_validateNoHookScript(originalScript,url);_attrNoHook=originalScript===attributes[attr];}if(!_attrNoHook){let initialContext=(cors?url.href:url.pathname)+','+name+(attributes.id?'#'+attributes.id:attributes.class?'.'+attributes.class:'')+','+attr+'@'+(scriptOffset+processed.length);let {isHooked,isValidated,raw,hooked,ctx,embeddedRaw}=_parseHookedInlineScript(attributes[attr]);if(isHooked){if(!isValidated){let hookedForVerification=hook(raw,hookName,[[ctx,{}]],contextGenerator,metaHooking,_hookProperty,null,false,getCompact(),getHookGlobal(),getHookPrefix(),{event:true});let insertReturnAt=getCompact()?hookedForVerification.indexOf('\']);')+4:hookedForVerification.indexOf('\'\n]);\n')+6;hookedForVerification=hookedForVerification.substring(0,insertReturnAt)+'return '+hookedForVerification.substring(insertReturnAt);if(hooked!==hookedForVerification){console.error('preprocess.js: _preprocessHtml: hooked !== hookedForVerification ctx = '+ctx,'\nhooked = ',hooked,'\nhookedForVerification = ',hookedForVerification,'\nraw =',raw);isHooked=false;}}}if(isHooked){_value=attributes[attr];}else{let inlineScript='(() => { '+attributes[attr]+'})()';_value=hook(inlineScript,hookName,[[initialContext,{}]],contextGenerator,metaHooking,_hookProperty,null,false,getCompact(),getHookGlobal(),getHookPrefix(),{event:true});let insertReturnAt=getCompact()?_value.indexOf('\']);')+4:_value.indexOf('\'\n]);\n')+6;_value=(_getScriptHashes()?`/* ctx:'${btoa(encodeURIComponent(initialContext))}' raw:'${btoa(encodeURIComponent(inlineScript))}' */`:'')+_value.substring(0,insertReturnAt)+'return '+_value.substring(insertReturnAt);}}}else if(attr==='src'&&name==='script'&&attributes[attr]){let _srcUrl=new URL(attributes[attr],url);switch(_srcUrl.protocol){case'https:':case'http:':if(_srcUrl.pathname.match(/[.]m?js$/)){let serviceWorkerReady=_srcUrl.searchParams.get('service-worker-ready');switch(serviceWorkerReady){case'false':_value=attributes[attr].replace(/([?&])service-worker-ready=false/,'$1service-worker-ready=true');break;case'true':default:_value=attributes[attr];break;}}break;case'data:':case'blob:':case'javascript:':default:break;}if(!_value){continue;}}else if(attr==='src'&&name==='iframe'&&attributes[attr]){if(typeof attributes['srcdoc']==='string'){continue;}let _srcUrl=new URL(attributes[attr],url);switch(_srcUrl.protocol){default:case'https:':case'http:':_value=attributes[attr];break;case'javascript:':break;case'data:':{let dataURL=_srcUrl.pathname.match(/^([a-zA-Z\/+]*)(;[^, ]*)?,(.*)$/);if(dataURL&&dataURL[1].toLowerCase()==='text/html'){let body;if(dataURL[2]===';base64'){body=decodeURIComponent(escape(atob(dataURL[3])));}else{body=dataURL[3];}if(scriptHashes){if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(attributes['id']?'@'+attributes['id']:''));let srcDecoded=he.decode(body+(hook.parameters.bootstrap||''),{isAttributeValue:true});_emptySrc+='&content='+btoa(encodeURIComponent(srcDecoded)).replace(/[+]/g,'-').replace(/[/]/g,'_');_attr='src';_value=_emptySrc;}}else{if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(attributes['id']?'@'+attributes['id']:''));attrs+=' src="'+_emptySrc+'"';}let srcDecoded=he.decode(body+(hook.parameters.bootstrap||''),{isAttributeValue:true});let srcEncoded=he.encode(srcDecoded,{isAttributeValue:true});_attr='onload';_value='event.target.contentDocument.write(`'+srcEncoded.replace(/&#x60;/g,'&#x5C;&#x60;')+'`);';if(hook.parameters.onloadWrapper&&attributes['onload']){let onload='return '+hook('(() => { '+attributes['onload']+'})()',hookName,[[(cors?url.href:url.pathname)+','+'iframe'+(attributes.id?'#'+attributes.id:attributes.class?'.'+attributes.class:'')+','+'onload'+'@'+(scriptOffset+processed.length),{}]],contextGenerator,metaHooking,_hookProperty,null,false,getCompact(),getHookGlobal(),getHookPrefix(),{event:true});_value+=hook.parameters.onloadWrapper.replace('$onload$',onload);}}}else if(dataURL&&dataURL[1].toLowerCase()==='image/svg+xml'){break;}else{_attr=attr;_value=attributes[attr];}}break;case'blob:':{if(scriptHashes){if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(attributes['id']?'@'+attributes['id']:''));_emptySrc+='&blob='+encodeURIComponent(_srcUrl.href);_attr='src';_value=_emptySrc;}}else{if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(attributes['id']?'@'+attributes['id']:''));attrs+=' src="'+_emptySrc+'"';}_attr='onload';_value='let iframe = this; '+'fetch(new Request("'+_srcUrl.href+'")).then(response => response.blob())'+'.then(blob => { let reader = new FileReader(); if (blob.type === "text/html") {'+'reader.addEventListener("loadend", () => { '+'iframe.contentDocument.write(reader.result + `'+hook.parameters.bootstrap.replace(/'/g,'&#39;')+'`); }); '+'reader.readAsText(blob); } else if (blob.type !== "image/svg+xml") { '+'reader.addEventListener("loadend", () => { iframe.src = reader.result; iframe.removeAttribute("onload"); }); '+'reader.readAsDataURL(blob); }});';if(hook.parameters.onloadWrapper&&attributes['onload']){let onload='return '+hook('(() => { '+attributes['onload']+'})()',hookName,[[(cors?url.href:url.pathname)+','+'iframe'+(attributes.id?'#'+attributes.id:attributes.class?'.'+attributes.class:'')+','+'onload'+'@'+(scriptOffset+processed.length),{}]],contextGenerator,metaHooking,_hookProperty,null,false,getCompact(),getHookGlobal(),getHookPrefix(),{event:true});_value+=hook.parameters.onloadWrapper.replace('$onload$',onload);}}}break;}if(!_value){continue;}}else if(attr==='srcdoc'&&name==='iframe'){if(scriptHashes){if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(attributes['id']?'@'+attributes['id']:''));let srcdocDecoded=he.decode(attributes[attr]+(hook.parameters.bootstrap||''),{isAttributeValue:true});_emptySrc+='&content='+btoa(encodeURIComponent(srcdocDecoded)).replace(/[+]/g,'-').replace(/[/]/g,'_');_attr='src';_value=_emptySrc;}}else{if(hook.parameters.emptyDocumentUrl){let _emptySrc=hook.parameters.emptyDocumentUrl.pathname+'?url='+encodeURIComponent((url.origin===hook.parameters.emptyDocumentUrl.origin?'':url.origin)+url.pathname+',iframe'+(attributes['id']?'@'+attributes['id']:''));attrs+=' src="'+_emptySrc+'"';}let srcdocDecoded=he.decode(attributes[attr]+(hook.parameters.bootstrap||''),{isAttributeValue:true});let srcdocEncoded=he.encode(srcdocDecoded,{isAttributeValue:true});_attr='onload';_value='event.target.contentDocument.write(`'+srcdocEncoded.replace(/&#x60;/g,'&#x5C;&#x60;')+'`);';if(hook.parameters.onloadWrapper&&attributes['onload']){let onload=hook('(() => { '+attributes['onload']+'})()',hookName,[[(cors?url.href:url.pathname)+','+'iframe'+(attributes.id?'#'+attributes.id:attributes.class?'.'+attributes.class:'')+','+'onload'+'@'+(scriptOffset+processed.length),{}]],contextGenerator,metaHooking,_hookProperty,null,false,getCompact(),getHookGlobal(),getHookPrefix(),{event:true});_value+=hook.parameters.onloadWrapper.replace('$onload$',onload);}}}else if(name==='object'&&attr==='data'&&attributes[attr]&&hook.parameters.emptySvg){let _dataUrl=new URL(attributes[attr],url);switch(_dataUrl.protocol){case'https:':case'http:':_value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(hook.parameters.emptySvg.replace('$location$',_dataUrl.origin===url.origin?_dataUrl.href.substring(url.origin.length):_dataUrl.href))));break;case'data:':if(attributes[attr]&&attributes[attr].startsWith('data:image/svg+xml;base64,')&&typeof hook.parameters.emptySvg==='string'){let svgLoader=decodeURIComponent(escape(atob(attributes[attr].substring('data:image/svg+xml;base64,'.length))));let emptySvgLocationIndex=hook.parameters.emptySvg.indexOf('$location$');let emptySvgStartsWith=hook.parameters.emptySvg.substring(0,emptySvgLocationIndex);let emptySvgEndsWith=hook.parameters.emptySvg.substring(emptySvgLocationIndex+'$location$'.length);if(svgLoader.startsWith(emptySvgStartsWith)&&svgLoader.endsWith(emptySvgEndsWith)){svgLoader=svgLoader.replace('$origin$',url.origin);_value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(svgLoader)));}else{console.error('preprocess.js: _preprocessHtml: invalid object data="data:image/svg+xml;base64,..."',svgLoader);_value='about:blank';}}else{_value='about:blank';}break;case'blob:':case'javascript:':default:_value='about:blank';break;}}else if(attr==='src'&&name==='embed'&&attributes[attr]&&hook.parameters.emptySvg){let _srcUrl=new URL(attributes[attr],url);switch(_srcUrl.protocol){case'https:':case'http:':_value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(hook.parameters.emptySvg.replace('$location$',_srcUrl.origin===url.origin?_srcUrl.href.substring(url.origin.length):_srcUrl.href))));break;case'data:':if(attributes[attr]&&attributes[attr].startsWith('data:image/svg+xml;base64,')&&typeof hook.parameters.emptySvg==='string'){let svgLoader=decodeURIComponent(escape(atob(attributes[attr].substring('data:image/svg+xml;base64,'.length))));let emptySvgLocationIndex=hook.parameters.emptySvg.indexOf('$location$');let emptySvgStartsWith=hook.parameters.emptySvg.substring(0,emptySvgLocationIndex);let emptySvgEndsWith=hook.parameters.emptySvg.substring(emptySvgLocationIndex+'$location$'.length);if(svgLoader.startsWith(emptySvgStartsWith)&&svgLoader.endsWith(emptySvgEndsWith)){svgLoader=svgLoader.replace('$origin$',url.origin);_value='data:image/svg+xml;base64,'+btoa(String.fromCharCode.apply(null,new TextEncoder().encode(svgLoader)));}else{console.error('preprocess.js: _preprocessHtml: invalid embed src="data:image/svg+xml;base64,..."',svgLoader);_value='about:blank';}}else{_value='about:blank';}break;case'blob:':case'javascript:':default:_value='about:blank';break;}}else if(attributes[attr]&&attributes[attr].trim().toLowerCase().indexOf('javascript:')===0){let _attrNoHook=attrNoHook;if(_attrNoHook){let originalScript=attributes[attr].substr(11);_value='javascript:'+_validateNoHookScript(originalScript,url);_attrNoHook=originalScript===attributes[attr];}if(!_attrNoHook){_value='javascript:'+hook('(() => { '+attributes[attr].substr(11)+'})()',hookName,[[(cors?url.href:url.pathname)+','+name+(attributes.id?'#'+attributes.id:attributes.class?'.'+attributes.class:'')+','+attr+'@'+(scriptOffset+processed.length),{}]],contextGenerator,metaHooking,_hookProperty);}}_attr=typeof _attr==='undefined'?omitSuperfluousClosingHtmlTags&&inSVG?rawAttributeNames[attr]:attr:_attr;_value=typeof _value==='undefined'?attributes[attr]:_value;attrs+=' '+_attr+(_value?_value.indexOf('"')>=0?'=\''+_value+'\'':'="'+_value+'"':'');}if(isSVG&&name==='svg'&&hook.parameters.bootstrapSvgScripts&&!xlinkNSAttributeExists){attrs+=` xmlns:${xlinkNS}="http://www.w3.org/1999/xlink"`;}if(omitSuperfluousClosingHtmlTags){if(inSVG){if(stream._parser._tokenizer._state===STATE_IN_SELF_CLOSING_TAG){processed+='<'+rawName+attrs+'/>';if(stream._parser._stack.length>0&&stream._parser._stack[stream._parser._stack.length-1]===rawName){stream._parser._stack.pop();}}else{processed+='<'+rawName+attrs+'>';}}else{if(stream._parser._tokenizer._state===STATE_IN_SELF_CLOSING_TAG){processed+='<'+name+attrs+'/>';if(stream._parser._stack.length>0&&stream._parser._stack[stream._parser._stack.length-1]===rawName){stream._parser._stack.pop();}}else if(stream._parser._tokenizer._state===STATE_IN_CLOSING_TAG_NAME&&name==='br'){}else{processed+='<'+name+attrs+'>';}}lastIndex=stream._parser.endIndex+1;}else{processed+='<'+name+attrs+'>';}if(isSVG&&name==='svg'&&hook.parameters.bootstrapSvgScripts){processed+=hook.parameters.bootstrapSvgScripts.replace(/xlink:href=/g,xlinkNS+':href=');}if(name==='script'){inScript=true;noHook=attrNoHook;src=attributes.src;inlineScript='';contextGeneratorAttr=attributes['context-generator'];if(src&&src.match(/\/hook[.]min[.]js\?/)){let srcUrl=new URL(he.decode(src,{isAttributeValue:true}),'https://host/');if(srcUrl.searchParams.has('hook-name')){setHookNameForServiceWorker(srcUrl.searchParams.get('hook-name')||'__hook__');}if(srcUrl.searchParams.has('context-generator-name')){setContextGeneratorName(srcUrl.searchParams.get('context-generator-name')||'method');}if(srcUrl.searchParams.has('discard-hook-errors')){setDiscardHookErrors(srcUrl.searchParams.get('discard-hook-errors')==='true');}if(srcUrl.searchParams.has('hook-property')){setHookProperty(srcUrl.searchParams.get('hook-property')==='true');}if(srcUrl.searchParams.has('hook-global')){setHookGlobal(srcUrl.searchParams.get('hook-global')==='true');}if(srcUrl.searchParams.has('hook-prefix')){setHookPrefix(srcUrl.searchParams.get('hook-prefix'));}if(srcUrl.searchParams.has('compact')){setCompact(srcUrl.searchParams.get('compact')==='true');}if(srcUrl.searchParams.has('no-hook-authorization')){let noHookAuthorization=srcUrl.searchParams.get('no-hook-authorization').split(/,/);hook.parameters.noHookAuthorizationPreValidated=hook.parameters.noHookAuthorizationPreValidated||{};noHookAuthorization.forEach(ticket=>{hook.parameters.noHookAuthorizationPreValidated[ticket]=true;});noHookAuthorization=[];for(let ticket in hook.parameters.noHookAuthorizationPreValidated){noHookAuthorization.push(ticket);}setNoHookAuthorizationPreValidated(noHookAuthorization);}}if(isDecoded&&typeof contextGeneratorAttr==='string'&&src){contextGeneratorScripts.push(new URL(src,url));}}},ontext(text){if(omitSuperfluousClosingHtmlTags){this.onskip();if(inScript){inlineScript+=text;}else if(inSVG){processed+=inCDATA?`<![CDATA[${text}]]>`:text;}else{processed+=text;}lastIndex=stream._parser.endIndex+1;}else{if(inScript){inlineScript+=text;}else{processed+=text;}}},onclosetag(rawName){let name;if(omitSuperfluousClosingHtmlTags){this.onskip();name=rawName.toLowerCase();}else{name=rawName;inSVG=isSVG;}if(name==='script'&&inScript){if(isDecoded&&typeof contextGeneratorAttr==='string'&&inlineScript){contextGeneratorScripts.push(inlineScript);}if(inlineScript){if(noHook){let originalScript=inlineScript;inlineScript=_validateNoHookScript(originalScript,url);noHook=originalScript===inlineScript;}if(!noHook){if(inSVG){if(inlineScript.startsWith('<![CDATA[')&&inlineScript.endsWith(']]>')){inlineScript=inlineScript.substring(9,inlineScript.length-3);}}let isHooked=false;let initialContext=(cors?url.href:url.pathname)+',script@'+(scriptOffset+processed.length);if(!inSVG){let raw,hooked,ctx,embeddedRaw;({isHooked,raw,hooked,ctx,embeddedRaw}=_parseHookedInlineScript(inlineScript));if(isHooked){let hookedForVerification=hook(raw,hookName,[[ctx,{}]],contextGenerator,metaHooking,_hookProperty);if(hooked!==hookedForVerification){console.error('preprocess.js: _preprocessHtml: hooked !== hookedForVerification ctx = '+ctx);isHooked=false;}}}if(!isHooked&&inlineScript){let hooked=hook(inlineScript,hookName,[[initialContext,{}]],contextGenerator,metaHooking,_hookProperty);inlineScript=hooked?(_getScriptHashes()?`/* ctx:"${btoa(encodeURIComponent(initialContext))}" raw:"${btoa(encodeURIComponent(inlineScript))}" */`:'')+hooked:'';}}if(inSVG){inlineScript='<![CDATA['+inlineScript+']]>';}}processed+=inlineScript;inScript=false;noHook=false;src='';}if(omitSuperfluousClosingHtmlTags){if(inSVG){processed+=stream._parser._tokenizer._state===STATE_IN_SELF_CLOSING_TAG?'':'</'+rawName+'>';}else{const startIndex=stream._parser._tokenizer._sectionStart-2>stream._parser.startIndex?stream._parser._tokenizer._sectionStart-2:stream._parser.startIndex;processed+=stream._parser._tokenizer._buffer.substring(startIndex,stream._parser.endIndex+1).startsWith('</')?'</'+name+'>':'';}if(name==='svg'){inSVG=false;stream._parser._options.xmlMode=false;}lastIndex=stream._parser.endIndex+1;}else{processed+='</'+name+'>';}},oncdatastart(){if(omitSuperfluousClosingHtmlTags){this.onskip();lastIndex=stream._parser.endIndex+1;}inCDATA=true;},oncdataend(){if(omitSuperfluousClosingHtmlTags){this.onskip();lastIndex=stream._parser.endIndex+1;}inCDATA=false;},oncomment(data){if(omitSuperfluousClosingHtmlTags){if(stream._parser.startIndex<=stream._parser.endIndex){this.onskip();}processed+=inCDATA?`<![CDATA[${data}]]>`:data.match(/^\[CDATA\[.*\]\]$/)?`<!${data}>`:`<!--${data}-->`;lastIndex=stream._parser.endIndex+1;}else{processed+='<!--'+data+'-->';}},onerror(error){throw error;}},omitSuperfluousClosingHtmlTags?{lowerCaseTags:false,lowerCaseAttributeNames:false,recognizeSelfClosing:true}:{});stream.write(html.replace(/\n/g,'\0').replace(/(<\/[\s]{1,})script([\s]*>)/g,'$1-closing-script-in-process-$2').replace(/\0/g,'\n'));stream.end();if(isSrcdoc&&!isBootstrapProcessed){processed+=hook.parameters.bootstrap||'';isBootstrapProcessed=true;}processed=processed.replace(/\n/g,'\0').replace(/(<\/[\s]{1,})-closing-script-in-process-([\s]*>)/g,'$1script$2').replace(/\0/g,'\n');return processed;}}const escodegenOptions={format:{indent:{style:'  '}},comment:true};const escodegenOptionsCompact={format:{compact:true},comment:false};const escodegenOptionsWithSourceMap={format:{indent:{style:'  ',base:0,adjustMultilineComment:false},newline:'\n',space:' ',json:false,renumber:false,hexadecimal:false,quotes:'single',escapeless:false,compact:false,parentheses:true,semicolons:true,safeConcatenation:false},moz:{starlessGenerator:false,parenthesizedComprehensionBlock:false,comprehensionExpressionStartsWithAssignment:false},parse:null,comment:true,sourceMap:'source.js',sourceMapRoot:'src',sourceMapWithCode:true,file:'source.js.map',sourceContent:'',directive:false,verbatim:undefined};const selfConstructorName=typeof self==='object'?self.constructor.name:'';function normalizeHookName(hookName){if(selfConstructorName==='Window'){if(typeof hookName==='symbol'){return Symbol.keyFor(hookName);}else{throw new Error('unknown error');}}else{if(typeof hookName==='symbol'){return Symbol.keyFor(hookName);}else{return hookName;}}}function hook(code,hookName,initialContext=[],contextGeneratorName='method',metaHooking=true,_hookProperty=getHookProperty(),_sourceMap=null,asynchronous=false,_compact=getCompact(),_hookGlobal=getHookGlobal(),_hookPrefix=getHookPrefix(),initialScope=null){let hookWith=getHookWith();if(asynchronous){let worker=getBestHookWorker();if(worker){return new Promise(function(resolve,reject){let id=getHookId(code);let size=code.length;worker.tasks[id]={status:'requesting'};worker.taskQueueSize+=size;worker.tasks[id].callback=function callback(task){delete worker.tasks[id];worker.taskQueueSize-=size;if(task.status==='success'){resolve(task.result);}else{reject(task.error);}};let message=[id,'text/javascript',code,normalizeHookName(hookName),initialContext,contextGeneratorName,metaHooking,_hookProperty,_sourceMap,false,_compact,_hookGlobal,_hookPrefix,initialScope];worker.port.postMessage(JSON.stringify(message,null,0));});}else{return new Promise(function(resolve,reject){try{resolve(hook(code,hookName,initialContext,contextGeneratorName,metaHooking,_hookProperty,_sourceMap,false,_compact,_hookGlobal,_hookPrefix,initialScope));}catch(e){reject(e);}});}}else{let targetAst;try{targetAst=espree.parse(code,_compact?espreeOptionsForTargetCompact:espreeOptionsForTarget);}catch(e){if(e.name==='SyntaxError'&&e.message.match(/'import' and 'export' may appear only with 'sourceType: module'/)){targetAst=espree.parse(code,_compact?espreeModuleOptionsCompact:espreeModuleOptions);}else{throw e;}}let astWithComments=_compact?targetAst:escodegen.attachComments(targetAst,targetAst.comments,targetAst.tokens);targetAst={type:astWithComments.type,sourceType:astWithComments.sourceType,body:astWithComments.body};contextGeneratorName=hook.contextGenerators[contextGeneratorName]?contextGeneratorName:'method';let contextGenerator=hook.contextGenerators[contextGeneratorName];initialContext.push(['root',targetAst]);let globalScope={};let globalObjectScope={};let globalClassScope={};let blockScope=globalScope;let functionScope=globalScope;hookName=normalizeHookName(hookName);if(initialScope instanceof Object){blockScope=Object.create(globalScope);functionScope=blockScope;Object.assign(blockScope,initialScope);}if(targetAst.sourceType==='module'&&hook.parameters.importMapper){let moduleContext=initialContext[0][0];if(typeof moduleContext==='string'&&moduleContext[0]!=='/'&&!moduleContext.startsWith('https://')){moduleContext=hook.parameters.importMapper(moduleContext,hook.parameters.baseURI);}const moduleDependencies={[moduleContext]:Object.assign(['export'],{source:initialContext[0].source||initialContext[0][0]})};targetAst.moduleDependencies=moduleDependencies;targetAst.moduleContext=moduleContext;}_analyzeScope(targetAst,blockScope,functionScope,globalScope,hookName,hookWith);if(targetAst.sourceType==='module'&&hook.parameters.importMapper){if(targetAst.$block$){let moduleContext=targetAst.moduleContext;const moduleDependencies=targetAst.moduleDependencies;for(let i in targetAst.$block$){let moduleVariable=targetAst.$block$[i];if(moduleVariable.type){if(!moduleVariable.status){if(moduleVariable.source&&hook.parameters.importMapper){moduleVariable.resolvedSource=hook.parameters.importMapper(moduleVariable.source,moduleContext);if(moduleVariable.sourceAst){if(!moduleVariable.sourceAst.resolvedSource){moduleVariable.sourceAst.resolvedSource=moduleVariable.resolvedSource;}}if(!moduleDependencies[moduleVariable.resolvedSource]){moduleDependencies[moduleVariable.resolvedSource]=['import'];moduleDependencies[moduleVariable.resolvedSource].source=moduleVariable.sourceAst.source.value;}}}}}}}for(let globalProperty in globalScope){switch(globalScope[globalProperty]){case'FunctionDeclaration':case'VariableDeclaration_var':globalObjectScope[globalProperty]=globalScope[globalProperty];break;default:globalClassScope[globalProperty]=globalScope[globalProperty];break;}globalScope[globalProperty]=false;}globalScope[hookName]=true;targetAst.__code__=code;_preprocess(targetAst,hookName,initialContext,contextGeneratorName,contextGenerator,metaHooking,_hookProperty,_sourceMap,_hookGlobal,_hookPrefix,hookWith,blockScope,functionScope,globalScope,globalObjectScope,globalClassScope);if(!_compact&&_sourceMap&&typeof _sourceMap==='object'&&_sourceMap.pathname){let sourcePath=_sourceMap.pathname.split(/\//).pop();escodegenOptionsWithSourceMap.code=code;escodegenOptionsWithSourceMap.sourceMap=sourcePath;escodegenOptionsWithSourceMap.file=sourcePath+'.map';let output=escodegen.generate(astWithComments,escodegenOptionsWithSourceMap);output.map.setSourceContent(sourcePath,code);let mapComment=convert.fromJSON(output.map.toString()).toComment();return output.code+'\n'+mapComment;}else{return escodegen.generate(astWithComments,_compact?escodegenOptionsCompact:escodegenOptions);}}}return Object.freeze({hook:hook,_preprocessHtml:_preprocessHtml,_validateNoHookScript:_validateNoHookScript,_getScriptHashes:_getScriptHashes,_parseHookedInlineScript:_parseHookedInlineScript,getConfigurations:getConfigurations,setConfigurations:setConfigurations,getHookNameForServiceWorker:getHookNameForServiceWorker,setHookNameForServiceWorker:setHookNameForServiceWorker,getHookWith:getHookWith,setHookWith:setHookWith,getContextGeneratorName:getContextGeneratorName,setContextGeneratorName:setContextGeneratorName,getDiscardHookErrors:getDiscardHookErrors,setDiscardHookErrors:setDiscardHookErrors,getHookProperty:getHookProperty,setHookProperty:setHookProperty,getHookGlobal:getHookGlobal,setHookGlobal:setHookGlobal,getHookPrefix:getHookPrefix,setHookPrefix:setHookPrefix,mutateScriptConfigurationsJSON:mutateScriptConfigurationsJSON,getCompact:getCompact,setCompact:setCompact,getNoHookAuthorizationPreValidated:getNoHookAuthorizationPreValidated,setNoHookAuthorizationPreValidated:setNoHookAuthorizationPreValidated,getContextGeneratorScripts:getContextGeneratorScripts,getHookWorkers:getHookWorkers,setHookWorkers:setHookWorkers,setupHookWorkers:setupHookWorkers,public:{hookHtml:_preprocessHtml}});};},{}],6:[function(require,module,exports){module.exports=function(hook,preprocess){const DEFAULT_VERSION='1';const UNINITIALIZED_VERSION='uninitialized';let version=UNINITIALIZED_VERSION;const CONFIGURATIONS_PSEUDO_URL='https://thin-hook.localhost.localdomain/configurations.json';const _self=function(){}.constructor('return this')();if(typeof _self==='object'&&_self.constructor.name==='ServiceWorkerGlobalScope'){version=new URL(location.href).searchParams.get('version')||DEFAULT_VERSION;caches.open('version_'+version).then(cache=>{return cache.match(CONFIGURATIONS_PSEUDO_URL).then(function(configurationsResponse){if(configurationsResponse){return configurationsResponse.text().then(function(configurationsJSON){let configurations=JSON.parse(configurationsJSON);preprocess.setConfigurations(configurations);hook.parameters.noHookAuthorizationPreValidated=hook.parameters.noHookAuthorizationPreValidated||{};preprocess.getNoHookAuthorizationPreValidated().forEach(ticket=>{hook.parameters.noHookAuthorizationPreValidated[ticket]=true;});preprocess.getContextGeneratorScripts().forEach(function contextGeneratorScriptsRunner(script){new Function('version',script)('version_'+version);});});}});}).catch(()=>true);}function onInstall(event){version=new URL(location.href).searchParams.get('version')||DEFAULT_VERSION;}function onActivate(event){preprocess.setHookWorkers([]);event.waitUntil(caches.keys().then(keys=>Promise.all(keys.map(key=>key==='version_'+version||caches.delete(key)))));}function onMessage(event){if(event.data==='channel'){let hookWorkers=[];for(let i=0;i<event.ports.length;i++){hookWorkers.push({worker:i,port:event.ports[i],taskQueueSize:0});}preprocess.setHookWorkers(hookWorkers);}else if(event.data==='unload'){preprocess.setHookWorkers([]);}else if(event.data==='coverage'&&typeof __coverage__==='object'){event.ports[0].postMessage(__coverage__);}else if(Array.isArray(event.data)&&event.data[0]==='plugin'){if(typeof event.data[1]==='string'&&event.data[1].endsWith(':enqueue')){const pluginId=event.data[1];let queue;let port=event.ports[0];if(!hook.parameters){hook.parameters={};}if(!hook.parameters.messageQueues){hook.parameters.messageQueues={};}if(!hook.parameters.messageQueues[pluginId]){hook.parameters.messageQueues[pluginId]=[];}queue=hook.parameters.messageQueues[pluginId];if(queue.length===0||queue[queue.length-1]!==':dequeued'){queue.push(event);if(port instanceof MessagePort){let message=[...event.data];message.push(':enqueued');port.postMessage(message);}}}}else{console.error('Invalid message to Service Worker');event.ports[0].postMessage('error: Invalid message to Service Worker');}}function onFetch(event){let restarted=false;if(version===UNINITIALIZED_VERSION){restarted=true;version=new URL(location.href).searchParams.get('version')||DEFAULT_VERSION;}event.respondWith(caches.open('version_'+version).then(function(cache){return(restarted?cache.match(CONFIGURATIONS_PSEUDO_URL).then(function(configurationsResponse){if(configurationsResponse){return configurationsResponse.text().then(function(configurationsJSON){let configurations=JSON.parse(configurationsJSON);preprocess.setConfigurations(configurations);hook.parameters.noHookAuthorizationPreValidated=hook.parameters.noHookAuthorizationPreValidated||{};preprocess.getNoHookAuthorizationPreValidated().forEach(ticket=>{hook.parameters.noHookAuthorizationPreValidated[ticket]=true;});preprocess.getContextGeneratorScripts().forEach(function contextGeneratorScriptsRunner(script){new Function(script)();});return cache.match(event.request);});}else{console.error('onFetch configurations not found for '+'version_'+version);return cache.match(event.request);}}):cache.match(event.request)).then(function(response){if(typeof hook.parameters.checkRequest==='function'){return hook.parameters.checkRequest(event,response,cache);}else{return response;}}).then(function(response){let cors=false;let request;if(!response){if(event.request.method==='GET'&&event.request.url.indexOf('cors=true')>=0){cors=true;request=new Request(event.request.url.replace(/&cors=true/,'').replace(/\?cors=true$/,'').replace(/\?cors=true&/,'?'),{mode:'cors'});}else if(event.request.method==='GET'&&Array.isArray(hook.parameters.cors)&&hook.parameters.cors.filter(pattern=>typeof pattern==='string'?pattern===event.request.url:typeof pattern==='function'?pattern(event.request.url):false).reduce((prev,curr)=>prev||curr,false)){cors=true;request=new Request(event.request.url,{mode:'cors'});}else{request=event.request.clone();}}return response||fetch(request).then(function(response){if(typeof hook.parameters.checkResponse==='function'){return hook.parameters.checkResponse(event,request,response,cache);}else{return response;}}).then(function(response){if(response.type==='opaque'){if(request&&response.status===0&&Array.isArray(hook.parameters.opaque)&&hook.parameters.opaque.filter(pattern=>typeof pattern==='string'?pattern===request.url:typeof pattern==='function'?pattern(request.url):false).reduce((prev,curr)=>prev||curr,false)){}else{response=null;}}else if(response.status===200){if(response.url){let url=new URL(response.url);let noHook=url.searchParams.get('no-hook')==='true'||Array.isArray(hook.parameters.noHook)&&hook.parameters.noHook.filter(pattern=>typeof pattern==='string'?pattern===url.href:typeof pattern==='function'?pattern(url):false).reduce((prev,curr)=>prev||curr,false);if(url.pathname.match(/[.]m?js$/)){return response.text().then(async function(result){let sourceMap=Array.isArray(hook.parameters.sourceMap)&&hook.parameters.sourceMap.filter(pattern=>typeof pattern==='string'?pattern===url.href:typeof pattern==='function'?pattern(url):false).reduce((prev,curr)=>prev||curr,false)?{pathname:url.pathname}:null;try{if(noHook){let originalScript=result;result=preprocess._validateNoHookScript(originalScript,url);noHook=originalScript===result;if(noHook){result=preprocess.mutateScriptConfigurationsJSON(result,url);}}if(!noHook){result=await hook(result,preprocess.getHookNameForServiceWorker(),[[cors?response.url:url.pathname,{}]],preprocess.getContextGeneratorName(),true,preprocess.getHookProperty(),sourceMap,true);}}catch(e){if(preprocess.getDiscardHookErrors()){console.log(e);}else{result='/* Empty script due to a hook error */';console.error(e);throw e;}}finally{let headers={'Content-Type':'text/javascript'};if(hook.parameters.significantHeaders&&Object.values(hook.parameters.significantHeaders).length>0){for(let name in hook.parameters.significantHeaders){if(response.headers.has(name)){headers[name]=response.headers.get(name);}}}let processedResponse=new Response(result,{headers:headers});cache.put(event.request,processedResponse.clone());return processedResponse;}});}else if(url.pathname.match(/(\/|[.]html?|[.]svg)$/i)||response.headers.get('content-type').match(/^text\/html|image\/svg\+xml/i)){let isSVG=url.pathname.match(/([.]svg)$/i)||response.headers.get('content-type').match(/^image\/svg\+xml/i);let original;let decoded;let contextGeneratorScripts=[];let newVersion=version;return response.text().then(async function(result){let redirectResponseOnUpgrading;try{result=decoded=hook.serviceWorkerTransformers.decodeHtml(original=result);if(original!==decoded){let match=decoded.replace(/\n/g,'\0').match(/<script [^>]*src="[^"]*\/hook[.]min[.]js[\?][^"]*version=([^&]*)&[^"]*"><\/script>/);if(match){newVersion=match[1];if(version!==newVersion){console.log('upgrading version from '+version+' to '+newVersion);version=newVersion;preprocess.setNoHookAuthorizationPreValidated([]);preprocess.getContextGeneratorScripts().splice(0,preprocess.getContextGeneratorScripts().length);await caches.keys().then(keys=>Promise.all(keys.map(key=>key==='version_'+version||caches.delete(key)))).then(()=>registration.unregister());cache=await caches.open('version_'+version);return redirectResponseOnUpgrading=Response.redirect(request.url);}}}result=await preprocess._preprocessHtml(decoded,preprocess.getHookNameForServiceWorker(),url,cors,preprocess.getContextGeneratorName(),contextGeneratorScripts,original!==decoded,true,0,preprocess.getHookProperty(),original===decoded);}catch(e){if(preprocess.getDiscardHookErrors()){console.log(e);}else{result='<!-- Empty HTML due to a hook error -->';console.error(e);throw e;}}finally{if(redirectResponseOnUpgrading){return redirectResponseOnUpgrading;}let headers={'Content-Type':isSVG?'image/svg+xml':'text/html'};if(hook.parameters.significantHeaders&&Object.values(hook.parameters.significantHeaders).length>0){for(let name in hook.parameters.significantHeaders){if(response.headers.has(name)){headers[name]=response.headers.get(name);}}}let processedResponse=new Response(result,{headers:headers});if(decoded===original&&request.method==='GET'){cache.put(event.request,processedResponse.clone());}if(contextGeneratorScripts.length===0){return processedResponse;}else{let sequence=Promise.resolve();contextGeneratorScripts.forEach(script=>{sequence=sequence.then(function contextGeneratorScriptsRunner(){if(typeof script==='string'){let authorized=preprocess._validateNoHookScript(script,url,true);if(script===authorized){new Function('version',script)('version_'+version);if(preprocess.getContextGeneratorScripts().indexOf(script)<0){preprocess.getContextGeneratorScripts().push(script);}}else{console.error('skip executing unauthorized inline context-generator script at '+url.href);}return true;}else if(script instanceof URL){let scriptRequest=new Request(script,{mode:'cors'});return cache.match(scriptRequest).then(scriptResponse=>{if(scriptResponse){return scriptResponse;}else{return fetch(scriptRequest);}}).then(scriptResponse=>{if(scriptResponse.status<400){return scriptResponse.text();}else{throw scriptResponse;}}).then(text=>{let authorized=preprocess._validateNoHookScript(text,script,true);if(text===authorized){new Function('version',text)('version_'+version);if(preprocess.getContextGeneratorScripts().indexOf(text)<0){preprocess.getContextGeneratorScripts().push(text);}}else{console.error('skip executing unauthorized context-generator script at '+script.href);}return true;}).catch(error=>{console.log('Failed to fetch context generator script at '+script,error);if(preprocess.getDiscardHookErrors()){return true;}else{if(error instanceof Response){throw new Error('Failed to fetch context generator script at '+script+' '+error.status+' '+error.statusText);}else{throw error;}}});}else{return true;}});});return sequence.then(async()=>{let newConfigurationsJSON=JSON.stringify(preprocess.getConfigurations(),null,0);let newConfigurationsRequest=new Request(CONFIGURATIONS_PSEUDO_URL);let newConfigurationsResponse=new Response(newConfigurationsJSON,{headers:{'Content-Type':'application/json'}});await cache.put(newConfigurationsRequest,newConfigurationsResponse);if(typeof hook.parameters.decodeEntryHtml==='function'){try{decoded=await hook.parameters.decodeEntryHtml(event,request,response,cache,original,decoded);}catch(e){if(e.result instanceof Response){return e.result;}else{throw e;}}}result=decoded===original?decoded:await preprocess._preprocessHtml(decoded,preprocess.getHookNameForServiceWorker(),url,cors,preprocess.getContextGeneratorName(),[],original!==decoded,true,0,preprocess.getHookProperty(),original===decoded);return new Response(result,{headers:{'Content-Type':'text/html'}});});}}});}}}return response;});}).catch(function(error){throw error;});}));}function encodeHtml(html){let html0=html.replace(/\n/g,'\0');let match;if(match=html0.match(/^(.*)(<script [^>]*src="[^"]*\/hook[.]min[.]js[\?][^"]*service-worker-ready=true"><\/script>.*)$/)){if(html.includes('<!-- end of mandatory no-hook scripts -->')){html=(match[1]+match[2].replace(/<!--/g,'<C!--').replace(/-->/g,'--C>').replace(/^(.*<script [^>]*src="[^"]*\/hook[.]min[.]js\?[^"]*service-worker-ready=)true("><\/script>)(.*)(<C!-- end of mandatory no-hook scripts --C>)(.*)$/,'$1false$2</head></html>$3<!--$4$5-->')).replace(/\0/g,'\n');}else{html=(match[1]+match[2].replace(/<!--/g,'<C!--').replace(/-->/g,'--C>').replace(/^(.*<script [^>]*src="[^"]*\/hook[.]min[.]js\?[^"]*service-worker-ready=)true("><\/script>)(.*)$/,'$1false$2</head></html><!--$3-->')).replace(/\0/g,'\n');}}return html;}function decodeHtml(html){let html0=html.replace(/\n/g,'\0');if(html0.match(/<script [^>]*src="[^"]*\/hook[.]min[.]js[\?][^"]*service-worker-ready=false"><\/script><\/head><\/html>/)){html=html0.replace(/^(.*<script [^>]*src="[^"]*\/hook[.]min[.]js\?[^"]*service-worker-ready=)false("><\/script>)<\/head><\/html>(.*)<!--(.*)-->$/,'$1true$2$3$4').replace(/<C!--/g,'<!--').replace(/--C>/g,'-->').replace(/\0/g,'\n');}return html;}let hookWorkerChannelTransferred=false;function hookWorkerHandler(event){if(event.data==='channel'){let port=event.ports[0];port.onmessage=function(hookEvent){let message;try{message=JSON.parse(hookEvent.data);}catch(parseError){console.error('Hook worker: unknown hookEvent message ',hookEvent.data);return;}let id=message.shift();let type=message.shift();let parameters=message;let result;try{switch(type){case'text/javascript':result=hook(...parameters);break;case'text/html':result=hook.hookHtml(...parameters);break;default:throw new Error('hookWorker: Unknown type: '+type);break;}port.postMessage(JSON.stringify([id,'success',result],null,0));}catch(e){port.postMessage(JSON.stringify([id,'error',e.toString()],null,0));}};hookWorkerChannelTransferred=true;}else if(event.data==='ping'){postMessage({hookWorkerChannelTransferred:hookWorkerChannelTransferred});}else if(event.data==='coverage'){if(typeof __coverage__==='object'){postMessage(__coverage__);}else{postMessage({});}}else{console.error('Hook worker: unknown message ',event.data);}}const workerEventTarget=typeof window==='object'?document.createElement('div'):null;let hookWorkerReady=false;async function _collectHookWorkerCoverage(timeout=5000){let hookWorkers=[];let interval=100;let retryCount=timeout/ interval;let intervalId;hookWorkers=await new Promise((resolve,reject)=>{if(hookWorkerReady){resolve(preprocess.getHookWorkers());}else{workerEventTarget.addEventListener('hook-worker-ready',function onHookWorkerReady(event){workerEventTarget.removeEventListener('hook-worker-ready',onHookWorkerReady);if(hookWorkerReady){resolve(preprocess.getHookWorkers());}else{throw new Error('_collectHookWorkerCoverage: hook-worker-ready event without hookWorkerReady === true');}});}});if(Array.isArray(hookWorkers)&&hookWorkers.length>0){return await Promise.all(hookWorkers.map(({worker,channel})=>new Promise((resolve,reject)=>{worker.onmessage=function onMessage(event){if(event.data.error){reject(event.data.error);}else{resolve(event.data);}worker.onmessage=null;};worker.postMessage('coverage');})));}else{return[];}}function pingHookWorkers(){let hookWorkers=preprocess.getHookWorkers();if(Array.isArray(hookWorkers)&&hookWorkers.length>0){let intervalId=setInterval(()=>{let done=hookWorkers.map(hookWorker=>hookWorker.hookWorkerChannelTransferred).reduce((acc,curr)=>acc=acc&&curr,true);if(done){clearInterval(intervalId);hookWorkerReady=true;workerEventTarget.dispatchEvent(new Event('hook-worker-ready'));}hookWorkers.forEach((hookWorker,index)=>{if(!hookWorker.hookWorkerChannelTransferred){hookWorker.worker.onmessage=function onMessage(event){if(event.data&&event.data.hookWorkerChannelTransferred){hookWorker.hookWorkerChannelTransferred=true;hookWorker.worker.onmessage=null;}};hookWorker.worker.postMessage('ping');}});},1000);}}function startPingService(){console.log('service-worker.js: startPingService');navigator.serviceWorker.addEventListener('message',function(event){let port=event.ports[0];let data=event.data;if(port&&Array.isArray(data)&&data[0]==='ping'){port.postMessage(data);}});}function waitForDOMContentLoaded(){return new Promise(resolve=>{addEventListener('DOMContentLoaded',async function onDOMContentLoaded(event){removeEventListener('DOMContentLoaded',onDOMContentLoaded);resolve(event);});});}async function defaultHandlerOnPreServiceWorkerTasksError(error){window.location='about:blank';return true;}async function waitForPreServiceWorkerTasksCompletion(){let tasks=hook.parameters.preServiceWorkerTasks;let onError=hook.parameters.onPreServiceWorkerTasksError||defaultHandlerOnPreServiceWorkerTasksError;let lastResult;if(tasks){try{const logResult=function(result){if(typeof result==='string'){console.log('message from hook.parameters.preServiceWorkerTasks: '+result);}};if(tasks instanceof Promise){logResult(lastResult=await tasks);}else if(typeof tasks[Symbol.iterator]==='function'){for(let task of tasks){let result=await task;logResult(lastResult=result);}}else if(typeof tasks[Symbol.asyncIterator]==='function'){let result;let iterator=tasks[Symbol.asyncIterator]();while(result=await iterator.next()){if(result.done){break;}logResult(lastResult=result.value);}}else{throw new TypeError('tasks is not iterable');}}catch(e){await onError(e);}}return lastResult==='skipServiceWorkerRegistration'?false:true;}async function registerServiceWorker(fallbackUrl='./index-no-service-worker.html',reloadTimeout=500,inactiveReloadTimeout=1000){if('serviceWorker'in navigator){let script=document.currentScript||Array.prototype.filter.call(document.querySelectorAll('script'),s=>s.src.match(/\/hook.min.js/))[0];let src=new URL(script.src,window.location.href);preprocess.setConfigurations(src);if(src.searchParams.has('service-worker-ready')){startPingService();await waitForDOMContentLoaded();if(!(await waitForPreServiceWorkerTasksCompletion())){if(src.searchParams.get('service-worker-ready')==='true'){preprocess.setupHookWorkers();pingHookWorkers();}return;}navigator.serviceWorker.register(script.src.replace(/\&service-worker-ready=.*$/,'&service-worker-initiator='+location.pathname),{scope:src.searchParams.get('sw-root')||window.location.pathname.replace(/\/[^\/]*$/,'/')}).then(registration=>{let serviceWorker=registration.active||registration.waiting||registration.installing;if(serviceWorker){if(!(src.searchParams.get('service-worker-ready')==='true'&&registration.active)){serviceWorker.addEventListener('statechange',function(e){if(serviceWorker.state==='activated'){window.location.reload();}});setTimeout(function(){window.location.reload();},inactiveReloadTimeout);}else{preprocess.setupHookWorkers();pingHookWorkers();}}else{setTimeout(function(){window.location.reload();},reloadTimeout);}});}}else{let src=new URL(document.currentScript.src,'https://host/');let match=src.search.match(/[&\?]fallback-page=([^&\?]*)/);if(match){fallbackUrl=match[1];}window.location=fallbackUrl;}}return Object.freeze({serviceWorkerHandlers:Object.freeze({install:onInstall,activate:onActivate,message:onMessage,fetch:onFetch}),serviceWorkerTransformers:Object.freeze({encodeHtml:encodeHtml,decodeHtml:decodeHtml}),hookWorkerHandler:hookWorkerHandler,_collectHookWorkerCoverage:_collectHookWorkerCoverage,registerServiceWorker:registerServiceWorker});};},{}],7:[function(require,module,exports){Object.defineProperty(exports,'__esModule',{value:true});exports['default']=injectDynamicImport;function injectDynamicImport(acorn){var tt=acorn.tokTypes;tt._import.startsExpr=true;function parseDynamicImport(){var node=this.startNode();this.next();if(this.type!==tt.parenL){this.unexpected();}return this.finishNode(node,'Import');}function peekNext(){return this.input[this.pos];}acorn.plugins.dynamicImport=function(){function dynamicImportPlugin(instance){instance.extend('parseStatement',function(nextMethod){return function(){function parseStatement(){var node=this.startNode();if(this.type===tt._import){var nextToken=peekNext.call(this);if(nextToken===tt.parenL.label){var expr=this.parseExpression();return this.parseExpressionStatement(node,expr);}}for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}return nextMethod.apply(this,args);}return parseStatement;}();});instance.extend('parseExprAtom',function(nextMethod){return function(){function parseExprAtom(refDestructuringErrors){if(this.type===tt._import){return parseDynamicImport.call(this);}return nextMethod.call(this,refDestructuringErrors);}return parseExprAtom;}();});}return dynamicImportPlugin;}();return acorn;}},{}],8:[function(require,module,exports){'use strict';var XHTMLEntities=require('./xhtml');var hexNumber=/^[\da-fA-F]+$/;var decimalNumber=/^\d+$/;module.exports=function(acorn){var tt=acorn.tokTypes;var tc=acorn.tokContexts;tc.j_oTag=new acorn.TokContext('<tag',false);tc.j_cTag=new acorn.TokContext('</tag',false);tc.j_expr=new acorn.TokContext('<tag>...</tag>',true,true);tt.jsxName=new acorn.TokenType('jsxName');tt.jsxText=new acorn.TokenType('jsxText',{beforeExpr:true});tt.jsxTagStart=new acorn.TokenType('jsxTagStart');tt.jsxTagEnd=new acorn.TokenType('jsxTagEnd');tt.jsxTagStart.updateContext=function(){this.context.push(tc.j_expr);this.context.push(tc.j_oTag);this.exprAllowed=false;};tt.jsxTagEnd.updateContext=function(prevType){var out=this.context.pop();if(out===tc.j_oTag&&prevType===tt.slash||out===tc.j_cTag){this.context.pop();this.exprAllowed=this.curContext()===tc.j_expr;}else{this.exprAllowed=true;}};var pp=acorn.Parser.prototype;pp.jsx_readToken=function(){var out='',chunkStart=this.pos;for(;;){if(this.pos>=this.input.length)this.raise(this.start,'Unterminated JSX contents');var ch=this.input.charCodeAt(this.pos);switch(ch){case 60:case 123:if(this.pos===this.start){if(ch===60&&this.exprAllowed){++this.pos;return this.finishToken(tt.jsxTagStart);}return this.getTokenFromCode(ch);}out+=this.input.slice(chunkStart,this.pos);return this.finishToken(tt.jsxText,out);case 38:out+=this.input.slice(chunkStart,this.pos);out+=this.jsx_readEntity();chunkStart=this.pos;break;default:if(acorn.isNewLine(ch)){out+=this.input.slice(chunkStart,this.pos);out+=this.jsx_readNewLine(true);chunkStart=this.pos;}else{++this.pos;}}}};pp.jsx_readNewLine=function(normalizeCRLF){var ch=this.input.charCodeAt(this.pos);var out;++this.pos;if(ch===13&&this.input.charCodeAt(this.pos)===10){++this.pos;out=normalizeCRLF?'\n':'\r\n';}else{out=String.fromCharCode(ch);}if(this.options.locations){++this.curLine;this.lineStart=this.pos;}return out;};pp.jsx_readString=function(quote){var out='',chunkStart=++this.pos;for(;;){if(this.pos>=this.input.length)this.raise(this.start,'Unterminated string constant');var ch=this.input.charCodeAt(this.pos);if(ch===quote)break;if(ch===38){out+=this.input.slice(chunkStart,this.pos);out+=this.jsx_readEntity();chunkStart=this.pos;}else if(acorn.isNewLine(ch)){out+=this.input.slice(chunkStart,this.pos);out+=this.jsx_readNewLine(false);chunkStart=this.pos;}else{++this.pos;}}out+=this.input.slice(chunkStart,this.pos++);return this.finishToken(tt.string,out);};pp.jsx_readEntity=function(){var str='',count=0,entity;var ch=this.input[this.pos];if(ch!=='&')this.raise(this.pos,'Entity must start with an ampersand');var startPos=++this.pos;while(this.pos<this.input.length&&count++<10){ch=this.input[this.pos++];if(ch===';'){if(str[0]==='#'){if(str[1]==='x'){str=str.substr(2);if(hexNumber.test(str))entity=String.fromCharCode(parseInt(str,16));}else{str=str.substr(1);if(decimalNumber.test(str))entity=String.fromCharCode(parseInt(str,10));}}else{entity=XHTMLEntities[str];}break;}str+=ch;}if(!entity){this.pos=startPos;return'&';}return entity;};pp.jsx_readWord=function(){var ch,start=this.pos;do{ch=this.input.charCodeAt(++this.pos);}while(acorn.isIdentifierChar(ch)||ch===45);return this.finishToken(tt.jsxName,this.input.slice(start,this.pos));};function getQualifiedJSXName(object){if(object.type==='JSXIdentifier')return object.name;if(object.type==='JSXNamespacedName')return object.namespace.name+':'+object.name.name;if(object.type==='JSXMemberExpression')return getQualifiedJSXName(object.object)+'.'+getQualifiedJSXName(object.property);}pp.jsx_parseIdentifier=function(){var node=this.startNode();if(this.type===tt.jsxName)node.name=this.value;else if(this.type.keyword)node.name=this.type.keyword;else this.unexpected();this.next();return this.finishNode(node,'JSXIdentifier');};pp.jsx_parseNamespacedName=function(){var startPos=this.start,startLoc=this.startLoc;var name=this.jsx_parseIdentifier();if(!this.options.plugins.jsx.allowNamespaces||!this.eat(tt.colon))return name;var node=this.startNodeAt(startPos,startLoc);node.namespace=name;node.name=this.jsx_parseIdentifier();return this.finishNode(node,'JSXNamespacedName');};pp.jsx_parseElementName=function(){var startPos=this.start,startLoc=this.startLoc;var node=this.jsx_parseNamespacedName();if(this.type===tt.dot&&node.type==='JSXNamespacedName'&&!this.options.plugins.jsx.allowNamespacedObjects){this.unexpected();}while(this.eat(tt.dot)){var newNode=this.startNodeAt(startPos,startLoc);newNode.object=node;newNode.property=this.jsx_parseIdentifier();node=this.finishNode(newNode,'JSXMemberExpression');}return node;};pp.jsx_parseAttributeValue=function(){switch(this.type){case tt.braceL:var node=this.jsx_parseExpressionContainer();if(node.expression.type==='JSXEmptyExpression')this.raise(node.start,'JSX attributes must only be assigned a non-empty expression');return node;case tt.jsxTagStart:case tt.string:return this.parseExprAtom();default:this.raise(this.start,'JSX value should be either an expression or a quoted JSX text');}};pp.jsx_parseEmptyExpression=function(){var node=this.startNodeAt(this.lastTokEnd,this.lastTokEndLoc);return this.finishNodeAt(node,'JSXEmptyExpression',this.start,this.startLoc);};pp.jsx_parseExpressionContainer=function(){var node=this.startNode();this.next();node.expression=this.type===tt.braceR?this.jsx_parseEmptyExpression():this.parseExpression();this.expect(tt.braceR);return this.finishNode(node,'JSXExpressionContainer');};pp.jsx_parseAttribute=function(){var node=this.startNode();if(this.eat(tt.braceL)){this.expect(tt.ellipsis);node.argument=this.parseMaybeAssign();this.expect(tt.braceR);return this.finishNode(node,'JSXSpreadAttribute');}node.name=this.jsx_parseNamespacedName();node.value=this.eat(tt.eq)?this.jsx_parseAttributeValue():null;return this.finishNode(node,'JSXAttribute');};pp.jsx_parseOpeningElementAt=function(startPos,startLoc){var node=this.startNodeAt(startPos,startLoc);node.attributes=[];node.name=this.jsx_parseElementName();while(this.type!==tt.slash&&this.type!==tt.jsxTagEnd)node.attributes.push(this.jsx_parseAttribute());node.selfClosing=this.eat(tt.slash);this.expect(tt.jsxTagEnd);return this.finishNode(node,'JSXOpeningElement');};pp.jsx_parseClosingElementAt=function(startPos,startLoc){var node=this.startNodeAt(startPos,startLoc);node.name=this.jsx_parseElementName();this.expect(tt.jsxTagEnd);return this.finishNode(node,'JSXClosingElement');};pp.jsx_parseElementAt=function(startPos,startLoc){var node=this.startNodeAt(startPos,startLoc);var children=[];var openingElement=this.jsx_parseOpeningElementAt(startPos,startLoc);var closingElement=null;if(!openingElement.selfClosing){contents:for(;;){switch(this.type){case tt.jsxTagStart:startPos=this.start;startLoc=this.startLoc;this.next();if(this.eat(tt.slash)){closingElement=this.jsx_parseClosingElementAt(startPos,startLoc);break contents;}children.push(this.jsx_parseElementAt(startPos,startLoc));break;case tt.jsxText:children.push(this.parseExprAtom());break;case tt.braceL:children.push(this.jsx_parseExpressionContainer());break;default:this.unexpected();}}if(getQualifiedJSXName(closingElement.name)!==getQualifiedJSXName(openingElement.name)){this.raise(closingElement.start,'Expected corresponding JSX closing tag for <'+getQualifiedJSXName(openingElement.name)+'>');}}node.openingElement=openingElement;node.closingElement=closingElement;node.children=children;if(this.type===tt.relational&&this.value==='<'){this.raise(this.start,'Adjacent JSX elements must be wrapped in an enclosing tag');}return this.finishNode(node,'JSXElement');};pp.jsx_parseElement=function(){var startPos=this.start,startLoc=this.startLoc;this.next();return this.jsx_parseElementAt(startPos,startLoc);};acorn.plugins.jsx=function(instance,opts){if(!opts){return;}if(typeof opts!=='object'){opts={};}instance.options.plugins.jsx={allowNamespaces:opts.allowNamespaces!==false,allowNamespacedObjects:!!opts.allowNamespacedObjects};instance.extend('parseExprAtom',function(inner){return function(refShortHandDefaultPos){if(this.type===tt.jsxText)return this.parseLiteral(this.value);else if(this.type===tt.jsxTagStart)return this.jsx_parseElement();else return inner.call(this,refShortHandDefaultPos);};});instance.extend('readToken',function(inner){return function(code){var context=this.curContext();if(context===tc.j_expr)return this.jsx_readToken();if(context===tc.j_oTag||context===tc.j_cTag){if(acorn.isIdentifierStart(code))return this.jsx_readWord();if(code==62){++this.pos;return this.finishToken(tt.jsxTagEnd);}if((code===34||code===39)&&context==tc.j_oTag)return this.jsx_readString(code);}if(code===60&&this.exprAllowed){++this.pos;return this.finishToken(tt.jsxTagStart);}return inner.call(this,code);};});instance.extend('updateContext',function(inner){return function(prevType){if(this.type==tt.braceL){var curContext=this.curContext();if(curContext==tc.j_oTag)this.context.push(tc.b_expr);else if(curContext==tc.j_expr)this.context.push(tc.b_tmpl);else inner.call(this,prevType);this.exprAllowed=true;}else if(this.type===tt.slash&&prevType===tt.jsxTagStart){this.context.length-=2;this.context.push(tc.j_cTag);this.exprAllowed=false;}else{return inner.call(this,prevType);}};});};return acorn;};},{'./xhtml':9}],9:[function(require,module,exports){module.exports={quot:'"',amp:'&',apos:'\'',lt:'<',gt:'>',nbsp:'\xA0',iexcl:'\xA1',cent:'\xA2',pound:'\xA3',curren:'\xA4',yen:'\xA5',brvbar:'\xA6',sect:'\xA7',uml:'\xA8',copy:'\xA9',ordf:'ª',laquo:'\xAB',not:'\xAC',shy:'\xAD',reg:'\xAE',macr:'\xAF',deg:'\xB0',plusmn:'\xB1',sup2:'\xB2',sup3:'\xB3',acute:'\xB4',micro:'µ',para:'\xB6',middot:'\xB7',cedil:'\xB8',sup1:'\xB9',ordm:'º',raquo:'\xBB',frac14:'\xBC',frac12:'\xBD',frac34:'\xBE',iquest:'\xBF',Agrave:'À',Aacute:'Á',Acirc:'Â',Atilde:'Ã',Auml:'Ä',Aring:'Å',AElig:'Æ',Ccedil:'Ç',Egrave:'È',Eacute:'É',Ecirc:'Ê',Euml:'Ë',Igrave:'Ì',Iacute:'Í',Icirc:'Î',Iuml:'Ï',ETH:'Ð',Ntilde:'Ñ',Ograve:'Ò',Oacute:'Ó',Ocirc:'Ô',Otilde:'Õ',Ouml:'Ö',times:'\xD7',Oslash:'Ø',Ugrave:'Ù',Uacute:'Ú',Ucirc:'Û',Uuml:'Ü',Yacute:'Ý',THORN:'Þ',szlig:'ß',agrave:'à',aacute:'á',acirc:'â',atilde:'ã',auml:'ä',aring:'å',aelig:'æ',ccedil:'ç',egrave:'è',eacute:'é',ecirc:'ê',euml:'ë',igrave:'ì',iacute:'í',icirc:'î',iuml:'ï',eth:'ð',ntilde:'ñ',ograve:'ò',oacute:'ó',ocirc:'ô',otilde:'õ',ouml:'ö',divide:'\xF7',oslash:'ø',ugrave:'ù',uacute:'ú',ucirc:'û',uuml:'ü',yacute:'ý',thorn:'þ',yuml:'ÿ',OElig:'Œ',oelig:'œ',Scaron:'Š',scaron:'š',Yuml:'Ÿ',fnof:'ƒ',circ:'ˆ',tilde:'\u02DC',Alpha:'Α',Beta:'Β',Gamma:'Γ',Delta:'Δ',Epsilon:'Ε',Zeta:'Ζ',Eta:'Η',Theta:'Θ',Iota:'Ι',Kappa:'Κ',Lambda:'Λ',Mu:'Μ',Nu:'Ν',Xi:'Ξ',Omicron:'Ο',Pi:'Π',Rho:'Ρ',Sigma:'Σ',Tau:'Τ',Upsilon:'Υ',Phi:'Φ',Chi:'Χ',Psi:'Ψ',Omega:'Ω',alpha:'α',beta:'β',gamma:'γ',delta:'δ',epsilon:'ε',zeta:'ζ',eta:'η',theta:'θ',iota:'ι',kappa:'κ',lambda:'λ',mu:'μ',nu:'ν',xi:'ξ',omicron:'ο',pi:'π',rho:'ρ',sigmaf:'ς',sigma:'σ',tau:'τ',upsilon:'υ',phi:'φ',chi:'χ',psi:'ψ',omega:'ω',thetasym:'ϑ',upsih:'ϒ',piv:'ϖ',ensp:'\u2002',emsp:'\u2003',thinsp:'\u2009',zwnj:'‌',zwj:'‍',lrm:'\u200E',rlm:'\u200F',ndash:'\u2013',mdash:'\u2014',lsquo:'\u2018',rsquo:'\u2019',sbquo:'\u201A',ldquo:'\u201C',rdquo:'\u201D',bdquo:'\u201E',dagger:'\u2020',Dagger:'\u2021',bull:'\u2022',hellip:'\u2026',permil:'\u2030',prime:'\u2032',Prime:'\u2033',lsaquo:'\u2039',rsaquo:'\u203A',oline:'\u203E',frasl:'\u2044',euro:'\u20AC',image:'ℑ',weierp:'\u2118',real:'ℜ',trade:'\u2122',alefsym:'ℵ',larr:'\u2190',uarr:'\u2191',rarr:'\u2192',darr:'\u2193',harr:'\u2194',crarr:'\u21B5',lArr:'\u21D0',uArr:'\u21D1',rArr:'\u21D2',dArr:'\u21D3',hArr:'\u21D4',forall:'\u2200',part:'\u2202',exist:'\u2203',empty:'\u2205',nabla:'\u2207',isin:'\u2208',notin:'\u2209',ni:'\u220B',prod:'\u220F',sum:'\u2211',minus:'\u2212',lowast:'\u2217',radic:'\u221A',prop:'\u221D',infin:'\u221E',ang:'\u2220',and:'\u2227',or:'\u2228',cap:'\u2229',cup:'\u222A','int':'\u222B',there4:'\u2234',sim:'\u223C',cong:'\u2245',asymp:'\u2248',ne:'\u2260',equiv:'\u2261',le:'\u2264',ge:'\u2265',sub:'\u2282',sup:'\u2283',nsub:'\u2284',sube:'\u2286',supe:'\u2287',oplus:'\u2295',otimes:'\u2297',perp:'\u22A5',sdot:'\u22C5',lceil:'\u2308',rceil:'\u2309',lfloor:'\u230A',rfloor:'\u230B',lang:'\u2329',rang:'\u232A',loz:'\u25CA',spades:'\u2660',clubs:'\u2663',hearts:'\u2665',diams:'\u2666'};},{}],10:[function(require,module,exports){'use strict';exports.byteLength=byteLength;exports.toByteArray=toByteArray;exports.fromByteArray=fromByteArray;var lookup=[];var revLookup=[];var Arr=typeof Uint8Array!=='undefined'?Uint8Array:Array;var code='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';for(var i=0,len=code.length;i<len;++i){lookup[i]=code[i];revLookup[code.charCodeAt(i)]=i;}revLookup['-'.charCodeAt(0)]=62;revLookup['_'.charCodeAt(0)]=63;function getLens(b64){var len=b64.length;if(len%4>0){throw new Error('Invalid string. Length must be a multiple of 4');}var validLen=b64.indexOf('=');if(validLen===-1)validLen=len;var placeHoldersLen=validLen===len?0:4-validLen%4;return[validLen,placeHoldersLen];}function byteLength(b64){var lens=getLens(b64);var validLen=lens[0];var placeHoldersLen=lens[1];return(validLen+placeHoldersLen)*3/4-placeHoldersLen;}function _byteLength(b64,validLen,placeHoldersLen){return(validLen+placeHoldersLen)*3/4-placeHoldersLen;}function toByteArray(b64){var tmp;var lens=getLens(b64);var validLen=lens[0];var placeHoldersLen=lens[1];var arr=new Arr(_byteLength(b64,validLen,placeHoldersLen));var curByte=0;var len=placeHoldersLen>0?validLen-4:validLen;var i;for(i=0;i<len;i+=4){tmp=revLookup[b64.charCodeAt(i)]<<18|revLookup[b64.charCodeAt(i+1)]<<12|revLookup[b64.charCodeAt(i+2)]<<6|revLookup[b64.charCodeAt(i+3)];arr[curByte++]=tmp>>16&255;arr[curByte++]=tmp>>8&255;arr[curByte++]=tmp&255;}if(placeHoldersLen===2){tmp=revLookup[b64.charCodeAt(i)]<<2|revLookup[b64.charCodeAt(i+1)]>>4;arr[curByte++]=tmp&255;}if(placeHoldersLen===1){tmp=revLookup[b64.charCodeAt(i)]<<10|revLookup[b64.charCodeAt(i+1)]<<4|revLookup[b64.charCodeAt(i+2)]>>2;arr[curByte++]=tmp>>8&255;arr[curByte++]=tmp&255;}return arr;}function tripletToBase64(num){return lookup[num>>18&63]+lookup[num>>12&63]+lookup[num>>6&63]+lookup[num&63];}function encodeChunk(uint8,start,end){var tmp;var output=[];for(var i=start;i<end;i+=3){tmp=(uint8[i]<<16&16711680)+(uint8[i+1]<<8&65280)+(uint8[i+2]&255);output.push(tripletToBase64(tmp));}return output.join('');}function fromByteArray(uint8){var tmp;var len=uint8.length;var extraBytes=len%3;var parts=[];var maxChunkLength=16383;for(var i=0,len2=len-extraBytes;i<len2;i+=maxChunkLength){parts.push(encodeChunk(uint8,i,i+maxChunkLength>len2?len2:i+maxChunkLength));}if(extraBytes===1){tmp=uint8[len-1];parts.push(lookup[tmp>>2]+lookup[tmp<<4&63]+'==');}else if(extraBytes===2){tmp=(uint8[len-2]<<8)+uint8[len-1];parts.push(lookup[tmp>>10]+lookup[tmp>>4&63]+lookup[tmp<<2&63]+'=');}return parts.join('');}},{}],11:[function(require,module,exports){},{}],12:[function(require,module,exports){var buffer=require('buffer');var Buffer=buffer.Buffer;function copyProps(src,dst){for(var key in src){dst[key]=src[key];}}if(Buffer.from&&Buffer.alloc&&Buffer.allocUnsafe&&Buffer.allocUnsafeSlow){module.exports=buffer;}else{copyProps(buffer,exports);exports.Buffer=SafeBuffer;}function SafeBuffer(arg,encodingOrOffset,length){return Buffer(arg,encodingOrOffset,length);}copyProps(Buffer,SafeBuffer);SafeBuffer.from=function(arg,encodingOrOffset,length){if(typeof arg==='number'){throw new TypeError('Argument must not be a number');}return Buffer(arg,encodingOrOffset,length);};SafeBuffer.alloc=function(size,fill,encoding){if(typeof size!=='number'){throw new TypeError('Argument must be a number');}var buf=Buffer(size);if(fill!==undefined){if(typeof encoding==='string'){buf.fill(fill,encoding);}else{buf.fill(fill);}}else{buf.fill(0);}return buf;};SafeBuffer.allocUnsafe=function(size){if(typeof size!=='number'){throw new TypeError('Argument must be a number');}return Buffer(size);};SafeBuffer.allocUnsafeSlow=function(size){if(typeof size!=='number'){throw new TypeError('Argument must be a number');}return buffer.SlowBuffer(size);};},{'buffer':14}],13:[function(require,module,exports){'use strict';var Buffer=require('safe-buffer').Buffer;var isEncoding=Buffer.isEncoding||function(encoding){encoding=''+encoding;switch(encoding&&encoding.toLowerCase()){case'hex':case'utf8':case'utf-8':case'ascii':case'binary':case'base64':case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':case'raw':return true;default:return false;}};function _normalizeEncoding(enc){if(!enc)return'utf8';var retried;while(true){switch(enc){case'utf8':case'utf-8':return'utf8';case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':return'utf16le';case'latin1':case'binary':return'latin1';case'base64':case'ascii':case'hex':return enc;default:if(retried)return;enc=(''+enc).toLowerCase();retried=true;}}};function normalizeEncoding(enc){var nenc=_normalizeEncoding(enc);if(typeof nenc!=='string'&&(Buffer.isEncoding===isEncoding||!isEncoding(enc)))throw new Error('Unknown encoding: '+enc);return nenc||enc;}exports.StringDecoder=StringDecoder;function StringDecoder(encoding){this.encoding=normalizeEncoding(encoding);var nb;switch(this.encoding){case'utf16le':this.text=utf16Text;this.end=utf16End;nb=4;break;case'utf8':this.fillLast=utf8FillLast;nb=4;break;case'base64':this.text=base64Text;this.end=base64End;nb=3;break;default:this.write=simpleWrite;this.end=simpleEnd;return;}this.lastNeed=0;this.lastTotal=0;this.lastChar=Buffer.allocUnsafe(nb);}StringDecoder.prototype.write=function(buf){if(buf.length===0)return'';var r;var i;if(this.lastNeed){r=this.fillLast(buf);if(r===undefined)return'';i=this.lastNeed;this.lastNeed=0;}else{i=0;}if(i<buf.length)return r?r+this.text(buf,i):this.text(buf,i);return r||'';};StringDecoder.prototype.end=utf8End;StringDecoder.prototype.text=utf8Text;StringDecoder.prototype.fillLast=function(buf){if(this.lastNeed<=buf.length){buf.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed);return this.lastChar.toString(this.encoding,0,this.lastTotal);}buf.copy(this.lastChar,this.lastTotal-this.lastNeed,0,buf.length);this.lastNeed-=buf.length;};function utf8CheckByte(byte){if(byte<=127)return 0;else if(byte>>5===6)return 2;else if(byte>>4===14)return 3;else if(byte>>3===30)return 4;return-1;}function utf8CheckIncomplete(self,buf,i){var j=buf.length-1;if(j<i)return 0;var nb=utf8CheckByte(buf[j]);if(nb>=0){if(nb>0)self.lastNeed=nb-1;return nb;}if(--j<i)return 0;nb=utf8CheckByte(buf[j]);if(nb>=0){if(nb>0)self.lastNeed=nb-2;return nb;}if(--j<i)return 0;nb=utf8CheckByte(buf[j]);if(nb>=0){if(nb>0){if(nb===2)nb=0;else self.lastNeed=nb-3;}return nb;}return 0;}function utf8CheckExtraBytes(self,buf,p){if((buf[0]&192)!==128){self.lastNeed=0;return'\uFFFD'.repeat(p);}if(self.lastNeed>1&&buf.length>1){if((buf[1]&192)!==128){self.lastNeed=1;return'\uFFFD'.repeat(p+1);}if(self.lastNeed>2&&buf.length>2){if((buf[2]&192)!==128){self.lastNeed=2;return'\uFFFD'.repeat(p+2);}}}}function utf8FillLast(buf){var p=this.lastTotal-this.lastNeed;var r=utf8CheckExtraBytes(this,buf,p);if(r!==undefined)return r;if(this.lastNeed<=buf.length){buf.copy(this.lastChar,p,0,this.lastNeed);return this.lastChar.toString(this.encoding,0,this.lastTotal);}buf.copy(this.lastChar,p,0,buf.length);this.lastNeed-=buf.length;}function utf8Text(buf,i){var total=utf8CheckIncomplete(this,buf,i);if(!this.lastNeed)return buf.toString('utf8',i);this.lastTotal=total;var end=buf.length-(total-this.lastNeed);buf.copy(this.lastChar,0,end);return buf.toString('utf8',i,end);}function utf8End(buf){var r=buf&&buf.length?this.write(buf):'';if(this.lastNeed)return r+'\uFFFD'.repeat(this.lastTotal-this.lastNeed);return r;}function utf16Text(buf,i){if((buf.length-i)%2===0){var r=buf.toString('utf16le',i);if(r){var c=r.charCodeAt(r.length-1);if(c>=55296&&c<=56319){this.lastNeed=2;this.lastTotal=4;this.lastChar[0]=buf[buf.length-2];this.lastChar[1]=buf[buf.length-1];return r.slice(0,-1);}}return r;}this.lastNeed=1;this.lastTotal=2;this.lastChar[0]=buf[buf.length-1];return buf.toString('utf16le',i,buf.length-1);}function utf16End(buf){var r=buf&&buf.length?this.write(buf):'';if(this.lastNeed){var end=this.lastTotal-this.lastNeed;return r+this.lastChar.toString('utf16le',0,end);}return r;}function base64Text(buf,i){var n=(buf.length-i)%3;if(n===0)return buf.toString('base64',i);this.lastNeed=3-n;this.lastTotal=3;if(n===1){this.lastChar[0]=buf[buf.length-1];}else{this.lastChar[0]=buf[buf.length-2];this.lastChar[1]=buf[buf.length-1];}return buf.toString('base64',i,buf.length-n);}function base64End(buf){var r=buf&&buf.length?this.write(buf):'';if(this.lastNeed)return r+this.lastChar.toString('base64',0,3-this.lastNeed);return r;}function simpleWrite(buf){return buf.toString(this.encoding);}function simpleEnd(buf){return buf&&buf.length?this.write(buf):'';}},{'safe-buffer':12}],14:[function(require,module,exports){(function(Buffer){(function(){'use strict';var base64=require('base64-js');var ieee754=require('ieee754');var customInspectSymbol=typeof Symbol==='function'&&typeof Symbol['for']==='function'?Symbol['for']('nodejs.util.inspect.custom'):null;exports.Buffer=Buffer;exports.SlowBuffer=SlowBuffer;exports.INSPECT_MAX_BYTES=50;var K_MAX_LENGTH=2147483647;exports.kMaxLength=K_MAX_LENGTH;Buffer.TYPED_ARRAY_SUPPORT=typedArraySupport();if(!Buffer.TYPED_ARRAY_SUPPORT&&typeof console!=='undefined'&&typeof console.error==='function'){console.error('This browser lacks typed array (Uint8Array) support which is required by '+'`buffer` v5.x. Use `buffer` v4.x if you require old browser support.');}function typedArraySupport(){try{var arr=new Uint8Array(1);var proto={foo:function(){return 42;}};Object.setPrototypeOf(proto,Uint8Array.prototype);Object.setPrototypeOf(arr,proto);return arr.foo()===42;}catch(e){return false;}}Object.defineProperty(Buffer.prototype,'parent',{enumerable:true,get:function(){if(!Buffer.isBuffer(this))return undefined;return this.buffer;}});Object.defineProperty(Buffer.prototype,'offset',{enumerable:true,get:function(){if(!Buffer.isBuffer(this))return undefined;return this.byteOffset;}});function createBuffer(length){if(length>K_MAX_LENGTH){throw new RangeError('The value "'+length+'" is invalid for option "size"');}var buf=new Uint8Array(length);Object.setPrototypeOf(buf,Buffer.prototype);return buf;}function Buffer(arg,encodingOrOffset,length){if(typeof arg==='number'){if(typeof encodingOrOffset==='string'){throw new TypeError('The "string" argument must be of type string. Received type number');}return allocUnsafe(arg);}return from(arg,encodingOrOffset,length);}Buffer.poolSize=8192;function from(value,encodingOrOffset,length){if(typeof value==='string'){return fromString(value,encodingOrOffset);}if(ArrayBuffer.isView(value)){return fromArrayView(value);}if(value==null){throw new TypeError('The first argument must be one of type string, Buffer, ArrayBuffer, Array, '+'or Array-like Object. Received type '+typeof value);}if(isInstance(value,ArrayBuffer)||value&&isInstance(value.buffer,ArrayBuffer)){return fromArrayBuffer(value,encodingOrOffset,length);}if(typeof SharedArrayBuffer!=='undefined'&&(isInstance(value,SharedArrayBuffer)||value&&isInstance(value.buffer,SharedArrayBuffer))){return fromArrayBuffer(value,encodingOrOffset,length);}if(typeof value==='number'){throw new TypeError('The "value" argument must not be of type number. Received type number');}var valueOf=value.valueOf&&value.valueOf();if(valueOf!=null&&valueOf!==value){return Buffer.from(valueOf,encodingOrOffset,length);}var b=fromObject(value);if(b)return b;if(typeof Symbol!=='undefined'&&Symbol.toPrimitive!=null&&typeof value[Symbol.toPrimitive]==='function'){return Buffer.from(value[Symbol.toPrimitive]('string'),encodingOrOffset,length);}throw new TypeError('The first argument must be one of type string, Buffer, ArrayBuffer, Array, '+'or Array-like Object. Received type '+typeof value);}Buffer.from=function(value,encodingOrOffset,length){return from(value,encodingOrOffset,length);};Object.setPrototypeOf(Buffer.prototype,Uint8Array.prototype);Object.setPrototypeOf(Buffer,Uint8Array);function assertSize(size){if(typeof size!=='number'){throw new TypeError('"size" argument must be of type number');}else if(size<0){throw new RangeError('The value "'+size+'" is invalid for option "size"');}}function alloc(size,fill,encoding){assertSize(size);if(size<=0){return createBuffer(size);}if(fill!==undefined){return typeof encoding==='string'?createBuffer(size).fill(fill,encoding):createBuffer(size).fill(fill);}return createBuffer(size);}Buffer.alloc=function(size,fill,encoding){return alloc(size,fill,encoding);};function allocUnsafe(size){assertSize(size);return createBuffer(size<0?0:checked(size)|0);}Buffer.allocUnsafe=function(size){return allocUnsafe(size);};Buffer.allocUnsafeSlow=function(size){return allocUnsafe(size);};function fromString(string,encoding){if(typeof encoding!=='string'||encoding===''){encoding='utf8';}if(!Buffer.isEncoding(encoding)){throw new TypeError('Unknown encoding: '+encoding);}var length=byteLength(string,encoding)|0;var buf=createBuffer(length);var actual=buf.write(string,encoding);if(actual!==length){buf=buf.slice(0,actual);}return buf;}function fromArrayLike(array){var length=array.length<0?0:checked(array.length)|0;var buf=createBuffer(length);for(var i=0;i<length;i+=1){buf[i]=array[i]&255;}return buf;}function fromArrayView(arrayView){if(isInstance(arrayView,Uint8Array)){var copy=new Uint8Array(arrayView);return fromArrayBuffer(copy.buffer,copy.byteOffset,copy.byteLength);}return fromArrayLike(arrayView);}function fromArrayBuffer(array,byteOffset,length){if(byteOffset<0||array.byteLength<byteOffset){throw new RangeError('"offset" is outside of buffer bounds');}if(array.byteLength<byteOffset+(length||0)){throw new RangeError('"length" is outside of buffer bounds');}var buf;if(byteOffset===undefined&&length===undefined){buf=new Uint8Array(array);}else if(length===undefined){buf=new Uint8Array(array,byteOffset);}else{buf=new Uint8Array(array,byteOffset,length);}Object.setPrototypeOf(buf,Buffer.prototype);return buf;}function fromObject(obj){if(Buffer.isBuffer(obj)){var len=checked(obj.length)|0;var buf=createBuffer(len);if(buf.length===0){return buf;}obj.copy(buf,0,0,len);return buf;}if(obj.length!==undefined){if(typeof obj.length!=='number'||numberIsNaN(obj.length)){return createBuffer(0);}return fromArrayLike(obj);}if(obj.type==='Buffer'&&Array.isArray(obj.data)){return fromArrayLike(obj.data);}}function checked(length){if(length>=K_MAX_LENGTH){throw new RangeError('Attempt to allocate Buffer larger than maximum '+'size: 0x'+K_MAX_LENGTH.toString(16)+' bytes');}return length|0;}function SlowBuffer(length){if(+length!=length){length=0;}return Buffer.alloc(+length);}Buffer.isBuffer=function isBuffer(b){return b!=null&&b._isBuffer===true&&b!==Buffer.prototype;};Buffer.compare=function compare(a,b){if(isInstance(a,Uint8Array))a=Buffer.from(a,a.offset,a.byteLength);if(isInstance(b,Uint8Array))b=Buffer.from(b,b.offset,b.byteLength);if(!Buffer.isBuffer(a)||!Buffer.isBuffer(b)){throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');}if(a===b)return 0;var x=a.length;var y=b.length;for(var i=0,len=Math.min(x,y);i<len;++i){if(a[i]!==b[i]){x=a[i];y=b[i];break;}}if(x<y)return-1;if(y<x)return 1;return 0;};Buffer.isEncoding=function isEncoding(encoding){switch(String(encoding).toLowerCase()){case'hex':case'utf8':case'utf-8':case'ascii':case'latin1':case'binary':case'base64':case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':return true;default:return false;}};Buffer.concat=function concat(list,length){if(!Array.isArray(list)){throw new TypeError('"list" argument must be an Array of Buffers');}if(list.length===0){return Buffer.alloc(0);}var i;if(length===undefined){length=0;for(i=0;i<list.length;++i){length+=list[i].length;}}var buffer=Buffer.allocUnsafe(length);var pos=0;for(i=0;i<list.length;++i){var buf=list[i];if(isInstance(buf,Uint8Array)){if(pos+buf.length>buffer.length){Buffer.from(buf).copy(buffer,pos);}else{Uint8Array.prototype.set.call(buffer,buf,pos);}}else if(!Buffer.isBuffer(buf)){throw new TypeError('"list" argument must be an Array of Buffers');}else{buf.copy(buffer,pos);}pos+=buf.length;}return buffer;};function byteLength(string,encoding){if(Buffer.isBuffer(string)){return string.length;}if(ArrayBuffer.isView(string)||isInstance(string,ArrayBuffer)){return string.byteLength;}if(typeof string!=='string'){throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. '+'Received type '+typeof string);}var len=string.length;var mustMatch=arguments.length>2&&arguments[2]===true;if(!mustMatch&&len===0)return 0;var loweredCase=false;for(;;){switch(encoding){case'ascii':case'latin1':case'binary':return len;case'utf8':case'utf-8':return utf8ToBytes(string).length;case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':return len*2;case'hex':return len>>>1;case'base64':return base64ToBytes(string).length;default:if(loweredCase){return mustMatch?-1:utf8ToBytes(string).length;}encoding=(''+encoding).toLowerCase();loweredCase=true;}}}Buffer.byteLength=byteLength;function slowToString(encoding,start,end){var loweredCase=false;if(start===undefined||start<0){start=0;}if(start>this.length){return'';}if(end===undefined||end>this.length){end=this.length;}if(end<=0){return'';}end>>>=0;start>>>=0;if(end<=start){return'';}if(!encoding)encoding='utf8';while(true){switch(encoding){case'hex':return hexSlice(this,start,end);case'utf8':case'utf-8':return utf8Slice(this,start,end);case'ascii':return asciiSlice(this,start,end);case'latin1':case'binary':return latin1Slice(this,start,end);case'base64':return base64Slice(this,start,end);case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':return utf16leSlice(this,start,end);default:if(loweredCase)throw new TypeError('Unknown encoding: '+encoding);encoding=(encoding+'').toLowerCase();loweredCase=true;}}}Buffer.prototype._isBuffer=true;function swap(b,n,m){var i=b[n];b[n]=b[m];b[m]=i;}Buffer.prototype.swap16=function swap16(){var len=this.length;if(len%2!==0){throw new RangeError('Buffer size must be a multiple of 16-bits');}for(var i=0;i<len;i+=2){swap(this,i,i+1);}return this;};Buffer.prototype.swap32=function swap32(){var len=this.length;if(len%4!==0){throw new RangeError('Buffer size must be a multiple of 32-bits');}for(var i=0;i<len;i+=4){swap(this,i,i+3);swap(this,i+1,i+2);}return this;};Buffer.prototype.swap64=function swap64(){var len=this.length;if(len%8!==0){throw new RangeError('Buffer size must be a multiple of 64-bits');}for(var i=0;i<len;i+=8){swap(this,i,i+7);swap(this,i+1,i+6);swap(this,i+2,i+5);swap(this,i+3,i+4);}return this;};Buffer.prototype.toString=function toString(){var length=this.length;if(length===0)return'';if(arguments.length===0)return utf8Slice(this,0,length);return slowToString.apply(this,arguments);};Buffer.prototype.toLocaleString=Buffer.prototype.toString;Buffer.prototype.equals=function equals(b){if(!Buffer.isBuffer(b))throw new TypeError('Argument must be a Buffer');if(this===b)return true;return Buffer.compare(this,b)===0;};Buffer.prototype.inspect=function inspect(){var str='';var max=exports.INSPECT_MAX_BYTES;str=this.toString('hex',0,max).replace(/(.{2})/g,'$1 ').trim();if(this.length>max)str+=' ... ';return'<Buffer '+str+'>';};if(customInspectSymbol){Buffer.prototype[customInspectSymbol]=Buffer.prototype.inspect;}Buffer.prototype.compare=function compare(target,start,end,thisStart,thisEnd){if(isInstance(target,Uint8Array)){target=Buffer.from(target,target.offset,target.byteLength);}if(!Buffer.isBuffer(target)){throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. '+'Received type '+typeof target);}if(start===undefined){start=0;}if(end===undefined){end=target?target.length:0;}if(thisStart===undefined){thisStart=0;}if(thisEnd===undefined){thisEnd=this.length;}if(start<0||end>target.length||thisStart<0||thisEnd>this.length){throw new RangeError('out of range index');}if(thisStart>=thisEnd&&start>=end){return 0;}if(thisStart>=thisEnd){return-1;}if(start>=end){return 1;}start>>>=0;end>>>=0;thisStart>>>=0;thisEnd>>>=0;if(this===target)return 0;var x=thisEnd-thisStart;var y=end-start;var len=Math.min(x,y);var thisCopy=this.slice(thisStart,thisEnd);var targetCopy=target.slice(start,end);for(var i=0;i<len;++i){if(thisCopy[i]!==targetCopy[i]){x=thisCopy[i];y=targetCopy[i];break;}}if(x<y)return-1;if(y<x)return 1;return 0;};function bidirectionalIndexOf(buffer,val,byteOffset,encoding,dir){if(buffer.length===0)return-1;if(typeof byteOffset==='string'){encoding=byteOffset;byteOffset=0;}else if(byteOffset>2147483647){byteOffset=2147483647;}else if(byteOffset<-2147483648){byteOffset=-2147483648;}byteOffset=+byteOffset;if(numberIsNaN(byteOffset)){byteOffset=dir?0:buffer.length-1;}if(byteOffset<0)byteOffset=buffer.length+byteOffset;if(byteOffset>=buffer.length){if(dir)return-1;else byteOffset=buffer.length-1;}else if(byteOffset<0){if(dir)byteOffset=0;else return-1;}if(typeof val==='string'){val=Buffer.from(val,encoding);}if(Buffer.isBuffer(val)){if(val.length===0){return-1;}return arrayIndexOf(buffer,val,byteOffset,encoding,dir);}else if(typeof val==='number'){val=val&255;if(typeof Uint8Array.prototype.indexOf==='function'){if(dir){return Uint8Array.prototype.indexOf.call(buffer,val,byteOffset);}else{return Uint8Array.prototype.lastIndexOf.call(buffer,val,byteOffset);}}return arrayIndexOf(buffer,[val],byteOffset,encoding,dir);}throw new TypeError('val must be string, number or Buffer');}function arrayIndexOf(arr,val,byteOffset,encoding,dir){var indexSize=1;var arrLength=arr.length;var valLength=val.length;if(encoding!==undefined){encoding=String(encoding).toLowerCase();if(encoding==='ucs2'||encoding==='ucs-2'||encoding==='utf16le'||encoding==='utf-16le'){if(arr.length<2||val.length<2){return-1;}indexSize=2;arrLength/=2;valLength/=2;byteOffset/=2;}}function read(buf,i){if(indexSize===1){return buf[i];}else{return buf.readUInt16BE(i*indexSize);}}var i;if(dir){var foundIndex=-1;for(i=byteOffset;i<arrLength;i++){if(read(arr,i)===read(val,foundIndex===-1?0:i-foundIndex)){if(foundIndex===-1)foundIndex=i;if(i-foundIndex+1===valLength)return foundIndex*indexSize;}else{if(foundIndex!==-1)i-=i-foundIndex;foundIndex=-1;}}}else{if(byteOffset+valLength>arrLength)byteOffset=arrLength-valLength;for(i=byteOffset;i>=0;i--){var found=true;for(var j=0;j<valLength;j++){if(read(arr,i+j)!==read(val,j)){found=false;break;}}if(found)return i;}}return-1;}Buffer.prototype.includes=function includes(val,byteOffset,encoding){return this.indexOf(val,byteOffset,encoding)!==-1;};Buffer.prototype.indexOf=function indexOf(val,byteOffset,encoding){return bidirectionalIndexOf(this,val,byteOffset,encoding,true);};Buffer.prototype.lastIndexOf=function lastIndexOf(val,byteOffset,encoding){return bidirectionalIndexOf(this,val,byteOffset,encoding,false);};function hexWrite(buf,string,offset,length){offset=Number(offset)||0;var remaining=buf.length-offset;if(!length){length=remaining;}else{length=Number(length);if(length>remaining){length=remaining;}}var strLen=string.length;if(length>strLen/2){length=strLen/2;}for(var i=0;i<length;++i){var parsed=parseInt(string.substr(i*2,2),16);if(numberIsNaN(parsed))return i;buf[offset+i]=parsed;}return i;}function utf8Write(buf,string,offset,length){return blitBuffer(utf8ToBytes(string,buf.length-offset),buf,offset,length);}function asciiWrite(buf,string,offset,length){return blitBuffer(asciiToBytes(string),buf,offset,length);}function base64Write(buf,string,offset,length){return blitBuffer(base64ToBytes(string),buf,offset,length);}function ucs2Write(buf,string,offset,length){return blitBuffer(utf16leToBytes(string,buf.length-offset),buf,offset,length);}Buffer.prototype.write=function write(string,offset,length,encoding){if(offset===undefined){encoding='utf8';length=this.length;offset=0;}else if(length===undefined&&typeof offset==='string'){encoding=offset;length=this.length;offset=0;}else if(isFinite(offset)){offset=offset>>>0;if(isFinite(length)){length=length>>>0;if(encoding===undefined)encoding='utf8';}else{encoding=length;length=undefined;}}else{throw new Error('Buffer.write(string, encoding, offset[, length]) is no longer supported');}var remaining=this.length-offset;if(length===undefined||length>remaining)length=remaining;if(string.length>0&&(length<0||offset<0)||offset>this.length){throw new RangeError('Attempt to write outside buffer bounds');}if(!encoding)encoding='utf8';var loweredCase=false;for(;;){switch(encoding){case'hex':return hexWrite(this,string,offset,length);case'utf8':case'utf-8':return utf8Write(this,string,offset,length);case'ascii':case'latin1':case'binary':return asciiWrite(this,string,offset,length);case'base64':return base64Write(this,string,offset,length);case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':return ucs2Write(this,string,offset,length);default:if(loweredCase)throw new TypeError('Unknown encoding: '+encoding);encoding=(''+encoding).toLowerCase();loweredCase=true;}}};Buffer.prototype.toJSON=function toJSON(){return{type:'Buffer',data:Array.prototype.slice.call(this._arr||this,0)};};function base64Slice(buf,start,end){if(start===0&&end===buf.length){return base64.fromByteArray(buf);}else{return base64.fromByteArray(buf.slice(start,end));}}function utf8Slice(buf,start,end){end=Math.min(buf.length,end);var res=[];var i=start;while(i<end){var firstByte=buf[i];var codePoint=null;var bytesPerSequence=firstByte>239?4:firstByte>223?3:firstByte>191?2:1;if(i+bytesPerSequence<=end){var secondByte,thirdByte,fourthByte,tempCodePoint;switch(bytesPerSequence){case 1:if(firstByte<128){codePoint=firstByte;}break;case 2:secondByte=buf[i+1];if((secondByte&192)===128){tempCodePoint=(firstByte&31)<<6|secondByte&63;if(tempCodePoint>127){codePoint=tempCodePoint;}}break;case 3:secondByte=buf[i+1];thirdByte=buf[i+2];if((secondByte&192)===128&&(thirdByte&192)===128){tempCodePoint=(firstByte&15)<<12|(secondByte&63)<<6|thirdByte&63;if(tempCodePoint>2047&&(tempCodePoint<55296||tempCodePoint>57343)){codePoint=tempCodePoint;}}break;case 4:secondByte=buf[i+1];thirdByte=buf[i+2];fourthByte=buf[i+3];if((secondByte&192)===128&&(thirdByte&192)===128&&(fourthByte&192)===128){tempCodePoint=(firstByte&15)<<18|(secondByte&63)<<12|(thirdByte&63)<<6|fourthByte&63;if(tempCodePoint>65535&&tempCodePoint<1114112){codePoint=tempCodePoint;}}}}if(codePoint===null){codePoint=65533;bytesPerSequence=1;}else if(codePoint>65535){codePoint-=65536;res.push(codePoint>>>10&1023|55296);codePoint=56320|codePoint&1023;}res.push(codePoint);i+=bytesPerSequence;}return decodeCodePointsArray(res);}var MAX_ARGUMENTS_LENGTH=4096;function decodeCodePointsArray(codePoints){var len=codePoints.length;if(len<=MAX_ARGUMENTS_LENGTH){return String.fromCharCode.apply(String,codePoints);}var res='';var i=0;while(i<len){res+=String.fromCharCode.apply(String,codePoints.slice(i,i+=MAX_ARGUMENTS_LENGTH));}return res;}function asciiSlice(buf,start,end){var ret='';end=Math.min(buf.length,end);for(var i=start;i<end;++i){ret+=String.fromCharCode(buf[i]&127);}return ret;}function latin1Slice(buf,start,end){var ret='';end=Math.min(buf.length,end);for(var i=start;i<end;++i){ret+=String.fromCharCode(buf[i]);}return ret;}function hexSlice(buf,start,end){var len=buf.length;if(!start||start<0)start=0;if(!end||end<0||end>len)end=len;var out='';for(var i=start;i<end;++i){out+=hexSliceLookupTable[buf[i]];}return out;}function utf16leSlice(buf,start,end){var bytes=buf.slice(start,end);var res='';for(var i=0;i<bytes.length-1;i+=2){res+=String.fromCharCode(bytes[i]+bytes[i+1]*256);}return res;}Buffer.prototype.slice=function slice(start,end){var len=this.length;start=~~start;end=end===undefined?len:~~end;if(start<0){start+=len;if(start<0)start=0;}else if(start>len){start=len;}if(end<0){end+=len;if(end<0)end=0;}else if(end>len){end=len;}if(end<start)end=start;var newBuf=this.subarray(start,end);Object.setPrototypeOf(newBuf,Buffer.prototype);return newBuf;};function checkOffset(offset,ext,length){if(offset%1!==0||offset<0)throw new RangeError('offset is not uint');if(offset+ext>length)throw new RangeError('Trying to access beyond buffer length');}Buffer.prototype.readUintLE=Buffer.prototype.readUIntLE=function readUIntLE(offset,byteLength,noAssert){offset=offset>>>0;byteLength=byteLength>>>0;if(!noAssert)checkOffset(offset,byteLength,this.length);var val=this[offset];var mul=1;var i=0;while(++i<byteLength&&(mul*=256)){val+=this[offset+i]*mul;}return val;};Buffer.prototype.readUintBE=Buffer.prototype.readUIntBE=function readUIntBE(offset,byteLength,noAssert){offset=offset>>>0;byteLength=byteLength>>>0;if(!noAssert){checkOffset(offset,byteLength,this.length);}var val=this[offset+--byteLength];var mul=1;while(byteLength>0&&(mul*=256)){val+=this[offset+--byteLength]*mul;}return val;};Buffer.prototype.readUint8=Buffer.prototype.readUInt8=function readUInt8(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,1,this.length);return this[offset];};Buffer.prototype.readUint16LE=Buffer.prototype.readUInt16LE=function readUInt16LE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,2,this.length);return this[offset]|this[offset+1]<<8;};Buffer.prototype.readUint16BE=Buffer.prototype.readUInt16BE=function readUInt16BE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,2,this.length);return this[offset]<<8|this[offset+1];};Buffer.prototype.readUint32LE=Buffer.prototype.readUInt32LE=function readUInt32LE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,4,this.length);return(this[offset]|this[offset+1]<<8|this[offset+2]<<16)+this[offset+3]*16777216;};Buffer.prototype.readUint32BE=Buffer.prototype.readUInt32BE=function readUInt32BE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,4,this.length);return this[offset]*16777216+(this[offset+1]<<16|this[offset+2]<<8|this[offset+3]);};Buffer.prototype.readIntLE=function readIntLE(offset,byteLength,noAssert){offset=offset>>>0;byteLength=byteLength>>>0;if(!noAssert)checkOffset(offset,byteLength,this.length);var val=this[offset];var mul=1;var i=0;while(++i<byteLength&&(mul*=256)){val+=this[offset+i]*mul;}mul*=128;if(val>=mul)val-=Math.pow(2,8*byteLength);return val;};Buffer.prototype.readIntBE=function readIntBE(offset,byteLength,noAssert){offset=offset>>>0;byteLength=byteLength>>>0;if(!noAssert)checkOffset(offset,byteLength,this.length);var i=byteLength;var mul=1;var val=this[offset+--i];while(i>0&&(mul*=256)){val+=this[offset+--i]*mul;}mul*=128;if(val>=mul)val-=Math.pow(2,8*byteLength);return val;};Buffer.prototype.readInt8=function readInt8(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,1,this.length);if(!(this[offset]&128))return this[offset];return(255-this[offset]+1)*-1;};Buffer.prototype.readInt16LE=function readInt16LE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,2,this.length);var val=this[offset]|this[offset+1]<<8;return val&32768?val|4294901760:val;};Buffer.prototype.readInt16BE=function readInt16BE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,2,this.length);var val=this[offset+1]|this[offset]<<8;return val&32768?val|4294901760:val;};Buffer.prototype.readInt32LE=function readInt32LE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,4,this.length);return this[offset]|this[offset+1]<<8|this[offset+2]<<16|this[offset+3]<<24;};Buffer.prototype.readInt32BE=function readInt32BE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,4,this.length);return this[offset]<<24|this[offset+1]<<16|this[offset+2]<<8|this[offset+3];};Buffer.prototype.readFloatLE=function readFloatLE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,4,this.length);return ieee754.read(this,offset,true,23,4);};Buffer.prototype.readFloatBE=function readFloatBE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,4,this.length);return ieee754.read(this,offset,false,23,4);};Buffer.prototype.readDoubleLE=function readDoubleLE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,8,this.length);return ieee754.read(this,offset,true,52,8);};Buffer.prototype.readDoubleBE=function readDoubleBE(offset,noAssert){offset=offset>>>0;if(!noAssert)checkOffset(offset,8,this.length);return ieee754.read(this,offset,false,52,8);};function checkInt(buf,value,offset,ext,max,min){if(!Buffer.isBuffer(buf))throw new TypeError('"buffer" argument must be a Buffer instance');if(value>max||value<min)throw new RangeError('"value" argument is out of bounds');if(offset+ext>buf.length)throw new RangeError('Index out of range');}Buffer.prototype.writeUintLE=Buffer.prototype.writeUIntLE=function writeUIntLE(value,offset,byteLength,noAssert){value=+value;offset=offset>>>0;byteLength=byteLength>>>0;if(!noAssert){var maxBytes=Math.pow(2,8*byteLength)-1;checkInt(this,value,offset,byteLength,maxBytes,0);}var mul=1;var i=0;this[offset]=value&255;while(++i<byteLength&&(mul*=256)){this[offset+i]=value/mul&255;}return offset+byteLength;};Buffer.prototype.writeUintBE=Buffer.prototype.writeUIntBE=function writeUIntBE(value,offset,byteLength,noAssert){value=+value;offset=offset>>>0;byteLength=byteLength>>>0;if(!noAssert){var maxBytes=Math.pow(2,8*byteLength)-1;checkInt(this,value,offset,byteLength,maxBytes,0);}var i=byteLength-1;var mul=1;this[offset+i]=value&255;while(--i>=0&&(mul*=256)){this[offset+i]=value/mul&255;}return offset+byteLength;};Buffer.prototype.writeUint8=Buffer.prototype.writeUInt8=function writeUInt8(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,1,255,0);this[offset]=value&255;return offset+1;};Buffer.prototype.writeUint16LE=Buffer.prototype.writeUInt16LE=function writeUInt16LE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,2,65535,0);this[offset]=value&255;this[offset+1]=value>>>8;return offset+2;};Buffer.prototype.writeUint16BE=Buffer.prototype.writeUInt16BE=function writeUInt16BE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,2,65535,0);this[offset]=value>>>8;this[offset+1]=value&255;return offset+2;};Buffer.prototype.writeUint32LE=Buffer.prototype.writeUInt32LE=function writeUInt32LE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,4,4294967295,0);this[offset+3]=value>>>24;this[offset+2]=value>>>16;this[offset+1]=value>>>8;this[offset]=value&255;return offset+4;};Buffer.prototype.writeUint32BE=Buffer.prototype.writeUInt32BE=function writeUInt32BE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,4,4294967295,0);this[offset]=value>>>24;this[offset+1]=value>>>16;this[offset+2]=value>>>8;this[offset+3]=value&255;return offset+4;};Buffer.prototype.writeIntLE=function writeIntLE(value,offset,byteLength,noAssert){value=+value;offset=offset>>>0;if(!noAssert){var limit=Math.pow(2,8*byteLength-1);checkInt(this,value,offset,byteLength,limit-1,-limit);}var i=0;var mul=1;var sub=0;this[offset]=value&255;while(++i<byteLength&&(mul*=256)){if(value<0&&sub===0&&this[offset+i-1]!==0){sub=1;}this[offset+i]=(value/mul>>0)-sub&255;}return offset+byteLength;};Buffer.prototype.writeIntBE=function writeIntBE(value,offset,byteLength,noAssert){value=+value;offset=offset>>>0;if(!noAssert){var limit=Math.pow(2,8*byteLength-1);checkInt(this,value,offset,byteLength,limit-1,-limit);}var i=byteLength-1;var mul=1;var sub=0;this[offset+i]=value&255;while(--i>=0&&(mul*=256)){if(value<0&&sub===0&&this[offset+i+1]!==0){sub=1;}this[offset+i]=(value/mul>>0)-sub&255;}return offset+byteLength;};Buffer.prototype.writeInt8=function writeInt8(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,1,127,-128);if(value<0)value=255+value+1;this[offset]=value&255;return offset+1;};Buffer.prototype.writeInt16LE=function writeInt16LE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,2,32767,-32768);this[offset]=value&255;this[offset+1]=value>>>8;return offset+2;};Buffer.prototype.writeInt16BE=function writeInt16BE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,2,32767,-32768);this[offset]=value>>>8;this[offset+1]=value&255;return offset+2;};Buffer.prototype.writeInt32LE=function writeInt32LE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,4,2147483647,-2147483648);this[offset]=value&255;this[offset+1]=value>>>8;this[offset+2]=value>>>16;this[offset+3]=value>>>24;return offset+4;};Buffer.prototype.writeInt32BE=function writeInt32BE(value,offset,noAssert){value=+value;offset=offset>>>0;if(!noAssert)checkInt(this,value,offset,4,2147483647,-2147483648);if(value<0)value=4294967295+value+1;this[offset]=value>>>24;this[offset+1]=value>>>16;this[offset+2]=value>>>8;this[offset+3]=value&255;return offset+4;};function checkIEEE754(buf,value,offset,ext,max,min){if(offset+ext>buf.length)throw new RangeError('Index out of range');if(offset<0)throw new RangeError('Index out of range');}function writeFloat(buf,value,offset,littleEndian,noAssert){value=+value;offset=offset>>>0;if(!noAssert){checkIEEE754(buf,value,offset,4,3.4028234663852886e+38,-3.4028234663852886e+38);}ieee754.write(buf,value,offset,littleEndian,23,4);return offset+4;}Buffer.prototype.writeFloatLE=function writeFloatLE(value,offset,noAssert){return writeFloat(this,value,offset,true,noAssert);};Buffer.prototype.writeFloatBE=function writeFloatBE(value,offset,noAssert){return writeFloat(this,value,offset,false,noAssert);};function writeDouble(buf,value,offset,littleEndian,noAssert){value=+value;offset=offset>>>0;if(!noAssert){checkIEEE754(buf,value,offset,8,1.7976931348623157e+308,-1.7976931348623157e+308);}ieee754.write(buf,value,offset,littleEndian,52,8);return offset+8;}Buffer.prototype.writeDoubleLE=function writeDoubleLE(value,offset,noAssert){return writeDouble(this,value,offset,true,noAssert);};Buffer.prototype.writeDoubleBE=function writeDoubleBE(value,offset,noAssert){return writeDouble(this,value,offset,false,noAssert);};Buffer.prototype.copy=function copy(target,targetStart,start,end){if(!Buffer.isBuffer(target))throw new TypeError('argument should be a Buffer');if(!start)start=0;if(!end&&end!==0)end=this.length;if(targetStart>=target.length)targetStart=target.length;if(!targetStart)targetStart=0;if(end>0&&end<start)end=start;if(end===start)return 0;if(target.length===0||this.length===0)return 0;if(targetStart<0){throw new RangeError('targetStart out of bounds');}if(start<0||start>=this.length)throw new RangeError('Index out of range');if(end<0)throw new RangeError('sourceEnd out of bounds');if(end>this.length)end=this.length;if(target.length-targetStart<end-start){end=target.length-targetStart+start;}var len=end-start;if(this===target&&typeof Uint8Array.prototype.copyWithin==='function'){this.copyWithin(targetStart,start,end);}else{Uint8Array.prototype.set.call(target,this.subarray(start,end),targetStart);}return len;};Buffer.prototype.fill=function fill(val,start,end,encoding){if(typeof val==='string'){if(typeof start==='string'){encoding=start;start=0;end=this.length;}else if(typeof end==='string'){encoding=end;end=this.length;}if(encoding!==undefined&&typeof encoding!=='string'){throw new TypeError('encoding must be a string');}if(typeof encoding==='string'&&!Buffer.isEncoding(encoding)){throw new TypeError('Unknown encoding: '+encoding);}if(val.length===1){var code=val.charCodeAt(0);if(encoding==='utf8'&&code<128||encoding==='latin1'){val=code;}}}else if(typeof val==='number'){val=val&255;}else if(typeof val==='boolean'){val=Number(val);}if(start<0||this.length<start||this.length<end){throw new RangeError('Out of range index');}if(end<=start){return this;}start=start>>>0;end=end===undefined?this.length:end>>>0;if(!val)val=0;var i;if(typeof val==='number'){for(i=start;i<end;++i){this[i]=val;}}else{var bytes=Buffer.isBuffer(val)?val:Buffer.from(val,encoding);var len=bytes.length;if(len===0){throw new TypeError('The value "'+val+'" is invalid for argument "value"');}for(i=0;i<end-start;++i){this[i+start]=bytes[i%len];}}return this;};var INVALID_BASE64_RE=/[^+/0-9A-Za-z-_]/g;function base64clean(str){str=str.split('=')[0];str=str.trim().replace(INVALID_BASE64_RE,'');if(str.length<2)return'';while(str.length%4!==0){str=str+'=';}return str;}function utf8ToBytes(string,units){units=units||Infinity;var codePoint;var length=string.length;var leadSurrogate=null;var bytes=[];for(var i=0;i<length;++i){codePoint=string.charCodeAt(i);if(codePoint>55295&&codePoint<57344){if(!leadSurrogate){if(codePoint>56319){if((units-=3)>-1)bytes.push(239,191,189);continue;}else if(i+1===length){if((units-=3)>-1)bytes.push(239,191,189);continue;}leadSurrogate=codePoint;continue;}if(codePoint<56320){if((units-=3)>-1)bytes.push(239,191,189);leadSurrogate=codePoint;continue;}codePoint=(leadSurrogate-55296<<10|codePoint-56320)+65536;}else if(leadSurrogate){if((units-=3)>-1)bytes.push(239,191,189);}leadSurrogate=null;if(codePoint<128){if((units-=1)<0)break;bytes.push(codePoint);}else if(codePoint<2048){if((units-=2)<0)break;bytes.push(codePoint>>6|192,codePoint&63|128);}else if(codePoint<65536){if((units-=3)<0)break;bytes.push(codePoint>>12|224,codePoint>>6&63|128,codePoint&63|128);}else if(codePoint<1114112){if((units-=4)<0)break;bytes.push(codePoint>>18|240,codePoint>>12&63|128,codePoint>>6&63|128,codePoint&63|128);}else{throw new Error('Invalid code point');}}return bytes;}function asciiToBytes(str){var byteArray=[];for(var i=0;i<str.length;++i){byteArray.push(str.charCodeAt(i)&255);}return byteArray;}function utf16leToBytes(str,units){var c,hi,lo;var byteArray=[];for(var i=0;i<str.length;++i){if((units-=2)<0)break;c=str.charCodeAt(i);hi=c>>8;lo=c%256;byteArray.push(lo);byteArray.push(hi);}return byteArray;}function base64ToBytes(str){return base64.toByteArray(base64clean(str));}function blitBuffer(src,dst,offset,length){for(var i=0;i<length;++i){if(i+offset>=dst.length||i>=src.length)break;dst[i+offset]=src[i];}return i;}function isInstance(obj,type){return obj instanceof type||obj!=null&&obj.constructor!=null&&obj.constructor.name!=null&&obj.constructor.name===type.name;}function numberIsNaN(obj){return obj!==obj;}var hexSliceLookupTable=function(){var alphabet='0123456789abcdef';var table=new Array(256);for(var i=0;i<16;++i){var i16=i*16;for(var j=0;j<16;++j){table[i16+j]=alphabet[i]+alphabet[j];}}return table;}();}.call(this));}.call(this,require('buffer').Buffer));},{'base64-js':10,'buffer':14,'ieee754':70}],15:[function(require,module,exports){(function(Buffer){(function(){'use strict';var fs=require('fs');var path=require('path');Object.defineProperty(exports,'commentRegex',{get:function getCommentRegex(){return/^\s*\/(?:\/|\*)[@#]\s+sourceMappingURL=data:(?:application|text)\/json;(?:charset[:=]\S+?;)?base64,(?:.*)$/mg;}});Object.defineProperty(exports,'mapFileCommentRegex',{get:function getMapFileCommentRegex(){return/(?:\/\/[@#][ \t]+sourceMappingURL=([^\s'"`]+?)[ \t]*$)|(?:\/\*[@#][ \t]+sourceMappingURL=([^\*]+?)[ \t]*(?:\*\/){1}[ \t]*$)/mg;}});var decodeBase64;if(typeof Buffer!=='undefined'){if(typeof Buffer.from==='function'){decodeBase64=decodeBase64WithBufferFrom;}else{decodeBase64=decodeBase64WithNewBuffer;}}else{decodeBase64=decodeBase64WithAtob;}function decodeBase64WithBufferFrom(base64){return Buffer.from(base64,'base64').toString();}function decodeBase64WithNewBuffer(base64){if(typeof value==='number'){throw new TypeError('The value to decode must not be of type number.');}return new Buffer(base64,'base64').toString();}function decodeBase64WithAtob(base64){return decodeURIComponent(escape(atob(base64)));}function stripComment(sm){return sm.split(',').pop();}function readFromFileMap(sm,dir){var r=exports.mapFileCommentRegex.exec(sm);var filename=r[1]||r[2];var filepath=path.resolve(dir,filename);try{return fs.readFileSync(filepath,'utf8');}catch(e){throw new Error('An error occurred while trying to read the map file at '+filepath+'\n'+e);}}function Converter(sm,opts){opts=opts||{};if(opts.isFileComment)sm=readFromFileMap(sm,opts.commentFileDir);if(opts.hasComment)sm=stripComment(sm);if(opts.isEncoded)sm=decodeBase64(sm);if(opts.isJSON||opts.isEncoded)sm=JSON.parse(sm);this.sourcemap=sm;}Converter.prototype.toJSON=function(space){return JSON.stringify(this.sourcemap,null,space);};if(typeof Buffer!=='undefined'){if(typeof Buffer.from==='function'){Converter.prototype.toBase64=encodeBase64WithBufferFrom;}else{Converter.prototype.toBase64=encodeBase64WithNewBuffer;}}else{Converter.prototype.toBase64=encodeBase64WithBtoa;}function encodeBase64WithBufferFrom(){var json=this.toJSON();return Buffer.from(json,'utf8').toString('base64');}function encodeBase64WithNewBuffer(){var json=this.toJSON();if(typeof json==='number'){throw new TypeError('The json to encode must not be of type number.');}return new Buffer(json,'utf8').toString('base64');}function encodeBase64WithBtoa(){var json=this.toJSON();return btoa(unescape(encodeURIComponent(json)));}Converter.prototype.toComment=function(options){var base64=this.toBase64();var data='sourceMappingURL=data:application/json;charset=utf-8;base64,'+base64;return options&&options.multiline?'/*# '+data+' */':'//# '+data;};Converter.prototype.toObject=function(){return JSON.parse(this.toJSON());};Converter.prototype.addProperty=function(key,value){if(this.sourcemap.hasOwnProperty(key))throw new Error('property "'+key+'" already exists on the sourcemap, use set property instead');return this.setProperty(key,value);};Converter.prototype.setProperty=function(key,value){this.sourcemap[key]=value;return this;};Converter.prototype.getProperty=function(key){return this.sourcemap[key];};exports.fromObject=function(obj){return new Converter(obj);};exports.fromJSON=function(json){return new Converter(json,{isJSON:true});};exports.fromBase64=function(base64){return new Converter(base64,{isEncoded:true});};exports.fromComment=function(comment){comment=comment.replace(/^\/\*/g,'//').replace(/\*\/$/g,'');return new Converter(comment,{isEncoded:true,hasComment:true});};exports.fromMapFileComment=function(comment,dir){return new Converter(comment,{commentFileDir:dir,isFileComment:true,isJSON:true});};exports.fromSource=function(content){var m=content.match(exports.commentRegex);return m?exports.fromComment(m.pop()):null;};exports.fromMapFileSource=function(content,dir){var m=content.match(exports.mapFileCommentRegex);return m?exports.fromMapFileComment(m.pop(),dir):null;};exports.removeComments=function(src){return src.replace(exports.commentRegex,'');};exports.removeMapFileComments=function(src){return src.replace(exports.mapFileCommentRegex,'');};exports.generateMapFileComment=function(file,options){var data='sourceMappingURL='+file;return options&&options.multiline?'/*# '+data+' */':'//# '+data;};}.call(this));}.call(this,require('buffer').Buffer));},{'buffer':14,'fs':11,'path':92}],16:[function(require,module,exports){function isArray(arg){if(Array.isArray){return Array.isArray(arg);}return objectToString(arg)==='[object Array]';}exports.isArray=isArray;function isBoolean(arg){return typeof arg==='boolean';}exports.isBoolean=isBoolean;function isNull(arg){return arg===null;}exports.isNull=isNull;function isNullOrUndefined(arg){return arg==null;}exports.isNullOrUndefined=isNullOrUndefined;function isNumber(arg){return typeof arg==='number';}exports.isNumber=isNumber;function isString(arg){return typeof arg==='string';}exports.isString=isString;function isSymbol(arg){return typeof arg==='symbol';}exports.isSymbol=isSymbol;function isUndefined(arg){return arg===void 0;}exports.isUndefined=isUndefined;function isRegExp(re){return objectToString(re)==='[object RegExp]';}exports.isRegExp=isRegExp;function isObject(arg){return typeof arg==='object'&&arg!==null;}exports.isObject=isObject;function isDate(d){return objectToString(d)==='[object Date]';}exports.isDate=isDate;function isError(e){return objectToString(e)==='[object Error]'||e instanceof Error;}exports.isError=isError;function isFunction(arg){return typeof arg==='function';}exports.isFunction=isFunction;function isPrimitive(arg){return arg===null||typeof arg==='boolean'||typeof arg==='number'||typeof arg==='string'||typeof arg==='symbol'||typeof arg==='undefined';}exports.isPrimitive=isPrimitive;exports.isBuffer=require('buffer').Buffer.isBuffer;function objectToString(o){return Object.prototype.toString.call(o);}},{'buffer':14}],17:[function(require,module,exports){module.exports={'elementNames':{'altglyph':'altGlyph','altglyphdef':'altGlyphDef','altglyphitem':'altGlyphItem','animatecolor':'animateColor','animatemotion':'animateMotion','animatetransform':'animateTransform','clippath':'clipPath','feblend':'feBlend','fecolormatrix':'feColorMatrix','fecomponenttransfer':'feComponentTransfer','fecomposite':'feComposite','feconvolvematrix':'feConvolveMatrix','fediffuselighting':'feDiffuseLighting','fedisplacementmap':'feDisplacementMap','fedistantlight':'feDistantLight','fedropshadow':'feDropShadow','feflood':'feFlood','fefunca':'feFuncA','fefuncb':'feFuncB','fefuncg':'feFuncG','fefuncr':'feFuncR','fegaussianblur':'feGaussianBlur','feimage':'feImage','femerge':'feMerge','femergenode':'feMergeNode','femorphology':'feMorphology','feoffset':'feOffset','fepointlight':'fePointLight','fespecularlighting':'feSpecularLighting','fespotlight':'feSpotLight','fetile':'feTile','feturbulence':'feTurbulence','foreignobject':'foreignObject','glyphref':'glyphRef','lineargradient':'linearGradient','radialgradient':'radialGradient','textpath':'textPath'},'attributeNames':{'definitionurl':'definitionURL','attributename':'attributeName','attributetype':'attributeType','basefrequency':'baseFrequency','baseprofile':'baseProfile','calcmode':'calcMode','clippathunits':'clipPathUnits','diffuseconstant':'diffuseConstant','edgemode':'edgeMode','filterunits':'filterUnits','glyphref':'glyphRef','gradienttransform':'gradientTransform','gradientunits':'gradientUnits','kernelmatrix':'kernelMatrix','kernelunitlength':'kernelUnitLength','keypoints':'keyPoints','keysplines':'keySplines','keytimes':'keyTimes','lengthadjust':'lengthAdjust','limitingconeangle':'limitingConeAngle','markerheight':'markerHeight','markerunits':'markerUnits','markerwidth':'markerWidth','maskcontentunits':'maskContentUnits','maskunits':'maskUnits','numoctaves':'numOctaves','pathlength':'pathLength','patterncontentunits':'patternContentUnits','patterntransform':'patternTransform','patternunits':'patternUnits','pointsatx':'pointsAtX','pointsaty':'pointsAtY','pointsatz':'pointsAtZ','preservealpha':'preserveAlpha','preserveaspectratio':'preserveAspectRatio','primitiveunits':'primitiveUnits','refx':'refX','refy':'refY','repeatcount':'repeatCount','repeatdur':'repeatDur','requiredextensions':'requiredExtensions','requiredfeatures':'requiredFeatures','specularconstant':'specularConstant','specularexponent':'specularExponent','spreadmethod':'spreadMethod','startoffset':'startOffset','stddeviation':'stdDeviation','stitchtiles':'stitchTiles','surfacescale':'surfaceScale','systemlanguage':'systemLanguage','tablevalues':'tableValues','targetx':'targetX','targety':'targetY','textlength':'textLength','viewbox':'viewBox','viewtarget':'viewTarget','xchannelselector':'xChannelSelector','ychannelselector':'yChannelSelector','zoomandpan':'zoomAndPan'}};},{}],18:[function(require,module,exports){var ElementType=require('domelementtype');var entities=require('entities');var foreignNames=require('./foreignNames.json');foreignNames.elementNames.__proto__=null;foreignNames.attributeNames.__proto__=null;var unencodedElements={__proto__:null,style:true,script:true,xmp:true,iframe:true,noembed:true,noframes:true,plaintext:true,noscript:true};function formatAttrs(attributes,opts){if(!attributes)return;var output='';var value;for(var key in attributes){value=attributes[key];if(output){output+=' ';}if(opts.xmlMode==='foreign'){key=foreignNames.attributeNames[key]||key;}output+=key;if(value!==null&&value!==''||opts.xmlMode){output+='="'+(opts.decodeEntities?entities.encodeXML(value):value.replace(/\"/g,'&quot;'))+'"';}}return output;}var singleTag={__proto__:null,area:true,base:true,basefont:true,br:true,col:true,command:true,embed:true,frame:true,hr:true,img:true,input:true,isindex:true,keygen:true,link:true,meta:true,param:true,source:true,track:true,wbr:true};var render=module.exports=function(dom,opts){if(!Array.isArray(dom)&&!dom.cheerio)dom=[dom];opts=opts||{};var output='';for(var i=0;i<dom.length;i++){var elem=dom[i];if(elem.type==='root')output+=render(elem.children,opts);else if(ElementType.isTag(elem))output+=renderTag(elem,opts);else if(elem.type===ElementType.Directive)output+=renderDirective(elem);else if(elem.type===ElementType.Comment)output+=renderComment(elem);else if(elem.type===ElementType.CDATA)output+=renderCdata(elem);else output+=renderText(elem,opts);}return output;};var foreignModeIntegrationPoints=['mi','mo','mn','ms','mtext','annotation-xml','foreignObject','desc','title'];function renderTag(elem,opts){if(opts.xmlMode==='foreign'){elem.name=foreignNames.elementNames[elem.name]||elem.name;if(elem.parent&&foreignModeIntegrationPoints.indexOf(elem.parent.name)>=0)opts=Object.assign({},opts,{xmlMode:false});}if(!opts.xmlMode&&['svg','math'].indexOf(elem.name)>=0){opts=Object.assign({},opts,{xmlMode:'foreign'});}var tag='<'+elem.name;var attribs=formatAttrs(elem.attribs,opts);if(attribs){tag+=' '+attribs;}if(opts.xmlMode&&(!elem.children||elem.children.length===0)){tag+='/>';}else{tag+='>';if(elem.children){tag+=render(elem.children,opts);}if(!singleTag[elem.name]||opts.xmlMode){tag+='</'+elem.name+'>';}}return tag;}function renderDirective(elem){return'<'+elem.data+'>';}function renderText(elem,opts){var data=elem.data||'';if(opts.decodeEntities&&!(elem.parent&&elem.parent.name in unencodedElements)){data=entities.encodeXML(data);}return data;}function renderCdata(elem){return'<![CDATA['+elem.children[0].data+']]>';}function renderComment(elem){return'<!--'+elem.data+'-->';}},{'./foreignNames.json':17,'domelementtype':19,'entities':23}],19:[function(require,module,exports){'use strict';Object.defineProperty(exports,'__esModule',{value:true});exports.Doctype=exports.CDATA=exports.Tag=exports.Style=exports.Script=exports.Comment=exports.Directive=exports.Text=exports.Root=exports.isTag=exports.ElementType=void 0;var ElementType;(function(ElementType){ElementType['Root']='root';ElementType['Text']='text';ElementType['Directive']='directive';ElementType['Comment']='comment';ElementType['Script']='script';ElementType['Style']='style';ElementType['Tag']='tag';ElementType['CDATA']='cdata';ElementType['Doctype']='doctype';}(ElementType=exports.ElementType||(exports.ElementType={})));function isTag(elem){return elem.type===ElementType.Tag||elem.type===ElementType.Script||elem.type===ElementType.Style;}exports.isTag=isTag;exports.Root=ElementType.Root;exports.Text=ElementType.Text;exports.Directive=ElementType.Directive;exports.Comment=ElementType.Comment;exports.Script=ElementType.Script;exports.Style=ElementType.Style;exports.Tag=ElementType.Tag;exports.CDATA=ElementType.CDATA;exports.Doctype=ElementType.Doctype;},{}],20:[function(require,module,exports){'use strict';var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{'default':mod};};Object.defineProperty(exports,'__esModule',{value:true});exports.decodeHTML=exports.decodeHTMLStrict=exports.decodeXML=void 0;var entities_json_1=__importDefault(require('./maps/entities.json'));var legacy_json_1=__importDefault(require('./maps/legacy.json'));var xml_json_1=__importDefault(require('./maps/xml.json'));var decode_codepoint_1=__importDefault(require('./decode_codepoint'));var strictEntityRe=/&(?:[a-zA-Z0-9]+|#[xX][\da-fA-F]+|#\d+);/g;exports.decodeXML=getStrictDecoder(xml_json_1.default);exports.decodeHTMLStrict=getStrictDecoder(entities_json_1.default);function getStrictDecoder(map){var replace=getReplacer(map);return function(str){return String(str).replace(strictEntityRe,replace);};}var sorter=function(a,b){return a<b?1:-1;};exports.decodeHTML=function(){var legacy=Object.keys(legacy_json_1.default).sort(sorter);var keys=Object.keys(entities_json_1.default).sort(sorter);for(var i=0,j=0;i<keys.length;i++){if(legacy[j]===keys[i]){keys[i]+=';?';j++;}else{keys[i]+=';';}}var re=new RegExp('&(?:'+keys.join('|')+'|#[xX][\\da-fA-F]+;?|#\\d+;?)','g');var replace=getReplacer(entities_json_1.default);function replacer(str){if(str.substr(-1)!==';')str+=';';return replace(str);}return function(str){return String(str).replace(re,replacer);};}();function getReplacer(map){return function replace(str){if(str.charAt(1)==='#'){var secondChar=str.charAt(2);if(secondChar==='X'||secondChar==='x'){return decode_codepoint_1.default(parseInt(str.substr(3),16));}return decode_codepoint_1.default(parseInt(str.substr(2),10));}return map[str.slice(1,-1)]||str;};}},{'./decode_codepoint':21,'./maps/entities.json':25,'./maps/legacy.json':26,'./maps/xml.json':27}],21:[function(require,module,exports){'use strict';var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{'default':mod};};Object.defineProperty(exports,'__esModule',{value:true});var decode_json_1=__importDefault(require('./maps/decode.json'));var fromCodePoint=String.fromCodePoint||function(codePoint){var output='';if(codePoint>65535){codePoint-=65536;output+=String.fromCharCode(codePoint>>>10&1023|55296);codePoint=56320|codePoint&1023;}output+=String.fromCharCode(codePoint);return output;};function decodeCodePoint(codePoint){if(codePoint>=55296&&codePoint<=57343||codePoint>1114111){return'\uFFFD';}if(codePoint in decode_json_1.default){codePoint=decode_json_1.default[codePoint];}return fromCodePoint(codePoint);}exports.default=decodeCodePoint;},{'./maps/decode.json':24}],22:[function(require,module,exports){'use strict';var __importDefault=this&&this.__importDefault||function(mod){return mod&&mod.__esModule?mod:{'default':mod};};Object.defineProperty(exports,'__esModule',{value:true});exports.escapeUTF8=exports.escape=exports.encodeNonAsciiHTML=exports.encodeHTML=exports.encodeXML=void 0;var xml_json_1=__importDefault(require('./maps/xml.json'));var inverseXML=getInverseObj(xml_json_1.default);var xmlReplacer=getInverseReplacer(inverseXML);exports.encodeXML=getASCIIEncoder(inverseXML);var entities_json_1=__importDefault(require('./maps/entities.json'));var inverseHTML=getInverseObj(entities_json_1.default);var htmlReplacer=getInverseReplacer(inverseHTML);exports.encodeHTML=getInverse(inverseHTML,htmlReplacer);exports.encodeNonAsciiHTML=getASCIIEncoder(inverseHTML);function getInverseObj(obj){return Object.keys(obj).sort().reduce(function(inverse,name){inverse[obj[name]]='&'+name+';';return inverse;},{});}function getInverseReplacer(inverse){var single=[];var multiple=[];for(var _i=0,_a=Object.keys(inverse);_i<_a.length;_i++){var k=_a[_i];if(k.length===1){single.push('\\'+k);}else{multiple.push(k);}}single.sort();for(var start=0;start<single.length-1;start++){var end=start;while(end<single.length-1&&single[end].charCodeAt(1)+1===single[end+1].charCodeAt(1)){end+=1;}var count=1+end-start;if(count<3)continue;single.splice(start,count,single[start]+'-'+single[end]);}multiple.unshift('['+single.join('')+']');return new RegExp(multiple.join('|'),'g');}var reNonASCII=/(?:[\x80-\uD7FF\uE000-\uFFFF]|[\uD800-\uDBFF][\uDC00-\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/g;var getCodePoint=String.prototype.codePointAt!=null?function(str){return str.codePointAt(0);}:function(c){return(c.charCodeAt(0)-55296)*1024+c.charCodeAt(1)-56320+65536;};function singleCharReplacer(c){return'&#x'+(c.length>1?getCodePoint(c):c.charCodeAt(0)).toString(16).toUpperCase()+';';}function getInverse(inverse,re){return function(data){return data.replace(re,function(name){return inverse[name];}).replace(reNonASCII,singleCharReplacer);};}var reEscapeChars=new RegExp(xmlReplacer.source+'|'+reNonASCII.source,'g');function escape(data){return data.replace(reEscapeChars,singleCharReplacer);}exports.escape=escape;function escapeUTF8(data){return data.replace(xmlReplacer,singleCharReplacer);}exports.escapeUTF8=escapeUTF8;function getASCIIEncoder(obj){return function(data){return data.replace(reEscapeChars,function(c){return obj[c]||singleCharReplacer(c);});};}},{'./maps/entities.json':25,'./maps/xml.json':27}],23:[function(require,module,exports){'use strict';Object.defineProperty(exports,'__esModule',{value:true});exports.decodeXMLStrict=exports.decodeHTML5Strict=exports.decodeHTML4Strict=exports.decodeHTML5=exports.decodeHTML4=exports.decodeHTMLStrict=exports.decodeHTML=exports.decodeXML=exports.encodeHTML5=exports.encodeHTML4=exports.escapeUTF8=exports.escape=exports.encodeNonAsciiHTML=exports.encodeHTML=exports.encodeXML=exports.encode=exports.decodeStrict=exports.decode=void 0;var decode_1=require('./decode');var encode_1=require('./encode');function decode(data,level){return(!level||level<=0?decode_1.decodeXML:decode_1.decodeHTML)(data);}exports.decode=decode;function decodeStrict(data,level){return(!level||level<=0?decode_1.decodeXML:decode_1.decodeHTMLStrict)(data);}exports.decodeStrict=decodeStrict;function encode(data,level){return(!level||level<=0?encode_1.encodeXML:encode_1.encodeHTML)(data);}exports.encode=encode;var encode_2=require('./encode');Object.defineProperty(exports,'encodeXML',{enumerable:true,get:function(){return encode_2.encodeXML;}});Object.defineProperty(exports,'encodeHTML',{enumerable:true,get:function(){return encode_2.encodeHTML;}});Object.defineProperty(exports,'encodeNonAsciiHTML',{enumerable:true,get:function(){return encode_2.encodeNonAsciiHTML;}});Object.defineProperty(exports,'escape',{enumerable:true,get:function(){return encode_2.escape;}});Object.defineProperty(exports,'escapeUTF8',{enumerable:true,get:function(){return encode_2.escapeUTF8;}});Object.defineProperty(exports,'encodeHTML4',{enumerable:true,get:function(){return encode_2.encodeHTML;}});Object.defineProperty(exports,'encodeHTML5',{enumerable:true,get:function(){return encode_2.encodeHTML;}});var decode_2=require('./decode');Object.defineProperty(exports,'decodeXML',{enumerable:true,get:function(){return decode_2.decodeXML;}});Object.defineProperty(exports,'decodeHTML',{enumerable:true,get:function(){return decode_2.decodeHTML;}});Object.defineProperty(exports,'decodeHTMLStrict',{enumerable:true,get:function(){return decode_2.decodeHTMLStrict;}});Object.defineProperty(exports,'decodeHTML4',{enumerable:true,get:function(){return decode_2.decodeHTML;}});Object.defineProperty(exports,'decodeHTML5',{enumerable:true,get:function(){return decode_2.decodeHTML;}});Object.defineProperty(exports,'decodeHTML4Strict',{enumerable:true,get:function(){return decode_2.decodeHTMLStrict;}});Object.defineProperty(exports,'decodeHTML5Strict',{enumerable:true,get:function(){return decode_2.decodeHTMLStrict;}});Object.defineProperty(exports,'decodeXMLStrict',{enumerable:true,get:function(){return decode_2.decodeXML;}});},{'./decode':20,'./encode':22}],24:[function(require,module,exports){module.exports={'0':65533,'128':8364,'130':8218,'131':402,'132':8222,'133':8230,'134':8224,'135':8225,'136':710,'137':8240,'138':352,'139':8249,'140':338,'142':381,'145':8216,'146':8217,'147':8220,'148':8221,'149':8226,'150':8211,'151':8212,'152':732,'153':8482,'154':353,'155':8250,'156':339,'158':382,'159':376};},{}],25:[function(require,module,exports){module.exports={'Aacute':'Á','aacute':'á','Abreve':'Ă','abreve':'ă','ac':'\u223E','acd':'\u223F','acE':'\u223E̳','Acirc':'Â','acirc':'â','acute':'\xB4','Acy':'А','acy':'а','AElig':'Æ','aelig':'æ','af':'\u2061','Afr':'\uD835\uDD04','afr':'\uD835\uDD1E','Agrave':'À','agrave':'à','alefsym':'ℵ','aleph':'ℵ','Alpha':'Α','alpha':'α','Amacr':'Ā','amacr':'ā','amalg':'\u2A3F','amp':'&','AMP':'&','andand':'\u2A55','And':'\u2A53','and':'\u2227','andd':'\u2A5C','andslope':'\u2A58','andv':'\u2A5A','ang':'\u2220','ange':'\u29A4','angle':'\u2220','angmsdaa':'\u29A8','angmsdab':'\u29A9','angmsdac':'\u29AA','angmsdad':'\u29AB','angmsdae':'\u29AC','angmsdaf':'\u29AD','angmsdag':'\u29AE','angmsdah':'\u29AF','angmsd':'\u2221','angrt':'\u221F','angrtvb':'\u22BE','angrtvbd':'\u299D','angsph':'\u2222','angst':'Å','angzarr':'\u237C','Aogon':'Ą','aogon':'ą','Aopf':'\uD835\uDD38','aopf':'\uD835\uDD52','apacir':'\u2A6F','ap':'\u2248','apE':'\u2A70','ape':'\u224A','apid':'\u224B','apos':'\'','ApplyFunction':'\u2061','approx':'\u2248','approxeq':'\u224A','Aring':'Å','aring':'å','Ascr':'\uD835\uDC9C','ascr':'\uD835\uDCB6','Assign':'\u2254','ast':'*','asymp':'\u2248','asympeq':'\u224D','Atilde':'Ã','atilde':'ã','Auml':'Ä','auml':'ä','awconint':'\u2233','awint':'\u2A11','backcong':'\u224C','backepsilon':'\u03F6','backprime':'\u2035','backsim':'\u223D','backsimeq':'\u22CD','Backslash':'\u2216','Barv':'\u2AE7','barvee':'\u22BD','barwed':'\u2305','Barwed':'\u2306','barwedge':'\u2305','bbrk':'\u23B5','bbrktbrk':'\u23B6','bcong':'\u224C','Bcy':'Б','bcy':'б','bdquo':'\u201E','becaus':'\u2235','because':'\u2235','Because':'\u2235','bemptyv':'\u29B0','bepsi':'\u03F6','bernou':'ℬ','Bernoullis':'ℬ','Beta':'Β','beta':'β','beth':'ℶ','between':'\u226C','Bfr':'\uD835\uDD05','bfr':'\uD835\uDD1F','bigcap':'\u22C2','bigcirc':'\u25EF','bigcup':'\u22C3','bigodot':'\u2A00','bigoplus':'\u2A01','bigotimes':'\u2A02','bigsqcup':'\u2A06','bigstar':'\u2605','bigtriangledown':'\u25BD','bigtriangleup':'\u25B3','biguplus':'\u2A04','bigvee':'\u22C1','bigwedge':'\u22C0','bkarow':'\u290D','blacklozenge':'\u29EB','blacksquare':'\u25AA','blacktriangle':'\u25B4','blacktriangledown':'\u25BE','blacktriangleleft':'\u25C2','blacktriangleright':'\u25B8','blank':'\u2423','blk12':'\u2592','blk14':'\u2591','blk34':'\u2593','block':'\u2588','bne':'=⃥','bnequiv':'\u2261⃥','bNot':'\u2AED','bnot':'\u2310','Bopf':'\uD835\uDD39','bopf':'\uD835\uDD53','bot':'\u22A5','bottom':'\u22A5','bowtie':'\u22C8','boxbox':'\u29C9','boxdl':'\u2510','boxdL':'\u2555','boxDl':'\u2556','boxDL':'\u2557','boxdr':'\u250C','boxdR':'\u2552','boxDr':'\u2553','boxDR':'\u2554','boxh':'\u2500','boxH':'\u2550','boxhd':'\u252C','boxHd':'\u2564','boxhD':'\u2565','boxHD':'\u2566','boxhu':'\u2534','boxHu':'\u2567','boxhU':'\u2568','boxHU':'\u2569','boxminus':'\u229F','boxplus':'\u229E','boxtimes':'\u22A0','boxul':'\u2518','boxuL':'\u255B','boxUl':'\u255C','boxUL':'\u255D','boxur':'\u2514','boxuR':'\u2558','boxUr':'\u2559','boxUR':'\u255A','boxv':'\u2502','boxV':'\u2551','boxvh':'\u253C','boxvH':'\u256A','boxVh':'\u256B','boxVH':'\u256C','boxvl':'\u2524','boxvL':'\u2561','boxVl':'\u2562','boxVL':'\u2563','boxvr':'\u251C','boxvR':'\u255E','boxVr':'\u255F','boxVR':'\u2560','bprime':'\u2035','breve':'\u02D8','Breve':'\u02D8','brvbar':'\xA6','bscr':'\uD835\uDCB7','Bscr':'ℬ','bsemi':'\u204F','bsim':'\u223D','bsime':'\u22CD','bsolb':'\u29C5','bsol':'\\','bsolhsub':'\u27C8','bull':'\u2022','bullet':'\u2022','bump':'\u224E','bumpE':'\u2AAE','bumpe':'\u224F','Bumpeq':'\u224E','bumpeq':'\u224F','Cacute':'Ć','cacute':'ć','capand':'\u2A44','capbrcup':'\u2A49','capcap':'\u2A4B','cap':'\u2229','Cap':'\u22D2','capcup':'\u2A47','capdot':'\u2A40','CapitalDifferentialD':'ⅅ','caps':'\u2229︀','caret':'\u2041','caron':'ˇ','Cayleys':'ℭ','ccaps':'\u2A4D','Ccaron':'Č','ccaron':'č','Ccedil':'Ç','ccedil':'ç','Ccirc':'Ĉ','ccirc':'ĉ','Cconint':'\u2230','ccups':'\u2A4C','ccupssm':'\u2A50','Cdot':'Ċ','cdot':'ċ','cedil':'\xB8','Cedilla':'\xB8','cemptyv':'\u29B2','cent':'\xA2','centerdot':'\xB7','CenterDot':'\xB7','cfr':'\uD835\uDD20','Cfr':'ℭ','CHcy':'Ч','chcy':'ч','check':'\u2713','checkmark':'\u2713','Chi':'Χ','chi':'χ','circ':'ˆ','circeq':'\u2257','circlearrowleft':'\u21BA','circlearrowright':'\u21BB','circledast':'\u229B','circledcirc':'\u229A','circleddash':'\u229D','CircleDot':'\u2299','circledR':'\xAE','circledS':'\u24C8','CircleMinus':'\u2296','CirclePlus':'\u2295','CircleTimes':'\u2297','cir':'\u25CB','cirE':'\u29C3','cire':'\u2257','cirfnint':'\u2A10','cirmid':'\u2AEF','cirscir':'\u29C2','ClockwiseContourIntegral':'\u2232','CloseCurlyDoubleQuote':'\u201D','CloseCurlyQuote':'\u2019','clubs':'\u2663','clubsuit':'\u2663','colon':':','Colon':'\u2237','Colone':'\u2A74','colone':'\u2254','coloneq':'\u2254','comma':',','commat':'@','comp':'\u2201','compfn':'\u2218','complement':'\u2201','complexes':'ℂ','cong':'\u2245','congdot':'\u2A6D','Congruent':'\u2261','conint':'\u222E','Conint':'\u222F','ContourIntegral':'\u222E','copf':'\uD835\uDD54','Copf':'ℂ','coprod':'\u2210','Coproduct':'\u2210','copy':'\xA9','COPY':'\xA9','copysr':'\u2117','CounterClockwiseContourIntegral':'\u2233','crarr':'\u21B5','cross':'\u2717','Cross':'\u2A2F','Cscr':'\uD835\uDC9E','cscr':'\uD835\uDCB8','csub':'\u2ACF','csube':'\u2AD1','csup':'\u2AD0','csupe':'\u2AD2','ctdot':'\u22EF','cudarrl':'\u2938','cudarrr':'\u2935','cuepr':'\u22DE','cuesc':'\u22DF','cularr':'\u21B6','cularrp':'\u293D','cupbrcap':'\u2A48','cupcap':'\u2A46','CupCap':'\u224D','cup':'\u222A','Cup':'\u22D3','cupcup':'\u2A4A','cupdot':'\u228D','cupor':'\u2A45','cups':'\u222A︀','curarr':'\u21B7','curarrm':'\u293C','curlyeqprec':'\u22DE','curlyeqsucc':'\u22DF','curlyvee':'\u22CE','curlywedge':'\u22CF','curren':'\xA4','curvearrowleft':'\u21B6','curvearrowright':'\u21B7','cuvee':'\u22CE','cuwed':'\u22CF','cwconint':'\u2232','cwint':'\u2231','cylcty':'\u232D','dagger':'\u2020','Dagger':'\u2021','daleth':'ℸ','darr':'\u2193','Darr':'\u21A1','dArr':'\u21D3','dash':'\u2010','Dashv':'\u2AE4','dashv':'\u22A3','dbkarow':'\u290F','dblac':'\u02DD','Dcaron':'Ď','dcaron':'ď','Dcy':'Д','dcy':'д','ddagger':'\u2021','ddarr':'\u21CA','DD':'ⅅ','dd':'ⅆ','DDotrahd':'\u2911','ddotseq':'\u2A77','deg':'\xB0','Del':'\u2207','Delta':'Δ','delta':'δ','demptyv':'\u29B1','dfisht':'\u297F','Dfr':'\uD835\uDD07','dfr':'\uD835\uDD21','dHar':'\u2965','dharl':'\u21C3','dharr':'\u21C2','DiacriticalAcute':'\xB4','DiacriticalDot':'\u02D9','DiacriticalDoubleAcute':'\u02DD','DiacriticalGrave':'`','DiacriticalTilde':'\u02DC','diam':'\u22C4','diamond':'\u22C4','Diamond':'\u22C4','diamondsuit':'\u2666','diams':'\u2666','die':'\xA8','DifferentialD':'ⅆ','digamma':'ϝ','disin':'\u22F2','div':'\xF7','divide':'\xF7','divideontimes':'\u22C7','divonx':'\u22C7','DJcy':'Ђ','djcy':'ђ','dlcorn':'\u231E','dlcrop':'\u230D','dollar':'$','Dopf':'\uD835\uDD3B','dopf':'\uD835\uDD55','Dot':'\xA8','dot':'\u02D9','DotDot':'⃜','doteq':'\u2250','doteqdot':'\u2251','DotEqual':'\u2250','dotminus':'\u2238','dotplus':'\u2214','dotsquare':'\u22A1','doublebarwedge':'\u2306','DoubleContourIntegral':'\u222F','DoubleDot':'\xA8','DoubleDownArrow':'\u21D3','DoubleLeftArrow':'\u21D0','DoubleLeftRightArrow':'\u21D4','DoubleLeftTee':'\u2AE4','DoubleLongLeftArrow':'\u27F8','DoubleLongLeftRightArrow':'\u27FA','DoubleLongRightArrow':'\u27F9','DoubleRightArrow':'\u21D2','DoubleRightTee':'\u22A8','DoubleUpArrow':'\u21D1','DoubleUpDownArrow':'\u21D5','DoubleVerticalBar':'\u2225','DownArrowBar':'\u2913','downarrow':'\u2193','DownArrow':'\u2193','Downarrow':'\u21D3','DownArrowUpArrow':'\u21F5','DownBreve':'̑','downdownarrows':'\u21CA','downharpoonleft':'\u21C3','downharpoonright':'\u21C2','DownLeftRightVector':'\u2950','DownLeftTeeVector':'\u295E','DownLeftVectorBar':'\u2956','DownLeftVector':'\u21BD','DownRightTeeVector':'\u295F','DownRightVectorBar':'\u2957','DownRightVector':'\u21C1','DownTeeArrow':'\u21A7','DownTee':'\u22A4','drbkarow':'\u2910','drcorn':'\u231F','drcrop':'\u230C','Dscr':'\uD835\uDC9F','dscr':'\uD835\uDCB9','DScy':'Ѕ','dscy':'ѕ','dsol':'\u29F6','Dstrok':'Đ','dstrok':'đ','dtdot':'\u22F1','dtri':'\u25BF','dtrif':'\u25BE','duarr':'\u21F5','duhar':'\u296F','dwangle':'\u29A6','DZcy':'Џ','dzcy':'џ','dzigrarr':'\u27FF','Eacute':'É','eacute':'é','easter':'\u2A6E','Ecaron':'Ě','ecaron':'ě','Ecirc':'Ê','ecirc':'ê','ecir':'\u2256','ecolon':'\u2255','Ecy':'Э','ecy':'э','eDDot':'\u2A77','Edot':'Ė','edot':'ė','eDot':'\u2251','ee':'ⅇ','efDot':'\u2252','Efr':'\uD835\uDD08','efr':'\uD835\uDD22','eg':'\u2A9A','Egrave':'È','egrave':'è','egs':'\u2A96','egsdot':'\u2A98','el':'\u2A99','Element':'\u2208','elinters':'\u23E7','ell':'ℓ','els':'\u2A95','elsdot':'\u2A97','Emacr':'Ē','emacr':'ē','empty':'\u2205','emptyset':'\u2205','EmptySmallSquare':'\u25FB','emptyv':'\u2205','EmptyVerySmallSquare':'\u25AB','emsp13':'\u2004','emsp14':'\u2005','emsp':'\u2003','ENG':'Ŋ','eng':'ŋ','ensp':'\u2002','Eogon':'Ę','eogon':'ę','Eopf':'\uD835\uDD3C','eopf':'\uD835\uDD56','epar':'\u22D5','eparsl':'\u29E3','eplus':'\u2A71','epsi':'ε','Epsilon':'Ε','epsilon':'ε','epsiv':'ϵ','eqcirc':'\u2256','eqcolon':'\u2255','eqsim':'\u2242','eqslantgtr':'\u2A96','eqslantless':'\u2A95','Equal':'\u2A75','equals':'=','EqualTilde':'\u2242','equest':'\u225F','Equilibrium':'\u21CC','equiv':'\u2261','equivDD':'\u2A78','eqvparsl':'\u29E5','erarr':'\u2971','erDot':'\u2253','escr':'ℯ','Escr':'ℰ','esdot':'\u2250','Esim':'\u2A73','esim':'\u2242','Eta':'Η','eta':'η','ETH':'Ð','eth':'ð','Euml':'Ë','euml':'ë','euro':'\u20AC','excl':'!','exist':'\u2203','Exists':'\u2203','expectation':'ℰ','exponentiale':'ⅇ','ExponentialE':'ⅇ','fallingdotseq':'\u2252','Fcy':'Ф','fcy':'ф','female':'\u2640','ffilig':'ﬃ','fflig':'ﬀ','ffllig':'ﬄ','Ffr':'\uD835\uDD09','ffr':'\uD835\uDD23','filig':'ﬁ','FilledSmallSquare':'\u25FC','FilledVerySmallSquare':'\u25AA','fjlig':'fj','flat':'\u266D','fllig':'ﬂ','fltns':'\u25B1','fnof':'ƒ','Fopf':'\uD835\uDD3D','fopf':'\uD835\uDD57','forall':'\u2200','ForAll':'\u2200','fork':'\u22D4','forkv':'\u2AD9','Fouriertrf':'ℱ','fpartint':'\u2A0D','frac12':'\xBD','frac13':'\u2153','frac14':'\xBC','frac15':'\u2155','frac16':'\u2159','frac18':'\u215B','frac23':'\u2154','frac25':'\u2156','frac34':'\xBE','frac35':'\u2157','frac38':'\u215C','frac45':'\u2158','frac56':'\u215A','frac58':'\u215D','frac78':'\u215E','frasl':'\u2044','frown':'\u2322','fscr':'\uD835\uDCBB','Fscr':'ℱ','gacute':'ǵ','Gamma':'Γ','gamma':'γ','Gammad':'Ϝ','gammad':'ϝ','gap':'\u2A86','Gbreve':'Ğ','gbreve':'ğ','Gcedil':'Ģ','Gcirc':'Ĝ','gcirc':'ĝ','Gcy':'Г','gcy':'г','Gdot':'Ġ','gdot':'ġ','ge':'\u2265','gE':'\u2267','gEl':'\u2A8C','gel':'\u22DB','geq':'\u2265','geqq':'\u2267','geqslant':'\u2A7E','gescc':'\u2AA9','ges':'\u2A7E','gesdot':'\u2A80','gesdoto':'\u2A82','gesdotol':'\u2A84','gesl':'\u22DB︀','gesles':'\u2A94','Gfr':'\uD835\uDD0A','gfr':'\uD835\uDD24','gg':'\u226B','Gg':'\u22D9','ggg':'\u22D9','gimel':'ℷ','GJcy':'Ѓ','gjcy':'ѓ','gla':'\u2AA5','gl':'\u2277','glE':'\u2A92','glj':'\u2AA4','gnap':'\u2A8A','gnapprox':'\u2A8A','gne':'\u2A88','gnE':'\u2269','gneq':'\u2A88','gneqq':'\u2269','gnsim':'\u22E7','Gopf':'\uD835\uDD3E','gopf':'\uD835\uDD58','grave':'`','GreaterEqual':'\u2265','GreaterEqualLess':'\u22DB','GreaterFullEqual':'\u2267','GreaterGreater':'\u2AA2','GreaterLess':'\u2277','GreaterSlantEqual':'\u2A7E','GreaterTilde':'\u2273','Gscr':'\uD835\uDCA2','gscr':'ℊ','gsim':'\u2273','gsime':'\u2A8E','gsiml':'\u2A90','gtcc':'\u2AA7','gtcir':'\u2A7A','gt':'>','GT':'>','Gt':'\u226B','gtdot':'\u22D7','gtlPar':'\u2995','gtquest':'\u2A7C','gtrapprox':'\u2A86','gtrarr':'\u2978','gtrdot':'\u22D7','gtreqless':'\u22DB','gtreqqless':'\u2A8C','gtrless':'\u2277','gtrsim':'\u2273','gvertneqq':'\u2269︀','gvnE':'\u2269︀','Hacek':'ˇ','hairsp':'\u200A','half':'\xBD','hamilt':'ℋ','HARDcy':'Ъ','hardcy':'ъ','harrcir':'\u2948','harr':'\u2194','hArr':'\u21D4','harrw':'\u21AD','Hat':'^','hbar':'ℏ','Hcirc':'Ĥ','hcirc':'ĥ','hearts':'\u2665','heartsuit':'\u2665','hellip':'\u2026','hercon':'\u22B9','hfr':'\uD835\uDD25','Hfr':'ℌ','HilbertSpace':'ℋ','hksearow':'\u2925','hkswarow':'\u2926','hoarr':'\u21FF','homtht':'\u223B','hookleftarrow':'\u21A9','hookrightarrow':'\u21AA','hopf':'\uD835\uDD59','Hopf':'ℍ','horbar':'\u2015','HorizontalLine':'\u2500','hscr':'\uD835\uDCBD','Hscr':'ℋ','hslash':'ℏ','Hstrok':'Ħ','hstrok':'ħ','HumpDownHump':'\u224E','HumpEqual':'\u224F','hybull':'\u2043','hyphen':'\u2010','Iacute':'Í','iacute':'í','ic':'\u2063','Icirc':'Î','icirc':'î','Icy':'И','icy':'и','Idot':'İ','IEcy':'Е','iecy':'е','iexcl':'\xA1','iff':'\u21D4','ifr':'\uD835\uDD26','Ifr':'ℑ','Igrave':'Ì','igrave':'ì','ii':'ⅈ','iiiint':'\u2A0C','iiint':'\u222D','iinfin':'\u29DC','iiota':'\u2129','IJlig':'Ĳ','ijlig':'ĳ','Imacr':'Ī','imacr':'ī','image':'ℑ','ImaginaryI':'ⅈ','imagline':'ℐ','imagpart':'ℑ','imath':'ı','Im':'ℑ','imof':'\u22B7','imped':'Ƶ','Implies':'\u21D2','incare':'\u2105','in':'\u2208','infin':'\u221E','infintie':'\u29DD','inodot':'ı','intcal':'\u22BA','int':'\u222B','Int':'\u222C','integers':'ℤ','Integral':'\u222B','intercal':'\u22BA','Intersection':'\u22C2','intlarhk':'\u2A17','intprod':'\u2A3C','InvisibleComma':'\u2063','InvisibleTimes':'\u2062','IOcy':'Ё','iocy':'ё','Iogon':'Į','iogon':'į','Iopf':'\uD835\uDD40','iopf':'\uD835\uDD5A','Iota':'Ι','iota':'ι','iprod':'\u2A3C','iquest':'\xBF','iscr':'\uD835\uDCBE','Iscr':'ℐ','isin':'\u2208','isindot':'\u22F5','isinE':'\u22F9','isins':'\u22F4','isinsv':'\u22F3','isinv':'\u2208','it':'\u2062','Itilde':'Ĩ','itilde':'ĩ','Iukcy':'І','iukcy':'і','Iuml':'Ï','iuml':'ï','Jcirc':'Ĵ','jcirc':'ĵ','Jcy':'Й','jcy':'й','Jfr':'\uD835\uDD0D','jfr':'\uD835\uDD27','jmath':'ȷ','Jopf':'\uD835\uDD41','jopf':'\uD835\uDD5B','Jscr':'\uD835\uDCA5','jscr':'\uD835\uDCBF','Jsercy':'Ј','jsercy':'ј','Jukcy':'Є','jukcy':'є','Kappa':'Κ','kappa':'κ','kappav':'ϰ','Kcedil':'Ķ','kcedil':'ķ','Kcy':'К','kcy':'к','Kfr':'\uD835\uDD0E','kfr':'\uD835\uDD28','kgreen':'ĸ','KHcy':'Х','khcy':'х','KJcy':'Ќ','kjcy':'ќ','Kopf':'\uD835\uDD42','kopf':'\uD835\uDD5C','Kscr':'\uD835\uDCA6','kscr':'\uD835\uDCC0','lAarr':'\u21DA','Lacute':'Ĺ','lacute':'ĺ','laemptyv':'\u29B4','lagran':'ℒ','Lambda':'Λ','lambda':'λ','lang':'\u27E8','Lang':'\u27EA','langd':'\u2991','langle':'\u27E8','lap':'\u2A85','Laplacetrf':'ℒ','laquo':'\xAB','larrb':'\u21E4','larrbfs':'\u291F','larr':'\u2190','Larr':'\u219E','lArr':'\u21D0','larrfs':'\u291D','larrhk':'\u21A9','larrlp':'\u21AB','larrpl':'\u2939','larrsim':'\u2973','larrtl':'\u21A2','latail':'\u2919','lAtail':'\u291B','lat':'\u2AAB','late':'\u2AAD','lates':'\u2AAD︀','lbarr':'\u290C','lBarr':'\u290E','lbbrk':'\u2772','lbrace':'{','lbrack':'[','lbrke':'\u298B','lbrksld':'\u298F','lbrkslu':'\u298D','Lcaron':'Ľ','lcaron':'ľ','Lcedil':'Ļ','lcedil':'ļ','lceil':'\u2308','lcub':'{','Lcy':'Л','lcy':'л','ldca':'\u2936','ldquo':'\u201C','ldquor':'\u201E','ldrdhar':'\u2967','ldrushar':'\u294B','ldsh':'\u21B2','le':'\u2264','lE':'\u2266','LeftAngleBracket':'\u27E8','LeftArrowBar':'\u21E4','leftarrow':'\u2190','LeftArrow':'\u2190','Leftarrow':'\u21D0','LeftArrowRightArrow':'\u21C6','leftarrowtail':'\u21A2','LeftCeiling':'\u2308','LeftDoubleBracket':'\u27E6','LeftDownTeeVector':'\u2961','LeftDownVectorBar':'\u2959','LeftDownVector':'\u21C3','LeftFloor':'\u230A','leftharpoondown':'\u21BD','leftharpoonup':'\u21BC','leftleftarrows':'\u21C7','leftrightarrow':'\u2194','LeftRightArrow':'\u2194','Leftrightarrow':'\u21D4','leftrightarrows':'\u21C6','leftrightharpoons':'\u21CB','leftrightsquigarrow':'\u21AD','LeftRightVector':'\u294E','LeftTeeArrow':'\u21A4','LeftTee':'\u22A3','LeftTeeVector':'\u295A','leftthreetimes':'\u22CB','LeftTriangleBar':'\u29CF','LeftTriangle':'\u22B2','LeftTriangleEqual':'\u22B4','LeftUpDownVector':'\u2951','LeftUpTeeVector':'\u2960','LeftUpVectorBar':'\u2958','LeftUpVector':'\u21BF','LeftVectorBar':'\u2952','LeftVector':'\u21BC','lEg':'\u2A8B','leg':'\u22DA','leq':'\u2264','leqq':'\u2266','leqslant':'\u2A7D','lescc':'\u2AA8','les':'\u2A7D','lesdot':'\u2A7F','lesdoto':'\u2A81','lesdotor':'\u2A83','lesg':'\u22DA︀','lesges':'\u2A93','lessapprox':'\u2A85','lessdot':'\u22D6','lesseqgtr':'\u22DA','lesseqqgtr':'\u2A8B','LessEqualGreater':'\u22DA','LessFullEqual':'\u2266','LessGreater':'\u2276','lessgtr':'\u2276','LessLess':'\u2AA1','lesssim':'\u2272','LessSlantEqual':'\u2A7D','LessTilde':'\u2272','lfisht':'\u297C','lfloor':'\u230A','Lfr':'\uD835\uDD0F','lfr':'\uD835\uDD29','lg':'\u2276','lgE':'\u2A91','lHar':'\u2962','lhard':'\u21BD','lharu':'\u21BC','lharul':'\u296A','lhblk':'\u2584','LJcy':'Љ','ljcy':'љ','llarr':'\u21C7','ll':'\u226A','Ll':'\u22D8','llcorner':'\u231E','Lleftarrow':'\u21DA','llhard':'\u296B','lltri':'\u25FA','Lmidot':'Ŀ','lmidot':'ŀ','lmoustache':'\u23B0','lmoust':'\u23B0','lnap':'\u2A89','lnapprox':'\u2A89','lne':'\u2A87','lnE':'\u2268','lneq':'\u2A87','lneqq':'\u2268','lnsim':'\u22E6','loang':'\u27EC','loarr':'\u21FD','lobrk':'\u27E6','longleftarrow':'\u27F5','LongLeftArrow':'\u27F5','Longleftarrow':'\u27F8','longleftrightarrow':'\u27F7','LongLeftRightArrow':'\u27F7','Longleftrightarrow':'\u27FA','longmapsto':'\u27FC','longrightarrow':'\u27F6','LongRightArrow':'\u27F6','Longrightarrow':'\u27F9','looparrowleft':'\u21AB','looparrowright':'\u21AC','lopar':'\u2985','Lopf':'\uD835\uDD43','lopf':'\uD835\uDD5D','loplus':'\u2A2D','lotimes':'\u2A34','lowast':'\u2217','lowbar':'_','LowerLeftArrow':'\u2199','LowerRightArrow':'\u2198','loz':'\u25CA','lozenge':'\u25CA','lozf':'\u29EB','lpar':'(','lparlt':'\u2993','lrarr':'\u21C6','lrcorner':'\u231F','lrhar':'\u21CB','lrhard':'\u296D','lrm':'\u200E','lrtri':'\u22BF','lsaquo':'\u2039','lscr':'\uD835\uDCC1','Lscr':'ℒ','lsh':'\u21B0','Lsh':'\u21B0','lsim':'\u2272','lsime':'\u2A8D','lsimg':'\u2A8F','lsqb':'[','lsquo':'\u2018','lsquor':'\u201A','Lstrok':'Ł','lstrok':'ł','ltcc':'\u2AA6','ltcir':'\u2A79','lt':'<','LT':'<','Lt':'\u226A','ltdot':'\u22D6','lthree':'\u22CB','ltimes':'\u22C9','ltlarr':'\u2976','ltquest':'\u2A7B','ltri':'\u25C3','ltrie':'\u22B4','ltrif':'\u25C2','ltrPar':'\u2996','lurdshar':'\u294A','luruhar':'\u2966','lvertneqq':'\u2268︀','lvnE':'\u2268︀','macr':'\xAF','male':'\u2642','malt':'\u2720','maltese':'\u2720','Map':'\u2905','map':'\u21A6','mapsto':'\u21A6','mapstodown':'\u21A7','mapstoleft':'\u21A4','mapstoup':'\u21A5','marker':'\u25AE','mcomma':'\u2A29','Mcy':'М','mcy':'м','mdash':'\u2014','mDDot':'\u223A','measuredangle':'\u2221','MediumSpace':'\u205F','Mellintrf':'ℳ','Mfr':'\uD835\uDD10','mfr':'\uD835\uDD2A','mho':'\u2127','micro':'µ','midast':'*','midcir':'\u2AF0','mid':'\u2223','middot':'\xB7','minusb':'\u229F','minus':'\u2212','minusd':'\u2238','minusdu':'\u2A2A','MinusPlus':'\u2213','mlcp':'\u2ADB','mldr':'\u2026','mnplus':'\u2213','models':'\u22A7','Mopf':'\uD835\uDD44','mopf':'\uD835\uDD5E','mp':'\u2213','mscr':'\uD835\uDCC2','Mscr':'ℳ','mstpos':'\u223E','Mu':'Μ','mu':'μ','multimap':'\u22B8','mumap':'\u22B8','nabla':'\u2207','Nacute':'Ń','nacute':'ń','nang':'\u2220⃒','nap':'\u2249','napE':'\u2A70̸','napid':'\u224B̸','napos':'ŉ','napprox':'\u2249','natural':'\u266E','naturals':'ℕ','natur':'\u266E','nbsp':'\xA0','nbump':'\u224E̸','nbumpe':'\u224F̸','ncap':'\u2A43','Ncaron':'Ň','ncaron':'ň','Ncedil':'Ņ','ncedil':'ņ','ncong':'\u2247','ncongdot':'\u2A6D̸','ncup':'\u2A42','Ncy':'Н','ncy':'н','ndash':'\u2013','nearhk':'\u2924','nearr':'\u2197','neArr':'\u21D7','nearrow':'\u2197','ne':'\u2260','nedot':'\u2250̸','NegativeMediumSpace':'\u200B','NegativeThickSpace':'\u200B','NegativeThinSpace':'\u200B','NegativeVeryThinSpace':'\u200B','nequiv':'\u2262','nesear':'\u2928','nesim':'\u2242̸','NestedGreaterGreater':'\u226B','NestedLessLess':'\u226A','NewLine':'\n','nexist':'\u2204','nexists':'\u2204','Nfr':'\uD835\uDD11','nfr':'\uD835\uDD2B','ngE':'\u2267̸','nge':'\u2271','ngeq':'\u2271','ngeqq':'\u2267̸','ngeqslant':'\u2A7E̸','nges':'\u2A7E̸','nGg':'\u22D9̸','ngsim':'\u2275','nGt':'\u226B⃒','ngt':'\u226F','ngtr':'\u226F','nGtv':'\u226B̸','nharr':'\u21AE','nhArr':'\u21CE','nhpar':'\u2AF2','ni':'\u220B','nis':'\u22FC','nisd':'\u22FA','niv':'\u220B','NJcy':'Њ','njcy':'њ','nlarr':'\u219A','nlArr':'\u21CD','nldr':'\u2025','nlE':'\u2266̸','nle':'\u2270','nleftarrow':'\u219A','nLeftarrow':'\u21CD','nleftrightarrow':'\u21AE','nLeftrightarrow':'\u21CE','nleq':'\u2270','nleqq':'\u2266̸','nleqslant':'\u2A7D̸','nles':'\u2A7D̸','nless':'\u226E','nLl':'\u22D8̸','nlsim':'\u2274','nLt':'\u226A⃒','nlt':'\u226E','nltri':'\u22EA','nltrie':'\u22EC','nLtv':'\u226A̸','nmid':'\u2224','NoBreak':'\u2060','NonBreakingSpace':'\xA0','nopf':'\uD835\uDD5F','Nopf':'ℕ','Not':'\u2AEC','not':'\xAC','NotCongruent':'\u2262','NotCupCap':'\u226D','NotDoubleVerticalBar':'\u2226','NotElement':'\u2209','NotEqual':'\u2260','NotEqualTilde':'\u2242̸','NotExists':'\u2204','NotGreater':'\u226F','NotGreaterEqual':'\u2271','NotGreaterFullEqual':'\u2267̸','NotGreaterGreater':'\u226B̸','NotGreaterLess':'\u2279','NotGreaterSlantEqual':'\u2A7E̸','NotGreaterTilde':'\u2275','NotHumpDownHump':'\u224E̸','NotHumpEqual':'\u224F̸','notin':'\u2209','notindot':'\u22F5̸','notinE':'\u22F9̸','notinva':'\u2209','notinvb':'\u22F7','notinvc':'\u22F6','NotLeftTriangleBar':'\u29CF̸','NotLeftTriangle':'\u22EA','NotLeftTriangleEqual':'\u22EC','NotLess':'\u226E','NotLessEqual':'\u2270','NotLessGreater':'\u2278','NotLessLess':'\u226A̸','NotLessSlantEqual':'\u2A7D̸','NotLessTilde':'\u2274','NotNestedGreaterGreater':'\u2AA2̸','NotNestedLessLess':'\u2AA1̸','notni':'\u220C','notniva':'\u220C','notnivb':'\u22FE','notnivc':'\u22FD','NotPrecedes':'\u2280','NotPrecedesEqual':'\u2AAF̸','NotPrecedesSlantEqual':'\u22E0','NotReverseElement':'\u220C','NotRightTriangleBar':'\u29D0̸','NotRightTriangle':'\u22EB','NotRightTriangleEqual':'\u22ED','NotSquareSubset':'\u228F̸','NotSquareSubsetEqual':'\u22E2','NotSquareSuperset':'\u2290̸','NotSquareSupersetEqual':'\u22E3','NotSubset':'\u2282⃒','NotSubsetEqual':'\u2288','NotSucceeds':'\u2281','NotSucceedsEqual':'\u2AB0̸','NotSucceedsSlantEqual':'\u22E1','NotSucceedsTilde':'\u227F̸','NotSuperset':'\u2283⃒','NotSupersetEqual':'\u2289','NotTilde':'\u2241','NotTildeEqual':'\u2244','NotTildeFullEqual':'\u2247','NotTildeTilde':'\u2249','NotVerticalBar':'\u2224','nparallel':'\u2226','npar':'\u2226','nparsl':'\u2AFD⃥','npart':'\u2202̸','npolint':'\u2A14','npr':'\u2280','nprcue':'\u22E0','nprec':'\u2280','npreceq':'\u2AAF̸','npre':'\u2AAF̸','nrarrc':'\u2933̸','nrarr':'\u219B','nrArr':'\u21CF','nrarrw':'\u219D̸','nrightarrow':'\u219B','nRightarrow':'\u21CF','nrtri':'\u22EB','nrtrie':'\u22ED','nsc':'\u2281','nsccue':'\u22E1','nsce':'\u2AB0̸','Nscr':'\uD835\uDCA9','nscr':'\uD835\uDCC3','nshortmid':'\u2224','nshortparallel':'\u2226','nsim':'\u2241','nsime':'\u2244','nsimeq':'\u2244','nsmid':'\u2224','nspar':'\u2226','nsqsube':'\u22E2','nsqsupe':'\u22E3','nsub':'\u2284','nsubE':'\u2AC5̸','nsube':'\u2288','nsubset':'\u2282⃒','nsubseteq':'\u2288','nsubseteqq':'\u2AC5̸','nsucc':'\u2281','nsucceq':'\u2AB0̸','nsup':'\u2285','nsupE':'\u2AC6̸','nsupe':'\u2289','nsupset':'\u2283⃒','nsupseteq':'\u2289','nsupseteqq':'\u2AC6̸','ntgl':'\u2279','Ntilde':'Ñ','ntilde':'ñ','ntlg':'\u2278','ntriangleleft':'\u22EA','ntrianglelefteq':'\u22EC','ntriangleright':'\u22EB','ntrianglerighteq':'\u22ED','Nu':'Ν','nu':'ν','num':'#','numero':'\u2116','numsp':'\u2007','nvap':'\u224D⃒','nvdash':'\u22AC','nvDash':'\u22AD','nVdash':'\u22AE','nVDash':'\u22AF','nvge':'\u2265⃒','nvgt':'>⃒','nvHarr':'\u2904','nvinfin':'\u29DE','nvlArr':'\u2902','nvle':'\u2264⃒','nvlt':'<⃒','nvltrie':'\u22B4⃒','nvrArr':'\u2903','nvrtrie':'\u22B5⃒','nvsim':'\u223C⃒','nwarhk':'\u2923','nwarr':'\u2196','nwArr':'\u21D6','nwarrow':'\u2196','nwnear':'\u2927','Oacute':'Ó','oacute':'ó','oast':'\u229B','Ocirc':'Ô','ocirc':'ô','ocir':'\u229A','Ocy':'О','ocy':'о','odash':'\u229D','Odblac':'Ő','odblac':'ő','odiv':'\u2A38','odot':'\u2299','odsold':'\u29BC','OElig':'Œ','oelig':'œ','ofcir':'\u29BF','Ofr':'\uD835\uDD12','ofr':'\uD835\uDD2C','ogon':'\u02DB','Ograve':'Ò','ograve':'ò','ogt':'\u29C1','ohbar':'\u29B5','ohm':'Ω','oint':'\u222E','olarr':'\u21BA','olcir':'\u29BE','olcross':'\u29BB','oline':'\u203E','olt':'\u29C0','Omacr':'Ō','omacr':'ō','Omega':'Ω','omega':'ω','Omicron':'Ο','omicron':'ο','omid':'\u29B6','ominus':'\u2296','Oopf':'\uD835\uDD46','oopf':'\uD835\uDD60','opar':'\u29B7','OpenCurlyDoubleQuote':'\u201C','OpenCurlyQuote':'\u2018','operp':'\u29B9','oplus':'\u2295','orarr':'\u21BB','Or':'\u2A54','or':'\u2228','ord':'\u2A5D','order':'ℴ','orderof':'ℴ','ordf':'ª','ordm':'º','origof':'\u22B6','oror':'\u2A56','orslope':'\u2A57','orv':'\u2A5B','oS':'\u24C8','Oscr':'\uD835\uDCAA','oscr':'ℴ','Oslash':'Ø','oslash':'ø','osol':'\u2298','Otilde':'Õ','otilde':'õ','otimesas':'\u2A36','Otimes':'\u2A37','otimes':'\u2297','Ouml':'Ö','ouml':'ö','ovbar':'\u233D','OverBar':'\u203E','OverBrace':'\u23DE','OverBracket':'\u23B4','OverParenthesis':'\u23DC','para':'\xB6','parallel':'\u2225','par':'\u2225','parsim':'\u2AF3','parsl':'\u2AFD','part':'\u2202','PartialD':'\u2202','Pcy':'П','pcy':'п','percnt':'%','period':'.','permil':'\u2030','perp':'\u22A5','pertenk':'\u2031','Pfr':'\uD835\uDD13','pfr':'\uD835\uDD2D','Phi':'Φ','phi':'φ','phiv':'ϕ','phmmat':'ℳ','phone':'\u260E','Pi':'Π','pi':'π','pitchfork':'\u22D4','piv':'ϖ','planck':'ℏ','planckh':'ℎ','plankv':'ℏ','plusacir':'\u2A23','plusb':'\u229E','pluscir':'\u2A22','plus':'+','plusdo':'\u2214','plusdu':'\u2A25','pluse':'\u2A72','PlusMinus':'\xB1','plusmn':'\xB1','plussim':'\u2A26','plustwo':'\u2A27','pm':'\xB1','Poincareplane':'ℌ','pointint':'\u2A15','popf':'\uD835\uDD61','Popf':'ℙ','pound':'\xA3','prap':'\u2AB7','Pr':'\u2ABB','pr':'\u227A','prcue':'\u227C','precapprox':'\u2AB7','prec':'\u227A','preccurlyeq':'\u227C','Precedes':'\u227A','PrecedesEqual':'\u2AAF','PrecedesSlantEqual':'\u227C','PrecedesTilde':'\u227E','preceq':'\u2AAF','precnapprox':'\u2AB9','precneqq':'\u2AB5','precnsim':'\u22E8','pre':'\u2AAF','prE':'\u2AB3','precsim':'\u227E','prime':'\u2032','Prime':'\u2033','primes':'ℙ','prnap':'\u2AB9','prnE':'\u2AB5','prnsim':'\u22E8','prod':'\u220F','Product':'\u220F','profalar':'\u232E','profline':'\u2312','profsurf':'\u2313','prop':'\u221D','Proportional':'\u221D','Proportion':'\u2237','propto':'\u221D','prsim':'\u227E','prurel':'\u22B0','Pscr':'\uD835\uDCAB','pscr':'\uD835\uDCC5','Psi':'Ψ','psi':'ψ','puncsp':'\u2008','Qfr':'\uD835\uDD14','qfr':'\uD835\uDD2E','qint':'\u2A0C','qopf':'\uD835\uDD62','Qopf':'ℚ','qprime':'\u2057','Qscr':'\uD835\uDCAC','qscr':'\uD835\uDCC6','quaternions':'ℍ','quatint':'\u2A16','quest':'?','questeq':'\u225F','quot':'"','QUOT':'"','rAarr':'\u21DB','race':'\u223Ḏ','Racute':'Ŕ','racute':'ŕ','radic':'\u221A','raemptyv':'\u29B3','rang':'\u27E9','Rang':'\u27EB','rangd':'\u2992','range':'\u29A5','rangle':'\u27E9','raquo':'\xBB','rarrap':'\u2975','rarrb':'\u21E5','rarrbfs':'\u2920','rarrc':'\u2933','rarr':'\u2192','Rarr':'\u21A0','rArr':'\u21D2','rarrfs':'\u291E','rarrhk':'\u21AA','rarrlp':'\u21AC','rarrpl':'\u2945','rarrsim':'\u2974','Rarrtl':'\u2916','rarrtl':'\u21A3','rarrw':'\u219D','ratail':'\u291A','rAtail':'\u291C','ratio':'\u2236','rationals':'ℚ','rbarr':'\u290D','rBarr':'\u290F','RBarr':'\u2910','rbbrk':'\u2773','rbrace':'}','rbrack':']','rbrke':'\u298C','rbrksld':'\u298E','rbrkslu':'\u2990','Rcaron':'Ř','rcaron':'ř','Rcedil':'Ŗ','rcedil':'ŗ','rceil':'\u2309','rcub':'}','Rcy':'Р','rcy':'р','rdca':'\u2937','rdldhar':'\u2969','rdquo':'\u201D','rdquor':'\u201D','rdsh':'\u21B3','real':'ℜ','realine':'ℛ','realpart':'ℜ','reals':'ℝ','Re':'ℜ','rect':'\u25AD','reg':'\xAE','REG':'\xAE','ReverseElement':'\u220B','ReverseEquilibrium':'\u21CB','ReverseUpEquilibrium':'\u296F','rfisht':'\u297D','rfloor':'\u230B','rfr':'\uD835\uDD2F','Rfr':'ℜ','rHar':'\u2964','rhard':'\u21C1','rharu':'\u21C0','rharul':'\u296C','Rho':'Ρ','rho':'ρ','rhov':'ϱ','RightAngleBracket':'\u27E9','RightArrowBar':'\u21E5','rightarrow':'\u2192','RightArrow':'\u2192','Rightarrow':'\u21D2','RightArrowLeftArrow':'\u21C4','rightarrowtail':'\u21A3','RightCeiling':'\u2309','RightDoubleBracket':'\u27E7','RightDownTeeVector':'\u295D','RightDownVectorBar':'\u2955','RightDownVector':'\u21C2','RightFloor':'\u230B','rightharpoondown':'\u21C1','rightharpoonup':'\u21C0','rightleftarrows':'\u21C4','rightleftharpoons':'\u21CC','rightrightarrows':'\u21C9','rightsquigarrow':'\u219D','RightTeeArrow':'\u21A6','RightTee':'\u22A2','RightTeeVector':'\u295B','rightthreetimes':'\u22CC','RightTriangleBar':'\u29D0','RightTriangle':'\u22B3','RightTriangleEqual':'\u22B5','RightUpDownVector':'\u294F','RightUpTeeVector':'\u295C','RightUpVectorBar':'\u2954','RightUpVector':'\u21BE','RightVectorBar':'\u2953','RightVector':'\u21C0','ring':'\u02DA','risingdotseq':'\u2253','rlarr':'\u21C4','rlhar':'\u21CC','rlm':'\u200F','rmoustache':'\u23B1','rmoust':'\u23B1','rnmid':'\u2AEE','roang':'\u27ED','roarr':'\u21FE','robrk':'\u27E7','ropar':'\u2986','ropf':'\uD835\uDD63','Ropf':'ℝ','roplus':'\u2A2E','rotimes':'\u2A35','RoundImplies':'\u2970','rpar':')','rpargt':'\u2994','rppolint':'\u2A12','rrarr':'\u21C9','Rrightarrow':'\u21DB','rsaquo':'\u203A','rscr':'\uD835\uDCC7','Rscr':'ℛ','rsh':'\u21B1','Rsh':'\u21B1','rsqb':']','rsquo':'\u2019','rsquor':'\u2019','rthree':'\u22CC','rtimes':'\u22CA','rtri':'\u25B9','rtrie':'\u22B5','rtrif':'\u25B8','rtriltri':'\u29CE','RuleDelayed':'\u29F4','ruluhar':'\u2968','rx':'\u211E','Sacute':'Ś','sacute':'ś','sbquo':'\u201A','scap':'\u2AB8','Scaron':'Š','scaron':'š','Sc':'\u2ABC','sc':'\u227B','sccue':'\u227D','sce':'\u2AB0','scE':'\u2AB4','Scedil':'Ş','scedil':'ş','Scirc':'Ŝ','scirc':'ŝ','scnap':'\u2ABA','scnE':'\u2AB6','scnsim':'\u22E9','scpolint':'\u2A13','scsim':'\u227F','Scy':'С','scy':'с','sdotb':'\u22A1','sdot':'\u22C5','sdote':'\u2A66','searhk':'\u2925','searr':'\u2198','seArr':'\u21D8','searrow':'\u2198','sect':'\xA7','semi':';','seswar':'\u2929','setminus':'\u2216','setmn':'\u2216','sext':'\u2736','Sfr':'\uD835\uDD16','sfr':'\uD835\uDD30','sfrown':'\u2322','sharp':'\u266F','SHCHcy':'Щ','shchcy':'щ','SHcy':'Ш','shcy':'ш','ShortDownArrow':'\u2193','ShortLeftArrow':'\u2190','shortmid':'\u2223','shortparallel':'\u2225','ShortRightArrow':'\u2192','ShortUpArrow':'\u2191','shy':'\xAD','Sigma':'Σ','sigma':'σ','sigmaf':'ς','sigmav':'ς','sim':'\u223C','simdot':'\u2A6A','sime':'\u2243','simeq':'\u2243','simg':'\u2A9E','simgE':'\u2AA0','siml':'\u2A9D','simlE':'\u2A9F','simne':'\u2246','simplus':'\u2A24','simrarr':'\u2972','slarr':'\u2190','SmallCircle':'\u2218','smallsetminus':'\u2216','smashp':'\u2A33','smeparsl':'\u29E4','smid':'\u2223','smile':'\u2323','smt':'\u2AAA','smte':'\u2AAC','smtes':'\u2AAC︀','SOFTcy':'Ь','softcy':'ь','solbar':'\u233F','solb':'\u29C4','sol':'/','Sopf':'\uD835\uDD4A','sopf':'\uD835\uDD64','spades':'\u2660','spadesuit':'\u2660','spar':'\u2225','sqcap':'\u2293','sqcaps':'\u2293︀','sqcup':'\u2294','sqcups':'\u2294︀','Sqrt':'\u221A','sqsub':'\u228F','sqsube':'\u2291','sqsubset':'\u228F','sqsubseteq':'\u2291','sqsup':'\u2290','sqsupe':'\u2292','sqsupset':'\u2290','sqsupseteq':'\u2292','square':'\u25A1','Square':'\u25A1','SquareIntersection':'\u2293','SquareSubset':'\u228F','SquareSubsetEqual':'\u2291','SquareSuperset':'\u2290','SquareSupersetEqual':'\u2292','SquareUnion':'\u2294','squarf':'\u25AA','squ':'\u25A1','squf':'\u25AA','srarr':'\u2192','Sscr':'\uD835\uDCAE','sscr':'\uD835\uDCC8','ssetmn':'\u2216','ssmile':'\u2323','sstarf':'\u22C6','Star':'\u22C6','star':'\u2606','starf':'\u2605','straightepsilon':'ϵ','straightphi':'ϕ','strns':'\xAF','sub':'\u2282','Sub':'\u22D0','subdot':'\u2ABD','subE':'\u2AC5','sube':'\u2286','subedot':'\u2AC3','submult':'\u2AC1','subnE':'\u2ACB','subne':'\u228A','subplus':'\u2ABF','subrarr':'\u2979','subset':'\u2282','Subset':'\u22D0','subseteq':'\u2286','subseteqq':'\u2AC5','SubsetEqual':'\u2286','subsetneq':'\u228A','subsetneqq':'\u2ACB','subsim':'\u2AC7','subsub':'\u2AD5','subsup':'\u2AD3','succapprox':'\u2AB8','succ':'\u227B','succcurlyeq':'\u227D','Succeeds':'\u227B','SucceedsEqual':'\u2AB0','SucceedsSlantEqual':'\u227D','SucceedsTilde':'\u227F','succeq':'\u2AB0','succnapprox':'\u2ABA','succneqq':'\u2AB6','succnsim':'\u22E9','succsim':'\u227F','SuchThat':'\u220B','sum':'\u2211','Sum':'\u2211','sung':'\u266A','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','sup':'\u2283','Sup':'\u22D1','supdot':'\u2ABE','supdsub':'\u2AD8','supE':'\u2AC6','supe':'\u2287','supedot':'\u2AC4','Superset':'\u2283','SupersetEqual':'\u2287','suphsol':'\u27C9','suphsub':'\u2AD7','suplarr':'\u297B','supmult':'\u2AC2','supnE':'\u2ACC','supne':'\u228B','supplus':'\u2AC0','supset':'\u2283','Supset':'\u22D1','supseteq':'\u2287','supseteqq':'\u2AC6','supsetneq':'\u228B','supsetneqq':'\u2ACC','supsim':'\u2AC8','supsub':'\u2AD4','supsup':'\u2AD6','swarhk':'\u2926','swarr':'\u2199','swArr':'\u21D9','swarrow':'\u2199','swnwar':'\u292A','szlig':'ß','Tab':'\t','target':'\u2316','Tau':'Τ','tau':'τ','tbrk':'\u23B4','Tcaron':'Ť','tcaron':'ť','Tcedil':'Ţ','tcedil':'ţ','Tcy':'Т','tcy':'т','tdot':'⃛','telrec':'\u2315','Tfr':'\uD835\uDD17','tfr':'\uD835\uDD31','there4':'\u2234','therefore':'\u2234','Therefore':'\u2234','Theta':'Θ','theta':'θ','thetasym':'ϑ','thetav':'ϑ','thickapprox':'\u2248','thicksim':'\u223C','ThickSpace':'\u205F\u200A','ThinSpace':'\u2009','thinsp':'\u2009','thkap':'\u2248','thksim':'\u223C','THORN':'Þ','thorn':'þ','tilde':'\u02DC','Tilde':'\u223C','TildeEqual':'\u2243','TildeFullEqual':'\u2245','TildeTilde':'\u2248','timesbar':'\u2A31','timesb':'\u22A0','times':'\xD7','timesd':'\u2A30','tint':'\u222D','toea':'\u2928','topbot':'\u2336','topcir':'\u2AF1','top':'\u22A4','Topf':'\uD835\uDD4B','topf':'\uD835\uDD65','topfork':'\u2ADA','tosa':'\u2929','tprime':'\u2034','trade':'\u2122','TRADE':'\u2122','triangle':'\u25B5','triangledown':'\u25BF','triangleleft':'\u25C3','trianglelefteq':'\u22B4','triangleq':'\u225C','triangleright':'\u25B9','trianglerighteq':'\u22B5','tridot':'\u25EC','trie':'\u225C','triminus':'\u2A3A','TripleDot':'⃛','triplus':'\u2A39','trisb':'\u29CD','tritime':'\u2A3B','trpezium':'\u23E2','Tscr':'\uD835\uDCAF','tscr':'\uD835\uDCC9','TScy':'Ц','tscy':'ц','TSHcy':'Ћ','tshcy':'ћ','Tstrok':'Ŧ','tstrok':'ŧ','twixt':'\u226C','twoheadleftarrow':'\u219E','twoheadrightarrow':'\u21A0','Uacute':'Ú','uacute':'ú','uarr':'\u2191','Uarr':'\u219F','uArr':'\u21D1','Uarrocir':'\u2949','Ubrcy':'Ў','ubrcy':'ў','Ubreve':'Ŭ','ubreve':'ŭ','Ucirc':'Û','ucirc':'û','Ucy':'У','ucy':'у','udarr':'\u21C5','Udblac':'Ű','udblac':'ű','udhar':'\u296E','ufisht':'\u297E','Ufr':'\uD835\uDD18','ufr':'\uD835\uDD32','Ugrave':'Ù','ugrave':'ù','uHar':'\u2963','uharl':'\u21BF','uharr':'\u21BE','uhblk':'\u2580','ulcorn':'\u231C','ulcorner':'\u231C','ulcrop':'\u230F','ultri':'\u25F8','Umacr':'Ū','umacr':'ū','uml':'\xA8','UnderBar':'_','UnderBrace':'\u23DF','UnderBracket':'\u23B5','UnderParenthesis':'\u23DD','Union':'\u22C3','UnionPlus':'\u228E','Uogon':'Ų','uogon':'ų','Uopf':'\uD835\uDD4C','uopf':'\uD835\uDD66','UpArrowBar':'\u2912','uparrow':'\u2191','UpArrow':'\u2191','Uparrow':'\u21D1','UpArrowDownArrow':'\u21C5','updownarrow':'\u2195','UpDownArrow':'\u2195','Updownarrow':'\u21D5','UpEquilibrium':'\u296E','upharpoonleft':'\u21BF','upharpoonright':'\u21BE','uplus':'\u228E','UpperLeftArrow':'\u2196','UpperRightArrow':'\u2197','upsi':'υ','Upsi':'ϒ','upsih':'ϒ','Upsilon':'Υ','upsilon':'υ','UpTeeArrow':'\u21A5','UpTee':'\u22A5','upuparrows':'\u21C8','urcorn':'\u231D','urcorner':'\u231D','urcrop':'\u230E','Uring':'Ů','uring':'ů','urtri':'\u25F9','Uscr':'\uD835\uDCB0','uscr':'\uD835\uDCCA','utdot':'\u22F0','Utilde':'Ũ','utilde':'ũ','utri':'\u25B5','utrif':'\u25B4','uuarr':'\u21C8','Uuml':'Ü','uuml':'ü','uwangle':'\u29A7','vangrt':'\u299C','varepsilon':'ϵ','varkappa':'ϰ','varnothing':'\u2205','varphi':'ϕ','varpi':'ϖ','varpropto':'\u221D','varr':'\u2195','vArr':'\u21D5','varrho':'ϱ','varsigma':'ς','varsubsetneq':'\u228A︀','varsubsetneqq':'\u2ACB︀','varsupsetneq':'\u228B︀','varsupsetneqq':'\u2ACC︀','vartheta':'ϑ','vartriangleleft':'\u22B2','vartriangleright':'\u22B3','vBar':'\u2AE8','Vbar':'\u2AEB','vBarv':'\u2AE9','Vcy':'В','vcy':'в','vdash':'\u22A2','vDash':'\u22A8','Vdash':'\u22A9','VDash':'\u22AB','Vdashl':'\u2AE6','veebar':'\u22BB','vee':'\u2228','Vee':'\u22C1','veeeq':'\u225A','vellip':'\u22EE','verbar':'|','Verbar':'\u2016','vert':'|','Vert':'\u2016','VerticalBar':'\u2223','VerticalLine':'|','VerticalSeparator':'\u2758','VerticalTilde':'\u2240','VeryThinSpace':'\u200A','Vfr':'\uD835\uDD19','vfr':'\uD835\uDD33','vltri':'\u22B2','vnsub':'\u2282⃒','vnsup':'\u2283⃒','Vopf':'\uD835\uDD4D','vopf':'\uD835\uDD67','vprop':'\u221D','vrtri':'\u22B3','Vscr':'\uD835\uDCB1','vscr':'\uD835\uDCCB','vsubnE':'\u2ACB︀','vsubne':'\u228A︀','vsupnE':'\u2ACC︀','vsupne':'\u228B︀','Vvdash':'\u22AA','vzigzag':'\u299A','Wcirc':'Ŵ','wcirc':'ŵ','wedbar':'\u2A5F','wedge':'\u2227','Wedge':'\u22C0','wedgeq':'\u2259','weierp':'\u2118','Wfr':'\uD835\uDD1A','wfr':'\uD835\uDD34','Wopf':'\uD835\uDD4E','wopf':'\uD835\uDD68','wp':'\u2118','wr':'\u2240','wreath':'\u2240','Wscr':'\uD835\uDCB2','wscr':'\uD835\uDCCC','xcap':'\u22C2','xcirc':'\u25EF','xcup':'\u22C3','xdtri':'\u25BD','Xfr':'\uD835\uDD1B','xfr':'\uD835\uDD35','xharr':'\u27F7','xhArr':'\u27FA','Xi':'Ξ','xi':'ξ','xlarr':'\u27F5','xlArr':'\u27F8','xmap':'\u27FC','xnis':'\u22FB','xodot':'\u2A00','Xopf':'\uD835\uDD4F','xopf':'\uD835\uDD69','xoplus':'\u2A01','xotime':'\u2A02','xrarr':'\u27F6','xrArr':'\u27F9','Xscr':'\uD835\uDCB3','xscr':'\uD835\uDCCD','xsqcup':'\u2A06','xuplus':'\u2A04','xutri':'\u25B3','xvee':'\u22C1','xwedge':'\u22C0','Yacute':'Ý','yacute':'ý','YAcy':'Я','yacy':'я','Ycirc':'Ŷ','ycirc':'ŷ','Ycy':'Ы','ycy':'ы','yen':'\xA5','Yfr':'\uD835\uDD1C','yfr':'\uD835\uDD36','YIcy':'Ї','yicy':'ї','Yopf':'\uD835\uDD50','yopf':'\uD835\uDD6A','Yscr':'\uD835\uDCB4','yscr':'\uD835\uDCCE','YUcy':'Ю','yucy':'ю','yuml':'ÿ','Yuml':'Ÿ','Zacute':'Ź','zacute':'ź','Zcaron':'Ž','zcaron':'ž','Zcy':'З','zcy':'з','Zdot':'Ż','zdot':'ż','zeetrf':'ℨ','ZeroWidthSpace':'\u200B','Zeta':'Ζ','zeta':'ζ','zfr':'\uD835\uDD37','Zfr':'ℨ','ZHcy':'Ж','zhcy':'ж','zigrarr':'\u21DD','zopf':'\uD835\uDD6B','Zopf':'ℤ','Zscr':'\uD835\uDCB5','zscr':'\uD835\uDCCF','zwj':'‍','zwnj':'‌'};},{}],26:[function(require,module,exports){module.exports={'Aacute':'Á','aacute':'á','Acirc':'Â','acirc':'â','acute':'\xB4','AElig':'Æ','aelig':'æ','Agrave':'À','agrave':'à','amp':'&','AMP':'&','Aring':'Å','aring':'å','Atilde':'Ã','atilde':'ã','Auml':'Ä','auml':'ä','brvbar':'\xA6','Ccedil':'Ç','ccedil':'ç','cedil':'\xB8','cent':'\xA2','copy':'\xA9','COPY':'\xA9','curren':'\xA4','deg':'\xB0','divide':'\xF7','Eacute':'É','eacute':'é','Ecirc':'Ê','ecirc':'ê','Egrave':'È','egrave':'è','ETH':'Ð','eth':'ð','Euml':'Ë','euml':'ë','frac12':'\xBD','frac14':'\xBC','frac34':'\xBE','gt':'>','GT':'>','Iacute':'Í','iacute':'í','Icirc':'Î','icirc':'î','iexcl':'\xA1','Igrave':'Ì','igrave':'ì','iquest':'\xBF','Iuml':'Ï','iuml':'ï','laquo':'\xAB','lt':'<','LT':'<','macr':'\xAF','micro':'µ','middot':'\xB7','nbsp':'\xA0','not':'\xAC','Ntilde':'Ñ','ntilde':'ñ','Oacute':'Ó','oacute':'ó','Ocirc':'Ô','ocirc':'ô','Ograve':'Ò','ograve':'ò','ordf':'ª','ordm':'º','Oslash':'Ø','oslash':'ø','Otilde':'Õ','otilde':'õ','Ouml':'Ö','ouml':'ö','para':'\xB6','plusmn':'\xB1','pound':'\xA3','quot':'"','QUOT':'"','raquo':'\xBB','reg':'\xAE','REG':'\xAE','sect':'\xA7','shy':'\xAD','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','szlig':'ß','THORN':'Þ','thorn':'þ','times':'\xD7','Uacute':'Ú','uacute':'ú','Ucirc':'Û','ucirc':'û','Ugrave':'Ù','ugrave':'ù','uml':'\xA8','Uuml':'Ü','uuml':'ü','Yacute':'Ý','yacute':'ý','yen':'\xA5','yuml':'ÿ'};},{}],27:[function(require,module,exports){module.exports={'amp':'&','apos':'\'','gt':'>','lt':'<','quot':'"'};},{}],28:[function(require,module,exports){module.exports={Text:'text',Directive:'directive',Comment:'comment',Script:'script',Style:'style',Tag:'tag',CDATA:'cdata',Doctype:'doctype',isTag:function(elem){return elem.type==='tag'||elem.type==='script'||elem.type==='style';}};},{}],29:[function(require,module,exports){var ElementType=require('domelementtype');var re_whitespace=/\s+/g;var NodePrototype=require('./lib/node');var ElementPrototype=require('./lib/element');function DomHandler(callback,options,elementCB){if(typeof callback==='object'){elementCB=options;options=callback;callback=null;}else if(typeof options==='function'){elementCB=options;options=defaultOpts;}this._callback=callback;this._options=options||defaultOpts;this._elementCB=elementCB;this.dom=[];this._done=false;this._tagStack=[];this._parser=this._parser||null;}var defaultOpts={normalizeWhitespace:false,withStartIndices:false,withEndIndices:false};DomHandler.prototype.onparserinit=function(parser){this._parser=parser;};DomHandler.prototype.onreset=function(){DomHandler.call(this,this._callback,this._options,this._elementCB);};DomHandler.prototype.onend=function(){if(this._done)return;this._done=true;this._parser=null;this._handleCallback(null);};DomHandler.prototype._handleCallback=DomHandler.prototype.onerror=function(error){if(typeof this._callback==='function'){this._callback(error,this.dom);}else{if(error)throw error;}};DomHandler.prototype.onclosetag=function(){var elem=this._tagStack.pop();if(this._options.withEndIndices&&elem){elem.endIndex=this._parser.endIndex;}if(this._elementCB)this._elementCB(elem);};DomHandler.prototype._createDomElement=function(properties){if(!this._options.withDomLvl1)return properties;var element;if(properties.type==='tag'){element=Object.create(ElementPrototype);}else{element=Object.create(NodePrototype);}for(var key in properties){if(properties.hasOwnProperty(key)){element[key]=properties[key];}}return element;};DomHandler.prototype._addDomElement=function(element){var parent=this._tagStack[this._tagStack.length-1];var siblings=parent?parent.children:this.dom;var previousSibling=siblings[siblings.length-1];element.next=null;if(this._options.withStartIndices){element.startIndex=this._parser.startIndex;}if(this._options.withEndIndices){element.endIndex=this._parser.endIndex;}if(previousSibling){element.prev=previousSibling;previousSibling.next=element;}else{element.prev=null;}siblings.push(element);element.parent=parent||null;};DomHandler.prototype.onopentag=function(name,attribs){var properties={type:name==='script'?ElementType.Script:name==='style'?ElementType.Style:ElementType.Tag,name:name,attribs:attribs,children:[]};var element=this._createDomElement(properties);this._addDomElement(element);this._tagStack.push(element);};DomHandler.prototype.ontext=function(data){var normalize=this._options.normalizeWhitespace||this._options.ignoreWhitespace;var lastTag;if(!this._tagStack.length&&this.dom.length&&(lastTag=this.dom[this.dom.length-1]).type===ElementType.Text){if(normalize){lastTag.data=(lastTag.data+data).replace(re_whitespace,' ');}else{lastTag.data+=data;}}else{if(this._tagStack.length&&(lastTag=this._tagStack[this._tagStack.length-1])&&(lastTag=lastTag.children[lastTag.children.length-1])&&lastTag.type===ElementType.Text){if(normalize){lastTag.data=(lastTag.data+data).replace(re_whitespace,' ');}else{lastTag.data+=data;}}else{if(normalize){data=data.replace(re_whitespace,' ');}var element=this._createDomElement({data:data,type:ElementType.Text});this._addDomElement(element);}}};DomHandler.prototype.oncomment=function(data){var lastTag=this._tagStack[this._tagStack.length-1];if(lastTag&&lastTag.type===ElementType.Comment){lastTag.data+=data;return;}var properties={data:data,type:ElementType.Comment};var element=this._createDomElement(properties);this._addDomElement(element);this._tagStack.push(element);};DomHandler.prototype.oncdatastart=function(){var properties={children:[{data:'',type:ElementType.Text}],type:ElementType.CDATA};var element=this._createDomElement(properties);this._addDomElement(element);this._tagStack.push(element);};DomHandler.prototype.oncommentend=DomHandler.prototype.oncdataend=function(){this._tagStack.pop();};DomHandler.prototype.onprocessinginstruction=function(name,data){var element=this._createDomElement({name:name,data:data,type:ElementType.Directive});this._addDomElement(element);};module.exports=DomHandler;},{'./lib/element':30,'./lib/node':31,'domelementtype':28}],30:[function(require,module,exports){var NodePrototype=require('./node');var ElementPrototype=module.exports=Object.create(NodePrototype);var domLvl1={tagName:'name'};Object.keys(domLvl1).forEach(function(key){var shorthand=domLvl1[key];Object.defineProperty(ElementPrototype,key,{get:function(){return this[shorthand]||null;},set:function(val){this[shorthand]=val;return val;}});});},{'./node':31}],31:[function(require,module,exports){var NodePrototype=module.exports={get firstChild(){var children=this.children;return children&&children[0]||null;},get lastChild(){var children=this.children;return children&&children[children.length-1]||null;},get nodeType(){return nodeTypes[this.type]||nodeTypes.element;}};var domLvl1={tagName:'name',childNodes:'children',parentNode:'parent',previousSibling:'prev',nextSibling:'next',nodeValue:'data'};var nodeTypes={element:1,text:3,cdata:4,comment:8};Object.keys(domLvl1).forEach(function(key){var shorthand=domLvl1[key];Object.defineProperty(NodePrototype,key,{get:function(){return this[shorthand]||null;},set:function(val){this[shorthand]=val;return val;}});});},{}],32:[function(require,module,exports){var DomUtils=module.exports;[require('./lib/stringify'),require('./lib/traversal'),require('./lib/manipulation'),require('./lib/querying'),require('./lib/legacy'),require('./lib/helpers')].forEach(function(ext){Object.keys(ext).forEach(function(key){DomUtils[key]=ext[key].bind(DomUtils);});});},{'./lib/helpers':33,'./lib/legacy':34,'./lib/manipulation':35,'./lib/querying':36,'./lib/stringify':37,'./lib/traversal':38}],33:[function(require,module,exports){exports.removeSubsets=function(nodes){var idx=nodes.length,node,ancestor,replace;while(--idx>-1){node=ancestor=nodes[idx];nodes[idx]=null;replace=true;while(ancestor){if(nodes.indexOf(ancestor)>-1){replace=false;nodes.splice(idx,1);break;}ancestor=ancestor.parent;}if(replace){nodes[idx]=node;}}return nodes;};var POSITION={DISCONNECTED:1,PRECEDING:2,FOLLOWING:4,CONTAINS:8,CONTAINED_BY:16};var comparePos=exports.compareDocumentPosition=function(nodeA,nodeB){var aParents=[];var bParents=[];var current,sharedParent,siblings,aSibling,bSibling,idx;if(nodeA===nodeB){return 0;}current=nodeA;while(current){aParents.unshift(current);current=current.parent;}current=nodeB;while(current){bParents.unshift(current);current=current.parent;}idx=0;while(aParents[idx]===bParents[idx]){idx++;}if(idx===0){return POSITION.DISCONNECTED;}sharedParent=aParents[idx-1];siblings=sharedParent.children;aSibling=aParents[idx];bSibling=bParents[idx];if(siblings.indexOf(aSibling)>siblings.indexOf(bSibling)){if(sharedParent===nodeB){return POSITION.FOLLOWING|POSITION.CONTAINED_BY;}return POSITION.FOLLOWING;}else{if(sharedParent===nodeA){return POSITION.PRECEDING|POSITION.CONTAINS;}return POSITION.PRECEDING;}};exports.uniqueSort=function(nodes){var idx=nodes.length,node,position;nodes=nodes.slice();while(--idx>-1){node=nodes[idx];position=nodes.indexOf(node);if(position>-1&&position<idx){nodes.splice(idx,1);}}nodes.sort(function(a,b){var relative=comparePos(a,b);if(relative&POSITION.PRECEDING){return-1;}else if(relative&POSITION.FOLLOWING){return 1;}return 0;});return nodes;};},{}],34:[function(require,module,exports){var ElementType=require('domelementtype');var isTag=exports.isTag=ElementType.isTag;exports.testElement=function(options,element){for(var key in options){if(!options.hasOwnProperty(key));else if(key==='tag_name'){if(!isTag(element)||!options.tag_name(element.name)){return false;}}else if(key==='tag_type'){if(!options.tag_type(element.type))return false;}else if(key==='tag_contains'){if(isTag(element)||!options.tag_contains(element.data)){return false;}}else if(!element.attribs||!options[key](element.attribs[key])){return false;}}return true;};var Checks={tag_name:function(name){if(typeof name==='function'){return function(elem){return isTag(elem)&&name(elem.name);};}else if(name==='*'){return isTag;}else{return function(elem){return isTag(elem)&&elem.name===name;};}},tag_type:function(type){if(typeof type==='function'){return function(elem){return type(elem.type);};}else{return function(elem){return elem.type===type;};}},tag_contains:function(data){if(typeof data==='function'){return function(elem){return!isTag(elem)&&data(elem.data);};}else{return function(elem){return!isTag(elem)&&elem.data===data;};}}};function getAttribCheck(attrib,value){if(typeof value==='function'){return function(elem){return elem.attribs&&value(elem.attribs[attrib]);};}else{return function(elem){return elem.attribs&&elem.attribs[attrib]===value;};}}function combineFuncs(a,b){return function(elem){return a(elem)||b(elem);};}exports.getElements=function(options,element,recurse,limit){var funcs=Object.keys(options).map(function(key){var value=options[key];return key in Checks?Checks[key](value):getAttribCheck(key,value);});return funcs.length===0?[]:this.filter(funcs.reduce(combineFuncs),element,recurse,limit);};exports.getElementById=function(id,element,recurse){if(!Array.isArray(element))element=[element];return this.findOne(getAttribCheck('id',id),element,recurse!==false);};exports.getElementsByTagName=function(name,element,recurse,limit){return this.filter(Checks.tag_name(name),element,recurse,limit);};exports.getElementsByTagType=function(type,element,recurse,limit){return this.filter(Checks.tag_type(type),element,recurse,limit);};},{'domelementtype':28}],35:[function(require,module,exports){exports.removeElement=function(elem){if(elem.prev)elem.prev.next=elem.next;if(elem.next)elem.next.prev=elem.prev;if(elem.parent){var childs=elem.parent.children;childs.splice(childs.lastIndexOf(elem),1);}};exports.replaceElement=function(elem,replacement){var prev=replacement.prev=elem.prev;if(prev){prev.next=replacement;}var next=replacement.next=elem.next;if(next){next.prev=replacement;}var parent=replacement.parent=elem.parent;if(parent){var childs=parent.children;childs[childs.lastIndexOf(elem)]=replacement;}};exports.appendChild=function(elem,child){child.parent=elem;if(elem.children.push(child)!==1){var sibling=elem.children[elem.children.length-2];sibling.next=child;child.prev=sibling;child.next=null;}};exports.append=function(elem,next){var parent=elem.parent,currNext=elem.next;next.next=currNext;next.prev=elem;elem.next=next;next.parent=parent;if(currNext){currNext.prev=next;if(parent){var childs=parent.children;childs.splice(childs.lastIndexOf(currNext),0,next);}}else if(parent){parent.children.push(next);}};exports.prepend=function(elem,prev){var parent=elem.parent;if(parent){var childs=parent.children;childs.splice(childs.lastIndexOf(elem),0,prev);}if(elem.prev){elem.prev.next=prev;}prev.parent=parent;prev.prev=elem.prev;prev.next=elem;elem.prev=prev;};},{}],36:[function(require,module,exports){var isTag=require('domelementtype').isTag;module.exports={filter:filter,find:find,findOneChild:findOneChild,findOne:findOne,existsOne:existsOne,findAll:findAll};function filter(test,element,recurse,limit){if(!Array.isArray(element))element=[element];if(typeof limit!=='number'||!isFinite(limit)){limit=Infinity;}return find(test,element,recurse!==false,limit);}function find(test,elems,recurse,limit){var result=[],childs;for(var i=0,j=elems.length;i<j;i++){if(test(elems[i])){result.push(elems[i]);if(--limit<=0)break;}childs=elems[i].children;if(recurse&&childs&&childs.length>0){childs=find(test,childs,recurse,limit);result=result.concat(childs);limit-=childs.length;if(limit<=0)break;}}return result;}function findOneChild(test,elems){for(var i=0,l=elems.length;i<l;i++){if(test(elems[i]))return elems[i];}return null;}function findOne(test,elems){var elem=null;for(var i=0,l=elems.length;i<l&&!elem;i++){if(!isTag(elems[i])){continue;}else if(test(elems[i])){elem=elems[i];}else if(elems[i].children.length>0){elem=findOne(test,elems[i].children);}}return elem;}function existsOne(test,elems){for(var i=0,l=elems.length;i<l;i++){if(isTag(elems[i])&&(test(elems[i])||elems[i].children.length>0&&existsOne(test,elems[i].children))){return true;}}return false;}function findAll(test,rootElems){var result=[];var stack=rootElems.slice();while(stack.length){var elem=stack.shift();if(!isTag(elem))continue;if(elem.children&&elem.children.length>0){stack.unshift.apply(stack,elem.children);}if(test(elem))result.push(elem);}return result;}},{'domelementtype':28}],37:[function(require,module,exports){var ElementType=require('domelementtype'),getOuterHTML=require('dom-serializer'),isTag=ElementType.isTag;module.exports={getInnerHTML:getInnerHTML,getOuterHTML:getOuterHTML,getText:getText};function getInnerHTML(elem,opts){return elem.children?elem.children.map(function(elem){return getOuterHTML(elem,opts);}).join(''):'';}function getText(elem){if(Array.isArray(elem))return elem.map(getText).join('');if(isTag(elem))return elem.name==='br'?'\n':getText(elem.children);if(elem.type===ElementType.CDATA)return getText(elem.children);if(elem.type===ElementType.Text)return elem.data;return'';}},{'dom-serializer':18,'domelementtype':28}],38:[function(require,module,exports){var getChildren=exports.getChildren=function(elem){return elem.children;};var getParent=exports.getParent=function(elem){return elem.parent;};exports.getSiblings=function(elem){var parent=getParent(elem);return parent?getChildren(parent):[elem];};exports.getAttributeValue=function(elem,name){return elem.attribs&&elem.attribs[name];};exports.hasAttrib=function(elem,name){return!!elem.attribs&&hasOwnProperty.call(elem.attribs,name);};exports.getName=function(elem){return elem.name;};},{}],39:[function(require,module,exports){var decodeMap=require('../maps/decode.json');module.exports=decodeCodePoint;function decodeCodePoint(codePoint){if(codePoint>=55296&&codePoint<=57343||codePoint>1114111){return'\uFFFD';}if(codePoint in decodeMap){codePoint=decodeMap[codePoint];}var output='';if(codePoint>65535){codePoint-=65536;output+=String.fromCharCode(codePoint>>>10&1023|55296);codePoint=56320|codePoint&1023;}output+=String.fromCharCode(codePoint);return output;}},{'../maps/decode.json':40}],40:[function(require,module,exports){module.exports={'0':65533,'128':8364,'130':8218,'131':402,'132':8222,'133':8230,'134':8224,'135':8225,'136':710,'137':8240,'138':352,'139':8249,'140':338,'142':381,'145':8216,'146':8217,'147':8220,'148':8221,'149':8226,'150':8211,'151':8212,'152':732,'153':8482,'154':353,'155':8250,'156':339,'158':382,'159':376};},{}],41:[function(require,module,exports){module.exports={'Aacute':'Á','aacute':'á','Abreve':'Ă','abreve':'ă','ac':'\u223E','acd':'\u223F','acE':'\u223E̳','Acirc':'Â','acirc':'â','acute':'\xB4','Acy':'А','acy':'а','AElig':'Æ','aelig':'æ','af':'\u2061','Afr':'\uD835\uDD04','afr':'\uD835\uDD1E','Agrave':'À','agrave':'à','alefsym':'ℵ','aleph':'ℵ','Alpha':'Α','alpha':'α','Amacr':'Ā','amacr':'ā','amalg':'\u2A3F','amp':'&','AMP':'&','andand':'\u2A55','And':'\u2A53','and':'\u2227','andd':'\u2A5C','andslope':'\u2A58','andv':'\u2A5A','ang':'\u2220','ange':'\u29A4','angle':'\u2220','angmsdaa':'\u29A8','angmsdab':'\u29A9','angmsdac':'\u29AA','angmsdad':'\u29AB','angmsdae':'\u29AC','angmsdaf':'\u29AD','angmsdag':'\u29AE','angmsdah':'\u29AF','angmsd':'\u2221','angrt':'\u221F','angrtvb':'\u22BE','angrtvbd':'\u299D','angsph':'\u2222','angst':'Å','angzarr':'\u237C','Aogon':'Ą','aogon':'ą','Aopf':'\uD835\uDD38','aopf':'\uD835\uDD52','apacir':'\u2A6F','ap':'\u2248','apE':'\u2A70','ape':'\u224A','apid':'\u224B','apos':'\'','ApplyFunction':'\u2061','approx':'\u2248','approxeq':'\u224A','Aring':'Å','aring':'å','Ascr':'\uD835\uDC9C','ascr':'\uD835\uDCB6','Assign':'\u2254','ast':'*','asymp':'\u2248','asympeq':'\u224D','Atilde':'Ã','atilde':'ã','Auml':'Ä','auml':'ä','awconint':'\u2233','awint':'\u2A11','backcong':'\u224C','backepsilon':'\u03F6','backprime':'\u2035','backsim':'\u223D','backsimeq':'\u22CD','Backslash':'\u2216','Barv':'\u2AE7','barvee':'\u22BD','barwed':'\u2305','Barwed':'\u2306','barwedge':'\u2305','bbrk':'\u23B5','bbrktbrk':'\u23B6','bcong':'\u224C','Bcy':'Б','bcy':'б','bdquo':'\u201E','becaus':'\u2235','because':'\u2235','Because':'\u2235','bemptyv':'\u29B0','bepsi':'\u03F6','bernou':'ℬ','Bernoullis':'ℬ','Beta':'Β','beta':'β','beth':'ℶ','between':'\u226C','Bfr':'\uD835\uDD05','bfr':'\uD835\uDD1F','bigcap':'\u22C2','bigcirc':'\u25EF','bigcup':'\u22C3','bigodot':'\u2A00','bigoplus':'\u2A01','bigotimes':'\u2A02','bigsqcup':'\u2A06','bigstar':'\u2605','bigtriangledown':'\u25BD','bigtriangleup':'\u25B3','biguplus':'\u2A04','bigvee':'\u22C1','bigwedge':'\u22C0','bkarow':'\u290D','blacklozenge':'\u29EB','blacksquare':'\u25AA','blacktriangle':'\u25B4','blacktriangledown':'\u25BE','blacktriangleleft':'\u25C2','blacktriangleright':'\u25B8','blank':'\u2423','blk12':'\u2592','blk14':'\u2591','blk34':'\u2593','block':'\u2588','bne':'=⃥','bnequiv':'\u2261⃥','bNot':'\u2AED','bnot':'\u2310','Bopf':'\uD835\uDD39','bopf':'\uD835\uDD53','bot':'\u22A5','bottom':'\u22A5','bowtie':'\u22C8','boxbox':'\u29C9','boxdl':'\u2510','boxdL':'\u2555','boxDl':'\u2556','boxDL':'\u2557','boxdr':'\u250C','boxdR':'\u2552','boxDr':'\u2553','boxDR':'\u2554','boxh':'\u2500','boxH':'\u2550','boxhd':'\u252C','boxHd':'\u2564','boxhD':'\u2565','boxHD':'\u2566','boxhu':'\u2534','boxHu':'\u2567','boxhU':'\u2568','boxHU':'\u2569','boxminus':'\u229F','boxplus':'\u229E','boxtimes':'\u22A0','boxul':'\u2518','boxuL':'\u255B','boxUl':'\u255C','boxUL':'\u255D','boxur':'\u2514','boxuR':'\u2558','boxUr':'\u2559','boxUR':'\u255A','boxv':'\u2502','boxV':'\u2551','boxvh':'\u253C','boxvH':'\u256A','boxVh':'\u256B','boxVH':'\u256C','boxvl':'\u2524','boxvL':'\u2561','boxVl':'\u2562','boxVL':'\u2563','boxvr':'\u251C','boxvR':'\u255E','boxVr':'\u255F','boxVR':'\u2560','bprime':'\u2035','breve':'\u02D8','Breve':'\u02D8','brvbar':'\xA6','bscr':'\uD835\uDCB7','Bscr':'ℬ','bsemi':'\u204F','bsim':'\u223D','bsime':'\u22CD','bsolb':'\u29C5','bsol':'\\','bsolhsub':'\u27C8','bull':'\u2022','bullet':'\u2022','bump':'\u224E','bumpE':'\u2AAE','bumpe':'\u224F','Bumpeq':'\u224E','bumpeq':'\u224F','Cacute':'Ć','cacute':'ć','capand':'\u2A44','capbrcup':'\u2A49','capcap':'\u2A4B','cap':'\u2229','Cap':'\u22D2','capcup':'\u2A47','capdot':'\u2A40','CapitalDifferentialD':'ⅅ','caps':'\u2229︀','caret':'\u2041','caron':'ˇ','Cayleys':'ℭ','ccaps':'\u2A4D','Ccaron':'Č','ccaron':'č','Ccedil':'Ç','ccedil':'ç','Ccirc':'Ĉ','ccirc':'ĉ','Cconint':'\u2230','ccups':'\u2A4C','ccupssm':'\u2A50','Cdot':'Ċ','cdot':'ċ','cedil':'\xB8','Cedilla':'\xB8','cemptyv':'\u29B2','cent':'\xA2','centerdot':'\xB7','CenterDot':'\xB7','cfr':'\uD835\uDD20','Cfr':'ℭ','CHcy':'Ч','chcy':'ч','check':'\u2713','checkmark':'\u2713','Chi':'Χ','chi':'χ','circ':'ˆ','circeq':'\u2257','circlearrowleft':'\u21BA','circlearrowright':'\u21BB','circledast':'\u229B','circledcirc':'\u229A','circleddash':'\u229D','CircleDot':'\u2299','circledR':'\xAE','circledS':'\u24C8','CircleMinus':'\u2296','CirclePlus':'\u2295','CircleTimes':'\u2297','cir':'\u25CB','cirE':'\u29C3','cire':'\u2257','cirfnint':'\u2A10','cirmid':'\u2AEF','cirscir':'\u29C2','ClockwiseContourIntegral':'\u2232','CloseCurlyDoubleQuote':'\u201D','CloseCurlyQuote':'\u2019','clubs':'\u2663','clubsuit':'\u2663','colon':':','Colon':'\u2237','Colone':'\u2A74','colone':'\u2254','coloneq':'\u2254','comma':',','commat':'@','comp':'\u2201','compfn':'\u2218','complement':'\u2201','complexes':'ℂ','cong':'\u2245','congdot':'\u2A6D','Congruent':'\u2261','conint':'\u222E','Conint':'\u222F','ContourIntegral':'\u222E','copf':'\uD835\uDD54','Copf':'ℂ','coprod':'\u2210','Coproduct':'\u2210','copy':'\xA9','COPY':'\xA9','copysr':'\u2117','CounterClockwiseContourIntegral':'\u2233','crarr':'\u21B5','cross':'\u2717','Cross':'\u2A2F','Cscr':'\uD835\uDC9E','cscr':'\uD835\uDCB8','csub':'\u2ACF','csube':'\u2AD1','csup':'\u2AD0','csupe':'\u2AD2','ctdot':'\u22EF','cudarrl':'\u2938','cudarrr':'\u2935','cuepr':'\u22DE','cuesc':'\u22DF','cularr':'\u21B6','cularrp':'\u293D','cupbrcap':'\u2A48','cupcap':'\u2A46','CupCap':'\u224D','cup':'\u222A','Cup':'\u22D3','cupcup':'\u2A4A','cupdot':'\u228D','cupor':'\u2A45','cups':'\u222A︀','curarr':'\u21B7','curarrm':'\u293C','curlyeqprec':'\u22DE','curlyeqsucc':'\u22DF','curlyvee':'\u22CE','curlywedge':'\u22CF','curren':'\xA4','curvearrowleft':'\u21B6','curvearrowright':'\u21B7','cuvee':'\u22CE','cuwed':'\u22CF','cwconint':'\u2232','cwint':'\u2231','cylcty':'\u232D','dagger':'\u2020','Dagger':'\u2021','daleth':'ℸ','darr':'\u2193','Darr':'\u21A1','dArr':'\u21D3','dash':'\u2010','Dashv':'\u2AE4','dashv':'\u22A3','dbkarow':'\u290F','dblac':'\u02DD','Dcaron':'Ď','dcaron':'ď','Dcy':'Д','dcy':'д','ddagger':'\u2021','ddarr':'\u21CA','DD':'ⅅ','dd':'ⅆ','DDotrahd':'\u2911','ddotseq':'\u2A77','deg':'\xB0','Del':'\u2207','Delta':'Δ','delta':'δ','demptyv':'\u29B1','dfisht':'\u297F','Dfr':'\uD835\uDD07','dfr':'\uD835\uDD21','dHar':'\u2965','dharl':'\u21C3','dharr':'\u21C2','DiacriticalAcute':'\xB4','DiacriticalDot':'\u02D9','DiacriticalDoubleAcute':'\u02DD','DiacriticalGrave':'`','DiacriticalTilde':'\u02DC','diam':'\u22C4','diamond':'\u22C4','Diamond':'\u22C4','diamondsuit':'\u2666','diams':'\u2666','die':'\xA8','DifferentialD':'ⅆ','digamma':'ϝ','disin':'\u22F2','div':'\xF7','divide':'\xF7','divideontimes':'\u22C7','divonx':'\u22C7','DJcy':'Ђ','djcy':'ђ','dlcorn':'\u231E','dlcrop':'\u230D','dollar':'$','Dopf':'\uD835\uDD3B','dopf':'\uD835\uDD55','Dot':'\xA8','dot':'\u02D9','DotDot':'⃜','doteq':'\u2250','doteqdot':'\u2251','DotEqual':'\u2250','dotminus':'\u2238','dotplus':'\u2214','dotsquare':'\u22A1','doublebarwedge':'\u2306','DoubleContourIntegral':'\u222F','DoubleDot':'\xA8','DoubleDownArrow':'\u21D3','DoubleLeftArrow':'\u21D0','DoubleLeftRightArrow':'\u21D4','DoubleLeftTee':'\u2AE4','DoubleLongLeftArrow':'\u27F8','DoubleLongLeftRightArrow':'\u27FA','DoubleLongRightArrow':'\u27F9','DoubleRightArrow':'\u21D2','DoubleRightTee':'\u22A8','DoubleUpArrow':'\u21D1','DoubleUpDownArrow':'\u21D5','DoubleVerticalBar':'\u2225','DownArrowBar':'\u2913','downarrow':'\u2193','DownArrow':'\u2193','Downarrow':'\u21D3','DownArrowUpArrow':'\u21F5','DownBreve':'̑','downdownarrows':'\u21CA','downharpoonleft':'\u21C3','downharpoonright':'\u21C2','DownLeftRightVector':'\u2950','DownLeftTeeVector':'\u295E','DownLeftVectorBar':'\u2956','DownLeftVector':'\u21BD','DownRightTeeVector':'\u295F','DownRightVectorBar':'\u2957','DownRightVector':'\u21C1','DownTeeArrow':'\u21A7','DownTee':'\u22A4','drbkarow':'\u2910','drcorn':'\u231F','drcrop':'\u230C','Dscr':'\uD835\uDC9F','dscr':'\uD835\uDCB9','DScy':'Ѕ','dscy':'ѕ','dsol':'\u29F6','Dstrok':'Đ','dstrok':'đ','dtdot':'\u22F1','dtri':'\u25BF','dtrif':'\u25BE','duarr':'\u21F5','duhar':'\u296F','dwangle':'\u29A6','DZcy':'Џ','dzcy':'џ','dzigrarr':'\u27FF','Eacute':'É','eacute':'é','easter':'\u2A6E','Ecaron':'Ě','ecaron':'ě','Ecirc':'Ê','ecirc':'ê','ecir':'\u2256','ecolon':'\u2255','Ecy':'Э','ecy':'э','eDDot':'\u2A77','Edot':'Ė','edot':'ė','eDot':'\u2251','ee':'ⅇ','efDot':'\u2252','Efr':'\uD835\uDD08','efr':'\uD835\uDD22','eg':'\u2A9A','Egrave':'È','egrave':'è','egs':'\u2A96','egsdot':'\u2A98','el':'\u2A99','Element':'\u2208','elinters':'\u23E7','ell':'ℓ','els':'\u2A95','elsdot':'\u2A97','Emacr':'Ē','emacr':'ē','empty':'\u2205','emptyset':'\u2205','EmptySmallSquare':'\u25FB','emptyv':'\u2205','EmptyVerySmallSquare':'\u25AB','emsp13':'\u2004','emsp14':'\u2005','emsp':'\u2003','ENG':'Ŋ','eng':'ŋ','ensp':'\u2002','Eogon':'Ę','eogon':'ę','Eopf':'\uD835\uDD3C','eopf':'\uD835\uDD56','epar':'\u22D5','eparsl':'\u29E3','eplus':'\u2A71','epsi':'ε','Epsilon':'Ε','epsilon':'ε','epsiv':'ϵ','eqcirc':'\u2256','eqcolon':'\u2255','eqsim':'\u2242','eqslantgtr':'\u2A96','eqslantless':'\u2A95','Equal':'\u2A75','equals':'=','EqualTilde':'\u2242','equest':'\u225F','Equilibrium':'\u21CC','equiv':'\u2261','equivDD':'\u2A78','eqvparsl':'\u29E5','erarr':'\u2971','erDot':'\u2253','escr':'ℯ','Escr':'ℰ','esdot':'\u2250','Esim':'\u2A73','esim':'\u2242','Eta':'Η','eta':'η','ETH':'Ð','eth':'ð','Euml':'Ë','euml':'ë','euro':'\u20AC','excl':'!','exist':'\u2203','Exists':'\u2203','expectation':'ℰ','exponentiale':'ⅇ','ExponentialE':'ⅇ','fallingdotseq':'\u2252','Fcy':'Ф','fcy':'ф','female':'\u2640','ffilig':'ﬃ','fflig':'ﬀ','ffllig':'ﬄ','Ffr':'\uD835\uDD09','ffr':'\uD835\uDD23','filig':'ﬁ','FilledSmallSquare':'\u25FC','FilledVerySmallSquare':'\u25AA','fjlig':'fj','flat':'\u266D','fllig':'ﬂ','fltns':'\u25B1','fnof':'ƒ','Fopf':'\uD835\uDD3D','fopf':'\uD835\uDD57','forall':'\u2200','ForAll':'\u2200','fork':'\u22D4','forkv':'\u2AD9','Fouriertrf':'ℱ','fpartint':'\u2A0D','frac12':'\xBD','frac13':'\u2153','frac14':'\xBC','frac15':'\u2155','frac16':'\u2159','frac18':'\u215B','frac23':'\u2154','frac25':'\u2156','frac34':'\xBE','frac35':'\u2157','frac38':'\u215C','frac45':'\u2158','frac56':'\u215A','frac58':'\u215D','frac78':'\u215E','frasl':'\u2044','frown':'\u2322','fscr':'\uD835\uDCBB','Fscr':'ℱ','gacute':'ǵ','Gamma':'Γ','gamma':'γ','Gammad':'Ϝ','gammad':'ϝ','gap':'\u2A86','Gbreve':'Ğ','gbreve':'ğ','Gcedil':'Ģ','Gcirc':'Ĝ','gcirc':'ĝ','Gcy':'Г','gcy':'г','Gdot':'Ġ','gdot':'ġ','ge':'\u2265','gE':'\u2267','gEl':'\u2A8C','gel':'\u22DB','geq':'\u2265','geqq':'\u2267','geqslant':'\u2A7E','gescc':'\u2AA9','ges':'\u2A7E','gesdot':'\u2A80','gesdoto':'\u2A82','gesdotol':'\u2A84','gesl':'\u22DB︀','gesles':'\u2A94','Gfr':'\uD835\uDD0A','gfr':'\uD835\uDD24','gg':'\u226B','Gg':'\u22D9','ggg':'\u22D9','gimel':'ℷ','GJcy':'Ѓ','gjcy':'ѓ','gla':'\u2AA5','gl':'\u2277','glE':'\u2A92','glj':'\u2AA4','gnap':'\u2A8A','gnapprox':'\u2A8A','gne':'\u2A88','gnE':'\u2269','gneq':'\u2A88','gneqq':'\u2269','gnsim':'\u22E7','Gopf':'\uD835\uDD3E','gopf':'\uD835\uDD58','grave':'`','GreaterEqual':'\u2265','GreaterEqualLess':'\u22DB','GreaterFullEqual':'\u2267','GreaterGreater':'\u2AA2','GreaterLess':'\u2277','GreaterSlantEqual':'\u2A7E','GreaterTilde':'\u2273','Gscr':'\uD835\uDCA2','gscr':'ℊ','gsim':'\u2273','gsime':'\u2A8E','gsiml':'\u2A90','gtcc':'\u2AA7','gtcir':'\u2A7A','gt':'>','GT':'>','Gt':'\u226B','gtdot':'\u22D7','gtlPar':'\u2995','gtquest':'\u2A7C','gtrapprox':'\u2A86','gtrarr':'\u2978','gtrdot':'\u22D7','gtreqless':'\u22DB','gtreqqless':'\u2A8C','gtrless':'\u2277','gtrsim':'\u2273','gvertneqq':'\u2269︀','gvnE':'\u2269︀','Hacek':'ˇ','hairsp':'\u200A','half':'\xBD','hamilt':'ℋ','HARDcy':'Ъ','hardcy':'ъ','harrcir':'\u2948','harr':'\u2194','hArr':'\u21D4','harrw':'\u21AD','Hat':'^','hbar':'ℏ','Hcirc':'Ĥ','hcirc':'ĥ','hearts':'\u2665','heartsuit':'\u2665','hellip':'\u2026','hercon':'\u22B9','hfr':'\uD835\uDD25','Hfr':'ℌ','HilbertSpace':'ℋ','hksearow':'\u2925','hkswarow':'\u2926','hoarr':'\u21FF','homtht':'\u223B','hookleftarrow':'\u21A9','hookrightarrow':'\u21AA','hopf':'\uD835\uDD59','Hopf':'ℍ','horbar':'\u2015','HorizontalLine':'\u2500','hscr':'\uD835\uDCBD','Hscr':'ℋ','hslash':'ℏ','Hstrok':'Ħ','hstrok':'ħ','HumpDownHump':'\u224E','HumpEqual':'\u224F','hybull':'\u2043','hyphen':'\u2010','Iacute':'Í','iacute':'í','ic':'\u2063','Icirc':'Î','icirc':'î','Icy':'И','icy':'и','Idot':'İ','IEcy':'Е','iecy':'е','iexcl':'\xA1','iff':'\u21D4','ifr':'\uD835\uDD26','Ifr':'ℑ','Igrave':'Ì','igrave':'ì','ii':'ⅈ','iiiint':'\u2A0C','iiint':'\u222D','iinfin':'\u29DC','iiota':'\u2129','IJlig':'Ĳ','ijlig':'ĳ','Imacr':'Ī','imacr':'ī','image':'ℑ','ImaginaryI':'ⅈ','imagline':'ℐ','imagpart':'ℑ','imath':'ı','Im':'ℑ','imof':'\u22B7','imped':'Ƶ','Implies':'\u21D2','incare':'\u2105','in':'\u2208','infin':'\u221E','infintie':'\u29DD','inodot':'ı','intcal':'\u22BA','int':'\u222B','Int':'\u222C','integers':'ℤ','Integral':'\u222B','intercal':'\u22BA','Intersection':'\u22C2','intlarhk':'\u2A17','intprod':'\u2A3C','InvisibleComma':'\u2063','InvisibleTimes':'\u2062','IOcy':'Ё','iocy':'ё','Iogon':'Į','iogon':'į','Iopf':'\uD835\uDD40','iopf':'\uD835\uDD5A','Iota':'Ι','iota':'ι','iprod':'\u2A3C','iquest':'\xBF','iscr':'\uD835\uDCBE','Iscr':'ℐ','isin':'\u2208','isindot':'\u22F5','isinE':'\u22F9','isins':'\u22F4','isinsv':'\u22F3','isinv':'\u2208','it':'\u2062','Itilde':'Ĩ','itilde':'ĩ','Iukcy':'І','iukcy':'і','Iuml':'Ï','iuml':'ï','Jcirc':'Ĵ','jcirc':'ĵ','Jcy':'Й','jcy':'й','Jfr':'\uD835\uDD0D','jfr':'\uD835\uDD27','jmath':'ȷ','Jopf':'\uD835\uDD41','jopf':'\uD835\uDD5B','Jscr':'\uD835\uDCA5','jscr':'\uD835\uDCBF','Jsercy':'Ј','jsercy':'ј','Jukcy':'Є','jukcy':'є','Kappa':'Κ','kappa':'κ','kappav':'ϰ','Kcedil':'Ķ','kcedil':'ķ','Kcy':'К','kcy':'к','Kfr':'\uD835\uDD0E','kfr':'\uD835\uDD28','kgreen':'ĸ','KHcy':'Х','khcy':'х','KJcy':'Ќ','kjcy':'ќ','Kopf':'\uD835\uDD42','kopf':'\uD835\uDD5C','Kscr':'\uD835\uDCA6','kscr':'\uD835\uDCC0','lAarr':'\u21DA','Lacute':'Ĺ','lacute':'ĺ','laemptyv':'\u29B4','lagran':'ℒ','Lambda':'Λ','lambda':'λ','lang':'\u27E8','Lang':'\u27EA','langd':'\u2991','langle':'\u27E8','lap':'\u2A85','Laplacetrf':'ℒ','laquo':'\xAB','larrb':'\u21E4','larrbfs':'\u291F','larr':'\u2190','Larr':'\u219E','lArr':'\u21D0','larrfs':'\u291D','larrhk':'\u21A9','larrlp':'\u21AB','larrpl':'\u2939','larrsim':'\u2973','larrtl':'\u21A2','latail':'\u2919','lAtail':'\u291B','lat':'\u2AAB','late':'\u2AAD','lates':'\u2AAD︀','lbarr':'\u290C','lBarr':'\u290E','lbbrk':'\u2772','lbrace':'{','lbrack':'[','lbrke':'\u298B','lbrksld':'\u298F','lbrkslu':'\u298D','Lcaron':'Ľ','lcaron':'ľ','Lcedil':'Ļ','lcedil':'ļ','lceil':'\u2308','lcub':'{','Lcy':'Л','lcy':'л','ldca':'\u2936','ldquo':'\u201C','ldquor':'\u201E','ldrdhar':'\u2967','ldrushar':'\u294B','ldsh':'\u21B2','le':'\u2264','lE':'\u2266','LeftAngleBracket':'\u27E8','LeftArrowBar':'\u21E4','leftarrow':'\u2190','LeftArrow':'\u2190','Leftarrow':'\u21D0','LeftArrowRightArrow':'\u21C6','leftarrowtail':'\u21A2','LeftCeiling':'\u2308','LeftDoubleBracket':'\u27E6','LeftDownTeeVector':'\u2961','LeftDownVectorBar':'\u2959','LeftDownVector':'\u21C3','LeftFloor':'\u230A','leftharpoondown':'\u21BD','leftharpoonup':'\u21BC','leftleftarrows':'\u21C7','leftrightarrow':'\u2194','LeftRightArrow':'\u2194','Leftrightarrow':'\u21D4','leftrightarrows':'\u21C6','leftrightharpoons':'\u21CB','leftrightsquigarrow':'\u21AD','LeftRightVector':'\u294E','LeftTeeArrow':'\u21A4','LeftTee':'\u22A3','LeftTeeVector':'\u295A','leftthreetimes':'\u22CB','LeftTriangleBar':'\u29CF','LeftTriangle':'\u22B2','LeftTriangleEqual':'\u22B4','LeftUpDownVector':'\u2951','LeftUpTeeVector':'\u2960','LeftUpVectorBar':'\u2958','LeftUpVector':'\u21BF','LeftVectorBar':'\u2952','LeftVector':'\u21BC','lEg':'\u2A8B','leg':'\u22DA','leq':'\u2264','leqq':'\u2266','leqslant':'\u2A7D','lescc':'\u2AA8','les':'\u2A7D','lesdot':'\u2A7F','lesdoto':'\u2A81','lesdotor':'\u2A83','lesg':'\u22DA︀','lesges':'\u2A93','lessapprox':'\u2A85','lessdot':'\u22D6','lesseqgtr':'\u22DA','lesseqqgtr':'\u2A8B','LessEqualGreater':'\u22DA','LessFullEqual':'\u2266','LessGreater':'\u2276','lessgtr':'\u2276','LessLess':'\u2AA1','lesssim':'\u2272','LessSlantEqual':'\u2A7D','LessTilde':'\u2272','lfisht':'\u297C','lfloor':'\u230A','Lfr':'\uD835\uDD0F','lfr':'\uD835\uDD29','lg':'\u2276','lgE':'\u2A91','lHar':'\u2962','lhard':'\u21BD','lharu':'\u21BC','lharul':'\u296A','lhblk':'\u2584','LJcy':'Љ','ljcy':'љ','llarr':'\u21C7','ll':'\u226A','Ll':'\u22D8','llcorner':'\u231E','Lleftarrow':'\u21DA','llhard':'\u296B','lltri':'\u25FA','Lmidot':'Ŀ','lmidot':'ŀ','lmoustache':'\u23B0','lmoust':'\u23B0','lnap':'\u2A89','lnapprox':'\u2A89','lne':'\u2A87','lnE':'\u2268','lneq':'\u2A87','lneqq':'\u2268','lnsim':'\u22E6','loang':'\u27EC','loarr':'\u21FD','lobrk':'\u27E6','longleftarrow':'\u27F5','LongLeftArrow':'\u27F5','Longleftarrow':'\u27F8','longleftrightarrow':'\u27F7','LongLeftRightArrow':'\u27F7','Longleftrightarrow':'\u27FA','longmapsto':'\u27FC','longrightarrow':'\u27F6','LongRightArrow':'\u27F6','Longrightarrow':'\u27F9','looparrowleft':'\u21AB','looparrowright':'\u21AC','lopar':'\u2985','Lopf':'\uD835\uDD43','lopf':'\uD835\uDD5D','loplus':'\u2A2D','lotimes':'\u2A34','lowast':'\u2217','lowbar':'_','LowerLeftArrow':'\u2199','LowerRightArrow':'\u2198','loz':'\u25CA','lozenge':'\u25CA','lozf':'\u29EB','lpar':'(','lparlt':'\u2993','lrarr':'\u21C6','lrcorner':'\u231F','lrhar':'\u21CB','lrhard':'\u296D','lrm':'\u200E','lrtri':'\u22BF','lsaquo':'\u2039','lscr':'\uD835\uDCC1','Lscr':'ℒ','lsh':'\u21B0','Lsh':'\u21B0','lsim':'\u2272','lsime':'\u2A8D','lsimg':'\u2A8F','lsqb':'[','lsquo':'\u2018','lsquor':'\u201A','Lstrok':'Ł','lstrok':'ł','ltcc':'\u2AA6','ltcir':'\u2A79','lt':'<','LT':'<','Lt':'\u226A','ltdot':'\u22D6','lthree':'\u22CB','ltimes':'\u22C9','ltlarr':'\u2976','ltquest':'\u2A7B','ltri':'\u25C3','ltrie':'\u22B4','ltrif':'\u25C2','ltrPar':'\u2996','lurdshar':'\u294A','luruhar':'\u2966','lvertneqq':'\u2268︀','lvnE':'\u2268︀','macr':'\xAF','male':'\u2642','malt':'\u2720','maltese':'\u2720','Map':'\u2905','map':'\u21A6','mapsto':'\u21A6','mapstodown':'\u21A7','mapstoleft':'\u21A4','mapstoup':'\u21A5','marker':'\u25AE','mcomma':'\u2A29','Mcy':'М','mcy':'м','mdash':'\u2014','mDDot':'\u223A','measuredangle':'\u2221','MediumSpace':'\u205F','Mellintrf':'ℳ','Mfr':'\uD835\uDD10','mfr':'\uD835\uDD2A','mho':'\u2127','micro':'µ','midast':'*','midcir':'\u2AF0','mid':'\u2223','middot':'\xB7','minusb':'\u229F','minus':'\u2212','minusd':'\u2238','minusdu':'\u2A2A','MinusPlus':'\u2213','mlcp':'\u2ADB','mldr':'\u2026','mnplus':'\u2213','models':'\u22A7','Mopf':'\uD835\uDD44','mopf':'\uD835\uDD5E','mp':'\u2213','mscr':'\uD835\uDCC2','Mscr':'ℳ','mstpos':'\u223E','Mu':'Μ','mu':'μ','multimap':'\u22B8','mumap':'\u22B8','nabla':'\u2207','Nacute':'Ń','nacute':'ń','nang':'\u2220⃒','nap':'\u2249','napE':'\u2A70̸','napid':'\u224B̸','napos':'ŉ','napprox':'\u2249','natural':'\u266E','naturals':'ℕ','natur':'\u266E','nbsp':'\xA0','nbump':'\u224E̸','nbumpe':'\u224F̸','ncap':'\u2A43','Ncaron':'Ň','ncaron':'ň','Ncedil':'Ņ','ncedil':'ņ','ncong':'\u2247','ncongdot':'\u2A6D̸','ncup':'\u2A42','Ncy':'Н','ncy':'н','ndash':'\u2013','nearhk':'\u2924','nearr':'\u2197','neArr':'\u21D7','nearrow':'\u2197','ne':'\u2260','nedot':'\u2250̸','NegativeMediumSpace':'\u200B','NegativeThickSpace':'\u200B','NegativeThinSpace':'\u200B','NegativeVeryThinSpace':'\u200B','nequiv':'\u2262','nesear':'\u2928','nesim':'\u2242̸','NestedGreaterGreater':'\u226B','NestedLessLess':'\u226A','NewLine':'\n','nexist':'\u2204','nexists':'\u2204','Nfr':'\uD835\uDD11','nfr':'\uD835\uDD2B','ngE':'\u2267̸','nge':'\u2271','ngeq':'\u2271','ngeqq':'\u2267̸','ngeqslant':'\u2A7E̸','nges':'\u2A7E̸','nGg':'\u22D9̸','ngsim':'\u2275','nGt':'\u226B⃒','ngt':'\u226F','ngtr':'\u226F','nGtv':'\u226B̸','nharr':'\u21AE','nhArr':'\u21CE','nhpar':'\u2AF2','ni':'\u220B','nis':'\u22FC','nisd':'\u22FA','niv':'\u220B','NJcy':'Њ','njcy':'њ','nlarr':'\u219A','nlArr':'\u21CD','nldr':'\u2025','nlE':'\u2266̸','nle':'\u2270','nleftarrow':'\u219A','nLeftarrow':'\u21CD','nleftrightarrow':'\u21AE','nLeftrightarrow':'\u21CE','nleq':'\u2270','nleqq':'\u2266̸','nleqslant':'\u2A7D̸','nles':'\u2A7D̸','nless':'\u226E','nLl':'\u22D8̸','nlsim':'\u2274','nLt':'\u226A⃒','nlt':'\u226E','nltri':'\u22EA','nltrie':'\u22EC','nLtv':'\u226A̸','nmid':'\u2224','NoBreak':'\u2060','NonBreakingSpace':'\xA0','nopf':'\uD835\uDD5F','Nopf':'ℕ','Not':'\u2AEC','not':'\xAC','NotCongruent':'\u2262','NotCupCap':'\u226D','NotDoubleVerticalBar':'\u2226','NotElement':'\u2209','NotEqual':'\u2260','NotEqualTilde':'\u2242̸','NotExists':'\u2204','NotGreater':'\u226F','NotGreaterEqual':'\u2271','NotGreaterFullEqual':'\u2267̸','NotGreaterGreater':'\u226B̸','NotGreaterLess':'\u2279','NotGreaterSlantEqual':'\u2A7E̸','NotGreaterTilde':'\u2275','NotHumpDownHump':'\u224E̸','NotHumpEqual':'\u224F̸','notin':'\u2209','notindot':'\u22F5̸','notinE':'\u22F9̸','notinva':'\u2209','notinvb':'\u22F7','notinvc':'\u22F6','NotLeftTriangleBar':'\u29CF̸','NotLeftTriangle':'\u22EA','NotLeftTriangleEqual':'\u22EC','NotLess':'\u226E','NotLessEqual':'\u2270','NotLessGreater':'\u2278','NotLessLess':'\u226A̸','NotLessSlantEqual':'\u2A7D̸','NotLessTilde':'\u2274','NotNestedGreaterGreater':'\u2AA2̸','NotNestedLessLess':'\u2AA1̸','notni':'\u220C','notniva':'\u220C','notnivb':'\u22FE','notnivc':'\u22FD','NotPrecedes':'\u2280','NotPrecedesEqual':'\u2AAF̸','NotPrecedesSlantEqual':'\u22E0','NotReverseElement':'\u220C','NotRightTriangleBar':'\u29D0̸','NotRightTriangle':'\u22EB','NotRightTriangleEqual':'\u22ED','NotSquareSubset':'\u228F̸','NotSquareSubsetEqual':'\u22E2','NotSquareSuperset':'\u2290̸','NotSquareSupersetEqual':'\u22E3','NotSubset':'\u2282⃒','NotSubsetEqual':'\u2288','NotSucceeds':'\u2281','NotSucceedsEqual':'\u2AB0̸','NotSucceedsSlantEqual':'\u22E1','NotSucceedsTilde':'\u227F̸','NotSuperset':'\u2283⃒','NotSupersetEqual':'\u2289','NotTilde':'\u2241','NotTildeEqual':'\u2244','NotTildeFullEqual':'\u2247','NotTildeTilde':'\u2249','NotVerticalBar':'\u2224','nparallel':'\u2226','npar':'\u2226','nparsl':'\u2AFD⃥','npart':'\u2202̸','npolint':'\u2A14','npr':'\u2280','nprcue':'\u22E0','nprec':'\u2280','npreceq':'\u2AAF̸','npre':'\u2AAF̸','nrarrc':'\u2933̸','nrarr':'\u219B','nrArr':'\u21CF','nrarrw':'\u219D̸','nrightarrow':'\u219B','nRightarrow':'\u21CF','nrtri':'\u22EB','nrtrie':'\u22ED','nsc':'\u2281','nsccue':'\u22E1','nsce':'\u2AB0̸','Nscr':'\uD835\uDCA9','nscr':'\uD835\uDCC3','nshortmid':'\u2224','nshortparallel':'\u2226','nsim':'\u2241','nsime':'\u2244','nsimeq':'\u2244','nsmid':'\u2224','nspar':'\u2226','nsqsube':'\u22E2','nsqsupe':'\u22E3','nsub':'\u2284','nsubE':'\u2AC5̸','nsube':'\u2288','nsubset':'\u2282⃒','nsubseteq':'\u2288','nsubseteqq':'\u2AC5̸','nsucc':'\u2281','nsucceq':'\u2AB0̸','nsup':'\u2285','nsupE':'\u2AC6̸','nsupe':'\u2289','nsupset':'\u2283⃒','nsupseteq':'\u2289','nsupseteqq':'\u2AC6̸','ntgl':'\u2279','Ntilde':'Ñ','ntilde':'ñ','ntlg':'\u2278','ntriangleleft':'\u22EA','ntrianglelefteq':'\u22EC','ntriangleright':'\u22EB','ntrianglerighteq':'\u22ED','Nu':'Ν','nu':'ν','num':'#','numero':'\u2116','numsp':'\u2007','nvap':'\u224D⃒','nvdash':'\u22AC','nvDash':'\u22AD','nVdash':'\u22AE','nVDash':'\u22AF','nvge':'\u2265⃒','nvgt':'>⃒','nvHarr':'\u2904','nvinfin':'\u29DE','nvlArr':'\u2902','nvle':'\u2264⃒','nvlt':'<⃒','nvltrie':'\u22B4⃒','nvrArr':'\u2903','nvrtrie':'\u22B5⃒','nvsim':'\u223C⃒','nwarhk':'\u2923','nwarr':'\u2196','nwArr':'\u21D6','nwarrow':'\u2196','nwnear':'\u2927','Oacute':'Ó','oacute':'ó','oast':'\u229B','Ocirc':'Ô','ocirc':'ô','ocir':'\u229A','Ocy':'О','ocy':'о','odash':'\u229D','Odblac':'Ő','odblac':'ő','odiv':'\u2A38','odot':'\u2299','odsold':'\u29BC','OElig':'Œ','oelig':'œ','ofcir':'\u29BF','Ofr':'\uD835\uDD12','ofr':'\uD835\uDD2C','ogon':'\u02DB','Ograve':'Ò','ograve':'ò','ogt':'\u29C1','ohbar':'\u29B5','ohm':'Ω','oint':'\u222E','olarr':'\u21BA','olcir':'\u29BE','olcross':'\u29BB','oline':'\u203E','olt':'\u29C0','Omacr':'Ō','omacr':'ō','Omega':'Ω','omega':'ω','Omicron':'Ο','omicron':'ο','omid':'\u29B6','ominus':'\u2296','Oopf':'\uD835\uDD46','oopf':'\uD835\uDD60','opar':'\u29B7','OpenCurlyDoubleQuote':'\u201C','OpenCurlyQuote':'\u2018','operp':'\u29B9','oplus':'\u2295','orarr':'\u21BB','Or':'\u2A54','or':'\u2228','ord':'\u2A5D','order':'ℴ','orderof':'ℴ','ordf':'ª','ordm':'º','origof':'\u22B6','oror':'\u2A56','orslope':'\u2A57','orv':'\u2A5B','oS':'\u24C8','Oscr':'\uD835\uDCAA','oscr':'ℴ','Oslash':'Ø','oslash':'ø','osol':'\u2298','Otilde':'Õ','otilde':'õ','otimesas':'\u2A36','Otimes':'\u2A37','otimes':'\u2297','Ouml':'Ö','ouml':'ö','ovbar':'\u233D','OverBar':'\u203E','OverBrace':'\u23DE','OverBracket':'\u23B4','OverParenthesis':'\u23DC','para':'\xB6','parallel':'\u2225','par':'\u2225','parsim':'\u2AF3','parsl':'\u2AFD','part':'\u2202','PartialD':'\u2202','Pcy':'П','pcy':'п','percnt':'%','period':'.','permil':'\u2030','perp':'\u22A5','pertenk':'\u2031','Pfr':'\uD835\uDD13','pfr':'\uD835\uDD2D','Phi':'Φ','phi':'φ','phiv':'ϕ','phmmat':'ℳ','phone':'\u260E','Pi':'Π','pi':'π','pitchfork':'\u22D4','piv':'ϖ','planck':'ℏ','planckh':'ℎ','plankv':'ℏ','plusacir':'\u2A23','plusb':'\u229E','pluscir':'\u2A22','plus':'+','plusdo':'\u2214','plusdu':'\u2A25','pluse':'\u2A72','PlusMinus':'\xB1','plusmn':'\xB1','plussim':'\u2A26','plustwo':'\u2A27','pm':'\xB1','Poincareplane':'ℌ','pointint':'\u2A15','popf':'\uD835\uDD61','Popf':'ℙ','pound':'\xA3','prap':'\u2AB7','Pr':'\u2ABB','pr':'\u227A','prcue':'\u227C','precapprox':'\u2AB7','prec':'\u227A','preccurlyeq':'\u227C','Precedes':'\u227A','PrecedesEqual':'\u2AAF','PrecedesSlantEqual':'\u227C','PrecedesTilde':'\u227E','preceq':'\u2AAF','precnapprox':'\u2AB9','precneqq':'\u2AB5','precnsim':'\u22E8','pre':'\u2AAF','prE':'\u2AB3','precsim':'\u227E','prime':'\u2032','Prime':'\u2033','primes':'ℙ','prnap':'\u2AB9','prnE':'\u2AB5','prnsim':'\u22E8','prod':'\u220F','Product':'\u220F','profalar':'\u232E','profline':'\u2312','profsurf':'\u2313','prop':'\u221D','Proportional':'\u221D','Proportion':'\u2237','propto':'\u221D','prsim':'\u227E','prurel':'\u22B0','Pscr':'\uD835\uDCAB','pscr':'\uD835\uDCC5','Psi':'Ψ','psi':'ψ','puncsp':'\u2008','Qfr':'\uD835\uDD14','qfr':'\uD835\uDD2E','qint':'\u2A0C','qopf':'\uD835\uDD62','Qopf':'ℚ','qprime':'\u2057','Qscr':'\uD835\uDCAC','qscr':'\uD835\uDCC6','quaternions':'ℍ','quatint':'\u2A16','quest':'?','questeq':'\u225F','quot':'"','QUOT':'"','rAarr':'\u21DB','race':'\u223Ḏ','Racute':'Ŕ','racute':'ŕ','radic':'\u221A','raemptyv':'\u29B3','rang':'\u27E9','Rang':'\u27EB','rangd':'\u2992','range':'\u29A5','rangle':'\u27E9','raquo':'\xBB','rarrap':'\u2975','rarrb':'\u21E5','rarrbfs':'\u2920','rarrc':'\u2933','rarr':'\u2192','Rarr':'\u21A0','rArr':'\u21D2','rarrfs':'\u291E','rarrhk':'\u21AA','rarrlp':'\u21AC','rarrpl':'\u2945','rarrsim':'\u2974','Rarrtl':'\u2916','rarrtl':'\u21A3','rarrw':'\u219D','ratail':'\u291A','rAtail':'\u291C','ratio':'\u2236','rationals':'ℚ','rbarr':'\u290D','rBarr':'\u290F','RBarr':'\u2910','rbbrk':'\u2773','rbrace':'}','rbrack':']','rbrke':'\u298C','rbrksld':'\u298E','rbrkslu':'\u2990','Rcaron':'Ř','rcaron':'ř','Rcedil':'Ŗ','rcedil':'ŗ','rceil':'\u2309','rcub':'}','Rcy':'Р','rcy':'р','rdca':'\u2937','rdldhar':'\u2969','rdquo':'\u201D','rdquor':'\u201D','rdsh':'\u21B3','real':'ℜ','realine':'ℛ','realpart':'ℜ','reals':'ℝ','Re':'ℜ','rect':'\u25AD','reg':'\xAE','REG':'\xAE','ReverseElement':'\u220B','ReverseEquilibrium':'\u21CB','ReverseUpEquilibrium':'\u296F','rfisht':'\u297D','rfloor':'\u230B','rfr':'\uD835\uDD2F','Rfr':'ℜ','rHar':'\u2964','rhard':'\u21C1','rharu':'\u21C0','rharul':'\u296C','Rho':'Ρ','rho':'ρ','rhov':'ϱ','RightAngleBracket':'\u27E9','RightArrowBar':'\u21E5','rightarrow':'\u2192','RightArrow':'\u2192','Rightarrow':'\u21D2','RightArrowLeftArrow':'\u21C4','rightarrowtail':'\u21A3','RightCeiling':'\u2309','RightDoubleBracket':'\u27E7','RightDownTeeVector':'\u295D','RightDownVectorBar':'\u2955','RightDownVector':'\u21C2','RightFloor':'\u230B','rightharpoondown':'\u21C1','rightharpoonup':'\u21C0','rightleftarrows':'\u21C4','rightleftharpoons':'\u21CC','rightrightarrows':'\u21C9','rightsquigarrow':'\u219D','RightTeeArrow':'\u21A6','RightTee':'\u22A2','RightTeeVector':'\u295B','rightthreetimes':'\u22CC','RightTriangleBar':'\u29D0','RightTriangle':'\u22B3','RightTriangleEqual':'\u22B5','RightUpDownVector':'\u294F','RightUpTeeVector':'\u295C','RightUpVectorBar':'\u2954','RightUpVector':'\u21BE','RightVectorBar':'\u2953','RightVector':'\u21C0','ring':'\u02DA','risingdotseq':'\u2253','rlarr':'\u21C4','rlhar':'\u21CC','rlm':'\u200F','rmoustache':'\u23B1','rmoust':'\u23B1','rnmid':'\u2AEE','roang':'\u27ED','roarr':'\u21FE','robrk':'\u27E7','ropar':'\u2986','ropf':'\uD835\uDD63','Ropf':'ℝ','roplus':'\u2A2E','rotimes':'\u2A35','RoundImplies':'\u2970','rpar':')','rpargt':'\u2994','rppolint':'\u2A12','rrarr':'\u21C9','Rrightarrow':'\u21DB','rsaquo':'\u203A','rscr':'\uD835\uDCC7','Rscr':'ℛ','rsh':'\u21B1','Rsh':'\u21B1','rsqb':']','rsquo':'\u2019','rsquor':'\u2019','rthree':'\u22CC','rtimes':'\u22CA','rtri':'\u25B9','rtrie':'\u22B5','rtrif':'\u25B8','rtriltri':'\u29CE','RuleDelayed':'\u29F4','ruluhar':'\u2968','rx':'\u211E','Sacute':'Ś','sacute':'ś','sbquo':'\u201A','scap':'\u2AB8','Scaron':'Š','scaron':'š','Sc':'\u2ABC','sc':'\u227B','sccue':'\u227D','sce':'\u2AB0','scE':'\u2AB4','Scedil':'Ş','scedil':'ş','Scirc':'Ŝ','scirc':'ŝ','scnap':'\u2ABA','scnE':'\u2AB6','scnsim':'\u22E9','scpolint':'\u2A13','scsim':'\u227F','Scy':'С','scy':'с','sdotb':'\u22A1','sdot':'\u22C5','sdote':'\u2A66','searhk':'\u2925','searr':'\u2198','seArr':'\u21D8','searrow':'\u2198','sect':'\xA7','semi':';','seswar':'\u2929','setminus':'\u2216','setmn':'\u2216','sext':'\u2736','Sfr':'\uD835\uDD16','sfr':'\uD835\uDD30','sfrown':'\u2322','sharp':'\u266F','SHCHcy':'Щ','shchcy':'щ','SHcy':'Ш','shcy':'ш','ShortDownArrow':'\u2193','ShortLeftArrow':'\u2190','shortmid':'\u2223','shortparallel':'\u2225','ShortRightArrow':'\u2192','ShortUpArrow':'\u2191','shy':'\xAD','Sigma':'Σ','sigma':'σ','sigmaf':'ς','sigmav':'ς','sim':'\u223C','simdot':'\u2A6A','sime':'\u2243','simeq':'\u2243','simg':'\u2A9E','simgE':'\u2AA0','siml':'\u2A9D','simlE':'\u2A9F','simne':'\u2246','simplus':'\u2A24','simrarr':'\u2972','slarr':'\u2190','SmallCircle':'\u2218','smallsetminus':'\u2216','smashp':'\u2A33','smeparsl':'\u29E4','smid':'\u2223','smile':'\u2323','smt':'\u2AAA','smte':'\u2AAC','smtes':'\u2AAC︀','SOFTcy':'Ь','softcy':'ь','solbar':'\u233F','solb':'\u29C4','sol':'/','Sopf':'\uD835\uDD4A','sopf':'\uD835\uDD64','spades':'\u2660','spadesuit':'\u2660','spar':'\u2225','sqcap':'\u2293','sqcaps':'\u2293︀','sqcup':'\u2294','sqcups':'\u2294︀','Sqrt':'\u221A','sqsub':'\u228F','sqsube':'\u2291','sqsubset':'\u228F','sqsubseteq':'\u2291','sqsup':'\u2290','sqsupe':'\u2292','sqsupset':'\u2290','sqsupseteq':'\u2292','square':'\u25A1','Square':'\u25A1','SquareIntersection':'\u2293','SquareSubset':'\u228F','SquareSubsetEqual':'\u2291','SquareSuperset':'\u2290','SquareSupersetEqual':'\u2292','SquareUnion':'\u2294','squarf':'\u25AA','squ':'\u25A1','squf':'\u25AA','srarr':'\u2192','Sscr':'\uD835\uDCAE','sscr':'\uD835\uDCC8','ssetmn':'\u2216','ssmile':'\u2323','sstarf':'\u22C6','Star':'\u22C6','star':'\u2606','starf':'\u2605','straightepsilon':'ϵ','straightphi':'ϕ','strns':'\xAF','sub':'\u2282','Sub':'\u22D0','subdot':'\u2ABD','subE':'\u2AC5','sube':'\u2286','subedot':'\u2AC3','submult':'\u2AC1','subnE':'\u2ACB','subne':'\u228A','subplus':'\u2ABF','subrarr':'\u2979','subset':'\u2282','Subset':'\u22D0','subseteq':'\u2286','subseteqq':'\u2AC5','SubsetEqual':'\u2286','subsetneq':'\u228A','subsetneqq':'\u2ACB','subsim':'\u2AC7','subsub':'\u2AD5','subsup':'\u2AD3','succapprox':'\u2AB8','succ':'\u227B','succcurlyeq':'\u227D','Succeeds':'\u227B','SucceedsEqual':'\u2AB0','SucceedsSlantEqual':'\u227D','SucceedsTilde':'\u227F','succeq':'\u2AB0','succnapprox':'\u2ABA','succneqq':'\u2AB6','succnsim':'\u22E9','succsim':'\u227F','SuchThat':'\u220B','sum':'\u2211','Sum':'\u2211','sung':'\u266A','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','sup':'\u2283','Sup':'\u22D1','supdot':'\u2ABE','supdsub':'\u2AD8','supE':'\u2AC6','supe':'\u2287','supedot':'\u2AC4','Superset':'\u2283','SupersetEqual':'\u2287','suphsol':'\u27C9','suphsub':'\u2AD7','suplarr':'\u297B','supmult':'\u2AC2','supnE':'\u2ACC','supne':'\u228B','supplus':'\u2AC0','supset':'\u2283','Supset':'\u22D1','supseteq':'\u2287','supseteqq':'\u2AC6','supsetneq':'\u228B','supsetneqq':'\u2ACC','supsim':'\u2AC8','supsub':'\u2AD4','supsup':'\u2AD6','swarhk':'\u2926','swarr':'\u2199','swArr':'\u21D9','swarrow':'\u2199','swnwar':'\u292A','szlig':'ß','Tab':'\t','target':'\u2316','Tau':'Τ','tau':'τ','tbrk':'\u23B4','Tcaron':'Ť','tcaron':'ť','Tcedil':'Ţ','tcedil':'ţ','Tcy':'Т','tcy':'т','tdot':'⃛','telrec':'\u2315','Tfr':'\uD835\uDD17','tfr':'\uD835\uDD31','there4':'\u2234','therefore':'\u2234','Therefore':'\u2234','Theta':'Θ','theta':'θ','thetasym':'ϑ','thetav':'ϑ','thickapprox':'\u2248','thicksim':'\u223C','ThickSpace':'\u205F\u200A','ThinSpace':'\u2009','thinsp':'\u2009','thkap':'\u2248','thksim':'\u223C','THORN':'Þ','thorn':'þ','tilde':'\u02DC','Tilde':'\u223C','TildeEqual':'\u2243','TildeFullEqual':'\u2245','TildeTilde':'\u2248','timesbar':'\u2A31','timesb':'\u22A0','times':'\xD7','timesd':'\u2A30','tint':'\u222D','toea':'\u2928','topbot':'\u2336','topcir':'\u2AF1','top':'\u22A4','Topf':'\uD835\uDD4B','topf':'\uD835\uDD65','topfork':'\u2ADA','tosa':'\u2929','tprime':'\u2034','trade':'\u2122','TRADE':'\u2122','triangle':'\u25B5','triangledown':'\u25BF','triangleleft':'\u25C3','trianglelefteq':'\u22B4','triangleq':'\u225C','triangleright':'\u25B9','trianglerighteq':'\u22B5','tridot':'\u25EC','trie':'\u225C','triminus':'\u2A3A','TripleDot':'⃛','triplus':'\u2A39','trisb':'\u29CD','tritime':'\u2A3B','trpezium':'\u23E2','Tscr':'\uD835\uDCAF','tscr':'\uD835\uDCC9','TScy':'Ц','tscy':'ц','TSHcy':'Ћ','tshcy':'ћ','Tstrok':'Ŧ','tstrok':'ŧ','twixt':'\u226C','twoheadleftarrow':'\u219E','twoheadrightarrow':'\u21A0','Uacute':'Ú','uacute':'ú','uarr':'\u2191','Uarr':'\u219F','uArr':'\u21D1','Uarrocir':'\u2949','Ubrcy':'Ў','ubrcy':'ў','Ubreve':'Ŭ','ubreve':'ŭ','Ucirc':'Û','ucirc':'û','Ucy':'У','ucy':'у','udarr':'\u21C5','Udblac':'Ű','udblac':'ű','udhar':'\u296E','ufisht':'\u297E','Ufr':'\uD835\uDD18','ufr':'\uD835\uDD32','Ugrave':'Ù','ugrave':'ù','uHar':'\u2963','uharl':'\u21BF','uharr':'\u21BE','uhblk':'\u2580','ulcorn':'\u231C','ulcorner':'\u231C','ulcrop':'\u230F','ultri':'\u25F8','Umacr':'Ū','umacr':'ū','uml':'\xA8','UnderBar':'_','UnderBrace':'\u23DF','UnderBracket':'\u23B5','UnderParenthesis':'\u23DD','Union':'\u22C3','UnionPlus':'\u228E','Uogon':'Ų','uogon':'ų','Uopf':'\uD835\uDD4C','uopf':'\uD835\uDD66','UpArrowBar':'\u2912','uparrow':'\u2191','UpArrow':'\u2191','Uparrow':'\u21D1','UpArrowDownArrow':'\u21C5','updownarrow':'\u2195','UpDownArrow':'\u2195','Updownarrow':'\u21D5','UpEquilibrium':'\u296E','upharpoonleft':'\u21BF','upharpoonright':'\u21BE','uplus':'\u228E','UpperLeftArrow':'\u2196','UpperRightArrow':'\u2197','upsi':'υ','Upsi':'ϒ','upsih':'ϒ','Upsilon':'Υ','upsilon':'υ','UpTeeArrow':'\u21A5','UpTee':'\u22A5','upuparrows':'\u21C8','urcorn':'\u231D','urcorner':'\u231D','urcrop':'\u230E','Uring':'Ů','uring':'ů','urtri':'\u25F9','Uscr':'\uD835\uDCB0','uscr':'\uD835\uDCCA','utdot':'\u22F0','Utilde':'Ũ','utilde':'ũ','utri':'\u25B5','utrif':'\u25B4','uuarr':'\u21C8','Uuml':'Ü','uuml':'ü','uwangle':'\u29A7','vangrt':'\u299C','varepsilon':'ϵ','varkappa':'ϰ','varnothing':'\u2205','varphi':'ϕ','varpi':'ϖ','varpropto':'\u221D','varr':'\u2195','vArr':'\u21D5','varrho':'ϱ','varsigma':'ς','varsubsetneq':'\u228A︀','varsubsetneqq':'\u2ACB︀','varsupsetneq':'\u228B︀','varsupsetneqq':'\u2ACC︀','vartheta':'ϑ','vartriangleleft':'\u22B2','vartriangleright':'\u22B3','vBar':'\u2AE8','Vbar':'\u2AEB','vBarv':'\u2AE9','Vcy':'В','vcy':'в','vdash':'\u22A2','vDash':'\u22A8','Vdash':'\u22A9','VDash':'\u22AB','Vdashl':'\u2AE6','veebar':'\u22BB','vee':'\u2228','Vee':'\u22C1','veeeq':'\u225A','vellip':'\u22EE','verbar':'|','Verbar':'\u2016','vert':'|','Vert':'\u2016','VerticalBar':'\u2223','VerticalLine':'|','VerticalSeparator':'\u2758','VerticalTilde':'\u2240','VeryThinSpace':'\u200A','Vfr':'\uD835\uDD19','vfr':'\uD835\uDD33','vltri':'\u22B2','vnsub':'\u2282⃒','vnsup':'\u2283⃒','Vopf':'\uD835\uDD4D','vopf':'\uD835\uDD67','vprop':'\u221D','vrtri':'\u22B3','Vscr':'\uD835\uDCB1','vscr':'\uD835\uDCCB','vsubnE':'\u2ACB︀','vsubne':'\u228A︀','vsupnE':'\u2ACC︀','vsupne':'\u228B︀','Vvdash':'\u22AA','vzigzag':'\u299A','Wcirc':'Ŵ','wcirc':'ŵ','wedbar':'\u2A5F','wedge':'\u2227','Wedge':'\u22C0','wedgeq':'\u2259','weierp':'\u2118','Wfr':'\uD835\uDD1A','wfr':'\uD835\uDD34','Wopf':'\uD835\uDD4E','wopf':'\uD835\uDD68','wp':'\u2118','wr':'\u2240','wreath':'\u2240','Wscr':'\uD835\uDCB2','wscr':'\uD835\uDCCC','xcap':'\u22C2','xcirc':'\u25EF','xcup':'\u22C3','xdtri':'\u25BD','Xfr':'\uD835\uDD1B','xfr':'\uD835\uDD35','xharr':'\u27F7','xhArr':'\u27FA','Xi':'Ξ','xi':'ξ','xlarr':'\u27F5','xlArr':'\u27F8','xmap':'\u27FC','xnis':'\u22FB','xodot':'\u2A00','Xopf':'\uD835\uDD4F','xopf':'\uD835\uDD69','xoplus':'\u2A01','xotime':'\u2A02','xrarr':'\u27F6','xrArr':'\u27F9','Xscr':'\uD835\uDCB3','xscr':'\uD835\uDCCD','xsqcup':'\u2A06','xuplus':'\u2A04','xutri':'\u25B3','xvee':'\u22C1','xwedge':'\u22C0','Yacute':'Ý','yacute':'ý','YAcy':'Я','yacy':'я','Ycirc':'Ŷ','ycirc':'ŷ','Ycy':'Ы','ycy':'ы','yen':'\xA5','Yfr':'\uD835\uDD1C','yfr':'\uD835\uDD36','YIcy':'Ї','yicy':'ї','Yopf':'\uD835\uDD50','yopf':'\uD835\uDD6A','Yscr':'\uD835\uDCB4','yscr':'\uD835\uDCCE','YUcy':'Ю','yucy':'ю','yuml':'ÿ','Yuml':'Ÿ','Zacute':'Ź','zacute':'ź','Zcaron':'Ž','zcaron':'ž','Zcy':'З','zcy':'з','Zdot':'Ż','zdot':'ż','zeetrf':'ℨ','ZeroWidthSpace':'\u200B','Zeta':'Ζ','zeta':'ζ','zfr':'\uD835\uDD37','Zfr':'ℨ','ZHcy':'Ж','zhcy':'ж','zigrarr':'\u21DD','zopf':'\uD835\uDD6B','Zopf':'ℤ','Zscr':'\uD835\uDCB5','zscr':'\uD835\uDCCF','zwj':'‍','zwnj':'‌'};},{}],42:[function(require,module,exports){module.exports={'Aacute':'Á','aacute':'á','Acirc':'Â','acirc':'â','acute':'\xB4','AElig':'Æ','aelig':'æ','Agrave':'À','agrave':'à','amp':'&','AMP':'&','Aring':'Å','aring':'å','Atilde':'Ã','atilde':'ã','Auml':'Ä','auml':'ä','brvbar':'\xA6','Ccedil':'Ç','ccedil':'ç','cedil':'\xB8','cent':'\xA2','copy':'\xA9','COPY':'\xA9','curren':'\xA4','deg':'\xB0','divide':'\xF7','Eacute':'É','eacute':'é','Ecirc':'Ê','ecirc':'ê','Egrave':'È','egrave':'è','ETH':'Ð','eth':'ð','Euml':'Ë','euml':'ë','frac12':'\xBD','frac14':'\xBC','frac34':'\xBE','gt':'>','GT':'>','Iacute':'Í','iacute':'í','Icirc':'Î','icirc':'î','iexcl':'\xA1','Igrave':'Ì','igrave':'ì','iquest':'\xBF','Iuml':'Ï','iuml':'ï','laquo':'\xAB','lt':'<','LT':'<','macr':'\xAF','micro':'µ','middot':'\xB7','nbsp':'\xA0','not':'\xAC','Ntilde':'Ñ','ntilde':'ñ','Oacute':'Ó','oacute':'ó','Ocirc':'Ô','ocirc':'ô','Ograve':'Ò','ograve':'ò','ordf':'ª','ordm':'º','Oslash':'Ø','oslash':'ø','Otilde':'Õ','otilde':'õ','Ouml':'Ö','ouml':'ö','para':'\xB6','plusmn':'\xB1','pound':'\xA3','quot':'"','QUOT':'"','raquo':'\xBB','reg':'\xAE','REG':'\xAE','sect':'\xA7','shy':'\xAD','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','szlig':'ß','THORN':'Þ','thorn':'þ','times':'\xD7','Uacute':'Ú','uacute':'ú','Ucirc':'Û','ucirc':'û','Ugrave':'Ù','ugrave':'ù','uml':'\xA8','Uuml':'Ü','uuml':'ü','Yacute':'Ý','yacute':'ý','yen':'\xA5','yuml':'ÿ'};},{}],43:[function(require,module,exports){arguments[4][27][0].apply(exports,arguments);},{'dup':27}],44:[function(require,module,exports){(function(global){(function(){(function(){'use strict';var Syntax,Precedence,BinaryPrecedence,SourceNode,estraverse,esutils,isArray,base,indent,json,renumber,hexadecimal,quotes,escapeless,newline,space,parentheses,semicolons,safeConcatenation,directive,extra,parse,sourceMap,sourceCode,preserveBlankLines,FORMAT_MINIFY,FORMAT_DEFAULTS;estraverse=require('estraverse');esutils=require('esutils');Syntax=estraverse.Syntax;Syntax.ExperimentalSpreadProperty='ExperimentalSpreadProperty';estraverse.VisitorKeys.ExperimentalSpreadProperty=['argument'];Syntax.ExperimentalRestProperty='ExperimentalRestProperty';estraverse.VisitorKeys.ExperimentalRestProperty=['argument'];Syntax.Import='Import';estraverse.VisitorKeys.Import=[];function isExpression(node){return CodeGenerator.Expression.hasOwnProperty(node.type);}function isStatement(node){return CodeGenerator.Statement.hasOwnProperty(node.type);}Precedence={Sequence:0,Yield:1,Await:1,Assignment:1,Conditional:2,ArrowFunction:2,LogicalOR:3,LogicalAND:4,BitwiseOR:5,BitwiseXOR:6,BitwiseAND:7,Equality:8,Relational:9,BitwiseSHIFT:10,Additive:11,Multiplicative:12,Exponentiation:13,Unary:14,ExponentiationWithUnaryAtLeft:15,Postfix:16,Call:17,New:18,TaggedTemplate:19,Member:20,Primary:21};BinaryPrecedence={'||':Precedence.LogicalOR,'&&':Precedence.LogicalAND,'|':Precedence.BitwiseOR,'^':Precedence.BitwiseXOR,'&':Precedence.BitwiseAND,'==':Precedence.Equality,'!=':Precedence.Equality,'===':Precedence.Equality,'!==':Precedence.Equality,'is':Precedence.Equality,'isnt':Precedence.Equality,'<':Precedence.Relational,'>':Precedence.Relational,'<=':Precedence.Relational,'>=':Precedence.Relational,'in':Precedence.Relational,'instanceof':Precedence.Relational,'<<':Precedence.BitwiseSHIFT,'>>':Precedence.BitwiseSHIFT,'>>>':Precedence.BitwiseSHIFT,'+':Precedence.Additive,'-':Precedence.Additive,'*':Precedence.Multiplicative,'%':Precedence.Multiplicative,'/':Precedence.Multiplicative,'**':Precedence.Exponentiation};var F_ALLOW_IN=1,F_ALLOW_CALL=1<<1,F_ALLOW_UNPARATH_NEW=1<<2,F_FUNC_BODY=1<<3,F_DIRECTIVE_CTX=1<<4,F_SEMICOLON_OPT=1<<5;var E_FTT=F_ALLOW_CALL|F_ALLOW_UNPARATH_NEW,E_TTF=F_ALLOW_IN|F_ALLOW_CALL,E_TTT=F_ALLOW_IN|F_ALLOW_CALL|F_ALLOW_UNPARATH_NEW,E_TFF=F_ALLOW_IN,E_FFT=F_ALLOW_UNPARATH_NEW,E_TFT=F_ALLOW_IN|F_ALLOW_UNPARATH_NEW;var S_TFFF=F_ALLOW_IN,S_TFFT=F_ALLOW_IN|F_SEMICOLON_OPT,S_FFFF=0,S_TFTF=F_ALLOW_IN|F_DIRECTIVE_CTX,S_TTFF=F_ALLOW_IN|F_FUNC_BODY;function getDefaultOptions(){return{indent:null,base:null,parse:null,comment:false,format:{indent:{style:'    ',base:0,adjustMultilineComment:false},newline:'\n',space:' ',json:false,renumber:false,hexadecimal:false,quotes:'single',escapeless:false,compact:false,parentheses:true,semicolons:true,safeConcatenation:false,preserveBlankLines:false},moz:{comprehensionExpressionStartsWithAssignment:false,starlessGenerator:false},sourceMap:null,sourceMapRoot:null,sourceMapWithCode:false,directive:false,raw:true,verbatim:null,sourceCode:null};}function stringRepeat(str,num){var result='';for(num|=0;num>0;num>>>=1,str+=str){if(num&1){result+=str;}}return result;}isArray=Array.isArray;if(!isArray){isArray=function isArray(array){return Object.prototype.toString.call(array)==='[object Array]';};}function hasLineTerminator(str){return/[\r\n]/g.test(str);}function endsWithLineTerminator(str){var len=str.length;return len&&esutils.code.isLineTerminator(str.charCodeAt(len-1));}function merge(target,override){var key;for(key in override){if(override.hasOwnProperty(key)){target[key]=override[key];}}return target;}function updateDeeply(target,override){var key,val;function isHashObject(target){return typeof target==='object'&&target instanceof Object&&!(target instanceof RegExp);}for(key in override){if(override.hasOwnProperty(key)){val=override[key];if(isHashObject(val)){if(isHashObject(target[key])){updateDeeply(target[key],val);}else{target[key]=updateDeeply({},val);}}else{target[key]=val;}}}return target;}function generateNumber(value){var result,point,temp,exponent,pos;if(value!==value){throw new Error('Numeric literal whose value is NaN');}if(value<0||value===0&&1/value<0){throw new Error('Numeric literal whose value is negative');}if(value===1/0){return json?'null':renumber?'1e400':'1e+400';}result=''+value;if(!renumber||result.length<3){return result;}point=result.indexOf('.');if(!json&&result.charCodeAt(0)===48&&point===1){point=0;result=result.slice(1);}temp=result;result=result.replace('e+','e');exponent=0;if((pos=temp.indexOf('e'))>0){exponent=+temp.slice(pos+1);temp=temp.slice(0,pos);}if(point>=0){exponent-=temp.length-point-1;temp=+(temp.slice(0,point)+temp.slice(point+1))+'';}pos=0;while(temp.charCodeAt(temp.length+pos-1)===48){--pos;}if(pos!==0){exponent-=pos;temp=temp.slice(0,pos);}if(exponent!==0){temp+='e'+exponent;}if((temp.length<result.length||hexadecimal&&value>1000000000000&&Math.floor(value)===value&&(temp='0x'+value.toString(16)).length<result.length)&&+temp===value){result=temp;}return result;}function escapeRegExpCharacter(ch,previousIsBackslash){if((ch&~1)===8232){return(previousIsBackslash?'u':'\\u')+(ch===8232?'2028':'2029');}else if(ch===10||ch===13){return(previousIsBackslash?'':'\\')+(ch===10?'n':'r');}return String.fromCharCode(ch);}function generateRegExp(reg){var match,result,flags,i,iz,ch,characterInBrack,previousIsBackslash;result=reg.toString();if(reg.source){match=result.match(/\/([^/]*)$/);if(!match){return result;}flags=match[1];result='';characterInBrack=false;previousIsBackslash=false;for(i=0,iz=reg.source.length;i<iz;++i){ch=reg.source.charCodeAt(i);if(!previousIsBackslash){if(characterInBrack){if(ch===93){characterInBrack=false;}}else{if(ch===47){result+='\\';}else if(ch===91){characterInBrack=true;}}result+=escapeRegExpCharacter(ch,previousIsBackslash);previousIsBackslash=ch===92;}else{result+=escapeRegExpCharacter(ch,previousIsBackslash);previousIsBackslash=false;}}return'/'+result+'/'+flags;}return result;}function escapeAllowedCharacter(code,next){var hex;if(code===8){return'\\b';}if(code===12){return'\\f';}if(code===9){return'\\t';}hex=code.toString(16).toUpperCase();if(json||code>255){return'\\u'+'0000'.slice(hex.length)+hex;}else if(code===0&&!esutils.code.isDecimalDigit(next)){return'\\0';}else if(code===11){return'\\x0B';}else{return'\\x'+'00'.slice(hex.length)+hex;}}function escapeDisallowedCharacter(code){if(code===92){return'\\\\';}if(code===10){return'\\n';}if(code===13){return'\\r';}if(code===8232){return'\\u2028';}if(code===8233){return'\\u2029';}throw new Error('Incorrectly classified character');}function escapeDirective(str){var i,iz,code,quote;quote=quotes==='double'?'"':'\'';for(i=0,iz=str.length;i<iz;++i){code=str.charCodeAt(i);if(code===39){quote='"';break;}else if(code===34){quote='\'';break;}else if(code===92){++i;}}return quote+str+quote;}function escapeString(str){var result='',i,len,code,singleQuotes=0,doubleQuotes=0,single,quote;for(i=0,len=str.length;i<len;++i){code=str.charCodeAt(i);if(code===39){++singleQuotes;}else if(code===34){++doubleQuotes;}else if(code===47&&json){result+='\\';}else if(esutils.code.isLineTerminator(code)||code===92){result+=escapeDisallowedCharacter(code);continue;}else if(!esutils.code.isIdentifierPartES5(code)&&(json&&code<32||!json&&!escapeless&&(code<32||code>126))){result+=escapeAllowedCharacter(code,str.charCodeAt(i+1));continue;}result+=String.fromCharCode(code);}single=!(quotes==='double'||quotes==='auto'&&doubleQuotes<singleQuotes);quote=single?'\'':'"';if(!(single?singleQuotes:doubleQuotes)){return quote+result+quote;}str=result;result=quote;for(i=0,len=str.length;i<len;++i){code=str.charCodeAt(i);if(code===39&&single||code===34&&!single){result+='\\';}result+=String.fromCharCode(code);}return result+quote;}function flattenToString(arr){var i,iz,elem,result='';for(i=0,iz=arr.length;i<iz;++i){elem=arr[i];result+=isArray(elem)?flattenToString(elem):elem;}return result;}function toSourceNodeWhenNeeded(generated,node){if(!sourceMap){if(isArray(generated)){return flattenToString(generated);}else{return generated;}}if(node==null){if(generated instanceof SourceNode){return generated;}else{node={};}}if(node.loc==null){return new SourceNode(null,null,sourceMap,generated,node.name||null);}return new SourceNode(node.loc.start.line,node.loc.start.column,sourceMap===true?node.loc.source||null:sourceMap,generated,node.name||null);}function noEmptySpace(){return space?space:' ';}function join(left,right){var leftSource,rightSource,leftCharCode,rightCharCode;leftSource=toSourceNodeWhenNeeded(left).toString();if(leftSource.length===0){return[right];}rightSource=toSourceNodeWhenNeeded(right).toString();if(rightSource.length===0){return[left];}leftCharCode=leftSource.charCodeAt(leftSource.length-1);rightCharCode=rightSource.charCodeAt(0);if((leftCharCode===43||leftCharCode===45)&&leftCharCode===rightCharCode||esutils.code.isIdentifierPartES5(leftCharCode)&&esutils.code.isIdentifierPartES5(rightCharCode)||leftCharCode===47&&rightCharCode===105){return[left,noEmptySpace(),right];}else if(esutils.code.isWhiteSpace(leftCharCode)||esutils.code.isLineTerminator(leftCharCode)||esutils.code.isWhiteSpace(rightCharCode)||esutils.code.isLineTerminator(rightCharCode)){return[left,right];}return[left,space,right];}function addIndent(stmt){return[base,stmt];}function withIndent(fn){var previousBase;previousBase=base;base+=indent;fn(base);base=previousBase;}function calculateSpaces(str){var i;for(i=str.length-1;i>=0;--i){if(esutils.code.isLineTerminator(str.charCodeAt(i))){break;}}return str.length-1-i;}function adjustMultilineComment(value,specialBase){var array,i,len,line,j,spaces,previousBase,sn;array=value.split(/\r\n|[\r\n]/);spaces=Number.MAX_VALUE;for(i=1,len=array.length;i<len;++i){line=array[i];j=0;while(j<line.length&&esutils.code.isWhiteSpace(line.charCodeAt(j))){++j;}if(spaces>j){spaces=j;}}if(typeof specialBase!=='undefined'){previousBase=base;if(array[1][spaces]==='*'){specialBase+=' ';}base=specialBase;}else{if(spaces&1){--spaces;}previousBase=base;}for(i=1,len=array.length;i<len;++i){sn=toSourceNodeWhenNeeded(addIndent(array[i].slice(spaces)));array[i]=sourceMap?sn.join(''):sn;}base=previousBase;return array.join('\n');}function generateComment(comment,specialBase){if(comment.type==='Line'){if(endsWithLineTerminator(comment.value)){return'//'+comment.value;}else{var result='//'+comment.value;if(!preserveBlankLines){result+='\n';}return result;}}if(extra.format.indent.adjustMultilineComment&&/[\n\r]/.test(comment.value)){return adjustMultilineComment('/*'+comment.value+'*/',specialBase);}return'/*'+comment.value+'*/';}function addComments(stmt,result){var i,len,comment,save,tailingToStatement,specialBase,fragment,extRange,range,prevRange,prefix,infix,suffix,count;if(stmt.leadingComments&&stmt.leadingComments.length>0){save=result;if(preserveBlankLines){comment=stmt.leadingComments[0];result=[];extRange=comment.extendedRange;range=comment.range;prefix=sourceCode.substring(extRange[0],range[0]);count=(prefix.match(/\n/g)||[]).length;if(count>0){result.push(stringRepeat('\n',count));result.push(addIndent(generateComment(comment)));}else{result.push(prefix);result.push(generateComment(comment));}prevRange=range;for(i=1,len=stmt.leadingComments.length;i<len;i++){comment=stmt.leadingComments[i];range=comment.range;infix=sourceCode.substring(prevRange[1],range[0]);count=(infix.match(/\n/g)||[]).length;result.push(stringRepeat('\n',count));result.push(addIndent(generateComment(comment)));prevRange=range;}suffix=sourceCode.substring(range[1],extRange[1]);count=(suffix.match(/\n/g)||[]).length;result.push(stringRepeat('\n',count));}else{comment=stmt.leadingComments[0];result=[];if(safeConcatenation&&stmt.type===Syntax.Program&&stmt.body.length===0){result.push('\n');}result.push(generateComment(comment));if(!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push('\n');}for(i=1,len=stmt.leadingComments.length;i<len;++i){comment=stmt.leadingComments[i];fragment=[generateComment(comment)];if(!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())){fragment.push('\n');}result.push(addIndent(fragment));}}result.push(addIndent(save));}if(stmt.trailingComments){if(preserveBlankLines){comment=stmt.trailingComments[0];extRange=comment.extendedRange;range=comment.range;prefix=sourceCode.substring(extRange[0],range[0]);count=(prefix.match(/\n/g)||[]).length;if(count>0){result.push(stringRepeat('\n',count));result.push(addIndent(generateComment(comment)));}else{result.push(prefix);result.push(generateComment(comment));}}else{tailingToStatement=!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString());specialBase=stringRepeat(' ',calculateSpaces(toSourceNodeWhenNeeded([base,result,indent]).toString()));for(i=0,len=stmt.trailingComments.length;i<len;++i){comment=stmt.trailingComments[i];if(tailingToStatement){if(i===0){result=[result,indent];}else{result=[result,specialBase];}result.push(generateComment(comment,specialBase));}else{result=[result,addIndent(generateComment(comment))];}if(i!==len-1&&!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result=[result,'\n'];}}}}return result;}function generateBlankLines(start,end,result){var j,newlineCount=0;for(j=start;j<end;j++){if(sourceCode[j]==='\n'){newlineCount++;}}for(j=1;j<newlineCount;j++){result.push(newline);}}function parenthesize(text,current,should){if(current<should){return['(',text,')'];}return text;}function generateVerbatimString(string){var i,iz,result;result=string.split(/\r\n|\n/);for(i=1,iz=result.length;i<iz;i++){result[i]=newline+base+result[i];}return result;}function generateVerbatim(expr,precedence){var verbatim,result,prec;verbatim=expr[extra.verbatim];if(typeof verbatim==='string'){result=parenthesize(generateVerbatimString(verbatim),Precedence.Sequence,precedence);}else{result=generateVerbatimString(verbatim.content);prec=verbatim.precedence!=null?verbatim.precedence:Precedence.Sequence;result=parenthesize(result,prec,precedence);}return toSourceNodeWhenNeeded(result,expr);}function CodeGenerator(){}CodeGenerator.prototype.maybeBlock=function(stmt,flags){var result,noLeadingComment,that=this;noLeadingComment=!extra.comment||!stmt.leadingComments;if(stmt.type===Syntax.BlockStatement&&noLeadingComment){return[space,this.generateStatement(stmt,flags)];}if(stmt.type===Syntax.EmptyStatement&&noLeadingComment){return';';}withIndent(function(){result=[newline,addIndent(that.generateStatement(stmt,flags))];});return result;};CodeGenerator.prototype.maybeBlockSuffix=function(stmt,result){var ends=endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString());if(stmt.type===Syntax.BlockStatement&&(!extra.comment||!stmt.leadingComments)&&!ends){return[result,space];}if(ends){return[result,base];}return[result,newline,base];};function generateIdentifier(node){return toSourceNodeWhenNeeded(node.name,node);}function generateAsyncPrefix(node,spaceRequired){return node.async?'async'+(spaceRequired?noEmptySpace():space):'';}function generateStarSuffix(node){var isGenerator=node.generator&&!extra.moz.starlessGenerator;return isGenerator?'*'+space:'';}function generateMethodPrefix(prop){var func=prop.value;if(func.async){return generateAsyncPrefix(func,!prop.computed);}else{return generateStarSuffix(func)?'*':'';}}CodeGenerator.prototype.generatePattern=function(node,precedence,flags){if(node.type===Syntax.Identifier){return generateIdentifier(node);}return this.generateExpression(node,precedence,flags);};CodeGenerator.prototype.generateFunctionParams=function(node){var i,iz,result,hasDefault;hasDefault=false;if(node.type===Syntax.ArrowFunctionExpression&&!node.rest&&(!node.defaults||node.defaults.length===0)&&node.params.length===1&&node.params[0].type===Syntax.Identifier){result=[generateAsyncPrefix(node,true),generateIdentifier(node.params[0])];}else{result=node.type===Syntax.ArrowFunctionExpression?[generateAsyncPrefix(node,false)]:[];result.push('(');if(node.defaults){hasDefault=true;}for(i=0,iz=node.params.length;i<iz;++i){if(hasDefault&&node.defaults[i]){result.push(this.generateAssignment(node.params[i],node.defaults[i],'=',Precedence.Assignment,E_TTT));}else{result.push(this.generatePattern(node.params[i],Precedence.Assignment,E_TTT));}if(i+1<iz){result.push(','+space);}}if(node.rest){if(node.params.length){result.push(','+space);}result.push('...');result.push(generateIdentifier(node.rest));}result.push(')');}return result;};CodeGenerator.prototype.generateFunctionBody=function(node){var result,expr;result=this.generateFunctionParams(node);if(node.type===Syntax.ArrowFunctionExpression){result.push(space);result.push('=>');}if(node.expression){result.push(space);expr=this.generateExpression(node.body,Precedence.Assignment,E_TTT);if(expr.toString().charAt(0)==='{'){expr=['(',expr,')'];}result.push(expr);}else{result.push(this.maybeBlock(node.body,S_TTFF));}return result;};CodeGenerator.prototype.generateIterationForStatement=function(operator,stmt,flags){var result=['for'+space+'('],that=this;withIndent(function(){if(stmt.left.type===Syntax.VariableDeclaration){withIndent(function(){result.push(stmt.left.kind+noEmptySpace());result.push(that.generateStatement(stmt.left.declarations[0],S_FFFF));});}else{result.push(that.generateExpression(stmt.left,Precedence.Call,E_TTT));}result=join(result,operator);result=[join(result,that.generateExpression(stmt.right,Precedence.Sequence,E_TTT)),')'];});result.push(this.maybeBlock(stmt.body,flags));return result;};CodeGenerator.prototype.generatePropertyKey=function(expr,computed,value,noShorthand){var result=[];if(computed){result.push('[');}if(value.type==='AssignmentPattern'&&expr.name===value.left.name&&!noShorthand){result.push(this.AssignmentPattern(value,Precedence.Sequence,E_TTT));}else{result.push(this.generateExpression(expr,Precedence.Sequence,E_TTT));}if(computed){result.push(']');}return result;};CodeGenerator.prototype.generateAssignment=function(left,right,operator,precedence,flags){if(Precedence.Assignment<precedence){flags|=F_ALLOW_IN;}return parenthesize([this.generateExpression(left,Precedence.Call,flags),space+operator+space,this.generateExpression(right,Precedence.Assignment,flags)],Precedence.Assignment,precedence);};CodeGenerator.prototype.semicolon=function(flags){if(!semicolons&&flags&F_SEMICOLON_OPT){return'';}return';';};CodeGenerator.Statement={BlockStatement:function(stmt,flags){var range,content,result=['{',newline],that=this;withIndent(function(){if(stmt.body.length===0&&preserveBlankLines){range=stmt.range;if(range[1]-range[0]>2){content=sourceCode.substring(range[0]+1,range[1]-1);if(content[0]==='\n'){result=['{'];}result.push(content);}}var i,iz,fragment,bodyFlags;bodyFlags=S_TFFF;if(flags&F_FUNC_BODY){bodyFlags|=F_DIRECTIVE_CTX;}for(i=0,iz=stmt.body.length;i<iz;++i){if(preserveBlankLines){if(i===0){if(stmt.body[0].leadingComments){range=stmt.body[0].leadingComments[0].extendedRange;content=sourceCode.substring(range[0],range[1]);if(content[0]==='\n'){result=['{'];}}if(!stmt.body[0].leadingComments){generateBlankLines(stmt.range[0],stmt.body[0].range[0],result);}}if(i>0){if(!stmt.body[i-1].trailingComments&&!stmt.body[i].leadingComments){generateBlankLines(stmt.body[i-1].range[1],stmt.body[i].range[0],result);}}}if(i===iz-1){bodyFlags|=F_SEMICOLON_OPT;}if(stmt.body[i].leadingComments&&preserveBlankLines){fragment=that.generateStatement(stmt.body[i],bodyFlags);}else{fragment=addIndent(that.generateStatement(stmt.body[i],bodyFlags));}result.push(fragment);if(!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())){if(preserveBlankLines&&i<iz-1){if(!stmt.body[i+1].leadingComments){result.push(newline);}}else{result.push(newline);}}if(preserveBlankLines){if(i===iz-1){if(!stmt.body[i].trailingComments){generateBlankLines(stmt.body[i].range[1],stmt.range[1],result);}}}}});result.push(addIndent('}'));return result;},BreakStatement:function(stmt,flags){if(stmt.label){return'break '+stmt.label.name+this.semicolon(flags);}return'break'+this.semicolon(flags);},ContinueStatement:function(stmt,flags){if(stmt.label){return'continue '+stmt.label.name+this.semicolon(flags);}return'continue'+this.semicolon(flags);},ClassBody:function(stmt,flags){var result=['{',newline],that=this;withIndent(function(indent){var i,iz;for(i=0,iz=stmt.body.length;i<iz;++i){result.push(indent);result.push(that.generateExpression(stmt.body[i],Precedence.Sequence,E_TTT));if(i+1<iz){result.push(newline);}}});if(!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}result.push(base);result.push('}');return result;},ClassDeclaration:function(stmt,flags){var result,fragment;result=['class'];if(stmt.id){result=join(result,this.generateExpression(stmt.id,Precedence.Sequence,E_TTT));}if(stmt.superClass){fragment=join('extends',this.generateExpression(stmt.superClass,Precedence.Call,E_TTT));result=join(result,fragment);}result.push(space);result.push(this.generateStatement(stmt.body,S_TFFT));return result;},DirectiveStatement:function(stmt,flags){if(extra.raw&&stmt.raw){return stmt.raw+this.semicolon(flags);}return escapeDirective(stmt.directive)+this.semicolon(flags);},DoWhileStatement:function(stmt,flags){var result=join('do',this.maybeBlock(stmt.body,S_TFFF));result=this.maybeBlockSuffix(stmt.body,result);return join(result,['while'+space+'(',this.generateExpression(stmt.test,Precedence.Sequence,E_TTT),')'+this.semicolon(flags)]);},CatchClause:function(stmt,flags){var result,that=this;withIndent(function(){var guard;result=['catch'+space+'(',that.generateExpression(stmt.param,Precedence.Sequence,E_TTT),')'];if(stmt.guard){guard=that.generateExpression(stmt.guard,Precedence.Sequence,E_TTT);result.splice(2,0,' if ',guard);}});result.push(this.maybeBlock(stmt.body,S_TFFF));return result;},DebuggerStatement:function(stmt,flags){return'debugger'+this.semicolon(flags);},EmptyStatement:function(stmt,flags){return';';},ExportDefaultDeclaration:function(stmt,flags){var result=['export'],bodyFlags;bodyFlags=flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF;result=join(result,'default');if(isStatement(stmt.declaration)){result=join(result,this.generateStatement(stmt.declaration,bodyFlags));}else{result=join(result,this.generateExpression(stmt.declaration,Precedence.Assignment,E_TTT)+this.semicolon(flags));}return result;},ExportNamedDeclaration:function(stmt,flags){var result=['export'],bodyFlags,that=this;bodyFlags=flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF;if(stmt.declaration){return join(result,this.generateStatement(stmt.declaration,bodyFlags));}if(stmt.specifiers){if(stmt.specifiers.length===0){result=join(result,'{'+space+'}');}else if(stmt.specifiers[0].type===Syntax.ExportBatchSpecifier){result=join(result,this.generateExpression(stmt.specifiers[0],Precedence.Sequence,E_TTT));}else{result=join(result,'{');withIndent(function(indent){var i,iz;result.push(newline);for(i=0,iz=stmt.specifiers.length;i<iz;++i){result.push(indent);result.push(that.generateExpression(stmt.specifiers[i],Precedence.Sequence,E_TTT));if(i+1<iz){result.push(','+newline);}}});if(!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}result.push(base+'}');}if(stmt.source){result=join(result,['from'+space,this.generateExpression(stmt.source,Precedence.Sequence,E_TTT),this.semicolon(flags)]);}else{result.push(this.semicolon(flags));}}return result;},ExportAllDeclaration:function(stmt,flags){return['export'+space,'*'+space,'from'+space,this.generateExpression(stmt.source,Precedence.Sequence,E_TTT),this.semicolon(flags)];},ExpressionStatement:function(stmt,flags){var result,fragment;function isClassPrefixed(fragment){var code;if(fragment.slice(0,5)!=='class'){return false;}code=fragment.charCodeAt(5);return code===123||esutils.code.isWhiteSpace(code)||esutils.code.isLineTerminator(code);}function isFunctionPrefixed(fragment){var code;if(fragment.slice(0,8)!=='function'){return false;}code=fragment.charCodeAt(8);return code===40||esutils.code.isWhiteSpace(code)||code===42||esutils.code.isLineTerminator(code);}function isAsyncPrefixed(fragment){var code,i,iz;if(fragment.slice(0,5)!=='async'){return false;}if(!esutils.code.isWhiteSpace(fragment.charCodeAt(5))){return false;}for(i=6,iz=fragment.length;i<iz;++i){if(!esutils.code.isWhiteSpace(fragment.charCodeAt(i))){break;}}if(i===iz){return false;}if(fragment.slice(i,i+8)!=='function'){return false;}code=fragment.charCodeAt(i+8);return code===40||esutils.code.isWhiteSpace(code)||code===42||esutils.code.isLineTerminator(code);}result=[this.generateExpression(stmt.expression,Precedence.Sequence,E_TTT)];fragment=toSourceNodeWhenNeeded(result).toString();if(fragment.charCodeAt(0)===123||isClassPrefixed(fragment)||isFunctionPrefixed(fragment)||isAsyncPrefixed(fragment)||directive&&flags&F_DIRECTIVE_CTX&&stmt.expression.type===Syntax.Literal&&typeof stmt.expression.value==='string'){result=['(',result,')'+this.semicolon(flags)];}else{result.push(this.semicolon(flags));}return result;},ImportDeclaration:function(stmt,flags){var result,cursor,that=this;if(stmt.specifiers.length===0){return['import',space,this.generateExpression(stmt.source,Precedence.Sequence,E_TTT),this.semicolon(flags)];}result=['import'];cursor=0;if(stmt.specifiers[cursor].type===Syntax.ImportDefaultSpecifier){result=join(result,[this.generateExpression(stmt.specifiers[cursor],Precedence.Sequence,E_TTT)]);++cursor;}if(stmt.specifiers[cursor]){if(cursor!==0){result.push(',');}if(stmt.specifiers[cursor].type===Syntax.ImportNamespaceSpecifier){result=join(result,[space,this.generateExpression(stmt.specifiers[cursor],Precedence.Sequence,E_TTT)]);}else{result.push(space+'{');if(stmt.specifiers.length-cursor===1){result.push(space);result.push(this.generateExpression(stmt.specifiers[cursor],Precedence.Sequence,E_TTT));result.push(space+'}'+space);}else{withIndent(function(indent){var i,iz;result.push(newline);for(i=cursor,iz=stmt.specifiers.length;i<iz;++i){result.push(indent);result.push(that.generateExpression(stmt.specifiers[i],Precedence.Sequence,E_TTT));if(i+1<iz){result.push(','+newline);}}});if(!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}result.push(base+'}'+space);}}}result=join(result,['from'+space,this.generateExpression(stmt.source,Precedence.Sequence,E_TTT),this.semicolon(flags)]);return result;},VariableDeclarator:function(stmt,flags){var itemFlags=flags&F_ALLOW_IN?E_TTT:E_FTT;if(stmt.init){return[this.generateExpression(stmt.id,Precedence.Assignment,itemFlags),space,'=',space,this.generateExpression(stmt.init,Precedence.Assignment,itemFlags)];}return this.generatePattern(stmt.id,Precedence.Assignment,itemFlags);},VariableDeclaration:function(stmt,flags){var result,i,iz,node,bodyFlags,that=this;result=[stmt.kind];bodyFlags=flags&F_ALLOW_IN?S_TFFF:S_FFFF;function block(){node=stmt.declarations[0];if(extra.comment&&node.leadingComments){result.push('\n');result.push(addIndent(that.generateStatement(node,bodyFlags)));}else{result.push(noEmptySpace());result.push(that.generateStatement(node,bodyFlags));}for(i=1,iz=stmt.declarations.length;i<iz;++i){node=stmt.declarations[i];if(extra.comment&&node.leadingComments){result.push(','+newline);result.push(addIndent(that.generateStatement(node,bodyFlags)));}else{result.push(','+space);result.push(that.generateStatement(node,bodyFlags));}}}if(stmt.declarations.length>1){withIndent(block);}else{block();}result.push(this.semicolon(flags));return result;},ThrowStatement:function(stmt,flags){return[join('throw',this.generateExpression(stmt.argument,Precedence.Sequence,E_TTT)),this.semicolon(flags)];},TryStatement:function(stmt,flags){var result,i,iz,guardedHandlers;result=['try',this.maybeBlock(stmt.block,S_TFFF)];result=this.maybeBlockSuffix(stmt.block,result);if(stmt.handlers){for(i=0,iz=stmt.handlers.length;i<iz;++i){result=join(result,this.generateStatement(stmt.handlers[i],S_TFFF));if(stmt.finalizer||i+1!==iz){result=this.maybeBlockSuffix(stmt.handlers[i].body,result);}}}else{guardedHandlers=stmt.guardedHandlers||[];for(i=0,iz=guardedHandlers.length;i<iz;++i){result=join(result,this.generateStatement(guardedHandlers[i],S_TFFF));if(stmt.finalizer||i+1!==iz){result=this.maybeBlockSuffix(guardedHandlers[i].body,result);}}if(stmt.handler){if(isArray(stmt.handler)){for(i=0,iz=stmt.handler.length;i<iz;++i){result=join(result,this.generateStatement(stmt.handler[i],S_TFFF));if(stmt.finalizer||i+1!==iz){result=this.maybeBlockSuffix(stmt.handler[i].body,result);}}}else{result=join(result,this.generateStatement(stmt.handler,S_TFFF));if(stmt.finalizer){result=this.maybeBlockSuffix(stmt.handler.body,result);}}}}if(stmt.finalizer){result=join(result,['finally',this.maybeBlock(stmt.finalizer,S_TFFF)]);}return result;},SwitchStatement:function(stmt,flags){var result,fragment,i,iz,bodyFlags,that=this;withIndent(function(){result=['switch'+space+'(',that.generateExpression(stmt.discriminant,Precedence.Sequence,E_TTT),')'+space+'{'+newline];});if(stmt.cases){bodyFlags=S_TFFF;for(i=0,iz=stmt.cases.length;i<iz;++i){if(i===iz-1){bodyFlags|=F_SEMICOLON_OPT;}fragment=addIndent(this.generateStatement(stmt.cases[i],bodyFlags));result.push(fragment);if(!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())){result.push(newline);}}}result.push(addIndent('}'));return result;},SwitchCase:function(stmt,flags){var result,fragment,i,iz,bodyFlags,that=this;withIndent(function(){if(stmt.test){result=[join('case',that.generateExpression(stmt.test,Precedence.Sequence,E_TTT)),':'];}else{result=['default:'];}i=0;iz=stmt.consequent.length;if(iz&&stmt.consequent[0].type===Syntax.BlockStatement){fragment=that.maybeBlock(stmt.consequent[0],S_TFFF);result.push(fragment);i=1;}if(i!==iz&&!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}bodyFlags=S_TFFF;for(;i<iz;++i){if(i===iz-1&&flags&F_SEMICOLON_OPT){bodyFlags|=F_SEMICOLON_OPT;}fragment=addIndent(that.generateStatement(stmt.consequent[i],bodyFlags));result.push(fragment);if(i+1!==iz&&!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())){result.push(newline);}}});return result;},IfStatement:function(stmt,flags){var result,bodyFlags,semicolonOptional,that=this;withIndent(function(){result=['if'+space+'(',that.generateExpression(stmt.test,Precedence.Sequence,E_TTT),')'];});semicolonOptional=flags&F_SEMICOLON_OPT;bodyFlags=S_TFFF;if(semicolonOptional){bodyFlags|=F_SEMICOLON_OPT;}if(stmt.alternate){result.push(this.maybeBlock(stmt.consequent,S_TFFF));result=this.maybeBlockSuffix(stmt.consequent,result);if(stmt.alternate.type===Syntax.IfStatement){result=join(result,['else ',this.generateStatement(stmt.alternate,bodyFlags)]);}else{result=join(result,join('else',this.maybeBlock(stmt.alternate,bodyFlags)));}}else{result.push(this.maybeBlock(stmt.consequent,bodyFlags));}return result;},ForStatement:function(stmt,flags){var result,that=this;withIndent(function(){result=['for'+space+'('];if(stmt.init){if(stmt.init.type===Syntax.VariableDeclaration){result.push(that.generateStatement(stmt.init,S_FFFF));}else{result.push(that.generateExpression(stmt.init,Precedence.Sequence,E_FTT));result.push(';');}}else{result.push(';');}if(stmt.test){result.push(space);result.push(that.generateExpression(stmt.test,Precedence.Sequence,E_TTT));result.push(';');}else{result.push(';');}if(stmt.update){result.push(space);result.push(that.generateExpression(stmt.update,Precedence.Sequence,E_TTT));result.push(')');}else{result.push(')');}});result.push(this.maybeBlock(stmt.body,flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF));return result;},ForInStatement:function(stmt,flags){return this.generateIterationForStatement('in',stmt,flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF);},ForOfStatement:function(stmt,flags){return this.generateIterationForStatement('of',stmt,flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF);},LabeledStatement:function(stmt,flags){return[stmt.label.name+':',this.maybeBlock(stmt.body,flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF)];},Program:function(stmt,flags){var result,fragment,i,iz,bodyFlags;iz=stmt.body.length;result=[safeConcatenation&&iz>0?'\n':''];bodyFlags=S_TFTF;for(i=0;i<iz;++i){if(!safeConcatenation&&i===iz-1){bodyFlags|=F_SEMICOLON_OPT;}if(preserveBlankLines){if(i===0){if(!stmt.body[0].leadingComments){generateBlankLines(stmt.range[0],stmt.body[i].range[0],result);}}if(i>0){if(!stmt.body[i-1].trailingComments&&!stmt.body[i].leadingComments){generateBlankLines(stmt.body[i-1].range[1],stmt.body[i].range[0],result);}}}fragment=addIndent(this.generateStatement(stmt.body[i],bodyFlags));result.push(fragment);if(i+1<iz&&!endsWithLineTerminator(toSourceNodeWhenNeeded(fragment).toString())){if(preserveBlankLines){if(!stmt.body[i+1].leadingComments){result.push(newline);}}else{result.push(newline);}}if(preserveBlankLines){if(i===iz-1){if(!stmt.body[i].trailingComments){generateBlankLines(stmt.body[i].range[1],stmt.range[1],result);}}}}return result;},FunctionDeclaration:function(stmt,flags){return[generateAsyncPrefix(stmt,true),'function',generateStarSuffix(stmt)||noEmptySpace(),stmt.id?generateIdentifier(stmt.id):'',this.generateFunctionBody(stmt)];},ReturnStatement:function(stmt,flags){if(stmt.argument){return[join('return',this.generateExpression(stmt.argument,Precedence.Sequence,E_TTT)),this.semicolon(flags)];}return['return'+this.semicolon(flags)];},WhileStatement:function(stmt,flags){var result,that=this;withIndent(function(){result=['while'+space+'(',that.generateExpression(stmt.test,Precedence.Sequence,E_TTT),')'];});result.push(this.maybeBlock(stmt.body,flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF));return result;},WithStatement:function(stmt,flags){var result,that=this;withIndent(function(){result=['with'+space+'(',that.generateExpression(stmt.object,Precedence.Sequence,E_TTT),')'];});result.push(this.maybeBlock(stmt.body,flags&F_SEMICOLON_OPT?S_TFFT:S_TFFF));return result;}};merge(CodeGenerator.prototype,CodeGenerator.Statement);CodeGenerator.Expression={SequenceExpression:function(expr,precedence,flags){var result,i,iz;if(Precedence.Sequence<precedence){flags|=F_ALLOW_IN;}result=[];for(i=0,iz=expr.expressions.length;i<iz;++i){result.push(this.generateExpression(expr.expressions[i],Precedence.Assignment,flags));if(i+1<iz){result.push(','+space);}}return parenthesize(result,Precedence.Sequence,precedence);},AssignmentExpression:function(expr,precedence,flags){return this.generateAssignment(expr.left,expr.right,expr.operator,precedence,flags);},ArrowFunctionExpression:function(expr,precedence,flags){return parenthesize(this.generateFunctionBody(expr),Precedence.ArrowFunction,precedence);},ConditionalExpression:function(expr,precedence,flags){if(Precedence.Conditional<precedence){flags|=F_ALLOW_IN;}return parenthesize([this.generateExpression(expr.test,Precedence.LogicalOR,flags),space+'?'+space,this.generateExpression(expr.consequent,Precedence.Assignment,flags),space+':'+space,this.generateExpression(expr.alternate,Precedence.Assignment,flags)],Precedence.Conditional,precedence);},LogicalExpression:function(expr,precedence,flags){return this.BinaryExpression(expr,precedence,flags);},BinaryExpression:function(expr,precedence,flags){var result,currentPrecedence,fragment,leftSource;currentPrecedence=BinaryPrecedence[expr.operator];if(currentPrecedence<precedence){flags|=F_ALLOW_IN;}if(currentPrecedence===Precedence.Exponentiation&&expr.left.type==='UnaryExpression'){fragment=this.generateExpression(expr.left,Precedence.ExponentiationWithUnaryAtLeft,flags);}else{fragment=this.generateExpression(expr.left,currentPrecedence,flags);}leftSource=fragment.toString();if(leftSource.charCodeAt(leftSource.length-1)===47&&esutils.code.isIdentifierPartES5(expr.operator.charCodeAt(0))){result=[fragment,noEmptySpace(),expr.operator];}else{result=join(fragment,expr.operator);}fragment=this.generateExpression(expr.right,currentPrecedence+1,flags);if(expr.operator==='/'&&fragment.toString().charAt(0)==='/'||expr.operator.slice(-1)==='<'&&fragment.toString().slice(0,3)==='!--'){result.push(noEmptySpace());result.push(fragment);}else{result=join(result,fragment);}if(expr.operator==='in'&&!(flags&F_ALLOW_IN)){return['(',result,')'];}return parenthesize(result,currentPrecedence,precedence);},CallExpression:function(expr,precedence,flags){var result,i,iz;result=[this.generateExpression(expr.callee,Precedence.Call,E_TTF)];result.push('(');for(i=0,iz=expr['arguments'].length;i<iz;++i){result.push(this.generateExpression(expr['arguments'][i],Precedence.Assignment,E_TTT));if(i+1<iz){result.push(','+space);}}result.push(')');if(!(flags&F_ALLOW_CALL)){return['(',result,')'];}return parenthesize(result,Precedence.Call,precedence);},NewExpression:function(expr,precedence,flags){var result,length,i,iz,itemFlags;length=expr['arguments'].length;itemFlags=flags&F_ALLOW_UNPARATH_NEW&&!parentheses&&length===0?E_TFT:E_TFF;result=join('new',this.generateExpression(expr.callee,Precedence.New,itemFlags));if(!(flags&F_ALLOW_UNPARATH_NEW)||parentheses||length>0){result.push('(');for(i=0,iz=length;i<iz;++i){result.push(this.generateExpression(expr['arguments'][i],Precedence.Assignment,E_TTT));if(i+1<iz){result.push(','+space);}}result.push(')');}return parenthesize(result,Precedence.New,precedence);},MemberExpression:function(expr,precedence,flags){var result,fragment;result=[this.generateExpression(expr.object,Precedence.Call,flags&F_ALLOW_CALL?E_TTF:E_TFF)];if(expr.computed){result.push('[');result.push(this.generateExpression(expr.property,Precedence.Sequence,flags&F_ALLOW_CALL?E_TTT:E_TFT));result.push(']');}else{if(expr.object.type===Syntax.Literal&&typeof expr.object.value==='number'){fragment=toSourceNodeWhenNeeded(result).toString();if(fragment.indexOf('.')<0&&!/[eExX]/.test(fragment)&&esutils.code.isDecimalDigit(fragment.charCodeAt(fragment.length-1))&&!(fragment.length>=2&&fragment.charCodeAt(0)===48)){result.push(' ');}}result.push('.');result.push(generateIdentifier(expr.property));}return parenthesize(result,Precedence.Member,precedence);},MetaProperty:function(expr,precedence,flags){var result;result=[];result.push(expr.meta);result.push('.');result.push(expr.property);return parenthesize(result,Precedence.Member,precedence);},UnaryExpression:function(expr,precedence,flags){var result,fragment,rightCharCode,leftSource,leftCharCode;fragment=this.generateExpression(expr.argument,Precedence.Unary,E_TTT);if(space===''){result=join(expr.operator,fragment);}else{result=[expr.operator];if(expr.operator.length>2){result=join(result,fragment);}else{leftSource=toSourceNodeWhenNeeded(result).toString();leftCharCode=leftSource.charCodeAt(leftSource.length-1);rightCharCode=fragment.toString().charCodeAt(0);if((leftCharCode===43||leftCharCode===45)&&leftCharCode===rightCharCode||esutils.code.isIdentifierPartES5(leftCharCode)&&esutils.code.isIdentifierPartES5(rightCharCode)){result.push(noEmptySpace());result.push(fragment);}else{result.push(fragment);}}}return parenthesize(result,Precedence.Unary,precedence);},YieldExpression:function(expr,precedence,flags){var result;if(expr.delegate){result='yield*';}else{result='yield';}if(expr.argument){result=join(result,this.generateExpression(expr.argument,Precedence.Yield,E_TTT));}return parenthesize(result,Precedence.Yield,precedence);},AwaitExpression:function(expr,precedence,flags){var result=join(expr.all?'await*':'await',this.generateExpression(expr.argument,Precedence.Await,E_TTT));return parenthesize(result,Precedence.Await,precedence);},UpdateExpression:function(expr,precedence,flags){if(expr.prefix){return parenthesize([expr.operator,this.generateExpression(expr.argument,Precedence.Unary,E_TTT)],Precedence.Unary,precedence);}return parenthesize([this.generateExpression(expr.argument,Precedence.Postfix,E_TTT),expr.operator],Precedence.Postfix,precedence);},FunctionExpression:function(expr,precedence,flags){var result=[generateAsyncPrefix(expr,true),'function'];if(expr.id){result.push(generateStarSuffix(expr)||noEmptySpace());result.push(generateIdentifier(expr.id));}else{result.push(generateStarSuffix(expr)||space);}result.push(this.generateFunctionBody(expr));return result;},ArrayPattern:function(expr,precedence,flags){return this.ArrayExpression(expr,precedence,flags,true);},ArrayExpression:function(expr,precedence,flags,isPattern){var result,multiline,that=this;if(!expr.elements.length){return'[]';}multiline=isPattern?false:expr.elements.length>1;result=['[',multiline?newline:''];withIndent(function(indent){var i,iz;for(i=0,iz=expr.elements.length;i<iz;++i){if(!expr.elements[i]){if(multiline){result.push(indent);}if(i+1===iz){result.push(',');}}else{result.push(multiline?indent:'');result.push(that.generateExpression(expr.elements[i],Precedence.Assignment,E_TTT));}if(i+1<iz){result.push(','+(multiline?newline:space));}}});if(multiline&&!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}result.push(multiline?base:'');result.push(']');return result;},RestElement:function(expr,precedence,flags){return'...'+this.generatePattern(expr.argument);},ExperimentalRestProperty:function(expr,precedence,flags){return'...'+this.generatePattern(expr.argument);},ClassExpression:function(expr,precedence,flags){var result,fragment;result=['class'];if(expr.id){result=join(result,this.generateExpression(expr.id,Precedence.Sequence,E_TTT));}if(expr.superClass){fragment=join('extends',this.generateExpression(expr.superClass,Precedence.Call,E_TTT));result=join(result,fragment);}result.push(space);result.push(this.generateStatement(expr.body,S_TFFT));return result;},MethodDefinition:function(expr,precedence,flags){var result,fragment;if(expr['static']){result=['static'+space];}else{result=[];}if(expr.kind==='get'||expr.kind==='set'){fragment=[join(expr.kind,this.generatePropertyKey(expr.key,expr.computed,expr.value)),this.generateFunctionBody(expr.value)];}else{fragment=[generateMethodPrefix(expr),this.generatePropertyKey(expr.key,expr.computed,expr.value),this.generateFunctionBody(expr.value)];}return join(result,fragment);},Property:function(expr,precedence,flags){if(expr.kind==='get'||expr.kind==='set'){return[expr.kind,noEmptySpace(),this.generatePropertyKey(expr.key,expr.computed,expr.value),this.generateFunctionBody(expr.value)];}if(expr.shorthand){return this.generatePropertyKey(expr.key,expr.computed,expr.value);}if(expr.method){return[generateMethodPrefix(expr),this.generatePropertyKey(expr.key,expr.computed,expr.value),this.generateFunctionBody(expr.value)];}return[this.generatePropertyKey(expr.key,expr.computed,expr.value,true),':'+space,this.generateExpression(expr.value,Precedence.Assignment,E_TTT)];},ObjectExpression:function(expr,precedence,flags){var multiline,result,fragment,that=this;if(!expr.properties.length){return'{}';}multiline=expr.properties.length>1;withIndent(function(){fragment=that.generateExpression(expr.properties[0],Precedence.Sequence,E_TTT);});if(!multiline){if(!hasLineTerminator(toSourceNodeWhenNeeded(fragment).toString())){return['{',space,fragment,space,'}'];}}withIndent(function(indent){var i,iz;result=['{',newline,indent,fragment];if(multiline){result.push(','+newline);for(i=1,iz=expr.properties.length;i<iz;++i){result.push(indent);result.push(that.generateExpression(expr.properties[i],Precedence.Sequence,E_TTT));if(i+1<iz){result.push(','+newline);}}}});if(!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}result.push(base);result.push('}');return result;},AssignmentPattern:function(expr,precedence,flags){return this.generateAssignment(expr.left,expr.right,'=',precedence,flags);},ObjectPattern:function(expr,precedence,flags){var result,i,iz,multiline,property,that=this;if(!expr.properties.length){return'{}';}multiline=false;if(expr.properties.length===1){property=expr.properties[0];if(property.value&&property.value.type!==Syntax.Identifier){multiline=true;}}else{for(i=0,iz=expr.properties.length;i<iz;++i){property=expr.properties[i];if(!property.shorthand){multiline=true;break;}}}result=['{',multiline?newline:''];withIndent(function(indent){var i,iz;for(i=0,iz=expr.properties.length;i<iz;++i){result.push(multiline?indent:'');result.push(that.generateExpression(expr.properties[i],Precedence.Sequence,E_TTT));if(i+1<iz){result.push(','+(multiline?newline:space));}}});if(multiline&&!endsWithLineTerminator(toSourceNodeWhenNeeded(result).toString())){result.push(newline);}result.push(multiline?base:'');result.push('}');return result;},ThisExpression:function(expr,precedence,flags){return'this';},Super:function(expr,precedence,flags){return'super';},Identifier:function(expr,precedence,flags){return generateIdentifier(expr);},Import:function(expr,precedence,flags){return'import';},ImportDefaultSpecifier:function(expr,precedence,flags){return generateIdentifier(expr.id||expr.local);},ImportNamespaceSpecifier:function(expr,precedence,flags){var result=['*'];var id=expr.id||expr.local;if(id){result.push(space+'as'+noEmptySpace()+generateIdentifier(id));}return result;},ImportSpecifier:function(expr,precedence,flags){var imported=expr.imported;var result=[imported.name];var local=expr.local;if(local&&local.name!==imported.name){result.push(noEmptySpace()+'as'+noEmptySpace()+generateIdentifier(local));}return result;},ExportSpecifier:function(expr,precedence,flags){var local=expr.local;var result=[local.name];var exported=expr.exported;if(exported&&exported.name!==local.name){result.push(noEmptySpace()+'as'+noEmptySpace()+generateIdentifier(exported));}return result;},Literal:function(expr,precedence,flags){var raw;if(expr.hasOwnProperty('raw')&&parse&&extra.raw){try{raw=parse(expr.raw).body[0].expression;if(raw.type===Syntax.Literal){if(raw.value===expr.value){return expr.raw;}}}catch(e){}}if(expr.value===null){return'null';}if(typeof expr.value==='string'){return escapeString(expr.value);}if(typeof expr.value==='number'){return generateNumber(expr.value);}if(typeof expr.value==='boolean'){return expr.value?'true':'false';}if(expr.regex){return'/'+expr.regex.pattern+'/'+expr.regex.flags;}return generateRegExp(expr.value);},GeneratorExpression:function(expr,precedence,flags){return this.ComprehensionExpression(expr,precedence,flags);},ComprehensionExpression:function(expr,precedence,flags){var result,i,iz,fragment,that=this;result=expr.type===Syntax.GeneratorExpression?['(']:['['];if(extra.moz.comprehensionExpressionStartsWithAssignment){fragment=this.generateExpression(expr.body,Precedence.Assignment,E_TTT);result.push(fragment);}if(expr.blocks){withIndent(function(){for(i=0,iz=expr.blocks.length;i<iz;++i){fragment=that.generateExpression(expr.blocks[i],Precedence.Sequence,E_TTT);if(i>0||extra.moz.comprehensionExpressionStartsWithAssignment){result=join(result,fragment);}else{result.push(fragment);}}});}if(expr.filter){result=join(result,'if'+space);fragment=this.generateExpression(expr.filter,Precedence.Sequence,E_TTT);result=join(result,['(',fragment,')']);}if(!extra.moz.comprehensionExpressionStartsWithAssignment){fragment=this.generateExpression(expr.body,Precedence.Assignment,E_TTT);result=join(result,fragment);}result.push(expr.type===Syntax.GeneratorExpression?')':']');return result;},ComprehensionBlock:function(expr,precedence,flags){var fragment;if(expr.left.type===Syntax.VariableDeclaration){fragment=[expr.left.kind,noEmptySpace(),this.generateStatement(expr.left.declarations[0],S_FFFF)];}else{fragment=this.generateExpression(expr.left,Precedence.Call,E_TTT);}fragment=join(fragment,expr.of?'of':'in');fragment=join(fragment,this.generateExpression(expr.right,Precedence.Sequence,E_TTT));return['for'+space+'(',fragment,')'];},SpreadElement:function(expr,precedence,flags){return['...',this.generateExpression(expr.argument,Precedence.Assignment,E_TTT)];},ExperimentalSpreadProperty:function(expr,precedence,flags){return['...',this.generateExpression(expr.argument,Precedence.Assignment,E_TTT)];},TaggedTemplateExpression:function(expr,precedence,flags){var itemFlags=E_TTF;if(!(flags&F_ALLOW_CALL)){itemFlags=E_TFF;}var result=[this.generateExpression(expr.tag,Precedence.Call,itemFlags),this.generateExpression(expr.quasi,Precedence.Primary,E_FFT)];return parenthesize(result,Precedence.TaggedTemplate,precedence);},TemplateElement:function(expr,precedence,flags){return expr.value.raw;},TemplateLiteral:function(expr,precedence,flags){var result,i,iz;result=['`'];for(i=0,iz=expr.quasis.length;i<iz;++i){result.push(this.generateExpression(expr.quasis[i],Precedence.Primary,E_TTT));if(i+1<iz){result.push('${'+space);result.push(this.generateExpression(expr.expressions[i],Precedence.Sequence,E_TTT));result.push(space+'}');}}result.push('`');return result;},ModuleSpecifier:function(expr,precedence,flags){return this.Literal(expr,precedence,flags);}};merge(CodeGenerator.prototype,CodeGenerator.Expression);CodeGenerator.prototype.generateExpression=function(expr,precedence,flags){var result,type;type=expr.type||Syntax.Property;if(extra.verbatim&&expr.hasOwnProperty(extra.verbatim)){return generateVerbatim(expr,precedence);}result=this[type](expr,precedence,flags);if(extra.comment){result=addComments(expr,result);}return toSourceNodeWhenNeeded(result,expr);};CodeGenerator.prototype.generateStatement=function(stmt,flags){var result,fragment;result=this[stmt.type](stmt,flags);if(extra.comment){result=addComments(stmt,result);}fragment=toSourceNodeWhenNeeded(result).toString();if(stmt.type===Syntax.Program&&!safeConcatenation&&newline===''&&fragment.charAt(fragment.length-1)==='\n'){result=sourceMap?toSourceNodeWhenNeeded(result).replaceRight(/\s+$/,''):fragment.replace(/\s+$/,'');}return toSourceNodeWhenNeeded(result,stmt);};function generateInternal(node){var codegen;codegen=new CodeGenerator();if(isStatement(node)){return codegen.generateStatement(node,S_TFFF);}if(isExpression(node)){return codegen.generateExpression(node,Precedence.Sequence,E_TTT);}throw new Error('Unknown node type: '+node.type);}function generate(node,options){var defaultOptions=getDefaultOptions(),result,pair;if(options!=null){if(typeof options.indent==='string'){defaultOptions.format.indent.style=options.indent;}if(typeof options.base==='number'){defaultOptions.format.indent.base=options.base;}options=updateDeeply(defaultOptions,options);indent=options.format.indent.style;if(typeof options.base==='string'){base=options.base;}else{base=stringRepeat(indent,options.format.indent.base);}}else{options=defaultOptions;indent=options.format.indent.style;base=stringRepeat(indent,options.format.indent.base);}json=options.format.json;renumber=options.format.renumber;hexadecimal=json?false:options.format.hexadecimal;quotes=json?'double':options.format.quotes;escapeless=options.format.escapeless;newline=options.format.newline;space=options.format.space;if(options.format.compact){newline=space=indent=base='';}parentheses=options.format.parentheses;semicolons=options.format.semicolons;safeConcatenation=options.format.safeConcatenation;directive=options.directive;parse=json?null:options.parse;sourceMap=options.sourceMap;sourceCode=options.sourceCode;preserveBlankLines=options.format.preserveBlankLines&&sourceCode!==null;extra=options;if(sourceMap){if(!exports.browser){SourceNode=require('source-map').SourceNode;}else{SourceNode=global.sourceMap.SourceNode;}}result=generateInternal(node);if(!sourceMap){pair={code:result.toString(),map:null};return options.sourceMapWithCode?pair:pair.code;}pair=result.toStringWithSourceMap({file:options.file,sourceRoot:options.sourceMapRoot});if(options.sourceContent){pair.map.setSourceContent(options.sourceMap,options.sourceContent);}if(options.sourceMapWithCode){return pair;}return pair.map.toString();}FORMAT_MINIFY={indent:{style:'',base:0},renumber:true,hexadecimal:true,quotes:'auto',escapeless:true,compact:true,parentheses:false,semicolons:false};FORMAT_DEFAULTS=getDefaultOptions().format;exports.version=require('./package.json').version;exports.generate=generate;exports.attachComments=estraverse.attachComments;exports.Precedence=updateDeeply({},Precedence);exports.browser=false;exports.FORMAT_MINIFY=FORMAT_MINIFY;exports.FORMAT_DEFAULTS=FORMAT_DEFAULTS;}());}.call(this));}.call(this,typeof global!=='undefined'?global:typeof self!=='undefined'?self:typeof window!=='undefined'?window:{}));},{'./package.json':45,'estraverse':54,'esutils':59,'source-map':114}],45:[function(require,module,exports){module.exports={'_from':'github:t2ym/escodegen#master','_id':'escodegen@1.9.0','_inBundle':false,'_integrity':'','_location':'/escodegen','_phantomChildren':{},'_requested':{'type':'git','raw':'escodegen@github:t2ym/escodegen#master','name':'escodegen','escapedName':'escodegen','rawSpec':'github:t2ym/escodegen#master','saveSpec':'github:t2ym/escodegen#master','fetchSpec':null,'gitCommittish':'master'},'_requiredBy':['/','/@thin-hook/build','/@thin-hook/build-coverage'],'_resolved':'github:t2ym/escodegen#09b2f38bfac77c5b4d2ebe15301603285858ca58','_spec':'escodegen@github:t2ym/escodegen#master','_where':'/home/t2ym/work/components/thin-hook','bin':{'esgenerate':'bin/esgenerate.js','escodegen':'bin/escodegen.js'},'bugs':{'url':'https://github.com/estools/escodegen/issues'},'bundleDependencies':false,'dependencies':{'esprima':'^3.1.3','estraverse':'^4.2.0','esutils':'^2.0.2','optionator':'^0.8.1','source-map':'~0.5.6'},'deprecated':false,'description':'ECMAScript code generator','devDependencies':{'acorn':'^4.0.4','bluebird':'^3.4.7','bower-registry-client':'^1.0.0','chai':'^3.5.0','commonjs-everywhere':'^0.9.7','gulp':'^3.8.10','gulp-eslint':'^3.0.1','gulp-mocha':'^3.0.1','semver':'^5.1.0'},'engines':{'node':'>=0.12.0'},'files':['LICENSE.BSD','LICENSE.source-map','README.md','bin','escodegen.js','package.json'],'homepage':'http://github.com/estools/escodegen','license':'BSD-2-Clause','main':'escodegen.js','maintainers':[{'name':'Yusuke Suzuki','email':'utatane.tea@gmail.com','url':'http://github.com/Constellation'}],'name':'escodegen','optionalDependencies':{'source-map':'~0.5.6'},'repository':{'type':'git','url':'git+ssh://git@github.com/estools/escodegen.git'},'scripts':{'build':'cjsify -a path: tools/entry-point.js > escodegen.browser.js','build-min':'cjsify -ma path: tools/entry-point.js > escodegen.browser.min.js','lint':'gulp lint','release':'node tools/release.js','test':'gulp travis','unit-test':'gulp test'},'version':'1.9.0'};},{}],46:[function(require,module,exports){'use strict';var astNodeTypes=require('./lib/ast-node-types'),commentAttachment=require('./lib/comment-attachment'),TokenTranslator=require('./lib/token-translator'),acornJSX=require('acorn-jsx/inject'),acornDynamicImport=require('acorn-dynamic-import/lib/inject').default,importMeta=require('./lib/import-meta'),rawAcorn=require('acorn');var acorn=acornDynamicImport(importMeta(acornJSX(rawAcorn)));var DEFAULT_ECMA_VERSION=5;var lookahead,extra,lastToken;var assign=Object.assign||function assign(target){for(var argIndex=1;argIndex<arguments.length;argIndex++){if(arguments[argIndex]!==null&&typeof arguments[argIndex]==='object'){var keys=Object.keys(arguments[argIndex]);for(var keyIndex=0;keyIndex<keys.length;keyIndex++){target[keys[keyIndex]]=arguments[argIndex][keys[keyIndex]];}}}return target;};function resetExtra(){extra={tokens:null,range:false,loc:false,comment:false,comments:[],tolerant:false,errors:[],strict:false,ecmaFeatures:{},ecmaVersion:DEFAULT_ECMA_VERSION,isModule:false};}var tt=acorn.tokTypes,getLineInfo=acorn.getLineInfo;tt.jsxAttrValueToken={};function normalizeEcmaVersion(ecmaVersion){if(typeof ecmaVersion==='number'){var version=ecmaVersion;if(version>=2015){version-=2009;}switch(version){case 3:case 5:case 6:case 7:case 8:case 9:return version;default:throw new Error('Invalid ecmaVersion.');}}else{return DEFAULT_ECMA_VERSION;}}function isValidNode(node){var ecma=extra.ecmaFeatures;switch(node.type){case'ExperimentalSpreadProperty':case'ExperimentalRestProperty':return ecma.experimentalObjectRestSpread;case'ImportDeclaration':case'ExportNamedDeclaration':case'ExportDefaultDeclaration':case'ExportAllDeclaration':return extra.isModule;default:return true;}}function esprimaFinishNode(result){if(!isValidNode(result)){this.unexpected(result.start);}if(result.type==='TryStatement'){delete result.guardedHandlers;}else if(result.type==='CatchClause'){delete result.guard;}if(result.type==='TemplateElement'){var terminalDollarBraceL=this.input.slice(result.end,result.end+2)==='${';if(result.range){result.range[0]--;result.range[1]+=terminalDollarBraceL?2:1;}if(result.loc){result.loc.start.column--;result.loc.end.column+=terminalDollarBraceL?2:1;}}if(result.type==='Literal'&&result.value===undefined){result.value=null;}if(extra.attachComment){commentAttachment.processComment(result);}if(result.type.indexOf('Function')>-1&&!result.generator){result.generator=false;}return result;}function isValidToken(parser){var ecma=extra.ecmaFeatures;var type=parser.type;switch(type){case tt.jsxName:case tt.jsxText:case tt.jsxTagStart:case tt.jsxTagEnd:return ecma.jsx;case tt.regexp:if(extra.ecmaVersion<6&&parser.value.flags&&parser.value.flags.indexOf('y')>-1){return false;}return true;default:return true;}}function wrapFinishNode(finishNode){return function(node,type,pos,loc){var result=finishNode.call(this,node,type,pos,loc);return esprimaFinishNode.call(this,result);};}acorn.plugins.espree=function(instance){instance.extend('finishNode',wrapFinishNode);instance.extend('finishNodeAt',wrapFinishNode);instance.extend('next',function(next){return function(){if(!isValidToken(this)){this.unexpected();}return next.call(this);};});instance.extend('checkLVal',function(checkLVal){return function(expr,isBinding,checkClashes){if(extra.ecmaFeatures.experimentalObjectRestSpread&&expr.type==='ObjectPattern'){for(var i=0;i<expr.properties.length;i++){if(expr.properties[i].type.indexOf('Experimental')===-1){this.checkLVal(expr.properties[i].value,isBinding,checkClashes);}}return undefined;}return checkLVal.call(this,expr,isBinding,checkClashes);};});instance.extend('parseTopLevel',function(parseTopLevel){return function(node){if(extra.ecmaFeatures.impliedStrict&&this.options.ecmaVersion>=5){this.strict=true;}return parseTopLevel.call(this,node);};});instance.extend('toAssignable',function(toAssignable){return function(node,isBinding){if(extra.ecmaFeatures.experimentalObjectRestSpread&&node.type==='ObjectExpression'){node.type='ObjectPattern';for(var i=0;i<node.properties.length;i++){var prop=node.properties[i];if(prop.type==='ExperimentalSpreadProperty'){prop.type='ExperimentalRestProperty';}else if(prop.kind!=='init'){this.raise(prop.key.start,'Object pattern can\'t contain getter or setter');}else{this.toAssignable(prop.value,isBinding);}}return node;}else{return toAssignable.call(this,node,isBinding);}};});instance.parseObjectRest=function(){var node=this.startNode();this.next();node.argument=this.parseIdent();if(this.type===tt.comma){this.raise(this.start,'Unexpected trailing comma after rest property');}return this.finishNode(node,'ExperimentalRestProperty');};instance.extend('parseProperty',function(parseProperty){return function(isPattern,refDestructuringErrors){if(extra.ecmaFeatures.experimentalObjectRestSpread&&this.type===tt.ellipsis){var prop;if(isPattern){prop=this.parseObjectRest();}else{prop=this.parseSpread();prop.type='ExperimentalSpreadProperty';}return prop;}return parseProperty.call(this,isPattern,refDestructuringErrors);};});instance.extend('checkPropClash',function(checkPropClash){return function(prop,propHash){if(prop.type==='ExperimentalRestProperty'||prop.type==='ExperimentalSpreadProperty'){return;}checkPropClash.call(this,prop,propHash);};});instance.raise=instance.raiseRecoverable=function(pos,message){var loc=getLineInfo(this.input,pos);var err=new SyntaxError(message);err.index=pos;err.lineNumber=loc.line;err.column=loc.column+1;throw err;};instance.unexpected=function(pos){var message='Unexpected token';if(pos!==null&&pos!==undefined){this.pos=pos;if(this.options.locations){while(this.pos<this.lineStart){this.lineStart=this.input.lastIndexOf('\n',this.lineStart-2)+1;--this.curLine;}}this.nextToken();}if(this.end>this.start){message+=' '+this.input.slice(this.start,this.end);}this.raise(this.start,message);};instance.extend('jsx_readString',function(jsxReadString){return function(quote){var result=jsxReadString.call(this,quote);if(this.type===tt.string){extra.jsxAttrValueToken=true;}return result;};});};function tokenize(code,options){var toString,tokens,impliedStrict,translator=new TokenTranslator(tt,code);toString=String;if(typeof code!=='string'&&!(code instanceof String)){code=toString(code);}lookahead=null;options=assign({},options);var acornOptions={ecmaVersion:DEFAULT_ECMA_VERSION,plugins:{espree:true,dynamicImport:true,importMeta:true}};resetExtra();options.tokens=true;extra.tokens=[];extra.range=typeof options.range==='boolean'&&options.range;acornOptions.ranges=extra.range;extra.loc=typeof options.loc==='boolean'&&options.loc;acornOptions.locations=extra.loc;extra.comment=typeof options.comment==='boolean'&&options.comment;if(extra.comment){acornOptions.onComment=function(){var comment=convertAcornCommentToEsprimaComment.apply(this,arguments);extra.comments.push(comment);};}extra.tolerant=typeof options.tolerant==='boolean'&&options.tolerant;acornOptions.ecmaVersion=extra.ecmaVersion=normalizeEcmaVersion(options.ecmaVersion);if(options.ecmaFeatures&&typeof options.ecmaFeatures==='object'){extra.ecmaFeatures=assign({},options.ecmaFeatures);impliedStrict=extra.ecmaFeatures.impliedStrict;extra.ecmaFeatures.impliedStrict=typeof impliedStrict==='boolean'&&impliedStrict;}try{var tokenizer=acorn.tokenizer(code,acornOptions);while((lookahead=tokenizer.getToken()).type!==tt.eof){translator.onToken(lookahead,extra);}tokens=extra.tokens;if(extra.comment){tokens.comments=extra.comments;}if(extra.tolerant){tokens.errors=extra.errors;}}catch(e){throw e;}return tokens;}function convertAcornCommentToEsprimaComment(block,text,start,end,startLoc,endLoc){var comment={type:block?'Block':'Line',value:text};if(typeof start==='number'){comment.start=start;comment.end=end;comment.range=[start,end];}if(typeof startLoc==='object'){comment.loc={start:startLoc,end:endLoc};}return comment;}function parse(code,options){var program,toString=String,translator,impliedStrict,acornOptions={ecmaVersion:DEFAULT_ECMA_VERSION,plugins:{espree:true,dynamicImport:true,importMeta:true}};lastToken=null;if(typeof code!=='string'&&!(code instanceof String)){code=toString(code);}resetExtra();commentAttachment.reset();if(typeof options!=='undefined'){extra.range=typeof options.range==='boolean'&&options.range;extra.loc=typeof options.loc==='boolean'&&options.loc;extra.attachComment=typeof options.attachComment==='boolean'&&options.attachComment;if(extra.loc&&options.source!==null&&options.source!==undefined){extra.source=toString(options.source);}if(typeof options.tokens==='boolean'&&options.tokens){extra.tokens=[];translator=new TokenTranslator(tt,code);}if(typeof options.comment==='boolean'&&options.comment){extra.comment=true;extra.comments=[];}if(typeof options.tolerant==='boolean'&&options.tolerant){extra.errors=[];}if(extra.attachComment){extra.range=true;extra.comments=[];commentAttachment.reset();}acornOptions.ecmaVersion=extra.ecmaVersion=normalizeEcmaVersion(options.ecmaVersion);if(options.sourceType==='module'){extra.isModule=true;if(acornOptions.ecmaVersion<6){acornOptions.ecmaVersion=6;extra.ecmaVersion=6;}acornOptions.sourceType='module';}if(options.ecmaFeatures&&typeof options.ecmaFeatures==='object'){extra.ecmaFeatures=assign({},options.ecmaFeatures);impliedStrict=extra.ecmaFeatures.impliedStrict;extra.ecmaFeatures.impliedStrict=typeof impliedStrict==='boolean'&&impliedStrict;if(options.ecmaFeatures.globalReturn){acornOptions.allowReturnOutsideFunction=true;}}acornOptions.onToken=function(token){if(extra.tokens){translator.onToken(token,extra);}if(token.type!==tt.eof){lastToken=token;}};if(extra.attachComment||extra.comment){acornOptions.onComment=function(){var comment=convertAcornCommentToEsprimaComment.apply(this,arguments);extra.comments.push(comment);if(extra.attachComment){commentAttachment.addComment(comment);}};}if(extra.range){acornOptions.ranges=true;}if(extra.loc){acornOptions.locations=true;}if(extra.ecmaFeatures.jsx){acornOptions.plugins={jsx:true,espree:true};}}program=acorn.parse(code,acornOptions);program.sourceType=extra.isModule?'module':'script';if(extra.comment||extra.attachComment){program.comments=extra.comments;}if(extra.tokens){program.tokens=extra.tokens;}if(program.range){program.range[0]=program.body.length?program.body[0].range[0]:program.range[0];program.range[1]=lastToken?lastToken.range[1]:program.range[1];}if(program.loc){program.loc.start=program.body.length?program.body[0].loc.start:program.loc.start;program.loc.end=lastToken?lastToken.loc.end:program.loc.end;}return program;}exports.version=require('./package.json').version;exports.tokenize=tokenize;exports.parse=parse;exports.Syntax=function(){var name,types={};if(typeof Object.create==='function'){types=Object.create(null);}for(name in astNodeTypes){if(astNodeTypes.hasOwnProperty(name)){types[name]=astNodeTypes[name];}}if(typeof Object.freeze==='function'){Object.freeze(types);}return types;}();exports.VisitorKeys=function(){var visitorKeys=require('./lib/visitor-keys');var name,keys={};if(typeof Object.create==='function'){keys=Object.create(null);}for(name in visitorKeys){if(visitorKeys.hasOwnProperty(name)){keys[name]=visitorKeys[name];}}if(typeof Object.freeze==='function'){Object.freeze(keys);}return keys;}();},{'./lib/ast-node-types':47,'./lib/comment-attachment':48,'./lib/import-meta':49,'./lib/token-translator':50,'./lib/visitor-keys':51,'./package.json':53,'acorn':52,'acorn-dynamic-import/lib/inject':7,'acorn-jsx/inject':8}],47:[function(require,module,exports){'use strict';module.exports={AssignmentExpression:'AssignmentExpression',AssignmentPattern:'AssignmentPattern',ArrayExpression:'ArrayExpression',ArrayPattern:'ArrayPattern',ArrowFunctionExpression:'ArrowFunctionExpression',AwaitExpression:'AwaitExpression',BlockStatement:'BlockStatement',BinaryExpression:'BinaryExpression',BreakStatement:'BreakStatement',CallExpression:'CallExpression',CatchClause:'CatchClause',ClassBody:'ClassBody',ClassDeclaration:'ClassDeclaration',ClassExpression:'ClassExpression',ConditionalExpression:'ConditionalExpression',ContinueStatement:'ContinueStatement',DoWhileStatement:'DoWhileStatement',DebuggerStatement:'DebuggerStatement',EmptyStatement:'EmptyStatement',ExperimentalRestProperty:'ExperimentalRestProperty',ExperimentalSpreadProperty:'ExperimentalSpreadProperty',ExpressionStatement:'ExpressionStatement',ForStatement:'ForStatement',ForInStatement:'ForInStatement',ForOfStatement:'ForOfStatement',FunctionDeclaration:'FunctionDeclaration',FunctionExpression:'FunctionExpression',Identifier:'Identifier',IfStatement:'IfStatement',Literal:'Literal',LabeledStatement:'LabeledStatement',LogicalExpression:'LogicalExpression',MemberExpression:'MemberExpression',MetaProperty:'MetaProperty',MethodDefinition:'MethodDefinition',NewExpression:'NewExpression',ObjectExpression:'ObjectExpression',ObjectPattern:'ObjectPattern',Program:'Program',Property:'Property',RestElement:'RestElement',ReturnStatement:'ReturnStatement',SequenceExpression:'SequenceExpression',SpreadElement:'SpreadElement',Super:'Super',SwitchCase:'SwitchCase',SwitchStatement:'SwitchStatement',TaggedTemplateExpression:'TaggedTemplateExpression',TemplateElement:'TemplateElement',TemplateLiteral:'TemplateLiteral',ThisExpression:'ThisExpression',ThrowStatement:'ThrowStatement',TryStatement:'TryStatement',UnaryExpression:'UnaryExpression',UpdateExpression:'UpdateExpression',VariableDeclaration:'VariableDeclaration',VariableDeclarator:'VariableDeclarator',WhileStatement:'WhileStatement',WithStatement:'WithStatement',YieldExpression:'YieldExpression',JSXIdentifier:'JSXIdentifier',JSXNamespacedName:'JSXNamespacedName',JSXMemberExpression:'JSXMemberExpression',JSXEmptyExpression:'JSXEmptyExpression',JSXExpressionContainer:'JSXExpressionContainer',JSXElement:'JSXElement',JSXClosingElement:'JSXClosingElement',JSXOpeningElement:'JSXOpeningElement',JSXAttribute:'JSXAttribute',JSXSpreadAttribute:'JSXSpreadAttribute',JSXText:'JSXText',ExportDefaultDeclaration:'ExportDefaultDeclaration',ExportNamedDeclaration:'ExportNamedDeclaration',ExportAllDeclaration:'ExportAllDeclaration',ExportSpecifier:'ExportSpecifier',ImportDeclaration:'ImportDeclaration',ImportSpecifier:'ImportSpecifier',ImportDefaultSpecifier:'ImportDefaultSpecifier',ImportNamespaceSpecifier:'ImportNamespaceSpecifier'};},{}],48:[function(require,module,exports){'use strict';var astNodeTypes=require('./ast-node-types');var extra={trailingComments:[],leadingComments:[],bottomRightStack:[],previousNode:null};module.exports={reset:function(){extra.trailingComments=[];extra.leadingComments=[];extra.bottomRightStack=[];extra.previousNode=null;},addComment:function(comment){extra.trailingComments.push(comment);extra.leadingComments.push(comment);},processComment:function(node){var lastChild,trailingComments,i,j;if(node.type===astNodeTypes.Program){if(node.body.length>0){return;}}if(extra.trailingComments.length>0){if(extra.trailingComments[0].range[0]>=node.range[1]){trailingComments=extra.trailingComments;extra.trailingComments=[];}else{extra.trailingComments.length=0;}}else{if(extra.bottomRightStack.length>0&&extra.bottomRightStack[extra.bottomRightStack.length-1].trailingComments&&extra.bottomRightStack[extra.bottomRightStack.length-1].trailingComments[0].range[0]>=node.range[1]){trailingComments=extra.bottomRightStack[extra.bottomRightStack.length-1].trailingComments;delete extra.bottomRightStack[extra.bottomRightStack.length-1].trailingComments;}}while(extra.bottomRightStack.length>0&&extra.bottomRightStack[extra.bottomRightStack.length-1].range[0]>=node.range[0]){lastChild=extra.bottomRightStack.pop();}if(lastChild){if(lastChild.leadingComments){if(lastChild.leadingComments[lastChild.leadingComments.length-1].range[1]<=node.range[0]){node.leadingComments=lastChild.leadingComments;delete lastChild.leadingComments;}else{for(i=lastChild.leadingComments.length-2;i>=0;--i){if(lastChild.leadingComments[i].range[1]<=node.range[0]){node.leadingComments=lastChild.leadingComments.splice(0,i+1);break;}}}}}else if(extra.leadingComments.length>0){if(extra.leadingComments[extra.leadingComments.length-1].range[1]<=node.range[0]){if(extra.previousNode){for(j=0;j<extra.leadingComments.length;j++){if(extra.leadingComments[j].end<extra.previousNode.end){extra.leadingComments.splice(j,1);j--;}}}if(extra.leadingComments.length>0){node.leadingComments=extra.leadingComments;extra.leadingComments=[];}}else{for(i=0;i<extra.leadingComments.length;i++){if(extra.leadingComments[i].range[1]>node.range[0]){break;}}node.leadingComments=extra.leadingComments.slice(0,i);if(node.leadingComments.length===0){delete node.leadingComments;}trailingComments=extra.leadingComments.slice(i);if(trailingComments.length===0){trailingComments=null;}}}extra.previousNode=node;if(trailingComments){node.trailingComments=trailingComments;}extra.bottomRightStack.push(node);}};},{'./ast-node-types':47}],49:[function(require,module,exports){'use strict';function injectImportMeta(acorn){var tt=acorn.tokTypes;tt._import.startsExpr=true;function parseImportMeta(){var node=this.startNode();var meta=this.parseIdent(true);if(this.type!==tt.dot){this.unexpected();}this.next();node.meta=meta;let containsEsc=this.containsEsc;node.property=this.parseIdent(true);if(node.property.name!=='meta'||containsEsc){this.raiseRecoverable(node.property.start,'The only valid meta property for import is import.meta');}return this.finishNode(node,'MetaProperty');}function peekNext(){let next=this.input[this.pos];if(' \t\n'.indexOf(next)>=0){let pos=this.pos;while(' \t\n'.indexOf(next=this.input[pos])>=0){pos++;}}return next;}acorn.plugins.importMeta=function(){function importMetaPlugin(instance){instance.extend('parseStatement',function(nextMethod){return function(){function parseStatement(){if(this.type===tt._import&&peekNext.call(this)==='.'){return this.parseExpressionStatement(this.startNode(),this.parseExpression());}for(var _len=arguments.length,args=Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}return nextMethod.apply(this,args);}return parseStatement;}();});instance.extend('parseExprAtom',function(nextMethod){return function(){function parseExprAtom(refDestructuringErrors){if(this.type===tt._import&&peekNext.call(this)==='.'){return parseImportMeta.call(this);}return nextMethod.call(this,refDestructuringErrors);}return parseExprAtom;}();});}return importMetaPlugin;}();return acorn;}module.exports=injectImportMeta;},{}],50:[function(require,module,exports){'use strict';var Token={Boolean:'Boolean',EOF:'<end>',Identifier:'Identifier',Keyword:'Keyword',Null:'Null',Numeric:'Numeric',Punctuator:'Punctuator',String:'String',RegularExpression:'RegularExpression',Template:'Template',JSXIdentifier:'JSXIdentifier',JSXText:'JSXText'};function convertTemplatePart(tokens,code){var firstToken=tokens[0],lastTemplateToken=tokens[tokens.length-1];var token={type:Token.Template,value:code.slice(firstToken.start,lastTemplateToken.end)};if(firstToken.loc){token.loc={start:firstToken.loc.start,end:lastTemplateToken.loc.end};}if(firstToken.range){token.start=firstToken.range[0];token.end=lastTemplateToken.range[1];token.range=[token.start,token.end];}return token;}function TokenTranslator(acornTokTypes,code){this._acornTokTypes=acornTokTypes;this._tokens=[];this._curlyBrace=null;this._code=code;}TokenTranslator.prototype={constructor:TokenTranslator,translate:function(token,extra){var type=token.type,tt=this._acornTokTypes;if(type===tt.name){token.type=Token.Identifier;if(token.value==='static'){token.type=Token.Keyword;}if(extra.ecmaVersion>5&&(token.value==='yield'||token.value==='let')){token.type=Token.Keyword;}}else if(type===tt.semi||type===tt.comma||type===tt.parenL||type===tt.parenR||type===tt.braceL||type===tt.braceR||type===tt.dot||type===tt.bracketL||type===tt.colon||type===tt.question||type===tt.bracketR||type===tt.ellipsis||type===tt.arrow||type===tt.jsxTagStart||type===tt.incDec||type===tt.starstar||type===tt.jsxTagEnd||type===tt.prefix||type.binop&&!type.keyword||type.isAssign){token.type=Token.Punctuator;token.value=this._code.slice(token.start,token.end);}else if(type===tt.jsxName){token.type=Token.JSXIdentifier;}else if(type.label==='jsxText'||type===tt.jsxAttrValueToken){token.type=Token.JSXText;}else if(type.keyword){if(type.keyword==='true'||type.keyword==='false'){token.type=Token.Boolean;}else if(type.keyword==='null'){token.type=Token.Null;}else{token.type=Token.Keyword;}}else if(type===tt.num){token.type=Token.Numeric;token.value=this._code.slice(token.start,token.end);}else if(type===tt.string){if(extra.jsxAttrValueToken){extra.jsxAttrValueToken=false;token.type=Token.JSXText;}else{token.type=Token.String;}token.value=this._code.slice(token.start,token.end);}else if(type===tt.regexp){token.type=Token.RegularExpression;var value=token.value;token.regex={flags:value.flags,pattern:value.pattern};token.value='/'+value.pattern+'/'+value.flags;}return token;},onToken:function(token,extra){var that=this,tt=this._acornTokTypes,tokens=extra.tokens,templateTokens=this._tokens;function translateTemplateTokens(){tokens.push(convertTemplatePart(that._tokens,that._code));that._tokens=[];}if(token.type===tt.eof){if(this._curlyBrace){tokens.push(this.translate(this._curlyBrace,extra));}return;}if(token.type===tt.backQuote){if(this._curlyBrace){tokens.push(this.translate(this._curlyBrace,extra));this._curlyBrace=null;}templateTokens.push(token);if(templateTokens.length>1){translateTemplateTokens();}return;}else if(token.type===tt.dollarBraceL){templateTokens.push(token);translateTemplateTokens();return;}else if(token.type===tt.braceR){if(this._curlyBrace){tokens.push(this.translate(this._curlyBrace,extra));}this._curlyBrace=token;return;}else if(token.type===tt.template||token.type===tt.invalidTemplate){if(this._curlyBrace){templateTokens.push(this._curlyBrace);this._curlyBrace=null;}templateTokens.push(token);return;}if(this._curlyBrace){tokens.push(this.translate(this._curlyBrace,extra));this._curlyBrace=null;}tokens.push(this.translate(token,extra));}};module.exports=TokenTranslator;},{}],51:[function(require,module,exports){'use strict';module.exports={AssignmentExpression:['left','right'],AssignmentPattern:['left','right'],ArrayExpression:['elements'],ArrayPattern:['elements'],ArrowFunctionExpression:['params','body'],BlockStatement:['body'],BinaryExpression:['left','right'],BreakStatement:['label'],CallExpression:['callee','arguments'],CatchClause:['param','body'],ClassBody:['body'],ClassDeclaration:['id','superClass','body'],ClassExpression:['id','superClass','body'],ConditionalExpression:['test','consequent','alternate'],ContinueStatement:['label'],DebuggerStatement:[],DirectiveStatement:[],DoWhileStatement:['body','test'],EmptyStatement:[],ExportAllDeclaration:['source'],ExportDefaultDeclaration:['declaration'],ExportNamedDeclaration:['declaration','specifiers','source'],ExportSpecifier:['exported','local'],ExpressionStatement:['expression'],ForStatement:['init','test','update','body'],ForInStatement:['left','right','body'],ForOfStatement:['left','right','body'],FunctionDeclaration:['id','params','body'],FunctionExpression:['id','params','body'],Identifier:[],IfStatement:['test','consequent','alternate'],ImportDeclaration:['specifiers','source'],ImportDefaultSpecifier:['local'],ImportNamespaceSpecifier:['local'],ImportSpecifier:['imported','local'],Literal:[],LabeledStatement:['label','body'],LogicalExpression:['left','right'],MemberExpression:['object','property'],MetaProperty:['meta','property'],MethodDefinition:['key','value'],ModuleSpecifier:[],NewExpression:['callee','arguments'],ObjectExpression:['properties'],ObjectPattern:['properties'],Program:['body'],Property:['key','value'],RestElement:['argument'],ReturnStatement:['argument'],SequenceExpression:['expressions'],SpreadElement:['argument'],Super:[],SwitchStatement:['discriminant','cases'],SwitchCase:['test','consequent'],TaggedTemplateExpression:['tag','quasi'],TemplateElement:[],TemplateLiteral:['quasis','expressions'],ThisExpression:[],ThrowStatement:['argument'],TryStatement:['block','handler','finalizer'],UnaryExpression:['argument'],UpdateExpression:['argument'],VariableDeclaration:['declarations'],VariableDeclarator:['id','init'],WhileStatement:['test','body'],WithStatement:['object','body'],YieldExpression:['argument'],JSXIdentifier:[],JSXNamespacedName:['namespace','name'],JSXMemberExpression:['object','property'],JSXEmptyExpression:[],JSXExpressionContainer:['expression'],JSXElement:['openingElement','closingElement','children'],JSXClosingElement:['name'],JSXOpeningElement:['name','attributes'],JSXAttribute:['name','value'],JSXText:null,JSXSpreadAttribute:['argument'],ExperimentalRestProperty:['argument'],ExperimentalSpreadProperty:['argument']};},{}],52:[function(require,module,exports){(function(global,factory){typeof exports==='object'&&typeof module!=='undefined'?factory(exports):typeof define==='function'&&define.amd?define(['exports'],factory):factory(global.acorn={});}(this,function(exports){'use strict';var reservedWords={3:'abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile',5:'class enum extends super const export import',6:'enum',strict:'implements interface let package private protected public static yield',strictBind:'eval arguments'};var ecma5AndLessKeywords='break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this';var keywords={5:ecma5AndLessKeywords,6:ecma5AndLessKeywords+' const class extends export import super'};var keywordRelationalOperator=/^in(stanceof)?$/;var nonASCIIidentifierStartChars='\\xaa\\xb5\\xba\\xc0-\\xd6\\xd8-\\xf6\\xf8-\\u02c1\\u02c6-\\u02d1\\u02e0-\\u02e4\\u02ec\\u02ee\\u0370-\\u0374\\u0376\\u0377\\u037a-\\u037d\\u037f\\u0386\\u0388-\\u038a\\u038c\\u038e-\\u03a1\\u03a3-\\u03f5\\u03f7-\\u0481\\u048a-\\u052f\\u0531-\\u0556\\u0559\\u0561-\\u0587\\u05d0-\\u05ea\\u05f0-\\u05f2\\u0620-\\u064a\\u066e\\u066f\\u0671-\\u06d3\\u06d5\\u06e5\\u06e6\\u06ee\\u06ef\\u06fa-\\u06fc\\u06ff\\u0710\\u0712-\\u072f\\u074d-\\u07a5\\u07b1\\u07ca-\\u07ea\\u07f4\\u07f5\\u07fa\\u0800-\\u0815\\u081a\\u0824\\u0828\\u0840-\\u0858\\u08a0-\\u08b4\\u08b6-\\u08bd\\u0904-\\u0939\\u093d\\u0950\\u0958-\\u0961\\u0971-\\u0980\\u0985-\\u098c\\u098f\\u0990\\u0993-\\u09a8\\u09aa-\\u09b0\\u09b2\\u09b6-\\u09b9\\u09bd\\u09ce\\u09dc\\u09dd\\u09df-\\u09e1\\u09f0\\u09f1\\u0a05-\\u0a0a\\u0a0f\\u0a10\\u0a13-\\u0a28\\u0a2a-\\u0a30\\u0a32\\u0a33\\u0a35\\u0a36\\u0a38\\u0a39\\u0a59-\\u0a5c\\u0a5e\\u0a72-\\u0a74\\u0a85-\\u0a8d\\u0a8f-\\u0a91\\u0a93-\\u0aa8\\u0aaa-\\u0ab0\\u0ab2\\u0ab3\\u0ab5-\\u0ab9\\u0abd\\u0ad0\\u0ae0\\u0ae1\\u0af9\\u0b05-\\u0b0c\\u0b0f\\u0b10\\u0b13-\\u0b28\\u0b2a-\\u0b30\\u0b32\\u0b33\\u0b35-\\u0b39\\u0b3d\\u0b5c\\u0b5d\\u0b5f-\\u0b61\\u0b71\\u0b83\\u0b85-\\u0b8a\\u0b8e-\\u0b90\\u0b92-\\u0b95\\u0b99\\u0b9a\\u0b9c\\u0b9e\\u0b9f\\u0ba3\\u0ba4\\u0ba8-\\u0baa\\u0bae-\\u0bb9\\u0bd0\\u0c05-\\u0c0c\\u0c0e-\\u0c10\\u0c12-\\u0c28\\u0c2a-\\u0c39\\u0c3d\\u0c58-\\u0c5a\\u0c60\\u0c61\\u0c80\\u0c85-\\u0c8c\\u0c8e-\\u0c90\\u0c92-\\u0ca8\\u0caa-\\u0cb3\\u0cb5-\\u0cb9\\u0cbd\\u0cde\\u0ce0\\u0ce1\\u0cf1\\u0cf2\\u0d05-\\u0d0c\\u0d0e-\\u0d10\\u0d12-\\u0d3a\\u0d3d\\u0d4e\\u0d54-\\u0d56\\u0d5f-\\u0d61\\u0d7a-\\u0d7f\\u0d85-\\u0d96\\u0d9a-\\u0db1\\u0db3-\\u0dbb\\u0dbd\\u0dc0-\\u0dc6\\u0e01-\\u0e30\\u0e32\\u0e33\\u0e40-\\u0e46\\u0e81\\u0e82\\u0e84\\u0e87\\u0e88\\u0e8a\\u0e8d\\u0e94-\\u0e97\\u0e99-\\u0e9f\\u0ea1-\\u0ea3\\u0ea5\\u0ea7\\u0eaa\\u0eab\\u0ead-\\u0eb0\\u0eb2\\u0eb3\\u0ebd\\u0ec0-\\u0ec4\\u0ec6\\u0edc-\\u0edf\\u0f00\\u0f40-\\u0f47\\u0f49-\\u0f6c\\u0f88-\\u0f8c\\u1000-\\u102a\\u103f\\u1050-\\u1055\\u105a-\\u105d\\u1061\\u1065\\u1066\\u106e-\\u1070\\u1075-\\u1081\\u108e\\u10a0-\\u10c5\\u10c7\\u10cd\\u10d0-\\u10fa\\u10fc-\\u1248\\u124a-\\u124d\\u1250-\\u1256\\u1258\\u125a-\\u125d\\u1260-\\u1288\\u128a-\\u128d\\u1290-\\u12b0\\u12b2-\\u12b5\\u12b8-\\u12be\\u12c0\\u12c2-\\u12c5\\u12c8-\\u12d6\\u12d8-\\u1310\\u1312-\\u1315\\u1318-\\u135a\\u1380-\\u138f\\u13a0-\\u13f5\\u13f8-\\u13fd\\u1401-\\u166c\\u166f-\\u167f\\u1681-\\u169a\\u16a0-\\u16ea\\u16ee-\\u16f8\\u1700-\\u170c\\u170e-\\u1711\\u1720-\\u1731\\u1740-\\u1751\\u1760-\\u176c\\u176e-\\u1770\\u1780-\\u17b3\\u17d7\\u17dc\\u1820-\\u1877\\u1880-\\u18a8\\u18aa\\u18b0-\\u18f5\\u1900-\\u191e\\u1950-\\u196d\\u1970-\\u1974\\u1980-\\u19ab\\u19b0-\\u19c9\\u1a00-\\u1a16\\u1a20-\\u1a54\\u1aa7\\u1b05-\\u1b33\\u1b45-\\u1b4b\\u1b83-\\u1ba0\\u1bae\\u1baf\\u1bba-\\u1be5\\u1c00-\\u1c23\\u1c4d-\\u1c4f\\u1c5a-\\u1c7d\\u1c80-\\u1c88\\u1ce9-\\u1cec\\u1cee-\\u1cf1\\u1cf5\\u1cf6\\u1d00-\\u1dbf\\u1e00-\\u1f15\\u1f18-\\u1f1d\\u1f20-\\u1f45\\u1f48-\\u1f4d\\u1f50-\\u1f57\\u1f59\\u1f5b\\u1f5d\\u1f5f-\\u1f7d\\u1f80-\\u1fb4\\u1fb6-\\u1fbc\\u1fbe\\u1fc2-\\u1fc4\\u1fc6-\\u1fcc\\u1fd0-\\u1fd3\\u1fd6-\\u1fdb\\u1fe0-\\u1fec\\u1ff2-\\u1ff4\\u1ff6-\\u1ffc\\u2071\\u207f\\u2090-\\u209c\\u2102\\u2107\\u210a-\\u2113\\u2115\\u2118-\\u211d\\u2124\\u2126\\u2128\\u212a-\\u2139\\u213c-\\u213f\\u2145-\\u2149\\u214e\\u2160-\\u2188\\u2c00-\\u2c2e\\u2c30-\\u2c5e\\u2c60-\\u2ce4\\u2ceb-\\u2cee\\u2cf2\\u2cf3\\u2d00-\\u2d25\\u2d27\\u2d2d\\u2d30-\\u2d67\\u2d6f\\u2d80-\\u2d96\\u2da0-\\u2da6\\u2da8-\\u2dae\\u2db0-\\u2db6\\u2db8-\\u2dbe\\u2dc0-\\u2dc6\\u2dc8-\\u2dce\\u2dd0-\\u2dd6\\u2dd8-\\u2dde\\u3005-\\u3007\\u3021-\\u3029\\u3031-\\u3035\\u3038-\\u303c\\u3041-\\u3096\\u309b-\\u309f\\u30a1-\\u30fa\\u30fc-\\u30ff\\u3105-\\u312d\\u3131-\\u318e\\u31a0-\\u31ba\\u31f0-\\u31ff\\u3400-\\u4db5\\u4e00-\\u9fd5\\ua000-\\ua48c\\ua4d0-\\ua4fd\\ua500-\\ua60c\\ua610-\\ua61f\\ua62a\\ua62b\\ua640-\\ua66e\\ua67f-\\ua69d\\ua6a0-\\ua6ef\\ua717-\\ua71f\\ua722-\\ua788\\ua78b-\\ua7ae\\ua7b0-\\ua7b7\\ua7f7-\\ua801\\ua803-\\ua805\\ua807-\\ua80a\\ua80c-\\ua822\\ua840-\\ua873\\ua882-\\ua8b3\\ua8f2-\\ua8f7\\ua8fb\\ua8fd\\ua90a-\\ua925\\ua930-\\ua946\\ua960-\\ua97c\\ua984-\\ua9b2\\ua9cf\\ua9e0-\\ua9e4\\ua9e6-\\ua9ef\\ua9fa-\\ua9fe\\uaa00-\\uaa28\\uaa40-\\uaa42\\uaa44-\\uaa4b\\uaa60-\\uaa76\\uaa7a\\uaa7e-\\uaaaf\\uaab1\\uaab5\\uaab6\\uaab9-\\uaabd\\uaac0\\uaac2\\uaadb-\\uaadd\\uaae0-\\uaaea\\uaaf2-\\uaaf4\\uab01-\\uab06\\uab09-\\uab0e\\uab11-\\uab16\\uab20-\\uab26\\uab28-\\uab2e\\uab30-\\uab5a\\uab5c-\\uab65\\uab70-\\uabe2\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\uf900-\\ufa6d\\ufa70-\\ufad9\\ufb00-\\ufb06\\ufb13-\\ufb17\\ufb1d\\ufb1f-\\ufb28\\ufb2a-\\ufb36\\ufb38-\\ufb3c\\ufb3e\\ufb40\\ufb41\\ufb43\\ufb44\\ufb46-\\ufbb1\\ufbd3-\\ufd3d\\ufd50-\\ufd8f\\ufd92-\\ufdc7\\ufdf0-\\ufdfb\\ufe70-\\ufe74\\ufe76-\\ufefc\\uff21-\\uff3a\\uff41-\\uff5a\\uff66-\\uffbe\\uffc2-\\uffc7\\uffca-\\uffcf\\uffd2-\\uffd7\\uffda-\\uffdc';var nonASCIIidentifierChars='\\u200c\\u200d\\xb7\\u0300-\\u036f\\u0387\\u0483-\\u0487\\u0591-\\u05bd\\u05bf\\u05c1\\u05c2\\u05c4\\u05c5\\u05c7\\u0610-\\u061a\\u064b-\\u0669\\u0670\\u06d6-\\u06dc\\u06df-\\u06e4\\u06e7\\u06e8\\u06ea-\\u06ed\\u06f0-\\u06f9\\u0711\\u0730-\\u074a\\u07a6-\\u07b0\\u07c0-\\u07c9\\u07eb-\\u07f3\\u0816-\\u0819\\u081b-\\u0823\\u0825-\\u0827\\u0829-\\u082d\\u0859-\\u085b\\u08d4-\\u08e1\\u08e3-\\u0903\\u093a-\\u093c\\u093e-\\u094f\\u0951-\\u0957\\u0962\\u0963\\u0966-\\u096f\\u0981-\\u0983\\u09bc\\u09be-\\u09c4\\u09c7\\u09c8\\u09cb-\\u09cd\\u09d7\\u09e2\\u09e3\\u09e6-\\u09ef\\u0a01-\\u0a03\\u0a3c\\u0a3e-\\u0a42\\u0a47\\u0a48\\u0a4b-\\u0a4d\\u0a51\\u0a66-\\u0a71\\u0a75\\u0a81-\\u0a83\\u0abc\\u0abe-\\u0ac5\\u0ac7-\\u0ac9\\u0acb-\\u0acd\\u0ae2\\u0ae3\\u0ae6-\\u0aef\\u0b01-\\u0b03\\u0b3c\\u0b3e-\\u0b44\\u0b47\\u0b48\\u0b4b-\\u0b4d\\u0b56\\u0b57\\u0b62\\u0b63\\u0b66-\\u0b6f\\u0b82\\u0bbe-\\u0bc2\\u0bc6-\\u0bc8\\u0bca-\\u0bcd\\u0bd7\\u0be6-\\u0bef\\u0c00-\\u0c03\\u0c3e-\\u0c44\\u0c46-\\u0c48\\u0c4a-\\u0c4d\\u0c55\\u0c56\\u0c62\\u0c63\\u0c66-\\u0c6f\\u0c81-\\u0c83\\u0cbc\\u0cbe-\\u0cc4\\u0cc6-\\u0cc8\\u0cca-\\u0ccd\\u0cd5\\u0cd6\\u0ce2\\u0ce3\\u0ce6-\\u0cef\\u0d01-\\u0d03\\u0d3e-\\u0d44\\u0d46-\\u0d48\\u0d4a-\\u0d4d\\u0d57\\u0d62\\u0d63\\u0d66-\\u0d6f\\u0d82\\u0d83\\u0dca\\u0dcf-\\u0dd4\\u0dd6\\u0dd8-\\u0ddf\\u0de6-\\u0def\\u0df2\\u0df3\\u0e31\\u0e34-\\u0e3a\\u0e47-\\u0e4e\\u0e50-\\u0e59\\u0eb1\\u0eb4-\\u0eb9\\u0ebb\\u0ebc\\u0ec8-\\u0ecd\\u0ed0-\\u0ed9\\u0f18\\u0f19\\u0f20-\\u0f29\\u0f35\\u0f37\\u0f39\\u0f3e\\u0f3f\\u0f71-\\u0f84\\u0f86\\u0f87\\u0f8d-\\u0f97\\u0f99-\\u0fbc\\u0fc6\\u102b-\\u103e\\u1040-\\u1049\\u1056-\\u1059\\u105e-\\u1060\\u1062-\\u1064\\u1067-\\u106d\\u1071-\\u1074\\u1082-\\u108d\\u108f-\\u109d\\u135d-\\u135f\\u1369-\\u1371\\u1712-\\u1714\\u1732-\\u1734\\u1752\\u1753\\u1772\\u1773\\u17b4-\\u17d3\\u17dd\\u17e0-\\u17e9\\u180b-\\u180d\\u1810-\\u1819\\u18a9\\u1920-\\u192b\\u1930-\\u193b\\u1946-\\u194f\\u19d0-\\u19da\\u1a17-\\u1a1b\\u1a55-\\u1a5e\\u1a60-\\u1a7c\\u1a7f-\\u1a89\\u1a90-\\u1a99\\u1ab0-\\u1abd\\u1b00-\\u1b04\\u1b34-\\u1b44\\u1b50-\\u1b59\\u1b6b-\\u1b73\\u1b80-\\u1b82\\u1ba1-\\u1bad\\u1bb0-\\u1bb9\\u1be6-\\u1bf3\\u1c24-\\u1c37\\u1c40-\\u1c49\\u1c50-\\u1c59\\u1cd0-\\u1cd2\\u1cd4-\\u1ce8\\u1ced\\u1cf2-\\u1cf4\\u1cf8\\u1cf9\\u1dc0-\\u1df5\\u1dfb-\\u1dff\\u203f\\u2040\\u2054\\u20d0-\\u20dc\\u20e1\\u20e5-\\u20f0\\u2cef-\\u2cf1\\u2d7f\\u2de0-\\u2dff\\u302a-\\u302f\\u3099\\u309a\\ua620-\\ua629\\ua66f\\ua674-\\ua67d\\ua69e\\ua69f\\ua6f0\\ua6f1\\ua802\\ua806\\ua80b\\ua823-\\ua827\\ua880\\ua881\\ua8b4-\\ua8c5\\ua8d0-\\ua8d9\\ua8e0-\\ua8f1\\ua900-\\ua909\\ua926-\\ua92d\\ua947-\\ua953\\ua980-\\ua983\\ua9b3-\\ua9c0\\ua9d0-\\ua9d9\\ua9e5\\ua9f0-\\ua9f9\\uaa29-\\uaa36\\uaa43\\uaa4c\\uaa4d\\uaa50-\\uaa59\\uaa7b-\\uaa7d\\uaab0\\uaab2-\\uaab4\\uaab7\\uaab8\\uaabe\\uaabf\\uaac1\\uaaeb-\\uaaef\\uaaf5\\uaaf6\\uabe3-\\uabea\\uabec\\uabed\\uabf0-\\uabf9\\ufb1e\\ufe00-\\ufe0f\\ufe20-\\ufe2f\\ufe33\\ufe34\\ufe4d-\\ufe4f\\uff10-\\uff19\\uff3f';var nonASCIIidentifierStart=new RegExp('['+nonASCIIidentifierStartChars+']');var nonASCIIidentifier=new RegExp('['+nonASCIIidentifierStartChars+nonASCIIidentifierChars+']');nonASCIIidentifierStartChars=nonASCIIidentifierChars=null;var astralIdentifierStartCodes=[0,11,2,25,2,18,2,1,2,14,3,13,35,122,70,52,268,28,4,48,48,31,17,26,6,37,11,29,3,35,5,7,2,4,43,157,19,35,5,35,5,39,9,51,157,310,10,21,11,7,153,5,3,0,2,43,2,1,4,0,3,22,11,22,10,30,66,18,2,1,11,21,11,25,71,55,7,1,65,0,16,3,2,2,2,26,45,28,4,28,36,7,2,27,28,53,11,21,11,18,14,17,111,72,56,50,14,50,785,52,76,44,33,24,27,35,42,34,4,0,13,47,15,3,22,0,2,0,36,17,2,24,85,6,2,0,2,3,2,14,2,9,8,46,39,7,3,1,3,21,2,6,2,1,2,4,4,0,19,0,13,4,159,52,19,3,54,47,21,1,2,0,185,46,42,3,37,47,21,0,60,42,86,25,391,63,32,0,449,56,264,8,2,36,18,0,50,29,881,921,103,110,18,195,2749,1070,4050,582,8634,568,8,30,114,29,19,47,17,3,32,20,6,18,881,68,12,0,67,12,65,0,32,6124,20,754,9486,1,3071,106,6,12,4,8,8,9,5991,84,2,70,2,1,3,0,3,1,3,3,2,11,2,0,2,6,2,64,2,3,3,7,2,6,2,27,2,3,2,4,2,0,4,6,2,339,3,24,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,7,4149,196,60,67,1213,3,2,26,2,1,2,0,3,0,2,9,2,3,2,0,2,0,7,0,5,0,2,0,2,0,2,2,2,1,2,0,3,0,2,0,2,0,2,0,2,0,2,1,2,0,3,3,2,6,2,3,2,3,2,0,2,9,2,16,6,2,2,4,2,16,4421,42710,42,4148,12,221,3,5761,10591,541];var astralIdentifierCodes=[509,0,227,0,150,4,294,9,1368,2,2,1,6,3,41,2,5,0,166,1,1306,2,54,14,32,9,16,3,46,10,54,9,7,2,37,13,2,9,52,0,13,2,49,13,10,2,4,9,83,11,7,0,161,11,6,9,7,3,57,0,2,6,3,1,3,2,10,0,11,1,3,6,4,4,193,17,10,9,87,19,13,9,214,6,3,8,28,1,83,16,16,9,82,12,9,9,84,14,5,9,423,9,838,7,2,7,17,9,57,21,2,13,19882,9,135,4,60,6,26,9,1016,45,17,3,19723,1,5319,4,4,5,9,7,3,6,31,3,149,2,1418,49,513,54,5,49,9,0,15,0,23,4,2,14,1361,6,2,16,3,6,2,1,2,4,2214,6,110,6,6,9,792487,239];function isInAstralSet(code,set){var pos=65536;for(var i=0;i<set.length;i+=2){pos+=set[i];if(pos>code){return false;}pos+=set[i+1];if(pos>=code){return true;}}}function isIdentifierStart(code,astral){if(code<65){return code===36;}if(code<91){return true;}if(code<97){return code===95;}if(code<123){return true;}if(code<=65535){return code>=170&&nonASCIIidentifierStart.test(String.fromCharCode(code));}if(astral===false){return false;}return isInAstralSet(code,astralIdentifierStartCodes);}function isIdentifierChar(code,astral){if(code<48){return code===36;}if(code<58){return true;}if(code<65){return false;}if(code<91){return true;}if(code<97){return code===95;}if(code<123){return true;}if(code<=65535){return code>=170&&nonASCIIidentifier.test(String.fromCharCode(code));}if(astral===false){return false;}return isInAstralSet(code,astralIdentifierStartCodes)||isInAstralSet(code,astralIdentifierCodes);}var TokenType=function TokenType(label,conf){if(conf===void 0)conf={};this.label=label;this.keyword=conf.keyword;this.beforeExpr=!!conf.beforeExpr;this.startsExpr=!!conf.startsExpr;this.isLoop=!!conf.isLoop;this.isAssign=!!conf.isAssign;this.prefix=!!conf.prefix;this.postfix=!!conf.postfix;this.binop=conf.binop||null;this.updateContext=null;};function binop(name,prec){return new TokenType(name,{beforeExpr:true,binop:prec});}var beforeExpr={beforeExpr:true};var startsExpr={startsExpr:true};var keywords$1={};function kw(name,options){if(options===void 0)options={};options.keyword=name;return keywords$1[name]=new TokenType(name,options);}var types={num:new TokenType('num',startsExpr),regexp:new TokenType('regexp',startsExpr),string:new TokenType('string',startsExpr),name:new TokenType('name',startsExpr),eof:new TokenType('eof'),bracketL:new TokenType('[',{beforeExpr:true,startsExpr:true}),bracketR:new TokenType(']'),braceL:new TokenType('{',{beforeExpr:true,startsExpr:true}),braceR:new TokenType('}'),parenL:new TokenType('(',{beforeExpr:true,startsExpr:true}),parenR:new TokenType(')'),comma:new TokenType(',',beforeExpr),semi:new TokenType(';',beforeExpr),colon:new TokenType(':',beforeExpr),dot:new TokenType('.'),question:new TokenType('?',beforeExpr),arrow:new TokenType('=>',beforeExpr),template:new TokenType('template'),invalidTemplate:new TokenType('invalidTemplate'),ellipsis:new TokenType('...',beforeExpr),backQuote:new TokenType('`',startsExpr),dollarBraceL:new TokenType('${',{beforeExpr:true,startsExpr:true}),eq:new TokenType('=',{beforeExpr:true,isAssign:true}),assign:new TokenType('_=',{beforeExpr:true,isAssign:true}),incDec:new TokenType('++/--',{prefix:true,postfix:true,startsExpr:true}),prefix:new TokenType('!/~',{beforeExpr:true,prefix:true,startsExpr:true}),logicalOR:binop('||',1),logicalAND:binop('&&',2),bitwiseOR:binop('|',3),bitwiseXOR:binop('^',4),bitwiseAND:binop('&',5),equality:binop('==/!=/===/!==',6),relational:binop('</>/<=/>=',7),bitShift:binop('<</>>/>>>',8),plusMin:new TokenType('+/-',{beforeExpr:true,binop:9,prefix:true,startsExpr:true}),modulo:binop('%',10),star:binop('*',10),slash:binop('/',10),starstar:new TokenType('**',{beforeExpr:true}),_break:kw('break'),_case:kw('case',beforeExpr),_catch:kw('catch'),_continue:kw('continue'),_debugger:kw('debugger'),_default:kw('default',beforeExpr),_do:kw('do',{isLoop:true,beforeExpr:true}),_else:kw('else',beforeExpr),_finally:kw('finally'),_for:kw('for',{isLoop:true}),_function:kw('function',startsExpr),_if:kw('if'),_return:kw('return',beforeExpr),_switch:kw('switch'),_throw:kw('throw',beforeExpr),_try:kw('try'),_var:kw('var'),_const:kw('const'),_while:kw('while',{isLoop:true}),_with:kw('with'),_new:kw('new',{beforeExpr:true,startsExpr:true}),_this:kw('this',startsExpr),_super:kw('super',startsExpr),_class:kw('class',startsExpr),_extends:kw('extends',beforeExpr),_export:kw('export'),_import:kw('import'),_null:kw('null',startsExpr),_true:kw('true',startsExpr),_false:kw('false',startsExpr),_in:kw('in',{beforeExpr:true,binop:7}),_instanceof:kw('instanceof',{beforeExpr:true,binop:7}),_typeof:kw('typeof',{beforeExpr:true,prefix:true,startsExpr:true}),_void:kw('void',{beforeExpr:true,prefix:true,startsExpr:true}),_delete:kw('delete',{beforeExpr:true,prefix:true,startsExpr:true})};var lineBreak=/\r\n?|\n|\u2028|\u2029/;var lineBreakG=new RegExp(lineBreak.source,'g');function isNewLine(code){return code===10||code===13||code===8232||code===8233;}var nonASCIIwhitespace=/[\u1680\u180e\u2000-\u200a\u202f\u205f\u3000\ufeff]/;var skipWhiteSpace=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g;var ref=Object.prototype;var hasOwnProperty=ref.hasOwnProperty;var toString=ref.toString;function has(obj,propName){return hasOwnProperty.call(obj,propName);}var isArray=Array.isArray||function(obj){return toString.call(obj)==='[object Array]';};var Position=function Position(line,col){this.line=line;this.column=col;};Position.prototype.offset=function offset(n){return new Position(this.line,this.column+n);};var SourceLocation=function SourceLocation(p,start,end){this.start=start;this.end=end;if(p.sourceFile!==null){this.source=p.sourceFile;}};function getLineInfo(input,offset){for(var line=1,cur=0;;){lineBreakG.lastIndex=cur;var match=lineBreakG.exec(input);if(match&&match.index<offset){++line;cur=match.index+match[0].length;}else{return new Position(line,offset-cur);}}}var defaultOptions={ecmaVersion:7,sourceType:'script',onInsertedSemicolon:null,onTrailingComma:null,allowReserved:null,allowReturnOutsideFunction:false,allowImportExportEverywhere:false,allowHashBang:false,locations:false,onToken:null,onComment:null,ranges:false,program:null,sourceFile:null,directSourceFile:null,preserveParens:false,plugins:{}};function getOptions(opts){var options={};for(var opt in defaultOptions){options[opt]=opts&&has(opts,opt)?opts[opt]:defaultOptions[opt];}if(options.ecmaVersion>=2015){options.ecmaVersion-=2009;}if(options.allowReserved==null){options.allowReserved=options.ecmaVersion<5;}if(isArray(options.onToken)){var tokens=options.onToken;options.onToken=function(token){return tokens.push(token);};}if(isArray(options.onComment)){options.onComment=pushComment(options,options.onComment);}return options;}function pushComment(options,array){return function(block,text,start,end,startLoc,endLoc){var comment={type:block?'Block':'Line',value:text,start:start,end:end};if(options.locations){comment.loc=new SourceLocation(this,startLoc,endLoc);}if(options.ranges){comment.range=[start,end];}array.push(comment);};}var plugins={};function keywordRegexp(words){return new RegExp('^(?:'+words.replace(/ /g,'|')+')$');}var Parser=function Parser(options,input,startPos){this.options=options=getOptions(options);this.sourceFile=options.sourceFile;this.keywords=keywordRegexp(keywords[options.ecmaVersion>=6?6:5]);var reserved='';if(!options.allowReserved){for(var v=options.ecmaVersion;;v--){if(reserved=reservedWords[v]){break;}}if(options.sourceType=='module'){reserved+=' await';}}this.reservedWords=keywordRegexp(reserved);var reservedStrict=(reserved?reserved+' ':'')+reservedWords.strict;this.reservedWordsStrict=keywordRegexp(reservedStrict);this.reservedWordsStrictBind=keywordRegexp(reservedStrict+' '+reservedWords.strictBind);this.input=String(input);this.containsEsc=false;this.loadPlugins(options.plugins);if(startPos){this.pos=startPos;this.lineStart=this.input.lastIndexOf('\n',startPos-1)+1;this.curLine=this.input.slice(0,this.lineStart).split(lineBreak).length;}else{this.pos=this.lineStart=0;this.curLine=1;}this.type=types.eof;this.value=null;this.start=this.end=this.pos;this.startLoc=this.endLoc=this.curPosition();this.lastTokEndLoc=this.lastTokStartLoc=null;this.lastTokStart=this.lastTokEnd=this.pos;this.context=this.initialContext();this.exprAllowed=true;this.inModule=options.sourceType==='module';this.strict=this.inModule||this.strictDirective(this.pos);this.potentialArrowAt=-1;this.inFunction=this.inGenerator=this.inAsync=false;this.yieldPos=this.awaitPos=0;this.labels=[];if(this.pos===0&&options.allowHashBang&&this.input.slice(0,2)==='#!'){this.skipLineComment(2);}this.scopeStack=[];this.enterFunctionScope();};Parser.prototype.isKeyword=function isKeyword(word){return this.keywords.test(word);};Parser.prototype.isReservedWord=function isReservedWord(word){return this.reservedWords.test(word);};Parser.prototype.extend=function extend(name,f){this[name]=f(this[name]);};Parser.prototype.loadPlugins=function loadPlugins(pluginConfigs){var this$1=this;for(var name in pluginConfigs){var plugin=plugins[name];if(!plugin){throw new Error('Plugin \''+name+'\' not found');}plugin(this$1,pluginConfigs[name]);}};Parser.prototype.parse=function parse(){var node=this.options.program||this.startNode();this.nextToken();return this.parseTopLevel(node);};var pp=Parser.prototype;var literal=/^(?:'((?:\\.|[^'])*?)'|"((?:\\.|[^"])*?)"|;)/;pp.strictDirective=function(start){var this$1=this;for(;;){skipWhiteSpace.lastIndex=start;start+=skipWhiteSpace.exec(this$1.input)[0].length;var match=literal.exec(this$1.input.slice(start));if(!match){return false;}if((match[1]||match[2])=='use strict'){return true;}start+=match[0].length;}};pp.eat=function(type){if(this.type===type){this.next();return true;}else{return false;}};pp.isContextual=function(name){return this.type===types.name&&this.value===name&&!this.containsEsc;};pp.eatContextual=function(name){if(!this.isContextual(name)){return false;}this.next();return true;};pp.expectContextual=function(name){if(!this.eatContextual(name)){this.unexpected();}};pp.canInsertSemicolon=function(){return this.type===types.eof||this.type===types.braceR||lineBreak.test(this.input.slice(this.lastTokEnd,this.start));};pp.insertSemicolon=function(){if(this.canInsertSemicolon()){if(this.options.onInsertedSemicolon){this.options.onInsertedSemicolon(this.lastTokEnd,this.lastTokEndLoc);}return true;}};pp.semicolon=function(){if(!this.eat(types.semi)&&!this.insertSemicolon()){this.unexpected();}};pp.afterTrailingComma=function(tokType,notNext){if(this.type==tokType){if(this.options.onTrailingComma){this.options.onTrailingComma(this.lastTokStart,this.lastTokStartLoc);}if(!notNext){this.next();}return true;}};pp.expect=function(type){this.eat(type)||this.unexpected();};pp.unexpected=function(pos){this.raise(pos!=null?pos:this.start,'Unexpected token');};function DestructuringErrors(){this.shorthandAssign=this.trailingComma=this.parenthesizedAssign=this.parenthesizedBind=this.doubleProto=-1;}pp.checkPatternErrors=function(refDestructuringErrors,isAssign){if(!refDestructuringErrors){return;}if(refDestructuringErrors.trailingComma>-1){this.raiseRecoverable(refDestructuringErrors.trailingComma,'Comma is not permitted after the rest element');}var parens=isAssign?refDestructuringErrors.parenthesizedAssign:refDestructuringErrors.parenthesizedBind;if(parens>-1){this.raiseRecoverable(parens,'Parenthesized pattern');}};pp.checkExpressionErrors=function(refDestructuringErrors,andThrow){if(!refDestructuringErrors){return false;}var shorthandAssign=refDestructuringErrors.shorthandAssign;var doubleProto=refDestructuringErrors.doubleProto;if(!andThrow){return shorthandAssign>=0||doubleProto>=0;}if(shorthandAssign>=0){this.raise(shorthandAssign,'Shorthand property assignments are valid only in destructuring patterns');}if(doubleProto>=0){this.raiseRecoverable(doubleProto,'Redefinition of __proto__ property');}};pp.checkYieldAwaitInDefaultParams=function(){if(this.yieldPos&&(!this.awaitPos||this.yieldPos<this.awaitPos)){this.raise(this.yieldPos,'Yield expression cannot be a default value');}if(this.awaitPos){this.raise(this.awaitPos,'Await expression cannot be a default value');}};pp.isSimpleAssignTarget=function(expr){if(expr.type==='ParenthesizedExpression'){return this.isSimpleAssignTarget(expr.expression);}return expr.type==='Identifier'||expr.type==='MemberExpression';};var pp$1=Parser.prototype;pp$1.parseTopLevel=function(node){var this$1=this;var exports={};if(!node.body){node.body=[];}while(this.type!==types.eof){var stmt=this$1.parseStatement(true,true,exports);node.body.push(stmt);}this.adaptDirectivePrologue(node.body);this.next();if(this.options.ecmaVersion>=6){node.sourceType=this.options.sourceType;}return this.finishNode(node,'Program');};var loopLabel={kind:'loop'};var switchLabel={kind:'switch'};pp$1.isLet=function(){if(this.options.ecmaVersion<6||!this.isContextual('let')){return false;}skipWhiteSpace.lastIndex=this.pos;var skip=skipWhiteSpace.exec(this.input);var next=this.pos+skip[0].length,nextCh=this.input.charCodeAt(next);if(nextCh===91||nextCh==123){return true;}if(isIdentifierStart(nextCh,true)){var pos=next+1;while(isIdentifierChar(this.input.charCodeAt(pos),true)){++pos;}var ident=this.input.slice(next,pos);if(!keywordRelationalOperator.test(ident)){return true;}}return false;};pp$1.isAsyncFunction=function(){if(this.options.ecmaVersion<8||!this.isContextual('async')){return false;}skipWhiteSpace.lastIndex=this.pos;var skip=skipWhiteSpace.exec(this.input);var next=this.pos+skip[0].length;return!lineBreak.test(this.input.slice(this.pos,next))&&this.input.slice(next,next+8)==='function'&&(next+8==this.input.length||!isIdentifierChar(this.input.charAt(next+8)));};pp$1.parseStatement=function(declaration,topLevel,exports){var starttype=this.type,node=this.startNode(),kind;if(this.isLet()){starttype=types._var;kind='let';}switch(starttype){case types._break:case types._continue:return this.parseBreakContinueStatement(node,starttype.keyword);case types._debugger:return this.parseDebuggerStatement(node);case types._do:return this.parseDoStatement(node);case types._for:return this.parseForStatement(node);case types._function:if(!declaration&&this.options.ecmaVersion>=6){this.unexpected();}return this.parseFunctionStatement(node,false);case types._class:if(!declaration){this.unexpected();}return this.parseClass(node,true);case types._if:return this.parseIfStatement(node);case types._return:return this.parseReturnStatement(node);case types._switch:return this.parseSwitchStatement(node);case types._throw:return this.parseThrowStatement(node);case types._try:return this.parseTryStatement(node);case types._const:case types._var:kind=kind||this.value;if(!declaration&&kind!='var'){this.unexpected();}return this.parseVarStatement(node,kind);case types._while:return this.parseWhileStatement(node);case types._with:return this.parseWithStatement(node);case types.braceL:return this.parseBlock();case types.semi:return this.parseEmptyStatement(node);case types._export:case types._import:if(!this.options.allowImportExportEverywhere){if(!topLevel){this.raise(this.start,'\'import\' and \'export\' may only appear at the top level');}if(!this.inModule){this.raise(this.start,'\'import\' and \'export\' may appear only with \'sourceType: module\'');}}return starttype===types._import?this.parseImport(node):this.parseExport(node,exports);default:if(this.isAsyncFunction()){if(!declaration){this.unexpected();}this.next();return this.parseFunctionStatement(node,true);}var maybeName=this.value,expr=this.parseExpression();if(starttype===types.name&&expr.type==='Identifier'&&this.eat(types.colon)){return this.parseLabeledStatement(node,maybeName,expr);}else{return this.parseExpressionStatement(node,expr);}}};pp$1.parseBreakContinueStatement=function(node,keyword){var this$1=this;var isBreak=keyword=='break';this.next();if(this.eat(types.semi)||this.insertSemicolon()){node.label=null;}else if(this.type!==types.name){this.unexpected();}else{node.label=this.parseIdent();this.semicolon();}var i=0;for(;i<this.labels.length;++i){var lab=this$1.labels[i];if(node.label==null||lab.name===node.label.name){if(lab.kind!=null&&(isBreak||lab.kind==='loop')){break;}if(node.label&&isBreak){break;}}}if(i===this.labels.length){this.raise(node.start,'Unsyntactic '+keyword);}return this.finishNode(node,isBreak?'BreakStatement':'ContinueStatement');};pp$1.parseDebuggerStatement=function(node){this.next();this.semicolon();return this.finishNode(node,'DebuggerStatement');};pp$1.parseDoStatement=function(node){this.next();this.labels.push(loopLabel);node.body=this.parseStatement(false);this.labels.pop();this.expect(types._while);node.test=this.parseParenExpression();if(this.options.ecmaVersion>=6){this.eat(types.semi);}else{this.semicolon();}return this.finishNode(node,'DoWhileStatement');};pp$1.parseForStatement=function(node){this.next();this.labels.push(loopLabel);this.enterLexicalScope();this.expect(types.parenL);if(this.type===types.semi){return this.parseFor(node,null);}var isLet=this.isLet();if(this.type===types._var||this.type===types._const||isLet){var init$1=this.startNode(),kind=isLet?'let':this.value;this.next();this.parseVar(init$1,true,kind);this.finishNode(init$1,'VariableDeclaration');if((this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual('of'))&&init$1.declarations.length===1&&!(kind!=='var'&&init$1.declarations[0].init)){return this.parseForIn(node,init$1);}return this.parseFor(node,init$1);}var refDestructuringErrors=new DestructuringErrors();var init=this.parseExpression(true,refDestructuringErrors);if(this.type===types._in||this.options.ecmaVersion>=6&&this.isContextual('of')){this.toAssignable(init,false,refDestructuringErrors);this.checkLVal(init);return this.parseForIn(node,init);}else{this.checkExpressionErrors(refDestructuringErrors,true);}return this.parseFor(node,init);};pp$1.parseFunctionStatement=function(node,isAsync){this.next();return this.parseFunction(node,true,false,isAsync);};pp$1.parseIfStatement=function(node){this.next();node.test=this.parseParenExpression();node.consequent=this.parseStatement(!this.strict&&this.type==types._function);node.alternate=this.eat(types._else)?this.parseStatement(!this.strict&&this.type==types._function):null;return this.finishNode(node,'IfStatement');};pp$1.parseReturnStatement=function(node){if(!this.inFunction&&!this.options.allowReturnOutsideFunction){this.raise(this.start,'\'return\' outside of function');}this.next();if(this.eat(types.semi)||this.insertSemicolon()){node.argument=null;}else{node.argument=this.parseExpression();this.semicolon();}return this.finishNode(node,'ReturnStatement');};pp$1.parseSwitchStatement=function(node){var this$1=this;this.next();node.discriminant=this.parseParenExpression();node.cases=[];this.expect(types.braceL);this.labels.push(switchLabel);this.enterLexicalScope();var cur;for(var sawDefault=false;this.type!=types.braceR;){if(this$1.type===types._case||this$1.type===types._default){var isCase=this$1.type===types._case;if(cur){this$1.finishNode(cur,'SwitchCase');}node.cases.push(cur=this$1.startNode());cur.consequent=[];this$1.next();if(isCase){cur.test=this$1.parseExpression();}else{if(sawDefault){this$1.raiseRecoverable(this$1.lastTokStart,'Multiple default clauses');}sawDefault=true;cur.test=null;}this$1.expect(types.colon);}else{if(!cur){this$1.unexpected();}cur.consequent.push(this$1.parseStatement(true));}}this.exitLexicalScope();if(cur){this.finishNode(cur,'SwitchCase');}this.next();this.labels.pop();return this.finishNode(node,'SwitchStatement');};pp$1.parseThrowStatement=function(node){this.next();if(lineBreak.test(this.input.slice(this.lastTokEnd,this.start))){this.raise(this.lastTokEnd,'Illegal newline after throw');}node.argument=this.parseExpression();this.semicolon();return this.finishNode(node,'ThrowStatement');};var empty=[];pp$1.parseTryStatement=function(node){this.next();node.block=this.parseBlock();node.handler=null;if(this.type===types._catch){var clause=this.startNode();this.next();this.expect(types.parenL);clause.param=this.parseBindingAtom();this.enterLexicalScope();this.checkLVal(clause.param,'let');this.expect(types.parenR);clause.body=this.parseBlock(false);this.exitLexicalScope();node.handler=this.finishNode(clause,'CatchClause');}node.finalizer=this.eat(types._finally)?this.parseBlock():null;if(!node.handler&&!node.finalizer){this.raise(node.start,'Missing catch or finally clause');}return this.finishNode(node,'TryStatement');};pp$1.parseVarStatement=function(node,kind){this.next();this.parseVar(node,false,kind);this.semicolon();return this.finishNode(node,'VariableDeclaration');};pp$1.parseWhileStatement=function(node){this.next();node.test=this.parseParenExpression();this.labels.push(loopLabel);node.body=this.parseStatement(false);this.labels.pop();return this.finishNode(node,'WhileStatement');};pp$1.parseWithStatement=function(node){if(this.strict){this.raise(this.start,'\'with\' in strict mode');}this.next();node.object=this.parseParenExpression();node.body=this.parseStatement(false);return this.finishNode(node,'WithStatement');};pp$1.parseEmptyStatement=function(node){this.next();return this.finishNode(node,'EmptyStatement');};pp$1.parseLabeledStatement=function(node,maybeName,expr){var this$1=this;for(var i$1=0,list=this$1.labels;i$1<list.length;i$1+=1){var label=list[i$1];if(label.name===maybeName){this$1.raise(expr.start,'Label \''+maybeName+'\' is already declared');}}var kind=this.type.isLoop?'loop':this.type===types._switch?'switch':null;for(var i=this.labels.length-1;i>=0;i--){var label$1=this$1.labels[i];if(label$1.statementStart==node.start){label$1.statementStart=this$1.start;label$1.kind=kind;}else{break;}}this.labels.push({name:maybeName,kind:kind,statementStart:this.start});node.body=this.parseStatement(true);if(node.body.type=='ClassDeclaration'||node.body.type=='VariableDeclaration'&&node.body.kind!='var'||node.body.type=='FunctionDeclaration'&&(this.strict||node.body.generator)){this.raiseRecoverable(node.body.start,'Invalid labeled declaration');}this.labels.pop();node.label=expr;return this.finishNode(node,'LabeledStatement');};pp$1.parseExpressionStatement=function(node,expr){node.expression=expr;this.semicolon();return this.finishNode(node,'ExpressionStatement');};pp$1.parseBlock=function(createNewLexicalScope){var this$1=this;if(createNewLexicalScope===void 0)createNewLexicalScope=true;var node=this.startNode();node.body=[];this.expect(types.braceL);if(createNewLexicalScope){this.enterLexicalScope();}while(!this.eat(types.braceR)){var stmt=this$1.parseStatement(true);node.body.push(stmt);}if(createNewLexicalScope){this.exitLexicalScope();}return this.finishNode(node,'BlockStatement');};pp$1.parseFor=function(node,init){node.init=init;this.expect(types.semi);node.test=this.type===types.semi?null:this.parseExpression();this.expect(types.semi);node.update=this.type===types.parenR?null:this.parseExpression();this.expect(types.parenR);this.exitLexicalScope();node.body=this.parseStatement(false);this.labels.pop();return this.finishNode(node,'ForStatement');};pp$1.parseForIn=function(node,init){var type=this.type===types._in?'ForInStatement':'ForOfStatement';this.next();if(type=='ForInStatement'){if(init.type==='AssignmentPattern'||init.type==='VariableDeclaration'&&init.declarations[0].init!=null&&(this.strict||init.declarations[0].id.type!=='Identifier')){this.raise(init.start,'Invalid assignment in for-in loop head');}}node.left=init;node.right=type=='ForInStatement'?this.parseExpression():this.parseMaybeAssign();this.expect(types.parenR);this.exitLexicalScope();node.body=this.parseStatement(false);this.labels.pop();return this.finishNode(node,type);};pp$1.parseVar=function(node,isFor,kind){var this$1=this;node.declarations=[];node.kind=kind;for(;;){var decl=this$1.startNode();this$1.parseVarId(decl,kind);if(this$1.eat(types.eq)){decl.init=this$1.parseMaybeAssign(isFor);}else if(kind==='const'&&!(this$1.type===types._in||this$1.options.ecmaVersion>=6&&this$1.isContextual('of'))){this$1.unexpected();}else if(decl.id.type!='Identifier'&&!(isFor&&(this$1.type===types._in||this$1.isContextual('of')))){this$1.raise(this$1.lastTokEnd,'Complex binding patterns require an initialization value');}else{decl.init=null;}node.declarations.push(this$1.finishNode(decl,'VariableDeclarator'));if(!this$1.eat(types.comma)){break;}}return node;};pp$1.parseVarId=function(decl,kind){decl.id=this.parseBindingAtom(kind);this.checkLVal(decl.id,kind,false);};pp$1.parseFunction=function(node,isStatement,allowExpressionBody,isAsync){this.initFunction(node);if(this.options.ecmaVersion>=6&&!isAsync){node.generator=this.eat(types.star);}if(this.options.ecmaVersion>=8){node.async=!!isAsync;}if(isStatement){node.id=isStatement==='nullableID'&&this.type!=types.name?null:this.parseIdent();if(node.id){this.checkLVal(node.id,'var');}}var oldInGen=this.inGenerator,oldInAsync=this.inAsync,oldYieldPos=this.yieldPos,oldAwaitPos=this.awaitPos,oldInFunc=this.inFunction;this.inGenerator=node.generator;this.inAsync=node.async;this.yieldPos=0;this.awaitPos=0;this.inFunction=true;this.enterFunctionScope();if(!isStatement){node.id=this.type==types.name?this.parseIdent():null;}this.parseFunctionParams(node);this.parseFunctionBody(node,allowExpressionBody);this.inGenerator=oldInGen;this.inAsync=oldInAsync;this.yieldPos=oldYieldPos;this.awaitPos=oldAwaitPos;this.inFunction=oldInFunc;return this.finishNode(node,isStatement?'FunctionDeclaration':'FunctionExpression');};pp$1.parseFunctionParams=function(node){this.expect(types.parenL);node.params=this.parseBindingList(types.parenR,false,this.options.ecmaVersion>=8);this.checkYieldAwaitInDefaultParams();};pp$1.parseClass=function(node,isStatement){var this$1=this;this.next();this.parseClassId(node,isStatement);this.parseClassSuper(node);var classBody=this.startNode();var hadConstructor=false;classBody.body=[];this.expect(types.braceL);while(!this.eat(types.braceR)){var member=this$1.parseClassMember(classBody);if(member&&member.type==='MethodDefinition'&&member.kind==='constructor'){if(hadConstructor){this$1.raise(member.start,'Duplicate constructor in the same class');}hadConstructor=true;}}node.body=this.finishNode(classBody,'ClassBody');return this.finishNode(node,isStatement?'ClassDeclaration':'ClassExpression');};pp$1.parseClassMember=function(classBody){var this$1=this;if(this.eat(types.semi)){return null;}var method=this.startNode();var tryContextual=function(k,noLineBreak){if(noLineBreak===void 0)noLineBreak=false;var start=this$1.start,startLoc=this$1.startLoc;if(!this$1.eatContextual(k)){return false;}if(this$1.type!==types.parenL&&(!noLineBreak||!this$1.canInsertSemicolon())){return true;}if(method.key){this$1.unexpected();}method.computed=false;method.key=this$1.startNodeAt(start,startLoc);method.key.name=k;this$1.finishNode(method.key,'Identifier');return false;};method.kind='method';method.static=tryContextual('static');var isGenerator=this.eat(types.star);var isAsync=false;if(!isGenerator){if(this.options.ecmaVersion>=8&&tryContextual('async',true)){isAsync=true;}else if(tryContextual('get')){method.kind='get';}else if(tryContextual('set')){method.kind='set';}}if(!method.key){this.parsePropertyName(method);}var key=method.key;if(!method.computed&&!method.static&&(key.type==='Identifier'&&key.name==='constructor'||key.type==='Literal'&&key.value==='constructor')){if(method.kind!=='method'){this.raise(key.start,'Constructor can\'t have get/set modifier');}if(isGenerator){this.raise(key.start,'Constructor can\'t be a generator');}if(isAsync){this.raise(key.start,'Constructor can\'t be an async method');}method.kind='constructor';}else if(method.static&&key.type==='Identifier'&&key.name==='prototype'){this.raise(key.start,'Classes may not have a static property named prototype');}this.parseClassMethod(classBody,method,isGenerator,isAsync);if(method.kind==='get'&&method.value.params.length!==0){this.raiseRecoverable(method.value.start,'getter should have no params');}if(method.kind==='set'&&method.value.params.length!==1){this.raiseRecoverable(method.value.start,'setter should have exactly one param');}if(method.kind==='set'&&method.value.params[0].type==='RestElement'){this.raiseRecoverable(method.value.params[0].start,'Setter cannot use rest params');}return method;};pp$1.parseClassMethod=function(classBody,method,isGenerator,isAsync){method.value=this.parseMethod(isGenerator,isAsync);classBody.body.push(this.finishNode(method,'MethodDefinition'));};pp$1.parseClassId=function(node,isStatement){node.id=this.type===types.name?this.parseIdent():isStatement===true?this.unexpected():null;};pp$1.parseClassSuper=function(node){node.superClass=this.eat(types._extends)?this.parseExprSubscripts():null;};pp$1.parseExport=function(node,exports){var this$1=this;this.next();if(this.eat(types.star)){this.expectContextual('from');if(this.type!==types.string){this.unexpected();}node.source=this.parseExprAtom();this.semicolon();return this.finishNode(node,'ExportAllDeclaration');}if(this.eat(types._default)){this.checkExport(exports,'default',this.lastTokStart);var isAsync;if(this.type===types._function||(isAsync=this.isAsyncFunction())){var fNode=this.startNode();this.next();if(isAsync){this.next();}node.declaration=this.parseFunction(fNode,'nullableID',false,isAsync);}else if(this.type===types._class){var cNode=this.startNode();node.declaration=this.parseClass(cNode,'nullableID');}else{node.declaration=this.parseMaybeAssign();this.semicolon();}return this.finishNode(node,'ExportDefaultDeclaration');}if(this.shouldParseExportStatement()){node.declaration=this.parseStatement(true);if(node.declaration.type==='VariableDeclaration'){this.checkVariableExport(exports,node.declaration.declarations);}else{this.checkExport(exports,node.declaration.id.name,node.declaration.id.start);}node.specifiers=[];node.source=null;}else{node.declaration=null;node.specifiers=this.parseExportSpecifiers(exports);if(this.eatContextual('from')){if(this.type!==types.string){this.unexpected();}node.source=this.parseExprAtom();}else{for(var i=0,list=node.specifiers;i<list.length;i+=1){var spec=list[i];this$1.checkUnreserved(spec.local);}node.source=null;}this.semicolon();}return this.finishNode(node,'ExportNamedDeclaration');};pp$1.checkExport=function(exports,name,pos){if(!exports){return;}if(has(exports,name)){this.raiseRecoverable(pos,'Duplicate export \''+name+'\'');}exports[name]=true;};pp$1.checkPatternExport=function(exports,pat){var this$1=this;var type=pat.type;if(type=='Identifier'){this.checkExport(exports,pat.name,pat.start);}else if(type=='ObjectPattern'){for(var i=0,list=pat.properties;i<list.length;i+=1){var prop=list[i];this$1.checkPatternExport(exports,prop.value);}}else if(type=='ArrayPattern'){for(var i$1=0,list$1=pat.elements;i$1<list$1.length;i$1+=1){var elt=list$1[i$1];if(elt){this$1.checkPatternExport(exports,elt);}}}else if(type=='AssignmentPattern'){this.checkPatternExport(exports,pat.left);}else if(type=='ParenthesizedExpression'){this.checkPatternExport(exports,pat.expression);}};pp$1.checkVariableExport=function(exports,decls){var this$1=this;if(!exports){return;}for(var i=0,list=decls;i<list.length;i+=1){var decl=list[i];this$1.checkPatternExport(exports,decl.id);}};pp$1.shouldParseExportStatement=function(){return this.type.keyword==='var'||this.type.keyword==='const'||this.type.keyword==='class'||this.type.keyword==='function'||this.isLet()||this.isAsyncFunction();};pp$1.parseExportSpecifiers=function(exports){var this$1=this;var nodes=[],first=true;this.expect(types.braceL);while(!this.eat(types.braceR)){if(!first){this$1.expect(types.comma);if(this$1.afterTrailingComma(types.braceR)){break;}}else{first=false;}var node=this$1.startNode();node.local=this$1.parseIdent(true);node.exported=this$1.eatContextual('as')?this$1.parseIdent(true):node.local;this$1.checkExport(exports,node.exported.name,node.exported.start);nodes.push(this$1.finishNode(node,'ExportSpecifier'));}return nodes;};pp$1.parseImport=function(node){this.next();if(this.type===types.string){node.specifiers=empty;node.source=this.parseExprAtom();}else{node.specifiers=this.parseImportSpecifiers();this.expectContextual('from');node.source=this.type===types.string?this.parseExprAtom():this.unexpected();}this.semicolon();return this.finishNode(node,'ImportDeclaration');};pp$1.parseImportSpecifiers=function(){var this$1=this;var nodes=[],first=true;if(this.type===types.name){var node=this.startNode();node.local=this.parseIdent();this.checkLVal(node.local,'let');nodes.push(this.finishNode(node,'ImportDefaultSpecifier'));if(!this.eat(types.comma)){return nodes;}}if(this.type===types.star){var node$1=this.startNode();this.next();this.expectContextual('as');node$1.local=this.parseIdent();this.checkLVal(node$1.local,'let');nodes.push(this.finishNode(node$1,'ImportNamespaceSpecifier'));return nodes;}this.expect(types.braceL);while(!this.eat(types.braceR)){if(!first){this$1.expect(types.comma);if(this$1.afterTrailingComma(types.braceR)){break;}}else{first=false;}var node$2=this$1.startNode();node$2.imported=this$1.parseIdent(true);if(this$1.eatContextual('as')){node$2.local=this$1.parseIdent();}else{this$1.checkUnreserved(node$2.imported);node$2.local=node$2.imported;}this$1.checkLVal(node$2.local,'let');nodes.push(this$1.finishNode(node$2,'ImportSpecifier'));}return nodes;};pp$1.adaptDirectivePrologue=function(statements){for(var i=0;i<statements.length&&this.isDirectiveCandidate(statements[i]);++i){statements[i].directive=statements[i].expression.raw.slice(1,-1);}};pp$1.isDirectiveCandidate=function(statement){return statement.type==='ExpressionStatement'&&statement.expression.type==='Literal'&&typeof statement.expression.value==='string'&&(this.input[statement.start]==='"'||this.input[statement.start]==='\'');};var pp$2=Parser.prototype;pp$2.toAssignable=function(node,isBinding,refDestructuringErrors){var this$1=this;if(this.options.ecmaVersion>=6&&node){switch(node.type){case'Identifier':if(this.inAsync&&node.name==='await'){this.raise(node.start,'Can not use \'await\' as identifier inside an async function');}break;case'ObjectPattern':case'ArrayPattern':case'RestElement':break;case'ObjectExpression':node.type='ObjectPattern';if(refDestructuringErrors){this.checkPatternErrors(refDestructuringErrors,true);}for(var i=0,list=node.properties;i<list.length;i+=1){var prop=list[i];this$1.toAssignable(prop,isBinding);}break;case'Property':if(node.kind!=='init'){this.raise(node.key.start,'Object pattern can\'t contain getter or setter');}this.toAssignable(node.value,isBinding);break;case'ArrayExpression':node.type='ArrayPattern';if(refDestructuringErrors){this.checkPatternErrors(refDestructuringErrors,true);}this.toAssignableList(node.elements,isBinding);break;case'SpreadElement':node.type='RestElement';this.toAssignable(node.argument,isBinding);if(node.argument.type==='AssignmentPattern'){this.raise(node.argument.start,'Rest elements cannot have a default value');}break;case'AssignmentExpression':if(node.operator!=='='){this.raise(node.left.end,'Only \'=\' operator can be used for specifying default value.');}node.type='AssignmentPattern';delete node.operator;this.toAssignable(node.left,isBinding);case'AssignmentPattern':break;case'ParenthesizedExpression':this.toAssignable(node.expression,isBinding);break;case'MemberExpression':if(!isBinding){break;}default:this.raise(node.start,'Assigning to rvalue');}}else if(refDestructuringErrors){this.checkPatternErrors(refDestructuringErrors,true);}return node;};pp$2.toAssignableList=function(exprList,isBinding){var this$1=this;var end=exprList.length;for(var i=0;i<end;i++){var elt=exprList[i];if(elt){this$1.toAssignable(elt,isBinding);}}if(end){var last=exprList[end-1];if(this.options.ecmaVersion===6&&isBinding&&last&&last.type==='RestElement'&&last.argument.type!=='Identifier'){this.unexpected(last.argument.start);}}return exprList;};pp$2.parseSpread=function(refDestructuringErrors){var node=this.startNode();this.next();node.argument=this.parseMaybeAssign(false,refDestructuringErrors);return this.finishNode(node,'SpreadElement');};pp$2.parseRestBinding=function(){var node=this.startNode();this.next();if(this.options.ecmaVersion===6&&this.type!==types.name){this.unexpected();}node.argument=this.parseBindingAtom();return this.finishNode(node,'RestElement');};pp$2.parseBindingAtom=function(){if(this.options.ecmaVersion>=6){switch(this.type){case types.bracketL:var node=this.startNode();this.next();node.elements=this.parseBindingList(types.bracketR,true,true);return this.finishNode(node,'ArrayPattern');case types.braceL:return this.parseObj(true);}}return this.parseIdent();};pp$2.parseBindingList=function(close,allowEmpty,allowTrailingComma){var this$1=this;var elts=[],first=true;while(!this.eat(close)){if(first){first=false;}else{this$1.expect(types.comma);}if(allowEmpty&&this$1.type===types.comma){elts.push(null);}else if(allowTrailingComma&&this$1.afterTrailingComma(close)){break;}else if(this$1.type===types.ellipsis){var rest=this$1.parseRestBinding();this$1.parseBindingListItem(rest);elts.push(rest);if(this$1.type===types.comma){this$1.raise(this$1.start,'Comma is not permitted after the rest element');}this$1.expect(close);break;}else{var elem=this$1.parseMaybeDefault(this$1.start,this$1.startLoc);this$1.parseBindingListItem(elem);elts.push(elem);}}return elts;};pp$2.parseBindingListItem=function(param){return param;};pp$2.parseMaybeDefault=function(startPos,startLoc,left){left=left||this.parseBindingAtom();if(this.options.ecmaVersion<6||!this.eat(types.eq)){return left;}var node=this.startNodeAt(startPos,startLoc);node.left=left;node.right=this.parseMaybeAssign();return this.finishNode(node,'AssignmentPattern');};pp$2.checkLVal=function(expr,bindingType,checkClashes){var this$1=this;switch(expr.type){case'Identifier':if(this.strict&&this.reservedWordsStrictBind.test(expr.name)){this.raiseRecoverable(expr.start,(bindingType?'Binding ':'Assigning to ')+expr.name+' in strict mode');}if(checkClashes){if(has(checkClashes,expr.name)){this.raiseRecoverable(expr.start,'Argument name clash');}checkClashes[expr.name]=true;}if(bindingType&&bindingType!=='none'){if(bindingType==='var'&&!this.canDeclareVarName(expr.name)||bindingType!=='var'&&!this.canDeclareLexicalName(expr.name)){this.raiseRecoverable(expr.start,'Identifier \''+expr.name+'\' has already been declared');}if(bindingType==='var'){this.declareVarName(expr.name);}else{this.declareLexicalName(expr.name);}}break;case'MemberExpression':if(bindingType){this.raiseRecoverable(expr.start,'Binding member expression');}break;case'ObjectPattern':for(var i=0,list=expr.properties;i<list.length;i+=1){var prop=list[i];this$1.checkLVal(prop,bindingType,checkClashes);}break;case'Property':this.checkLVal(expr.value,bindingType,checkClashes);break;case'ArrayPattern':for(var i$1=0,list$1=expr.elements;i$1<list$1.length;i$1+=1){var elem=list$1[i$1];if(elem){this$1.checkLVal(elem,bindingType,checkClashes);}}break;case'AssignmentPattern':this.checkLVal(expr.left,bindingType,checkClashes);break;case'RestElement':this.checkLVal(expr.argument,bindingType,checkClashes);break;case'ParenthesizedExpression':this.checkLVal(expr.expression,bindingType,checkClashes);break;default:this.raise(expr.start,(bindingType?'Binding':'Assigning to')+' rvalue');}};var pp$3=Parser.prototype;pp$3.checkPropClash=function(prop,propHash,refDestructuringErrors){if(this.options.ecmaVersion>=6&&(prop.computed||prop.method||prop.shorthand)){return;}var key=prop.key;var name;switch(key.type){case'Identifier':name=key.name;break;case'Literal':name=String(key.value);break;default:return;}var kind=prop.kind;if(this.options.ecmaVersion>=6){if(name==='__proto__'&&kind==='init'){if(propHash.proto){if(refDestructuringErrors&&refDestructuringErrors.doubleProto<0){refDestructuringErrors.doubleProto=key.start;}else{this.raiseRecoverable(key.start,'Redefinition of __proto__ property');}}propHash.proto=true;}return;}name='$'+name;var other=propHash[name];if(other){var redefinition;if(kind==='init'){redefinition=this.strict&&other.init||other.get||other.set;}else{redefinition=other.init||other[kind];}if(redefinition){this.raiseRecoverable(key.start,'Redefinition of property');}}else{other=propHash[name]={init:false,get:false,set:false};}other[kind]=true;};pp$3.parseExpression=function(noIn,refDestructuringErrors){var this$1=this;var startPos=this.start,startLoc=this.startLoc;var expr=this.parseMaybeAssign(noIn,refDestructuringErrors);if(this.type===types.comma){var node=this.startNodeAt(startPos,startLoc);node.expressions=[expr];while(this.eat(types.comma)){node.expressions.push(this$1.parseMaybeAssign(noIn,refDestructuringErrors));}return this.finishNode(node,'SequenceExpression');}return expr;};pp$3.parseMaybeAssign=function(noIn,refDestructuringErrors,afterLeftParse){if(this.inGenerator&&this.isContextual('yield')){return this.parseYield();}var ownDestructuringErrors=false,oldParenAssign=-1,oldTrailingComma=-1;if(refDestructuringErrors){oldParenAssign=refDestructuringErrors.parenthesizedAssign;oldTrailingComma=refDestructuringErrors.trailingComma;refDestructuringErrors.parenthesizedAssign=refDestructuringErrors.trailingComma=-1;}else{refDestructuringErrors=new DestructuringErrors();ownDestructuringErrors=true;}var startPos=this.start,startLoc=this.startLoc;if(this.type==types.parenL||this.type==types.name){this.potentialArrowAt=this.start;}var left=this.parseMaybeConditional(noIn,refDestructuringErrors);if(afterLeftParse){left=afterLeftParse.call(this,left,startPos,startLoc);}if(this.type.isAssign){var node=this.startNodeAt(startPos,startLoc);node.operator=this.value;node.left=this.type===types.eq?this.toAssignable(left,false,refDestructuringErrors):left;if(!ownDestructuringErrors){DestructuringErrors.call(refDestructuringErrors);}refDestructuringErrors.shorthandAssign=-1;this.checkLVal(left);this.next();node.right=this.parseMaybeAssign(noIn);return this.finishNode(node,'AssignmentExpression');}else{if(ownDestructuringErrors){this.checkExpressionErrors(refDestructuringErrors,true);}}if(oldParenAssign>-1){refDestructuringErrors.parenthesizedAssign=oldParenAssign;}if(oldTrailingComma>-1){refDestructuringErrors.trailingComma=oldTrailingComma;}return left;};pp$3.parseMaybeConditional=function(noIn,refDestructuringErrors){var startPos=this.start,startLoc=this.startLoc;var expr=this.parseExprOps(noIn,refDestructuringErrors);if(this.checkExpressionErrors(refDestructuringErrors)){return expr;}if(this.eat(types.question)){var node=this.startNodeAt(startPos,startLoc);node.test=expr;node.consequent=this.parseMaybeAssign();this.expect(types.colon);node.alternate=this.parseMaybeAssign(noIn);return this.finishNode(node,'ConditionalExpression');}return expr;};pp$3.parseExprOps=function(noIn,refDestructuringErrors){var startPos=this.start,startLoc=this.startLoc;var expr=this.parseMaybeUnary(refDestructuringErrors,false);if(this.checkExpressionErrors(refDestructuringErrors)){return expr;}return expr.start==startPos&&expr.type==='ArrowFunctionExpression'?expr:this.parseExprOp(expr,startPos,startLoc,-1,noIn);};pp$3.parseExprOp=function(left,leftStartPos,leftStartLoc,minPrec,noIn){var prec=this.type.binop;if(prec!=null&&(!noIn||this.type!==types._in)){if(prec>minPrec){var logical=this.type===types.logicalOR||this.type===types.logicalAND;var op=this.value;this.next();var startPos=this.start,startLoc=this.startLoc;var right=this.parseExprOp(this.parseMaybeUnary(null,false),startPos,startLoc,prec,noIn);var node=this.buildBinary(leftStartPos,leftStartLoc,left,right,op,logical);return this.parseExprOp(node,leftStartPos,leftStartLoc,minPrec,noIn);}}return left;};pp$3.buildBinary=function(startPos,startLoc,left,right,op,logical){var node=this.startNodeAt(startPos,startLoc);node.left=left;node.operator=op;node.right=right;return this.finishNode(node,logical?'LogicalExpression':'BinaryExpression');};pp$3.parseMaybeUnary=function(refDestructuringErrors,sawUnary){var this$1=this;var startPos=this.start,startLoc=this.startLoc,expr;if(this.inAsync&&this.isContextual('await')){expr=this.parseAwait();sawUnary=true;}else if(this.type.prefix){var node=this.startNode(),update=this.type===types.incDec;node.operator=this.value;node.prefix=true;this.next();node.argument=this.parseMaybeUnary(null,true);this.checkExpressionErrors(refDestructuringErrors,true);if(update){this.checkLVal(node.argument);}else if(this.strict&&node.operator==='delete'&&node.argument.type==='Identifier'){this.raiseRecoverable(node.start,'Deleting local variable in strict mode');}else{sawUnary=true;}expr=this.finishNode(node,update?'UpdateExpression':'UnaryExpression');}else{expr=this.parseExprSubscripts(refDestructuringErrors);if(this.checkExpressionErrors(refDestructuringErrors)){return expr;}while(this.type.postfix&&!this.canInsertSemicolon()){var node$1=this$1.startNodeAt(startPos,startLoc);node$1.operator=this$1.value;node$1.prefix=false;node$1.argument=expr;this$1.checkLVal(expr);this$1.next();expr=this$1.finishNode(node$1,'UpdateExpression');}}if(!sawUnary&&this.eat(types.starstar)){return this.buildBinary(startPos,startLoc,expr,this.parseMaybeUnary(null,false),'**',false);}else{return expr;}};pp$3.parseExprSubscripts=function(refDestructuringErrors){var startPos=this.start,startLoc=this.startLoc;var expr=this.parseExprAtom(refDestructuringErrors);var skipArrowSubscripts=expr.type==='ArrowFunctionExpression'&&this.input.slice(this.lastTokStart,this.lastTokEnd)!==')';if(this.checkExpressionErrors(refDestructuringErrors)||skipArrowSubscripts){return expr;}var result=this.parseSubscripts(expr,startPos,startLoc);if(refDestructuringErrors&&result.type==='MemberExpression'){if(refDestructuringErrors.parenthesizedAssign>=result.start){refDestructuringErrors.parenthesizedAssign=-1;}if(refDestructuringErrors.parenthesizedBind>=result.start){refDestructuringErrors.parenthesizedBind=-1;}}return result;};pp$3.parseSubscripts=function(base,startPos,startLoc,noCalls){var this$1=this;var maybeAsyncArrow=this.options.ecmaVersion>=8&&base.type==='Identifier'&&base.name==='async'&&this.lastTokEnd==base.end&&!this.canInsertSemicolon()&&this.input.slice(base.start,base.end)==='async';for(var computed=void 0;;){if((computed=this$1.eat(types.bracketL))||this$1.eat(types.dot)){var node=this$1.startNodeAt(startPos,startLoc);node.object=base;node.property=computed?this$1.parseExpression():this$1.parseIdent(true);node.computed=!!computed;if(computed){this$1.expect(types.bracketR);}base=this$1.finishNode(node,'MemberExpression');}else if(!noCalls&&this$1.eat(types.parenL)){var refDestructuringErrors=new DestructuringErrors(),oldYieldPos=this$1.yieldPos,oldAwaitPos=this$1.awaitPos;this$1.yieldPos=0;this$1.awaitPos=0;var exprList=this$1.parseExprList(types.parenR,this$1.options.ecmaVersion>=8,false,refDestructuringErrors);if(maybeAsyncArrow&&!this$1.canInsertSemicolon()&&this$1.eat(types.arrow)){this$1.checkPatternErrors(refDestructuringErrors,false);this$1.checkYieldAwaitInDefaultParams();this$1.yieldPos=oldYieldPos;this$1.awaitPos=oldAwaitPos;return this$1.parseArrowExpression(this$1.startNodeAt(startPos,startLoc),exprList,true);}this$1.checkExpressionErrors(refDestructuringErrors,true);this$1.yieldPos=oldYieldPos||this$1.yieldPos;this$1.awaitPos=oldAwaitPos||this$1.awaitPos;var node$1=this$1.startNodeAt(startPos,startLoc);node$1.callee=base;node$1.arguments=exprList;base=this$1.finishNode(node$1,'CallExpression');}else if(this$1.type===types.backQuote){var node$2=this$1.startNodeAt(startPos,startLoc);node$2.tag=base;node$2.quasi=this$1.parseTemplate({isTagged:true});base=this$1.finishNode(node$2,'TaggedTemplateExpression');}else{return base;}}};pp$3.parseExprAtom=function(refDestructuringErrors){var node,canBeArrow=this.potentialArrowAt==this.start;switch(this.type){case types._super:if(!this.inFunction){this.raise(this.start,'\'super\' outside of function or class');}node=this.startNode();this.next();if(this.type!==types.dot&&this.type!==types.bracketL&&this.type!==types.parenL){this.unexpected();}return this.finishNode(node,'Super');case types._this:node=this.startNode();this.next();return this.finishNode(node,'ThisExpression');case types.name:var startPos=this.start,startLoc=this.startLoc,containsEsc=this.containsEsc;var id=this.parseIdent(this.type!==types.name);if(this.options.ecmaVersion>=8&&!containsEsc&&id.name==='async'&&!this.canInsertSemicolon()&&this.eat(types._function)){return this.parseFunction(this.startNodeAt(startPos,startLoc),false,false,true);}if(canBeArrow&&!this.canInsertSemicolon()){if(this.eat(types.arrow)){return this.parseArrowExpression(this.startNodeAt(startPos,startLoc),[id],false);}if(this.options.ecmaVersion>=8&&id.name==='async'&&this.type===types.name&&!containsEsc){id=this.parseIdent();if(this.canInsertSemicolon()||!this.eat(types.arrow)){this.unexpected();}return this.parseArrowExpression(this.startNodeAt(startPos,startLoc),[id],true);}}return id;case types.regexp:var value=this.value;node=this.parseLiteral(value.value);node.regex={pattern:value.pattern,flags:value.flags};return node;case types.num:case types.string:return this.parseLiteral(this.value);case types._null:case types._true:case types._false:node=this.startNode();node.value=this.type===types._null?null:this.type===types._true;node.raw=this.type.keyword;this.next();return this.finishNode(node,'Literal');case types.parenL:var start=this.start,expr=this.parseParenAndDistinguishExpression(canBeArrow);if(refDestructuringErrors){if(refDestructuringErrors.parenthesizedAssign<0&&!this.isSimpleAssignTarget(expr)){refDestructuringErrors.parenthesizedAssign=start;}if(refDestructuringErrors.parenthesizedBind<0){refDestructuringErrors.parenthesizedBind=start;}}return expr;case types.bracketL:node=this.startNode();this.next();node.elements=this.parseExprList(types.bracketR,true,true,refDestructuringErrors);return this.finishNode(node,'ArrayExpression');case types.braceL:return this.parseObj(false,refDestructuringErrors);case types._function:node=this.startNode();this.next();return this.parseFunction(node,false);case types._class:return this.parseClass(this.startNode(),false);case types._new:return this.parseNew();case types.backQuote:return this.parseTemplate();default:this.unexpected();}};pp$3.parseLiteral=function(value){var node=this.startNode();node.value=value;node.raw=this.input.slice(this.start,this.end);this.next();return this.finishNode(node,'Literal');};pp$3.parseParenExpression=function(){this.expect(types.parenL);var val=this.parseExpression();this.expect(types.parenR);return val;};pp$3.parseParenAndDistinguishExpression=function(canBeArrow){var this$1=this;var startPos=this.start,startLoc=this.startLoc,val,allowTrailingComma=this.options.ecmaVersion>=8;if(this.options.ecmaVersion>=6){this.next();var innerStartPos=this.start,innerStartLoc=this.startLoc;var exprList=[],first=true,lastIsComma=false;var refDestructuringErrors=new DestructuringErrors(),oldYieldPos=this.yieldPos,oldAwaitPos=this.awaitPos,spreadStart;this.yieldPos=0;this.awaitPos=0;while(this.type!==types.parenR){first?first=false:this$1.expect(types.comma);if(allowTrailingComma&&this$1.afterTrailingComma(types.parenR,true)){lastIsComma=true;break;}else if(this$1.type===types.ellipsis){spreadStart=this$1.start;exprList.push(this$1.parseParenItem(this$1.parseRestBinding()));if(this$1.type===types.comma){this$1.raise(this$1.start,'Comma is not permitted after the rest element');}break;}else{exprList.push(this$1.parseMaybeAssign(false,refDestructuringErrors,this$1.parseParenItem));}}var innerEndPos=this.start,innerEndLoc=this.startLoc;this.expect(types.parenR);if(canBeArrow&&!this.canInsertSemicolon()&&this.eat(types.arrow)){this.checkPatternErrors(refDestructuringErrors,false);this.checkYieldAwaitInDefaultParams();this.yieldPos=oldYieldPos;this.awaitPos=oldAwaitPos;return this.parseParenArrowList(startPos,startLoc,exprList);}if(!exprList.length||lastIsComma){this.unexpected(this.lastTokStart);}if(spreadStart){this.unexpected(spreadStart);}this.checkExpressionErrors(refDestructuringErrors,true);this.yieldPos=oldYieldPos||this.yieldPos;this.awaitPos=oldAwaitPos||this.awaitPos;if(exprList.length>1){val=this.startNodeAt(innerStartPos,innerStartLoc);val.expressions=exprList;this.finishNodeAt(val,'SequenceExpression',innerEndPos,innerEndLoc);}else{val=exprList[0];}}else{val=this.parseParenExpression();}if(this.options.preserveParens){var par=this.startNodeAt(startPos,startLoc);par.expression=val;return this.finishNode(par,'ParenthesizedExpression');}else{return val;}};pp$3.parseParenItem=function(item){return item;};pp$3.parseParenArrowList=function(startPos,startLoc,exprList){return this.parseArrowExpression(this.startNodeAt(startPos,startLoc),exprList);};var empty$1=[];pp$3.parseNew=function(){var node=this.startNode();var meta=this.parseIdent(true);if(this.options.ecmaVersion>=6&&this.eat(types.dot)){node.meta=meta;var containsEsc=this.containsEsc;node.property=this.parseIdent(true);if(node.property.name!=='target'||containsEsc){this.raiseRecoverable(node.property.start,'The only valid meta property for new is new.target');}if(!this.inFunction){this.raiseRecoverable(node.start,'new.target can only be used in functions');}return this.finishNode(node,'MetaProperty');}var startPos=this.start,startLoc=this.startLoc;node.callee=this.parseSubscripts(this.parseExprAtom(),startPos,startLoc,true);if(this.eat(types.parenL)){node.arguments=this.parseExprList(types.parenR,this.options.ecmaVersion>=8,false);}else{node.arguments=empty$1;}return this.finishNode(node,'NewExpression');};pp$3.parseTemplateElement=function(ref){var isTagged=ref.isTagged;var elem=this.startNode();if(this.type===types.invalidTemplate){if(!isTagged){this.raiseRecoverable(this.start,'Bad escape sequence in untagged template literal');}elem.value={raw:this.value,cooked:null};}else{elem.value={raw:this.input.slice(this.start,this.end).replace(/\r\n?/g,'\n'),cooked:this.value};}this.next();elem.tail=this.type===types.backQuote;return this.finishNode(elem,'TemplateElement');};pp$3.parseTemplate=function(ref){var this$1=this;if(ref===void 0)ref={};var isTagged=ref.isTagged;if(isTagged===void 0)isTagged=false;var node=this.startNode();this.next();node.expressions=[];var curElt=this.parseTemplateElement({isTagged:isTagged});node.quasis=[curElt];while(!curElt.tail){this$1.expect(types.dollarBraceL);node.expressions.push(this$1.parseExpression());this$1.expect(types.braceR);node.quasis.push(curElt=this$1.parseTemplateElement({isTagged:isTagged}));}this.next();return this.finishNode(node,'TemplateLiteral');};pp$3.isAsyncProp=function(prop){return!prop.computed&&prop.key.type==='Identifier'&&prop.key.name==='async'&&(this.type===types.name||this.type===types.num||this.type===types.string||this.type===types.bracketL||this.type.keyword)&&!lineBreak.test(this.input.slice(this.lastTokEnd,this.start));};pp$3.parseObj=function(isPattern,refDestructuringErrors){var this$1=this;var node=this.startNode(),first=true,propHash={};node.properties=[];this.next();while(!this.eat(types.braceR)){if(!first){this$1.expect(types.comma);if(this$1.afterTrailingComma(types.braceR)){break;}}else{first=false;}var prop=this$1.parseProperty(isPattern,refDestructuringErrors);if(!isPattern){this$1.checkPropClash(prop,propHash,refDestructuringErrors);}node.properties.push(prop);}return this.finishNode(node,isPattern?'ObjectPattern':'ObjectExpression');};pp$3.parseProperty=function(isPattern,refDestructuringErrors){var prop=this.startNode(),isGenerator,isAsync,startPos,startLoc;if(this.options.ecmaVersion>=6){prop.method=false;prop.shorthand=false;if(isPattern||refDestructuringErrors){startPos=this.start;startLoc=this.startLoc;}if(!isPattern){isGenerator=this.eat(types.star);}}var containsEsc=this.containsEsc;this.parsePropertyName(prop);if(!isPattern&&!containsEsc&&this.options.ecmaVersion>=8&&!isGenerator&&this.isAsyncProp(prop)){isAsync=true;this.parsePropertyName(prop,refDestructuringErrors);}else{isAsync=false;}this.parsePropertyValue(prop,isPattern,isGenerator,isAsync,startPos,startLoc,refDestructuringErrors,containsEsc);return this.finishNode(prop,'Property');};pp$3.parsePropertyValue=function(prop,isPattern,isGenerator,isAsync,startPos,startLoc,refDestructuringErrors,containsEsc){if((isGenerator||isAsync)&&this.type===types.colon){this.unexpected();}if(this.eat(types.colon)){prop.value=isPattern?this.parseMaybeDefault(this.start,this.startLoc):this.parseMaybeAssign(false,refDestructuringErrors);prop.kind='init';}else if(this.options.ecmaVersion>=6&&this.type===types.parenL){if(isPattern){this.unexpected();}prop.kind='init';prop.method=true;prop.value=this.parseMethod(isGenerator,isAsync);}else if(!isPattern&&!containsEsc&&this.options.ecmaVersion>=5&&!prop.computed&&prop.key.type==='Identifier'&&(prop.key.name==='get'||prop.key.name==='set')&&(this.type!=types.comma&&this.type!=types.braceR)){if(isGenerator||isAsync){this.unexpected();}prop.kind=prop.key.name;this.parsePropertyName(prop);prop.value=this.parseMethod(false);var paramCount=prop.kind==='get'?0:1;if(prop.value.params.length!==paramCount){var start=prop.value.start;if(prop.kind==='get'){this.raiseRecoverable(start,'getter should have no params');}else{this.raiseRecoverable(start,'setter should have exactly one param');}}else{if(prop.kind==='set'&&prop.value.params[0].type==='RestElement'){this.raiseRecoverable(prop.value.params[0].start,'Setter cannot use rest params');}}}else if(this.options.ecmaVersion>=6&&!prop.computed&&prop.key.type==='Identifier'){this.checkUnreserved(prop.key);prop.kind='init';if(isPattern){prop.value=this.parseMaybeDefault(startPos,startLoc,prop.key);}else if(this.type===types.eq&&refDestructuringErrors){if(refDestructuringErrors.shorthandAssign<0){refDestructuringErrors.shorthandAssign=this.start;}prop.value=this.parseMaybeDefault(startPos,startLoc,prop.key);}else{prop.value=prop.key;}prop.shorthand=true;}else{this.unexpected();}};pp$3.parsePropertyName=function(prop){if(this.options.ecmaVersion>=6){if(this.eat(types.bracketL)){prop.computed=true;prop.key=this.parseMaybeAssign();this.expect(types.bracketR);return prop.key;}else{prop.computed=false;}}return prop.key=this.type===types.num||this.type===types.string?this.parseExprAtom():this.parseIdent(true);};pp$3.initFunction=function(node){node.id=null;if(this.options.ecmaVersion>=6){node.generator=false;node.expression=false;}if(this.options.ecmaVersion>=8){node.async=false;}};pp$3.parseMethod=function(isGenerator,isAsync){var node=this.startNode(),oldInGen=this.inGenerator,oldInAsync=this.inAsync,oldYieldPos=this.yieldPos,oldAwaitPos=this.awaitPos,oldInFunc=this.inFunction;this.initFunction(node);if(this.options.ecmaVersion>=6){node.generator=isGenerator;}if(this.options.ecmaVersion>=8){node.async=!!isAsync;}this.inGenerator=node.generator;this.inAsync=node.async;this.yieldPos=0;this.awaitPos=0;this.inFunction=true;this.enterFunctionScope();this.expect(types.parenL);node.params=this.parseBindingList(types.parenR,false,this.options.ecmaVersion>=8);this.checkYieldAwaitInDefaultParams();this.parseFunctionBody(node,false);this.inGenerator=oldInGen;this.inAsync=oldInAsync;this.yieldPos=oldYieldPos;this.awaitPos=oldAwaitPos;this.inFunction=oldInFunc;return this.finishNode(node,'FunctionExpression');};pp$3.parseArrowExpression=function(node,params,isAsync){var oldInGen=this.inGenerator,oldInAsync=this.inAsync,oldYieldPos=this.yieldPos,oldAwaitPos=this.awaitPos,oldInFunc=this.inFunction;this.enterFunctionScope();this.initFunction(node);if(this.options.ecmaVersion>=8){node.async=!!isAsync;}this.inGenerator=false;this.inAsync=node.async;this.yieldPos=0;this.awaitPos=0;this.inFunction=true;node.params=this.toAssignableList(params,true);this.parseFunctionBody(node,true);this.inGenerator=oldInGen;this.inAsync=oldInAsync;this.yieldPos=oldYieldPos;this.awaitPos=oldAwaitPos;this.inFunction=oldInFunc;return this.finishNode(node,'ArrowFunctionExpression');};pp$3.parseFunctionBody=function(node,isArrowFunction){var isExpression=isArrowFunction&&this.type!==types.braceL;var oldStrict=this.strict,useStrict=false;if(isExpression){node.body=this.parseMaybeAssign();node.expression=true;this.checkParams(node,false);}else{var nonSimple=this.options.ecmaVersion>=7&&!this.isSimpleParamList(node.params);if(!oldStrict||nonSimple){useStrict=this.strictDirective(this.end);if(useStrict&&nonSimple){this.raiseRecoverable(node.start,'Illegal \'use strict\' directive in function with non-simple parameter list');}}var oldLabels=this.labels;this.labels=[];if(useStrict){this.strict=true;}this.checkParams(node,!oldStrict&&!useStrict&&!isArrowFunction&&this.isSimpleParamList(node.params));node.body=this.parseBlock(false);node.expression=false;this.adaptDirectivePrologue(node.body.body);this.labels=oldLabels;}this.exitFunctionScope();if(this.strict&&node.id){this.checkLVal(node.id,'none');}this.strict=oldStrict;};pp$3.isSimpleParamList=function(params){for(var i=0,list=params;i<list.length;i+=1){var param=list[i];if(param.type!=='Identifier'){return false;}}return true;};pp$3.checkParams=function(node,allowDuplicates){var this$1=this;var nameHash={};for(var i=0,list=node.params;i<list.length;i+=1){var param=list[i];this$1.checkLVal(param,'var',allowDuplicates?null:nameHash);}};pp$3.parseExprList=function(close,allowTrailingComma,allowEmpty,refDestructuringErrors){var this$1=this;var elts=[],first=true;while(!this.eat(close)){if(!first){this$1.expect(types.comma);if(allowTrailingComma&&this$1.afterTrailingComma(close)){break;}}else{first=false;}var elt=void 0;if(allowEmpty&&this$1.type===types.comma){elt=null;}else if(this$1.type===types.ellipsis){elt=this$1.parseSpread(refDestructuringErrors);if(refDestructuringErrors&&this$1.type===types.comma&&refDestructuringErrors.trailingComma<0){refDestructuringErrors.trailingComma=this$1.start;}}else{elt=this$1.parseMaybeAssign(false,refDestructuringErrors);}elts.push(elt);}return elts;};pp$3.checkUnreserved=function(ref){var start=ref.start;var end=ref.end;var name=ref.name;if(this.inGenerator&&name==='yield'){this.raiseRecoverable(start,'Can not use \'yield\' as identifier inside a generator');}if(this.inAsync&&name==='await'){this.raiseRecoverable(start,'Can not use \'await\' as identifier inside an async function');}if(this.isKeyword(name)){this.raise(start,'Unexpected keyword \''+name+'\'');}if(this.options.ecmaVersion<6&&this.input.slice(start,end).indexOf('\\')!=-1){return;}var re=this.strict?this.reservedWordsStrict:this.reservedWords;if(re.test(name)){if(!this.inAsync&&name==='await'){this.raiseRecoverable(start,'Can not use keyword \'await\' outside an async function');}this.raiseRecoverable(start,'The keyword \''+name+'\' is reserved');}};pp$3.parseIdent=function(liberal,isBinding){var node=this.startNode();if(liberal&&this.options.allowReserved=='never'){liberal=false;}if(this.type===types.name){node.name=this.value;}else if(this.type.keyword){node.name=this.type.keyword;if((node.name==='class'||node.name==='function')&&(this.lastTokEnd!==this.lastTokStart+1||this.input.charCodeAt(this.lastTokStart)!==46)){this.context.pop();}}else{this.unexpected();}this.next();this.finishNode(node,'Identifier');if(!liberal){this.checkUnreserved(node);}return node;};pp$3.parseYield=function(){if(!this.yieldPos){this.yieldPos=this.start;}var node=this.startNode();this.next();if(this.type==types.semi||this.canInsertSemicolon()||this.type!=types.star&&!this.type.startsExpr){node.delegate=false;node.argument=null;}else{node.delegate=this.eat(types.star);node.argument=this.parseMaybeAssign();}return this.finishNode(node,'YieldExpression');};pp$3.parseAwait=function(){if(!this.awaitPos){this.awaitPos=this.start;}var node=this.startNode();this.next();node.argument=this.parseMaybeUnary(null,true);return this.finishNode(node,'AwaitExpression');};var pp$4=Parser.prototype;pp$4.raise=function(pos,message){var loc=getLineInfo(this.input,pos);message+=' ('+loc.line+':'+loc.column+')';var err=new SyntaxError(message);err.pos=pos;err.loc=loc;err.raisedAt=this.pos;throw err;};pp$4.raiseRecoverable=pp$4.raise;pp$4.curPosition=function(){if(this.options.locations){return new Position(this.curLine,this.pos-this.lineStart);}};var pp$5=Parser.prototype;var assign=Object.assign||function(target){var sources=[],len=arguments.length-1;while(len-->0)sources[len]=arguments[len+1];for(var i=0,list=sources;i<list.length;i+=1){var source=list[i];for(var key in source){if(has(source,key)){target[key]=source[key];}}}return target;};pp$5.enterFunctionScope=function(){this.scopeStack.push({var:{},lexical:{},childVar:{},parentLexical:{}});};pp$5.exitFunctionScope=function(){this.scopeStack.pop();};pp$5.enterLexicalScope=function(){var parentScope=this.scopeStack[this.scopeStack.length-1];var childScope={var:{},lexical:{},childVar:{},parentLexical:{}};this.scopeStack.push(childScope);assign(childScope.parentLexical,parentScope.lexical,parentScope.parentLexical);};pp$5.exitLexicalScope=function(){var childScope=this.scopeStack.pop();var parentScope=this.scopeStack[this.scopeStack.length-1];assign(parentScope.childVar,childScope.var,childScope.childVar);};pp$5.canDeclareVarName=function(name){var currentScope=this.scopeStack[this.scopeStack.length-1];return!has(currentScope.lexical,name)&&!has(currentScope.parentLexical,name);};pp$5.canDeclareLexicalName=function(name){var currentScope=this.scopeStack[this.scopeStack.length-1];return!has(currentScope.lexical,name)&&!has(currentScope.var,name)&&!has(currentScope.childVar,name);};pp$5.declareVarName=function(name){this.scopeStack[this.scopeStack.length-1].var[name]=true;};pp$5.declareLexicalName=function(name){this.scopeStack[this.scopeStack.length-1].lexical[name]=true;};var Node=function Node(parser,pos,loc){this.type='';this.start=pos;this.end=0;if(parser.options.locations){this.loc=new SourceLocation(parser,loc);}if(parser.options.directSourceFile){this.sourceFile=parser.options.directSourceFile;}if(parser.options.ranges){this.range=[pos,0];}};var pp$6=Parser.prototype;pp$6.startNode=function(){return new Node(this,this.start,this.startLoc);};pp$6.startNodeAt=function(pos,loc){return new Node(this,pos,loc);};function finishNodeAt(node,type,pos,loc){node.type=type;node.end=pos;if(this.options.locations){node.loc.end=loc;}if(this.options.ranges){node.range[1]=pos;}return node;}pp$6.finishNode=function(node,type){return finishNodeAt.call(this,node,type,this.lastTokEnd,this.lastTokEndLoc);};pp$6.finishNodeAt=function(node,type,pos,loc){return finishNodeAt.call(this,node,type,pos,loc);};var TokContext=function TokContext(token,isExpr,preserveSpace,override,generator){this.token=token;this.isExpr=!!isExpr;this.preserveSpace=!!preserveSpace;this.override=override;this.generator=!!generator;};var types$1={b_stat:new TokContext('{',false),b_expr:new TokContext('{',true),b_tmpl:new TokContext('${',false),p_stat:new TokContext('(',false),p_expr:new TokContext('(',true),q_tmpl:new TokContext('`',true,true,function(p){return p.tryReadTemplateToken();}),f_stat:new TokContext('function',false),f_expr:new TokContext('function',true),f_expr_gen:new TokContext('function',true,false,null,true),f_gen:new TokContext('function',false,false,null,true)};var pp$7=Parser.prototype;pp$7.initialContext=function(){return[types$1.b_stat];};pp$7.braceIsBlock=function(prevType){var parent=this.curContext();if(parent===types$1.f_expr||parent===types$1.f_stat){return true;}if(prevType===types.colon&&(parent===types$1.b_stat||parent===types$1.b_expr)){return!parent.isExpr;}if(prevType===types._return||prevType==types.name&&this.exprAllowed){return lineBreak.test(this.input.slice(this.lastTokEnd,this.start));}if(prevType===types._else||prevType===types.semi||prevType===types.eof||prevType===types.parenR||prevType==types.arrow){return true;}if(prevType==types.braceL){return parent===types$1.b_stat;}if(prevType==types._var||prevType==types.name){return false;}return!this.exprAllowed;};pp$7.inGeneratorContext=function(){var this$1=this;for(var i=this.context.length-1;i>=1;i--){var context=this$1.context[i];if(context.token==='function'){return context.generator;}}return false;};pp$7.updateContext=function(prevType){var update,type=this.type;if(type.keyword&&prevType==types.dot){this.exprAllowed=false;}else if(update=type.updateContext){update.call(this,prevType);}else{this.exprAllowed=type.beforeExpr;}};types.parenR.updateContext=types.braceR.updateContext=function(){if(this.context.length==1){this.exprAllowed=true;return;}var out=this.context.pop();if(out===types$1.b_stat&&this.curContext().token==='function'){out=this.context.pop();}this.exprAllowed=!out.isExpr;};types.braceL.updateContext=function(prevType){this.context.push(this.braceIsBlock(prevType)?types$1.b_stat:types$1.b_expr);this.exprAllowed=true;};types.dollarBraceL.updateContext=function(){this.context.push(types$1.b_tmpl);this.exprAllowed=true;};types.parenL.updateContext=function(prevType){var statementParens=prevType===types._if||prevType===types._for||prevType===types._with||prevType===types._while;this.context.push(statementParens?types$1.p_stat:types$1.p_expr);this.exprAllowed=true;};types.incDec.updateContext=function(){};types._function.updateContext=types._class.updateContext=function(prevType){if(prevType.beforeExpr&&prevType!==types.semi&&prevType!==types._else&&!((prevType===types.colon||prevType===types.braceL)&&this.curContext()===types$1.b_stat)){this.context.push(types$1.f_expr);}else{this.context.push(types$1.f_stat);}this.exprAllowed=false;};types.backQuote.updateContext=function(){if(this.curContext()===types$1.q_tmpl){this.context.pop();}else{this.context.push(types$1.q_tmpl);}this.exprAllowed=false;};types.star.updateContext=function(prevType){if(prevType==types._function){var index=this.context.length-1;if(this.context[index]===types$1.f_expr){this.context[index]=types$1.f_expr_gen;}else{this.context[index]=types$1.f_gen;}}this.exprAllowed=true;};types.name.updateContext=function(prevType){var allowed=false;if(this.options.ecmaVersion>=6){if(this.value=='of'&&!this.exprAllowed||this.value=='yield'&&this.inGeneratorContext()){allowed=true;}}this.exprAllowed=allowed;};var Token=function Token(p){this.type=p.type;this.value=p.value;this.start=p.start;this.end=p.end;if(p.options.locations){this.loc=new SourceLocation(p,p.startLoc,p.endLoc);}if(p.options.ranges){this.range=[p.start,p.end];}};var pp$8=Parser.prototype;var isRhino=typeof Packages=='object'&&Object.prototype.toString.call(Packages)=='[object JavaPackage]';pp$8.next=function(){if(this.options.onToken){this.options.onToken(new Token(this));}this.lastTokEnd=this.end;this.lastTokStart=this.start;this.lastTokEndLoc=this.endLoc;this.lastTokStartLoc=this.startLoc;this.nextToken();};pp$8.getToken=function(){this.next();return new Token(this);};if(typeof Symbol!=='undefined'){pp$8[Symbol.iterator]=function(){var this$1=this;return{next:function(){var token=this$1.getToken();return{done:token.type===types.eof,value:token};}};};}pp$8.curContext=function(){return this.context[this.context.length-1];};pp$8.nextToken=function(){var curContext=this.curContext();if(!curContext||!curContext.preserveSpace){this.skipSpace();}this.start=this.pos;if(this.options.locations){this.startLoc=this.curPosition();}if(this.pos>=this.input.length){return this.finishToken(types.eof);}if(curContext.override){return curContext.override(this);}else{this.readToken(this.fullCharCodeAtPos());}};pp$8.readToken=function(code){if(isIdentifierStart(code,this.options.ecmaVersion>=6)||code===92){return this.readWord();}return this.getTokenFromCode(code);};pp$8.fullCharCodeAtPos=function(){var code=this.input.charCodeAt(this.pos);if(code<=55295||code>=57344){return code;}var next=this.input.charCodeAt(this.pos+1);return(code<<10)+next-56613888;};pp$8.skipBlockComment=function(){var this$1=this;var startLoc=this.options.onComment&&this.curPosition();var start=this.pos,end=this.input.indexOf('*/',this.pos+=2);if(end===-1){this.raise(this.pos-2,'Unterminated comment');}this.pos=end+2;if(this.options.locations){lineBreakG.lastIndex=start;var match;while((match=lineBreakG.exec(this.input))&&match.index<this.pos){++this$1.curLine;this$1.lineStart=match.index+match[0].length;}}if(this.options.onComment){this.options.onComment(true,this.input.slice(start+2,end),start,this.pos,startLoc,this.curPosition());}};pp$8.skipLineComment=function(startSkip){var this$1=this;var start=this.pos;var startLoc=this.options.onComment&&this.curPosition();var ch=this.input.charCodeAt(this.pos+=startSkip);while(this.pos<this.input.length&&!isNewLine(ch)){ch=this$1.input.charCodeAt(++this$1.pos);}if(this.options.onComment){this.options.onComment(false,this.input.slice(start+startSkip,this.pos),start,this.pos,startLoc,this.curPosition());}};pp$8.skipSpace=function(){var this$1=this;loop:while(this.pos<this.input.length){var ch=this$1.input.charCodeAt(this$1.pos);switch(ch){case 32:case 160:++this$1.pos;break;case 13:if(this$1.input.charCodeAt(this$1.pos+1)===10){++this$1.pos;}case 10:case 8232:case 8233:++this$1.pos;if(this$1.options.locations){++this$1.curLine;this$1.lineStart=this$1.pos;}break;case 47:switch(this$1.input.charCodeAt(this$1.pos+1)){case 42:this$1.skipBlockComment();break;case 47:this$1.skipLineComment(2);break;default:break loop;}break;default:if(ch>8&&ch<14||ch>=5760&&nonASCIIwhitespace.test(String.fromCharCode(ch))){++this$1.pos;}else{break loop;}}}};pp$8.finishToken=function(type,val){this.end=this.pos;if(this.options.locations){this.endLoc=this.curPosition();}var prevType=this.type;this.type=type;this.value=val;this.updateContext(prevType);};pp$8.readToken_dot=function(){var next=this.input.charCodeAt(this.pos+1);if(next>=48&&next<=57){return this.readNumber(true);}var next2=this.input.charCodeAt(this.pos+2);if(this.options.ecmaVersion>=6&&next===46&&next2===46){this.pos+=3;return this.finishToken(types.ellipsis);}else{++this.pos;return this.finishToken(types.dot);}};pp$8.readToken_slash=function(){var next=this.input.charCodeAt(this.pos+1);if(this.exprAllowed){++this.pos;return this.readRegexp();}if(next===61){return this.finishOp(types.assign,2);}return this.finishOp(types.slash,1);};pp$8.readToken_mult_modulo_exp=function(code){var next=this.input.charCodeAt(this.pos+1);var size=1;var tokentype=code===42?types.star:types.modulo;if(this.options.ecmaVersion>=7&&code==42&&next===42){++size;tokentype=types.starstar;next=this.input.charCodeAt(this.pos+2);}if(next===61){return this.finishOp(types.assign,size+1);}return this.finishOp(tokentype,size);};pp$8.readToken_pipe_amp=function(code){var next=this.input.charCodeAt(this.pos+1);if(next===code){return this.finishOp(code===124?types.logicalOR:types.logicalAND,2);}if(next===61){return this.finishOp(types.assign,2);}return this.finishOp(code===124?types.bitwiseOR:types.bitwiseAND,1);};pp$8.readToken_caret=function(){var next=this.input.charCodeAt(this.pos+1);if(next===61){return this.finishOp(types.assign,2);}return this.finishOp(types.bitwiseXOR,1);};pp$8.readToken_plus_min=function(code){var next=this.input.charCodeAt(this.pos+1);if(next===code){if(next==45&&!this.inModule&&this.input.charCodeAt(this.pos+2)==62&&(this.lastTokEnd===0||lineBreak.test(this.input.slice(this.lastTokEnd,this.pos)))){this.skipLineComment(3);this.skipSpace();return this.nextToken();}return this.finishOp(types.incDec,2);}if(next===61){return this.finishOp(types.assign,2);}return this.finishOp(types.plusMin,1);};pp$8.readToken_lt_gt=function(code){var next=this.input.charCodeAt(this.pos+1);var size=1;if(next===code){size=code===62&&this.input.charCodeAt(this.pos+2)===62?3:2;if(this.input.charCodeAt(this.pos+size)===61){return this.finishOp(types.assign,size+1);}return this.finishOp(types.bitShift,size);}if(next==33&&code==60&&!this.inModule&&this.input.charCodeAt(this.pos+2)==45&&this.input.charCodeAt(this.pos+3)==45){this.skipLineComment(4);this.skipSpace();return this.nextToken();}if(next===61){size=2;}return this.finishOp(types.relational,size);};pp$8.readToken_eq_excl=function(code){var next=this.input.charCodeAt(this.pos+1);if(next===61){return this.finishOp(types.equality,this.input.charCodeAt(this.pos+2)===61?3:2);}if(code===61&&next===62&&this.options.ecmaVersion>=6){this.pos+=2;return this.finishToken(types.arrow);}return this.finishOp(code===61?types.eq:types.prefix,1);};pp$8.getTokenFromCode=function(code){switch(code){case 46:return this.readToken_dot();case 40:++this.pos;return this.finishToken(types.parenL);case 41:++this.pos;return this.finishToken(types.parenR);case 59:++this.pos;return this.finishToken(types.semi);case 44:++this.pos;return this.finishToken(types.comma);case 91:++this.pos;return this.finishToken(types.bracketL);case 93:++this.pos;return this.finishToken(types.bracketR);case 123:++this.pos;return this.finishToken(types.braceL);case 125:++this.pos;return this.finishToken(types.braceR);case 58:++this.pos;return this.finishToken(types.colon);case 63:++this.pos;return this.finishToken(types.question);case 96:if(this.options.ecmaVersion<6){break;}++this.pos;return this.finishToken(types.backQuote);case 48:var next=this.input.charCodeAt(this.pos+1);if(next===120||next===88){return this.readRadixNumber(16);}if(this.options.ecmaVersion>=6){if(next===111||next===79){return this.readRadixNumber(8);}if(next===98||next===66){return this.readRadixNumber(2);}}case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return this.readNumber(false);case 34:case 39:return this.readString(code);case 47:return this.readToken_slash();case 37:case 42:return this.readToken_mult_modulo_exp(code);case 124:case 38:return this.readToken_pipe_amp(code);case 94:return this.readToken_caret();case 43:case 45:return this.readToken_plus_min(code);case 60:case 62:return this.readToken_lt_gt(code);case 61:case 33:return this.readToken_eq_excl(code);case 126:return this.finishOp(types.prefix,1);}this.raise(this.pos,'Unexpected character \''+codePointToString(code)+'\'');};pp$8.finishOp=function(type,size){var str=this.input.slice(this.pos,this.pos+size);this.pos+=size;return this.finishToken(type,str);};function tryCreateRegexp(src,flags,throwErrorAt,parser){try{return new RegExp(src,flags);}catch(e){if(throwErrorAt!==undefined){if(e instanceof SyntaxError){parser.raise(throwErrorAt,'Error parsing regular expression: '+e.message);}throw e;}}}var regexpUnicodeSupport=!!tryCreateRegexp('\uFFFF','u');pp$8.readRegexp=function(){var this$1=this;var escaped,inClass,start=this.pos;for(;;){if(this$1.pos>=this$1.input.length){this$1.raise(start,'Unterminated regular expression');}var ch=this$1.input.charAt(this$1.pos);if(lineBreak.test(ch)){this$1.raise(start,'Unterminated regular expression');}if(!escaped){if(ch==='['){inClass=true;}else if(ch===']'&&inClass){inClass=false;}else if(ch==='/'&&!inClass){break;}escaped=ch==='\\';}else{escaped=false;}++this$1.pos;}var content=this.input.slice(start,this.pos);++this.pos;var mods=this.readWord1();var tmp=content,tmpFlags='';if(mods){var validFlags=/^[gim]*$/;if(this.options.ecmaVersion>=6){validFlags=/^[gimuy]*$/;}if(this.options.ecmaVersion>=9){validFlags=/^[gimsuy]*$/;}if(!validFlags.test(mods)){this.raise(start,'Invalid regular expression flag');}if(mods.indexOf('u')>=0){if(regexpUnicodeSupport){tmpFlags='u';}else{tmp=tmp.replace(/\\u\{([0-9a-fA-F]+)\}/g,function(_match,code,offset){code=Number('0x'+code);if(code>1114111){this$1.raise(start+offset+3,'Code point out of bounds');}return'x';});tmp=tmp.replace(/\\u([a-fA-F0-9]{4})|[\uD800-\uDBFF][\uDC00-\uDFFF]/g,'x');tmpFlags=tmpFlags.replace('u','');}}}var value=null;if(!isRhino){tryCreateRegexp(tmp,tmpFlags,start,this);value=tryCreateRegexp(content,mods);}return this.finishToken(types.regexp,{pattern:content,flags:mods,value:value});};pp$8.readInt=function(radix,len){var this$1=this;var start=this.pos,total=0;for(var i=0,e=len==null?Infinity:len;i<e;++i){var code=this$1.input.charCodeAt(this$1.pos),val=void 0;if(code>=97){val=code-97+10;}else if(code>=65){val=code-65+10;}else if(code>=48&&code<=57){val=code-48;}else{val=Infinity;}if(val>=radix){break;}++this$1.pos;total=total*radix+val;}if(this.pos===start||len!=null&&this.pos-start!==len){return null;}return total;};pp$8.readRadixNumber=function(radix){this.pos+=2;var val=this.readInt(radix);if(val==null){this.raise(this.start+2,'Expected number in radix '+radix);}if(isIdentifierStart(this.fullCharCodeAtPos())){this.raise(this.pos,'Identifier directly after number');}return this.finishToken(types.num,val);};pp$8.readNumber=function(startsWithDot){var start=this.pos;if(!startsWithDot&&this.readInt(10)===null){this.raise(start,'Invalid number');}var octal=this.pos-start>=2&&this.input.charCodeAt(start)===48;if(octal&&this.strict){this.raise(start,'Invalid number');}if(octal&&/[89]/.test(this.input.slice(start,this.pos))){octal=false;}var next=this.input.charCodeAt(this.pos);if(next===46&&!octal){++this.pos;this.readInt(10);next=this.input.charCodeAt(this.pos);}if((next===69||next===101)&&!octal){next=this.input.charCodeAt(++this.pos);if(next===43||next===45){++this.pos;}if(this.readInt(10)===null){this.raise(start,'Invalid number');}}if(isIdentifierStart(this.fullCharCodeAtPos())){this.raise(this.pos,'Identifier directly after number');}var str=this.input.slice(start,this.pos);var val=octal?parseInt(str,8):parseFloat(str);return this.finishToken(types.num,val);};pp$8.readCodePoint=function(){var ch=this.input.charCodeAt(this.pos),code;if(ch===123){if(this.options.ecmaVersion<6){this.unexpected();}var codePos=++this.pos;code=this.readHexChar(this.input.indexOf('}',this.pos)-this.pos);++this.pos;if(code>1114111){this.invalidStringToken(codePos,'Code point out of bounds');}}else{code=this.readHexChar(4);}return code;};function codePointToString(code){if(code<=65535){return String.fromCharCode(code);}code-=65536;return String.fromCharCode((code>>10)+55296,(code&1023)+56320);}pp$8.readString=function(quote){var this$1=this;var out='',chunkStart=++this.pos;for(;;){if(this$1.pos>=this$1.input.length){this$1.raise(this$1.start,'Unterminated string constant');}var ch=this$1.input.charCodeAt(this$1.pos);if(ch===quote){break;}if(ch===92){out+=this$1.input.slice(chunkStart,this$1.pos);out+=this$1.readEscapedChar(false);chunkStart=this$1.pos;}else{if(isNewLine(ch)){this$1.raise(this$1.start,'Unterminated string constant');}++this$1.pos;}}out+=this.input.slice(chunkStart,this.pos++);return this.finishToken(types.string,out);};var INVALID_TEMPLATE_ESCAPE_ERROR={};pp$8.tryReadTemplateToken=function(){this.inTemplateElement=true;try{this.readTmplToken();}catch(err){if(err===INVALID_TEMPLATE_ESCAPE_ERROR){this.readInvalidTemplateToken();}else{throw err;}}this.inTemplateElement=false;};pp$8.invalidStringToken=function(position,message){if(this.inTemplateElement&&this.options.ecmaVersion>=9){throw INVALID_TEMPLATE_ESCAPE_ERROR;}else{this.raise(position,message);}};pp$8.readTmplToken=function(){var this$1=this;var out='',chunkStart=this.pos;for(;;){if(this$1.pos>=this$1.input.length){this$1.raise(this$1.start,'Unterminated template');}var ch=this$1.input.charCodeAt(this$1.pos);if(ch===96||ch===36&&this$1.input.charCodeAt(this$1.pos+1)===123){if(this$1.pos===this$1.start&&(this$1.type===types.template||this$1.type===types.invalidTemplate)){if(ch===36){this$1.pos+=2;return this$1.finishToken(types.dollarBraceL);}else{++this$1.pos;return this$1.finishToken(types.backQuote);}}out+=this$1.input.slice(chunkStart,this$1.pos);return this$1.finishToken(types.template,out);}if(ch===92){out+=this$1.input.slice(chunkStart,this$1.pos);out+=this$1.readEscapedChar(true);chunkStart=this$1.pos;}else if(isNewLine(ch)){out+=this$1.input.slice(chunkStart,this$1.pos);++this$1.pos;switch(ch){case 13:if(this$1.input.charCodeAt(this$1.pos)===10){++this$1.pos;}case 10:out+='\n';break;default:out+=String.fromCharCode(ch);break;}if(this$1.options.locations){++this$1.curLine;this$1.lineStart=this$1.pos;}chunkStart=this$1.pos;}else{++this$1.pos;}}};pp$8.readInvalidTemplateToken=function(){var this$1=this;for(;this.pos<this.input.length;this.pos++){switch(this$1.input[this$1.pos]){case'\\':++this$1.pos;break;case'$':if(this$1.input[this$1.pos+1]!=='{'){break;}case'`':return this$1.finishToken(types.invalidTemplate,this$1.input.slice(this$1.start,this$1.pos));}}this.raise(this.start,'Unterminated template');};pp$8.readEscapedChar=function(inTemplate){var ch=this.input.charCodeAt(++this.pos);++this.pos;switch(ch){case 110:return'\n';case 114:return'\r';case 120:return String.fromCharCode(this.readHexChar(2));case 117:return codePointToString(this.readCodePoint());case 116:return'\t';case 98:return'\b';case 118:return'\x0B';case 102:return'\f';case 13:if(this.input.charCodeAt(this.pos)===10){++this.pos;}case 10:if(this.options.locations){this.lineStart=this.pos;++this.curLine;}return'';default:if(ch>=48&&ch<=55){var octalStr=this.input.substr(this.pos-1,3).match(/^[0-7]+/)[0];var octal=parseInt(octalStr,8);if(octal>255){octalStr=octalStr.slice(0,-1);octal=parseInt(octalStr,8);}if(octalStr!=='0'&&(this.strict||inTemplate)){this.invalidStringToken(this.pos-2,'Octal literal in strict mode');}this.pos+=octalStr.length-1;return String.fromCharCode(octal);}return String.fromCharCode(ch);}};pp$8.readHexChar=function(len){var codePos=this.pos;var n=this.readInt(16,len);if(n===null){this.invalidStringToken(codePos,'Bad character escape sequence');}return n;};pp$8.readWord1=function(){var this$1=this;this.containsEsc=false;var word='',first=true,chunkStart=this.pos;var astral=this.options.ecmaVersion>=6;while(this.pos<this.input.length){var ch=this$1.fullCharCodeAtPos();if(isIdentifierChar(ch,astral)){this$1.pos+=ch<=65535?1:2;}else if(ch===92){this$1.containsEsc=true;word+=this$1.input.slice(chunkStart,this$1.pos);var escStart=this$1.pos;if(this$1.input.charCodeAt(++this$1.pos)!=117){this$1.invalidStringToken(this$1.pos,'Expecting Unicode escape sequence \\uXXXX');}++this$1.pos;var esc=this$1.readCodePoint();if(!(first?isIdentifierStart:isIdentifierChar)(esc,astral)){this$1.invalidStringToken(escStart,'Invalid Unicode escape');}word+=codePointToString(esc);chunkStart=this$1.pos;}else{break;}first=false;}return word+this.input.slice(chunkStart,this.pos);};pp$8.readWord=function(){var word=this.readWord1();var type=types.name;if(this.keywords.test(word)){if(this.containsEsc){this.raiseRecoverable(this.start,'Escape sequence in keyword '+word);}type=keywords$1[word];}return this.finishToken(type,word);};var version='5.3.0';function parse(input,options){return new Parser(options,input).parse();}function parseExpressionAt(input,pos,options){var p=new Parser(options,input,pos);p.nextToken();return p.parseExpression();}function tokenizer(input,options){return new Parser(options,input);}function addLooseExports(parse,Parser$$1,plugins$$1){exports.parse_dammit=parse;exports.LooseParser=Parser$$1;exports.pluginsLoose=plugins$$1;}exports.version=version;exports.parse=parse;exports.parseExpressionAt=parseExpressionAt;exports.tokenizer=tokenizer;exports.addLooseExports=addLooseExports;exports.Parser=Parser;exports.plugins=plugins;exports.defaultOptions=defaultOptions;exports.Position=Position;exports.SourceLocation=SourceLocation;exports.getLineInfo=getLineInfo;exports.Node=Node;exports.TokenType=TokenType;exports.tokTypes=types;exports.keywordTypes=keywords$1;exports.TokContext=TokContext;exports.tokContexts=types$1;exports.isIdentifierChar=isIdentifierChar;exports.isIdentifierStart=isIdentifierStart;exports.Token=Token;exports.isNewLine=isNewLine;exports.lineBreak=lineBreak;exports.lineBreakG=lineBreakG;exports.nonASCIIwhitespace=nonASCIIwhitespace;Object.defineProperty(exports,'__esModule',{value:true});}));},{}],53:[function(require,module,exports){module.exports={'_from':'github:t2ym/espree#master','_id':'espree@3.5.2','_inBundle':false,'_integrity':'','_location':'/espree','_phantomChildren':{},'_requested':{'type':'git','raw':'espree@github:t2ym/espree#master','name':'espree','escapedName':'espree','rawSpec':'github:t2ym/espree#master','saveSpec':'github:t2ym/espree#master','fetchSpec':null,'gitCommittish':'master'},'_requiredBy':['/','/@thin-hook/build','/@thin-hook/build-coverage','/@thin-hook/injector-helpers','/polymer-bundler'],'_resolved':'github:t2ym/espree#f63dee870411439f5cedf9684b10f2c6edd128ad','_spec':'espree@github:t2ym/espree#master','_where':'/home/t2ym/work/components/thin-hook','author':{'name':'Nicholas C. Zakas','email':'nicholas+npm@nczconsulting.com'},'bugs':{'url':'http://github.com/eslint/espree.git'},'bundleDependencies':false,'dependencies':{'acorn':'5.3.0','acorn-dynamic-import':'^2.0.2','acorn-jsx':'^3.0.0'},'deprecated':false,'description':'An Esprima-compatible JavaScript parser built on Acorn','devDependencies':{'browserify':'^7.0.0','chai':'^1.10.0','eslint':'^2.13.1','eslint-config-eslint':'^3.0.0','eslint-release':'^0.10.0','esprima':'latest','esprima-fb':'^8001.2001.0-dev-harmony-fb','istanbul':'~0.2.6','json-diff':'~0.3.1','leche':'^1.0.1','mocha':'^2.0.1','regenerate':'~0.5.4','shelljs':'^0.3.0','shelljs-nodecli':'^0.1.1','unicode-6.3.0':'~0.1.0'},'engines':{'node':'>=0.10.0'},'files':['lib','espree.js'],'homepage':'https://github.com/eslint/espree','keywords':['ast','ecmascript','javascript','parser','syntax','acorn'],'license':'BSD-2-Clause','main':'espree.js','name':'espree','repository':{'type':'git','url':'git+https://github.com/eslint/espree.git'},'scripts':{'alpharelease':'eslint-prelease alpha','betarelease':'eslint-prelease beta','browserify':'node Makefile.js browserify','ci-release':'eslint-ci-release','generate-regex':'node tools/generate-identifier-regex.js','gh-release':'eslint-gh-release','lint':'node Makefile.js lint','release':'eslint-release','test':'npm run-script lint && node Makefile.js test'},'version':'3.5.2'};},{}],54:[function(require,module,exports){(function clone(exports){'use strict';var Syntax,VisitorOption,VisitorKeys,BREAK,SKIP,REMOVE;function deepCopy(obj){var ret={},key,val;for(key in obj){if(obj.hasOwnProperty(key)){val=obj[key];if(typeof val==='object'&&val!==null){ret[key]=deepCopy(val);}else{ret[key]=val;}}}return ret;}function upperBound(array,func){var diff,len,i,current;len=array.length;i=0;while(len){diff=len>>>1;current=i+diff;if(func(array[current])){len=diff;}else{i=current+1;len-=diff+1;}}return i;}Syntax={AssignmentExpression:'AssignmentExpression',AssignmentPattern:'AssignmentPattern',ArrayExpression:'ArrayExpression',ArrayPattern:'ArrayPattern',ArrowFunctionExpression:'ArrowFunctionExpression',AwaitExpression:'AwaitExpression',BlockStatement:'BlockStatement',BinaryExpression:'BinaryExpression',BreakStatement:'BreakStatement',CallExpression:'CallExpression',CatchClause:'CatchClause',ClassBody:'ClassBody',ClassDeclaration:'ClassDeclaration',ClassExpression:'ClassExpression',ComprehensionBlock:'ComprehensionBlock',ComprehensionExpression:'ComprehensionExpression',ConditionalExpression:'ConditionalExpression',ContinueStatement:'ContinueStatement',DebuggerStatement:'DebuggerStatement',DirectiveStatement:'DirectiveStatement',DoWhileStatement:'DoWhileStatement',EmptyStatement:'EmptyStatement',ExportAllDeclaration:'ExportAllDeclaration',ExportDefaultDeclaration:'ExportDefaultDeclaration',ExportNamedDeclaration:'ExportNamedDeclaration',ExportSpecifier:'ExportSpecifier',ExpressionStatement:'ExpressionStatement',ForStatement:'ForStatement',ForInStatement:'ForInStatement',ForOfStatement:'ForOfStatement',FunctionDeclaration:'FunctionDeclaration',FunctionExpression:'FunctionExpression',GeneratorExpression:'GeneratorExpression',Identifier:'Identifier',IfStatement:'IfStatement',ImportExpression:'ImportExpression',ImportDeclaration:'ImportDeclaration',ImportDefaultSpecifier:'ImportDefaultSpecifier',ImportNamespaceSpecifier:'ImportNamespaceSpecifier',ImportSpecifier:'ImportSpecifier',Literal:'Literal',LabeledStatement:'LabeledStatement',LogicalExpression:'LogicalExpression',MemberExpression:'MemberExpression',MetaProperty:'MetaProperty',MethodDefinition:'MethodDefinition',ModuleSpecifier:'ModuleSpecifier',NewExpression:'NewExpression',ObjectExpression:'ObjectExpression',ObjectPattern:'ObjectPattern',Program:'Program',Property:'Property',RestElement:'RestElement',ReturnStatement:'ReturnStatement',SequenceExpression:'SequenceExpression',SpreadElement:'SpreadElement',Super:'Super',SwitchStatement:'SwitchStatement',SwitchCase:'SwitchCase',TaggedTemplateExpression:'TaggedTemplateExpression',TemplateElement:'TemplateElement',TemplateLiteral:'TemplateLiteral',ThisExpression:'ThisExpression',ThrowStatement:'ThrowStatement',TryStatement:'TryStatement',UnaryExpression:'UnaryExpression',UpdateExpression:'UpdateExpression',VariableDeclaration:'VariableDeclaration',VariableDeclarator:'VariableDeclarator',WhileStatement:'WhileStatement',WithStatement:'WithStatement',YieldExpression:'YieldExpression'};VisitorKeys={AssignmentExpression:['left','right'],AssignmentPattern:['left','right'],ArrayExpression:['elements'],ArrayPattern:['elements'],ArrowFunctionExpression:['params','body'],AwaitExpression:['argument'],BlockStatement:['body'],BinaryExpression:['left','right'],BreakStatement:['label'],CallExpression:['callee','arguments'],CatchClause:['param','body'],ClassBody:['body'],ClassDeclaration:['id','superClass','body'],ClassExpression:['id','superClass','body'],ComprehensionBlock:['left','right'],ComprehensionExpression:['blocks','filter','body'],ConditionalExpression:['test','consequent','alternate'],ContinueStatement:['label'],DebuggerStatement:[],DirectiveStatement:[],DoWhileStatement:['body','test'],EmptyStatement:[],ExportAllDeclaration:['source'],ExportDefaultDeclaration:['declaration'],ExportNamedDeclaration:['declaration','specifiers','source'],ExportSpecifier:['exported','local'],ExpressionStatement:['expression'],ForStatement:['init','test','update','body'],ForInStatement:['left','right','body'],ForOfStatement:['left','right','body'],FunctionDeclaration:['id','params','body'],FunctionExpression:['id','params','body'],GeneratorExpression:['blocks','filter','body'],Identifier:[],IfStatement:['test','consequent','alternate'],ImportExpression:['source'],ImportDeclaration:['specifiers','source'],ImportDefaultSpecifier:['local'],ImportNamespaceSpecifier:['local'],ImportSpecifier:['imported','local'],Literal:[],LabeledStatement:['label','body'],LogicalExpression:['left','right'],MemberExpression:['object','property'],MetaProperty:['meta','property'],MethodDefinition:['key','value'],ModuleSpecifier:[],NewExpression:['callee','arguments'],ObjectExpression:['properties'],ObjectPattern:['properties'],Program:['body'],Property:['key','value'],RestElement:['argument'],ReturnStatement:['argument'],SequenceExpression:['expressions'],SpreadElement:['argument'],Super:[],SwitchStatement:['discriminant','cases'],SwitchCase:['test','consequent'],TaggedTemplateExpression:['tag','quasi'],TemplateElement:[],TemplateLiteral:['quasis','expressions'],ThisExpression:[],ThrowStatement:['argument'],TryStatement:['block','handler','finalizer'],UnaryExpression:['argument'],UpdateExpression:['argument'],VariableDeclaration:['declarations'],VariableDeclarator:['id','init'],WhileStatement:['test','body'],WithStatement:['object','body'],YieldExpression:['argument']};BREAK={};SKIP={};REMOVE={};VisitorOption={Break:BREAK,Skip:SKIP,Remove:REMOVE};function Reference(parent,key){this.parent=parent;this.key=key;}Reference.prototype.replace=function replace(node){this.parent[this.key]=node;};Reference.prototype.remove=function remove(){if(Array.isArray(this.parent)){this.parent.splice(this.key,1);return true;}else{this.replace(null);return false;}};function Element(node,path,wrap,ref){this.node=node;this.path=path;this.wrap=wrap;this.ref=ref;}function Controller(){}Controller.prototype.path=function path(){var i,iz,j,jz,result,element;function addToPath(result,path){if(Array.isArray(path)){for(j=0,jz=path.length;j<jz;++j){result.push(path[j]);}}else{result.push(path);}}if(!this.__current.path){return null;}result=[];for(i=2,iz=this.__leavelist.length;i<iz;++i){element=this.__leavelist[i];addToPath(result,element.path);}addToPath(result,this.__current.path);return result;};Controller.prototype.type=function(){var node=this.current();return node.type||this.__current.wrap;};Controller.prototype.parents=function parents(){var i,iz,result;result=[];for(i=1,iz=this.__leavelist.length;i<iz;++i){result.push(this.__leavelist[i].node);}return result;};Controller.prototype.current=function current(){return this.__current.node;};Controller.prototype.__execute=function __execute(callback,element){var previous,result;result=undefined;previous=this.__current;this.__current=element;this.__state=null;if(callback){result=callback.call(this,element.node,this.__leavelist[this.__leavelist.length-1].node);}this.__current=previous;return result;};Controller.prototype.notify=function notify(flag){this.__state=flag;};Controller.prototype.skip=function(){this.notify(SKIP);};Controller.prototype['break']=function(){this.notify(BREAK);};Controller.prototype.remove=function(){this.notify(REMOVE);};Controller.prototype.__initialize=function(root,visitor){this.visitor=visitor;this.root=root;this.__worklist=[];this.__leavelist=[];this.__current=null;this.__state=null;this.__fallback=null;if(visitor.fallback==='iteration'){this.__fallback=Object.keys;}else if(typeof visitor.fallback==='function'){this.__fallback=visitor.fallback;}this.__keys=VisitorKeys;if(visitor.keys){this.__keys=Object.assign(Object.create(this.__keys),visitor.keys);}};function isNode(node){if(node==null){return false;}return typeof node==='object'&&typeof node.type==='string';}function isProperty(nodeType,key){return(nodeType===Syntax.ObjectExpression||nodeType===Syntax.ObjectPattern)&&'properties'===key;}Controller.prototype.traverse=function traverse(root,visitor){var worklist,leavelist,element,node,nodeType,ret,key,current,current2,candidates,candidate,sentinel;this.__initialize(root,visitor);sentinel={};worklist=this.__worklist;leavelist=this.__leavelist;worklist.push(new Element(root,null,null,null));leavelist.push(new Element(null,null,null,null));while(worklist.length){element=worklist.pop();if(element===sentinel){element=leavelist.pop();ret=this.__execute(visitor.leave,element);if(this.__state===BREAK||ret===BREAK){return;}continue;}if(element.node){ret=this.__execute(visitor.enter,element);if(this.__state===BREAK||ret===BREAK){return;}worklist.push(sentinel);leavelist.push(element);if(this.__state===SKIP||ret===SKIP){continue;}node=element.node;nodeType=node.type||element.wrap;candidates=this.__keys[nodeType];if(!candidates){if(this.__fallback){candidates=this.__fallback(node);}else{throw new Error('Unknown node type '+nodeType+'.');}}current=candidates.length;while((current-=1)>=0){key=candidates[current];candidate=node[key];if(!candidate){continue;}if(Array.isArray(candidate)){current2=candidate.length;while((current2-=1)>=0){if(!candidate[current2]){continue;}if(isProperty(nodeType,candidates[current])){element=new Element(candidate[current2],[key,current2],'Property',null);}else if(isNode(candidate[current2])){element=new Element(candidate[current2],[key,current2],null,null);}else{continue;}worklist.push(element);}}else if(isNode(candidate)){worklist.push(new Element(candidate,key,null,null));}}}}};Controller.prototype.replace=function replace(root,visitor){var worklist,leavelist,node,nodeType,target,element,current,current2,candidates,candidate,sentinel,outer,key;function removeElem(element){var i,key,nextElem,parent;if(element.ref.remove()){key=element.ref.key;parent=element.ref.parent;i=worklist.length;while(i--){nextElem=worklist[i];if(nextElem.ref&&nextElem.ref.parent===parent){if(nextElem.ref.key<key){break;}--nextElem.ref.key;}}}}this.__initialize(root,visitor);sentinel={};worklist=this.__worklist;leavelist=this.__leavelist;outer={root:root};element=new Element(root,null,null,new Reference(outer,'root'));worklist.push(element);leavelist.push(element);while(worklist.length){element=worklist.pop();if(element===sentinel){element=leavelist.pop();target=this.__execute(visitor.leave,element);if(target!==undefined&&target!==BREAK&&target!==SKIP&&target!==REMOVE){element.ref.replace(target);}if(this.__state===REMOVE||target===REMOVE){removeElem(element);}if(this.__state===BREAK||target===BREAK){return outer.root;}continue;}target=this.__execute(visitor.enter,element);if(target!==undefined&&target!==BREAK&&target!==SKIP&&target!==REMOVE){element.ref.replace(target);element.node=target;}if(this.__state===REMOVE||target===REMOVE){removeElem(element);element.node=null;}if(this.__state===BREAK||target===BREAK){return outer.root;}node=element.node;if(!node){continue;}worklist.push(sentinel);leavelist.push(element);if(this.__state===SKIP||target===SKIP){continue;}nodeType=node.type||element.wrap;candidates=this.__keys[nodeType];if(!candidates){if(this.__fallback){candidates=this.__fallback(node);}else{throw new Error('Unknown node type '+nodeType+'.');}}current=candidates.length;while((current-=1)>=0){key=candidates[current];candidate=node[key];if(!candidate){continue;}if(Array.isArray(candidate)){current2=candidate.length;while((current2-=1)>=0){if(!candidate[current2]){continue;}if(isProperty(nodeType,candidates[current])){element=new Element(candidate[current2],[key,current2],'Property',new Reference(candidate,current2));}else if(isNode(candidate[current2])){element=new Element(candidate[current2],[key,current2],null,new Reference(candidate,current2));}else{continue;}worklist.push(element);}}else if(isNode(candidate)){worklist.push(new Element(candidate,key,null,new Reference(node,key)));}}}return outer.root;};function traverse(root,visitor){var controller=new Controller();return controller.traverse(root,visitor);}function replace(root,visitor){var controller=new Controller();return controller.replace(root,visitor);}function extendCommentRange(comment,tokens){var target;target=upperBound(tokens,function search(token){return token.range[0]>comment.range[0];});comment.extendedRange=[comment.range[0],comment.range[1]];if(target!==tokens.length){comment.extendedRange[1]=tokens[target].range[0];}target-=1;if(target>=0){comment.extendedRange[0]=tokens[target].range[1];}return comment;}function attachComments(tree,providedComments,tokens){var comments=[],comment,len,i,cursor;if(!tree.range){throw new Error('attachComments needs range information');}if(!tokens.length){if(providedComments.length){for(i=0,len=providedComments.length;i<len;i+=1){comment=deepCopy(providedComments[i]);comment.extendedRange=[0,tree.range[0]];comments.push(comment);}tree.leadingComments=comments;}return tree;}for(i=0,len=providedComments.length;i<len;i+=1){comments.push(extendCommentRange(deepCopy(providedComments[i]),tokens));}cursor=0;traverse(tree,{enter:function(node){var comment;while(cursor<comments.length){comment=comments[cursor];if(comment.extendedRange[1]>node.range[0]){break;}if(comment.extendedRange[1]===node.range[0]){if(!node.leadingComments){node.leadingComments=[];}node.leadingComments.push(comment);comments.splice(cursor,1);}else{cursor+=1;}}if(cursor===comments.length){return VisitorOption.Break;}if(comments[cursor].extendedRange[0]>node.range[1]){return VisitorOption.Skip;}}});cursor=0;traverse(tree,{leave:function(node){var comment;while(cursor<comments.length){comment=comments[cursor];if(node.range[1]<comment.extendedRange[0]){break;}if(node.range[1]===comment.extendedRange[0]){if(!node.trailingComments){node.trailingComments=[];}node.trailingComments.push(comment);comments.splice(cursor,1);}else{cursor+=1;}}if(cursor===comments.length){return VisitorOption.Break;}if(comments[cursor].extendedRange[0]>node.range[1]){return VisitorOption.Skip;}}});return tree;}exports.version=require('./package.json').version;exports.Syntax=Syntax;exports.traverse=traverse;exports.replace=replace;exports.attachComments=attachComments;exports.VisitorKeys=VisitorKeys;exports.VisitorOption=VisitorOption;exports.Controller=Controller;exports.cloneEnvironment=function(){return clone({});};return exports;}(exports));},{'./package.json':55}],55:[function(require,module,exports){module.exports={'_from':'estraverse@^4.1.1','_id':'estraverse@4.3.0','_inBundle':false,'_integrity':'sha512-39nnKffWz8xN1BU/2c79n9nB9HDzo0niYUqx6xyqUnyoAnQyyWpOTdZEeiCch8BBu515t4wp9ZmgVfVhn9EBpw==','_location':'/estraverse','_phantomChildren':{},'_requested':{'type':'range','registry':true,'raw':'estraverse@^4.1.1','name':'estraverse','escapedName':'estraverse','rawSpec':'^4.1.1','saveSpec':null,'fetchSpec':'^4.1.1'},'_requiredBy':['/@thin-hook/injector-helpers','/escodegen','/escope'],'_resolved':'https://registry.npmjs.org/estraverse/-/estraverse-4.3.0.tgz','_shasum':'398ad3f3c5a24948be7725e83d11a7de28cdbd1d','_spec':'estraverse@^4.1.1','_where':'/home/t2ym/work/components/thin-hook/node_modules/escope','bugs':{'url':'https://github.com/estools/estraverse/issues'},'bundleDependencies':false,'deprecated':false,'description':'ECMAScript JS AST traversal functions','devDependencies':{'babel-preset-env':'^1.6.1','babel-register':'^6.3.13','chai':'^2.1.1','espree':'^1.11.0','gulp':'^3.8.10','gulp-bump':'^0.2.2','gulp-filter':'^2.0.0','gulp-git':'^1.0.1','gulp-tag-version':'^1.3.0','jshint':'^2.5.6','mocha':'^2.1.0'},'engines':{'node':'>=4.0'},'homepage':'https://github.com/estools/estraverse','license':'BSD-2-Clause','main':'estraverse.js','maintainers':[{'name':'Yusuke Suzuki','email':'utatane.tea@gmail.com','url':'http://github.com/Constellation'}],'name':'estraverse','repository':{'type':'git','url':'git+ssh://git@github.com/estools/estraverse.git'},'scripts':{'lint':'jshint estraverse.js','test':'npm run-script lint && npm run-script unit-test','unit-test':'mocha --compilers js:babel-register'},'version':'4.3.0'};},{}],56:[function(require,module,exports){(function(){'use strict';function isExpression(node){if(node==null){return false;}switch(node.type){case'ArrayExpression':case'AssignmentExpression':case'BinaryExpression':case'CallExpression':case'ConditionalExpression':case'FunctionExpression':case'Identifier':case'Literal':case'LogicalExpression':case'MemberExpression':case'NewExpression':case'ObjectExpression':case'SequenceExpression':case'ThisExpression':case'UnaryExpression':case'UpdateExpression':return true;}return false;}function isIterationStatement(node){if(node==null){return false;}switch(node.type){case'DoWhileStatement':case'ForInStatement':case'ForStatement':case'WhileStatement':return true;}return false;}function isStatement(node){if(node==null){return false;}switch(node.type){case'BlockStatement':case'BreakStatement':case'ContinueStatement':case'DebuggerStatement':case'DoWhileStatement':case'EmptyStatement':case'ExpressionStatement':case'ForInStatement':case'ForStatement':case'IfStatement':case'LabeledStatement':case'ReturnStatement':case'SwitchStatement':case'ThrowStatement':case'TryStatement':case'VariableDeclaration':case'WhileStatement':case'WithStatement':return true;}return false;}function isSourceElement(node){return isStatement(node)||node!=null&&node.type==='FunctionDeclaration';}function trailingStatement(node){switch(node.type){case'IfStatement':if(node.alternate!=null){return node.alternate;}return node.consequent;case'LabeledStatement':case'ForStatement':case'ForInStatement':case'WhileStatement':case'WithStatement':return node.body;}return null;}function isProblematicIfStatement(node){var current;if(node.type!=='IfStatement'){return false;}if(node.alternate==null){return false;}current=node.consequent;do{if(current.type==='IfStatement'){if(current.alternate==null){return true;}}current=trailingStatement(current);}while(current);return false;}module.exports={isExpression:isExpression,isStatement:isStatement,isIterationStatement:isIterationStatement,isSourceElement:isSourceElement,isProblematicIfStatement:isProblematicIfStatement,trailingStatement:trailingStatement};}());},{}],57:[function(require,module,exports){(function(){'use strict';var ES6Regex,ES5Regex,NON_ASCII_WHITESPACES,IDENTIFIER_START,IDENTIFIER_PART,ch;ES5Regex={NonAsciiIdentifierStart:/[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/,NonAsciiIdentifierPart:/[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/};ES6Regex={NonAsciiIdentifierStart:/[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,NonAsciiIdentifierPart:/[\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/};function isDecimalDigit(ch){return 48<=ch&&ch<=57;}function isHexDigit(ch){return 48<=ch&&ch<=57||97<=ch&&ch<=102||65<=ch&&ch<=70;}function isOctalDigit(ch){return ch>=48&&ch<=55;}NON_ASCII_WHITESPACES=[5760,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8239,8287,12288,65279];function isWhiteSpace(ch){return ch===32||ch===9||ch===11||ch===12||ch===160||ch>=5760&&NON_ASCII_WHITESPACES.indexOf(ch)>=0;}function isLineTerminator(ch){return ch===10||ch===13||ch===8232||ch===8233;}function fromCodePoint(cp){if(cp<=65535){return String.fromCharCode(cp);}var cu1=String.fromCharCode(Math.floor((cp-65536)/1024)+55296);var cu2=String.fromCharCode((cp-65536)%1024+56320);return cu1+cu2;}IDENTIFIER_START=new Array(128);for(ch=0;ch<128;++ch){IDENTIFIER_START[ch]=ch>=97&&ch<=122||ch>=65&&ch<=90||ch===36||ch===95;}IDENTIFIER_PART=new Array(128);for(ch=0;ch<128;++ch){IDENTIFIER_PART[ch]=ch>=97&&ch<=122||ch>=65&&ch<=90||ch>=48&&ch<=57||ch===36||ch===95;}function isIdentifierStartES5(ch){return ch<128?IDENTIFIER_START[ch]:ES5Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch));}function isIdentifierPartES5(ch){return ch<128?IDENTIFIER_PART[ch]:ES5Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch));}function isIdentifierStartES6(ch){return ch<128?IDENTIFIER_START[ch]:ES6Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch));}function isIdentifierPartES6(ch){return ch<128?IDENTIFIER_PART[ch]:ES6Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch));}module.exports={isDecimalDigit:isDecimalDigit,isHexDigit:isHexDigit,isOctalDigit:isOctalDigit,isWhiteSpace:isWhiteSpace,isLineTerminator:isLineTerminator,isIdentifierStartES5:isIdentifierStartES5,isIdentifierPartES5:isIdentifierPartES5,isIdentifierStartES6:isIdentifierStartES6,isIdentifierPartES6:isIdentifierPartES6};}());},{}],58:[function(require,module,exports){(function(){'use strict';var code=require('./code');function isStrictModeReservedWordES6(id){switch(id){case'implements':case'interface':case'package':case'private':case'protected':case'public':case'static':case'let':return true;default:return false;}}function isKeywordES5(id,strict){if(!strict&&id==='yield'){return false;}return isKeywordES6(id,strict);}function isKeywordES6(id,strict){if(strict&&isStrictModeReservedWordES6(id)){return true;}switch(id.length){case 2:return id==='if'||id==='in'||id==='do';case 3:return id==='var'||id==='for'||id==='new'||id==='try';case 4:return id==='this'||id==='else'||id==='case'||id==='void'||id==='with'||id==='enum';case 5:return id==='while'||id==='break'||id==='catch'||id==='throw'||id==='const'||id==='yield'||id==='class'||id==='super';case 6:return id==='return'||id==='typeof'||id==='delete'||id==='switch'||id==='export'||id==='import';case 7:return id==='default'||id==='finally'||id==='extends';case 8:return id==='function'||id==='continue'||id==='debugger';case 10:return id==='instanceof';default:return false;}}function isReservedWordES5(id,strict){return id==='null'||id==='true'||id==='false'||isKeywordES5(id,strict);}function isReservedWordES6(id,strict){return id==='null'||id==='true'||id==='false'||isKeywordES6(id,strict);}function isRestrictedWord(id){return id==='eval'||id==='arguments';}function isIdentifierNameES5(id){var i,iz,ch;if(id.length===0){return false;}ch=id.charCodeAt(0);if(!code.isIdentifierStartES5(ch)){return false;}for(i=1,iz=id.length;i<iz;++i){ch=id.charCodeAt(i);if(!code.isIdentifierPartES5(ch)){return false;}}return true;}function decodeUtf16(lead,trail){return(lead-55296)*1024+(trail-56320)+65536;}function isIdentifierNameES6(id){var i,iz,ch,lowCh,check;if(id.length===0){return false;}check=code.isIdentifierStartES6;for(i=0,iz=id.length;i<iz;++i){ch=id.charCodeAt(i);if(55296<=ch&&ch<=56319){++i;if(i>=iz){return false;}lowCh=id.charCodeAt(i);if(!(56320<=lowCh&&lowCh<=57343)){return false;}ch=decodeUtf16(ch,lowCh);}if(!check(ch)){return false;}check=code.isIdentifierPartES6;}return true;}function isIdentifierES5(id,strict){return isIdentifierNameES5(id)&&!isReservedWordES5(id,strict);}function isIdentifierES6(id,strict){return isIdentifierNameES6(id)&&!isReservedWordES6(id,strict);}module.exports={isKeywordES5:isKeywordES5,isKeywordES6:isKeywordES6,isReservedWordES5:isReservedWordES5,isReservedWordES6:isReservedWordES6,isRestrictedWord:isRestrictedWord,isIdentifierNameES5:isIdentifierNameES5,isIdentifierNameES6:isIdentifierNameES6,isIdentifierES5:isIdentifierES5,isIdentifierES6:isIdentifierES6};}());},{'./code':57}],59:[function(require,module,exports){(function(){'use strict';exports.ast=require('./ast');exports.code=require('./code');exports.keyword=require('./keyword');}());},{'./ast':56,'./code':57,'./keyword':58}],60:[function(require,module,exports){function EventEmitter(){this._events=this._events||{};this._maxListeners=this._maxListeners||undefined;}module.exports=EventEmitter;EventEmitter.EventEmitter=EventEmitter;EventEmitter.prototype._events=undefined;EventEmitter.prototype._maxListeners=undefined;EventEmitter.defaultMaxListeners=10;EventEmitter.prototype.setMaxListeners=function(n){if(!isNumber(n)||n<0||isNaN(n))throw TypeError('n must be a positive number');this._maxListeners=n;return this;};EventEmitter.prototype.emit=function(type){var er,handler,len,args,i,listeners;if(!this._events)this._events={};if(type==='error'){if(!this._events.error||isObject(this._events.error)&&!this._events.error.length){er=arguments[1];if(er instanceof Error){throw er;}else{var err=new Error('Uncaught, unspecified "error" event. ('+er+')');err.context=er;throw err;}}}handler=this._events[type];if(isUndefined(handler))return false;if(isFunction(handler)){switch(arguments.length){case 1:handler.call(this);break;case 2:handler.call(this,arguments[1]);break;case 3:handler.call(this,arguments[1],arguments[2]);break;default:args=Array.prototype.slice.call(arguments,1);handler.apply(this,args);}}else if(isObject(handler)){args=Array.prototype.slice.call(arguments,1);listeners=handler.slice();len=listeners.length;for(i=0;i<len;i++)listeners[i].apply(this,args);}return true;};EventEmitter.prototype.addListener=function(type,listener){var m;if(!isFunction(listener))throw TypeError('listener must be a function');if(!this._events)this._events={};if(this._events.newListener)this.emit('newListener',type,isFunction(listener.listener)?listener.listener:listener);if(!this._events[type])this._events[type]=listener;else if(isObject(this._events[type]))this._events[type].push(listener);else this._events[type]=[this._events[type],listener];if(isObject(this._events[type])&&!this._events[type].warned){if(!isUndefined(this._maxListeners)){m=this._maxListeners;}else{m=EventEmitter.defaultMaxListeners;}if(m&&m>0&&this._events[type].length>m){this._events[type].warned=true;console.error('(node) warning: possible EventEmitter memory '+'leak detected. %d listeners added. '+'Use emitter.setMaxListeners() to increase limit.',this._events[type].length);if(typeof console.trace==='function'){console.trace();}}}return this;};EventEmitter.prototype.on=EventEmitter.prototype.addListener;EventEmitter.prototype.once=function(type,listener){if(!isFunction(listener))throw TypeError('listener must be a function');var fired=false;function g(){this.removeListener(type,g);if(!fired){fired=true;listener.apply(this,arguments);}}g.listener=listener;this.on(type,g);return this;};EventEmitter.prototype.removeListener=function(type,listener){var list,position,length,i;if(!isFunction(listener))throw TypeError('listener must be a function');if(!this._events||!this._events[type])return this;list=this._events[type];length=list.length;position=-1;if(list===listener||isFunction(list.listener)&&list.listener===listener){delete this._events[type];if(this._events.removeListener)this.emit('removeListener',type,listener);}else if(isObject(list)){for(i=length;i-->0;){if(list[i]===listener||list[i].listener&&list[i].listener===listener){position=i;break;}}if(position<0)return this;if(list.length===1){list.length=0;delete this._events[type];}else{list.splice(position,1);}if(this._events.removeListener)this.emit('removeListener',type,listener);}return this;};EventEmitter.prototype.removeAllListeners=function(type){var key,listeners;if(!this._events)return this;if(!this._events.removeListener){if(arguments.length===0)this._events={};else if(this._events[type])delete this._events[type];return this;}if(arguments.length===0){for(key in this._events){if(key==='removeListener')continue;this.removeAllListeners(key);}this.removeAllListeners('removeListener');this._events={};return this;}listeners=this._events[type];if(isFunction(listeners)){this.removeListener(type,listeners);}else if(listeners){while(listeners.length)this.removeListener(type,listeners[listeners.length-1]);}delete this._events[type];return this;};EventEmitter.prototype.listeners=function(type){var ret;if(!this._events||!this._events[type])ret=[];else if(isFunction(this._events[type]))ret=[this._events[type]];else ret=this._events[type].slice();return ret;};EventEmitter.prototype.listenerCount=function(type){if(this._events){var evlistener=this._events[type];if(isFunction(evlistener))return 1;else if(evlistener)return evlistener.length;}return 0;};EventEmitter.listenerCount=function(emitter,type){return emitter.listenerCount(type);};function isFunction(arg){return typeof arg==='function';}function isNumber(arg){return typeof arg==='number';}function isObject(arg){return typeof arg==='object'&&arg!==null;}function isUndefined(arg){return arg===void 0;}},{}],61:[function(require,module,exports){(function(global){(function(){;(function(root){var freeExports=typeof exports=='object'&&exports;var freeModule=typeof module=='object'&&module&&module.exports==freeExports&&module;var freeGlobal=typeof global=='object'&&global;if(freeGlobal.global===freeGlobal||freeGlobal.window===freeGlobal){root=freeGlobal;}var regexAstralSymbols=/[\uD800-\uDBFF][\uDC00-\uDFFF]/g;var regexAsciiWhitelist=/[\x01-\x7F]/g;var regexBmpWhitelist=/[\x01-\t\x0B\f\x0E-\x1F\x7F\x81\x8D\x8F\x90\x9D\xA0-\uFFFF]/g;var regexEncodeNonAscii=/<\u20D2|=\u20E5|>\u20D2|\u205F\u200A|\u219D\u0338|\u2202\u0338|\u2220\u20D2|\u2229\uFE00|\u222A\uFE00|\u223C\u20D2|\u223D\u0331|\u223E\u0333|\u2242\u0338|\u224B\u0338|\u224D\u20D2|\u224E\u0338|\u224F\u0338|\u2250\u0338|\u2261\u20E5|\u2264\u20D2|\u2265\u20D2|\u2266\u0338|\u2267\u0338|\u2268\uFE00|\u2269\uFE00|\u226A\u0338|\u226A\u20D2|\u226B\u0338|\u226B\u20D2|\u227F\u0338|\u2282\u20D2|\u2283\u20D2|\u228A\uFE00|\u228B\uFE00|\u228F\u0338|\u2290\u0338|\u2293\uFE00|\u2294\uFE00|\u22B4\u20D2|\u22B5\u20D2|\u22D8\u0338|\u22D9\u0338|\u22DA\uFE00|\u22DB\uFE00|\u22F5\u0338|\u22F9\u0338|\u2933\u0338|\u29CF\u0338|\u29D0\u0338|\u2A6D\u0338|\u2A70\u0338|\u2A7D\u0338|\u2A7E\u0338|\u2AA1\u0338|\u2AA2\u0338|\u2AAC\uFE00|\u2AAD\uFE00|\u2AAF\u0338|\u2AB0\u0338|\u2AC5\u0338|\u2AC6\u0338|\u2ACB\uFE00|\u2ACC\uFE00|\u2AFD\u20E5|[\xA0-\u0113\u0116-\u0122\u0124-\u012B\u012E-\u014D\u0150-\u017E\u0192\u01B5\u01F5\u0237\u02C6\u02C7\u02D8-\u02DD\u0311\u0391-\u03A1\u03A3-\u03A9\u03B1-\u03C9\u03D1\u03D2\u03D5\u03D6\u03DC\u03DD\u03F0\u03F1\u03F5\u03F6\u0401-\u040C\u040E-\u044F\u0451-\u045C\u045E\u045F\u2002-\u2005\u2007-\u2010\u2013-\u2016\u2018-\u201A\u201C-\u201E\u2020-\u2022\u2025\u2026\u2030-\u2035\u2039\u203A\u203E\u2041\u2043\u2044\u204F\u2057\u205F-\u2063\u20AC\u20DB\u20DC\u2102\u2105\u210A-\u2113\u2115-\u211E\u2122\u2124\u2127-\u2129\u212C\u212D\u212F-\u2131\u2133-\u2138\u2145-\u2148\u2153-\u215E\u2190-\u219B\u219D-\u21A7\u21A9-\u21AE\u21B0-\u21B3\u21B5-\u21B7\u21BA-\u21DB\u21DD\u21E4\u21E5\u21F5\u21FD-\u2205\u2207-\u2209\u220B\u220C\u220F-\u2214\u2216-\u2218\u221A\u221D-\u2238\u223A-\u2257\u2259\u225A\u225C\u225F-\u2262\u2264-\u228B\u228D-\u229B\u229D-\u22A5\u22A7-\u22B0\u22B2-\u22BB\u22BD-\u22DB\u22DE-\u22E3\u22E6-\u22F7\u22F9-\u22FE\u2305\u2306\u2308-\u2310\u2312\u2313\u2315\u2316\u231C-\u231F\u2322\u2323\u232D\u232E\u2336\u233D\u233F\u237C\u23B0\u23B1\u23B4-\u23B6\u23DC-\u23DF\u23E2\u23E7\u2423\u24C8\u2500\u2502\u250C\u2510\u2514\u2518\u251C\u2524\u252C\u2534\u253C\u2550-\u256C\u2580\u2584\u2588\u2591-\u2593\u25A1\u25AA\u25AB\u25AD\u25AE\u25B1\u25B3-\u25B5\u25B8\u25B9\u25BD-\u25BF\u25C2\u25C3\u25CA\u25CB\u25EC\u25EF\u25F8-\u25FC\u2605\u2606\u260E\u2640\u2642\u2660\u2663\u2665\u2666\u266A\u266D-\u266F\u2713\u2717\u2720\u2736\u2758\u2772\u2773\u27C8\u27C9\u27E6-\u27ED\u27F5-\u27FA\u27FC\u27FF\u2902-\u2905\u290C-\u2913\u2916\u2919-\u2920\u2923-\u292A\u2933\u2935-\u2939\u293C\u293D\u2945\u2948-\u294B\u294E-\u2976\u2978\u2979\u297B-\u297F\u2985\u2986\u298B-\u2996\u299A\u299C\u299D\u29A4-\u29B7\u29B9\u29BB\u29BC\u29BE-\u29C5\u29C9\u29CD-\u29D0\u29DC-\u29DE\u29E3-\u29E5\u29EB\u29F4\u29F6\u2A00-\u2A02\u2A04\u2A06\u2A0C\u2A0D\u2A10-\u2A17\u2A22-\u2A27\u2A29\u2A2A\u2A2D-\u2A31\u2A33-\u2A3C\u2A3F\u2A40\u2A42-\u2A4D\u2A50\u2A53-\u2A58\u2A5A-\u2A5D\u2A5F\u2A66\u2A6A\u2A6D-\u2A75\u2A77-\u2A9A\u2A9D-\u2AA2\u2AA4-\u2AB0\u2AB3-\u2AC8\u2ACB\u2ACC\u2ACF-\u2ADB\u2AE4\u2AE6-\u2AE9\u2AEB-\u2AF3\u2AFD\uFB00-\uFB04]|\uD835[\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDCCF\uDD04\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDD6B]/g;var encodeMap={'\xAD':'shy','‌':'zwnj','‍':'zwj','\u200E':'lrm','\u2063':'ic','\u2062':'it','\u2061':'af','\u200F':'rlm','\u200B':'ZeroWidthSpace','\u2060':'NoBreak','̑':'DownBreve','⃛':'tdot','⃜':'DotDot','\t':'Tab','\n':'NewLine','\u2008':'puncsp','\u205F':'MediumSpace','\u2009':'thinsp','\u200A':'hairsp','\u2004':'emsp13','\u2002':'ensp','\u2005':'emsp14','\u2003':'emsp','\u2007':'numsp','\xA0':'nbsp','\u205F\u200A':'ThickSpace','\u203E':'oline','_':'lowbar','\u2010':'dash','\u2013':'ndash','\u2014':'mdash','\u2015':'horbar',',':'comma',';':'semi','\u204F':'bsemi',':':'colon','\u2A74':'Colone','!':'excl','\xA1':'iexcl','?':'quest','\xBF':'iquest','.':'period','\u2025':'nldr','\u2026':'mldr','\xB7':'middot','\'':'apos','\u2018':'lsquo','\u2019':'rsquo','\u201A':'sbquo','\u2039':'lsaquo','\u203A':'rsaquo','"':'quot','\u201C':'ldquo','\u201D':'rdquo','\u201E':'bdquo','\xAB':'laquo','\xBB':'raquo','(':'lpar',')':'rpar','[':'lsqb',']':'rsqb','{':'lcub','}':'rcub','\u2308':'lceil','\u2309':'rceil','\u230A':'lfloor','\u230B':'rfloor','\u2985':'lopar','\u2986':'ropar','\u298B':'lbrke','\u298C':'rbrke','\u298D':'lbrkslu','\u298E':'rbrksld','\u298F':'lbrksld','\u2990':'rbrkslu','\u2991':'langd','\u2992':'rangd','\u2993':'lparlt','\u2994':'rpargt','\u2995':'gtlPar','\u2996':'ltrPar','\u27E6':'lobrk','\u27E7':'robrk','\u27E8':'lang','\u27E9':'rang','\u27EA':'Lang','\u27EB':'Rang','\u27EC':'loang','\u27ED':'roang','\u2772':'lbbrk','\u2773':'rbbrk','\u2016':'Vert','\xA7':'sect','\xB6':'para','@':'commat','*':'ast','/':'sol','undefined':null,'&':'amp','#':'num','%':'percnt','\u2030':'permil','\u2031':'pertenk','\u2020':'dagger','\u2021':'Dagger','\u2022':'bull','\u2043':'hybull','\u2032':'prime','\u2033':'Prime','\u2034':'tprime','\u2057':'qprime','\u2035':'bprime','\u2041':'caret','`':'grave','\xB4':'acute','\u02DC':'tilde','^':'Hat','\xAF':'macr','\u02D8':'breve','\u02D9':'dot','\xA8':'die','\u02DA':'ring','\u02DD':'dblac','\xB8':'cedil','\u02DB':'ogon','ˆ':'circ','ˇ':'caron','\xB0':'deg','\xA9':'copy','\xAE':'reg','\u2117':'copysr','\u2118':'wp','\u211E':'rx','\u2127':'mho','\u2129':'iiota','\u2190':'larr','\u219A':'nlarr','\u2192':'rarr','\u219B':'nrarr','\u2191':'uarr','\u2193':'darr','\u2194':'harr','\u21AE':'nharr','\u2195':'varr','\u2196':'nwarr','\u2197':'nearr','\u2198':'searr','\u2199':'swarr','\u219D':'rarrw','\u219D̸':'nrarrw','\u219E':'Larr','\u219F':'Uarr','\u21A0':'Rarr','\u21A1':'Darr','\u21A2':'larrtl','\u21A3':'rarrtl','\u21A4':'mapstoleft','\u21A5':'mapstoup','\u21A6':'map','\u21A7':'mapstodown','\u21A9':'larrhk','\u21AA':'rarrhk','\u21AB':'larrlp','\u21AC':'rarrlp','\u21AD':'harrw','\u21B0':'lsh','\u21B1':'rsh','\u21B2':'ldsh','\u21B3':'rdsh','\u21B5':'crarr','\u21B6':'cularr','\u21B7':'curarr','\u21BA':'olarr','\u21BB':'orarr','\u21BC':'lharu','\u21BD':'lhard','\u21BE':'uharr','\u21BF':'uharl','\u21C0':'rharu','\u21C1':'rhard','\u21C2':'dharr','\u21C3':'dharl','\u21C4':'rlarr','\u21C5':'udarr','\u21C6':'lrarr','\u21C7':'llarr','\u21C8':'uuarr','\u21C9':'rrarr','\u21CA':'ddarr','\u21CB':'lrhar','\u21CC':'rlhar','\u21D0':'lArr','\u21CD':'nlArr','\u21D1':'uArr','\u21D2':'rArr','\u21CF':'nrArr','\u21D3':'dArr','\u21D4':'iff','\u21CE':'nhArr','\u21D5':'vArr','\u21D6':'nwArr','\u21D7':'neArr','\u21D8':'seArr','\u21D9':'swArr','\u21DA':'lAarr','\u21DB':'rAarr','\u21DD':'zigrarr','\u21E4':'larrb','\u21E5':'rarrb','\u21F5':'duarr','\u21FD':'loarr','\u21FE':'roarr','\u21FF':'hoarr','\u2200':'forall','\u2201':'comp','\u2202':'part','\u2202̸':'npart','\u2203':'exist','\u2204':'nexist','\u2205':'empty','\u2207':'Del','\u2208':'in','\u2209':'notin','\u220B':'ni','\u220C':'notni','\u03F6':'bepsi','\u220F':'prod','\u2210':'coprod','\u2211':'sum','+':'plus','\xB1':'pm','\xF7':'div','\xD7':'times','<':'lt','\u226E':'nlt','<⃒':'nvlt','=':'equals','\u2260':'ne','=⃥':'bne','\u2A75':'Equal','>':'gt','\u226F':'ngt','>⃒':'nvgt','\xAC':'not','|':'vert','\xA6':'brvbar','\u2212':'minus','\u2213':'mp','\u2214':'plusdo','\u2044':'frasl','\u2216':'setmn','\u2217':'lowast','\u2218':'compfn','\u221A':'Sqrt','\u221D':'prop','\u221E':'infin','\u221F':'angrt','\u2220':'ang','\u2220⃒':'nang','\u2221':'angmsd','\u2222':'angsph','\u2223':'mid','\u2224':'nmid','\u2225':'par','\u2226':'npar','\u2227':'and','\u2228':'or','\u2229':'cap','\u2229︀':'caps','\u222A':'cup','\u222A︀':'cups','\u222B':'int','\u222C':'Int','\u222D':'tint','\u2A0C':'qint','\u222E':'oint','\u222F':'Conint','\u2230':'Cconint','\u2231':'cwint','\u2232':'cwconint','\u2233':'awconint','\u2234':'there4','\u2235':'becaus','\u2236':'ratio','\u2237':'Colon','\u2238':'minusd','\u223A':'mDDot','\u223B':'homtht','\u223C':'sim','\u2241':'nsim','\u223C⃒':'nvsim','\u223D':'bsim','\u223Ḏ':'race','\u223E':'ac','\u223E̳':'acE','\u223F':'acd','\u2240':'wr','\u2242':'esim','\u2242̸':'nesim','\u2243':'sime','\u2244':'nsime','\u2245':'cong','\u2247':'ncong','\u2246':'simne','\u2248':'ap','\u2249':'nap','\u224A':'ape','\u224B':'apid','\u224B̸':'napid','\u224C':'bcong','\u224D':'CupCap','\u226D':'NotCupCap','\u224D⃒':'nvap','\u224E':'bump','\u224E̸':'nbump','\u224F':'bumpe','\u224F̸':'nbumpe','\u2250':'doteq','\u2250̸':'nedot','\u2251':'eDot','\u2252':'efDot','\u2253':'erDot','\u2254':'colone','\u2255':'ecolon','\u2256':'ecir','\u2257':'cire','\u2259':'wedgeq','\u225A':'veeeq','\u225C':'trie','\u225F':'equest','\u2261':'equiv','\u2262':'nequiv','\u2261⃥':'bnequiv','\u2264':'le','\u2270':'nle','\u2264⃒':'nvle','\u2265':'ge','\u2271':'nge','\u2265⃒':'nvge','\u2266':'lE','\u2266̸':'nlE','\u2267':'gE','\u2267̸':'ngE','\u2268︀':'lvnE','\u2268':'lnE','\u2269':'gnE','\u2269︀':'gvnE','\u226A':'ll','\u226A̸':'nLtv','\u226A⃒':'nLt','\u226B':'gg','\u226B̸':'nGtv','\u226B⃒':'nGt','\u226C':'twixt','\u2272':'lsim','\u2274':'nlsim','\u2273':'gsim','\u2275':'ngsim','\u2276':'lg','\u2278':'ntlg','\u2277':'gl','\u2279':'ntgl','\u227A':'pr','\u2280':'npr','\u227B':'sc','\u2281':'nsc','\u227C':'prcue','\u22E0':'nprcue','\u227D':'sccue','\u22E1':'nsccue','\u227E':'prsim','\u227F':'scsim','\u227F̸':'NotSucceedsTilde','\u2282':'sub','\u2284':'nsub','\u2282⃒':'vnsub','\u2283':'sup','\u2285':'nsup','\u2283⃒':'vnsup','\u2286':'sube','\u2288':'nsube','\u2287':'supe','\u2289':'nsupe','\u228A︀':'vsubne','\u228A':'subne','\u228B︀':'vsupne','\u228B':'supne','\u228D':'cupdot','\u228E':'uplus','\u228F':'sqsub','\u228F̸':'NotSquareSubset','\u2290':'sqsup','\u2290̸':'NotSquareSuperset','\u2291':'sqsube','\u22E2':'nsqsube','\u2292':'sqsupe','\u22E3':'nsqsupe','\u2293':'sqcap','\u2293︀':'sqcaps','\u2294':'sqcup','\u2294︀':'sqcups','\u2295':'oplus','\u2296':'ominus','\u2297':'otimes','\u2298':'osol','\u2299':'odot','\u229A':'ocir','\u229B':'oast','\u229D':'odash','\u229E':'plusb','\u229F':'minusb','\u22A0':'timesb','\u22A1':'sdotb','\u22A2':'vdash','\u22AC':'nvdash','\u22A3':'dashv','\u22A4':'top','\u22A5':'bot','\u22A7':'models','\u22A8':'vDash','\u22AD':'nvDash','\u22A9':'Vdash','\u22AE':'nVdash','\u22AA':'Vvdash','\u22AB':'VDash','\u22AF':'nVDash','\u22B0':'prurel','\u22B2':'vltri','\u22EA':'nltri','\u22B3':'vrtri','\u22EB':'nrtri','\u22B4':'ltrie','\u22EC':'nltrie','\u22B4⃒':'nvltrie','\u22B5':'rtrie','\u22ED':'nrtrie','\u22B5⃒':'nvrtrie','\u22B6':'origof','\u22B7':'imof','\u22B8':'mumap','\u22B9':'hercon','\u22BA':'intcal','\u22BB':'veebar','\u22BD':'barvee','\u22BE':'angrtvb','\u22BF':'lrtri','\u22C0':'Wedge','\u22C1':'Vee','\u22C2':'xcap','\u22C3':'xcup','\u22C4':'diam','\u22C5':'sdot','\u22C6':'Star','\u22C7':'divonx','\u22C8':'bowtie','\u22C9':'ltimes','\u22CA':'rtimes','\u22CB':'lthree','\u22CC':'rthree','\u22CD':'bsime','\u22CE':'cuvee','\u22CF':'cuwed','\u22D0':'Sub','\u22D1':'Sup','\u22D2':'Cap','\u22D3':'Cup','\u22D4':'fork','\u22D5':'epar','\u22D6':'ltdot','\u22D7':'gtdot','\u22D8':'Ll','\u22D8̸':'nLl','\u22D9':'Gg','\u22D9̸':'nGg','\u22DA︀':'lesg','\u22DA':'leg','\u22DB':'gel','\u22DB︀':'gesl','\u22DE':'cuepr','\u22DF':'cuesc','\u22E6':'lnsim','\u22E7':'gnsim','\u22E8':'prnsim','\u22E9':'scnsim','\u22EE':'vellip','\u22EF':'ctdot','\u22F0':'utdot','\u22F1':'dtdot','\u22F2':'disin','\u22F3':'isinsv','\u22F4':'isins','\u22F5':'isindot','\u22F5̸':'notindot','\u22F6':'notinvc','\u22F7':'notinvb','\u22F9':'isinE','\u22F9̸':'notinE','\u22FA':'nisd','\u22FB':'xnis','\u22FC':'nis','\u22FD':'notnivc','\u22FE':'notnivb','\u2305':'barwed','\u2306':'Barwed','\u230C':'drcrop','\u230D':'dlcrop','\u230E':'urcrop','\u230F':'ulcrop','\u2310':'bnot','\u2312':'profline','\u2313':'profsurf','\u2315':'telrec','\u2316':'target','\u231C':'ulcorn','\u231D':'urcorn','\u231E':'dlcorn','\u231F':'drcorn','\u2322':'frown','\u2323':'smile','\u232D':'cylcty','\u232E':'profalar','\u2336':'topbot','\u233D':'ovbar','\u233F':'solbar','\u237C':'angzarr','\u23B0':'lmoust','\u23B1':'rmoust','\u23B4':'tbrk','\u23B5':'bbrk','\u23B6':'bbrktbrk','\u23DC':'OverParenthesis','\u23DD':'UnderParenthesis','\u23DE':'OverBrace','\u23DF':'UnderBrace','\u23E2':'trpezium','\u23E7':'elinters','\u2423':'blank','\u2500':'boxh','\u2502':'boxv','\u250C':'boxdr','\u2510':'boxdl','\u2514':'boxur','\u2518':'boxul','\u251C':'boxvr','\u2524':'boxvl','\u252C':'boxhd','\u2534':'boxhu','\u253C':'boxvh','\u2550':'boxH','\u2551':'boxV','\u2552':'boxdR','\u2553':'boxDr','\u2554':'boxDR','\u2555':'boxdL','\u2556':'boxDl','\u2557':'boxDL','\u2558':'boxuR','\u2559':'boxUr','\u255A':'boxUR','\u255B':'boxuL','\u255C':'boxUl','\u255D':'boxUL','\u255E':'boxvR','\u255F':'boxVr','\u2560':'boxVR','\u2561':'boxvL','\u2562':'boxVl','\u2563':'boxVL','\u2564':'boxHd','\u2565':'boxhD','\u2566':'boxHD','\u2567':'boxHu','\u2568':'boxhU','\u2569':'boxHU','\u256A':'boxvH','\u256B':'boxVh','\u256C':'boxVH','\u2580':'uhblk','\u2584':'lhblk','\u2588':'block','\u2591':'blk14','\u2592':'blk12','\u2593':'blk34','\u25A1':'squ','\u25AA':'squf','\u25AB':'EmptyVerySmallSquare','\u25AD':'rect','\u25AE':'marker','\u25B1':'fltns','\u25B3':'xutri','\u25B4':'utrif','\u25B5':'utri','\u25B8':'rtrif','\u25B9':'rtri','\u25BD':'xdtri','\u25BE':'dtrif','\u25BF':'dtri','\u25C2':'ltrif','\u25C3':'ltri','\u25CA':'loz','\u25CB':'cir','\u25EC':'tridot','\u25EF':'xcirc','\u25F8':'ultri','\u25F9':'urtri','\u25FA':'lltri','\u25FB':'EmptySmallSquare','\u25FC':'FilledSmallSquare','\u2605':'starf','\u2606':'star','\u260E':'phone','\u2640':'female','\u2642':'male','\u2660':'spades','\u2663':'clubs','\u2665':'hearts','\u2666':'diams','\u266A':'sung','\u2713':'check','\u2717':'cross','\u2720':'malt','\u2736':'sext','\u2758':'VerticalSeparator','\u27C8':'bsolhsub','\u27C9':'suphsol','\u27F5':'xlarr','\u27F6':'xrarr','\u27F7':'xharr','\u27F8':'xlArr','\u27F9':'xrArr','\u27FA':'xhArr','\u27FC':'xmap','\u27FF':'dzigrarr','\u2902':'nvlArr','\u2903':'nvrArr','\u2904':'nvHarr','\u2905':'Map','\u290C':'lbarr','\u290D':'rbarr','\u290E':'lBarr','\u290F':'rBarr','\u2910':'RBarr','\u2911':'DDotrahd','\u2912':'UpArrowBar','\u2913':'DownArrowBar','\u2916':'Rarrtl','\u2919':'latail','\u291A':'ratail','\u291B':'lAtail','\u291C':'rAtail','\u291D':'larrfs','\u291E':'rarrfs','\u291F':'larrbfs','\u2920':'rarrbfs','\u2923':'nwarhk','\u2924':'nearhk','\u2925':'searhk','\u2926':'swarhk','\u2927':'nwnear','\u2928':'toea','\u2929':'tosa','\u292A':'swnwar','\u2933':'rarrc','\u2933̸':'nrarrc','\u2935':'cudarrr','\u2936':'ldca','\u2937':'rdca','\u2938':'cudarrl','\u2939':'larrpl','\u293C':'curarrm','\u293D':'cularrp','\u2945':'rarrpl','\u2948':'harrcir','\u2949':'Uarrocir','\u294A':'lurdshar','\u294B':'ldrushar','\u294E':'LeftRightVector','\u294F':'RightUpDownVector','\u2950':'DownLeftRightVector','\u2951':'LeftUpDownVector','\u2952':'LeftVectorBar','\u2953':'RightVectorBar','\u2954':'RightUpVectorBar','\u2955':'RightDownVectorBar','\u2956':'DownLeftVectorBar','\u2957':'DownRightVectorBar','\u2958':'LeftUpVectorBar','\u2959':'LeftDownVectorBar','\u295A':'LeftTeeVector','\u295B':'RightTeeVector','\u295C':'RightUpTeeVector','\u295D':'RightDownTeeVector','\u295E':'DownLeftTeeVector','\u295F':'DownRightTeeVector','\u2960':'LeftUpTeeVector','\u2961':'LeftDownTeeVector','\u2962':'lHar','\u2963':'uHar','\u2964':'rHar','\u2965':'dHar','\u2966':'luruhar','\u2967':'ldrdhar','\u2968':'ruluhar','\u2969':'rdldhar','\u296A':'lharul','\u296B':'llhard','\u296C':'rharul','\u296D':'lrhard','\u296E':'udhar','\u296F':'duhar','\u2970':'RoundImplies','\u2971':'erarr','\u2972':'simrarr','\u2973':'larrsim','\u2974':'rarrsim','\u2975':'rarrap','\u2976':'ltlarr','\u2978':'gtrarr','\u2979':'subrarr','\u297B':'suplarr','\u297C':'lfisht','\u297D':'rfisht','\u297E':'ufisht','\u297F':'dfisht','\u299A':'vzigzag','\u299C':'vangrt','\u299D':'angrtvbd','\u29A4':'ange','\u29A5':'range','\u29A6':'dwangle','\u29A7':'uwangle','\u29A8':'angmsdaa','\u29A9':'angmsdab','\u29AA':'angmsdac','\u29AB':'angmsdad','\u29AC':'angmsdae','\u29AD':'angmsdaf','\u29AE':'angmsdag','\u29AF':'angmsdah','\u29B0':'bemptyv','\u29B1':'demptyv','\u29B2':'cemptyv','\u29B3':'raemptyv','\u29B4':'laemptyv','\u29B5':'ohbar','\u29B6':'omid','\u29B7':'opar','\u29B9':'operp','\u29BB':'olcross','\u29BC':'odsold','\u29BE':'olcir','\u29BF':'ofcir','\u29C0':'olt','\u29C1':'ogt','\u29C2':'cirscir','\u29C3':'cirE','\u29C4':'solb','\u29C5':'bsolb','\u29C9':'boxbox','\u29CD':'trisb','\u29CE':'rtriltri','\u29CF':'LeftTriangleBar','\u29CF̸':'NotLeftTriangleBar','\u29D0':'RightTriangleBar','\u29D0̸':'NotRightTriangleBar','\u29DC':'iinfin','\u29DD':'infintie','\u29DE':'nvinfin','\u29E3':'eparsl','\u29E4':'smeparsl','\u29E5':'eqvparsl','\u29EB':'lozf','\u29F4':'RuleDelayed','\u29F6':'dsol','\u2A00':'xodot','\u2A01':'xoplus','\u2A02':'xotime','\u2A04':'xuplus','\u2A06':'xsqcup','\u2A0D':'fpartint','\u2A10':'cirfnint','\u2A11':'awint','\u2A12':'rppolint','\u2A13':'scpolint','\u2A14':'npolint','\u2A15':'pointint','\u2A16':'quatint','\u2A17':'intlarhk','\u2A22':'pluscir','\u2A23':'plusacir','\u2A24':'simplus','\u2A25':'plusdu','\u2A26':'plussim','\u2A27':'plustwo','\u2A29':'mcomma','\u2A2A':'minusdu','\u2A2D':'loplus','\u2A2E':'roplus','\u2A2F':'Cross','\u2A30':'timesd','\u2A31':'timesbar','\u2A33':'smashp','\u2A34':'lotimes','\u2A35':'rotimes','\u2A36':'otimesas','\u2A37':'Otimes','\u2A38':'odiv','\u2A39':'triplus','\u2A3A':'triminus','\u2A3B':'tritime','\u2A3C':'iprod','\u2A3F':'amalg','\u2A40':'capdot','\u2A42':'ncup','\u2A43':'ncap','\u2A44':'capand','\u2A45':'cupor','\u2A46':'cupcap','\u2A47':'capcup','\u2A48':'cupbrcap','\u2A49':'capbrcup','\u2A4A':'cupcup','\u2A4B':'capcap','\u2A4C':'ccups','\u2A4D':'ccaps','\u2A50':'ccupssm','\u2A53':'And','\u2A54':'Or','\u2A55':'andand','\u2A56':'oror','\u2A57':'orslope','\u2A58':'andslope','\u2A5A':'andv','\u2A5B':'orv','\u2A5C':'andd','\u2A5D':'ord','\u2A5F':'wedbar','\u2A66':'sdote','\u2A6A':'simdot','\u2A6D':'congdot','\u2A6D̸':'ncongdot','\u2A6E':'easter','\u2A6F':'apacir','\u2A70':'apE','\u2A70̸':'napE','\u2A71':'eplus','\u2A72':'pluse','\u2A73':'Esim','\u2A77':'eDDot','\u2A78':'equivDD','\u2A79':'ltcir','\u2A7A':'gtcir','\u2A7B':'ltquest','\u2A7C':'gtquest','\u2A7D':'les','\u2A7D̸':'nles','\u2A7E':'ges','\u2A7E̸':'nges','\u2A7F':'lesdot','\u2A80':'gesdot','\u2A81':'lesdoto','\u2A82':'gesdoto','\u2A83':'lesdotor','\u2A84':'gesdotol','\u2A85':'lap','\u2A86':'gap','\u2A87':'lne','\u2A88':'gne','\u2A89':'lnap','\u2A8A':'gnap','\u2A8B':'lEg','\u2A8C':'gEl','\u2A8D':'lsime','\u2A8E':'gsime','\u2A8F':'lsimg','\u2A90':'gsiml','\u2A91':'lgE','\u2A92':'glE','\u2A93':'lesges','\u2A94':'gesles','\u2A95':'els','\u2A96':'egs','\u2A97':'elsdot','\u2A98':'egsdot','\u2A99':'el','\u2A9A':'eg','\u2A9D':'siml','\u2A9E':'simg','\u2A9F':'simlE','\u2AA0':'simgE','\u2AA1':'LessLess','\u2AA1̸':'NotNestedLessLess','\u2AA2':'GreaterGreater','\u2AA2̸':'NotNestedGreaterGreater','\u2AA4':'glj','\u2AA5':'gla','\u2AA6':'ltcc','\u2AA7':'gtcc','\u2AA8':'lescc','\u2AA9':'gescc','\u2AAA':'smt','\u2AAB':'lat','\u2AAC':'smte','\u2AAC︀':'smtes','\u2AAD':'late','\u2AAD︀':'lates','\u2AAE':'bumpE','\u2AAF':'pre','\u2AAF̸':'npre','\u2AB0':'sce','\u2AB0̸':'nsce','\u2AB3':'prE','\u2AB4':'scE','\u2AB5':'prnE','\u2AB6':'scnE','\u2AB7':'prap','\u2AB8':'scap','\u2AB9':'prnap','\u2ABA':'scnap','\u2ABB':'Pr','\u2ABC':'Sc','\u2ABD':'subdot','\u2ABE':'supdot','\u2ABF':'subplus','\u2AC0':'supplus','\u2AC1':'submult','\u2AC2':'supmult','\u2AC3':'subedot','\u2AC4':'supedot','\u2AC5':'subE','\u2AC5̸':'nsubE','\u2AC6':'supE','\u2AC6̸':'nsupE','\u2AC7':'subsim','\u2AC8':'supsim','\u2ACB︀':'vsubnE','\u2ACB':'subnE','\u2ACC︀':'vsupnE','\u2ACC':'supnE','\u2ACF':'csub','\u2AD0':'csup','\u2AD1':'csube','\u2AD2':'csupe','\u2AD3':'subsup','\u2AD4':'supsub','\u2AD5':'subsub','\u2AD6':'supsup','\u2AD7':'suphsub','\u2AD8':'supdsub','\u2AD9':'forkv','\u2ADA':'topfork','\u2ADB':'mlcp','\u2AE4':'Dashv','\u2AE6':'Vdashl','\u2AE7':'Barv','\u2AE8':'vBar','\u2AE9':'vBarv','\u2AEB':'Vbar','\u2AEC':'Not','\u2AED':'bNot','\u2AEE':'rnmid','\u2AEF':'cirmid','\u2AF0':'midcir','\u2AF1':'topcir','\u2AF2':'nhpar','\u2AF3':'parsim','\u2AFD':'parsl','\u2AFD⃥':'nparsl','\u266D':'flat','\u266E':'natur','\u266F':'sharp','\xA4':'curren','\xA2':'cent','$':'dollar','\xA3':'pound','\xA5':'yen','\u20AC':'euro','\xB9':'sup1','\xBD':'half','\u2153':'frac13','\xBC':'frac14','\u2155':'frac15','\u2159':'frac16','\u215B':'frac18','\xB2':'sup2','\u2154':'frac23','\u2156':'frac25','\xB3':'sup3','\xBE':'frac34','\u2157':'frac35','\u215C':'frac38','\u2158':'frac45','\u215A':'frac56','\u215D':'frac58','\u215E':'frac78','\uD835\uDCB6':'ascr','\uD835\uDD52':'aopf','\uD835\uDD1E':'afr','\uD835\uDD38':'Aopf','\uD835\uDD04':'Afr','\uD835\uDC9C':'Ascr','ª':'ordf','á':'aacute','Á':'Aacute','à':'agrave','À':'Agrave','ă':'abreve','Ă':'Abreve','â':'acirc','Â':'Acirc','å':'aring','Å':'angst','ä':'auml','Ä':'Auml','ã':'atilde','Ã':'Atilde','ą':'aogon','Ą':'Aogon','ā':'amacr','Ā':'Amacr','æ':'aelig','Æ':'AElig','\uD835\uDCB7':'bscr','\uD835\uDD53':'bopf','\uD835\uDD1F':'bfr','\uD835\uDD39':'Bopf','ℬ':'Bscr','\uD835\uDD05':'Bfr','\uD835\uDD20':'cfr','\uD835\uDCB8':'cscr','\uD835\uDD54':'copf','ℭ':'Cfr','\uD835\uDC9E':'Cscr','ℂ':'Copf','ć':'cacute','Ć':'Cacute','ĉ':'ccirc','Ĉ':'Ccirc','č':'ccaron','Č':'Ccaron','ċ':'cdot','Ċ':'Cdot','ç':'ccedil','Ç':'Ccedil','\u2105':'incare','\uD835\uDD21':'dfr','ⅆ':'dd','\uD835\uDD55':'dopf','\uD835\uDCB9':'dscr','\uD835\uDC9F':'Dscr','\uD835\uDD07':'Dfr','ⅅ':'DD','\uD835\uDD3B':'Dopf','ď':'dcaron','Ď':'Dcaron','đ':'dstrok','Đ':'Dstrok','ð':'eth','Ð':'ETH','ⅇ':'ee','ℯ':'escr','\uD835\uDD22':'efr','\uD835\uDD56':'eopf','ℰ':'Escr','\uD835\uDD08':'Efr','\uD835\uDD3C':'Eopf','é':'eacute','É':'Eacute','è':'egrave','È':'Egrave','ê':'ecirc','Ê':'Ecirc','ě':'ecaron','Ě':'Ecaron','ë':'euml','Ë':'Euml','ė':'edot','Ė':'Edot','ę':'eogon','Ę':'Eogon','ē':'emacr','Ē':'Emacr','\uD835\uDD23':'ffr','\uD835\uDD57':'fopf','\uD835\uDCBB':'fscr','\uD835\uDD09':'Ffr','\uD835\uDD3D':'Fopf','ℱ':'Fscr','ﬀ':'fflig','ﬃ':'ffilig','ﬄ':'ffllig','ﬁ':'filig','fj':'fjlig','ﬂ':'fllig','ƒ':'fnof','ℊ':'gscr','\uD835\uDD58':'gopf','\uD835\uDD24':'gfr','\uD835\uDCA2':'Gscr','\uD835\uDD3E':'Gopf','\uD835\uDD0A':'Gfr','ǵ':'gacute','ğ':'gbreve','Ğ':'Gbreve','ĝ':'gcirc','Ĝ':'Gcirc','ġ':'gdot','Ġ':'Gdot','Ģ':'Gcedil','\uD835\uDD25':'hfr','ℎ':'planckh','\uD835\uDCBD':'hscr','\uD835\uDD59':'hopf','ℋ':'Hscr','ℌ':'Hfr','ℍ':'Hopf','ĥ':'hcirc','Ĥ':'Hcirc','ℏ':'hbar','ħ':'hstrok','Ħ':'Hstrok','\uD835\uDD5A':'iopf','\uD835\uDD26':'ifr','\uD835\uDCBE':'iscr','ⅈ':'ii','\uD835\uDD40':'Iopf','ℐ':'Iscr','ℑ':'Im','í':'iacute','Í':'Iacute','ì':'igrave','Ì':'Igrave','î':'icirc','Î':'Icirc','ï':'iuml','Ï':'Iuml','ĩ':'itilde','Ĩ':'Itilde','İ':'Idot','į':'iogon','Į':'Iogon','ī':'imacr','Ī':'Imacr','ĳ':'ijlig','Ĳ':'IJlig','ı':'imath','\uD835\uDCBF':'jscr','\uD835\uDD5B':'jopf','\uD835\uDD27':'jfr','\uD835\uDCA5':'Jscr','\uD835\uDD0D':'Jfr','\uD835\uDD41':'Jopf','ĵ':'jcirc','Ĵ':'Jcirc','ȷ':'jmath','\uD835\uDD5C':'kopf','\uD835\uDCC0':'kscr','\uD835\uDD28':'kfr','\uD835\uDCA6':'Kscr','\uD835\uDD42':'Kopf','\uD835\uDD0E':'Kfr','ķ':'kcedil','Ķ':'Kcedil','\uD835\uDD29':'lfr','\uD835\uDCC1':'lscr','ℓ':'ell','\uD835\uDD5D':'lopf','ℒ':'Lscr','\uD835\uDD0F':'Lfr','\uD835\uDD43':'Lopf','ĺ':'lacute','Ĺ':'Lacute','ľ':'lcaron','Ľ':'Lcaron','ļ':'lcedil','Ļ':'Lcedil','ł':'lstrok','Ł':'Lstrok','ŀ':'lmidot','Ŀ':'Lmidot','\uD835\uDD2A':'mfr','\uD835\uDD5E':'mopf','\uD835\uDCC2':'mscr','\uD835\uDD10':'Mfr','\uD835\uDD44':'Mopf','ℳ':'Mscr','\uD835\uDD2B':'nfr','\uD835\uDD5F':'nopf','\uD835\uDCC3':'nscr','ℕ':'Nopf','\uD835\uDCA9':'Nscr','\uD835\uDD11':'Nfr','ń':'nacute','Ń':'Nacute','ň':'ncaron','Ň':'Ncaron','ñ':'ntilde','Ñ':'Ntilde','ņ':'ncedil','Ņ':'Ncedil','\u2116':'numero','ŋ':'eng','Ŋ':'ENG','\uD835\uDD60':'oopf','\uD835\uDD2C':'ofr','ℴ':'oscr','\uD835\uDCAA':'Oscr','\uD835\uDD12':'Ofr','\uD835\uDD46':'Oopf','º':'ordm','ó':'oacute','Ó':'Oacute','ò':'ograve','Ò':'Ograve','ô':'ocirc','Ô':'Ocirc','ö':'ouml','Ö':'Ouml','ő':'odblac','Ő':'Odblac','õ':'otilde','Õ':'Otilde','ø':'oslash','Ø':'Oslash','ō':'omacr','Ō':'Omacr','œ':'oelig','Œ':'OElig','\uD835\uDD2D':'pfr','\uD835\uDCC5':'pscr','\uD835\uDD61':'popf','ℙ':'Popf','\uD835\uDD13':'Pfr','\uD835\uDCAB':'Pscr','\uD835\uDD62':'qopf','\uD835\uDD2E':'qfr','\uD835\uDCC6':'qscr','\uD835\uDCAC':'Qscr','\uD835\uDD14':'Qfr','ℚ':'Qopf','ĸ':'kgreen','\uD835\uDD2F':'rfr','\uD835\uDD63':'ropf','\uD835\uDCC7':'rscr','ℛ':'Rscr','ℜ':'Re','ℝ':'Ropf','ŕ':'racute','Ŕ':'Racute','ř':'rcaron','Ř':'Rcaron','ŗ':'rcedil','Ŗ':'Rcedil','\uD835\uDD64':'sopf','\uD835\uDCC8':'sscr','\uD835\uDD30':'sfr','\uD835\uDD4A':'Sopf','\uD835\uDD16':'Sfr','\uD835\uDCAE':'Sscr','\u24C8':'oS','ś':'sacute','Ś':'Sacute','ŝ':'scirc','Ŝ':'Scirc','š':'scaron','Š':'Scaron','ş':'scedil','Ş':'Scedil','ß':'szlig','\uD835\uDD31':'tfr','\uD835\uDCC9':'tscr','\uD835\uDD65':'topf','\uD835\uDCAF':'Tscr','\uD835\uDD17':'Tfr','\uD835\uDD4B':'Topf','ť':'tcaron','Ť':'Tcaron','ţ':'tcedil','Ţ':'Tcedil','\u2122':'trade','ŧ':'tstrok','Ŧ':'Tstrok','\uD835\uDCCA':'uscr','\uD835\uDD66':'uopf','\uD835\uDD32':'ufr','\uD835\uDD4C':'Uopf','\uD835\uDD18':'Ufr','\uD835\uDCB0':'Uscr','ú':'uacute','Ú':'Uacute','ù':'ugrave','Ù':'Ugrave','ŭ':'ubreve','Ŭ':'Ubreve','û':'ucirc','Û':'Ucirc','ů':'uring','Ů':'Uring','ü':'uuml','Ü':'Uuml','ű':'udblac','Ű':'Udblac','ũ':'utilde','Ũ':'Utilde','ų':'uogon','Ų':'Uogon','ū':'umacr','Ū':'Umacr','\uD835\uDD33':'vfr','\uD835\uDD67':'vopf','\uD835\uDCCB':'vscr','\uD835\uDD19':'Vfr','\uD835\uDD4D':'Vopf','\uD835\uDCB1':'Vscr','\uD835\uDD68':'wopf','\uD835\uDCCC':'wscr','\uD835\uDD34':'wfr','\uD835\uDCB2':'Wscr','\uD835\uDD4E':'Wopf','\uD835\uDD1A':'Wfr','ŵ':'wcirc','Ŵ':'Wcirc','\uD835\uDD35':'xfr','\uD835\uDCCD':'xscr','\uD835\uDD69':'xopf','\uD835\uDD4F':'Xopf','\uD835\uDD1B':'Xfr','\uD835\uDCB3':'Xscr','\uD835\uDD36':'yfr','\uD835\uDCCE':'yscr','\uD835\uDD6A':'yopf','\uD835\uDCB4':'Yscr','\uD835\uDD1C':'Yfr','\uD835\uDD50':'Yopf','ý':'yacute','Ý':'Yacute','ŷ':'ycirc','Ŷ':'Ycirc','ÿ':'yuml','Ÿ':'Yuml','\uD835\uDCCF':'zscr','\uD835\uDD37':'zfr','\uD835\uDD6B':'zopf','ℨ':'Zfr','ℤ':'Zopf','\uD835\uDCB5':'Zscr','ź':'zacute','Ź':'Zacute','ž':'zcaron','Ž':'Zcaron','ż':'zdot','Ż':'Zdot','Ƶ':'imped','þ':'thorn','Þ':'THORN','ŉ':'napos','α':'alpha','Α':'Alpha','β':'beta','Β':'Beta','γ':'gamma','Γ':'Gamma','δ':'delta','Δ':'Delta','ε':'epsi','ϵ':'epsiv','Ε':'Epsilon','ϝ':'gammad','Ϝ':'Gammad','ζ':'zeta','Ζ':'Zeta','η':'eta','Η':'Eta','θ':'theta','ϑ':'thetav','Θ':'Theta','ι':'iota','Ι':'Iota','κ':'kappa','ϰ':'kappav','Κ':'Kappa','λ':'lambda','Λ':'Lambda','μ':'mu','µ':'micro','Μ':'Mu','ν':'nu','Ν':'Nu','ξ':'xi','Ξ':'Xi','ο':'omicron','Ο':'Omicron','π':'pi','ϖ':'piv','Π':'Pi','ρ':'rho','ϱ':'rhov','Ρ':'Rho','σ':'sigma','Σ':'Sigma','ς':'sigmaf','τ':'tau','Τ':'Tau','υ':'upsi','Υ':'Upsilon','ϒ':'Upsi','φ':'phi','ϕ':'phiv','Φ':'Phi','χ':'chi','Χ':'Chi','ψ':'psi','Ψ':'Psi','ω':'omega','Ω':'ohm','а':'acy','А':'Acy','б':'bcy','Б':'Bcy','в':'vcy','В':'Vcy','г':'gcy','Г':'Gcy','ѓ':'gjcy','Ѓ':'GJcy','д':'dcy','Д':'Dcy','ђ':'djcy','Ђ':'DJcy','е':'iecy','Е':'IEcy','ё':'iocy','Ё':'IOcy','є':'jukcy','Є':'Jukcy','ж':'zhcy','Ж':'ZHcy','з':'zcy','З':'Zcy','ѕ':'dscy','Ѕ':'DScy','и':'icy','И':'Icy','і':'iukcy','І':'Iukcy','ї':'yicy','Ї':'YIcy','й':'jcy','Й':'Jcy','ј':'jsercy','Ј':'Jsercy','к':'kcy','К':'Kcy','ќ':'kjcy','Ќ':'KJcy','л':'lcy','Л':'Lcy','љ':'ljcy','Љ':'LJcy','м':'mcy','М':'Mcy','н':'ncy','Н':'Ncy','њ':'njcy','Њ':'NJcy','о':'ocy','О':'Ocy','п':'pcy','П':'Pcy','р':'rcy','Р':'Rcy','с':'scy','С':'Scy','т':'tcy','Т':'Tcy','ћ':'tshcy','Ћ':'TSHcy','у':'ucy','У':'Ucy','ў':'ubrcy','Ў':'Ubrcy','ф':'fcy','Ф':'Fcy','х':'khcy','Х':'KHcy','ц':'tscy','Ц':'TScy','ч':'chcy','Ч':'CHcy','џ':'dzcy','Џ':'DZcy','ш':'shcy','Ш':'SHcy','щ':'shchcy','Щ':'SHCHcy','ъ':'hardcy','Ъ':'HARDcy','ы':'ycy','Ы':'Ycy','ь':'softcy','Ь':'SOFTcy','э':'ecy','Э':'Ecy','ю':'yucy','Ю':'YUcy','я':'yacy','Я':'YAcy','ℵ':'aleph','ℶ':'beth','ℷ':'gimel','ℸ':'daleth'};var regexEscape=/["&'<>`]/g;var escapeMap={'"':'&quot;','&':'&amp;','\'':'&#x27;','<':'&lt;','>':'&gt;','`':'&#x60;'};var regexInvalidEntity=/&#(?:[xX][^a-fA-F0-9]|[^0-9xX])/;var regexInvalidRawCodePoint=/[\0-\x08\x0B\x0E-\x1F\x7F-\x9F\uFDD0-\uFDEF\uFFFE\uFFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F\uDBBF\uDBFF][\uDFFE\uDFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;var regexDecode=/&(CounterClockwiseContourIntegral|DoubleLongLeftRightArrow|ClockwiseContourIntegral|NotNestedGreaterGreater|NotSquareSupersetEqual|DiacriticalDoubleAcute|NotRightTriangleEqual|NotSucceedsSlantEqual|NotPrecedesSlantEqual|CloseCurlyDoubleQuote|NegativeVeryThinSpace|DoubleContourIntegral|FilledVerySmallSquare|CapitalDifferentialD|OpenCurlyDoubleQuote|EmptyVerySmallSquare|NestedGreaterGreater|DoubleLongRightArrow|NotLeftTriangleEqual|NotGreaterSlantEqual|ReverseUpEquilibrium|DoubleLeftRightArrow|NotSquareSubsetEqual|NotDoubleVerticalBar|RightArrowLeftArrow|NotGreaterFullEqual|NotRightTriangleBar|SquareSupersetEqual|DownLeftRightVector|DoubleLongLeftArrow|leftrightsquigarrow|LeftArrowRightArrow|NegativeMediumSpace|blacktriangleright|RightDownVectorBar|PrecedesSlantEqual|RightDoubleBracket|SucceedsSlantEqual|NotLeftTriangleBar|RightTriangleEqual|SquareIntersection|RightDownTeeVector|ReverseEquilibrium|NegativeThickSpace|longleftrightarrow|Longleftrightarrow|LongLeftRightArrow|DownRightTeeVector|DownRightVectorBar|GreaterSlantEqual|SquareSubsetEqual|LeftDownVectorBar|LeftDoubleBracket|VerticalSeparator|rightleftharpoons|NotGreaterGreater|NotSquareSuperset|blacktriangleleft|blacktriangledown|NegativeThinSpace|LeftDownTeeVector|NotLessSlantEqual|leftrightharpoons|DoubleUpDownArrow|DoubleVerticalBar|LeftTriangleEqual|FilledSmallSquare|twoheadrightarrow|NotNestedLessLess|DownLeftTeeVector|DownLeftVectorBar|RightAngleBracket|NotTildeFullEqual|NotReverseElement|RightUpDownVector|DiacriticalTilde|NotSucceedsTilde|circlearrowright|NotPrecedesEqual|rightharpoondown|DoubleRightArrow|NotSucceedsEqual|NonBreakingSpace|NotRightTriangle|LessEqualGreater|RightUpTeeVector|LeftAngleBracket|GreaterFullEqual|DownArrowUpArrow|RightUpVectorBar|twoheadleftarrow|GreaterEqualLess|downharpoonright|RightTriangleBar|ntrianglerighteq|NotSupersetEqual|LeftUpDownVector|DiacriticalAcute|rightrightarrows|vartriangleright|UpArrowDownArrow|DiacriticalGrave|UnderParenthesis|EmptySmallSquare|LeftUpVectorBar|leftrightarrows|DownRightVector|downharpoonleft|trianglerighteq|ShortRightArrow|OverParenthesis|DoubleLeftArrow|DoubleDownArrow|NotSquareSubset|bigtriangledown|ntrianglelefteq|UpperRightArrow|curvearrowright|vartriangleleft|NotLeftTriangle|nleftrightarrow|LowerRightArrow|NotHumpDownHump|NotGreaterTilde|rightthreetimes|LeftUpTeeVector|NotGreaterEqual|straightepsilon|LeftTriangleBar|rightsquigarrow|ContourIntegral|rightleftarrows|CloseCurlyQuote|RightDownVector|LeftRightVector|nLeftrightarrow|leftharpoondown|circlearrowleft|SquareSuperset|OpenCurlyQuote|hookrightarrow|HorizontalLine|DiacriticalDot|NotLessGreater|ntriangleright|DoubleRightTee|InvisibleComma|InvisibleTimes|LowerLeftArrow|DownLeftVector|NotSubsetEqual|curvearrowleft|trianglelefteq|NotVerticalBar|TildeFullEqual|downdownarrows|NotGreaterLess|RightTeeVector|ZeroWidthSpace|looparrowright|LongRightArrow|doublebarwedge|ShortLeftArrow|ShortDownArrow|RightVectorBar|GreaterGreater|ReverseElement|rightharpoonup|LessSlantEqual|leftthreetimes|upharpoonright|rightarrowtail|LeftDownVector|Longrightarrow|NestedLessLess|UpperLeftArrow|nshortparallel|leftleftarrows|leftrightarrow|Leftrightarrow|LeftRightArrow|longrightarrow|upharpoonleft|RightArrowBar|ApplyFunction|LeftTeeVector|leftarrowtail|NotEqualTilde|varsubsetneqq|varsupsetneqq|RightTeeArrow|SucceedsEqual|SucceedsTilde|LeftVectorBar|SupersetEqual|hookleftarrow|DifferentialD|VerticalTilde|VeryThinSpace|blacktriangle|bigtriangleup|LessFullEqual|divideontimes|leftharpoonup|UpEquilibrium|ntriangleleft|RightTriangle|measuredangle|shortparallel|longleftarrow|Longleftarrow|LongLeftArrow|DoubleLeftTee|Poincareplane|PrecedesEqual|triangleright|DoubleUpArrow|RightUpVector|fallingdotseq|looparrowleft|PrecedesTilde|NotTildeEqual|NotTildeTilde|smallsetminus|Proportional|triangleleft|triangledown|UnderBracket|NotHumpEqual|exponentiale|ExponentialE|NotLessTilde|HilbertSpace|RightCeiling|blacklozenge|varsupsetneq|HumpDownHump|GreaterEqual|VerticalLine|LeftTeeArrow|NotLessEqual|DownTeeArrow|LeftTriangle|varsubsetneq|Intersection|NotCongruent|DownArrowBar|LeftUpVector|LeftArrowBar|risingdotseq|GreaterTilde|RoundImplies|SquareSubset|ShortUpArrow|NotSuperset|quaternions|precnapprox|backepsilon|preccurlyeq|OverBracket|blacksquare|MediumSpace|VerticalBar|circledcirc|circleddash|CircleMinus|CircleTimes|LessGreater|curlyeqprec|curlyeqsucc|diamondsuit|UpDownArrow|Updownarrow|RuleDelayed|Rrightarrow|updownarrow|RightVector|nRightarrow|nrightarrow|eqslantless|LeftCeiling|Equilibrium|SmallCircle|expectation|NotSucceeds|thickapprox|GreaterLess|SquareUnion|NotPrecedes|NotLessLess|straightphi|succnapprox|succcurlyeq|SubsetEqual|sqsupseteq|Proportion|Laplacetrf|ImaginaryI|supsetneqq|NotGreater|gtreqqless|NotElement|ThickSpace|TildeEqual|TildeTilde|Fouriertrf|rmoustache|EqualTilde|eqslantgtr|UnderBrace|LeftVector|UpArrowBar|nLeftarrow|nsubseteqq|subsetneqq|nsupseteqq|nleftarrow|succapprox|lessapprox|UpTeeArrow|upuparrows|curlywedge|lesseqqgtr|varepsilon|varnothing|RightFloor|complement|CirclePlus|sqsubseteq|Lleftarrow|circledast|RightArrow|Rightarrow|rightarrow|lmoustache|Bernoullis|precapprox|mapstoleft|mapstodown|longmapsto|dotsquare|downarrow|DoubleDot|nsubseteq|supsetneq|leftarrow|nsupseteq|subsetneq|ThinSpace|ngeqslant|subseteqq|HumpEqual|NotSubset|triangleq|NotCupCap|lesseqgtr|heartsuit|TripleDot|Leftarrow|Coproduct|Congruent|varpropto|complexes|gvertneqq|LeftArrow|LessTilde|supseteqq|MinusPlus|CircleDot|nleqslant|NotExists|gtreqless|nparallel|UnionPlus|LeftFloor|checkmark|CenterDot|centerdot|Mellintrf|gtrapprox|bigotimes|OverBrace|spadesuit|therefore|pitchfork|rationals|PlusMinus|Backslash|Therefore|DownBreve|backsimeq|backprime|DownArrow|nshortmid|Downarrow|lvertneqq|eqvparsl|imagline|imagpart|infintie|integers|Integral|intercal|LessLess|Uarrocir|intlarhk|sqsupset|angmsdaf|sqsubset|llcorner|vartheta|cupbrcap|lnapprox|Superset|SuchThat|succnsim|succneqq|angmsdag|biguplus|curlyvee|trpezium|Succeeds|NotTilde|bigwedge|angmsdah|angrtvbd|triminus|cwconint|fpartint|lrcorner|smeparsl|subseteq|urcorner|lurdshar|laemptyv|DDotrahd|approxeq|ldrushar|awconint|mapstoup|backcong|shortmid|triangle|geqslant|gesdotol|timesbar|circledR|circledS|setminus|multimap|naturals|scpolint|ncongdot|RightTee|boxminus|gnapprox|boxtimes|andslope|thicksim|angmsdaa|varsigma|cirfnint|rtriltri|angmsdab|rppolint|angmsdac|barwedge|drbkarow|clubsuit|thetasym|bsolhsub|capbrcup|dzigrarr|doteqdot|DotEqual|dotminus|UnderBar|NotEqual|realpart|otimesas|ulcorner|hksearow|hkswarow|parallel|PartialD|elinters|emptyset|plusacir|bbrktbrk|angmsdad|pointint|bigoplus|angmsdae|Precedes|bigsqcup|varkappa|notindot|supseteq|precneqq|precnsim|profalar|profline|profsurf|leqslant|lesdotor|raemptyv|subplus|notnivb|notnivc|subrarr|zigrarr|vzigzag|submult|subedot|Element|between|cirscir|larrbfs|larrsim|lotimes|lbrksld|lbrkslu|lozenge|ldrdhar|dbkarow|bigcirc|epsilon|simrarr|simplus|ltquest|Epsilon|luruhar|gtquest|maltese|npolint|eqcolon|npreceq|bigodot|ddagger|gtrless|bnequiv|harrcir|ddotseq|equivDD|backsim|demptyv|nsqsube|nsqsupe|Upsilon|nsubset|upsilon|minusdu|nsucceq|swarrow|nsupset|coloneq|searrow|boxplus|napprox|natural|asympeq|alefsym|congdot|nearrow|bigstar|diamond|supplus|tritime|LeftTee|nvinfin|triplus|NewLine|nvltrie|nvrtrie|nwarrow|nexists|Diamond|ruluhar|Implies|supmult|angzarr|suplarr|suphsub|questeq|because|digamma|Because|olcross|bemptyv|omicron|Omicron|rotimes|NoBreak|intprod|angrtvb|orderof|uwangle|suphsol|lesdoto|orslope|DownTee|realine|cudarrl|rdldhar|OverBar|supedot|lessdot|supdsub|topfork|succsim|rbrkslu|rbrksld|pertenk|cudarrr|isindot|planckh|lessgtr|pluscir|gesdoto|plussim|plustwo|lesssim|cularrp|rarrsim|Cayleys|notinva|notinvb|notinvc|UpArrow|Uparrow|uparrow|NotLess|dwangle|precsim|Product|curarrm|Cconint|dotplus|rarrbfs|ccupssm|Cedilla|cemptyv|notniva|quatint|frac35|frac38|frac45|frac56|frac58|frac78|tridot|xoplus|gacute|gammad|Gammad|lfisht|lfloor|bigcup|sqsupe|gbreve|Gbreve|lharul|sqsube|sqcups|Gcedil|apacir|llhard|lmidot|Lmidot|lmoust|andand|sqcaps|approx|Abreve|spades|circeq|tprime|divide|topcir|Assign|topbot|gesdot|divonx|xuplus|timesd|gesles|atilde|solbar|SOFTcy|loplus|timesb|lowast|lowbar|dlcorn|dlcrop|softcy|dollar|lparlt|thksim|lrhard|Atilde|lsaquo|smashp|bigvee|thinsp|wreath|bkarow|lsquor|lstrok|Lstrok|lthree|ltimes|ltlarr|DotDot|simdot|ltrPar|weierp|xsqcup|angmsd|sigmav|sigmaf|zeetrf|Zcaron|zcaron|mapsto|vsupne|thetav|cirmid|marker|mcomma|Zacute|vsubnE|there4|gtlPar|vsubne|bottom|gtrarr|SHCHcy|shchcy|midast|midcir|middot|minusb|minusd|gtrdot|bowtie|sfrown|mnplus|models|colone|seswar|Colone|mstpos|searhk|gtrsim|nacute|Nacute|boxbox|telrec|hairsp|Tcedil|nbumpe|scnsim|ncaron|Ncaron|ncedil|Ncedil|hamilt|Scedil|nearhk|hardcy|HARDcy|tcedil|Tcaron|commat|nequiv|nesear|tcaron|target|hearts|nexist|varrho|scedil|Scaron|scaron|hellip|Sacute|sacute|hercon|swnwar|compfn|rtimes|rthree|rsquor|rsaquo|zacute|wedgeq|homtht|barvee|barwed|Barwed|rpargt|horbar|conint|swarhk|roplus|nltrie|hslash|hstrok|Hstrok|rmoust|Conint|bprime|hybull|hyphen|iacute|Iacute|supsup|supsub|supsim|varphi|coprod|brvbar|agrave|Supset|supset|igrave|Igrave|notinE|Agrave|iiiint|iinfin|copysr|wedbar|Verbar|vangrt|becaus|incare|verbar|inodot|bullet|drcorn|intcal|drcrop|cularr|vellip|Utilde|bumpeq|cupcap|dstrok|Dstrok|CupCap|cupcup|cupdot|eacute|Eacute|supdot|iquest|easter|ecaron|Ecaron|ecolon|isinsv|utilde|itilde|Itilde|curarr|succeq|Bumpeq|cacute|ulcrop|nparsl|Cacute|nprcue|egrave|Egrave|nrarrc|nrarrw|subsup|subsub|nrtrie|jsercy|nsccue|Jsercy|kappav|kcedil|Kcedil|subsim|ulcorn|nsimeq|egsdot|veebar|kgreen|capand|elsdot|Subset|subset|curren|aacute|lacute|Lacute|emptyv|ntilde|Ntilde|lagran|lambda|Lambda|capcap|Ugrave|langle|subdot|emsp13|numero|emsp14|nvdash|nvDash|nVdash|nVDash|ugrave|ufisht|nvHarr|larrfs|nvlArr|larrhk|larrlp|larrpl|nvrArr|Udblac|nwarhk|larrtl|nwnear|oacute|Oacute|latail|lAtail|sstarf|lbrace|odblac|Odblac|lbrack|udblac|odsold|eparsl|lcaron|Lcaron|ograve|Ograve|lcedil|Lcedil|Aacute|ssmile|ssetmn|squarf|ldquor|capcup|ominus|cylcty|rharul|eqcirc|dagger|rfloor|rfisht|Dagger|daleth|equals|origof|capdot|equest|dcaron|Dcaron|rdquor|oslash|Oslash|otilde|Otilde|otimes|Otimes|urcrop|Ubreve|ubreve|Yacute|Uacute|uacute|Rcedil|rcedil|urcorn|parsim|Rcaron|Vdashl|rcaron|Tstrok|percnt|period|permil|Exists|yacute|rbrack|rbrace|phmmat|ccaron|Ccaron|planck|ccedil|plankv|tstrok|female|plusdo|plusdu|ffilig|plusmn|ffllig|Ccedil|rAtail|dfisht|bernou|ratail|Rarrtl|rarrtl|angsph|rarrpl|rarrlp|rarrhk|xwedge|xotime|forall|ForAll|Vvdash|vsupnE|preceq|bigcap|frac12|frac13|frac14|primes|rarrfs|prnsim|frac15|Square|frac16|square|lesdot|frac18|frac23|propto|prurel|rarrap|rangle|puncsp|frac25|Racute|qprime|racute|lesges|frac34|abreve|AElig|eqsim|utdot|setmn|urtri|Equal|Uring|seArr|uring|searr|dashv|Dashv|mumap|nabla|iogon|Iogon|sdote|sdotb|scsim|napid|napos|equiv|natur|Acirc|dblac|erarr|nbump|iprod|erDot|ucirc|awint|esdot|angrt|ncong|isinE|scnap|Scirc|scirc|ndash|isins|Ubrcy|nearr|neArr|isinv|nedot|ubrcy|acute|Ycirc|iukcy|Iukcy|xutri|nesim|caret|jcirc|Jcirc|caron|twixt|ddarr|sccue|exist|jmath|sbquo|ngeqq|angst|ccaps|lceil|ngsim|UpTee|delta|Delta|rtrif|nharr|nhArr|nhpar|rtrie|jukcy|Jukcy|kappa|rsquo|Kappa|nlarr|nlArr|TSHcy|rrarr|aogon|Aogon|fflig|xrarr|tshcy|ccirc|nleqq|filig|upsih|nless|dharl|nlsim|fjlig|ropar|nltri|dharr|robrk|roarr|fllig|fltns|roang|rnmid|subnE|subne|lAarr|trisb|Ccirc|acirc|ccups|blank|VDash|forkv|Vdash|langd|cedil|blk12|blk14|laquo|strns|diams|notin|vDash|larrb|blk34|block|disin|uplus|vdash|vBarv|aelig|starf|Wedge|check|xrArr|lates|lbarr|lBarr|notni|lbbrk|bcong|frasl|lbrke|frown|vrtri|vprop|vnsup|gamma|Gamma|wedge|xodot|bdquo|srarr|doteq|ldquo|boxdl|boxdL|gcirc|Gcirc|boxDl|boxDL|boxdr|boxdR|boxDr|TRADE|trade|rlhar|boxDR|vnsub|npart|vltri|rlarr|boxhd|boxhD|nprec|gescc|nrarr|nrArr|boxHd|boxHD|boxhu|boxhU|nrtri|boxHu|clubs|boxHU|times|colon|Colon|gimel|xlArr|Tilde|nsime|tilde|nsmid|nspar|THORN|thorn|xlarr|nsube|nsubE|thkap|xhArr|comma|nsucc|boxul|boxuL|nsupe|nsupE|gneqq|gnsim|boxUl|boxUL|grave|boxur|boxuR|boxUr|boxUR|lescc|angle|bepsi|boxvh|varpi|boxvH|numsp|Theta|gsime|gsiml|theta|boxVh|boxVH|boxvl|gtcir|gtdot|boxvL|boxVl|boxVL|crarr|cross|Cross|nvsim|boxvr|nwarr|nwArr|sqsup|dtdot|Uogon|lhard|lharu|dtrif|ocirc|Ocirc|lhblk|duarr|odash|sqsub|Hacek|sqcup|llarr|duhar|oelig|OElig|ofcir|boxvR|uogon|lltri|boxVr|csube|uuarr|ohbar|csupe|ctdot|olarr|olcir|harrw|oline|sqcap|omacr|Omacr|omega|Omega|boxVR|aleph|lneqq|lnsim|loang|loarr|rharu|lobrk|hcirc|operp|oplus|rhard|Hcirc|orarr|Union|order|ecirc|Ecirc|cuepr|szlig|cuesc|breve|reals|eDDot|Breve|hoarr|lopar|utrif|rdquo|Umacr|umacr|efDot|swArr|ultri|alpha|rceil|ovbar|swarr|Wcirc|wcirc|smtes|smile|bsemi|lrarr|aring|parsl|lrhar|bsime|uhblk|lrtri|cupor|Aring|uharr|uharl|slarr|rbrke|bsolb|lsime|rbbrk|RBarr|lsimg|phone|rBarr|rbarr|icirc|lsquo|Icirc|emacr|Emacr|ratio|simne|plusb|simlE|simgE|simeq|pluse|ltcir|ltdot|empty|xharr|xdtri|iexcl|Alpha|ltrie|rarrw|pound|ltrif|xcirc|bumpe|prcue|bumpE|asymp|amacr|cuvee|Sigma|sigma|iiint|udhar|iiota|ijlig|IJlig|supnE|imacr|Imacr|prime|Prime|image|prnap|eogon|Eogon|rarrc|mdash|mDDot|cuwed|imath|supne|imped|Amacr|udarr|prsim|micro|rarrb|cwint|raquo|infin|eplus|range|rangd|Ucirc|radic|minus|amalg|veeeq|rAarr|epsiv|ycirc|quest|sharp|quot|zwnj|Qscr|race|qscr|Qopf|qopf|qint|rang|Rang|Zscr|zscr|Zopf|zopf|rarr|rArr|Rarr|Pscr|pscr|prop|prod|prnE|prec|ZHcy|zhcy|prap|Zeta|zeta|Popf|popf|Zdot|plus|zdot|Yuml|yuml|phiv|YUcy|yucy|Yscr|yscr|perp|Yopf|yopf|part|para|YIcy|Ouml|rcub|yicy|YAcy|rdca|ouml|osol|Oscr|rdsh|yacy|real|oscr|xvee|andd|rect|andv|Xscr|oror|ordm|ordf|xscr|ange|aopf|Aopf|rHar|Xopf|opar|Oopf|xopf|xnis|rhov|oopf|omid|xmap|oint|apid|apos|ogon|ascr|Ascr|odot|odiv|xcup|xcap|ocir|oast|nvlt|nvle|nvgt|nvge|nvap|Wscr|wscr|auml|ntlg|ntgl|nsup|nsub|nsim|Nscr|nscr|nsce|Wopf|ring|npre|wopf|npar|Auml|Barv|bbrk|Nopf|nopf|nmid|nLtv|beta|ropf|Ropf|Beta|beth|nles|rpar|nleq|bnot|bNot|nldr|NJcy|rscr|Rscr|Vscr|vscr|rsqb|njcy|bopf|nisd|Bopf|rtri|Vopf|nGtv|ngtr|vopf|boxh|boxH|boxv|nges|ngeq|boxV|bscr|scap|Bscr|bsim|Vert|vert|bsol|bull|bump|caps|cdot|ncup|scnE|ncap|nbsp|napE|Cdot|cent|sdot|Vbar|nang|vBar|chcy|Mscr|mscr|sect|semi|CHcy|Mopf|mopf|sext|circ|cire|mldr|mlcp|cirE|comp|shcy|SHcy|vArr|varr|cong|copf|Copf|copy|COPY|malt|male|macr|lvnE|cscr|ltri|sime|ltcc|simg|Cscr|siml|csub|Uuml|lsqb|lsim|uuml|csup|Lscr|lscr|utri|smid|lpar|cups|smte|lozf|darr|Lopf|Uscr|solb|lopf|sopf|Sopf|lneq|uscr|spar|dArr|lnap|Darr|dash|Sqrt|LJcy|ljcy|lHar|dHar|Upsi|upsi|diam|lesg|djcy|DJcy|leqq|dopf|Dopf|dscr|Dscr|dscy|ldsh|ldca|squf|DScy|sscr|Sscr|dsol|lcub|late|star|Star|Uopf|Larr|lArr|larr|uopf|dtri|dzcy|sube|subE|Lang|lang|Kscr|kscr|Kopf|kopf|KJcy|kjcy|KHcy|khcy|DZcy|ecir|edot|eDot|Jscr|jscr|succ|Jopf|jopf|Edot|uHar|emsp|ensp|Iuml|iuml|eopf|isin|Iscr|iscr|Eopf|epar|sung|epsi|escr|sup1|sup2|sup3|Iota|iota|supe|supE|Iopf|iopf|IOcy|iocy|Escr|esim|Esim|imof|Uarr|QUOT|uArr|uarr|euml|IEcy|iecy|Idot|Euml|euro|excl|Hscr|hscr|Hopf|hopf|TScy|tscy|Tscr|hbar|tscr|flat|tbrk|fnof|hArr|harr|half|fopf|Fopf|tdot|gvnE|fork|trie|gtcc|fscr|Fscr|gdot|gsim|Gscr|gscr|Gopf|gopf|gneq|Gdot|tosa|gnap|Topf|topf|geqq|toea|GJcy|gjcy|tint|gesl|mid|Sfr|ggg|top|ges|gla|glE|glj|geq|gne|gEl|gel|gnE|Gcy|gcy|gap|Tfr|tfr|Tcy|tcy|Hat|Tau|Ffr|tau|Tab|hfr|Hfr|ffr|Fcy|fcy|icy|Icy|iff|ETH|eth|ifr|Ifr|Eta|eta|int|Int|Sup|sup|ucy|Ucy|Sum|sum|jcy|ENG|ufr|Ufr|eng|Jcy|jfr|els|ell|egs|Efr|efr|Jfr|uml|kcy|Kcy|Ecy|ecy|kfr|Kfr|lap|Sub|sub|lat|lcy|Lcy|leg|Dot|dot|lEg|leq|les|squ|div|die|lfr|Lfr|lgE|Dfr|dfr|Del|deg|Dcy|dcy|lne|lnE|sol|loz|smt|Cup|lrm|cup|lsh|Lsh|sim|shy|map|Map|mcy|Mcy|mfr|Mfr|mho|gfr|Gfr|sfr|cir|Chi|chi|nap|Cfr|vcy|Vcy|cfr|Scy|scy|ncy|Ncy|vee|Vee|Cap|cap|nfr|scE|sce|Nfr|nge|ngE|nGg|vfr|Vfr|ngt|bot|nGt|nis|niv|Rsh|rsh|nle|nlE|bne|Bfr|bfr|nLl|nlt|nLt|Bcy|bcy|not|Not|rlm|wfr|Wfr|npr|nsc|num|ocy|ast|Ocy|ofr|xfr|Xfr|Ofr|ogt|ohm|apE|olt|Rho|ape|rho|Rfr|rfr|ord|REG|ang|reg|orv|And|and|AMP|Rcy|amp|Afr|ycy|Ycy|yen|yfr|Yfr|rcy|par|pcy|Pcy|pfr|Pfr|phi|Phi|afr|Acy|acy|zcy|Zcy|piv|acE|acd|zfr|Zfr|pre|prE|psi|Psi|qfr|Qfr|zwj|Or|ge|Gg|gt|gg|el|oS|lt|Lt|LT|Re|lg|gl|eg|ne|Im|it|le|DD|wp|wr|nu|Nu|dd|lE|Sc|sc|pi|Pi|ee|af|ll|Ll|rx|gE|xi|pm|Xi|ic|pr|Pr|in|ni|mp|mu|ac|Mu|or|ap|Gt|GT|ii);|&(Aacute|Agrave|Atilde|Ccedil|Eacute|Egrave|Iacute|Igrave|Ntilde|Oacute|Ograve|Oslash|Otilde|Uacute|Ugrave|Yacute|aacute|agrave|atilde|brvbar|ccedil|curren|divide|eacute|egrave|frac12|frac14|frac34|iacute|igrave|iquest|middot|ntilde|oacute|ograve|oslash|otilde|plusmn|uacute|ugrave|yacute|AElig|Acirc|Aring|Ecirc|Icirc|Ocirc|THORN|Ucirc|acirc|acute|aelig|aring|cedil|ecirc|icirc|iexcl|laquo|micro|ocirc|pound|raquo|szlig|thorn|times|ucirc|Auml|COPY|Euml|Iuml|Ouml|QUOT|Uuml|auml|cent|copy|euml|iuml|macr|nbsp|ordf|ordm|ouml|para|quot|sect|sup1|sup2|sup3|uuml|yuml|AMP|ETH|REG|amp|deg|eth|not|reg|shy|uml|yen|GT|LT|gt|lt)(?!;)([=a-zA-Z0-9]?)|&#([0-9]+)(;?)|&#[xX]([a-fA-F0-9]+)(;?)|&([0-9a-zA-Z]+)/g;var decodeMap={'aacute':'á','Aacute':'Á','abreve':'ă','Abreve':'Ă','ac':'\u223E','acd':'\u223F','acE':'\u223E̳','acirc':'â','Acirc':'Â','acute':'\xB4','acy':'а','Acy':'А','aelig':'æ','AElig':'Æ','af':'\u2061','afr':'\uD835\uDD1E','Afr':'\uD835\uDD04','agrave':'à','Agrave':'À','alefsym':'ℵ','aleph':'ℵ','alpha':'α','Alpha':'Α','amacr':'ā','Amacr':'Ā','amalg':'\u2A3F','amp':'&','AMP':'&','and':'\u2227','And':'\u2A53','andand':'\u2A55','andd':'\u2A5C','andslope':'\u2A58','andv':'\u2A5A','ang':'\u2220','ange':'\u29A4','angle':'\u2220','angmsd':'\u2221','angmsdaa':'\u29A8','angmsdab':'\u29A9','angmsdac':'\u29AA','angmsdad':'\u29AB','angmsdae':'\u29AC','angmsdaf':'\u29AD','angmsdag':'\u29AE','angmsdah':'\u29AF','angrt':'\u221F','angrtvb':'\u22BE','angrtvbd':'\u299D','angsph':'\u2222','angst':'Å','angzarr':'\u237C','aogon':'ą','Aogon':'Ą','aopf':'\uD835\uDD52','Aopf':'\uD835\uDD38','ap':'\u2248','apacir':'\u2A6F','ape':'\u224A','apE':'\u2A70','apid':'\u224B','apos':'\'','ApplyFunction':'\u2061','approx':'\u2248','approxeq':'\u224A','aring':'å','Aring':'Å','ascr':'\uD835\uDCB6','Ascr':'\uD835\uDC9C','Assign':'\u2254','ast':'*','asymp':'\u2248','asympeq':'\u224D','atilde':'ã','Atilde':'Ã','auml':'ä','Auml':'Ä','awconint':'\u2233','awint':'\u2A11','backcong':'\u224C','backepsilon':'\u03F6','backprime':'\u2035','backsim':'\u223D','backsimeq':'\u22CD','Backslash':'\u2216','Barv':'\u2AE7','barvee':'\u22BD','barwed':'\u2305','Barwed':'\u2306','barwedge':'\u2305','bbrk':'\u23B5','bbrktbrk':'\u23B6','bcong':'\u224C','bcy':'б','Bcy':'Б','bdquo':'\u201E','becaus':'\u2235','because':'\u2235','Because':'\u2235','bemptyv':'\u29B0','bepsi':'\u03F6','bernou':'ℬ','Bernoullis':'ℬ','beta':'β','Beta':'Β','beth':'ℶ','between':'\u226C','bfr':'\uD835\uDD1F','Bfr':'\uD835\uDD05','bigcap':'\u22C2','bigcirc':'\u25EF','bigcup':'\u22C3','bigodot':'\u2A00','bigoplus':'\u2A01','bigotimes':'\u2A02','bigsqcup':'\u2A06','bigstar':'\u2605','bigtriangledown':'\u25BD','bigtriangleup':'\u25B3','biguplus':'\u2A04','bigvee':'\u22C1','bigwedge':'\u22C0','bkarow':'\u290D','blacklozenge':'\u29EB','blacksquare':'\u25AA','blacktriangle':'\u25B4','blacktriangledown':'\u25BE','blacktriangleleft':'\u25C2','blacktriangleright':'\u25B8','blank':'\u2423','blk12':'\u2592','blk14':'\u2591','blk34':'\u2593','block':'\u2588','bne':'=⃥','bnequiv':'\u2261⃥','bnot':'\u2310','bNot':'\u2AED','bopf':'\uD835\uDD53','Bopf':'\uD835\uDD39','bot':'\u22A5','bottom':'\u22A5','bowtie':'\u22C8','boxbox':'\u29C9','boxdl':'\u2510','boxdL':'\u2555','boxDl':'\u2556','boxDL':'\u2557','boxdr':'\u250C','boxdR':'\u2552','boxDr':'\u2553','boxDR':'\u2554','boxh':'\u2500','boxH':'\u2550','boxhd':'\u252C','boxhD':'\u2565','boxHd':'\u2564','boxHD':'\u2566','boxhu':'\u2534','boxhU':'\u2568','boxHu':'\u2567','boxHU':'\u2569','boxminus':'\u229F','boxplus':'\u229E','boxtimes':'\u22A0','boxul':'\u2518','boxuL':'\u255B','boxUl':'\u255C','boxUL':'\u255D','boxur':'\u2514','boxuR':'\u2558','boxUr':'\u2559','boxUR':'\u255A','boxv':'\u2502','boxV':'\u2551','boxvh':'\u253C','boxvH':'\u256A','boxVh':'\u256B','boxVH':'\u256C','boxvl':'\u2524','boxvL':'\u2561','boxVl':'\u2562','boxVL':'\u2563','boxvr':'\u251C','boxvR':'\u255E','boxVr':'\u255F','boxVR':'\u2560','bprime':'\u2035','breve':'\u02D8','Breve':'\u02D8','brvbar':'\xA6','bscr':'\uD835\uDCB7','Bscr':'ℬ','bsemi':'\u204F','bsim':'\u223D','bsime':'\u22CD','bsol':'\\','bsolb':'\u29C5','bsolhsub':'\u27C8','bull':'\u2022','bullet':'\u2022','bump':'\u224E','bumpe':'\u224F','bumpE':'\u2AAE','bumpeq':'\u224F','Bumpeq':'\u224E','cacute':'ć','Cacute':'Ć','cap':'\u2229','Cap':'\u22D2','capand':'\u2A44','capbrcup':'\u2A49','capcap':'\u2A4B','capcup':'\u2A47','capdot':'\u2A40','CapitalDifferentialD':'ⅅ','caps':'\u2229︀','caret':'\u2041','caron':'ˇ','Cayleys':'ℭ','ccaps':'\u2A4D','ccaron':'č','Ccaron':'Č','ccedil':'ç','Ccedil':'Ç','ccirc':'ĉ','Ccirc':'Ĉ','Cconint':'\u2230','ccups':'\u2A4C','ccupssm':'\u2A50','cdot':'ċ','Cdot':'Ċ','cedil':'\xB8','Cedilla':'\xB8','cemptyv':'\u29B2','cent':'\xA2','centerdot':'\xB7','CenterDot':'\xB7','cfr':'\uD835\uDD20','Cfr':'ℭ','chcy':'ч','CHcy':'Ч','check':'\u2713','checkmark':'\u2713','chi':'χ','Chi':'Χ','cir':'\u25CB','circ':'ˆ','circeq':'\u2257','circlearrowleft':'\u21BA','circlearrowright':'\u21BB','circledast':'\u229B','circledcirc':'\u229A','circleddash':'\u229D','CircleDot':'\u2299','circledR':'\xAE','circledS':'\u24C8','CircleMinus':'\u2296','CirclePlus':'\u2295','CircleTimes':'\u2297','cire':'\u2257','cirE':'\u29C3','cirfnint':'\u2A10','cirmid':'\u2AEF','cirscir':'\u29C2','ClockwiseContourIntegral':'\u2232','CloseCurlyDoubleQuote':'\u201D','CloseCurlyQuote':'\u2019','clubs':'\u2663','clubsuit':'\u2663','colon':':','Colon':'\u2237','colone':'\u2254','Colone':'\u2A74','coloneq':'\u2254','comma':',','commat':'@','comp':'\u2201','compfn':'\u2218','complement':'\u2201','complexes':'ℂ','cong':'\u2245','congdot':'\u2A6D','Congruent':'\u2261','conint':'\u222E','Conint':'\u222F','ContourIntegral':'\u222E','copf':'\uD835\uDD54','Copf':'ℂ','coprod':'\u2210','Coproduct':'\u2210','copy':'\xA9','COPY':'\xA9','copysr':'\u2117','CounterClockwiseContourIntegral':'\u2233','crarr':'\u21B5','cross':'\u2717','Cross':'\u2A2F','cscr':'\uD835\uDCB8','Cscr':'\uD835\uDC9E','csub':'\u2ACF','csube':'\u2AD1','csup':'\u2AD0','csupe':'\u2AD2','ctdot':'\u22EF','cudarrl':'\u2938','cudarrr':'\u2935','cuepr':'\u22DE','cuesc':'\u22DF','cularr':'\u21B6','cularrp':'\u293D','cup':'\u222A','Cup':'\u22D3','cupbrcap':'\u2A48','cupcap':'\u2A46','CupCap':'\u224D','cupcup':'\u2A4A','cupdot':'\u228D','cupor':'\u2A45','cups':'\u222A︀','curarr':'\u21B7','curarrm':'\u293C','curlyeqprec':'\u22DE','curlyeqsucc':'\u22DF','curlyvee':'\u22CE','curlywedge':'\u22CF','curren':'\xA4','curvearrowleft':'\u21B6','curvearrowright':'\u21B7','cuvee':'\u22CE','cuwed':'\u22CF','cwconint':'\u2232','cwint':'\u2231','cylcty':'\u232D','dagger':'\u2020','Dagger':'\u2021','daleth':'ℸ','darr':'\u2193','dArr':'\u21D3','Darr':'\u21A1','dash':'\u2010','dashv':'\u22A3','Dashv':'\u2AE4','dbkarow':'\u290F','dblac':'\u02DD','dcaron':'ď','Dcaron':'Ď','dcy':'д','Dcy':'Д','dd':'ⅆ','DD':'ⅅ','ddagger':'\u2021','ddarr':'\u21CA','DDotrahd':'\u2911','ddotseq':'\u2A77','deg':'\xB0','Del':'\u2207','delta':'δ','Delta':'Δ','demptyv':'\u29B1','dfisht':'\u297F','dfr':'\uD835\uDD21','Dfr':'\uD835\uDD07','dHar':'\u2965','dharl':'\u21C3','dharr':'\u21C2','DiacriticalAcute':'\xB4','DiacriticalDot':'\u02D9','DiacriticalDoubleAcute':'\u02DD','DiacriticalGrave':'`','DiacriticalTilde':'\u02DC','diam':'\u22C4','diamond':'\u22C4','Diamond':'\u22C4','diamondsuit':'\u2666','diams':'\u2666','die':'\xA8','DifferentialD':'ⅆ','digamma':'ϝ','disin':'\u22F2','div':'\xF7','divide':'\xF7','divideontimes':'\u22C7','divonx':'\u22C7','djcy':'ђ','DJcy':'Ђ','dlcorn':'\u231E','dlcrop':'\u230D','dollar':'$','dopf':'\uD835\uDD55','Dopf':'\uD835\uDD3B','dot':'\u02D9','Dot':'\xA8','DotDot':'⃜','doteq':'\u2250','doteqdot':'\u2251','DotEqual':'\u2250','dotminus':'\u2238','dotplus':'\u2214','dotsquare':'\u22A1','doublebarwedge':'\u2306','DoubleContourIntegral':'\u222F','DoubleDot':'\xA8','DoubleDownArrow':'\u21D3','DoubleLeftArrow':'\u21D0','DoubleLeftRightArrow':'\u21D4','DoubleLeftTee':'\u2AE4','DoubleLongLeftArrow':'\u27F8','DoubleLongLeftRightArrow':'\u27FA','DoubleLongRightArrow':'\u27F9','DoubleRightArrow':'\u21D2','DoubleRightTee':'\u22A8','DoubleUpArrow':'\u21D1','DoubleUpDownArrow':'\u21D5','DoubleVerticalBar':'\u2225','downarrow':'\u2193','Downarrow':'\u21D3','DownArrow':'\u2193','DownArrowBar':'\u2913','DownArrowUpArrow':'\u21F5','DownBreve':'̑','downdownarrows':'\u21CA','downharpoonleft':'\u21C3','downharpoonright':'\u21C2','DownLeftRightVector':'\u2950','DownLeftTeeVector':'\u295E','DownLeftVector':'\u21BD','DownLeftVectorBar':'\u2956','DownRightTeeVector':'\u295F','DownRightVector':'\u21C1','DownRightVectorBar':'\u2957','DownTee':'\u22A4','DownTeeArrow':'\u21A7','drbkarow':'\u2910','drcorn':'\u231F','drcrop':'\u230C','dscr':'\uD835\uDCB9','Dscr':'\uD835\uDC9F','dscy':'ѕ','DScy':'Ѕ','dsol':'\u29F6','dstrok':'đ','Dstrok':'Đ','dtdot':'\u22F1','dtri':'\u25BF','dtrif':'\u25BE','duarr':'\u21F5','duhar':'\u296F','dwangle':'\u29A6','dzcy':'џ','DZcy':'Џ','dzigrarr':'\u27FF','eacute':'é','Eacute':'É','easter':'\u2A6E','ecaron':'ě','Ecaron':'Ě','ecir':'\u2256','ecirc':'ê','Ecirc':'Ê','ecolon':'\u2255','ecy':'э','Ecy':'Э','eDDot':'\u2A77','edot':'ė','eDot':'\u2251','Edot':'Ė','ee':'ⅇ','efDot':'\u2252','efr':'\uD835\uDD22','Efr':'\uD835\uDD08','eg':'\u2A9A','egrave':'è','Egrave':'È','egs':'\u2A96','egsdot':'\u2A98','el':'\u2A99','Element':'\u2208','elinters':'\u23E7','ell':'ℓ','els':'\u2A95','elsdot':'\u2A97','emacr':'ē','Emacr':'Ē','empty':'\u2205','emptyset':'\u2205','EmptySmallSquare':'\u25FB','emptyv':'\u2205','EmptyVerySmallSquare':'\u25AB','emsp':'\u2003','emsp13':'\u2004','emsp14':'\u2005','eng':'ŋ','ENG':'Ŋ','ensp':'\u2002','eogon':'ę','Eogon':'Ę','eopf':'\uD835\uDD56','Eopf':'\uD835\uDD3C','epar':'\u22D5','eparsl':'\u29E3','eplus':'\u2A71','epsi':'ε','epsilon':'ε','Epsilon':'Ε','epsiv':'ϵ','eqcirc':'\u2256','eqcolon':'\u2255','eqsim':'\u2242','eqslantgtr':'\u2A96','eqslantless':'\u2A95','Equal':'\u2A75','equals':'=','EqualTilde':'\u2242','equest':'\u225F','Equilibrium':'\u21CC','equiv':'\u2261','equivDD':'\u2A78','eqvparsl':'\u29E5','erarr':'\u2971','erDot':'\u2253','escr':'ℯ','Escr':'ℰ','esdot':'\u2250','esim':'\u2242','Esim':'\u2A73','eta':'η','Eta':'Η','eth':'ð','ETH':'Ð','euml':'ë','Euml':'Ë','euro':'\u20AC','excl':'!','exist':'\u2203','Exists':'\u2203','expectation':'ℰ','exponentiale':'ⅇ','ExponentialE':'ⅇ','fallingdotseq':'\u2252','fcy':'ф','Fcy':'Ф','female':'\u2640','ffilig':'ﬃ','fflig':'ﬀ','ffllig':'ﬄ','ffr':'\uD835\uDD23','Ffr':'\uD835\uDD09','filig':'ﬁ','FilledSmallSquare':'\u25FC','FilledVerySmallSquare':'\u25AA','fjlig':'fj','flat':'\u266D','fllig':'ﬂ','fltns':'\u25B1','fnof':'ƒ','fopf':'\uD835\uDD57','Fopf':'\uD835\uDD3D','forall':'\u2200','ForAll':'\u2200','fork':'\u22D4','forkv':'\u2AD9','Fouriertrf':'ℱ','fpartint':'\u2A0D','frac12':'\xBD','frac13':'\u2153','frac14':'\xBC','frac15':'\u2155','frac16':'\u2159','frac18':'\u215B','frac23':'\u2154','frac25':'\u2156','frac34':'\xBE','frac35':'\u2157','frac38':'\u215C','frac45':'\u2158','frac56':'\u215A','frac58':'\u215D','frac78':'\u215E','frasl':'\u2044','frown':'\u2322','fscr':'\uD835\uDCBB','Fscr':'ℱ','gacute':'ǵ','gamma':'γ','Gamma':'Γ','gammad':'ϝ','Gammad':'Ϝ','gap':'\u2A86','gbreve':'ğ','Gbreve':'Ğ','Gcedil':'Ģ','gcirc':'ĝ','Gcirc':'Ĝ','gcy':'г','Gcy':'Г','gdot':'ġ','Gdot':'Ġ','ge':'\u2265','gE':'\u2267','gel':'\u22DB','gEl':'\u2A8C','geq':'\u2265','geqq':'\u2267','geqslant':'\u2A7E','ges':'\u2A7E','gescc':'\u2AA9','gesdot':'\u2A80','gesdoto':'\u2A82','gesdotol':'\u2A84','gesl':'\u22DB︀','gesles':'\u2A94','gfr':'\uD835\uDD24','Gfr':'\uD835\uDD0A','gg':'\u226B','Gg':'\u22D9','ggg':'\u22D9','gimel':'ℷ','gjcy':'ѓ','GJcy':'Ѓ','gl':'\u2277','gla':'\u2AA5','glE':'\u2A92','glj':'\u2AA4','gnap':'\u2A8A','gnapprox':'\u2A8A','gne':'\u2A88','gnE':'\u2269','gneq':'\u2A88','gneqq':'\u2269','gnsim':'\u22E7','gopf':'\uD835\uDD58','Gopf':'\uD835\uDD3E','grave':'`','GreaterEqual':'\u2265','GreaterEqualLess':'\u22DB','GreaterFullEqual':'\u2267','GreaterGreater':'\u2AA2','GreaterLess':'\u2277','GreaterSlantEqual':'\u2A7E','GreaterTilde':'\u2273','gscr':'ℊ','Gscr':'\uD835\uDCA2','gsim':'\u2273','gsime':'\u2A8E','gsiml':'\u2A90','gt':'>','Gt':'\u226B','GT':'>','gtcc':'\u2AA7','gtcir':'\u2A7A','gtdot':'\u22D7','gtlPar':'\u2995','gtquest':'\u2A7C','gtrapprox':'\u2A86','gtrarr':'\u2978','gtrdot':'\u22D7','gtreqless':'\u22DB','gtreqqless':'\u2A8C','gtrless':'\u2277','gtrsim':'\u2273','gvertneqq':'\u2269︀','gvnE':'\u2269︀','Hacek':'ˇ','hairsp':'\u200A','half':'\xBD','hamilt':'ℋ','hardcy':'ъ','HARDcy':'Ъ','harr':'\u2194','hArr':'\u21D4','harrcir':'\u2948','harrw':'\u21AD','Hat':'^','hbar':'ℏ','hcirc':'ĥ','Hcirc':'Ĥ','hearts':'\u2665','heartsuit':'\u2665','hellip':'\u2026','hercon':'\u22B9','hfr':'\uD835\uDD25','Hfr':'ℌ','HilbertSpace':'ℋ','hksearow':'\u2925','hkswarow':'\u2926','hoarr':'\u21FF','homtht':'\u223B','hookleftarrow':'\u21A9','hookrightarrow':'\u21AA','hopf':'\uD835\uDD59','Hopf':'ℍ','horbar':'\u2015','HorizontalLine':'\u2500','hscr':'\uD835\uDCBD','Hscr':'ℋ','hslash':'ℏ','hstrok':'ħ','Hstrok':'Ħ','HumpDownHump':'\u224E','HumpEqual':'\u224F','hybull':'\u2043','hyphen':'\u2010','iacute':'í','Iacute':'Í','ic':'\u2063','icirc':'î','Icirc':'Î','icy':'и','Icy':'И','Idot':'İ','iecy':'е','IEcy':'Е','iexcl':'\xA1','iff':'\u21D4','ifr':'\uD835\uDD26','Ifr':'ℑ','igrave':'ì','Igrave':'Ì','ii':'ⅈ','iiiint':'\u2A0C','iiint':'\u222D','iinfin':'\u29DC','iiota':'\u2129','ijlig':'ĳ','IJlig':'Ĳ','Im':'ℑ','imacr':'ī','Imacr':'Ī','image':'ℑ','ImaginaryI':'ⅈ','imagline':'ℐ','imagpart':'ℑ','imath':'ı','imof':'\u22B7','imped':'Ƶ','Implies':'\u21D2','in':'\u2208','incare':'\u2105','infin':'\u221E','infintie':'\u29DD','inodot':'ı','int':'\u222B','Int':'\u222C','intcal':'\u22BA','integers':'ℤ','Integral':'\u222B','intercal':'\u22BA','Intersection':'\u22C2','intlarhk':'\u2A17','intprod':'\u2A3C','InvisibleComma':'\u2063','InvisibleTimes':'\u2062','iocy':'ё','IOcy':'Ё','iogon':'į','Iogon':'Į','iopf':'\uD835\uDD5A','Iopf':'\uD835\uDD40','iota':'ι','Iota':'Ι','iprod':'\u2A3C','iquest':'\xBF','iscr':'\uD835\uDCBE','Iscr':'ℐ','isin':'\u2208','isindot':'\u22F5','isinE':'\u22F9','isins':'\u22F4','isinsv':'\u22F3','isinv':'\u2208','it':'\u2062','itilde':'ĩ','Itilde':'Ĩ','iukcy':'і','Iukcy':'І','iuml':'ï','Iuml':'Ï','jcirc':'ĵ','Jcirc':'Ĵ','jcy':'й','Jcy':'Й','jfr':'\uD835\uDD27','Jfr':'\uD835\uDD0D','jmath':'ȷ','jopf':'\uD835\uDD5B','Jopf':'\uD835\uDD41','jscr':'\uD835\uDCBF','Jscr':'\uD835\uDCA5','jsercy':'ј','Jsercy':'Ј','jukcy':'є','Jukcy':'Є','kappa':'κ','Kappa':'Κ','kappav':'ϰ','kcedil':'ķ','Kcedil':'Ķ','kcy':'к','Kcy':'К','kfr':'\uD835\uDD28','Kfr':'\uD835\uDD0E','kgreen':'ĸ','khcy':'х','KHcy':'Х','kjcy':'ќ','KJcy':'Ќ','kopf':'\uD835\uDD5C','Kopf':'\uD835\uDD42','kscr':'\uD835\uDCC0','Kscr':'\uD835\uDCA6','lAarr':'\u21DA','lacute':'ĺ','Lacute':'Ĺ','laemptyv':'\u29B4','lagran':'ℒ','lambda':'λ','Lambda':'Λ','lang':'\u27E8','Lang':'\u27EA','langd':'\u2991','langle':'\u27E8','lap':'\u2A85','Laplacetrf':'ℒ','laquo':'\xAB','larr':'\u2190','lArr':'\u21D0','Larr':'\u219E','larrb':'\u21E4','larrbfs':'\u291F','larrfs':'\u291D','larrhk':'\u21A9','larrlp':'\u21AB','larrpl':'\u2939','larrsim':'\u2973','larrtl':'\u21A2','lat':'\u2AAB','latail':'\u2919','lAtail':'\u291B','late':'\u2AAD','lates':'\u2AAD︀','lbarr':'\u290C','lBarr':'\u290E','lbbrk':'\u2772','lbrace':'{','lbrack':'[','lbrke':'\u298B','lbrksld':'\u298F','lbrkslu':'\u298D','lcaron':'ľ','Lcaron':'Ľ','lcedil':'ļ','Lcedil':'Ļ','lceil':'\u2308','lcub':'{','lcy':'л','Lcy':'Л','ldca':'\u2936','ldquo':'\u201C','ldquor':'\u201E','ldrdhar':'\u2967','ldrushar':'\u294B','ldsh':'\u21B2','le':'\u2264','lE':'\u2266','LeftAngleBracket':'\u27E8','leftarrow':'\u2190','Leftarrow':'\u21D0','LeftArrow':'\u2190','LeftArrowBar':'\u21E4','LeftArrowRightArrow':'\u21C6','leftarrowtail':'\u21A2','LeftCeiling':'\u2308','LeftDoubleBracket':'\u27E6','LeftDownTeeVector':'\u2961','LeftDownVector':'\u21C3','LeftDownVectorBar':'\u2959','LeftFloor':'\u230A','leftharpoondown':'\u21BD','leftharpoonup':'\u21BC','leftleftarrows':'\u21C7','leftrightarrow':'\u2194','Leftrightarrow':'\u21D4','LeftRightArrow':'\u2194','leftrightarrows':'\u21C6','leftrightharpoons':'\u21CB','leftrightsquigarrow':'\u21AD','LeftRightVector':'\u294E','LeftTee':'\u22A3','LeftTeeArrow':'\u21A4','LeftTeeVector':'\u295A','leftthreetimes':'\u22CB','LeftTriangle':'\u22B2','LeftTriangleBar':'\u29CF','LeftTriangleEqual':'\u22B4','LeftUpDownVector':'\u2951','LeftUpTeeVector':'\u2960','LeftUpVector':'\u21BF','LeftUpVectorBar':'\u2958','LeftVector':'\u21BC','LeftVectorBar':'\u2952','leg':'\u22DA','lEg':'\u2A8B','leq':'\u2264','leqq':'\u2266','leqslant':'\u2A7D','les':'\u2A7D','lescc':'\u2AA8','lesdot':'\u2A7F','lesdoto':'\u2A81','lesdotor':'\u2A83','lesg':'\u22DA︀','lesges':'\u2A93','lessapprox':'\u2A85','lessdot':'\u22D6','lesseqgtr':'\u22DA','lesseqqgtr':'\u2A8B','LessEqualGreater':'\u22DA','LessFullEqual':'\u2266','LessGreater':'\u2276','lessgtr':'\u2276','LessLess':'\u2AA1','lesssim':'\u2272','LessSlantEqual':'\u2A7D','LessTilde':'\u2272','lfisht':'\u297C','lfloor':'\u230A','lfr':'\uD835\uDD29','Lfr':'\uD835\uDD0F','lg':'\u2276','lgE':'\u2A91','lHar':'\u2962','lhard':'\u21BD','lharu':'\u21BC','lharul':'\u296A','lhblk':'\u2584','ljcy':'љ','LJcy':'Љ','ll':'\u226A','Ll':'\u22D8','llarr':'\u21C7','llcorner':'\u231E','Lleftarrow':'\u21DA','llhard':'\u296B','lltri':'\u25FA','lmidot':'ŀ','Lmidot':'Ŀ','lmoust':'\u23B0','lmoustache':'\u23B0','lnap':'\u2A89','lnapprox':'\u2A89','lne':'\u2A87','lnE':'\u2268','lneq':'\u2A87','lneqq':'\u2268','lnsim':'\u22E6','loang':'\u27EC','loarr':'\u21FD','lobrk':'\u27E6','longleftarrow':'\u27F5','Longleftarrow':'\u27F8','LongLeftArrow':'\u27F5','longleftrightarrow':'\u27F7','Longleftrightarrow':'\u27FA','LongLeftRightArrow':'\u27F7','longmapsto':'\u27FC','longrightarrow':'\u27F6','Longrightarrow':'\u27F9','LongRightArrow':'\u27F6','looparrowleft':'\u21AB','looparrowright':'\u21AC','lopar':'\u2985','lopf':'\uD835\uDD5D','Lopf':'\uD835\uDD43','loplus':'\u2A2D','lotimes':'\u2A34','lowast':'\u2217','lowbar':'_','LowerLeftArrow':'\u2199','LowerRightArrow':'\u2198','loz':'\u25CA','lozenge':'\u25CA','lozf':'\u29EB','lpar':'(','lparlt':'\u2993','lrarr':'\u21C6','lrcorner':'\u231F','lrhar':'\u21CB','lrhard':'\u296D','lrm':'\u200E','lrtri':'\u22BF','lsaquo':'\u2039','lscr':'\uD835\uDCC1','Lscr':'ℒ','lsh':'\u21B0','Lsh':'\u21B0','lsim':'\u2272','lsime':'\u2A8D','lsimg':'\u2A8F','lsqb':'[','lsquo':'\u2018','lsquor':'\u201A','lstrok':'ł','Lstrok':'Ł','lt':'<','Lt':'\u226A','LT':'<','ltcc':'\u2AA6','ltcir':'\u2A79','ltdot':'\u22D6','lthree':'\u22CB','ltimes':'\u22C9','ltlarr':'\u2976','ltquest':'\u2A7B','ltri':'\u25C3','ltrie':'\u22B4','ltrif':'\u25C2','ltrPar':'\u2996','lurdshar':'\u294A','luruhar':'\u2966','lvertneqq':'\u2268︀','lvnE':'\u2268︀','macr':'\xAF','male':'\u2642','malt':'\u2720','maltese':'\u2720','map':'\u21A6','Map':'\u2905','mapsto':'\u21A6','mapstodown':'\u21A7','mapstoleft':'\u21A4','mapstoup':'\u21A5','marker':'\u25AE','mcomma':'\u2A29','mcy':'м','Mcy':'М','mdash':'\u2014','mDDot':'\u223A','measuredangle':'\u2221','MediumSpace':'\u205F','Mellintrf':'ℳ','mfr':'\uD835\uDD2A','Mfr':'\uD835\uDD10','mho':'\u2127','micro':'µ','mid':'\u2223','midast':'*','midcir':'\u2AF0','middot':'\xB7','minus':'\u2212','minusb':'\u229F','minusd':'\u2238','minusdu':'\u2A2A','MinusPlus':'\u2213','mlcp':'\u2ADB','mldr':'\u2026','mnplus':'\u2213','models':'\u22A7','mopf':'\uD835\uDD5E','Mopf':'\uD835\uDD44','mp':'\u2213','mscr':'\uD835\uDCC2','Mscr':'ℳ','mstpos':'\u223E','mu':'μ','Mu':'Μ','multimap':'\u22B8','mumap':'\u22B8','nabla':'\u2207','nacute':'ń','Nacute':'Ń','nang':'\u2220⃒','nap':'\u2249','napE':'\u2A70̸','napid':'\u224B̸','napos':'ŉ','napprox':'\u2249','natur':'\u266E','natural':'\u266E','naturals':'ℕ','nbsp':'\xA0','nbump':'\u224E̸','nbumpe':'\u224F̸','ncap':'\u2A43','ncaron':'ň','Ncaron':'Ň','ncedil':'ņ','Ncedil':'Ņ','ncong':'\u2247','ncongdot':'\u2A6D̸','ncup':'\u2A42','ncy':'н','Ncy':'Н','ndash':'\u2013','ne':'\u2260','nearhk':'\u2924','nearr':'\u2197','neArr':'\u21D7','nearrow':'\u2197','nedot':'\u2250̸','NegativeMediumSpace':'\u200B','NegativeThickSpace':'\u200B','NegativeThinSpace':'\u200B','NegativeVeryThinSpace':'\u200B','nequiv':'\u2262','nesear':'\u2928','nesim':'\u2242̸','NestedGreaterGreater':'\u226B','NestedLessLess':'\u226A','NewLine':'\n','nexist':'\u2204','nexists':'\u2204','nfr':'\uD835\uDD2B','Nfr':'\uD835\uDD11','nge':'\u2271','ngE':'\u2267̸','ngeq':'\u2271','ngeqq':'\u2267̸','ngeqslant':'\u2A7E̸','nges':'\u2A7E̸','nGg':'\u22D9̸','ngsim':'\u2275','ngt':'\u226F','nGt':'\u226B⃒','ngtr':'\u226F','nGtv':'\u226B̸','nharr':'\u21AE','nhArr':'\u21CE','nhpar':'\u2AF2','ni':'\u220B','nis':'\u22FC','nisd':'\u22FA','niv':'\u220B','njcy':'њ','NJcy':'Њ','nlarr':'\u219A','nlArr':'\u21CD','nldr':'\u2025','nle':'\u2270','nlE':'\u2266̸','nleftarrow':'\u219A','nLeftarrow':'\u21CD','nleftrightarrow':'\u21AE','nLeftrightarrow':'\u21CE','nleq':'\u2270','nleqq':'\u2266̸','nleqslant':'\u2A7D̸','nles':'\u2A7D̸','nless':'\u226E','nLl':'\u22D8̸','nlsim':'\u2274','nlt':'\u226E','nLt':'\u226A⃒','nltri':'\u22EA','nltrie':'\u22EC','nLtv':'\u226A̸','nmid':'\u2224','NoBreak':'\u2060','NonBreakingSpace':'\xA0','nopf':'\uD835\uDD5F','Nopf':'ℕ','not':'\xAC','Not':'\u2AEC','NotCongruent':'\u2262','NotCupCap':'\u226D','NotDoubleVerticalBar':'\u2226','NotElement':'\u2209','NotEqual':'\u2260','NotEqualTilde':'\u2242̸','NotExists':'\u2204','NotGreater':'\u226F','NotGreaterEqual':'\u2271','NotGreaterFullEqual':'\u2267̸','NotGreaterGreater':'\u226B̸','NotGreaterLess':'\u2279','NotGreaterSlantEqual':'\u2A7E̸','NotGreaterTilde':'\u2275','NotHumpDownHump':'\u224E̸','NotHumpEqual':'\u224F̸','notin':'\u2209','notindot':'\u22F5̸','notinE':'\u22F9̸','notinva':'\u2209','notinvb':'\u22F7','notinvc':'\u22F6','NotLeftTriangle':'\u22EA','NotLeftTriangleBar':'\u29CF̸','NotLeftTriangleEqual':'\u22EC','NotLess':'\u226E','NotLessEqual':'\u2270','NotLessGreater':'\u2278','NotLessLess':'\u226A̸','NotLessSlantEqual':'\u2A7D̸','NotLessTilde':'\u2274','NotNestedGreaterGreater':'\u2AA2̸','NotNestedLessLess':'\u2AA1̸','notni':'\u220C','notniva':'\u220C','notnivb':'\u22FE','notnivc':'\u22FD','NotPrecedes':'\u2280','NotPrecedesEqual':'\u2AAF̸','NotPrecedesSlantEqual':'\u22E0','NotReverseElement':'\u220C','NotRightTriangle':'\u22EB','NotRightTriangleBar':'\u29D0̸','NotRightTriangleEqual':'\u22ED','NotSquareSubset':'\u228F̸','NotSquareSubsetEqual':'\u22E2','NotSquareSuperset':'\u2290̸','NotSquareSupersetEqual':'\u22E3','NotSubset':'\u2282⃒','NotSubsetEqual':'\u2288','NotSucceeds':'\u2281','NotSucceedsEqual':'\u2AB0̸','NotSucceedsSlantEqual':'\u22E1','NotSucceedsTilde':'\u227F̸','NotSuperset':'\u2283⃒','NotSupersetEqual':'\u2289','NotTilde':'\u2241','NotTildeEqual':'\u2244','NotTildeFullEqual':'\u2247','NotTildeTilde':'\u2249','NotVerticalBar':'\u2224','npar':'\u2226','nparallel':'\u2226','nparsl':'\u2AFD⃥','npart':'\u2202̸','npolint':'\u2A14','npr':'\u2280','nprcue':'\u22E0','npre':'\u2AAF̸','nprec':'\u2280','npreceq':'\u2AAF̸','nrarr':'\u219B','nrArr':'\u21CF','nrarrc':'\u2933̸','nrarrw':'\u219D̸','nrightarrow':'\u219B','nRightarrow':'\u21CF','nrtri':'\u22EB','nrtrie':'\u22ED','nsc':'\u2281','nsccue':'\u22E1','nsce':'\u2AB0̸','nscr':'\uD835\uDCC3','Nscr':'\uD835\uDCA9','nshortmid':'\u2224','nshortparallel':'\u2226','nsim':'\u2241','nsime':'\u2244','nsimeq':'\u2244','nsmid':'\u2224','nspar':'\u2226','nsqsube':'\u22E2','nsqsupe':'\u22E3','nsub':'\u2284','nsube':'\u2288','nsubE':'\u2AC5̸','nsubset':'\u2282⃒','nsubseteq':'\u2288','nsubseteqq':'\u2AC5̸','nsucc':'\u2281','nsucceq':'\u2AB0̸','nsup':'\u2285','nsupe':'\u2289','nsupE':'\u2AC6̸','nsupset':'\u2283⃒','nsupseteq':'\u2289','nsupseteqq':'\u2AC6̸','ntgl':'\u2279','ntilde':'ñ','Ntilde':'Ñ','ntlg':'\u2278','ntriangleleft':'\u22EA','ntrianglelefteq':'\u22EC','ntriangleright':'\u22EB','ntrianglerighteq':'\u22ED','nu':'ν','Nu':'Ν','num':'#','numero':'\u2116','numsp':'\u2007','nvap':'\u224D⃒','nvdash':'\u22AC','nvDash':'\u22AD','nVdash':'\u22AE','nVDash':'\u22AF','nvge':'\u2265⃒','nvgt':'>⃒','nvHarr':'\u2904','nvinfin':'\u29DE','nvlArr':'\u2902','nvle':'\u2264⃒','nvlt':'<⃒','nvltrie':'\u22B4⃒','nvrArr':'\u2903','nvrtrie':'\u22B5⃒','nvsim':'\u223C⃒','nwarhk':'\u2923','nwarr':'\u2196','nwArr':'\u21D6','nwarrow':'\u2196','nwnear':'\u2927','oacute':'ó','Oacute':'Ó','oast':'\u229B','ocir':'\u229A','ocirc':'ô','Ocirc':'Ô','ocy':'о','Ocy':'О','odash':'\u229D','odblac':'ő','Odblac':'Ő','odiv':'\u2A38','odot':'\u2299','odsold':'\u29BC','oelig':'œ','OElig':'Œ','ofcir':'\u29BF','ofr':'\uD835\uDD2C','Ofr':'\uD835\uDD12','ogon':'\u02DB','ograve':'ò','Ograve':'Ò','ogt':'\u29C1','ohbar':'\u29B5','ohm':'Ω','oint':'\u222E','olarr':'\u21BA','olcir':'\u29BE','olcross':'\u29BB','oline':'\u203E','olt':'\u29C0','omacr':'ō','Omacr':'Ō','omega':'ω','Omega':'Ω','omicron':'ο','Omicron':'Ο','omid':'\u29B6','ominus':'\u2296','oopf':'\uD835\uDD60','Oopf':'\uD835\uDD46','opar':'\u29B7','OpenCurlyDoubleQuote':'\u201C','OpenCurlyQuote':'\u2018','operp':'\u29B9','oplus':'\u2295','or':'\u2228','Or':'\u2A54','orarr':'\u21BB','ord':'\u2A5D','order':'ℴ','orderof':'ℴ','ordf':'ª','ordm':'º','origof':'\u22B6','oror':'\u2A56','orslope':'\u2A57','orv':'\u2A5B','oS':'\u24C8','oscr':'ℴ','Oscr':'\uD835\uDCAA','oslash':'ø','Oslash':'Ø','osol':'\u2298','otilde':'õ','Otilde':'Õ','otimes':'\u2297','Otimes':'\u2A37','otimesas':'\u2A36','ouml':'ö','Ouml':'Ö','ovbar':'\u233D','OverBar':'\u203E','OverBrace':'\u23DE','OverBracket':'\u23B4','OverParenthesis':'\u23DC','par':'\u2225','para':'\xB6','parallel':'\u2225','parsim':'\u2AF3','parsl':'\u2AFD','part':'\u2202','PartialD':'\u2202','pcy':'п','Pcy':'П','percnt':'%','period':'.','permil':'\u2030','perp':'\u22A5','pertenk':'\u2031','pfr':'\uD835\uDD2D','Pfr':'\uD835\uDD13','phi':'φ','Phi':'Φ','phiv':'ϕ','phmmat':'ℳ','phone':'\u260E','pi':'π','Pi':'Π','pitchfork':'\u22D4','piv':'ϖ','planck':'ℏ','planckh':'ℎ','plankv':'ℏ','plus':'+','plusacir':'\u2A23','plusb':'\u229E','pluscir':'\u2A22','plusdo':'\u2214','plusdu':'\u2A25','pluse':'\u2A72','PlusMinus':'\xB1','plusmn':'\xB1','plussim':'\u2A26','plustwo':'\u2A27','pm':'\xB1','Poincareplane':'ℌ','pointint':'\u2A15','popf':'\uD835\uDD61','Popf':'ℙ','pound':'\xA3','pr':'\u227A','Pr':'\u2ABB','prap':'\u2AB7','prcue':'\u227C','pre':'\u2AAF','prE':'\u2AB3','prec':'\u227A','precapprox':'\u2AB7','preccurlyeq':'\u227C','Precedes':'\u227A','PrecedesEqual':'\u2AAF','PrecedesSlantEqual':'\u227C','PrecedesTilde':'\u227E','preceq':'\u2AAF','precnapprox':'\u2AB9','precneqq':'\u2AB5','precnsim':'\u22E8','precsim':'\u227E','prime':'\u2032','Prime':'\u2033','primes':'ℙ','prnap':'\u2AB9','prnE':'\u2AB5','prnsim':'\u22E8','prod':'\u220F','Product':'\u220F','profalar':'\u232E','profline':'\u2312','profsurf':'\u2313','prop':'\u221D','Proportion':'\u2237','Proportional':'\u221D','propto':'\u221D','prsim':'\u227E','prurel':'\u22B0','pscr':'\uD835\uDCC5','Pscr':'\uD835\uDCAB','psi':'ψ','Psi':'Ψ','puncsp':'\u2008','qfr':'\uD835\uDD2E','Qfr':'\uD835\uDD14','qint':'\u2A0C','qopf':'\uD835\uDD62','Qopf':'ℚ','qprime':'\u2057','qscr':'\uD835\uDCC6','Qscr':'\uD835\uDCAC','quaternions':'ℍ','quatint':'\u2A16','quest':'?','questeq':'\u225F','quot':'"','QUOT':'"','rAarr':'\u21DB','race':'\u223Ḏ','racute':'ŕ','Racute':'Ŕ','radic':'\u221A','raemptyv':'\u29B3','rang':'\u27E9','Rang':'\u27EB','rangd':'\u2992','range':'\u29A5','rangle':'\u27E9','raquo':'\xBB','rarr':'\u2192','rArr':'\u21D2','Rarr':'\u21A0','rarrap':'\u2975','rarrb':'\u21E5','rarrbfs':'\u2920','rarrc':'\u2933','rarrfs':'\u291E','rarrhk':'\u21AA','rarrlp':'\u21AC','rarrpl':'\u2945','rarrsim':'\u2974','rarrtl':'\u21A3','Rarrtl':'\u2916','rarrw':'\u219D','ratail':'\u291A','rAtail':'\u291C','ratio':'\u2236','rationals':'ℚ','rbarr':'\u290D','rBarr':'\u290F','RBarr':'\u2910','rbbrk':'\u2773','rbrace':'}','rbrack':']','rbrke':'\u298C','rbrksld':'\u298E','rbrkslu':'\u2990','rcaron':'ř','Rcaron':'Ř','rcedil':'ŗ','Rcedil':'Ŗ','rceil':'\u2309','rcub':'}','rcy':'р','Rcy':'Р','rdca':'\u2937','rdldhar':'\u2969','rdquo':'\u201D','rdquor':'\u201D','rdsh':'\u21B3','Re':'ℜ','real':'ℜ','realine':'ℛ','realpart':'ℜ','reals':'ℝ','rect':'\u25AD','reg':'\xAE','REG':'\xAE','ReverseElement':'\u220B','ReverseEquilibrium':'\u21CB','ReverseUpEquilibrium':'\u296F','rfisht':'\u297D','rfloor':'\u230B','rfr':'\uD835\uDD2F','Rfr':'ℜ','rHar':'\u2964','rhard':'\u21C1','rharu':'\u21C0','rharul':'\u296C','rho':'ρ','Rho':'Ρ','rhov':'ϱ','RightAngleBracket':'\u27E9','rightarrow':'\u2192','Rightarrow':'\u21D2','RightArrow':'\u2192','RightArrowBar':'\u21E5','RightArrowLeftArrow':'\u21C4','rightarrowtail':'\u21A3','RightCeiling':'\u2309','RightDoubleBracket':'\u27E7','RightDownTeeVector':'\u295D','RightDownVector':'\u21C2','RightDownVectorBar':'\u2955','RightFloor':'\u230B','rightharpoondown':'\u21C1','rightharpoonup':'\u21C0','rightleftarrows':'\u21C4','rightleftharpoons':'\u21CC','rightrightarrows':'\u21C9','rightsquigarrow':'\u219D','RightTee':'\u22A2','RightTeeArrow':'\u21A6','RightTeeVector':'\u295B','rightthreetimes':'\u22CC','RightTriangle':'\u22B3','RightTriangleBar':'\u29D0','RightTriangleEqual':'\u22B5','RightUpDownVector':'\u294F','RightUpTeeVector':'\u295C','RightUpVector':'\u21BE','RightUpVectorBar':'\u2954','RightVector':'\u21C0','RightVectorBar':'\u2953','ring':'\u02DA','risingdotseq':'\u2253','rlarr':'\u21C4','rlhar':'\u21CC','rlm':'\u200F','rmoust':'\u23B1','rmoustache':'\u23B1','rnmid':'\u2AEE','roang':'\u27ED','roarr':'\u21FE','robrk':'\u27E7','ropar':'\u2986','ropf':'\uD835\uDD63','Ropf':'ℝ','roplus':'\u2A2E','rotimes':'\u2A35','RoundImplies':'\u2970','rpar':')','rpargt':'\u2994','rppolint':'\u2A12','rrarr':'\u21C9','Rrightarrow':'\u21DB','rsaquo':'\u203A','rscr':'\uD835\uDCC7','Rscr':'ℛ','rsh':'\u21B1','Rsh':'\u21B1','rsqb':']','rsquo':'\u2019','rsquor':'\u2019','rthree':'\u22CC','rtimes':'\u22CA','rtri':'\u25B9','rtrie':'\u22B5','rtrif':'\u25B8','rtriltri':'\u29CE','RuleDelayed':'\u29F4','ruluhar':'\u2968','rx':'\u211E','sacute':'ś','Sacute':'Ś','sbquo':'\u201A','sc':'\u227B','Sc':'\u2ABC','scap':'\u2AB8','scaron':'š','Scaron':'Š','sccue':'\u227D','sce':'\u2AB0','scE':'\u2AB4','scedil':'ş','Scedil':'Ş','scirc':'ŝ','Scirc':'Ŝ','scnap':'\u2ABA','scnE':'\u2AB6','scnsim':'\u22E9','scpolint':'\u2A13','scsim':'\u227F','scy':'с','Scy':'С','sdot':'\u22C5','sdotb':'\u22A1','sdote':'\u2A66','searhk':'\u2925','searr':'\u2198','seArr':'\u21D8','searrow':'\u2198','sect':'\xA7','semi':';','seswar':'\u2929','setminus':'\u2216','setmn':'\u2216','sext':'\u2736','sfr':'\uD835\uDD30','Sfr':'\uD835\uDD16','sfrown':'\u2322','sharp':'\u266F','shchcy':'щ','SHCHcy':'Щ','shcy':'ш','SHcy':'Ш','ShortDownArrow':'\u2193','ShortLeftArrow':'\u2190','shortmid':'\u2223','shortparallel':'\u2225','ShortRightArrow':'\u2192','ShortUpArrow':'\u2191','shy':'\xAD','sigma':'σ','Sigma':'Σ','sigmaf':'ς','sigmav':'ς','sim':'\u223C','simdot':'\u2A6A','sime':'\u2243','simeq':'\u2243','simg':'\u2A9E','simgE':'\u2AA0','siml':'\u2A9D','simlE':'\u2A9F','simne':'\u2246','simplus':'\u2A24','simrarr':'\u2972','slarr':'\u2190','SmallCircle':'\u2218','smallsetminus':'\u2216','smashp':'\u2A33','smeparsl':'\u29E4','smid':'\u2223','smile':'\u2323','smt':'\u2AAA','smte':'\u2AAC','smtes':'\u2AAC︀','softcy':'ь','SOFTcy':'Ь','sol':'/','solb':'\u29C4','solbar':'\u233F','sopf':'\uD835\uDD64','Sopf':'\uD835\uDD4A','spades':'\u2660','spadesuit':'\u2660','spar':'\u2225','sqcap':'\u2293','sqcaps':'\u2293︀','sqcup':'\u2294','sqcups':'\u2294︀','Sqrt':'\u221A','sqsub':'\u228F','sqsube':'\u2291','sqsubset':'\u228F','sqsubseteq':'\u2291','sqsup':'\u2290','sqsupe':'\u2292','sqsupset':'\u2290','sqsupseteq':'\u2292','squ':'\u25A1','square':'\u25A1','Square':'\u25A1','SquareIntersection':'\u2293','SquareSubset':'\u228F','SquareSubsetEqual':'\u2291','SquareSuperset':'\u2290','SquareSupersetEqual':'\u2292','SquareUnion':'\u2294','squarf':'\u25AA','squf':'\u25AA','srarr':'\u2192','sscr':'\uD835\uDCC8','Sscr':'\uD835\uDCAE','ssetmn':'\u2216','ssmile':'\u2323','sstarf':'\u22C6','star':'\u2606','Star':'\u22C6','starf':'\u2605','straightepsilon':'ϵ','straightphi':'ϕ','strns':'\xAF','sub':'\u2282','Sub':'\u22D0','subdot':'\u2ABD','sube':'\u2286','subE':'\u2AC5','subedot':'\u2AC3','submult':'\u2AC1','subne':'\u228A','subnE':'\u2ACB','subplus':'\u2ABF','subrarr':'\u2979','subset':'\u2282','Subset':'\u22D0','subseteq':'\u2286','subseteqq':'\u2AC5','SubsetEqual':'\u2286','subsetneq':'\u228A','subsetneqq':'\u2ACB','subsim':'\u2AC7','subsub':'\u2AD5','subsup':'\u2AD3','succ':'\u227B','succapprox':'\u2AB8','succcurlyeq':'\u227D','Succeeds':'\u227B','SucceedsEqual':'\u2AB0','SucceedsSlantEqual':'\u227D','SucceedsTilde':'\u227F','succeq':'\u2AB0','succnapprox':'\u2ABA','succneqq':'\u2AB6','succnsim':'\u22E9','succsim':'\u227F','SuchThat':'\u220B','sum':'\u2211','Sum':'\u2211','sung':'\u266A','sup':'\u2283','Sup':'\u22D1','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','supdot':'\u2ABE','supdsub':'\u2AD8','supe':'\u2287','supE':'\u2AC6','supedot':'\u2AC4','Superset':'\u2283','SupersetEqual':'\u2287','suphsol':'\u27C9','suphsub':'\u2AD7','suplarr':'\u297B','supmult':'\u2AC2','supne':'\u228B','supnE':'\u2ACC','supplus':'\u2AC0','supset':'\u2283','Supset':'\u22D1','supseteq':'\u2287','supseteqq':'\u2AC6','supsetneq':'\u228B','supsetneqq':'\u2ACC','supsim':'\u2AC8','supsub':'\u2AD4','supsup':'\u2AD6','swarhk':'\u2926','swarr':'\u2199','swArr':'\u21D9','swarrow':'\u2199','swnwar':'\u292A','szlig':'ß','Tab':'\t','target':'\u2316','tau':'τ','Tau':'Τ','tbrk':'\u23B4','tcaron':'ť','Tcaron':'Ť','tcedil':'ţ','Tcedil':'Ţ','tcy':'т','Tcy':'Т','tdot':'⃛','telrec':'\u2315','tfr':'\uD835\uDD31','Tfr':'\uD835\uDD17','there4':'\u2234','therefore':'\u2234','Therefore':'\u2234','theta':'θ','Theta':'Θ','thetasym':'ϑ','thetav':'ϑ','thickapprox':'\u2248','thicksim':'\u223C','ThickSpace':'\u205F\u200A','thinsp':'\u2009','ThinSpace':'\u2009','thkap':'\u2248','thksim':'\u223C','thorn':'þ','THORN':'Þ','tilde':'\u02DC','Tilde':'\u223C','TildeEqual':'\u2243','TildeFullEqual':'\u2245','TildeTilde':'\u2248','times':'\xD7','timesb':'\u22A0','timesbar':'\u2A31','timesd':'\u2A30','tint':'\u222D','toea':'\u2928','top':'\u22A4','topbot':'\u2336','topcir':'\u2AF1','topf':'\uD835\uDD65','Topf':'\uD835\uDD4B','topfork':'\u2ADA','tosa':'\u2929','tprime':'\u2034','trade':'\u2122','TRADE':'\u2122','triangle':'\u25B5','triangledown':'\u25BF','triangleleft':'\u25C3','trianglelefteq':'\u22B4','triangleq':'\u225C','triangleright':'\u25B9','trianglerighteq':'\u22B5','tridot':'\u25EC','trie':'\u225C','triminus':'\u2A3A','TripleDot':'⃛','triplus':'\u2A39','trisb':'\u29CD','tritime':'\u2A3B','trpezium':'\u23E2','tscr':'\uD835\uDCC9','Tscr':'\uD835\uDCAF','tscy':'ц','TScy':'Ц','tshcy':'ћ','TSHcy':'Ћ','tstrok':'ŧ','Tstrok':'Ŧ','twixt':'\u226C','twoheadleftarrow':'\u219E','twoheadrightarrow':'\u21A0','uacute':'ú','Uacute':'Ú','uarr':'\u2191','uArr':'\u21D1','Uarr':'\u219F','Uarrocir':'\u2949','ubrcy':'ў','Ubrcy':'Ў','ubreve':'ŭ','Ubreve':'Ŭ','ucirc':'û','Ucirc':'Û','ucy':'у','Ucy':'У','udarr':'\u21C5','udblac':'ű','Udblac':'Ű','udhar':'\u296E','ufisht':'\u297E','ufr':'\uD835\uDD32','Ufr':'\uD835\uDD18','ugrave':'ù','Ugrave':'Ù','uHar':'\u2963','uharl':'\u21BF','uharr':'\u21BE','uhblk':'\u2580','ulcorn':'\u231C','ulcorner':'\u231C','ulcrop':'\u230F','ultri':'\u25F8','umacr':'ū','Umacr':'Ū','uml':'\xA8','UnderBar':'_','UnderBrace':'\u23DF','UnderBracket':'\u23B5','UnderParenthesis':'\u23DD','Union':'\u22C3','UnionPlus':'\u228E','uogon':'ų','Uogon':'Ų','uopf':'\uD835\uDD66','Uopf':'\uD835\uDD4C','uparrow':'\u2191','Uparrow':'\u21D1','UpArrow':'\u2191','UpArrowBar':'\u2912','UpArrowDownArrow':'\u21C5','updownarrow':'\u2195','Updownarrow':'\u21D5','UpDownArrow':'\u2195','UpEquilibrium':'\u296E','upharpoonleft':'\u21BF','upharpoonright':'\u21BE','uplus':'\u228E','UpperLeftArrow':'\u2196','UpperRightArrow':'\u2197','upsi':'υ','Upsi':'ϒ','upsih':'ϒ','upsilon':'υ','Upsilon':'Υ','UpTee':'\u22A5','UpTeeArrow':'\u21A5','upuparrows':'\u21C8','urcorn':'\u231D','urcorner':'\u231D','urcrop':'\u230E','uring':'ů','Uring':'Ů','urtri':'\u25F9','uscr':'\uD835\uDCCA','Uscr':'\uD835\uDCB0','utdot':'\u22F0','utilde':'ũ','Utilde':'Ũ','utri':'\u25B5','utrif':'\u25B4','uuarr':'\u21C8','uuml':'ü','Uuml':'Ü','uwangle':'\u29A7','vangrt':'\u299C','varepsilon':'ϵ','varkappa':'ϰ','varnothing':'\u2205','varphi':'ϕ','varpi':'ϖ','varpropto':'\u221D','varr':'\u2195','vArr':'\u21D5','varrho':'ϱ','varsigma':'ς','varsubsetneq':'\u228A︀','varsubsetneqq':'\u2ACB︀','varsupsetneq':'\u228B︀','varsupsetneqq':'\u2ACC︀','vartheta':'ϑ','vartriangleleft':'\u22B2','vartriangleright':'\u22B3','vBar':'\u2AE8','Vbar':'\u2AEB','vBarv':'\u2AE9','vcy':'в','Vcy':'В','vdash':'\u22A2','vDash':'\u22A8','Vdash':'\u22A9','VDash':'\u22AB','Vdashl':'\u2AE6','vee':'\u2228','Vee':'\u22C1','veebar':'\u22BB','veeeq':'\u225A','vellip':'\u22EE','verbar':'|','Verbar':'\u2016','vert':'|','Vert':'\u2016','VerticalBar':'\u2223','VerticalLine':'|','VerticalSeparator':'\u2758','VerticalTilde':'\u2240','VeryThinSpace':'\u200A','vfr':'\uD835\uDD33','Vfr':'\uD835\uDD19','vltri':'\u22B2','vnsub':'\u2282⃒','vnsup':'\u2283⃒','vopf':'\uD835\uDD67','Vopf':'\uD835\uDD4D','vprop':'\u221D','vrtri':'\u22B3','vscr':'\uD835\uDCCB','Vscr':'\uD835\uDCB1','vsubne':'\u228A︀','vsubnE':'\u2ACB︀','vsupne':'\u228B︀','vsupnE':'\u2ACC︀','Vvdash':'\u22AA','vzigzag':'\u299A','wcirc':'ŵ','Wcirc':'Ŵ','wedbar':'\u2A5F','wedge':'\u2227','Wedge':'\u22C0','wedgeq':'\u2259','weierp':'\u2118','wfr':'\uD835\uDD34','Wfr':'\uD835\uDD1A','wopf':'\uD835\uDD68','Wopf':'\uD835\uDD4E','wp':'\u2118','wr':'\u2240','wreath':'\u2240','wscr':'\uD835\uDCCC','Wscr':'\uD835\uDCB2','xcap':'\u22C2','xcirc':'\u25EF','xcup':'\u22C3','xdtri':'\u25BD','xfr':'\uD835\uDD35','Xfr':'\uD835\uDD1B','xharr':'\u27F7','xhArr':'\u27FA','xi':'ξ','Xi':'Ξ','xlarr':'\u27F5','xlArr':'\u27F8','xmap':'\u27FC','xnis':'\u22FB','xodot':'\u2A00','xopf':'\uD835\uDD69','Xopf':'\uD835\uDD4F','xoplus':'\u2A01','xotime':'\u2A02','xrarr':'\u27F6','xrArr':'\u27F9','xscr':'\uD835\uDCCD','Xscr':'\uD835\uDCB3','xsqcup':'\u2A06','xuplus':'\u2A04','xutri':'\u25B3','xvee':'\u22C1','xwedge':'\u22C0','yacute':'ý','Yacute':'Ý','yacy':'я','YAcy':'Я','ycirc':'ŷ','Ycirc':'Ŷ','ycy':'ы','Ycy':'Ы','yen':'\xA5','yfr':'\uD835\uDD36','Yfr':'\uD835\uDD1C','yicy':'ї','YIcy':'Ї','yopf':'\uD835\uDD6A','Yopf':'\uD835\uDD50','yscr':'\uD835\uDCCE','Yscr':'\uD835\uDCB4','yucy':'ю','YUcy':'Ю','yuml':'ÿ','Yuml':'Ÿ','zacute':'ź','Zacute':'Ź','zcaron':'ž','Zcaron':'Ž','zcy':'з','Zcy':'З','zdot':'ż','Zdot':'Ż','zeetrf':'ℨ','ZeroWidthSpace':'\u200B','zeta':'ζ','Zeta':'Ζ','zfr':'\uD835\uDD37','Zfr':'ℨ','zhcy':'ж','ZHcy':'Ж','zigrarr':'\u21DD','zopf':'\uD835\uDD6B','Zopf':'ℤ','zscr':'\uD835\uDCCF','Zscr':'\uD835\uDCB5','zwj':'‍','zwnj':'‌'};var decodeMapLegacy={'aacute':'á','Aacute':'Á','acirc':'â','Acirc':'Â','acute':'\xB4','aelig':'æ','AElig':'Æ','agrave':'à','Agrave':'À','amp':'&','AMP':'&','aring':'å','Aring':'Å','atilde':'ã','Atilde':'Ã','auml':'ä','Auml':'Ä','brvbar':'\xA6','ccedil':'ç','Ccedil':'Ç','cedil':'\xB8','cent':'\xA2','copy':'\xA9','COPY':'\xA9','curren':'\xA4','deg':'\xB0','divide':'\xF7','eacute':'é','Eacute':'É','ecirc':'ê','Ecirc':'Ê','egrave':'è','Egrave':'È','eth':'ð','ETH':'Ð','euml':'ë','Euml':'Ë','frac12':'\xBD','frac14':'\xBC','frac34':'\xBE','gt':'>','GT':'>','iacute':'í','Iacute':'Í','icirc':'î','Icirc':'Î','iexcl':'\xA1','igrave':'ì','Igrave':'Ì','iquest':'\xBF','iuml':'ï','Iuml':'Ï','laquo':'\xAB','lt':'<','LT':'<','macr':'\xAF','micro':'µ','middot':'\xB7','nbsp':'\xA0','not':'\xAC','ntilde':'ñ','Ntilde':'Ñ','oacute':'ó','Oacute':'Ó','ocirc':'ô','Ocirc':'Ô','ograve':'ò','Ograve':'Ò','ordf':'ª','ordm':'º','oslash':'ø','Oslash':'Ø','otilde':'õ','Otilde':'Õ','ouml':'ö','Ouml':'Ö','para':'\xB6','plusmn':'\xB1','pound':'\xA3','quot':'"','QUOT':'"','raquo':'\xBB','reg':'\xAE','REG':'\xAE','sect':'\xA7','shy':'\xAD','sup1':'\xB9','sup2':'\xB2','sup3':'\xB3','szlig':'ß','thorn':'þ','THORN':'Þ','times':'\xD7','uacute':'ú','Uacute':'Ú','ucirc':'û','Ucirc':'Û','ugrave':'ù','Ugrave':'Ù','uml':'\xA8','uuml':'ü','Uuml':'Ü','yacute':'ý','Yacute':'Ý','yen':'\xA5','yuml':'ÿ'};var decodeMapNumeric={'0':'\uFFFD','128':'\u20AC','130':'\u201A','131':'ƒ','132':'\u201E','133':'\u2026','134':'\u2020','135':'\u2021','136':'ˆ','137':'\u2030','138':'Š','139':'\u2039','140':'Œ','142':'Ž','145':'\u2018','146':'\u2019','147':'\u201C','148':'\u201D','149':'\u2022','150':'\u2013','151':'\u2014','152':'\u02DC','153':'\u2122','154':'š','155':'\u203A','156':'œ','158':'ž','159':'Ÿ'};var invalidReferenceCodePoints=[1,2,3,4,5,6,7,8,11,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,64976,64977,64978,64979,64980,64981,64982,64983,64984,64985,64986,64987,64988,64989,64990,64991,64992,64993,64994,64995,64996,64997,64998,64999,65000,65001,65002,65003,65004,65005,65006,65007,65534,65535,131070,131071,196606,196607,262142,262143,327678,327679,393214,393215,458750,458751,524286,524287,589822,589823,655358,655359,720894,720895,786430,786431,851966,851967,917502,917503,983038,983039,1048574,1048575,1114110,1114111];var stringFromCharCode=String.fromCharCode;var object={};var hasOwnProperty=object.hasOwnProperty;var has=function(object,propertyName){return hasOwnProperty.call(object,propertyName);};var contains=function(array,value){var index=-1;var length=array.length;while(++index<length){if(array[index]==value){return true;}}return false;};var merge=function(options,defaults){if(!options){return defaults;}var result={};var key;for(key in defaults){result[key]=has(options,key)?options[key]:defaults[key];}return result;};var codePointToSymbol=function(codePoint,strict){var output='';if(codePoint>=55296&&codePoint<=57343||codePoint>1114111){if(strict){parseError('character reference outside the permissible Unicode range');}return'\uFFFD';}if(has(decodeMapNumeric,codePoint)){if(strict){parseError('disallowed character reference');}return decodeMapNumeric[codePoint];}if(strict&&contains(invalidReferenceCodePoints,codePoint)){parseError('disallowed character reference');}if(codePoint>65535){codePoint-=65536;output+=stringFromCharCode(codePoint>>>10&1023|55296);codePoint=56320|codePoint&1023;}output+=stringFromCharCode(codePoint);return output;};var hexEscape=function(codePoint){return'&#x'+codePoint.toString(16).toUpperCase()+';';};var decEscape=function(codePoint){return'&#'+codePoint+';';};var parseError=function(message){throw Error('Parse error: '+message);};var encode=function(string,options){options=merge(options,encode.options);var strict=options.strict;if(strict&&regexInvalidRawCodePoint.test(string)){parseError('forbidden code point');}var encodeEverything=options.encodeEverything;var useNamedReferences=options.useNamedReferences;var allowUnsafeSymbols=options.allowUnsafeSymbols;var escapeCodePoint=options.decimal?decEscape:hexEscape;var escapeBmpSymbol=function(symbol){return escapeCodePoint(symbol.charCodeAt(0));};if(encodeEverything){string=string.replace(regexAsciiWhitelist,function(symbol){if(useNamedReferences&&has(encodeMap,symbol)){return'&'+encodeMap[symbol]+';';}return escapeBmpSymbol(symbol);});if(useNamedReferences){string=string.replace(/&gt;\u20D2/g,'&nvgt;').replace(/&lt;\u20D2/g,'&nvlt;').replace(/&#x66;&#x6A;/g,'&fjlig;');}if(useNamedReferences){string=string.replace(regexEncodeNonAscii,function(string){return'&'+encodeMap[string]+';';});}}else if(useNamedReferences){if(!allowUnsafeSymbols){string=string.replace(regexEscape,function(string){return'&'+encodeMap[string]+';';});}string=string.replace(/&gt;\u20D2/g,'&nvgt;').replace(/&lt;\u20D2/g,'&nvlt;');string=string.replace(regexEncodeNonAscii,function(string){return'&'+encodeMap[string]+';';});}else if(!allowUnsafeSymbols){string=string.replace(regexEscape,escapeBmpSymbol);}return string.replace(regexAstralSymbols,function($0){var high=$0.charCodeAt(0);var low=$0.charCodeAt(1);var codePoint=(high-55296)*1024+low-56320+65536;return escapeCodePoint(codePoint);}).replace(regexBmpWhitelist,escapeBmpSymbol);};encode.options={'allowUnsafeSymbols':false,'encodeEverything':false,'strict':false,'useNamedReferences':false,'decimal':false};var decode=function(html,options){options=merge(options,decode.options);var strict=options.strict;if(strict&&regexInvalidEntity.test(html)){parseError('malformed character reference');}return html.replace(regexDecode,function($0,$1,$2,$3,$4,$5,$6,$7,$8){var codePoint;var semicolon;var decDigits;var hexDigits;var reference;var next;if($1){reference=$1;return decodeMap[reference];}if($2){reference=$2;next=$3;if(next&&options.isAttributeValue){if(strict&&next=='='){parseError('`&` did not start a character reference');}return $0;}else{if(strict){parseError('named character reference was not terminated by a semicolon');}return decodeMapLegacy[reference]+(next||'');}}if($4){decDigits=$4;semicolon=$5;if(strict&&!semicolon){parseError('character reference was not terminated by a semicolon');}codePoint=parseInt(decDigits,10);return codePointToSymbol(codePoint,strict);}if($6){hexDigits=$6;semicolon=$7;if(strict&&!semicolon){parseError('character reference was not terminated by a semicolon');}codePoint=parseInt(hexDigits,16);return codePointToSymbol(codePoint,strict);}if(strict){parseError('named character reference was not terminated by a semicolon');}return $0;});};decode.options={'isAttributeValue':false,'strict':false};var escape=function(string){return string.replace(regexEscape,function($0){return escapeMap[$0];});};var he={'version':'1.2.0','encode':encode,'decode':decode,'escape':escape,'unescape':decode};if(typeof define=='function'&&typeof define.amd=='object'&&define.amd){define(function(){return he;});}else if(freeExports&&!freeExports.nodeType){if(freeModule){freeModule.exports=he;}else{for(var key in he){has(he,key)&&(freeExports[key]=he[key]);}}}else{root.he=he;}}(this));}.call(this));}.call(this,typeof global!=='undefined'?global:typeof self!=='undefined'?self:typeof window!=='undefined'?window:{}));},{}],62:[function(require,module,exports){module.exports=CollectingHandler;function CollectingHandler(cbs){this._cbs=cbs||{};this.events=[];}var EVENTS=require('./').EVENTS;Object.keys(EVENTS).forEach(function(name){if(EVENTS[name]===0){name='on'+name;CollectingHandler.prototype[name]=function(){this.events.push([name]);if(this._cbs[name])this._cbs[name]();};}else if(EVENTS[name]===1){name='on'+name;CollectingHandler.prototype[name]=function(a){this.events.push([name,a]);if(this._cbs[name])this._cbs[name](a);};}else if(EVENTS[name]===2){name='on'+name;CollectingHandler.prototype[name]=function(a,b){this.events.push([name,a,b]);if(this._cbs[name])this._cbs[name](a,b);};}else{throw Error('wrong number of arguments');}});CollectingHandler.prototype.onreset=function(){this.events=[];if(this._cbs.onreset)this._cbs.onreset();};CollectingHandler.prototype.restart=function(){if(this._cbs.onreset)this._cbs.onreset();for(var i=0,len=this.events.length;i<len;i++){if(this._cbs[this.events[i][0]]){var num=this.events[i].length;if(num===1){this._cbs[this.events[i][0]]();}else if(num===2){this._cbs[this.events[i][0]](this.events[i][1]);}else{this._cbs[this.events[i][0]](this.events[i][1],this.events[i][2]);}}}};},{'./':69}],63:[function(require,module,exports){var index=require('./index.js'),DomHandler=index.DomHandler,DomUtils=index.DomUtils;function FeedHandler(callback,options){this.init(callback,options);}require('inherits')(FeedHandler,DomHandler);FeedHandler.prototype.init=DomHandler;function getElements(what,where){return DomUtils.getElementsByTagName(what,where,true);}function getOneElement(what,where){return DomUtils.getElementsByTagName(what,where,true,1)[0];}function fetch(what,where,recurse){return DomUtils.getText(DomUtils.getElementsByTagName(what,where,recurse,1)).trim();}function addConditionally(obj,prop,what,where,recurse){var tmp=fetch(what,where,recurse);if(tmp)obj[prop]=tmp;}var isValidFeed=function(value){return value==='rss'||value==='feed'||value==='rdf:RDF';};FeedHandler.prototype.onend=function(){var feed={},feedRoot=getOneElement(isValidFeed,this.dom),tmp,childs;if(feedRoot){if(feedRoot.name==='feed'){childs=feedRoot.children;feed.type='atom';addConditionally(feed,'id','id',childs);addConditionally(feed,'title','title',childs);if((tmp=getOneElement('link',childs))&&(tmp=tmp.attribs)&&(tmp=tmp.href))feed.link=tmp;addConditionally(feed,'description','subtitle',childs);if(tmp=fetch('updated',childs))feed.updated=new Date(tmp);addConditionally(feed,'author','email',childs,true);feed.items=getElements('entry',childs).map(function(item){var entry={},tmp;item=item.children;addConditionally(entry,'id','id',item);addConditionally(entry,'title','title',item);if((tmp=getOneElement('link',item))&&(tmp=tmp.attribs)&&(tmp=tmp.href))entry.link=tmp;if(tmp=fetch('summary',item)||fetch('content',item))entry.description=tmp;if(tmp=fetch('updated',item))entry.pubDate=new Date(tmp);return entry;});}else{childs=getOneElement('channel',feedRoot.children).children;feed.type=feedRoot.name.substr(0,3);feed.id='';addConditionally(feed,'title','title',childs);addConditionally(feed,'link','link',childs);addConditionally(feed,'description','description',childs);if(tmp=fetch('lastBuildDate',childs))feed.updated=new Date(tmp);addConditionally(feed,'author','managingEditor',childs,true);feed.items=getElements('item',feedRoot.children).map(function(item){var entry={},tmp;item=item.children;addConditionally(entry,'id','guid',item);addConditionally(entry,'title','title',item);addConditionally(entry,'link','link',item);addConditionally(entry,'description','description',item);if(tmp=fetch('pubDate',item))entry.pubDate=new Date(tmp);return entry;});}}this.dom=feed;DomHandler.prototype._handleCallback.call(this,feedRoot?null:Error('couldn\'t find root of feed'));};module.exports=FeedHandler;},{'./index.js':69,'inherits':74}],64:[function(require,module,exports){var Tokenizer=require('./Tokenizer.js');var formTags={input:true,option:true,optgroup:true,select:true,button:true,datalist:true,textarea:true};var openImpliesClose={tr:{tr:true,th:true,td:true},th:{th:true},td:{thead:true,th:true,td:true},body:{head:true,link:true,script:true},li:{li:true},p:{p:true},h1:{p:true},h2:{p:true},h3:{p:true},h4:{p:true},h5:{p:true},h6:{p:true},select:formTags,input:formTags,output:formTags,button:formTags,datalist:formTags,textarea:formTags,option:{option:true},optgroup:{optgroup:true}};var voidElements={__proto__:null,area:true,base:true,basefont:true,br:true,col:true,command:true,embed:true,frame:true,hr:true,img:true,input:true,isindex:true,keygen:true,link:true,meta:true,param:true,source:true,track:true,wbr:true,path:true,circle:true,ellipse:true,line:true,rect:true,use:true,stop:true,polyline:true,polygon:true};var re_nameEnd=/\s|\//;function Parser(cbs,options){this._options=options||{};this._cbs=cbs||{};this._tagname='';this._attribname='';this._attribvalue='';this._attribs=null;this._stack=[];this.startIndex=0;this.endIndex=null;this._lowerCaseTagNames='lowerCaseTags'in this._options?!!this._options.lowerCaseTags:!this._options.xmlMode;this._lowerCaseAttributeNames='lowerCaseAttributeNames'in this._options?!!this._options.lowerCaseAttributeNames:!this._options.xmlMode;if(this._options.Tokenizer){Tokenizer=this._options.Tokenizer;}this._tokenizer=new Tokenizer(this._options,this);if(this._cbs.onparserinit)this._cbs.onparserinit(this);}require('inherits')(Parser,require('events').EventEmitter);Parser.prototype._updatePosition=function(initialOffset){if(this.endIndex===null){if(this._tokenizer._sectionStart<=initialOffset){this.startIndex=0;}else{this.startIndex=this._tokenizer._sectionStart-initialOffset;}}else this.startIndex=this.endIndex+1;this.endIndex=this._tokenizer.getAbsoluteIndex();};Parser.prototype.ontext=function(data){this._updatePosition(1);this.endIndex--;if(this._cbs.ontext)this._cbs.ontext(data);};Parser.prototype.onopentagname=function(name){if(this._lowerCaseTagNames){name=name.toLowerCase();}this._tagname=name;if(!this._options.xmlMode&&name in openImpliesClose){for(var el;(el=this._stack[this._stack.length-1])in openImpliesClose[name];this.onclosetag(el));}if(this._options.xmlMode||!(name in voidElements)){this._stack.push(name);}if(this._cbs.onopentagname)this._cbs.onopentagname(name);if(this._cbs.onopentag)this._attribs={};};Parser.prototype.onopentagend=function(){this._updatePosition(1);if(this._attribs){if(this._cbs.onopentag)this._cbs.onopentag(this._tagname,this._attribs);this._attribs=null;}if(!this._options.xmlMode&&this._cbs.onclosetag&&this._tagname in voidElements){this._cbs.onclosetag(this._tagname);}this._tagname='';};Parser.prototype.onclosetag=function(name){this._updatePosition(1);if(this._lowerCaseTagNames){name=name.toLowerCase();}if(this._stack.length&&(!(name in voidElements)||this._options.xmlMode)){var pos=this._stack.lastIndexOf(name);if(pos!==-1){if(this._cbs.onclosetag){pos=this._stack.length-pos;while(pos--)this._cbs.onclosetag(this._stack.pop());}else this._stack.length=pos;}else if(name==='p'&&!this._options.xmlMode){this.onopentagname(name);this._closeCurrentTag();}}else if(!this._options.xmlMode&&(name==='br'||name==='p')){this.onopentagname(name);this._closeCurrentTag();}};Parser.prototype.onselfclosingtag=function(){if(this._options.xmlMode||this._options.recognizeSelfClosing){this._closeCurrentTag();}else{this.onopentagend();}};Parser.prototype._closeCurrentTag=function(){var name=this._tagname;this.onopentagend();if(this._stack[this._stack.length-1]===name){if(this._cbs.onclosetag){this._cbs.onclosetag(name);}this._stack.pop();}};Parser.prototype.onattribname=function(name){if(this._lowerCaseAttributeNames){name=name.toLowerCase();}this._attribname=name;};Parser.prototype.onattribdata=function(value){this._attribvalue+=value;};Parser.prototype.onattribend=function(){if(this._cbs.onattribute)this._cbs.onattribute(this._attribname,this._attribvalue);if(this._attribs&&!Object.prototype.hasOwnProperty.call(this._attribs,this._attribname)){this._attribs[this._attribname]=this._attribvalue;}this._attribname='';this._attribvalue='';};Parser.prototype._getInstructionName=function(value){var idx=value.search(re_nameEnd),name=idx<0?value:value.substr(0,idx);if(this._lowerCaseTagNames){name=name.toLowerCase();}return name;};Parser.prototype.ondeclaration=function(value){if(this._cbs.onprocessinginstruction){var name=this._getInstructionName(value);this._cbs.onprocessinginstruction('!'+name,'!'+value);}};Parser.prototype.onprocessinginstruction=function(value){if(this._cbs.onprocessinginstruction){var name=this._getInstructionName(value);this._cbs.onprocessinginstruction('?'+name,'?'+value);}};Parser.prototype.oncomment=function(value){this._updatePosition(4);if(this._cbs.oncomment)this._cbs.oncomment(value);if(this._cbs.oncommentend)this._cbs.oncommentend();};Parser.prototype.oncdata=function(value){this._updatePosition(1);if(this._options.xmlMode||this._options.recognizeCDATA){if(this._cbs.oncdatastart)this._cbs.oncdatastart();if(this._cbs.ontext)this._cbs.ontext(value);if(this._cbs.oncdataend)this._cbs.oncdataend();}else{this.oncomment('[CDATA['+value+']]');}};Parser.prototype.onerror=function(err){if(this._cbs.onerror)this._cbs.onerror(err);};Parser.prototype.onend=function(){if(this._cbs.onclosetag){for(var i=this._stack.length;i>0;this._cbs.onclosetag(this._stack[--i]));}if(this._cbs.onend)this._cbs.onend();};Parser.prototype.reset=function(){if(this._cbs.onreset)this._cbs.onreset();this._tokenizer.reset();this._tagname='';this._attribname='';this._attribs=null;this._stack=[];if(this._cbs.onparserinit)this._cbs.onparserinit(this);};Parser.prototype.parseComplete=function(data){this.reset();this.end(data);};Parser.prototype.write=function(chunk){this._tokenizer.write(chunk);};Parser.prototype.end=function(chunk){this._tokenizer.end(chunk);};Parser.prototype.pause=function(){this._tokenizer.pause();};Parser.prototype.resume=function(){this._tokenizer.resume();};Parser.prototype.parseChunk=Parser.prototype.write;Parser.prototype.done=Parser.prototype.end;module.exports=Parser;},{'./Tokenizer.js':67,'events':60,'inherits':74}],65:[function(require,module,exports){module.exports=ProxyHandler;function ProxyHandler(cbs){this._cbs=cbs||{};}var EVENTS=require('./').EVENTS;Object.keys(EVENTS).forEach(function(name){if(EVENTS[name]===0){name='on'+name;ProxyHandler.prototype[name]=function(){if(this._cbs[name])this._cbs[name]();};}else if(EVENTS[name]===1){name='on'+name;ProxyHandler.prototype[name]=function(a){if(this._cbs[name])this._cbs[name](a);};}else if(EVENTS[name]===2){name='on'+name;ProxyHandler.prototype[name]=function(a,b){if(this._cbs[name])this._cbs[name](a,b);};}else{throw Error('wrong number of arguments');}});},{'./':69}],66:[function(require,module,exports){module.exports=Stream;var Parser=require('./WritableStream.js');function Stream(options){Parser.call(this,new Cbs(this),options);}require('inherits')(Stream,Parser);Stream.prototype.readable=true;function Cbs(scope){this.scope=scope;}var EVENTS=require('../').EVENTS;Object.keys(EVENTS).forEach(function(name){if(EVENTS[name]===0){Cbs.prototype['on'+name]=function(){this.scope.emit(name);};}else if(EVENTS[name]===1){Cbs.prototype['on'+name]=function(a){this.scope.emit(name,a);};}else if(EVENTS[name]===2){Cbs.prototype['on'+name]=function(a,b){this.scope.emit(name,a,b);};}else{throw Error('wrong number of arguments!');}});},{'../':69,'./WritableStream.js':68,'inherits':74}],67:[function(require,module,exports){module.exports=Tokenizer;var decodeCodePoint=require('entities/lib/decode_codepoint.js'),entityMap=require('entities/maps/entities.json'),legacyMap=require('entities/maps/legacy.json'),xmlMap=require('entities/maps/xml.json'),i=0,TEXT=i++,BEFORE_TAG_NAME=i++,IN_TAG_NAME=i++,IN_SELF_CLOSING_TAG=i++,BEFORE_CLOSING_TAG_NAME=i++,IN_CLOSING_TAG_NAME=i++,AFTER_CLOSING_TAG_NAME=i++,BEFORE_ATTRIBUTE_NAME=i++,IN_ATTRIBUTE_NAME=i++,AFTER_ATTRIBUTE_NAME=i++,BEFORE_ATTRIBUTE_VALUE=i++,IN_ATTRIBUTE_VALUE_DQ=i++,IN_ATTRIBUTE_VALUE_SQ=i++,IN_ATTRIBUTE_VALUE_NQ=i++,BEFORE_DECLARATION=i++,IN_DECLARATION=i++,IN_PROCESSING_INSTRUCTION=i++,BEFORE_COMMENT=i++,IN_COMMENT=i++,AFTER_COMMENT_1=i++,AFTER_COMMENT_2=i++,BEFORE_CDATA_1=i++,BEFORE_CDATA_2=i++,BEFORE_CDATA_3=i++,BEFORE_CDATA_4=i++,BEFORE_CDATA_5=i++,BEFORE_CDATA_6=i++,IN_CDATA=i++,AFTER_CDATA_1=i++,AFTER_CDATA_2=i++,BEFORE_SPECIAL=i++,BEFORE_SPECIAL_END=i++,BEFORE_SCRIPT_1=i++,BEFORE_SCRIPT_2=i++,BEFORE_SCRIPT_3=i++,BEFORE_SCRIPT_4=i++,BEFORE_SCRIPT_5=i++,AFTER_SCRIPT_1=i++,AFTER_SCRIPT_2=i++,AFTER_SCRIPT_3=i++,AFTER_SCRIPT_4=i++,AFTER_SCRIPT_5=i++,BEFORE_STYLE_1=i++,BEFORE_STYLE_2=i++,BEFORE_STYLE_3=i++,BEFORE_STYLE_4=i++,AFTER_STYLE_1=i++,AFTER_STYLE_2=i++,AFTER_STYLE_3=i++,AFTER_STYLE_4=i++,BEFORE_ENTITY=i++,BEFORE_NUMERIC_ENTITY=i++,IN_NAMED_ENTITY=i++,IN_NUMERIC_ENTITY=i++,IN_HEX_ENTITY=i++,j=0,SPECIAL_NONE=j++,SPECIAL_SCRIPT=j++,SPECIAL_STYLE=j++;function whitespace(c){return c===' '||c==='\n'||c==='\t'||c==='\f'||c==='\r';}function characterState(char,SUCCESS){return function(c){if(c===char)this._state=SUCCESS;};}function ifElseState(upper,SUCCESS,FAILURE){var lower=upper.toLowerCase();if(upper===lower){return function(c){if(c===lower){this._state=SUCCESS;}else{this._state=FAILURE;this._index--;}};}else{return function(c){if(c===lower||c===upper){this._state=SUCCESS;}else{this._state=FAILURE;this._index--;}};}}function consumeSpecialNameChar(upper,NEXT_STATE){var lower=upper.toLowerCase();return function(c){if(c===lower||c===upper){this._state=NEXT_STATE;}else{this._state=IN_TAG_NAME;this._index--;}};}function Tokenizer(options,cbs){this._state=TEXT;this._buffer='';this._sectionStart=0;this._index=0;this._bufferOffset=0;this._baseState=TEXT;this._special=SPECIAL_NONE;this._cbs=cbs;this._running=true;this._ended=false;this._xmlMode=!!(options&&options.xmlMode);this._decodeEntities=!!(options&&options.decodeEntities);}Tokenizer.prototype._stateText=function(c){if(c==='<'){if(this._index>this._sectionStart){this._cbs.ontext(this._getSection());}this._state=BEFORE_TAG_NAME;this._sectionStart=this._index;}else if(this._decodeEntities&&this._special===SPECIAL_NONE&&c==='&'){if(this._index>this._sectionStart){this._cbs.ontext(this._getSection());}this._baseState=TEXT;this._state=BEFORE_ENTITY;this._sectionStart=this._index;}};Tokenizer.prototype._stateBeforeTagName=function(c){if(c==='/'){this._state=BEFORE_CLOSING_TAG_NAME;}else if(c==='<'){this._cbs.ontext(this._getSection());this._sectionStart=this._index;}else if(c==='>'||this._special!==SPECIAL_NONE||whitespace(c)){this._state=TEXT;}else if(c==='!'){this._state=BEFORE_DECLARATION;this._sectionStart=this._index+1;}else if(c==='?'){this._state=IN_PROCESSING_INSTRUCTION;this._sectionStart=this._index+1;}else{this._state=!this._xmlMode&&(c==='s'||c==='S')?BEFORE_SPECIAL:IN_TAG_NAME;this._sectionStart=this._index;}};Tokenizer.prototype._stateInTagName=function(c){if(c==='/'||c==='>'||whitespace(c)){this._emitToken('onopentagname');this._state=BEFORE_ATTRIBUTE_NAME;this._index--;}};Tokenizer.prototype._stateBeforeCloseingTagName=function(c){if(whitespace(c));else if(c==='>'){this._state=TEXT;}else if(this._special!==SPECIAL_NONE){if(c==='s'||c==='S'){this._state=BEFORE_SPECIAL_END;}else{this._state=TEXT;this._index--;}}else{this._state=IN_CLOSING_TAG_NAME;this._sectionStart=this._index;}};Tokenizer.prototype._stateInCloseingTagName=function(c){if(c==='>'||whitespace(c)){this._emitToken('onclosetag');this._state=AFTER_CLOSING_TAG_NAME;this._index--;}};Tokenizer.prototype._stateAfterCloseingTagName=function(c){if(c==='>'){this._state=TEXT;this._sectionStart=this._index+1;}};Tokenizer.prototype._stateBeforeAttributeName=function(c){if(c==='>'){this._cbs.onopentagend();this._state=TEXT;this._sectionStart=this._index+1;}else if(c==='/'){this._state=IN_SELF_CLOSING_TAG;}else if(!whitespace(c)){this._state=IN_ATTRIBUTE_NAME;this._sectionStart=this._index;}};Tokenizer.prototype._stateInSelfClosingTag=function(c){if(c==='>'){this._cbs.onselfclosingtag();this._state=TEXT;this._sectionStart=this._index+1;}else if(!whitespace(c)){this._state=BEFORE_ATTRIBUTE_NAME;this._index--;}};Tokenizer.prototype._stateInAttributeName=function(c){if(c==='='||c==='/'||c==='>'||whitespace(c)){this._cbs.onattribname(this._getSection());this._sectionStart=-1;this._state=AFTER_ATTRIBUTE_NAME;this._index--;}};Tokenizer.prototype._stateAfterAttributeName=function(c){if(c==='='){this._state=BEFORE_ATTRIBUTE_VALUE;}else if(c==='/'||c==='>'){this._cbs.onattribend();this._state=BEFORE_ATTRIBUTE_NAME;this._index--;}else if(!whitespace(c)){this._cbs.onattribend();this._state=IN_ATTRIBUTE_NAME;this._sectionStart=this._index;}};Tokenizer.prototype._stateBeforeAttributeValue=function(c){if(c==='"'){this._state=IN_ATTRIBUTE_VALUE_DQ;this._sectionStart=this._index+1;}else if(c==='\''){this._state=IN_ATTRIBUTE_VALUE_SQ;this._sectionStart=this._index+1;}else if(!whitespace(c)){this._state=IN_ATTRIBUTE_VALUE_NQ;this._sectionStart=this._index;this._index--;}};Tokenizer.prototype._stateInAttributeValueDoubleQuotes=function(c){if(c==='"'){this._emitToken('onattribdata');this._cbs.onattribend();this._state=BEFORE_ATTRIBUTE_NAME;}else if(this._decodeEntities&&c==='&'){this._emitToken('onattribdata');this._baseState=this._state;this._state=BEFORE_ENTITY;this._sectionStart=this._index;}};Tokenizer.prototype._stateInAttributeValueSingleQuotes=function(c){if(c==='\''){this._emitToken('onattribdata');this._cbs.onattribend();this._state=BEFORE_ATTRIBUTE_NAME;}else if(this._decodeEntities&&c==='&'){this._emitToken('onattribdata');this._baseState=this._state;this._state=BEFORE_ENTITY;this._sectionStart=this._index;}};Tokenizer.prototype._stateInAttributeValueNoQuotes=function(c){if(whitespace(c)||c==='>'){this._emitToken('onattribdata');this._cbs.onattribend();this._state=BEFORE_ATTRIBUTE_NAME;this._index--;}else if(this._decodeEntities&&c==='&'){this._emitToken('onattribdata');this._baseState=this._state;this._state=BEFORE_ENTITY;this._sectionStart=this._index;}};Tokenizer.prototype._stateBeforeDeclaration=function(c){this._state=c==='['?BEFORE_CDATA_1:c==='-'?BEFORE_COMMENT:IN_DECLARATION;};Tokenizer.prototype._stateInDeclaration=function(c){if(c==='>'){this._cbs.ondeclaration(this._getSection());this._state=TEXT;this._sectionStart=this._index+1;}};Tokenizer.prototype._stateInProcessingInstruction=function(c){if(c==='>'){this._cbs.onprocessinginstruction(this._getSection());this._state=TEXT;this._sectionStart=this._index+1;}};Tokenizer.prototype._stateBeforeComment=function(c){if(c==='-'){this._state=IN_COMMENT;this._sectionStart=this._index+1;}else{this._state=IN_DECLARATION;}};Tokenizer.prototype._stateInComment=function(c){if(c==='-')this._state=AFTER_COMMENT_1;};Tokenizer.prototype._stateAfterComment1=function(c){if(c==='-'){this._state=AFTER_COMMENT_2;}else{this._state=IN_COMMENT;}};Tokenizer.prototype._stateAfterComment2=function(c){if(c==='>'){this._cbs.oncomment(this._buffer.substring(this._sectionStart,this._index-2));this._state=TEXT;this._sectionStart=this._index+1;}else if(c!=='-'){this._state=IN_COMMENT;}};Tokenizer.prototype._stateBeforeCdata1=ifElseState('C',BEFORE_CDATA_2,IN_DECLARATION);Tokenizer.prototype._stateBeforeCdata2=ifElseState('D',BEFORE_CDATA_3,IN_DECLARATION);Tokenizer.prototype._stateBeforeCdata3=ifElseState('A',BEFORE_CDATA_4,IN_DECLARATION);Tokenizer.prototype._stateBeforeCdata4=ifElseState('T',BEFORE_CDATA_5,IN_DECLARATION);Tokenizer.prototype._stateBeforeCdata5=ifElseState('A',BEFORE_CDATA_6,IN_DECLARATION);Tokenizer.prototype._stateBeforeCdata6=function(c){if(c==='['){this._state=IN_CDATA;this._sectionStart=this._index+1;}else{this._state=IN_DECLARATION;this._index--;}};Tokenizer.prototype._stateInCdata=function(c){if(c===']')this._state=AFTER_CDATA_1;};Tokenizer.prototype._stateAfterCdata1=characterState(']',AFTER_CDATA_2);Tokenizer.prototype._stateAfterCdata2=function(c){if(c==='>'){this._cbs.oncdata(this._buffer.substring(this._sectionStart,this._index-2));this._state=TEXT;this._sectionStart=this._index+1;}else if(c!==']'){this._state=IN_CDATA;}};Tokenizer.prototype._stateBeforeSpecial=function(c){if(c==='c'||c==='C'){this._state=BEFORE_SCRIPT_1;}else if(c==='t'||c==='T'){this._state=BEFORE_STYLE_1;}else{this._state=IN_TAG_NAME;this._index--;}};Tokenizer.prototype._stateBeforeSpecialEnd=function(c){if(this._special===SPECIAL_SCRIPT&&(c==='c'||c==='C')){this._state=AFTER_SCRIPT_1;}else if(this._special===SPECIAL_STYLE&&(c==='t'||c==='T')){this._state=AFTER_STYLE_1;}else this._state=TEXT;};Tokenizer.prototype._stateBeforeScript1=consumeSpecialNameChar('R',BEFORE_SCRIPT_2);Tokenizer.prototype._stateBeforeScript2=consumeSpecialNameChar('I',BEFORE_SCRIPT_3);Tokenizer.prototype._stateBeforeScript3=consumeSpecialNameChar('P',BEFORE_SCRIPT_4);Tokenizer.prototype._stateBeforeScript4=consumeSpecialNameChar('T',BEFORE_SCRIPT_5);Tokenizer.prototype._stateBeforeScript5=function(c){if(c==='/'||c==='>'||whitespace(c)){this._special=SPECIAL_SCRIPT;}this._state=IN_TAG_NAME;this._index--;};Tokenizer.prototype._stateAfterScript1=ifElseState('R',AFTER_SCRIPT_2,TEXT);Tokenizer.prototype._stateAfterScript2=ifElseState('I',AFTER_SCRIPT_3,TEXT);Tokenizer.prototype._stateAfterScript3=ifElseState('P',AFTER_SCRIPT_4,TEXT);Tokenizer.prototype._stateAfterScript4=ifElseState('T',AFTER_SCRIPT_5,TEXT);Tokenizer.prototype._stateAfterScript5=function(c){if(c==='>'||whitespace(c)){this._special=SPECIAL_NONE;this._state=IN_CLOSING_TAG_NAME;this._sectionStart=this._index-6;this._index--;}else this._state=TEXT;};Tokenizer.prototype._stateBeforeStyle1=consumeSpecialNameChar('Y',BEFORE_STYLE_2);Tokenizer.prototype._stateBeforeStyle2=consumeSpecialNameChar('L',BEFORE_STYLE_3);Tokenizer.prototype._stateBeforeStyle3=consumeSpecialNameChar('E',BEFORE_STYLE_4);Tokenizer.prototype._stateBeforeStyle4=function(c){if(c==='/'||c==='>'||whitespace(c)){this._special=SPECIAL_STYLE;}this._state=IN_TAG_NAME;this._index--;};Tokenizer.prototype._stateAfterStyle1=ifElseState('Y',AFTER_STYLE_2,TEXT);Tokenizer.prototype._stateAfterStyle2=ifElseState('L',AFTER_STYLE_3,TEXT);Tokenizer.prototype._stateAfterStyle3=ifElseState('E',AFTER_STYLE_4,TEXT);Tokenizer.prototype._stateAfterStyle4=function(c){if(c==='>'||whitespace(c)){this._special=SPECIAL_NONE;this._state=IN_CLOSING_TAG_NAME;this._sectionStart=this._index-5;this._index--;}else this._state=TEXT;};Tokenizer.prototype._stateBeforeEntity=ifElseState('#',BEFORE_NUMERIC_ENTITY,IN_NAMED_ENTITY);Tokenizer.prototype._stateBeforeNumericEntity=ifElseState('X',IN_HEX_ENTITY,IN_NUMERIC_ENTITY);Tokenizer.prototype._parseNamedEntityStrict=function(){if(this._sectionStart+1<this._index){var entity=this._buffer.substring(this._sectionStart+1,this._index),map=this._xmlMode?xmlMap:entityMap;if(map.hasOwnProperty(entity)){this._emitPartial(map[entity]);this._sectionStart=this._index+1;}}};Tokenizer.prototype._parseLegacyEntity=function(){var start=this._sectionStart+1,limit=this._index-start;if(limit>6)limit=6;while(limit>=2){var entity=this._buffer.substr(start,limit);if(legacyMap.hasOwnProperty(entity)){this._emitPartial(legacyMap[entity]);this._sectionStart+=limit+1;return;}else{limit--;}}};Tokenizer.prototype._stateInNamedEntity=function(c){if(c===';'){this._parseNamedEntityStrict();if(this._sectionStart+1<this._index&&!this._xmlMode){this._parseLegacyEntity();}this._state=this._baseState;}else if((c<'a'||c>'z')&&(c<'A'||c>'Z')&&(c<'0'||c>'9')){if(this._xmlMode);else if(this._sectionStart+1===this._index);else if(this._baseState!==TEXT){if(c!=='='){this._parseNamedEntityStrict();}}else{this._parseLegacyEntity();}this._state=this._baseState;this._index--;}};Tokenizer.prototype._decodeNumericEntity=function(offset,base){var sectionStart=this._sectionStart+offset;if(sectionStart!==this._index){var entity=this._buffer.substring(sectionStart,this._index);var parsed=parseInt(entity,base);this._emitPartial(decodeCodePoint(parsed));this._sectionStart=this._index;}else{this._sectionStart--;}this._state=this._baseState;};Tokenizer.prototype._stateInNumericEntity=function(c){if(c===';'){this._decodeNumericEntity(2,10);this._sectionStart++;}else if(c<'0'||c>'9'){if(!this._xmlMode){this._decodeNumericEntity(2,10);}else{this._state=this._baseState;}this._index--;}};Tokenizer.prototype._stateInHexEntity=function(c){if(c===';'){this._decodeNumericEntity(3,16);this._sectionStart++;}else if((c<'a'||c>'f')&&(c<'A'||c>'F')&&(c<'0'||c>'9')){if(!this._xmlMode){this._decodeNumericEntity(3,16);}else{this._state=this._baseState;}this._index--;}};Tokenizer.prototype._cleanup=function(){if(this._sectionStart<0){this._buffer='';this._bufferOffset+=this._index;this._index=0;}else if(this._running){if(this._state===TEXT){if(this._sectionStart!==this._index){this._cbs.ontext(this._buffer.substr(this._sectionStart));}this._buffer='';this._bufferOffset+=this._index;this._index=0;}else if(this._sectionStart===this._index){this._buffer='';this._bufferOffset+=this._index;this._index=0;}else{this._buffer=this._buffer.substr(this._sectionStart);this._index-=this._sectionStart;this._bufferOffset+=this._sectionStart;}this._sectionStart=0;}};Tokenizer.prototype.write=function(chunk){if(this._ended)this._cbs.onerror(Error('.write() after done!'));this._buffer+=chunk;this._parse();};Tokenizer.prototype._parse=function(){while(this._index<this._buffer.length&&this._running){var c=this._buffer.charAt(this._index);if(this._state===TEXT){this._stateText(c);}else if(this._state===BEFORE_TAG_NAME){this._stateBeforeTagName(c);}else if(this._state===IN_TAG_NAME){this._stateInTagName(c);}else if(this._state===BEFORE_CLOSING_TAG_NAME){this._stateBeforeCloseingTagName(c);}else if(this._state===IN_CLOSING_TAG_NAME){this._stateInCloseingTagName(c);}else if(this._state===AFTER_CLOSING_TAG_NAME){this._stateAfterCloseingTagName(c);}else if(this._state===IN_SELF_CLOSING_TAG){this._stateInSelfClosingTag(c);}else if(this._state===BEFORE_ATTRIBUTE_NAME){this._stateBeforeAttributeName(c);}else if(this._state===IN_ATTRIBUTE_NAME){this._stateInAttributeName(c);}else if(this._state===AFTER_ATTRIBUTE_NAME){this._stateAfterAttributeName(c);}else if(this._state===BEFORE_ATTRIBUTE_VALUE){this._stateBeforeAttributeValue(c);}else if(this._state===IN_ATTRIBUTE_VALUE_DQ){this._stateInAttributeValueDoubleQuotes(c);}else if(this._state===IN_ATTRIBUTE_VALUE_SQ){this._stateInAttributeValueSingleQuotes(c);}else if(this._state===IN_ATTRIBUTE_VALUE_NQ){this._stateInAttributeValueNoQuotes(c);}else if(this._state===BEFORE_DECLARATION){this._stateBeforeDeclaration(c);}else if(this._state===IN_DECLARATION){this._stateInDeclaration(c);}else if(this._state===IN_PROCESSING_INSTRUCTION){this._stateInProcessingInstruction(c);}else if(this._state===BEFORE_COMMENT){this._stateBeforeComment(c);}else if(this._state===IN_COMMENT){this._stateInComment(c);}else if(this._state===AFTER_COMMENT_1){this._stateAfterComment1(c);}else if(this._state===AFTER_COMMENT_2){this._stateAfterComment2(c);}else if(this._state===BEFORE_CDATA_1){this._stateBeforeCdata1(c);}else if(this._state===BEFORE_CDATA_2){this._stateBeforeCdata2(c);}else if(this._state===BEFORE_CDATA_3){this._stateBeforeCdata3(c);}else if(this._state===BEFORE_CDATA_4){this._stateBeforeCdata4(c);}else if(this._state===BEFORE_CDATA_5){this._stateBeforeCdata5(c);}else if(this._state===BEFORE_CDATA_6){this._stateBeforeCdata6(c);}else if(this._state===IN_CDATA){this._stateInCdata(c);}else if(this._state===AFTER_CDATA_1){this._stateAfterCdata1(c);}else if(this._state===AFTER_CDATA_2){this._stateAfterCdata2(c);}else if(this._state===BEFORE_SPECIAL){this._stateBeforeSpecial(c);}else if(this._state===BEFORE_SPECIAL_END){this._stateBeforeSpecialEnd(c);}else if(this._state===BEFORE_SCRIPT_1){this._stateBeforeScript1(c);}else if(this._state===BEFORE_SCRIPT_2){this._stateBeforeScript2(c);}else if(this._state===BEFORE_SCRIPT_3){this._stateBeforeScript3(c);}else if(this._state===BEFORE_SCRIPT_4){this._stateBeforeScript4(c);}else if(this._state===BEFORE_SCRIPT_5){this._stateBeforeScript5(c);}else if(this._state===AFTER_SCRIPT_1){this._stateAfterScript1(c);}else if(this._state===AFTER_SCRIPT_2){this._stateAfterScript2(c);}else if(this._state===AFTER_SCRIPT_3){this._stateAfterScript3(c);}else if(this._state===AFTER_SCRIPT_4){this._stateAfterScript4(c);}else if(this._state===AFTER_SCRIPT_5){this._stateAfterScript5(c);}else if(this._state===BEFORE_STYLE_1){this._stateBeforeStyle1(c);}else if(this._state===BEFORE_STYLE_2){this._stateBeforeStyle2(c);}else if(this._state===BEFORE_STYLE_3){this._stateBeforeStyle3(c);}else if(this._state===BEFORE_STYLE_4){this._stateBeforeStyle4(c);}else if(this._state===AFTER_STYLE_1){this._stateAfterStyle1(c);}else if(this._state===AFTER_STYLE_2){this._stateAfterStyle2(c);}else if(this._state===AFTER_STYLE_3){this._stateAfterStyle3(c);}else if(this._state===AFTER_STYLE_4){this._stateAfterStyle4(c);}else if(this._state===BEFORE_ENTITY){this._stateBeforeEntity(c);}else if(this._state===BEFORE_NUMERIC_ENTITY){this._stateBeforeNumericEntity(c);}else if(this._state===IN_NAMED_ENTITY){this._stateInNamedEntity(c);}else if(this._state===IN_NUMERIC_ENTITY){this._stateInNumericEntity(c);}else if(this._state===IN_HEX_ENTITY){this._stateInHexEntity(c);}else{this._cbs.onerror(Error('unknown _state'),this._state);}this._index++;}this._cleanup();};Tokenizer.prototype.pause=function(){this._running=false;};Tokenizer.prototype.resume=function(){this._running=true;if(this._index<this._buffer.length){this._parse();}if(this._ended){this._finish();}};Tokenizer.prototype.end=function(chunk){if(this._ended)this._cbs.onerror(Error('.end() after done!'));if(chunk)this.write(chunk);this._ended=true;if(this._running)this._finish();};Tokenizer.prototype._finish=function(){if(this._sectionStart<this._index){this._handleTrailingData();}this._cbs.onend();};Tokenizer.prototype._handleTrailingData=function(){var data=this._buffer.substr(this._sectionStart);if(this._state===IN_CDATA||this._state===AFTER_CDATA_1||this._state===AFTER_CDATA_2){this._cbs.oncdata(data);}else if(this._state===IN_COMMENT||this._state===AFTER_COMMENT_1||this._state===AFTER_COMMENT_2){this._cbs.oncomment(data);}else if(this._state===IN_NAMED_ENTITY&&!this._xmlMode){this._parseLegacyEntity();if(this._sectionStart<this._index){this._state=this._baseState;this._handleTrailingData();}}else if(this._state===IN_NUMERIC_ENTITY&&!this._xmlMode){this._decodeNumericEntity(2,10);if(this._sectionStart<this._index){this._state=this._baseState;this._handleTrailingData();}}else if(this._state===IN_HEX_ENTITY&&!this._xmlMode){this._decodeNumericEntity(3,16);if(this._sectionStart<this._index){this._state=this._baseState;this._handleTrailingData();}}else if(this._state!==IN_TAG_NAME&&this._state!==BEFORE_ATTRIBUTE_NAME&&this._state!==BEFORE_ATTRIBUTE_VALUE&&this._state!==AFTER_ATTRIBUTE_NAME&&this._state!==IN_ATTRIBUTE_NAME&&this._state!==IN_ATTRIBUTE_VALUE_SQ&&this._state!==IN_ATTRIBUTE_VALUE_DQ&&this._state!==IN_ATTRIBUTE_VALUE_NQ&&this._state!==IN_CLOSING_TAG_NAME){this._cbs.ontext(data);}};Tokenizer.prototype.reset=function(){Tokenizer.call(this,{xmlMode:this._xmlMode,decodeEntities:this._decodeEntities},this._cbs);};Tokenizer.prototype.getAbsoluteIndex=function(){return this._bufferOffset+this._index;};Tokenizer.prototype._getSection=function(){return this._buffer.substring(this._sectionStart,this._index);};Tokenizer.prototype._emitToken=function(name){this._cbs[name](this._getSection());this._sectionStart=-1;};Tokenizer.prototype._emitPartial=function(value){if(this._baseState!==TEXT){this._cbs.onattribdata(value);}else{this._cbs.ontext(value);}};},{'entities/lib/decode_codepoint.js':39,'entities/maps/entities.json':41,'entities/maps/legacy.json':42,'entities/maps/xml.json':43}],68:[function(require,module,exports){module.exports=Stream;var Parser=require('./Parser.js'),WritableStream=require('stream').Writable||require('readable-stream').Writable,StringDecoder=require('string_decoder').StringDecoder,Buffer=require('buffer').Buffer;function Stream(cbs,options){var parser=this._parser=new Parser(cbs,options);var decoder=this._decoder=new StringDecoder();WritableStream.call(this,{decodeStrings:false});this.once('finish',function(){parser.end(decoder.end());});}require('inherits')(Stream,WritableStream);WritableStream.prototype._write=function(chunk,encoding,cb){if(chunk instanceof Buffer)chunk=this._decoder.write(chunk);this._parser.write(chunk);cb();};},{'./Parser.js':64,'buffer':14,'inherits':74,'readable-stream':11,'stream':115,'string_decoder':13}],69:[function(require,module,exports){var Parser=require('./Parser.js'),DomHandler=require('domhandler');function defineProp(name,value){delete module.exports[name];module.exports[name]=value;return value;}module.exports={Parser:Parser,Tokenizer:require('./Tokenizer.js'),ElementType:require('domelementtype'),DomHandler:DomHandler,get FeedHandler(){return defineProp('FeedHandler',require('./FeedHandler.js'));},get Stream(){return defineProp('Stream',require('./Stream.js'));},get WritableStream(){return defineProp('WritableStream',require('./WritableStream.js'));},get ProxyHandler(){return defineProp('ProxyHandler',require('./ProxyHandler.js'));},get DomUtils(){return defineProp('DomUtils',require('domutils'));},get CollectingHandler(){return defineProp('CollectingHandler',require('./CollectingHandler.js'));},DefaultHandler:DomHandler,get RssHandler(){return defineProp('RssHandler',this.FeedHandler);},parseDOM:function(data,options){var handler=new DomHandler(options);new Parser(handler,options).end(data);return handler.dom;},parseFeed:function(feed,options){var handler=new module.exports.FeedHandler(options);new Parser(handler,options).end(feed);return handler.dom;},createDomStream:function(cb,options,elementCb){var handler=new DomHandler(cb,options,elementCb);return new Parser(handler,options);},EVENTS:{attribute:2,cdatastart:0,cdataend:0,text:1,processinginstruction:2,comment:1,commentend:0,closetag:1,opentag:2,opentagname:1,error:1,end:0}};},{'./CollectingHandler.js':62,'./FeedHandler.js':63,'./Parser.js':64,'./ProxyHandler.js':65,'./Stream.js':66,'./Tokenizer.js':67,'./WritableStream.js':68,'domelementtype':28,'domhandler':29,'domutils':32}],70:[function(require,module,exports){exports.read=function(buffer,offset,isLE,mLen,nBytes){var e,m;var eLen=nBytes*8-mLen-1;var eMax=(1<<eLen)-1;var eBias=eMax>>1;var nBits=-7;var i=isLE?nBytes-1:0;var d=isLE?-1:1;var s=buffer[offset+i];i+=d;e=s&(1<<-nBits)-1;s>>=-nBits;nBits+=eLen;for(;nBits>0;e=e*256+buffer[offset+i],i+=d,nBits-=8){}m=e&(1<<-nBits)-1;e>>=-nBits;nBits+=mLen;for(;nBits>0;m=m*256+buffer[offset+i],i+=d,nBits-=8){}if(e===0){e=1-eBias;}else if(e===eMax){return m?NaN:(s?-1:1)*Infinity;}else{m=m+Math.pow(2,mLen);e=e-eBias;}return(s?-1:1)*m*Math.pow(2,e-mLen);};exports.write=function(buffer,value,offset,isLE,mLen,nBytes){var e,m,c;var eLen=nBytes*8-mLen-1;var eMax=(1<<eLen)-1;var eBias=eMax>>1;var rt=mLen===23?Math.pow(2,-24)-Math.pow(2,-77):0;var i=isLE?0:nBytes-1;var d=isLE?1:-1;var s=value<0||value===0&&1/value<0?1:0;value=Math.abs(value);if(isNaN(value)||value===Infinity){m=isNaN(value)?1:0;e=eMax;}else{e=Math.floor(Math.log(value)/Math.LN2);if(value*(c=Math.pow(2,-e))<1){e--;c*=2;}if(e+eBias>=1){value+=rt/c;}else{value+=rt*Math.pow(2,1-eBias);}if(value*c>=2){e++;c/=2;}if(e+eBias>=eMax){m=0;e=eMax;}else if(e+eBias>=1){m=(value*c-1)*Math.pow(2,mLen);e=e+eBias;}else{m=value*Math.pow(2,eBias-1)*Math.pow(2,mLen);e=0;}}for(;mLen>=8;buffer[offset+i]=m&255,i+=d,m/=256,mLen-=8){}e=e<<mLen|m;eLen+=mLen;for(;eLen>0;buffer[offset+i]=e&255,i+=d,e/=256,eLen-=8){}buffer[offset+i-d]|=s*128;};},{}],71:[function(require,module,exports){'use strict';const assert=()=>true;const {tryURLParse,tryURLLikeSpecifierParse}=require('./utils.js');exports.parseFromString=(input,baseURL)=>{const parsed=JSON.parse(input);if(!isJSONObject(parsed)){throw new TypeError('Import map JSON must be an object.');}let sortedAndNormalizedImports={};if('imports'in parsed){if(!isJSONObject(parsed.imports)){throw new TypeError('Import map\'s imports value must be an object.');}sortedAndNormalizedImports=sortAndNormalizeSpecifierMap(parsed.imports,baseURL);}let sortedAndNormalizedScopes={};if('scopes'in parsed){if(!isJSONObject(parsed.scopes)){throw new TypeError('Import map\'s scopes value must be an object.');}sortedAndNormalizedScopes=sortAndNormalizeScopes(parsed.scopes,baseURL);}const badTopLevelKeys=new Set(Object.keys(parsed));badTopLevelKeys.delete('imports');badTopLevelKeys.delete('scopes');for(const badKey of badTopLevelKeys){console.warn(`Invalid top-level key "${badKey}". Only "imports" and "scopes" can be present.`);}return{imports:sortedAndNormalizedImports,scopes:sortedAndNormalizedScopes};};function sortAndNormalizeSpecifierMap(obj,baseURL){assert(isJSONObject(obj));const normalized={};for(const [specifierKey,value]of Object.entries(obj)){const normalizedSpecifierKey=normalizeSpecifierKey(specifierKey,baseURL);if(normalizedSpecifierKey===null){continue;}if(typeof value!=='string'){console.warn(`Invalid address ${JSON.stringify(value)} for the specifier key "${specifierKey}". `+`Addresses must be strings.`);continue;}const addressURL=tryURLLikeSpecifierParse(value,baseURL);if(addressURL===null){console.warn(`Invalid address "${value}" for the specifier key "${specifierKey}".`);continue;}if(specifierKey.endsWith('/')&&!addressURL.href.endsWith('/')){console.warn(`Invalid address "${addressURL.href}" for package specifier key "${specifierKey}". `+`Package addresses must end with "/".`);continue;}normalized[normalizedSpecifierKey]=addressURL;}const sortedAndNormalized={};const sortedKeys=Object.keys(normalized).sort((a,b)=>codeUnitCompare(b,a));for(const key of sortedKeys){sortedAndNormalized[key]=normalized[key];}return sortedAndNormalized;}function sortAndNormalizeScopes(obj,baseURL){const normalized={};for(const [scopePrefix,potentialSpecifierMap]of Object.entries(obj)){if(!isJSONObject(potentialSpecifierMap)){throw new TypeError(`The value for the "${scopePrefix}" scope prefix must be an object.`);}const scopePrefixURL=tryURLParse(scopePrefix,baseURL);if(scopePrefixURL===null){console.warn(`Invalid scope "${scopePrefix}" (parsed against base URL "${baseURL}").`);continue;}const normalizedScopePrefix=scopePrefixURL.href;normalized[normalizedScopePrefix]=sortAndNormalizeSpecifierMap(potentialSpecifierMap,baseURL);}const sortedAndNormalized={};const sortedKeys=Object.keys(normalized).sort((a,b)=>codeUnitCompare(b,a));for(const key of sortedKeys){sortedAndNormalized[key]=normalized[key];}return sortedAndNormalized;}function normalizeSpecifierKey(specifierKey,baseURL){if(specifierKey===''){console.warn(`Invalid empty string specifier key.`);return null;}const url=tryURLLikeSpecifierParse(specifierKey,baseURL);if(url!==null){return url.href;}return specifierKey;}function isJSONObject(value){return typeof value==='object'&&value!==null&&!Array.isArray(value);}function codeUnitCompare(a,b){if(a>b){return 1;}if(b>a){return-1;}throw new Error('This should never be reached because this is only used on JSON object keys');}},{'./utils.js':73}],72:[function(require,module,exports){'use strict';const assert=()=>true;const {tryURLLikeSpecifierParse,tryURLParse}=require('./utils.js');exports.resolve=(specifier,parsedImportMap,scriptURL)=>{const asURL=tryURLLikeSpecifierParse(specifier,scriptURL);const normalizedSpecifier=asURL?asURL.href:specifier;const scriptURLString=scriptURL.href;for(const [scopePrefix,scopeImports]of Object.entries(parsedImportMap.scopes)){if(scopePrefix===scriptURLString||scopePrefix.endsWith('/')&&scriptURLString.startsWith(scopePrefix)){const scopeImportsMatch=resolveImportsMatch(normalizedSpecifier,scopeImports);if(scopeImportsMatch!==null){return scopeImportsMatch;}}}const topLevelImportsMatch=resolveImportsMatch(normalizedSpecifier,parsedImportMap.imports);if(topLevelImportsMatch!==null){return topLevelImportsMatch;}if(asURL){return asURL;}throw new TypeError(`Unmapped bare specifier "${specifier}"`);};function resolveImportsMatch(normalizedSpecifier,specifierMap){for(const [specifierKey,address]of Object.entries(specifierMap)){if(specifierKey===normalizedSpecifier){return address;}if(specifierKey.endsWith('/')&&normalizedSpecifier.startsWith(specifierKey)){const afterPrefix=normalizedSpecifier.substring(specifierKey.length);assert(address.href.endsWith('/'));const url=tryURLParse(afterPrefix,address);if(url===null){return null;}return url;}}return null;}},{'./utils.js':73}],73:[function(require,module,exports){'use strict';exports.tryURLParse=(string,baseURL)=>{try{return new URL(string,baseURL);}catch(e){return null;}};exports.tryURLLikeSpecifierParse=(specifier,baseURL)=>{if(specifier.startsWith('/')||specifier.startsWith('./')||specifier.startsWith('../')){return exports.tryURLParse(specifier,baseURL);}const url=exports.tryURLParse(specifier);return url;};},{}],74:[function(require,module,exports){if(typeof Object.create==='function'){module.exports=function inherits(ctor,superCtor){if(superCtor){ctor.super_=superCtor;ctor.prototype=Object.create(superCtor.prototype,{constructor:{value:ctor,enumerable:false,writable:true,configurable:true}});}};}else{module.exports=function inherits(ctor,superCtor){if(superCtor){ctor.super_=superCtor;var TempCtor=function(){};TempCtor.prototype=superCtor.prototype;ctor.prototype=new TempCtor();ctor.prototype.constructor=ctor;}};}},{}],75:[function(require,module,exports){var toString={}.toString;module.exports=Array.isArray||function(arr){return toString.call(arr)=='[object Array]';};},{}],76:[function(require,module,exports){'use strict';var assign=require('./lib/utils/common').assign;var deflate=require('./lib/deflate');var inflate=require('./lib/inflate');var constants=require('./lib/zlib/constants');var pako={};assign(pako,deflate,inflate,constants);module.exports=pako;},{'./lib/deflate':77,'./lib/inflate':78,'./lib/utils/common':79,'./lib/zlib/constants':82}],77:[function(require,module,exports){'use strict';var zlib_deflate=require('./zlib/deflate');var utils=require('./utils/common');var strings=require('./utils/strings');var msg=require('./zlib/messages');var ZStream=require('./zlib/zstream');var toString=Object.prototype.toString;var Z_NO_FLUSH=0;var Z_FINISH=4;var Z_OK=0;var Z_STREAM_END=1;var Z_SYNC_FLUSH=2;var Z_DEFAULT_COMPRESSION=-1;var Z_DEFAULT_STRATEGY=0;var Z_DEFLATED=8;function Deflate(options){if(!(this instanceof Deflate))return new Deflate(options);this.options=utils.assign({level:Z_DEFAULT_COMPRESSION,method:Z_DEFLATED,chunkSize:16384,windowBits:15,memLevel:8,strategy:Z_DEFAULT_STRATEGY,to:''},options||{});var opt=this.options;if(opt.raw&&opt.windowBits>0){opt.windowBits=-opt.windowBits;}else if(opt.gzip&&opt.windowBits>0&&opt.windowBits<16){opt.windowBits+=16;}this.err=0;this.msg='';this.ended=false;this.chunks=[];this.strm=new ZStream();this.strm.avail_out=0;var status=zlib_deflate.deflateInit2(this.strm,opt.level,opt.method,opt.windowBits,opt.memLevel,opt.strategy);if(status!==Z_OK){throw new Error(msg[status]);}if(opt.header){zlib_deflate.deflateSetHeader(this.strm,opt.header);}if(opt.dictionary){var dict;if(typeof opt.dictionary==='string'){dict=strings.string2buf(opt.dictionary);}else if(toString.call(opt.dictionary)==='[object ArrayBuffer]'){dict=new Uint8Array(opt.dictionary);}else{dict=opt.dictionary;}status=zlib_deflate.deflateSetDictionary(this.strm,dict);if(status!==Z_OK){throw new Error(msg[status]);}this._dict_set=true;}}Deflate.prototype.push=function(data,mode){var strm=this.strm;var chunkSize=this.options.chunkSize;var status,_mode;if(this.ended){return false;}_mode=mode===~~mode?mode:mode===true?Z_FINISH:Z_NO_FLUSH;if(typeof data==='string'){strm.input=strings.string2buf(data);}else if(toString.call(data)==='[object ArrayBuffer]'){strm.input=new Uint8Array(data);}else{strm.input=data;}strm.next_in=0;strm.avail_in=strm.input.length;do{if(strm.avail_out===0){strm.output=new utils.Buf8(chunkSize);strm.next_out=0;strm.avail_out=chunkSize;}status=zlib_deflate.deflate(strm,_mode);if(status!==Z_STREAM_END&&status!==Z_OK){this.onEnd(status);this.ended=true;return false;}if(strm.avail_out===0||strm.avail_in===0&&(_mode===Z_FINISH||_mode===Z_SYNC_FLUSH)){if(this.options.to==='string'){this.onData(strings.buf2binstring(utils.shrinkBuf(strm.output,strm.next_out)));}else{this.onData(utils.shrinkBuf(strm.output,strm.next_out));}}}while((strm.avail_in>0||strm.avail_out===0)&&status!==Z_STREAM_END);if(_mode===Z_FINISH){status=zlib_deflate.deflateEnd(this.strm);this.onEnd(status);this.ended=true;return status===Z_OK;}if(_mode===Z_SYNC_FLUSH){this.onEnd(Z_OK);strm.avail_out=0;return true;}return true;};Deflate.prototype.onData=function(chunk){this.chunks.push(chunk);};Deflate.prototype.onEnd=function(status){if(status===Z_OK){if(this.options.to==='string'){this.result=this.chunks.join('');}else{this.result=utils.flattenChunks(this.chunks);}}this.chunks=[];this.err=status;this.msg=this.strm.msg;};function deflate(input,options){var deflator=new Deflate(options);deflator.push(input,true);if(deflator.err){throw deflator.msg||msg[deflator.err];}return deflator.result;}function deflateRaw(input,options){options=options||{};options.raw=true;return deflate(input,options);}function gzip(input,options){options=options||{};options.gzip=true;return deflate(input,options);}exports.Deflate=Deflate;exports.deflate=deflate;exports.deflateRaw=deflateRaw;exports.gzip=gzip;},{'./utils/common':79,'./utils/strings':80,'./zlib/deflate':84,'./zlib/messages':89,'./zlib/zstream':91}],78:[function(require,module,exports){'use strict';var zlib_inflate=require('./zlib/inflate');var utils=require('./utils/common');var strings=require('./utils/strings');var c=require('./zlib/constants');var msg=require('./zlib/messages');var ZStream=require('./zlib/zstream');var GZheader=require('./zlib/gzheader');var toString=Object.prototype.toString;function Inflate(options){if(!(this instanceof Inflate))return new Inflate(options);this.options=utils.assign({chunkSize:16384,windowBits:0,to:''},options||{});var opt=this.options;if(opt.raw&&opt.windowBits>=0&&opt.windowBits<16){opt.windowBits=-opt.windowBits;if(opt.windowBits===0){opt.windowBits=-15;}}if(opt.windowBits>=0&&opt.windowBits<16&&!(options&&options.windowBits)){opt.windowBits+=32;}if(opt.windowBits>15&&opt.windowBits<48){if((opt.windowBits&15)===0){opt.windowBits|=15;}}this.err=0;this.msg='';this.ended=false;this.chunks=[];this.strm=new ZStream();this.strm.avail_out=0;var status=zlib_inflate.inflateInit2(this.strm,opt.windowBits);if(status!==c.Z_OK){throw new Error(msg[status]);}this.header=new GZheader();zlib_inflate.inflateGetHeader(this.strm,this.header);if(opt.dictionary){if(typeof opt.dictionary==='string'){opt.dictionary=strings.string2buf(opt.dictionary);}else if(toString.call(opt.dictionary)==='[object ArrayBuffer]'){opt.dictionary=new Uint8Array(opt.dictionary);}if(opt.raw){status=zlib_inflate.inflateSetDictionary(this.strm,opt.dictionary);if(status!==c.Z_OK){throw new Error(msg[status]);}}}}Inflate.prototype.push=function(data,mode){var strm=this.strm;var chunkSize=this.options.chunkSize;var dictionary=this.options.dictionary;var status,_mode;var next_out_utf8,tail,utf8str;var allowBufError=false;if(this.ended){return false;}_mode=mode===~~mode?mode:mode===true?c.Z_FINISH:c.Z_NO_FLUSH;if(typeof data==='string'){strm.input=strings.binstring2buf(data);}else if(toString.call(data)==='[object ArrayBuffer]'){strm.input=new Uint8Array(data);}else{strm.input=data;}strm.next_in=0;strm.avail_in=strm.input.length;do{if(strm.avail_out===0){strm.output=new utils.Buf8(chunkSize);strm.next_out=0;strm.avail_out=chunkSize;}status=zlib_inflate.inflate(strm,c.Z_NO_FLUSH);if(status===c.Z_NEED_DICT&&dictionary){status=zlib_inflate.inflateSetDictionary(this.strm,dictionary);}if(status===c.Z_BUF_ERROR&&allowBufError===true){status=c.Z_OK;allowBufError=false;}if(status!==c.Z_STREAM_END&&status!==c.Z_OK){this.onEnd(status);this.ended=true;return false;}if(strm.next_out){if(strm.avail_out===0||status===c.Z_STREAM_END||strm.avail_in===0&&(_mode===c.Z_FINISH||_mode===c.Z_SYNC_FLUSH)){if(this.options.to==='string'){next_out_utf8=strings.utf8border(strm.output,strm.next_out);tail=strm.next_out-next_out_utf8;utf8str=strings.buf2string(strm.output,next_out_utf8);strm.next_out=tail;strm.avail_out=chunkSize-tail;if(tail){utils.arraySet(strm.output,strm.output,next_out_utf8,tail,0);}this.onData(utf8str);}else{this.onData(utils.shrinkBuf(strm.output,strm.next_out));}}}if(strm.avail_in===0&&strm.avail_out===0){allowBufError=true;}}while((strm.avail_in>0||strm.avail_out===0)&&status!==c.Z_STREAM_END);if(status===c.Z_STREAM_END){_mode=c.Z_FINISH;}if(_mode===c.Z_FINISH){status=zlib_inflate.inflateEnd(this.strm);this.onEnd(status);this.ended=true;return status===c.Z_OK;}if(_mode===c.Z_SYNC_FLUSH){this.onEnd(c.Z_OK);strm.avail_out=0;return true;}return true;};Inflate.prototype.onData=function(chunk){this.chunks.push(chunk);};Inflate.prototype.onEnd=function(status){if(status===c.Z_OK){if(this.options.to==='string'){this.result=this.chunks.join('');}else{this.result=utils.flattenChunks(this.chunks);}}this.chunks=[];this.err=status;this.msg=this.strm.msg;};function inflate(input,options){var inflator=new Inflate(options);inflator.push(input,true);if(inflator.err){throw inflator.msg||msg[inflator.err];}return inflator.result;}function inflateRaw(input,options){options=options||{};options.raw=true;return inflate(input,options);}exports.Inflate=Inflate;exports.inflate=inflate;exports.inflateRaw=inflateRaw;exports.ungzip=inflate;},{'./utils/common':79,'./utils/strings':80,'./zlib/constants':82,'./zlib/gzheader':85,'./zlib/inflate':87,'./zlib/messages':89,'./zlib/zstream':91}],79:[function(require,module,exports){'use strict';var TYPED_OK=typeof Uint8Array!=='undefined'&&typeof Uint16Array!=='undefined'&&typeof Int32Array!=='undefined';function _has(obj,key){return Object.prototype.hasOwnProperty.call(obj,key);}exports.assign=function(obj){var sources=Array.prototype.slice.call(arguments,1);while(sources.length){var source=sources.shift();if(!source){continue;}if(typeof source!=='object'){throw new TypeError(source+'must be non-object');}for(var p in source){if(_has(source,p)){obj[p]=source[p];}}}return obj;};exports.shrinkBuf=function(buf,size){if(buf.length===size){return buf;}if(buf.subarray){return buf.subarray(0,size);}buf.length=size;return buf;};var fnTyped={arraySet:function(dest,src,src_offs,len,dest_offs){if(src.subarray&&dest.subarray){dest.set(src.subarray(src_offs,src_offs+len),dest_offs);return;}for(var i=0;i<len;i++){dest[dest_offs+i]=src[src_offs+i];}},flattenChunks:function(chunks){var i,l,len,pos,chunk,result;len=0;for(i=0,l=chunks.length;i<l;i++){len+=chunks[i].length;}result=new Uint8Array(len);pos=0;for(i=0,l=chunks.length;i<l;i++){chunk=chunks[i];result.set(chunk,pos);pos+=chunk.length;}return result;}};var fnUntyped={arraySet:function(dest,src,src_offs,len,dest_offs){for(var i=0;i<len;i++){dest[dest_offs+i]=src[src_offs+i];}},flattenChunks:function(chunks){return[].concat.apply([],chunks);}};exports.setTyped=function(on){if(on){exports.Buf8=Uint8Array;exports.Buf16=Uint16Array;exports.Buf32=Int32Array;exports.assign(exports,fnTyped);}else{exports.Buf8=Array;exports.Buf16=Array;exports.Buf32=Array;exports.assign(exports,fnUntyped);}};exports.setTyped(TYPED_OK);},{}],80:[function(require,module,exports){'use strict';var utils=require('./common');var STR_APPLY_OK=true;var STR_APPLY_UIA_OK=true;try{String.fromCharCode.apply(null,[0]);}catch(__){STR_APPLY_OK=false;}try{String.fromCharCode.apply(null,new Uint8Array(1));}catch(__){STR_APPLY_UIA_OK=false;}var _utf8len=new utils.Buf8(256);for(var q=0;q<256;q++){_utf8len[q]=q>=252?6:q>=248?5:q>=240?4:q>=224?3:q>=192?2:1;}_utf8len[254]=_utf8len[254]=1;exports.string2buf=function(str){var buf,c,c2,m_pos,i,str_len=str.length,buf_len=0;for(m_pos=0;m_pos<str_len;m_pos++){c=str.charCodeAt(m_pos);if((c&64512)===55296&&m_pos+1<str_len){c2=str.charCodeAt(m_pos+1);if((c2&64512)===56320){c=65536+(c-55296<<10)+(c2-56320);m_pos++;}}buf_len+=c<128?1:c<2048?2:c<65536?3:4;}buf=new utils.Buf8(buf_len);for(i=0,m_pos=0;i<buf_len;m_pos++){c=str.charCodeAt(m_pos);if((c&64512)===55296&&m_pos+1<str_len){c2=str.charCodeAt(m_pos+1);if((c2&64512)===56320){c=65536+(c-55296<<10)+(c2-56320);m_pos++;}}if(c<128){buf[i++]=c;}else if(c<2048){buf[i++]=192|c>>>6;buf[i++]=128|c&63;}else if(c<65536){buf[i++]=224|c>>>12;buf[i++]=128|c>>>6&63;buf[i++]=128|c&63;}else{buf[i++]=240|c>>>18;buf[i++]=128|c>>>12&63;buf[i++]=128|c>>>6&63;buf[i++]=128|c&63;}}return buf;};function buf2binstring(buf,len){if(len<65534){if(buf.subarray&&STR_APPLY_UIA_OK||!buf.subarray&&STR_APPLY_OK){return String.fromCharCode.apply(null,utils.shrinkBuf(buf,len));}}var result='';for(var i=0;i<len;i++){result+=String.fromCharCode(buf[i]);}return result;}exports.buf2binstring=function(buf){return buf2binstring(buf,buf.length);};exports.binstring2buf=function(str){var buf=new utils.Buf8(str.length);for(var i=0,len=buf.length;i<len;i++){buf[i]=str.charCodeAt(i);}return buf;};exports.buf2string=function(buf,max){var i,out,c,c_len;var len=max||buf.length;var utf16buf=new Array(len*2);for(out=0,i=0;i<len;){c=buf[i++];if(c<128){utf16buf[out++]=c;continue;}c_len=_utf8len[c];if(c_len>4){utf16buf[out++]=65533;i+=c_len-1;continue;}c&=c_len===2?31:c_len===3?15:7;while(c_len>1&&i<len){c=c<<6|buf[i++]&63;c_len--;}if(c_len>1){utf16buf[out++]=65533;continue;}if(c<65536){utf16buf[out++]=c;}else{c-=65536;utf16buf[out++]=55296|c>>10&1023;utf16buf[out++]=56320|c&1023;}}return buf2binstring(utf16buf,out);};exports.utf8border=function(buf,max){var pos;max=max||buf.length;if(max>buf.length){max=buf.length;}pos=max-1;while(pos>=0&&(buf[pos]&192)===128){pos--;}if(pos<0){return max;}if(pos===0){return max;}return pos+_utf8len[buf[pos]]>max?pos:max;};},{'./common':79}],81:[function(require,module,exports){'use strict';function adler32(adler,buf,len,pos){var s1=adler&65535|0,s2=adler>>>16&65535|0,n=0;while(len!==0){n=len>2000?2000:len;len-=n;do{s1=s1+buf[pos++]|0;s2=s2+s1|0;}while(--n);s1%=65521;s2%=65521;}return s1|s2<<16|0;}module.exports=adler32;},{}],82:[function(require,module,exports){'use strict';module.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8};},{}],83:[function(require,module,exports){'use strict';function makeTable(){var c,table=[];for(var n=0;n<256;n++){c=n;for(var k=0;k<8;k++){c=c&1?3988292384^c>>>1:c>>>1;}table[n]=c;}return table;}var crcTable=makeTable();function crc32(crc,buf,len,pos){var t=crcTable,end=pos+len;crc^=-1;for(var i=pos;i<end;i++){crc=crc>>>8^t[(crc^buf[i])&255];}return crc^-1;}module.exports=crc32;},{}],84:[function(require,module,exports){'use strict';var utils=require('../utils/common');var trees=require('./trees');var adler32=require('./adler32');var crc32=require('./crc32');var msg=require('./messages');var Z_NO_FLUSH=0;var Z_PARTIAL_FLUSH=1;var Z_FULL_FLUSH=3;var Z_FINISH=4;var Z_BLOCK=5;var Z_OK=0;var Z_STREAM_END=1;var Z_STREAM_ERROR=-2;var Z_DATA_ERROR=-3;var Z_BUF_ERROR=-5;var Z_DEFAULT_COMPRESSION=-1;var Z_FILTERED=1;var Z_HUFFMAN_ONLY=2;var Z_RLE=3;var Z_FIXED=4;var Z_DEFAULT_STRATEGY=0;var Z_UNKNOWN=2;var Z_DEFLATED=8;var MAX_MEM_LEVEL=9;var MAX_WBITS=15;var DEF_MEM_LEVEL=8;var LENGTH_CODES=29;var LITERALS=256;var L_CODES=LITERALS+1+LENGTH_CODES;var D_CODES=30;var BL_CODES=19;var HEAP_SIZE=2*L_CODES+1;var MAX_BITS=15;var MIN_MATCH=3;var MAX_MATCH=258;var MIN_LOOKAHEAD=MAX_MATCH+MIN_MATCH+1;var PRESET_DICT=32;var INIT_STATE=42;var EXTRA_STATE=69;var NAME_STATE=73;var COMMENT_STATE=91;var HCRC_STATE=103;var BUSY_STATE=113;var FINISH_STATE=666;var BS_NEED_MORE=1;var BS_BLOCK_DONE=2;var BS_FINISH_STARTED=3;var BS_FINISH_DONE=4;var OS_CODE=3;function err(strm,errorCode){strm.msg=msg[errorCode];return errorCode;}function rank(f){return(f<<1)-(f>4?9:0);}function zero(buf){var len=buf.length;while(--len>=0){buf[len]=0;}}function flush_pending(strm){var s=strm.state;var len=s.pending;if(len>strm.avail_out){len=strm.avail_out;}if(len===0){return;}utils.arraySet(strm.output,s.pending_buf,s.pending_out,len,strm.next_out);strm.next_out+=len;s.pending_out+=len;strm.total_out+=len;strm.avail_out-=len;s.pending-=len;if(s.pending===0){s.pending_out=0;}}function flush_block_only(s,last){trees._tr_flush_block(s,s.block_start>=0?s.block_start:-1,s.strstart-s.block_start,last);s.block_start=s.strstart;flush_pending(s.strm);}function put_byte(s,b){s.pending_buf[s.pending++]=b;}function putShortMSB(s,b){s.pending_buf[s.pending++]=b>>>8&255;s.pending_buf[s.pending++]=b&255;}function read_buf(strm,buf,start,size){var len=strm.avail_in;if(len>size){len=size;}if(len===0){return 0;}strm.avail_in-=len;utils.arraySet(buf,strm.input,strm.next_in,len,start);if(strm.state.wrap===1){strm.adler=adler32(strm.adler,buf,len,start);}else if(strm.state.wrap===2){strm.adler=crc32(strm.adler,buf,len,start);}strm.next_in+=len;strm.total_in+=len;return len;}function longest_match(s,cur_match){var chain_length=s.max_chain_length;var scan=s.strstart;var match;var len;var best_len=s.prev_length;var nice_match=s.nice_match;var limit=s.strstart>s.w_size-MIN_LOOKAHEAD?s.strstart-(s.w_size-MIN_LOOKAHEAD):0;var _win=s.window;var wmask=s.w_mask;var prev=s.prev;var strend=s.strstart+MAX_MATCH;var scan_end1=_win[scan+best_len-1];var scan_end=_win[scan+best_len];if(s.prev_length>=s.good_match){chain_length>>=2;}if(nice_match>s.lookahead){nice_match=s.lookahead;}do{match=cur_match;if(_win[match+best_len]!==scan_end||_win[match+best_len-1]!==scan_end1||_win[match]!==_win[scan]||_win[++match]!==_win[scan+1]){continue;}scan+=2;match++;do{}while(_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&_win[++scan]===_win[++match]&&scan<strend);len=MAX_MATCH-(strend-scan);scan=strend-MAX_MATCH;if(len>best_len){s.match_start=cur_match;best_len=len;if(len>=nice_match){break;}scan_end1=_win[scan+best_len-1];scan_end=_win[scan+best_len];}}while((cur_match=prev[cur_match&wmask])>limit&&--chain_length!==0);if(best_len<=s.lookahead){return best_len;}return s.lookahead;}function fill_window(s){var _w_size=s.w_size;var p,n,m,more,str;do{more=s.window_size-s.lookahead-s.strstart;if(s.strstart>=_w_size+(_w_size-MIN_LOOKAHEAD)){utils.arraySet(s.window,s.window,_w_size,_w_size,0);s.match_start-=_w_size;s.strstart-=_w_size;s.block_start-=_w_size;n=s.hash_size;p=n;do{m=s.head[--p];s.head[p]=m>=_w_size?m-_w_size:0;}while(--n);n=_w_size;p=n;do{m=s.prev[--p];s.prev[p]=m>=_w_size?m-_w_size:0;}while(--n);more+=_w_size;}if(s.strm.avail_in===0){break;}n=read_buf(s.strm,s.window,s.strstart+s.lookahead,more);s.lookahead+=n;if(s.lookahead+s.insert>=MIN_MATCH){str=s.strstart-s.insert;s.ins_h=s.window[str];s.ins_h=(s.ins_h<<s.hash_shift^s.window[str+1])&s.hash_mask;while(s.insert){s.ins_h=(s.ins_h<<s.hash_shift^s.window[str+MIN_MATCH-1])&s.hash_mask;s.prev[str&s.w_mask]=s.head[s.ins_h];s.head[s.ins_h]=str;str++;s.insert--;if(s.lookahead+s.insert<MIN_MATCH){break;}}}}while(s.lookahead<MIN_LOOKAHEAD&&s.strm.avail_in!==0);}function deflate_stored(s,flush){var max_block_size=65535;if(max_block_size>s.pending_buf_size-5){max_block_size=s.pending_buf_size-5;}for(;;){if(s.lookahead<=1){fill_window(s);if(s.lookahead===0&&flush===Z_NO_FLUSH){return BS_NEED_MORE;}if(s.lookahead===0){break;}}s.strstart+=s.lookahead;s.lookahead=0;var max_start=s.block_start+max_block_size;if(s.strstart===0||s.strstart>=max_start){s.lookahead=s.strstart-max_start;s.strstart=max_start;flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}if(s.strstart-s.block_start>=s.w_size-MIN_LOOKAHEAD){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}}s.insert=0;if(flush===Z_FINISH){flush_block_only(s,true);if(s.strm.avail_out===0){return BS_FINISH_STARTED;}return BS_FINISH_DONE;}if(s.strstart>s.block_start){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}return BS_NEED_MORE;}function deflate_fast(s,flush){var hash_head;var bflush;for(;;){if(s.lookahead<MIN_LOOKAHEAD){fill_window(s);if(s.lookahead<MIN_LOOKAHEAD&&flush===Z_NO_FLUSH){return BS_NEED_MORE;}if(s.lookahead===0){break;}}hash_head=0;if(s.lookahead>=MIN_MATCH){s.ins_h=(s.ins_h<<s.hash_shift^s.window[s.strstart+MIN_MATCH-1])&s.hash_mask;hash_head=s.prev[s.strstart&s.w_mask]=s.head[s.ins_h];s.head[s.ins_h]=s.strstart;}if(hash_head!==0&&s.strstart-hash_head<=s.w_size-MIN_LOOKAHEAD){s.match_length=longest_match(s,hash_head);}if(s.match_length>=MIN_MATCH){bflush=trees._tr_tally(s,s.strstart-s.match_start,s.match_length-MIN_MATCH);s.lookahead-=s.match_length;if(s.match_length<=s.max_lazy_match&&s.lookahead>=MIN_MATCH){s.match_length--;do{s.strstart++;s.ins_h=(s.ins_h<<s.hash_shift^s.window[s.strstart+MIN_MATCH-1])&s.hash_mask;hash_head=s.prev[s.strstart&s.w_mask]=s.head[s.ins_h];s.head[s.ins_h]=s.strstart;}while(--s.match_length!==0);s.strstart++;}else{s.strstart+=s.match_length;s.match_length=0;s.ins_h=s.window[s.strstart];s.ins_h=(s.ins_h<<s.hash_shift^s.window[s.strstart+1])&s.hash_mask;}}else{bflush=trees._tr_tally(s,0,s.window[s.strstart]);s.lookahead--;s.strstart++;}if(bflush){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}}s.insert=s.strstart<MIN_MATCH-1?s.strstart:MIN_MATCH-1;if(flush===Z_FINISH){flush_block_only(s,true);if(s.strm.avail_out===0){return BS_FINISH_STARTED;}return BS_FINISH_DONE;}if(s.last_lit){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}return BS_BLOCK_DONE;}function deflate_slow(s,flush){var hash_head;var bflush;var max_insert;for(;;){if(s.lookahead<MIN_LOOKAHEAD){fill_window(s);if(s.lookahead<MIN_LOOKAHEAD&&flush===Z_NO_FLUSH){return BS_NEED_MORE;}if(s.lookahead===0){break;}}hash_head=0;if(s.lookahead>=MIN_MATCH){s.ins_h=(s.ins_h<<s.hash_shift^s.window[s.strstart+MIN_MATCH-1])&s.hash_mask;hash_head=s.prev[s.strstart&s.w_mask]=s.head[s.ins_h];s.head[s.ins_h]=s.strstart;}s.prev_length=s.match_length;s.prev_match=s.match_start;s.match_length=MIN_MATCH-1;if(hash_head!==0&&s.prev_length<s.max_lazy_match&&s.strstart-hash_head<=s.w_size-MIN_LOOKAHEAD){s.match_length=longest_match(s,hash_head);if(s.match_length<=5&&(s.strategy===Z_FILTERED||s.match_length===MIN_MATCH&&s.strstart-s.match_start>4096)){s.match_length=MIN_MATCH-1;}}if(s.prev_length>=MIN_MATCH&&s.match_length<=s.prev_length){max_insert=s.strstart+s.lookahead-MIN_MATCH;bflush=trees._tr_tally(s,s.strstart-1-s.prev_match,s.prev_length-MIN_MATCH);s.lookahead-=s.prev_length-1;s.prev_length-=2;do{if(++s.strstart<=max_insert){s.ins_h=(s.ins_h<<s.hash_shift^s.window[s.strstart+MIN_MATCH-1])&s.hash_mask;hash_head=s.prev[s.strstart&s.w_mask]=s.head[s.ins_h];s.head[s.ins_h]=s.strstart;}}while(--s.prev_length!==0);s.match_available=0;s.match_length=MIN_MATCH-1;s.strstart++;if(bflush){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}}else if(s.match_available){bflush=trees._tr_tally(s,0,s.window[s.strstart-1]);if(bflush){flush_block_only(s,false);}s.strstart++;s.lookahead--;if(s.strm.avail_out===0){return BS_NEED_MORE;}}else{s.match_available=1;s.strstart++;s.lookahead--;}}if(s.match_available){bflush=trees._tr_tally(s,0,s.window[s.strstart-1]);s.match_available=0;}s.insert=s.strstart<MIN_MATCH-1?s.strstart:MIN_MATCH-1;if(flush===Z_FINISH){flush_block_only(s,true);if(s.strm.avail_out===0){return BS_FINISH_STARTED;}return BS_FINISH_DONE;}if(s.last_lit){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}return BS_BLOCK_DONE;}function deflate_rle(s,flush){var bflush;var prev;var scan,strend;var _win=s.window;for(;;){if(s.lookahead<=MAX_MATCH){fill_window(s);if(s.lookahead<=MAX_MATCH&&flush===Z_NO_FLUSH){return BS_NEED_MORE;}if(s.lookahead===0){break;}}s.match_length=0;if(s.lookahead>=MIN_MATCH&&s.strstart>0){scan=s.strstart-1;prev=_win[scan];if(prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]){strend=s.strstart+MAX_MATCH;do{}while(prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]&&prev===_win[++scan]&&scan<strend);s.match_length=MAX_MATCH-(strend-scan);if(s.match_length>s.lookahead){s.match_length=s.lookahead;}}}if(s.match_length>=MIN_MATCH){bflush=trees._tr_tally(s,1,s.match_length-MIN_MATCH);s.lookahead-=s.match_length;s.strstart+=s.match_length;s.match_length=0;}else{bflush=trees._tr_tally(s,0,s.window[s.strstart]);s.lookahead--;s.strstart++;}if(bflush){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}}s.insert=0;if(flush===Z_FINISH){flush_block_only(s,true);if(s.strm.avail_out===0){return BS_FINISH_STARTED;}return BS_FINISH_DONE;}if(s.last_lit){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}return BS_BLOCK_DONE;}function deflate_huff(s,flush){var bflush;for(;;){if(s.lookahead===0){fill_window(s);if(s.lookahead===0){if(flush===Z_NO_FLUSH){return BS_NEED_MORE;}break;}}s.match_length=0;bflush=trees._tr_tally(s,0,s.window[s.strstart]);s.lookahead--;s.strstart++;if(bflush){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}}s.insert=0;if(flush===Z_FINISH){flush_block_only(s,true);if(s.strm.avail_out===0){return BS_FINISH_STARTED;}return BS_FINISH_DONE;}if(s.last_lit){flush_block_only(s,false);if(s.strm.avail_out===0){return BS_NEED_MORE;}}return BS_BLOCK_DONE;}function Config(good_length,max_lazy,nice_length,max_chain,func){this.good_length=good_length;this.max_lazy=max_lazy;this.nice_length=nice_length;this.max_chain=max_chain;this.func=func;}var configuration_table;configuration_table=[new Config(0,0,0,0,deflate_stored),new Config(4,4,8,4,deflate_fast),new Config(4,5,16,8,deflate_fast),new Config(4,6,32,32,deflate_fast),new Config(4,4,16,16,deflate_slow),new Config(8,16,32,32,deflate_slow),new Config(8,16,128,128,deflate_slow),new Config(8,32,128,256,deflate_slow),new Config(32,128,258,1024,deflate_slow),new Config(32,258,258,4096,deflate_slow)];function lm_init(s){s.window_size=2*s.w_size;zero(s.head);s.max_lazy_match=configuration_table[s.level].max_lazy;s.good_match=configuration_table[s.level].good_length;s.nice_match=configuration_table[s.level].nice_length;s.max_chain_length=configuration_table[s.level].max_chain;s.strstart=0;s.block_start=0;s.lookahead=0;s.insert=0;s.match_length=s.prev_length=MIN_MATCH-1;s.match_available=0;s.ins_h=0;}function DeflateState(){this.strm=null;this.status=0;this.pending_buf=null;this.pending_buf_size=0;this.pending_out=0;this.pending=0;this.wrap=0;this.gzhead=null;this.gzindex=0;this.method=Z_DEFLATED;this.last_flush=-1;this.w_size=0;this.w_bits=0;this.w_mask=0;this.window=null;this.window_size=0;this.prev=null;this.head=null;this.ins_h=0;this.hash_size=0;this.hash_bits=0;this.hash_mask=0;this.hash_shift=0;this.block_start=0;this.match_length=0;this.prev_match=0;this.match_available=0;this.strstart=0;this.match_start=0;this.lookahead=0;this.prev_length=0;this.max_chain_length=0;this.max_lazy_match=0;this.level=0;this.strategy=0;this.good_match=0;this.nice_match=0;this.dyn_ltree=new utils.Buf16(HEAP_SIZE*2);this.dyn_dtree=new utils.Buf16((2*D_CODES+1)*2);this.bl_tree=new utils.Buf16((2*BL_CODES+1)*2);zero(this.dyn_ltree);zero(this.dyn_dtree);zero(this.bl_tree);this.l_desc=null;this.d_desc=null;this.bl_desc=null;this.bl_count=new utils.Buf16(MAX_BITS+1);this.heap=new utils.Buf16(2*L_CODES+1);zero(this.heap);this.heap_len=0;this.heap_max=0;this.depth=new utils.Buf16(2*L_CODES+1);zero(this.depth);this.l_buf=0;this.lit_bufsize=0;this.last_lit=0;this.d_buf=0;this.opt_len=0;this.static_len=0;this.matches=0;this.insert=0;this.bi_buf=0;this.bi_valid=0;}function deflateResetKeep(strm){var s;if(!strm||!strm.state){return err(strm,Z_STREAM_ERROR);}strm.total_in=strm.total_out=0;strm.data_type=Z_UNKNOWN;s=strm.state;s.pending=0;s.pending_out=0;if(s.wrap<0){s.wrap=-s.wrap;}s.status=s.wrap?INIT_STATE:BUSY_STATE;strm.adler=s.wrap===2?0:1;s.last_flush=Z_NO_FLUSH;trees._tr_init(s);return Z_OK;}function deflateReset(strm){var ret=deflateResetKeep(strm);if(ret===Z_OK){lm_init(strm.state);}return ret;}function deflateSetHeader(strm,head){if(!strm||!strm.state){return Z_STREAM_ERROR;}if(strm.state.wrap!==2){return Z_STREAM_ERROR;}strm.state.gzhead=head;return Z_OK;}function deflateInit2(strm,level,method,windowBits,memLevel,strategy){if(!strm){return Z_STREAM_ERROR;}var wrap=1;if(level===Z_DEFAULT_COMPRESSION){level=6;}if(windowBits<0){wrap=0;windowBits=-windowBits;}else if(windowBits>15){wrap=2;windowBits-=16;}if(memLevel<1||memLevel>MAX_MEM_LEVEL||method!==Z_DEFLATED||windowBits<8||windowBits>15||level<0||level>9||strategy<0||strategy>Z_FIXED){return err(strm,Z_STREAM_ERROR);}if(windowBits===8){windowBits=9;}var s=new DeflateState();strm.state=s;s.strm=strm;s.wrap=wrap;s.gzhead=null;s.w_bits=windowBits;s.w_size=1<<s.w_bits;s.w_mask=s.w_size-1;s.hash_bits=memLevel+7;s.hash_size=1<<s.hash_bits;s.hash_mask=s.hash_size-1;s.hash_shift=~~((s.hash_bits+MIN_MATCH-1)/MIN_MATCH);s.window=new utils.Buf8(s.w_size*2);s.head=new utils.Buf16(s.hash_size);s.prev=new utils.Buf16(s.w_size);s.lit_bufsize=1<<memLevel+6;s.pending_buf_size=s.lit_bufsize*4;s.pending_buf=new utils.Buf8(s.pending_buf_size);s.d_buf=1*s.lit_bufsize;s.l_buf=(1+2)*s.lit_bufsize;s.level=level;s.strategy=strategy;s.method=method;return deflateReset(strm);}function deflateInit(strm,level){return deflateInit2(strm,level,Z_DEFLATED,MAX_WBITS,DEF_MEM_LEVEL,Z_DEFAULT_STRATEGY);}function deflate(strm,flush){var old_flush,s;var beg,val;if(!strm||!strm.state||flush>Z_BLOCK||flush<0){return strm?err(strm,Z_STREAM_ERROR):Z_STREAM_ERROR;}s=strm.state;if(!strm.output||!strm.input&&strm.avail_in!==0||s.status===FINISH_STATE&&flush!==Z_FINISH){return err(strm,strm.avail_out===0?Z_BUF_ERROR:Z_STREAM_ERROR);}s.strm=strm;old_flush=s.last_flush;s.last_flush=flush;if(s.status===INIT_STATE){if(s.wrap===2){strm.adler=0;put_byte(s,31);put_byte(s,139);put_byte(s,8);if(!s.gzhead){put_byte(s,0);put_byte(s,0);put_byte(s,0);put_byte(s,0);put_byte(s,0);put_byte(s,s.level===9?2:s.strategy>=Z_HUFFMAN_ONLY||s.level<2?4:0);put_byte(s,OS_CODE);s.status=BUSY_STATE;}else{put_byte(s,(s.gzhead.text?1:0)+(s.gzhead.hcrc?2:0)+(!s.gzhead.extra?0:4)+(!s.gzhead.name?0:8)+(!s.gzhead.comment?0:16));put_byte(s,s.gzhead.time&255);put_byte(s,s.gzhead.time>>8&255);put_byte(s,s.gzhead.time>>16&255);put_byte(s,s.gzhead.time>>24&255);put_byte(s,s.level===9?2:s.strategy>=Z_HUFFMAN_ONLY||s.level<2?4:0);put_byte(s,s.gzhead.os&255);if(s.gzhead.extra&&s.gzhead.extra.length){put_byte(s,s.gzhead.extra.length&255);put_byte(s,s.gzhead.extra.length>>8&255);}if(s.gzhead.hcrc){strm.adler=crc32(strm.adler,s.pending_buf,s.pending,0);}s.gzindex=0;s.status=EXTRA_STATE;}}else{var header=Z_DEFLATED+(s.w_bits-8<<4)<<8;var level_flags=-1;if(s.strategy>=Z_HUFFMAN_ONLY||s.level<2){level_flags=0;}else if(s.level<6){level_flags=1;}else if(s.level===6){level_flags=2;}else{level_flags=3;}header|=level_flags<<6;if(s.strstart!==0){header|=PRESET_DICT;}header+=31-header%31;s.status=BUSY_STATE;putShortMSB(s,header);if(s.strstart!==0){putShortMSB(s,strm.adler>>>16);putShortMSB(s,strm.adler&65535);}strm.adler=1;}}if(s.status===EXTRA_STATE){if(s.gzhead.extra){beg=s.pending;while(s.gzindex<(s.gzhead.extra.length&65535)){if(s.pending===s.pending_buf_size){if(s.gzhead.hcrc&&s.pending>beg){strm.adler=crc32(strm.adler,s.pending_buf,s.pending-beg,beg);}flush_pending(strm);beg=s.pending;if(s.pending===s.pending_buf_size){break;}}put_byte(s,s.gzhead.extra[s.gzindex]&255);s.gzindex++;}if(s.gzhead.hcrc&&s.pending>beg){strm.adler=crc32(strm.adler,s.pending_buf,s.pending-beg,beg);}if(s.gzindex===s.gzhead.extra.length){s.gzindex=0;s.status=NAME_STATE;}}else{s.status=NAME_STATE;}}if(s.status===NAME_STATE){if(s.gzhead.name){beg=s.pending;do{if(s.pending===s.pending_buf_size){if(s.gzhead.hcrc&&s.pending>beg){strm.adler=crc32(strm.adler,s.pending_buf,s.pending-beg,beg);}flush_pending(strm);beg=s.pending;if(s.pending===s.pending_buf_size){val=1;break;}}if(s.gzindex<s.gzhead.name.length){val=s.gzhead.name.charCodeAt(s.gzindex++)&255;}else{val=0;}put_byte(s,val);}while(val!==0);if(s.gzhead.hcrc&&s.pending>beg){strm.adler=crc32(strm.adler,s.pending_buf,s.pending-beg,beg);}if(val===0){s.gzindex=0;s.status=COMMENT_STATE;}}else{s.status=COMMENT_STATE;}}if(s.status===COMMENT_STATE){if(s.gzhead.comment){beg=s.pending;do{if(s.pending===s.pending_buf_size){if(s.gzhead.hcrc&&s.pending>beg){strm.adler=crc32(strm.adler,s.pending_buf,s.pending-beg,beg);}flush_pending(strm);beg=s.pending;if(s.pending===s.pending_buf_size){val=1;break;}}if(s.gzindex<s.gzhead.comment.length){val=s.gzhead.comment.charCodeAt(s.gzindex++)&255;}else{val=0;}put_byte(s,val);}while(val!==0);if(s.gzhead.hcrc&&s.pending>beg){strm.adler=crc32(strm.adler,s.pending_buf,s.pending-beg,beg);}if(val===0){s.status=HCRC_STATE;}}else{s.status=HCRC_STATE;}}if(s.status===HCRC_STATE){if(s.gzhead.hcrc){if(s.pending+2>s.pending_buf_size){flush_pending(strm);}if(s.pending+2<=s.pending_buf_size){put_byte(s,strm.adler&255);put_byte(s,strm.adler>>8&255);strm.adler=0;s.status=BUSY_STATE;}}else{s.status=BUSY_STATE;}}if(s.pending!==0){flush_pending(strm);if(strm.avail_out===0){s.last_flush=-1;return Z_OK;}}else if(strm.avail_in===0&&rank(flush)<=rank(old_flush)&&flush!==Z_FINISH){return err(strm,Z_BUF_ERROR);}if(s.status===FINISH_STATE&&strm.avail_in!==0){return err(strm,Z_BUF_ERROR);}if(strm.avail_in!==0||s.lookahead!==0||flush!==Z_NO_FLUSH&&s.status!==FINISH_STATE){var bstate=s.strategy===Z_HUFFMAN_ONLY?deflate_huff(s,flush):s.strategy===Z_RLE?deflate_rle(s,flush):configuration_table[s.level].func(s,flush);if(bstate===BS_FINISH_STARTED||bstate===BS_FINISH_DONE){s.status=FINISH_STATE;}if(bstate===BS_NEED_MORE||bstate===BS_FINISH_STARTED){if(strm.avail_out===0){s.last_flush=-1;}return Z_OK;}if(bstate===BS_BLOCK_DONE){if(flush===Z_PARTIAL_FLUSH){trees._tr_align(s);}else if(flush!==Z_BLOCK){trees._tr_stored_block(s,0,0,false);if(flush===Z_FULL_FLUSH){zero(s.head);if(s.lookahead===0){s.strstart=0;s.block_start=0;s.insert=0;}}}flush_pending(strm);if(strm.avail_out===0){s.last_flush=-1;return Z_OK;}}}if(flush!==Z_FINISH){return Z_OK;}if(s.wrap<=0){return Z_STREAM_END;}if(s.wrap===2){put_byte(s,strm.adler&255);put_byte(s,strm.adler>>8&255);put_byte(s,strm.adler>>16&255);put_byte(s,strm.adler>>24&255);put_byte(s,strm.total_in&255);put_byte(s,strm.total_in>>8&255);put_byte(s,strm.total_in>>16&255);put_byte(s,strm.total_in>>24&255);}else{putShortMSB(s,strm.adler>>>16);putShortMSB(s,strm.adler&65535);}flush_pending(strm);if(s.wrap>0){s.wrap=-s.wrap;}return s.pending!==0?Z_OK:Z_STREAM_END;}function deflateEnd(strm){var status;if(!strm||!strm.state){return Z_STREAM_ERROR;}status=strm.state.status;if(status!==INIT_STATE&&status!==EXTRA_STATE&&status!==NAME_STATE&&status!==COMMENT_STATE&&status!==HCRC_STATE&&status!==BUSY_STATE&&status!==FINISH_STATE){return err(strm,Z_STREAM_ERROR);}strm.state=null;return status===BUSY_STATE?err(strm,Z_DATA_ERROR):Z_OK;}function deflateSetDictionary(strm,dictionary){var dictLength=dictionary.length;var s;var str,n;var wrap;var avail;var next;var input;var tmpDict;if(!strm||!strm.state){return Z_STREAM_ERROR;}s=strm.state;wrap=s.wrap;if(wrap===2||wrap===1&&s.status!==INIT_STATE||s.lookahead){return Z_STREAM_ERROR;}if(wrap===1){strm.adler=adler32(strm.adler,dictionary,dictLength,0);}s.wrap=0;if(dictLength>=s.w_size){if(wrap===0){zero(s.head);s.strstart=0;s.block_start=0;s.insert=0;}tmpDict=new utils.Buf8(s.w_size);utils.arraySet(tmpDict,dictionary,dictLength-s.w_size,s.w_size,0);dictionary=tmpDict;dictLength=s.w_size;}avail=strm.avail_in;next=strm.next_in;input=strm.input;strm.avail_in=dictLength;strm.next_in=0;strm.input=dictionary;fill_window(s);while(s.lookahead>=MIN_MATCH){str=s.strstart;n=s.lookahead-(MIN_MATCH-1);do{s.ins_h=(s.ins_h<<s.hash_shift^s.window[str+MIN_MATCH-1])&s.hash_mask;s.prev[str&s.w_mask]=s.head[s.ins_h];s.head[s.ins_h]=str;str++;}while(--n);s.strstart=str;s.lookahead=MIN_MATCH-1;fill_window(s);}s.strstart+=s.lookahead;s.block_start=s.strstart;s.insert=s.lookahead;s.lookahead=0;s.match_length=s.prev_length=MIN_MATCH-1;s.match_available=0;strm.next_in=next;strm.input=input;strm.avail_in=avail;s.wrap=wrap;return Z_OK;}exports.deflateInit=deflateInit;exports.deflateInit2=deflateInit2;exports.deflateReset=deflateReset;exports.deflateResetKeep=deflateResetKeep;exports.deflateSetHeader=deflateSetHeader;exports.deflate=deflate;exports.deflateEnd=deflateEnd;exports.deflateSetDictionary=deflateSetDictionary;exports.deflateInfo='pako deflate (from Nodeca project)';},{'../utils/common':79,'./adler32':81,'./crc32':83,'./messages':89,'./trees':90}],85:[function(require,module,exports){'use strict';function GZheader(){this.text=0;this.time=0;this.xflags=0;this.os=0;this.extra=null;this.extra_len=0;this.name='';this.comment='';this.hcrc=0;this.done=false;}module.exports=GZheader;},{}],86:[function(require,module,exports){'use strict';var BAD=30;var TYPE=12;module.exports=function inflate_fast(strm,start){var state;var _in;var last;var _out;var beg;var end;var dmax;var wsize;var whave;var wnext;var s_window;var hold;var bits;var lcode;var dcode;var lmask;var dmask;var here;var op;var len;var dist;var from;var from_source;var input,output;state=strm.state;_in=strm.next_in;input=strm.input;last=_in+(strm.avail_in-5);_out=strm.next_out;output=strm.output;beg=_out-(start-strm.avail_out);end=_out+(strm.avail_out-257);dmax=state.dmax;wsize=state.wsize;whave=state.whave;wnext=state.wnext;s_window=state.window;hold=state.hold;bits=state.bits;lcode=state.lencode;dcode=state.distcode;lmask=(1<<state.lenbits)-1;dmask=(1<<state.distbits)-1;top:do{if(bits<15){hold+=input[_in++]<<bits;bits+=8;hold+=input[_in++]<<bits;bits+=8;}here=lcode[hold&lmask];dolen:for(;;){op=here>>>24;hold>>>=op;bits-=op;op=here>>>16&255;if(op===0){output[_out++]=here&65535;}else if(op&16){len=here&65535;op&=15;if(op){if(bits<op){hold+=input[_in++]<<bits;bits+=8;}len+=hold&(1<<op)-1;hold>>>=op;bits-=op;}if(bits<15){hold+=input[_in++]<<bits;bits+=8;hold+=input[_in++]<<bits;bits+=8;}here=dcode[hold&dmask];dodist:for(;;){op=here>>>24;hold>>>=op;bits-=op;op=here>>>16&255;if(op&16){dist=here&65535;op&=15;if(bits<op){hold+=input[_in++]<<bits;bits+=8;if(bits<op){hold+=input[_in++]<<bits;bits+=8;}}dist+=hold&(1<<op)-1;if(dist>dmax){strm.msg='invalid distance too far back';state.mode=BAD;break top;}hold>>>=op;bits-=op;op=_out-beg;if(dist>op){op=dist-op;if(op>whave){if(state.sane){strm.msg='invalid distance too far back';state.mode=BAD;break top;}}from=0;from_source=s_window;if(wnext===0){from+=wsize-op;if(op<len){len-=op;do{output[_out++]=s_window[from++];}while(--op);from=_out-dist;from_source=output;}}else if(wnext<op){from+=wsize+wnext-op;op-=wnext;if(op<len){len-=op;do{output[_out++]=s_window[from++];}while(--op);from=0;if(wnext<len){op=wnext;len-=op;do{output[_out++]=s_window[from++];}while(--op);from=_out-dist;from_source=output;}}}else{from+=wnext-op;if(op<len){len-=op;do{output[_out++]=s_window[from++];}while(--op);from=_out-dist;from_source=output;}}while(len>2){output[_out++]=from_source[from++];output[_out++]=from_source[from++];output[_out++]=from_source[from++];len-=3;}if(len){output[_out++]=from_source[from++];if(len>1){output[_out++]=from_source[from++];}}}else{from=_out-dist;do{output[_out++]=output[from++];output[_out++]=output[from++];output[_out++]=output[from++];len-=3;}while(len>2);if(len){output[_out++]=output[from++];if(len>1){output[_out++]=output[from++];}}}}else if((op&64)===0){here=dcode[(here&65535)+(hold&(1<<op)-1)];continue dodist;}else{strm.msg='invalid distance code';state.mode=BAD;break top;}break;}}else if((op&64)===0){here=lcode[(here&65535)+(hold&(1<<op)-1)];continue dolen;}else if(op&32){state.mode=TYPE;break top;}else{strm.msg='invalid literal/length code';state.mode=BAD;break top;}break;}}while(_in<last&&_out<end);len=bits>>3;_in-=len;bits-=len<<3;hold&=(1<<bits)-1;strm.next_in=_in;strm.next_out=_out;strm.avail_in=_in<last?5+(last-_in):5-(_in-last);strm.avail_out=_out<end?257+(end-_out):257-(_out-end);state.hold=hold;state.bits=bits;return;};},{}],87:[function(require,module,exports){'use strict';var utils=require('../utils/common');var adler32=require('./adler32');var crc32=require('./crc32');var inflate_fast=require('./inffast');var inflate_table=require('./inftrees');var CODES=0;var LENS=1;var DISTS=2;var Z_FINISH=4;var Z_BLOCK=5;var Z_TREES=6;var Z_OK=0;var Z_STREAM_END=1;var Z_NEED_DICT=2;var Z_STREAM_ERROR=-2;var Z_DATA_ERROR=-3;var Z_MEM_ERROR=-4;var Z_BUF_ERROR=-5;var Z_DEFLATED=8;var HEAD=1;var FLAGS=2;var TIME=3;var OS=4;var EXLEN=5;var EXTRA=6;var NAME=7;var COMMENT=8;var HCRC=9;var DICTID=10;var DICT=11;var TYPE=12;var TYPEDO=13;var STORED=14;var COPY_=15;var COPY=16;var TABLE=17;var LENLENS=18;var CODELENS=19;var LEN_=20;var LEN=21;var LENEXT=22;var DIST=23;var DISTEXT=24;var MATCH=25;var LIT=26;var CHECK=27;var LENGTH=28;var DONE=29;var BAD=30;var MEM=31;var SYNC=32;var ENOUGH_LENS=852;var ENOUGH_DISTS=592;var MAX_WBITS=15;var DEF_WBITS=MAX_WBITS;function zswap32(q){return(q>>>24&255)+(q>>>8&65280)+((q&65280)<<8)+((q&255)<<24);}function InflateState(){this.mode=0;this.last=false;this.wrap=0;this.havedict=false;this.flags=0;this.dmax=0;this.check=0;this.total=0;this.head=null;this.wbits=0;this.wsize=0;this.whave=0;this.wnext=0;this.window=null;this.hold=0;this.bits=0;this.length=0;this.offset=0;this.extra=0;this.lencode=null;this.distcode=null;this.lenbits=0;this.distbits=0;this.ncode=0;this.nlen=0;this.ndist=0;this.have=0;this.next=null;this.lens=new utils.Buf16(320);this.work=new utils.Buf16(288);this.lendyn=null;this.distdyn=null;this.sane=0;this.back=0;this.was=0;}function inflateResetKeep(strm){var state;if(!strm||!strm.state){return Z_STREAM_ERROR;}state=strm.state;strm.total_in=strm.total_out=state.total=0;strm.msg='';if(state.wrap){strm.adler=state.wrap&1;}state.mode=HEAD;state.last=0;state.havedict=0;state.dmax=32768;state.head=null;state.hold=0;state.bits=0;state.lencode=state.lendyn=new utils.Buf32(ENOUGH_LENS);state.distcode=state.distdyn=new utils.Buf32(ENOUGH_DISTS);state.sane=1;state.back=-1;return Z_OK;}function inflateReset(strm){var state;if(!strm||!strm.state){return Z_STREAM_ERROR;}state=strm.state;state.wsize=0;state.whave=0;state.wnext=0;return inflateResetKeep(strm);}function inflateReset2(strm,windowBits){var wrap;var state;if(!strm||!strm.state){return Z_STREAM_ERROR;}state=strm.state;if(windowBits<0){wrap=0;windowBits=-windowBits;}else{wrap=(windowBits>>4)+1;if(windowBits<48){windowBits&=15;}}if(windowBits&&(windowBits<8||windowBits>15)){return Z_STREAM_ERROR;}if(state.window!==null&&state.wbits!==windowBits){state.window=null;}state.wrap=wrap;state.wbits=windowBits;return inflateReset(strm);}function inflateInit2(strm,windowBits){var ret;var state;if(!strm){return Z_STREAM_ERROR;}state=new InflateState();strm.state=state;state.window=null;ret=inflateReset2(strm,windowBits);if(ret!==Z_OK){strm.state=null;}return ret;}function inflateInit(strm){return inflateInit2(strm,DEF_WBITS);}var virgin=true;var lenfix,distfix;function fixedtables(state){if(virgin){var sym;lenfix=new utils.Buf32(512);distfix=new utils.Buf32(32);sym=0;while(sym<144){state.lens[sym++]=8;}while(sym<256){state.lens[sym++]=9;}while(sym<280){state.lens[sym++]=7;}while(sym<288){state.lens[sym++]=8;}inflate_table(LENS,state.lens,0,288,lenfix,0,state.work,{bits:9});sym=0;while(sym<32){state.lens[sym++]=5;}inflate_table(DISTS,state.lens,0,32,distfix,0,state.work,{bits:5});virgin=false;}state.lencode=lenfix;state.lenbits=9;state.distcode=distfix;state.distbits=5;}function updatewindow(strm,src,end,copy){var dist;var state=strm.state;if(state.window===null){state.wsize=1<<state.wbits;state.wnext=0;state.whave=0;state.window=new utils.Buf8(state.wsize);}if(copy>=state.wsize){utils.arraySet(state.window,src,end-state.wsize,state.wsize,0);state.wnext=0;state.whave=state.wsize;}else{dist=state.wsize-state.wnext;if(dist>copy){dist=copy;}utils.arraySet(state.window,src,end-copy,dist,state.wnext);copy-=dist;if(copy){utils.arraySet(state.window,src,end-copy,copy,0);state.wnext=copy;state.whave=state.wsize;}else{state.wnext+=dist;if(state.wnext===state.wsize){state.wnext=0;}if(state.whave<state.wsize){state.whave+=dist;}}}return 0;}function inflate(strm,flush){var state;var input,output;var next;var put;var have,left;var hold;var bits;var _in,_out;var copy;var from;var from_source;var here=0;var here_bits,here_op,here_val;var last_bits,last_op,last_val;var len;var ret;var hbuf=new utils.Buf8(4);var opts;var n;var order=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];if(!strm||!strm.state||!strm.output||!strm.input&&strm.avail_in!==0){return Z_STREAM_ERROR;}state=strm.state;if(state.mode===TYPE){state.mode=TYPEDO;}put=strm.next_out;output=strm.output;left=strm.avail_out;next=strm.next_in;input=strm.input;have=strm.avail_in;hold=state.hold;bits=state.bits;_in=have;_out=left;ret=Z_OK;inf_leave:for(;;){switch(state.mode){case HEAD:if(state.wrap===0){state.mode=TYPEDO;break;}while(bits<16){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(state.wrap&2&&hold===35615){state.check=0;hbuf[0]=hold&255;hbuf[1]=hold>>>8&255;state.check=crc32(state.check,hbuf,2,0);hold=0;bits=0;state.mode=FLAGS;break;}state.flags=0;if(state.head){state.head.done=false;}if(!(state.wrap&1)||(((hold&255)<<8)+(hold>>8))%31){strm.msg='incorrect header check';state.mode=BAD;break;}if((hold&15)!==Z_DEFLATED){strm.msg='unknown compression method';state.mode=BAD;break;}hold>>>=4;bits-=4;len=(hold&15)+8;if(state.wbits===0){state.wbits=len;}else if(len>state.wbits){strm.msg='invalid window size';state.mode=BAD;break;}state.dmax=1<<len;strm.adler=state.check=1;state.mode=hold&512?DICTID:TYPE;hold=0;bits=0;break;case FLAGS:while(bits<16){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.flags=hold;if((state.flags&255)!==Z_DEFLATED){strm.msg='unknown compression method';state.mode=BAD;break;}if(state.flags&57344){strm.msg='unknown header flags set';state.mode=BAD;break;}if(state.head){state.head.text=hold>>8&1;}if(state.flags&512){hbuf[0]=hold&255;hbuf[1]=hold>>>8&255;state.check=crc32(state.check,hbuf,2,0);}hold=0;bits=0;state.mode=TIME;case TIME:while(bits<32){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(state.head){state.head.time=hold;}if(state.flags&512){hbuf[0]=hold&255;hbuf[1]=hold>>>8&255;hbuf[2]=hold>>>16&255;hbuf[3]=hold>>>24&255;state.check=crc32(state.check,hbuf,4,0);}hold=0;bits=0;state.mode=OS;case OS:while(bits<16){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(state.head){state.head.xflags=hold&255;state.head.os=hold>>8;}if(state.flags&512){hbuf[0]=hold&255;hbuf[1]=hold>>>8&255;state.check=crc32(state.check,hbuf,2,0);}hold=0;bits=0;state.mode=EXLEN;case EXLEN:if(state.flags&1024){while(bits<16){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.length=hold;if(state.head){state.head.extra_len=hold;}if(state.flags&512){hbuf[0]=hold&255;hbuf[1]=hold>>>8&255;state.check=crc32(state.check,hbuf,2,0);}hold=0;bits=0;}else if(state.head){state.head.extra=null;}state.mode=EXTRA;case EXTRA:if(state.flags&1024){copy=state.length;if(copy>have){copy=have;}if(copy){if(state.head){len=state.head.extra_len-state.length;if(!state.head.extra){state.head.extra=new Array(state.head.extra_len);}utils.arraySet(state.head.extra,input,next,copy,len);}if(state.flags&512){state.check=crc32(state.check,input,copy,next);}have-=copy;next+=copy;state.length-=copy;}if(state.length){break inf_leave;}}state.length=0;state.mode=NAME;case NAME:if(state.flags&2048){if(have===0){break inf_leave;}copy=0;do{len=input[next+copy++];if(state.head&&len&&state.length<65536){state.head.name+=String.fromCharCode(len);}}while(len&&copy<have);if(state.flags&512){state.check=crc32(state.check,input,copy,next);}have-=copy;next+=copy;if(len){break inf_leave;}}else if(state.head){state.head.name=null;}state.length=0;state.mode=COMMENT;case COMMENT:if(state.flags&4096){if(have===0){break inf_leave;}copy=0;do{len=input[next+copy++];if(state.head&&len&&state.length<65536){state.head.comment+=String.fromCharCode(len);}}while(len&&copy<have);if(state.flags&512){state.check=crc32(state.check,input,copy,next);}have-=copy;next+=copy;if(len){break inf_leave;}}else if(state.head){state.head.comment=null;}state.mode=HCRC;case HCRC:if(state.flags&512){while(bits<16){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(hold!==(state.check&65535)){strm.msg='header crc mismatch';state.mode=BAD;break;}hold=0;bits=0;}if(state.head){state.head.hcrc=state.flags>>9&1;state.head.done=true;}strm.adler=state.check=0;state.mode=TYPE;break;case DICTID:while(bits<32){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}strm.adler=state.check=zswap32(hold);hold=0;bits=0;state.mode=DICT;case DICT:if(state.havedict===0){strm.next_out=put;strm.avail_out=left;strm.next_in=next;strm.avail_in=have;state.hold=hold;state.bits=bits;return Z_NEED_DICT;}strm.adler=state.check=1;state.mode=TYPE;case TYPE:if(flush===Z_BLOCK||flush===Z_TREES){break inf_leave;}case TYPEDO:if(state.last){hold>>>=bits&7;bits-=bits&7;state.mode=CHECK;break;}while(bits<3){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.last=hold&1;hold>>>=1;bits-=1;switch(hold&3){case 0:state.mode=STORED;break;case 1:fixedtables(state);state.mode=LEN_;if(flush===Z_TREES){hold>>>=2;bits-=2;break inf_leave;}break;case 2:state.mode=TABLE;break;case 3:strm.msg='invalid block type';state.mode=BAD;}hold>>>=2;bits-=2;break;case STORED:hold>>>=bits&7;bits-=bits&7;while(bits<32){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if((hold&65535)!==(hold>>>16^65535)){strm.msg='invalid stored block lengths';state.mode=BAD;break;}state.length=hold&65535;hold=0;bits=0;state.mode=COPY_;if(flush===Z_TREES){break inf_leave;}case COPY_:state.mode=COPY;case COPY:copy=state.length;if(copy){if(copy>have){copy=have;}if(copy>left){copy=left;}if(copy===0){break inf_leave;}utils.arraySet(output,input,next,copy,put);have-=copy;next+=copy;left-=copy;put+=copy;state.length-=copy;break;}state.mode=TYPE;break;case TABLE:while(bits<14){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.nlen=(hold&31)+257;hold>>>=5;bits-=5;state.ndist=(hold&31)+1;hold>>>=5;bits-=5;state.ncode=(hold&15)+4;hold>>>=4;bits-=4;if(state.nlen>286||state.ndist>30){strm.msg='too many length or distance symbols';state.mode=BAD;break;}state.have=0;state.mode=LENLENS;case LENLENS:while(state.have<state.ncode){while(bits<3){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.lens[order[state.have++]]=hold&7;hold>>>=3;bits-=3;}while(state.have<19){state.lens[order[state.have++]]=0;}state.lencode=state.lendyn;state.lenbits=7;opts={bits:state.lenbits};ret=inflate_table(CODES,state.lens,0,19,state.lencode,0,state.work,opts);state.lenbits=opts.bits;if(ret){strm.msg='invalid code lengths set';state.mode=BAD;break;}state.have=0;state.mode=CODELENS;case CODELENS:while(state.have<state.nlen+state.ndist){for(;;){here=state.lencode[hold&(1<<state.lenbits)-1];here_bits=here>>>24;here_op=here>>>16&255;here_val=here&65535;if(here_bits<=bits){break;}if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(here_val<16){hold>>>=here_bits;bits-=here_bits;state.lens[state.have++]=here_val;}else{if(here_val===16){n=here_bits+2;while(bits<n){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}hold>>>=here_bits;bits-=here_bits;if(state.have===0){strm.msg='invalid bit length repeat';state.mode=BAD;break;}len=state.lens[state.have-1];copy=3+(hold&3);hold>>>=2;bits-=2;}else if(here_val===17){n=here_bits+3;while(bits<n){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}hold>>>=here_bits;bits-=here_bits;len=0;copy=3+(hold&7);hold>>>=3;bits-=3;}else{n=here_bits+7;while(bits<n){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}hold>>>=here_bits;bits-=here_bits;len=0;copy=11+(hold&127);hold>>>=7;bits-=7;}if(state.have+copy>state.nlen+state.ndist){strm.msg='invalid bit length repeat';state.mode=BAD;break;}while(copy--){state.lens[state.have++]=len;}}}if(state.mode===BAD){break;}if(state.lens[256]===0){strm.msg='invalid code -- missing end-of-block';state.mode=BAD;break;}state.lenbits=9;opts={bits:state.lenbits};ret=inflate_table(LENS,state.lens,0,state.nlen,state.lencode,0,state.work,opts);state.lenbits=opts.bits;if(ret){strm.msg='invalid literal/lengths set';state.mode=BAD;break;}state.distbits=6;state.distcode=state.distdyn;opts={bits:state.distbits};ret=inflate_table(DISTS,state.lens,state.nlen,state.ndist,state.distcode,0,state.work,opts);state.distbits=opts.bits;if(ret){strm.msg='invalid distances set';state.mode=BAD;break;}state.mode=LEN_;if(flush===Z_TREES){break inf_leave;}case LEN_:state.mode=LEN;case LEN:if(have>=6&&left>=258){strm.next_out=put;strm.avail_out=left;strm.next_in=next;strm.avail_in=have;state.hold=hold;state.bits=bits;inflate_fast(strm,_out);put=strm.next_out;output=strm.output;left=strm.avail_out;next=strm.next_in;input=strm.input;have=strm.avail_in;hold=state.hold;bits=state.bits;if(state.mode===TYPE){state.back=-1;}break;}state.back=0;for(;;){here=state.lencode[hold&(1<<state.lenbits)-1];here_bits=here>>>24;here_op=here>>>16&255;here_val=here&65535;if(here_bits<=bits){break;}if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(here_op&&(here_op&240)===0){last_bits=here_bits;last_op=here_op;last_val=here_val;for(;;){here=state.lencode[last_val+((hold&(1<<last_bits+last_op)-1)>>last_bits)];here_bits=here>>>24;here_op=here>>>16&255;here_val=here&65535;if(last_bits+here_bits<=bits){break;}if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}hold>>>=last_bits;bits-=last_bits;state.back+=last_bits;}hold>>>=here_bits;bits-=here_bits;state.back+=here_bits;state.length=here_val;if(here_op===0){state.mode=LIT;break;}if(here_op&32){state.back=-1;state.mode=TYPE;break;}if(here_op&64){strm.msg='invalid literal/length code';state.mode=BAD;break;}state.extra=here_op&15;state.mode=LENEXT;case LENEXT:if(state.extra){n=state.extra;while(bits<n){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.length+=hold&(1<<state.extra)-1;hold>>>=state.extra;bits-=state.extra;state.back+=state.extra;}state.was=state.length;state.mode=DIST;case DIST:for(;;){here=state.distcode[hold&(1<<state.distbits)-1];here_bits=here>>>24;here_op=here>>>16&255;here_val=here&65535;if(here_bits<=bits){break;}if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if((here_op&240)===0){last_bits=here_bits;last_op=here_op;last_val=here_val;for(;;){here=state.distcode[last_val+((hold&(1<<last_bits+last_op)-1)>>last_bits)];here_bits=here>>>24;here_op=here>>>16&255;here_val=here&65535;if(last_bits+here_bits<=bits){break;}if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}hold>>>=last_bits;bits-=last_bits;state.back+=last_bits;}hold>>>=here_bits;bits-=here_bits;state.back+=here_bits;if(here_op&64){strm.msg='invalid distance code';state.mode=BAD;break;}state.offset=here_val;state.extra=here_op&15;state.mode=DISTEXT;case DISTEXT:if(state.extra){n=state.extra;while(bits<n){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}state.offset+=hold&(1<<state.extra)-1;hold>>>=state.extra;bits-=state.extra;state.back+=state.extra;}if(state.offset>state.dmax){strm.msg='invalid distance too far back';state.mode=BAD;break;}state.mode=MATCH;case MATCH:if(left===0){break inf_leave;}copy=_out-left;if(state.offset>copy){copy=state.offset-copy;if(copy>state.whave){if(state.sane){strm.msg='invalid distance too far back';state.mode=BAD;break;}}if(copy>state.wnext){copy-=state.wnext;from=state.wsize-copy;}else{from=state.wnext-copy;}if(copy>state.length){copy=state.length;}from_source=state.window;}else{from_source=output;from=put-state.offset;copy=state.length;}if(copy>left){copy=left;}left-=copy;state.length-=copy;do{output[put++]=from_source[from++];}while(--copy);if(state.length===0){state.mode=LEN;}break;case LIT:if(left===0){break inf_leave;}output[put++]=state.length;left--;state.mode=LEN;break;case CHECK:if(state.wrap){while(bits<32){if(have===0){break inf_leave;}have--;hold|=input[next++]<<bits;bits+=8;}_out-=left;strm.total_out+=_out;state.total+=_out;if(_out){strm.adler=state.check=state.flags?crc32(state.check,output,_out,put-_out):adler32(state.check,output,_out,put-_out);}_out=left;if((state.flags?hold:zswap32(hold))!==state.check){strm.msg='incorrect data check';state.mode=BAD;break;}hold=0;bits=0;}state.mode=LENGTH;case LENGTH:if(state.wrap&&state.flags){while(bits<32){if(have===0){break inf_leave;}have--;hold+=input[next++]<<bits;bits+=8;}if(hold!==(state.total&4294967295)){strm.msg='incorrect length check';state.mode=BAD;break;}hold=0;bits=0;}state.mode=DONE;case DONE:ret=Z_STREAM_END;break inf_leave;case BAD:ret=Z_DATA_ERROR;break inf_leave;case MEM:return Z_MEM_ERROR;case SYNC:default:return Z_STREAM_ERROR;}}strm.next_out=put;strm.avail_out=left;strm.next_in=next;strm.avail_in=have;state.hold=hold;state.bits=bits;if(state.wsize||_out!==strm.avail_out&&state.mode<BAD&&(state.mode<CHECK||flush!==Z_FINISH)){if(updatewindow(strm,strm.output,strm.next_out,_out-strm.avail_out)){state.mode=MEM;return Z_MEM_ERROR;}}_in-=strm.avail_in;_out-=strm.avail_out;strm.total_in+=_in;strm.total_out+=_out;state.total+=_out;if(state.wrap&&_out){strm.adler=state.check=state.flags?crc32(state.check,output,_out,strm.next_out-_out):adler32(state.check,output,_out,strm.next_out-_out);}strm.data_type=state.bits+(state.last?64:0)+(state.mode===TYPE?128:0)+(state.mode===LEN_||state.mode===COPY_?256:0);if((_in===0&&_out===0||flush===Z_FINISH)&&ret===Z_OK){ret=Z_BUF_ERROR;}return ret;}function inflateEnd(strm){if(!strm||!strm.state){return Z_STREAM_ERROR;}var state=strm.state;if(state.window){state.window=null;}strm.state=null;return Z_OK;}function inflateGetHeader(strm,head){var state;if(!strm||!strm.state){return Z_STREAM_ERROR;}state=strm.state;if((state.wrap&2)===0){return Z_STREAM_ERROR;}state.head=head;head.done=false;return Z_OK;}function inflateSetDictionary(strm,dictionary){var dictLength=dictionary.length;var state;var dictid;var ret;if(!strm||!strm.state){return Z_STREAM_ERROR;}state=strm.state;if(state.wrap!==0&&state.mode!==DICT){return Z_STREAM_ERROR;}if(state.mode===DICT){dictid=1;dictid=adler32(dictid,dictionary,dictLength,0);if(dictid!==state.check){return Z_DATA_ERROR;}}ret=updatewindow(strm,dictionary,dictLength,dictLength);if(ret){state.mode=MEM;return Z_MEM_ERROR;}state.havedict=1;return Z_OK;}exports.inflateReset=inflateReset;exports.inflateReset2=inflateReset2;exports.inflateResetKeep=inflateResetKeep;exports.inflateInit=inflateInit;exports.inflateInit2=inflateInit2;exports.inflate=inflate;exports.inflateEnd=inflateEnd;exports.inflateGetHeader=inflateGetHeader;exports.inflateSetDictionary=inflateSetDictionary;exports.inflateInfo='pako inflate (from Nodeca project)';},{'../utils/common':79,'./adler32':81,'./crc32':83,'./inffast':86,'./inftrees':88}],88:[function(require,module,exports){'use strict';var utils=require('../utils/common');var MAXBITS=15;var ENOUGH_LENS=852;var ENOUGH_DISTS=592;var CODES=0;var LENS=1;var DISTS=2;var lbase=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,0,0];var lext=[16,16,16,16,16,16,16,16,17,17,17,17,18,18,18,18,19,19,19,19,20,20,20,20,21,21,21,21,16,72,78];var dbase=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577,0,0];var dext=[16,16,16,16,17,17,18,18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,64,64];module.exports=function inflate_table(type,lens,lens_index,codes,table,table_index,work,opts){var bits=opts.bits;var len=0;var sym=0;var min=0,max=0;var root=0;var curr=0;var drop=0;var left=0;var used=0;var huff=0;var incr;var fill;var low;var mask;var next;var base=null;var base_index=0;var end;var count=new utils.Buf16(MAXBITS+1);var offs=new utils.Buf16(MAXBITS+1);var extra=null;var extra_index=0;var here_bits,here_op,here_val;for(len=0;len<=MAXBITS;len++){count[len]=0;}for(sym=0;sym<codes;sym++){count[lens[lens_index+sym]]++;}root=bits;for(max=MAXBITS;max>=1;max--){if(count[max]!==0){break;}}if(root>max){root=max;}if(max===0){table[table_index++]=1<<24|64<<16|0;table[table_index++]=1<<24|64<<16|0;opts.bits=1;return 0;}for(min=1;min<max;min++){if(count[min]!==0){break;}}if(root<min){root=min;}left=1;for(len=1;len<=MAXBITS;len++){left<<=1;left-=count[len];if(left<0){return-1;}}if(left>0&&(type===CODES||max!==1)){return-1;}offs[1]=0;for(len=1;len<MAXBITS;len++){offs[len+1]=offs[len]+count[len];}for(sym=0;sym<codes;sym++){if(lens[lens_index+sym]!==0){work[offs[lens[lens_index+sym]]++]=sym;}}if(type===CODES){base=extra=work;end=19;}else if(type===LENS){base=lbase;base_index-=257;extra=lext;extra_index-=257;end=256;}else{base=dbase;extra=dext;end=-1;}huff=0;sym=0;len=min;next=table_index;curr=root;drop=0;low=-1;used=1<<root;mask=used-1;if(type===LENS&&used>ENOUGH_LENS||type===DISTS&&used>ENOUGH_DISTS){return 1;}for(;;){here_bits=len-drop;if(work[sym]<end){here_op=0;here_val=work[sym];}else if(work[sym]>end){here_op=extra[extra_index+work[sym]];here_val=base[base_index+work[sym]];}else{here_op=32+64;here_val=0;}incr=1<<len-drop;fill=1<<curr;min=fill;do{fill-=incr;table[next+(huff>>drop)+fill]=here_bits<<24|here_op<<16|here_val|0;}while(fill!==0);incr=1<<len-1;while(huff&incr){incr>>=1;}if(incr!==0){huff&=incr-1;huff+=incr;}else{huff=0;}sym++;if(--count[len]===0){if(len===max){break;}len=lens[lens_index+work[sym]];}if(len>root&&(huff&mask)!==low){if(drop===0){drop=root;}next+=min;curr=len-drop;left=1<<curr;while(curr+drop<max){left-=count[curr+drop];if(left<=0){break;}curr++;left<<=1;}used+=1<<curr;if(type===LENS&&used>ENOUGH_LENS||type===DISTS&&used>ENOUGH_DISTS){return 1;}low=huff&mask;table[low]=root<<24|curr<<16|next-table_index|0;}}if(huff!==0){table[next+huff]=len-drop<<24|64<<16|0;}opts.bits=root;return 0;};},{'../utils/common':79}],89:[function(require,module,exports){'use strict';module.exports={2:'need dictionary',1:'stream end',0:'','-1':'file error','-2':'stream error','-3':'data error','-4':'insufficient memory','-5':'buffer error','-6':'incompatible version'};},{}],90:[function(require,module,exports){'use strict';var utils=require('../utils/common');var Z_FIXED=4;var Z_BINARY=0;var Z_TEXT=1;var Z_UNKNOWN=2;function zero(buf){var len=buf.length;while(--len>=0){buf[len]=0;}}var STORED_BLOCK=0;var STATIC_TREES=1;var DYN_TREES=2;var MIN_MATCH=3;var MAX_MATCH=258;var LENGTH_CODES=29;var LITERALS=256;var L_CODES=LITERALS+1+LENGTH_CODES;var D_CODES=30;var BL_CODES=19;var HEAP_SIZE=2*L_CODES+1;var MAX_BITS=15;var Buf_size=16;var MAX_BL_BITS=7;var END_BLOCK=256;var REP_3_6=16;var REPZ_3_10=17;var REPZ_11_138=18;var extra_lbits=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0];var extra_dbits=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13];var extra_blbits=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7];var bl_order=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15];var DIST_CODE_LEN=512;var static_ltree=new Array((L_CODES+2)*2);zero(static_ltree);var static_dtree=new Array(D_CODES*2);zero(static_dtree);var _dist_code=new Array(DIST_CODE_LEN);zero(_dist_code);var _length_code=new Array(MAX_MATCH-MIN_MATCH+1);zero(_length_code);var base_length=new Array(LENGTH_CODES);zero(base_length);var base_dist=new Array(D_CODES);zero(base_dist);function StaticTreeDesc(static_tree,extra_bits,extra_base,elems,max_length){this.static_tree=static_tree;this.extra_bits=extra_bits;this.extra_base=extra_base;this.elems=elems;this.max_length=max_length;this.has_stree=static_tree&&static_tree.length;}var static_l_desc;var static_d_desc;var static_bl_desc;function TreeDesc(dyn_tree,stat_desc){this.dyn_tree=dyn_tree;this.max_code=0;this.stat_desc=stat_desc;}function d_code(dist){return dist<256?_dist_code[dist]:_dist_code[256+(dist>>>7)];}function put_short(s,w){s.pending_buf[s.pending++]=w&255;s.pending_buf[s.pending++]=w>>>8&255;}function send_bits(s,value,length){if(s.bi_valid>Buf_size-length){s.bi_buf|=value<<s.bi_valid&65535;put_short(s,s.bi_buf);s.bi_buf=value>>Buf_size-s.bi_valid;s.bi_valid+=length-Buf_size;}else{s.bi_buf|=value<<s.bi_valid&65535;s.bi_valid+=length;}}function send_code(s,c,tree){send_bits(s,tree[c*2],tree[c*2+1]);}function bi_reverse(code,len){var res=0;do{res|=code&1;code>>>=1;res<<=1;}while(--len>0);return res>>>1;}function bi_flush(s){if(s.bi_valid===16){put_short(s,s.bi_buf);s.bi_buf=0;s.bi_valid=0;}else if(s.bi_valid>=8){s.pending_buf[s.pending++]=s.bi_buf&255;s.bi_buf>>=8;s.bi_valid-=8;}}function gen_bitlen(s,desc){var tree=desc.dyn_tree;var max_code=desc.max_code;var stree=desc.stat_desc.static_tree;var has_stree=desc.stat_desc.has_stree;var extra=desc.stat_desc.extra_bits;var base=desc.stat_desc.extra_base;var max_length=desc.stat_desc.max_length;var h;var n,m;var bits;var xbits;var f;var overflow=0;for(bits=0;bits<=MAX_BITS;bits++){s.bl_count[bits]=0;}tree[s.heap[s.heap_max]*2+1]=0;for(h=s.heap_max+1;h<HEAP_SIZE;h++){n=s.heap[h];bits=tree[tree[n*2+1]*2+1]+1;if(bits>max_length){bits=max_length;overflow++;}tree[n*2+1]=bits;if(n>max_code){continue;}s.bl_count[bits]++;xbits=0;if(n>=base){xbits=extra[n-base];}f=tree[n*2];s.opt_len+=f*(bits+xbits);if(has_stree){s.static_len+=f*(stree[n*2+1]+xbits);}}if(overflow===0){return;}do{bits=max_length-1;while(s.bl_count[bits]===0){bits--;}s.bl_count[bits]--;s.bl_count[bits+1]+=2;s.bl_count[max_length]--;overflow-=2;}while(overflow>0);for(bits=max_length;bits!==0;bits--){n=s.bl_count[bits];while(n!==0){m=s.heap[--h];if(m>max_code){continue;}if(tree[m*2+1]!==bits){s.opt_len+=(bits-tree[m*2+1])*tree[m*2];tree[m*2+1]=bits;}n--;}}}function gen_codes(tree,max_code,bl_count){var next_code=new Array(MAX_BITS+1);var code=0;var bits;var n;for(bits=1;bits<=MAX_BITS;bits++){next_code[bits]=code=code+bl_count[bits-1]<<1;}for(n=0;n<=max_code;n++){var len=tree[n*2+1];if(len===0){continue;}tree[n*2]=bi_reverse(next_code[len]++,len);}}function tr_static_init(){var n;var bits;var length;var code;var dist;var bl_count=new Array(MAX_BITS+1);length=0;for(code=0;code<LENGTH_CODES-1;code++){base_length[code]=length;for(n=0;n<1<<extra_lbits[code];n++){_length_code[length++]=code;}}_length_code[length-1]=code;dist=0;for(code=0;code<16;code++){base_dist[code]=dist;for(n=0;n<1<<extra_dbits[code];n++){_dist_code[dist++]=code;}}dist>>=7;for(;code<D_CODES;code++){base_dist[code]=dist<<7;for(n=0;n<1<<extra_dbits[code]-7;n++){_dist_code[256+dist++]=code;}}for(bits=0;bits<=MAX_BITS;bits++){bl_count[bits]=0;}n=0;while(n<=143){static_ltree[n*2+1]=8;n++;bl_count[8]++;}while(n<=255){static_ltree[n*2+1]=9;n++;bl_count[9]++;}while(n<=279){static_ltree[n*2+1]=7;n++;bl_count[7]++;}while(n<=287){static_ltree[n*2+1]=8;n++;bl_count[8]++;}gen_codes(static_ltree,L_CODES+1,bl_count);for(n=0;n<D_CODES;n++){static_dtree[n*2+1]=5;static_dtree[n*2]=bi_reverse(n,5);}static_l_desc=new StaticTreeDesc(static_ltree,extra_lbits,LITERALS+1,L_CODES,MAX_BITS);static_d_desc=new StaticTreeDesc(static_dtree,extra_dbits,0,D_CODES,MAX_BITS);static_bl_desc=new StaticTreeDesc(new Array(0),extra_blbits,0,BL_CODES,MAX_BL_BITS);}function init_block(s){var n;for(n=0;n<L_CODES;n++){s.dyn_ltree[n*2]=0;}for(n=0;n<D_CODES;n++){s.dyn_dtree[n*2]=0;}for(n=0;n<BL_CODES;n++){s.bl_tree[n*2]=0;}s.dyn_ltree[END_BLOCK*2]=1;s.opt_len=s.static_len=0;s.last_lit=s.matches=0;}function bi_windup(s){if(s.bi_valid>8){put_short(s,s.bi_buf);}else if(s.bi_valid>0){s.pending_buf[s.pending++]=s.bi_buf;}s.bi_buf=0;s.bi_valid=0;}function copy_block(s,buf,len,header){bi_windup(s);if(header){put_short(s,len);put_short(s,~len);}utils.arraySet(s.pending_buf,s.window,buf,len,s.pending);s.pending+=len;}function smaller(tree,n,m,depth){var _n2=n*2;var _m2=m*2;return tree[_n2]<tree[_m2]||tree[_n2]===tree[_m2]&&depth[n]<=depth[m];}function pqdownheap(s,tree,k){var v=s.heap[k];var j=k<<1;while(j<=s.heap_len){if(j<s.heap_len&&smaller(tree,s.heap[j+1],s.heap[j],s.depth)){j++;}if(smaller(tree,v,s.heap[j],s.depth)){break;}s.heap[k]=s.heap[j];k=j;j<<=1;}s.heap[k]=v;}function compress_block(s,ltree,dtree){var dist;var lc;var lx=0;var code;var extra;if(s.last_lit!==0){do{dist=s.pending_buf[s.d_buf+lx*2]<<8|s.pending_buf[s.d_buf+lx*2+1];lc=s.pending_buf[s.l_buf+lx];lx++;if(dist===0){send_code(s,lc,ltree);}else{code=_length_code[lc];send_code(s,code+LITERALS+1,ltree);extra=extra_lbits[code];if(extra!==0){lc-=base_length[code];send_bits(s,lc,extra);}dist--;code=d_code(dist);send_code(s,code,dtree);extra=extra_dbits[code];if(extra!==0){dist-=base_dist[code];send_bits(s,dist,extra);}}}while(lx<s.last_lit);}send_code(s,END_BLOCK,ltree);}function build_tree(s,desc){var tree=desc.dyn_tree;var stree=desc.stat_desc.static_tree;var has_stree=desc.stat_desc.has_stree;var elems=desc.stat_desc.elems;var n,m;var max_code=-1;var node;s.heap_len=0;s.heap_max=HEAP_SIZE;for(n=0;n<elems;n++){if(tree[n*2]!==0){s.heap[++s.heap_len]=max_code=n;s.depth[n]=0;}else{tree[n*2+1]=0;}}while(s.heap_len<2){node=s.heap[++s.heap_len]=max_code<2?++max_code:0;tree[node*2]=1;s.depth[node]=0;s.opt_len--;if(has_stree){s.static_len-=stree[node*2+1];}}desc.max_code=max_code;for(n=s.heap_len>>1;n>=1;n--){pqdownheap(s,tree,n);}node=elems;do{n=s.heap[1];s.heap[1]=s.heap[s.heap_len--];pqdownheap(s,tree,1);m=s.heap[1];s.heap[--s.heap_max]=n;s.heap[--s.heap_max]=m;tree[node*2]=tree[n*2]+tree[m*2];s.depth[node]=(s.depth[n]>=s.depth[m]?s.depth[n]:s.depth[m])+1;tree[n*2+1]=tree[m*2+1]=node;s.heap[1]=node++;pqdownheap(s,tree,1);}while(s.heap_len>=2);s.heap[--s.heap_max]=s.heap[1];gen_bitlen(s,desc);gen_codes(tree,max_code,s.bl_count);}function scan_tree(s,tree,max_code){var n;var prevlen=-1;var curlen;var nextlen=tree[0*2+1];var count=0;var max_count=7;var min_count=4;if(nextlen===0){max_count=138;min_count=3;}tree[(max_code+1)*2+1]=65535;for(n=0;n<=max_code;n++){curlen=nextlen;nextlen=tree[(n+1)*2+1];if(++count<max_count&&curlen===nextlen){continue;}else if(count<min_count){s.bl_tree[curlen*2]+=count;}else if(curlen!==0){if(curlen!==prevlen){s.bl_tree[curlen*2]++;}s.bl_tree[REP_3_6*2]++;}else if(count<=10){s.bl_tree[REPZ_3_10*2]++;}else{s.bl_tree[REPZ_11_138*2]++;}count=0;prevlen=curlen;if(nextlen===0){max_count=138;min_count=3;}else if(curlen===nextlen){max_count=6;min_count=3;}else{max_count=7;min_count=4;}}}function send_tree(s,tree,max_code){var n;var prevlen=-1;var curlen;var nextlen=tree[0*2+1];var count=0;var max_count=7;var min_count=4;if(nextlen===0){max_count=138;min_count=3;}for(n=0;n<=max_code;n++){curlen=nextlen;nextlen=tree[(n+1)*2+1];if(++count<max_count&&curlen===nextlen){continue;}else if(count<min_count){do{send_code(s,curlen,s.bl_tree);}while(--count!==0);}else if(curlen!==0){if(curlen!==prevlen){send_code(s,curlen,s.bl_tree);count--;}send_code(s,REP_3_6,s.bl_tree);send_bits(s,count-3,2);}else if(count<=10){send_code(s,REPZ_3_10,s.bl_tree);send_bits(s,count-3,3);}else{send_code(s,REPZ_11_138,s.bl_tree);send_bits(s,count-11,7);}count=0;prevlen=curlen;if(nextlen===0){max_count=138;min_count=3;}else if(curlen===nextlen){max_count=6;min_count=3;}else{max_count=7;min_count=4;}}}function build_bl_tree(s){var max_blindex;scan_tree(s,s.dyn_ltree,s.l_desc.max_code);scan_tree(s,s.dyn_dtree,s.d_desc.max_code);build_tree(s,s.bl_desc);for(max_blindex=BL_CODES-1;max_blindex>=3;max_blindex--){if(s.bl_tree[bl_order[max_blindex]*2+1]!==0){break;}}s.opt_len+=3*(max_blindex+1)+5+5+4;return max_blindex;}function send_all_trees(s,lcodes,dcodes,blcodes){var rank;send_bits(s,lcodes-257,5);send_bits(s,dcodes-1,5);send_bits(s,blcodes-4,4);for(rank=0;rank<blcodes;rank++){send_bits(s,s.bl_tree[bl_order[rank]*2+1],3);}send_tree(s,s.dyn_ltree,lcodes-1);send_tree(s,s.dyn_dtree,dcodes-1);}function detect_data_type(s){var black_mask=4093624447;var n;for(n=0;n<=31;n++,black_mask>>>=1){if(black_mask&1&&s.dyn_ltree[n*2]!==0){return Z_BINARY;}}if(s.dyn_ltree[9*2]!==0||s.dyn_ltree[10*2]!==0||s.dyn_ltree[13*2]!==0){return Z_TEXT;}for(n=32;n<LITERALS;n++){if(s.dyn_ltree[n*2]!==0){return Z_TEXT;}}return Z_BINARY;}var static_init_done=false;function _tr_init(s){if(!static_init_done){tr_static_init();static_init_done=true;}s.l_desc=new TreeDesc(s.dyn_ltree,static_l_desc);s.d_desc=new TreeDesc(s.dyn_dtree,static_d_desc);s.bl_desc=new TreeDesc(s.bl_tree,static_bl_desc);s.bi_buf=0;s.bi_valid=0;init_block(s);}function _tr_stored_block(s,buf,stored_len,last){send_bits(s,(STORED_BLOCK<<1)+(last?1:0),3);copy_block(s,buf,stored_len,true);}function _tr_align(s){send_bits(s,STATIC_TREES<<1,3);send_code(s,END_BLOCK,static_ltree);bi_flush(s);}function _tr_flush_block(s,buf,stored_len,last){var opt_lenb,static_lenb;var max_blindex=0;if(s.level>0){if(s.strm.data_type===Z_UNKNOWN){s.strm.data_type=detect_data_type(s);}build_tree(s,s.l_desc);build_tree(s,s.d_desc);max_blindex=build_bl_tree(s);opt_lenb=s.opt_len+3+7>>>3;static_lenb=s.static_len+3+7>>>3;if(static_lenb<=opt_lenb){opt_lenb=static_lenb;}}else{opt_lenb=static_lenb=stored_len+5;}if(stored_len+4<=opt_lenb&&buf!==-1){_tr_stored_block(s,buf,stored_len,last);}else if(s.strategy===Z_FIXED||static_lenb===opt_lenb){send_bits(s,(STATIC_TREES<<1)+(last?1:0),3);compress_block(s,static_ltree,static_dtree);}else{send_bits(s,(DYN_TREES<<1)+(last?1:0),3);send_all_trees(s,s.l_desc.max_code+1,s.d_desc.max_code+1,max_blindex+1);compress_block(s,s.dyn_ltree,s.dyn_dtree);}init_block(s);if(last){bi_windup(s);}}function _tr_tally(s,dist,lc){s.pending_buf[s.d_buf+s.last_lit*2]=dist>>>8&255;s.pending_buf[s.d_buf+s.last_lit*2+1]=dist&255;s.pending_buf[s.l_buf+s.last_lit]=lc&255;s.last_lit++;if(dist===0){s.dyn_ltree[lc*2]++;}else{s.matches++;dist--;s.dyn_ltree[(_length_code[lc]+LITERALS+1)*2]++;s.dyn_dtree[d_code(dist)*2]++;}return s.last_lit===s.lit_bufsize-1;}exports._tr_init=_tr_init;exports._tr_stored_block=_tr_stored_block;exports._tr_flush_block=_tr_flush_block;exports._tr_tally=_tr_tally;exports._tr_align=_tr_align;},{'../utils/common':79}],91:[function(require,module,exports){'use strict';function ZStream(){this.input=null;this.next_in=0;this.avail_in=0;this.total_in=0;this.output=null;this.next_out=0;this.avail_out=0;this.total_out=0;this.msg='';this.state=null;this.data_type=2;this.adler=0;}module.exports=ZStream;},{}],92:[function(require,module,exports){(function(process){(function(){function normalizeArray(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==='.'){parts.splice(i,1);}else if(last==='..'){parts.splice(i,1);up++;}else if(up){parts.splice(i,1);up--;}}if(allowAboveRoot){for(;up--;up){parts.unshift('..');}}return parts;}exports.resolve=function(){var resolvedPath='',resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:process.cwd();if(typeof path!=='string'){throw new TypeError('Arguments to path.resolve must be strings');}else if(!path){continue;}resolvedPath=path+'/'+resolvedPath;resolvedAbsolute=path.charAt(0)==='/';}resolvedPath=normalizeArray(filter(resolvedPath.split('/'),function(p){return!!p;}),!resolvedAbsolute).join('/');return(resolvedAbsolute?'/':'')+resolvedPath||'.';};exports.normalize=function(path){var isAbsolute=exports.isAbsolute(path),trailingSlash=substr(path,-1)==='/';path=normalizeArray(filter(path.split('/'),function(p){return!!p;}),!isAbsolute).join('/');if(!path&&!isAbsolute){path='.';}if(path&&trailingSlash){path+='/';}return(isAbsolute?'/':'')+path;};exports.isAbsolute=function(path){return path.charAt(0)==='/';};exports.join=function(){var paths=Array.prototype.slice.call(arguments,0);return exports.normalize(filter(paths,function(p,index){if(typeof p!=='string'){throw new TypeError('Arguments to path.join must be strings');}return p;}).join('/'));};exports.relative=function(from,to){from=exports.resolve(from).substr(1);to=exports.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=='')break;}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=='')break;}if(start>end)return[];return arr.slice(start,end-start+1);}var fromParts=trim(from.split('/'));var toParts=trim(to.split('/'));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break;}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push('..');}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join('/');};exports.sep='/';exports.delimiter=':';exports.dirname=function(path){if(typeof path!=='string')path=path+'';if(path.length===0)return'.';var code=path.charCodeAt(0);var hasRoot=code===47;var end=-1;var matchedSlash=true;for(var i=path.length-1;i>=1;--i){code=path.charCodeAt(i);if(code===47){if(!matchedSlash){end=i;break;}}else{matchedSlash=false;}}if(end===-1)return hasRoot?'/':'.';if(hasRoot&&end===1){return'/';}return path.slice(0,end);};function basename(path){if(typeof path!=='string')path=path+'';var start=0;var end=-1;var matchedSlash=true;var i;for(i=path.length-1;i>=0;--i){if(path.charCodeAt(i)===47){if(!matchedSlash){start=i+1;break;}}else if(end===-1){matchedSlash=false;end=i+1;}}if(end===-1)return'';return path.slice(start,end);}exports.basename=function(path,ext){var f=basename(path);if(ext&&f.substr(-1*ext.length)===ext){f=f.substr(0,f.length-ext.length);}return f;};exports.extname=function(path){if(typeof path!=='string')path=path+'';var startDot=-1;var startPart=0;var end=-1;var matchedSlash=true;var preDotState=0;for(var i=path.length-1;i>=0;--i){var code=path.charCodeAt(i);if(code===47){if(!matchedSlash){startPart=i+1;break;}continue;}if(end===-1){matchedSlash=false;end=i+1;}if(code===46){if(startDot===-1)startDot=i;else if(preDotState!==1)preDotState=1;}else if(startDot!==-1){preDotState=-1;}}if(startDot===-1||end===-1||preDotState===0||preDotState===1&&startDot===end-1&&startDot===startPart+1){return'';}return path.slice(startDot,end);};function filter(xs,f){if(xs.filter)return xs.filter(f);var res=[];for(var i=0;i<xs.length;i++){if(f(xs[i],i,xs))res.push(xs[i]);}return res;}var substr='ab'.substr(-1)==='b'?function(str,start,len){return str.substr(start,len);}:function(str,start,len){if(start<0)start=str.length+start;return str.substr(start,len);};}.call(this));}.call(this,require('_process')));},{'_process':94}],93:[function(require,module,exports){(function(process){(function(){'use strict';if(typeof process==='undefined'||!process.version||process.version.indexOf('v0.')===0||process.version.indexOf('v1.')===0&&process.version.indexOf('v1.8.')!==0){module.exports={nextTick:nextTick};}else{module.exports=process;}function nextTick(fn,arg1,arg2,arg3){if(typeof fn!=='function'){throw new TypeError('"callback" argument must be a function');}var len=arguments.length;var args,i;switch(len){case 0:case 1:return process.nextTick(fn);case 2:return process.nextTick(function afterTickOne(){fn.call(null,arg1);});case 3:return process.nextTick(function afterTickTwo(){fn.call(null,arg1,arg2);});case 4:return process.nextTick(function afterTickThree(){fn.call(null,arg1,arg2,arg3);});default:args=new Array(len-1);i=0;while(i<args.length){args[i++]=arguments[i];}return process.nextTick(function afterTick(){fn.apply(null,args);});}}}.call(this));}.call(this,require('_process')));},{'_process':94}],94:[function(require,module,exports){var process=module.exports={};var cachedSetTimeout;var cachedClearTimeout;function defaultSetTimout(){throw new Error('setTimeout has not been defined');}function defaultClearTimeout(){throw new Error('clearTimeout has not been defined');}(function(){try{if(typeof setTimeout==='function'){cachedSetTimeout=setTimeout;}else{cachedSetTimeout=defaultSetTimout;}}catch(e){cachedSetTimeout=defaultSetTimout;}try{if(typeof clearTimeout==='function'){cachedClearTimeout=clearTimeout;}else{cachedClearTimeout=defaultClearTimeout;}}catch(e){cachedClearTimeout=defaultClearTimeout;}}());function runTimeout(fun){if(cachedSetTimeout===setTimeout){return setTimeout(fun,0);}if((cachedSetTimeout===defaultSetTimout||!cachedSetTimeout)&&setTimeout){cachedSetTimeout=setTimeout;return setTimeout(fun,0);}try{return cachedSetTimeout(fun,0);}catch(e){try{return cachedSetTimeout.call(null,fun,0);}catch(e){return cachedSetTimeout.call(this,fun,0);}}}function runClearTimeout(marker){if(cachedClearTimeout===clearTimeout){return clearTimeout(marker);}if((cachedClearTimeout===defaultClearTimeout||!cachedClearTimeout)&&clearTimeout){cachedClearTimeout=clearTimeout;return clearTimeout(marker);}try{return cachedClearTimeout(marker);}catch(e){try{return cachedClearTimeout.call(null,marker);}catch(e){return cachedClearTimeout.call(this,marker);}}}var queue=[];var draining=false;var currentQueue;var queueIndex=-1;function cleanUpNextTick(){if(!draining||!currentQueue){return;}draining=false;if(currentQueue.length){queue=currentQueue.concat(queue);}else{queueIndex=-1;}if(queue.length){drainQueue();}}function drainQueue(){if(draining){return;}var timeout=runTimeout(cleanUpNextTick);draining=true;var len=queue.length;while(len){currentQueue=queue;queue=[];while(++queueIndex<len){if(currentQueue){currentQueue[queueIndex].run();}}queueIndex=-1;len=queue.length;}currentQueue=null;draining=false;runClearTimeout(timeout);}process.nextTick=function(fun){var args=new Array(arguments.length-1);if(arguments.length>1){for(var i=1;i<arguments.length;i++){args[i-1]=arguments[i];}}queue.push(new Item(fun,args));if(queue.length===1&&!draining){runTimeout(drainQueue);}};function Item(fun,array){this.fun=fun;this.array=array;}Item.prototype.run=function(){this.fun.apply(null,this.array);};process.title='browser';process.browser=true;process.env={};process.argv=[];process.version='';process.versions={};function noop(){}process.on=noop;process.addListener=noop;process.once=noop;process.off=noop;process.removeListener=noop;process.removeAllListeners=noop;process.emit=noop;process.prependListener=noop;process.prependOnceListener=noop;process.listeners=function(name){return[];};process.binding=function(name){throw new Error('process.binding is not supported');};process.cwd=function(){return'/';};process.chdir=function(dir){throw new Error('process.chdir is not supported');};process.umask=function(){return 0;};},{}],95:[function(require,module,exports){var buffer=require('buffer');var Buffer=buffer.Buffer;function copyProps(src,dst){for(var key in src){dst[key]=src[key];}}if(Buffer.from&&Buffer.alloc&&Buffer.allocUnsafe&&Buffer.allocUnsafeSlow){module.exports=buffer;}else{copyProps(buffer,exports);exports.Buffer=SafeBuffer;}function SafeBuffer(arg,encodingOrOffset,length){return Buffer(arg,encodingOrOffset,length);}SafeBuffer.prototype=Object.create(Buffer.prototype);copyProps(Buffer,SafeBuffer);SafeBuffer.from=function(arg,encodingOrOffset,length){if(typeof arg==='number'){throw new TypeError('Argument must not be a number');}return Buffer(arg,encodingOrOffset,length);};SafeBuffer.alloc=function(size,fill,encoding){if(typeof size!=='number'){throw new TypeError('Argument must be a number');}var buf=Buffer(size);if(fill!==undefined){if(typeof encoding==='string'){buf.fill(fill,encoding);}else{buf.fill(fill);}}else{buf.fill(0);}return buf;};SafeBuffer.allocUnsafe=function(size){if(typeof size!=='number'){throw new TypeError('Argument must be a number');}return Buffer(size);};SafeBuffer.allocUnsafeSlow=function(size){if(typeof size!=='number'){throw new TypeError('Argument must be a number');}return buffer.SlowBuffer(size);};},{'buffer':14}],96:[function(require,module,exports){var Buffer=require('safe-buffer').Buffer;function Hash(blockSize,finalSize){this._block=Buffer.alloc(blockSize);this._finalSize=finalSize;this._blockSize=blockSize;this._len=0;}Hash.prototype.update=function(data,enc){if(typeof data==='string'){enc=enc||'utf8';data=Buffer.from(data,enc);}var block=this._block;var blockSize=this._blockSize;var length=data.length;var accum=this._len;for(var offset=0;offset<length;){var assigned=accum%blockSize;var remainder=Math.min(length-offset,blockSize-assigned);for(var i=0;i<remainder;i++){block[assigned+i]=data[offset+i];}accum+=remainder;offset+=remainder;if(accum%blockSize===0){this._update(block);}}this._len+=length;return this;};Hash.prototype.digest=function(enc){var rem=this._len%this._blockSize;this._block[rem]=128;this._block.fill(0,rem+1);if(rem>=this._finalSize){this._update(this._block);this._block.fill(0);}var bits=this._len*8;if(bits<=4294967295){this._block.writeUInt32BE(bits,this._blockSize-4);}else{var lowBits=(bits&4294967295)>>>0;var highBits=(bits-lowBits)/4294967296;this._block.writeUInt32BE(highBits,this._blockSize-8);this._block.writeUInt32BE(lowBits,this._blockSize-4);}this._update(this._block);var hash=this._hash();return enc?hash.toString(enc):hash;};Hash.prototype._update=function(){throw new Error('_update must be implemented by subclass');};module.exports=Hash;},{'safe-buffer':95}],97:[function(require,module,exports){var exports=module.exports=function SHA(algorithm){algorithm=algorithm.toLowerCase();var Algorithm=exports[algorithm];if(!Algorithm)throw new Error(algorithm+' is not supported (we accept pull requests)');return new Algorithm();};exports.sha=require('./sha');exports.sha1=require('./sha1');exports.sha224=require('./sha224');exports.sha256=require('./sha256');exports.sha384=require('./sha384');exports.sha512=require('./sha512');},{'./sha':98,'./sha1':99,'./sha224':100,'./sha256':101,'./sha384':102,'./sha512':103}],98:[function(require,module,exports){var inherits=require('inherits');var Hash=require('./hash');var Buffer=require('safe-buffer').Buffer;var K=[1518500249,1859775393,2400959708|0,3395469782|0];var W=new Array(80);function Sha(){this.init();this._w=W;Hash.call(this,64,56);}inherits(Sha,Hash);Sha.prototype.init=function(){this._a=1732584193;this._b=4023233417;this._c=2562383102;this._d=271733878;this._e=3285377520;return this;};function rotl5(num){return num<<5|num>>>27;}function rotl30(num){return num<<30|num>>>2;}function ft(s,b,c,d){if(s===0)return b&c|~b&d;if(s===2)return b&c|b&d|c&d;return b^c^d;}Sha.prototype._update=function(M){var W=this._w;var a=this._a|0;var b=this._b|0;var c=this._c|0;var d=this._d|0;var e=this._e|0;for(var i=0;i<16;++i)W[i]=M.readInt32BE(i*4);for(;i<80;++i)W[i]=W[i-3]^W[i-8]^W[i-14]^W[i-16];for(var j=0;j<80;++j){var s=~~(j/20);var t=rotl5(a)+ft(s,b,c,d)+e+W[j]+K[s]|0;e=d;d=c;c=rotl30(b);b=a;a=t;}this._a=a+this._a|0;this._b=b+this._b|0;this._c=c+this._c|0;this._d=d+this._d|0;this._e=e+this._e|0;};Sha.prototype._hash=function(){var H=Buffer.allocUnsafe(20);H.writeInt32BE(this._a|0,0);H.writeInt32BE(this._b|0,4);H.writeInt32BE(this._c|0,8);H.writeInt32BE(this._d|0,12);H.writeInt32BE(this._e|0,16);return H;};module.exports=Sha;},{'./hash':96,'inherits':74,'safe-buffer':95}],99:[function(require,module,exports){var inherits=require('inherits');var Hash=require('./hash');var Buffer=require('safe-buffer').Buffer;var K=[1518500249,1859775393,2400959708|0,3395469782|0];var W=new Array(80);function Sha1(){this.init();this._w=W;Hash.call(this,64,56);}inherits(Sha1,Hash);Sha1.prototype.init=function(){this._a=1732584193;this._b=4023233417;this._c=2562383102;this._d=271733878;this._e=3285377520;return this;};function rotl1(num){return num<<1|num>>>31;}function rotl5(num){return num<<5|num>>>27;}function rotl30(num){return num<<30|num>>>2;}function ft(s,b,c,d){if(s===0)return b&c|~b&d;if(s===2)return b&c|b&d|c&d;return b^c^d;}Sha1.prototype._update=function(M){var W=this._w;var a=this._a|0;var b=this._b|0;var c=this._c|0;var d=this._d|0;var e=this._e|0;for(var i=0;i<16;++i)W[i]=M.readInt32BE(i*4);for(;i<80;++i)W[i]=rotl1(W[i-3]^W[i-8]^W[i-14]^W[i-16]);for(var j=0;j<80;++j){var s=~~(j/20);var t=rotl5(a)+ft(s,b,c,d)+e+W[j]+K[s]|0;e=d;d=c;c=rotl30(b);b=a;a=t;}this._a=a+this._a|0;this._b=b+this._b|0;this._c=c+this._c|0;this._d=d+this._d|0;this._e=e+this._e|0;};Sha1.prototype._hash=function(){var H=Buffer.allocUnsafe(20);H.writeInt32BE(this._a|0,0);H.writeInt32BE(this._b|0,4);H.writeInt32BE(this._c|0,8);H.writeInt32BE(this._d|0,12);H.writeInt32BE(this._e|0,16);return H;};module.exports=Sha1;},{'./hash':96,'inherits':74,'safe-buffer':95}],100:[function(require,module,exports){var inherits=require('inherits');var Sha256=require('./sha256');var Hash=require('./hash');var Buffer=require('safe-buffer').Buffer;var W=new Array(64);function Sha224(){this.init();this._w=W;Hash.call(this,64,56);}inherits(Sha224,Sha256);Sha224.prototype.init=function(){this._a=3238371032;this._b=914150663;this._c=812702999;this._d=4144912697;this._e=4290775857;this._f=1750603025;this._g=1694076839;this._h=3204075428;return this;};Sha224.prototype._hash=function(){var H=Buffer.allocUnsafe(28);H.writeInt32BE(this._a,0);H.writeInt32BE(this._b,4);H.writeInt32BE(this._c,8);H.writeInt32BE(this._d,12);H.writeInt32BE(this._e,16);H.writeInt32BE(this._f,20);H.writeInt32BE(this._g,24);return H;};module.exports=Sha224;},{'./hash':96,'./sha256':101,'inherits':74,'safe-buffer':95}],101:[function(require,module,exports){var inherits=require('inherits');var Hash=require('./hash');var Buffer=require('safe-buffer').Buffer;var K=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298];var W=new Array(64);function Sha256(){this.init();this._w=W;Hash.call(this,64,56);}inherits(Sha256,Hash);Sha256.prototype.init=function(){this._a=1779033703;this._b=3144134277;this._c=1013904242;this._d=2773480762;this._e=1359893119;this._f=2600822924;this._g=528734635;this._h=1541459225;return this;};function ch(x,y,z){return z^x&(y^z);}function maj(x,y,z){return x&y|z&(x|y);}function sigma0(x){return(x>>>2|x<<30)^(x>>>13|x<<19)^(x>>>22|x<<10);}function sigma1(x){return(x>>>6|x<<26)^(x>>>11|x<<21)^(x>>>25|x<<7);}function gamma0(x){return(x>>>7|x<<25)^(x>>>18|x<<14)^x>>>3;}function gamma1(x){return(x>>>17|x<<15)^(x>>>19|x<<13)^x>>>10;}Sha256.prototype._update=function(M){var W=this._w;var a=this._a|0;var b=this._b|0;var c=this._c|0;var d=this._d|0;var e=this._e|0;var f=this._f|0;var g=this._g|0;var h=this._h|0;for(var i=0;i<16;++i)W[i]=M.readInt32BE(i*4);for(;i<64;++i)W[i]=gamma1(W[i-2])+W[i-7]+gamma0(W[i-15])+W[i-16]|0;for(var j=0;j<64;++j){var T1=h+sigma1(e)+ch(e,f,g)+K[j]+W[j]|0;var T2=sigma0(a)+maj(a,b,c)|0;h=g;g=f;f=e;e=d+T1|0;d=c;c=b;b=a;a=T1+T2|0;}this._a=a+this._a|0;this._b=b+this._b|0;this._c=c+this._c|0;this._d=d+this._d|0;this._e=e+this._e|0;this._f=f+this._f|0;this._g=g+this._g|0;this._h=h+this._h|0;};Sha256.prototype._hash=function(){var H=Buffer.allocUnsafe(32);H.writeInt32BE(this._a,0);H.writeInt32BE(this._b,4);H.writeInt32BE(this._c,8);H.writeInt32BE(this._d,12);H.writeInt32BE(this._e,16);H.writeInt32BE(this._f,20);H.writeInt32BE(this._g,24);H.writeInt32BE(this._h,28);return H;};module.exports=Sha256;},{'./hash':96,'inherits':74,'safe-buffer':95}],102:[function(require,module,exports){var inherits=require('inherits');var SHA512=require('./sha512');var Hash=require('./hash');var Buffer=require('safe-buffer').Buffer;var W=new Array(160);function Sha384(){this.init();this._w=W;Hash.call(this,128,112);}inherits(Sha384,SHA512);Sha384.prototype.init=function(){this._ah=3418070365;this._bh=1654270250;this._ch=2438529370;this._dh=355462360;this._eh=1731405415;this._fh=2394180231;this._gh=3675008525;this._hh=1203062813;this._al=3238371032;this._bl=914150663;this._cl=812702999;this._dl=4144912697;this._el=4290775857;this._fl=1750603025;this._gl=1694076839;this._hl=3204075428;return this;};Sha384.prototype._hash=function(){var H=Buffer.allocUnsafe(48);function writeInt64BE(h,l,offset){H.writeInt32BE(h,offset);H.writeInt32BE(l,offset+4);}writeInt64BE(this._ah,this._al,0);writeInt64BE(this._bh,this._bl,8);writeInt64BE(this._ch,this._cl,16);writeInt64BE(this._dh,this._dl,24);writeInt64BE(this._eh,this._el,32);writeInt64BE(this._fh,this._fl,40);return H;};module.exports=Sha384;},{'./hash':96,'./sha512':103,'inherits':74,'safe-buffer':95}],103:[function(require,module,exports){var inherits=require('inherits');var Hash=require('./hash');var Buffer=require('safe-buffer').Buffer;var K=[1116352408,3609767458,1899447441,602891725,3049323471,3964484399,3921009573,2173295548,961987163,4081628472,1508970993,3053834265,2453635748,2937671579,2870763221,3664609560,3624381080,2734883394,310598401,1164996542,607225278,1323610764,1426881987,3590304994,1925078388,4068182383,2162078206,991336113,2614888103,633803317,3248222580,3479774868,3835390401,2666613458,4022224774,944711139,264347078,2341262773,604807628,2007800933,770255983,1495990901,1249150122,1856431235,1555081692,3175218132,1996064986,2198950837,2554220882,3999719339,2821834349,766784016,2952996808,2566594879,3210313671,3203337956,3336571891,1034457026,3584528711,2466948901,113926993,3758326383,338241895,168717936,666307205,1188179964,773529912,1546045734,1294757372,1522805485,1396182291,2643833823,1695183700,2343527390,1986661051,1014477480,2177026350,1206759142,2456956037,344077627,2730485921,1290863460,2820302411,3158454273,3259730800,3505952657,3345764771,106217008,3516065817,3606008344,3600352804,1432725776,4094571909,1467031594,275423344,851169720,430227734,3100823752,506948616,1363258195,659060556,3750685593,883997877,3785050280,958139571,3318307427,1322822218,3812723403,1537002063,2003034995,1747873779,3602036899,1955562222,1575990012,2024104815,1125592928,2227730452,2716904306,2361852424,442776044,2428436474,593698344,2756734187,3733110249,3204031479,2999351573,3329325298,3815920427,3391569614,3928383900,3515267271,566280711,3940187606,3454069534,4118630271,4000239992,116418474,1914138554,174292421,2731055270,289380356,3203993006,460393269,320620315,685471733,587496836,852142971,1086792851,1017036298,365543100,1126000580,2618297676,1288033470,3409855158,1501505948,4234509866,1607167915,987167468,1816402316,1246189591];var W=new Array(160);function Sha512(){this.init();this._w=W;Hash.call(this,128,112);}inherits(Sha512,Hash);Sha512.prototype.init=function(){this._ah=1779033703;this._bh=3144134277;this._ch=1013904242;this._dh=2773480762;this._eh=1359893119;this._fh=2600822924;this._gh=528734635;this._hh=1541459225;this._al=4089235720;this._bl=2227873595;this._cl=4271175723;this._dl=1595750129;this._el=2917565137;this._fl=725511199;this._gl=4215389547;this._hl=327033209;return this;};function Ch(x,y,z){return z^x&(y^z);}function maj(x,y,z){return x&y|z&(x|y);}function sigma0(x,xl){return(x>>>28|xl<<4)^(xl>>>2|x<<30)^(xl>>>7|x<<25);}function sigma1(x,xl){return(x>>>14|xl<<18)^(x>>>18|xl<<14)^(xl>>>9|x<<23);}function Gamma0(x,xl){return(x>>>1|xl<<31)^(x>>>8|xl<<24)^x>>>7;}function Gamma0l(x,xl){return(x>>>1|xl<<31)^(x>>>8|xl<<24)^(x>>>7|xl<<25);}function Gamma1(x,xl){return(x>>>19|xl<<13)^(xl>>>29|x<<3)^x>>>6;}function Gamma1l(x,xl){return(x>>>19|xl<<13)^(xl>>>29|x<<3)^(x>>>6|xl<<26);}function getCarry(a,b){return a>>>0<b>>>0?1:0;}Sha512.prototype._update=function(M){var W=this._w;var ah=this._ah|0;var bh=this._bh|0;var ch=this._ch|0;var dh=this._dh|0;var eh=this._eh|0;var fh=this._fh|0;var gh=this._gh|0;var hh=this._hh|0;var al=this._al|0;var bl=this._bl|0;var cl=this._cl|0;var dl=this._dl|0;var el=this._el|0;var fl=this._fl|0;var gl=this._gl|0;var hl=this._hl|0;for(var i=0;i<32;i+=2){W[i]=M.readInt32BE(i*4);W[i+1]=M.readInt32BE(i*4+4);}for(;i<160;i+=2){var xh=W[i-15*2];var xl=W[i-15*2+1];var gamma0=Gamma0(xh,xl);var gamma0l=Gamma0l(xl,xh);xh=W[i-2*2];xl=W[i-2*2+1];var gamma1=Gamma1(xh,xl);var gamma1l=Gamma1l(xl,xh);var Wi7h=W[i-7*2];var Wi7l=W[i-7*2+1];var Wi16h=W[i-16*2];var Wi16l=W[i-16*2+1];var Wil=gamma0l+Wi7l|0;var Wih=gamma0+Wi7h+getCarry(Wil,gamma0l)|0;Wil=Wil+gamma1l|0;Wih=Wih+gamma1+getCarry(Wil,gamma1l)|0;Wil=Wil+Wi16l|0;Wih=Wih+Wi16h+getCarry(Wil,Wi16l)|0;W[i]=Wih;W[i+1]=Wil;}for(var j=0;j<160;j+=2){Wih=W[j];Wil=W[j+1];var majh=maj(ah,bh,ch);var majl=maj(al,bl,cl);var sigma0h=sigma0(ah,al);var sigma0l=sigma0(al,ah);var sigma1h=sigma1(eh,el);var sigma1l=sigma1(el,eh);var Kih=K[j];var Kil=K[j+1];var chh=Ch(eh,fh,gh);var chl=Ch(el,fl,gl);var t1l=hl+sigma1l|0;var t1h=hh+sigma1h+getCarry(t1l,hl)|0;t1l=t1l+chl|0;t1h=t1h+chh+getCarry(t1l,chl)|0;t1l=t1l+Kil|0;t1h=t1h+Kih+getCarry(t1l,Kil)|0;t1l=t1l+Wil|0;t1h=t1h+Wih+getCarry(t1l,Wil)|0;var t2l=sigma0l+majl|0;var t2h=sigma0h+majh+getCarry(t2l,sigma0l)|0;hh=gh;hl=gl;gh=fh;gl=fl;fh=eh;fl=el;el=dl+t1l|0;eh=dh+t1h+getCarry(el,dl)|0;dh=ch;dl=cl;ch=bh;cl=bl;bh=ah;bl=al;al=t1l+t2l|0;ah=t1h+t2h+getCarry(al,t1l)|0;}this._al=this._al+al|0;this._bl=this._bl+bl|0;this._cl=this._cl+cl|0;this._dl=this._dl+dl|0;this._el=this._el+el|0;this._fl=this._fl+fl|0;this._gl=this._gl+gl|0;this._hl=this._hl+hl|0;this._ah=this._ah+ah+getCarry(this._al,al)|0;this._bh=this._bh+bh+getCarry(this._bl,bl)|0;this._ch=this._ch+ch+getCarry(this._cl,cl)|0;this._dh=this._dh+dh+getCarry(this._dl,dl)|0;this._eh=this._eh+eh+getCarry(this._el,el)|0;this._fh=this._fh+fh+getCarry(this._fl,fl)|0;this._gh=this._gh+gh+getCarry(this._gl,gl)|0;this._hh=this._hh+hh+getCarry(this._hl,hl)|0;};Sha512.prototype._hash=function(){var H=Buffer.allocUnsafe(64);function writeInt64BE(h,l,offset){H.writeInt32BE(h,offset);H.writeInt32BE(l,offset+4);}writeInt64BE(this._ah,this._al,0);writeInt64BE(this._bh,this._bl,8);writeInt64BE(this._ch,this._cl,16);writeInt64BE(this._dh,this._dl,24);writeInt64BE(this._eh,this._el,32);writeInt64BE(this._fh,this._fl,40);writeInt64BE(this._gh,this._gl,48);writeInt64BE(this._hh,this._hl,56);return H;};module.exports=Sha512;},{'./hash':96,'inherits':74,'safe-buffer':95}],104:[function(require,module,exports){var util=require('./util');var has=Object.prototype.hasOwnProperty;var hasNativeMap=typeof Map!=='undefined';function ArraySet(){this._array=[];this._set=hasNativeMap?new Map():Object.create(null);}ArraySet.fromArray=function ArraySet_fromArray(aArray,aAllowDuplicates){var set=new ArraySet();for(var i=0,len=aArray.length;i<len;i++){set.add(aArray[i],aAllowDuplicates);}return set;};ArraySet.prototype.size=function ArraySet_size(){return hasNativeMap?this._set.size:Object.getOwnPropertyNames(this._set).length;};ArraySet.prototype.add=function ArraySet_add(aStr,aAllowDuplicates){var sStr=hasNativeMap?aStr:util.toSetString(aStr);var isDuplicate=hasNativeMap?this.has(aStr):has.call(this._set,sStr);var idx=this._array.length;if(!isDuplicate||aAllowDuplicates){this._array.push(aStr);}if(!isDuplicate){if(hasNativeMap){this._set.set(aStr,idx);}else{this._set[sStr]=idx;}}};ArraySet.prototype.has=function ArraySet_has(aStr){if(hasNativeMap){return this._set.has(aStr);}else{var sStr=util.toSetString(aStr);return has.call(this._set,sStr);}};ArraySet.prototype.indexOf=function ArraySet_indexOf(aStr){if(hasNativeMap){var idx=this._set.get(aStr);if(idx>=0){return idx;}}else{var sStr=util.toSetString(aStr);if(has.call(this._set,sStr)){return this._set[sStr];}}throw new Error('"'+aStr+'" is not in the set.');};ArraySet.prototype.at=function ArraySet_at(aIdx){if(aIdx>=0&&aIdx<this._array.length){return this._array[aIdx];}throw new Error('No element indexed by '+aIdx);};ArraySet.prototype.toArray=function ArraySet_toArray(){return this._array.slice();};exports.ArraySet=ArraySet;},{'./util':113}],105:[function(require,module,exports){var base64=require('./base64');var VLQ_BASE_SHIFT=5;var VLQ_BASE=1<<VLQ_BASE_SHIFT;var VLQ_BASE_MASK=VLQ_BASE-1;var VLQ_CONTINUATION_BIT=VLQ_BASE;function toVLQSigned(aValue){return aValue<0?(-aValue<<1)+1:(aValue<<1)+0;}function fromVLQSigned(aValue){var isNegative=(aValue&1)===1;var shifted=aValue>>1;return isNegative?-shifted:shifted;}exports.encode=function base64VLQ_encode(aValue){var encoded='';var digit;var vlq=toVLQSigned(aValue);do{digit=vlq&VLQ_BASE_MASK;vlq>>>=VLQ_BASE_SHIFT;if(vlq>0){digit|=VLQ_CONTINUATION_BIT;}encoded+=base64.encode(digit);}while(vlq>0);return encoded;};exports.decode=function base64VLQ_decode(aStr,aIndex,aOutParam){var strLen=aStr.length;var result=0;var shift=0;var continuation,digit;do{if(aIndex>=strLen){throw new Error('Expected more digits in base 64 VLQ value.');}digit=base64.decode(aStr.charCodeAt(aIndex++));if(digit===-1){throw new Error('Invalid base64 digit: '+aStr.charAt(aIndex-1));}continuation=!!(digit&VLQ_CONTINUATION_BIT);digit&=VLQ_BASE_MASK;result=result+(digit<<shift);shift+=VLQ_BASE_SHIFT;}while(continuation);aOutParam.value=fromVLQSigned(result);aOutParam.rest=aIndex;};},{'./base64':106}],106:[function(require,module,exports){var intToCharMap='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.split('');exports.encode=function(number){if(0<=number&&number<intToCharMap.length){return intToCharMap[number];}throw new TypeError('Must be between 0 and 63: '+number);};exports.decode=function(charCode){var bigA=65;var bigZ=90;var littleA=97;var littleZ=122;var zero=48;var nine=57;var plus=43;var slash=47;var littleOffset=26;var numberOffset=52;if(bigA<=charCode&&charCode<=bigZ){return charCode-bigA;}if(littleA<=charCode&&charCode<=littleZ){return charCode-littleA+littleOffset;}if(zero<=charCode&&charCode<=nine){return charCode-zero+numberOffset;}if(charCode==plus){return 62;}if(charCode==slash){return 63;}return-1;};},{}],107:[function(require,module,exports){exports.GREATEST_LOWER_BOUND=1;exports.LEAST_UPPER_BOUND=2;function recursiveSearch(aLow,aHigh,aNeedle,aHaystack,aCompare,aBias){var mid=Math.floor((aHigh-aLow)/2)+aLow;var cmp=aCompare(aNeedle,aHaystack[mid],true);if(cmp===0){return mid;}else if(cmp>0){if(aHigh-mid>1){return recursiveSearch(mid,aHigh,aNeedle,aHaystack,aCompare,aBias);}if(aBias==exports.LEAST_UPPER_BOUND){return aHigh<aHaystack.length?aHigh:-1;}else{return mid;}}else{if(mid-aLow>1){return recursiveSearch(aLow,mid,aNeedle,aHaystack,aCompare,aBias);}if(aBias==exports.LEAST_UPPER_BOUND){return mid;}else{return aLow<0?-1:aLow;}}}exports.search=function search(aNeedle,aHaystack,aCompare,aBias){if(aHaystack.length===0){return-1;}var index=recursiveSearch(-1,aHaystack.length,aNeedle,aHaystack,aCompare,aBias||exports.GREATEST_LOWER_BOUND);if(index<0){return-1;}while(index-1>=0){if(aCompare(aHaystack[index],aHaystack[index-1],true)!==0){break;}--index;}return index;};},{}],108:[function(require,module,exports){var util=require('./util');function generatedPositionAfter(mappingA,mappingB){var lineA=mappingA.generatedLine;var lineB=mappingB.generatedLine;var columnA=mappingA.generatedColumn;var columnB=mappingB.generatedColumn;return lineB>lineA||lineB==lineA&&columnB>=columnA||util.compareByGeneratedPositionsInflated(mappingA,mappingB)<=0;}function MappingList(){this._array=[];this._sorted=true;this._last={generatedLine:-1,generatedColumn:0};}MappingList.prototype.unsortedForEach=function MappingList_forEach(aCallback,aThisArg){this._array.forEach(aCallback,aThisArg);};MappingList.prototype.add=function MappingList_add(aMapping){if(generatedPositionAfter(this._last,aMapping)){this._last=aMapping;this._array.push(aMapping);}else{this._sorted=false;this._array.push(aMapping);}};MappingList.prototype.toArray=function MappingList_toArray(){if(!this._sorted){this._array.sort(util.compareByGeneratedPositionsInflated);this._sorted=true;}return this._array;};exports.MappingList=MappingList;},{'./util':113}],109:[function(require,module,exports){function swap(ary,x,y){var temp=ary[x];ary[x]=ary[y];ary[y]=temp;}function randomIntInRange(low,high){return Math.round(low+Math.random()*(high-low));}function doQuickSort(ary,comparator,p,r){if(p<r){var pivotIndex=randomIntInRange(p,r);var i=p-1;swap(ary,pivotIndex,r);var pivot=ary[r];for(var j=p;j<r;j++){if(comparator(ary[j],pivot)<=0){i+=1;swap(ary,i,j);}}swap(ary,i+1,j);var q=i+1;doQuickSort(ary,comparator,p,q-1);doQuickSort(ary,comparator,q+1,r);}}exports.quickSort=function(ary,comparator){doQuickSort(ary,comparator,0,ary.length-1);};},{}],110:[function(require,module,exports){var util=require('./util');var binarySearch=require('./binary-search');var ArraySet=require('./array-set').ArraySet;var base64VLQ=require('./base64-vlq');var quickSort=require('./quick-sort').quickSort;function SourceMapConsumer(aSourceMap){var sourceMap=aSourceMap;if(typeof aSourceMap==='string'){sourceMap=JSON.parse(aSourceMap.replace(/^\)\]\}'/,''));}return sourceMap.sections!=null?new IndexedSourceMapConsumer(sourceMap):new BasicSourceMapConsumer(sourceMap);}SourceMapConsumer.fromSourceMap=function(aSourceMap){return BasicSourceMapConsumer.fromSourceMap(aSourceMap);};SourceMapConsumer.prototype._version=3;SourceMapConsumer.prototype.__generatedMappings=null;Object.defineProperty(SourceMapConsumer.prototype,'_generatedMappings',{get:function(){if(!this.__generatedMappings){this._parseMappings(this._mappings,this.sourceRoot);}return this.__generatedMappings;}});SourceMapConsumer.prototype.__originalMappings=null;Object.defineProperty(SourceMapConsumer.prototype,'_originalMappings',{get:function(){if(!this.__originalMappings){this._parseMappings(this._mappings,this.sourceRoot);}return this.__originalMappings;}});SourceMapConsumer.prototype._charIsMappingSeparator=function SourceMapConsumer_charIsMappingSeparator(aStr,index){var c=aStr.charAt(index);return c===';'||c===',';};SourceMapConsumer.prototype._parseMappings=function SourceMapConsumer_parseMappings(aStr,aSourceRoot){throw new Error('Subclasses must implement _parseMappings');};SourceMapConsumer.GENERATED_ORDER=1;SourceMapConsumer.ORIGINAL_ORDER=2;SourceMapConsumer.GREATEST_LOWER_BOUND=1;SourceMapConsumer.LEAST_UPPER_BOUND=2;SourceMapConsumer.prototype.eachMapping=function SourceMapConsumer_eachMapping(aCallback,aContext,aOrder){var context=aContext||null;var order=aOrder||SourceMapConsumer.GENERATED_ORDER;var mappings;switch(order){case SourceMapConsumer.GENERATED_ORDER:mappings=this._generatedMappings;break;case SourceMapConsumer.ORIGINAL_ORDER:mappings=this._originalMappings;break;default:throw new Error('Unknown order of iteration.');}var sourceRoot=this.sourceRoot;mappings.map(function(mapping){var source=mapping.source===null?null:this._sources.at(mapping.source);if(source!=null&&sourceRoot!=null){source=util.join(sourceRoot,source);}return{source:source,generatedLine:mapping.generatedLine,generatedColumn:mapping.generatedColumn,originalLine:mapping.originalLine,originalColumn:mapping.originalColumn,name:mapping.name===null?null:this._names.at(mapping.name)};},this).forEach(aCallback,context);};SourceMapConsumer.prototype.allGeneratedPositionsFor=function SourceMapConsumer_allGeneratedPositionsFor(aArgs){var line=util.getArg(aArgs,'line');var needle={source:util.getArg(aArgs,'source'),originalLine:line,originalColumn:util.getArg(aArgs,'column',0)};if(this.sourceRoot!=null){needle.source=util.relative(this.sourceRoot,needle.source);}if(!this._sources.has(needle.source)){return[];}needle.source=this._sources.indexOf(needle.source);var mappings=[];var index=this._findMapping(needle,this._originalMappings,'originalLine','originalColumn',util.compareByOriginalPositions,binarySearch.LEAST_UPPER_BOUND);if(index>=0){var mapping=this._originalMappings[index];if(aArgs.column===undefined){var originalLine=mapping.originalLine;while(mapping&&mapping.originalLine===originalLine){mappings.push({line:util.getArg(mapping,'generatedLine',null),column:util.getArg(mapping,'generatedColumn',null),lastColumn:util.getArg(mapping,'lastGeneratedColumn',null)});mapping=this._originalMappings[++index];}}else{var originalColumn=mapping.originalColumn;while(mapping&&mapping.originalLine===line&&mapping.originalColumn==originalColumn){mappings.push({line:util.getArg(mapping,'generatedLine',null),column:util.getArg(mapping,'generatedColumn',null),lastColumn:util.getArg(mapping,'lastGeneratedColumn',null)});mapping=this._originalMappings[++index];}}}return mappings;};exports.SourceMapConsumer=SourceMapConsumer;function BasicSourceMapConsumer(aSourceMap){var sourceMap=aSourceMap;if(typeof aSourceMap==='string'){sourceMap=JSON.parse(aSourceMap.replace(/^\)\]\}'/,''));}var version=util.getArg(sourceMap,'version');var sources=util.getArg(sourceMap,'sources');var names=util.getArg(sourceMap,'names',[]);var sourceRoot=util.getArg(sourceMap,'sourceRoot',null);var sourcesContent=util.getArg(sourceMap,'sourcesContent',null);var mappings=util.getArg(sourceMap,'mappings');var file=util.getArg(sourceMap,'file',null);if(version!=this._version){throw new Error('Unsupported version: '+version);}sources=sources.map(String).map(util.normalize).map(function(source){return sourceRoot&&util.isAbsolute(sourceRoot)&&util.isAbsolute(source)?util.relative(sourceRoot,source):source;});this._names=ArraySet.fromArray(names.map(String),true);this._sources=ArraySet.fromArray(sources,true);this.sourceRoot=sourceRoot;this.sourcesContent=sourcesContent;this._mappings=mappings;this.file=file;}BasicSourceMapConsumer.prototype=Object.create(SourceMapConsumer.prototype);BasicSourceMapConsumer.prototype.consumer=SourceMapConsumer;BasicSourceMapConsumer.fromSourceMap=function SourceMapConsumer_fromSourceMap(aSourceMap){var smc=Object.create(BasicSourceMapConsumer.prototype);var names=smc._names=ArraySet.fromArray(aSourceMap._names.toArray(),true);var sources=smc._sources=ArraySet.fromArray(aSourceMap._sources.toArray(),true);smc.sourceRoot=aSourceMap._sourceRoot;smc.sourcesContent=aSourceMap._generateSourcesContent(smc._sources.toArray(),smc.sourceRoot);smc.file=aSourceMap._file;var generatedMappings=aSourceMap._mappings.toArray().slice();var destGeneratedMappings=smc.__generatedMappings=[];var destOriginalMappings=smc.__originalMappings=[];for(var i=0,length=generatedMappings.length;i<length;i++){var srcMapping=generatedMappings[i];var destMapping=new Mapping();destMapping.generatedLine=srcMapping.generatedLine;destMapping.generatedColumn=srcMapping.generatedColumn;if(srcMapping.source){destMapping.source=sources.indexOf(srcMapping.source);destMapping.originalLine=srcMapping.originalLine;destMapping.originalColumn=srcMapping.originalColumn;if(srcMapping.name){destMapping.name=names.indexOf(srcMapping.name);}destOriginalMappings.push(destMapping);}destGeneratedMappings.push(destMapping);}quickSort(smc.__originalMappings,util.compareByOriginalPositions);return smc;};BasicSourceMapConsumer.prototype._version=3;Object.defineProperty(BasicSourceMapConsumer.prototype,'sources',{get:function(){return this._sources.toArray().map(function(s){return this.sourceRoot!=null?util.join(this.sourceRoot,s):s;},this);}});function Mapping(){this.generatedLine=0;this.generatedColumn=0;this.source=null;this.originalLine=null;this.originalColumn=null;this.name=null;}BasicSourceMapConsumer.prototype._parseMappings=function SourceMapConsumer_parseMappings(aStr,aSourceRoot){var generatedLine=1;var previousGeneratedColumn=0;var previousOriginalLine=0;var previousOriginalColumn=0;var previousSource=0;var previousName=0;var length=aStr.length;var index=0;var cachedSegments={};var temp={};var originalMappings=[];var generatedMappings=[];var mapping,str,segment,end,value;while(index<length){if(aStr.charAt(index)===';'){generatedLine++;index++;previousGeneratedColumn=0;}else if(aStr.charAt(index)===','){index++;}else{mapping=new Mapping();mapping.generatedLine=generatedLine;for(end=index;end<length;end++){if(this._charIsMappingSeparator(aStr,end)){break;}}str=aStr.slice(index,end);segment=cachedSegments[str];if(segment){index+=str.length;}else{segment=[];while(index<end){base64VLQ.decode(aStr,index,temp);value=temp.value;index=temp.rest;segment.push(value);}if(segment.length===2){throw new Error('Found a source, but no line and column');}if(segment.length===3){throw new Error('Found a source and line, but no column');}cachedSegments[str]=segment;}mapping.generatedColumn=previousGeneratedColumn+segment[0];previousGeneratedColumn=mapping.generatedColumn;if(segment.length>1){mapping.source=previousSource+segment[1];previousSource+=segment[1];mapping.originalLine=previousOriginalLine+segment[2];previousOriginalLine=mapping.originalLine;mapping.originalLine+=1;mapping.originalColumn=previousOriginalColumn+segment[3];previousOriginalColumn=mapping.originalColumn;if(segment.length>4){mapping.name=previousName+segment[4];previousName+=segment[4];}}generatedMappings.push(mapping);if(typeof mapping.originalLine==='number'){originalMappings.push(mapping);}}}quickSort(generatedMappings,util.compareByGeneratedPositionsDeflated);this.__generatedMappings=generatedMappings;quickSort(originalMappings,util.compareByOriginalPositions);this.__originalMappings=originalMappings;};BasicSourceMapConsumer.prototype._findMapping=function SourceMapConsumer_findMapping(aNeedle,aMappings,aLineName,aColumnName,aComparator,aBias){if(aNeedle[aLineName]<=0){throw new TypeError('Line must be greater than or equal to 1, got '+aNeedle[aLineName]);}if(aNeedle[aColumnName]<0){throw new TypeError('Column must be greater than or equal to 0, got '+aNeedle[aColumnName]);}return binarySearch.search(aNeedle,aMappings,aComparator,aBias);};BasicSourceMapConsumer.prototype.computeColumnSpans=function SourceMapConsumer_computeColumnSpans(){for(var index=0;index<this._generatedMappings.length;++index){var mapping=this._generatedMappings[index];if(index+1<this._generatedMappings.length){var nextMapping=this._generatedMappings[index+1];if(mapping.generatedLine===nextMapping.generatedLine){mapping.lastGeneratedColumn=nextMapping.generatedColumn-1;continue;}}mapping.lastGeneratedColumn=Infinity;}};BasicSourceMapConsumer.prototype.originalPositionFor=function SourceMapConsumer_originalPositionFor(aArgs){var needle={generatedLine:util.getArg(aArgs,'line'),generatedColumn:util.getArg(aArgs,'column')};var index=this._findMapping(needle,this._generatedMappings,'generatedLine','generatedColumn',util.compareByGeneratedPositionsDeflated,util.getArg(aArgs,'bias',SourceMapConsumer.GREATEST_LOWER_BOUND));if(index>=0){var mapping=this._generatedMappings[index];if(mapping.generatedLine===needle.generatedLine){var source=util.getArg(mapping,'source',null);if(source!==null){source=this._sources.at(source);if(this.sourceRoot!=null){source=util.join(this.sourceRoot,source);}}var name=util.getArg(mapping,'name',null);if(name!==null){name=this._names.at(name);}return{source:source,line:util.getArg(mapping,'originalLine',null),column:util.getArg(mapping,'originalColumn',null),name:name};}}return{source:null,line:null,column:null,name:null};};BasicSourceMapConsumer.prototype.hasContentsOfAllSources=function BasicSourceMapConsumer_hasContentsOfAllSources(){if(!this.sourcesContent){return false;}return this.sourcesContent.length>=this._sources.size()&&!this.sourcesContent.some(function(sc){return sc==null;});};BasicSourceMapConsumer.prototype.sourceContentFor=function SourceMapConsumer_sourceContentFor(aSource,nullOnMissing){if(!this.sourcesContent){return null;}if(this.sourceRoot!=null){aSource=util.relative(this.sourceRoot,aSource);}if(this._sources.has(aSource)){return this.sourcesContent[this._sources.indexOf(aSource)];}var url;if(this.sourceRoot!=null&&(url=util.urlParse(this.sourceRoot))){var fileUriAbsPath=aSource.replace(/^file:\/\//,'');if(url.scheme=='file'&&this._sources.has(fileUriAbsPath)){return this.sourcesContent[this._sources.indexOf(fileUriAbsPath)];}if((!url.path||url.path=='/')&&this._sources.has('/'+aSource)){return this.sourcesContent[this._sources.indexOf('/'+aSource)];}}if(nullOnMissing){return null;}else{throw new Error('"'+aSource+'" is not in the SourceMap.');}};BasicSourceMapConsumer.prototype.generatedPositionFor=function SourceMapConsumer_generatedPositionFor(aArgs){var source=util.getArg(aArgs,'source');if(this.sourceRoot!=null){source=util.relative(this.sourceRoot,source);}if(!this._sources.has(source)){return{line:null,column:null,lastColumn:null};}source=this._sources.indexOf(source);var needle={source:source,originalLine:util.getArg(aArgs,'line'),originalColumn:util.getArg(aArgs,'column')};var index=this._findMapping(needle,this._originalMappings,'originalLine','originalColumn',util.compareByOriginalPositions,util.getArg(aArgs,'bias',SourceMapConsumer.GREATEST_LOWER_BOUND));if(index>=0){var mapping=this._originalMappings[index];if(mapping.source===needle.source){return{line:util.getArg(mapping,'generatedLine',null),column:util.getArg(mapping,'generatedColumn',null),lastColumn:util.getArg(mapping,'lastGeneratedColumn',null)};}}return{line:null,column:null,lastColumn:null};};exports.BasicSourceMapConsumer=BasicSourceMapConsumer;function IndexedSourceMapConsumer(aSourceMap){var sourceMap=aSourceMap;if(typeof aSourceMap==='string'){sourceMap=JSON.parse(aSourceMap.replace(/^\)\]\}'/,''));}var version=util.getArg(sourceMap,'version');var sections=util.getArg(sourceMap,'sections');if(version!=this._version){throw new Error('Unsupported version: '+version);}this._sources=new ArraySet();this._names=new ArraySet();var lastOffset={line:-1,column:0};this._sections=sections.map(function(s){if(s.url){throw new Error('Support for url field in sections not implemented.');}var offset=util.getArg(s,'offset');var offsetLine=util.getArg(offset,'line');var offsetColumn=util.getArg(offset,'column');if(offsetLine<lastOffset.line||offsetLine===lastOffset.line&&offsetColumn<lastOffset.column){throw new Error('Section offsets must be ordered and non-overlapping.');}lastOffset=offset;return{generatedOffset:{generatedLine:offsetLine+1,generatedColumn:offsetColumn+1},consumer:new SourceMapConsumer(util.getArg(s,'map'))};});}IndexedSourceMapConsumer.prototype=Object.create(SourceMapConsumer.prototype);IndexedSourceMapConsumer.prototype.constructor=SourceMapConsumer;IndexedSourceMapConsumer.prototype._version=3;Object.defineProperty(IndexedSourceMapConsumer.prototype,'sources',{get:function(){var sources=[];for(var i=0;i<this._sections.length;i++){for(var j=0;j<this._sections[i].consumer.sources.length;j++){sources.push(this._sections[i].consumer.sources[j]);}}return sources;}});IndexedSourceMapConsumer.prototype.originalPositionFor=function IndexedSourceMapConsumer_originalPositionFor(aArgs){var needle={generatedLine:util.getArg(aArgs,'line'),generatedColumn:util.getArg(aArgs,'column')};var sectionIndex=binarySearch.search(needle,this._sections,function(needle,section){var cmp=needle.generatedLine-section.generatedOffset.generatedLine;if(cmp){return cmp;}return needle.generatedColumn-section.generatedOffset.generatedColumn;});var section=this._sections[sectionIndex];if(!section){return{source:null,line:null,column:null,name:null};}return section.consumer.originalPositionFor({line:needle.generatedLine-(section.generatedOffset.generatedLine-1),column:needle.generatedColumn-(section.generatedOffset.generatedLine===needle.generatedLine?section.generatedOffset.generatedColumn-1:0),bias:aArgs.bias});};IndexedSourceMapConsumer.prototype.hasContentsOfAllSources=function IndexedSourceMapConsumer_hasContentsOfAllSources(){return this._sections.every(function(s){return s.consumer.hasContentsOfAllSources();});};IndexedSourceMapConsumer.prototype.sourceContentFor=function IndexedSourceMapConsumer_sourceContentFor(aSource,nullOnMissing){for(var i=0;i<this._sections.length;i++){var section=this._sections[i];var content=section.consumer.sourceContentFor(aSource,true);if(content){return content;}}if(nullOnMissing){return null;}else{throw new Error('"'+aSource+'" is not in the SourceMap.');}};IndexedSourceMapConsumer.prototype.generatedPositionFor=function IndexedSourceMapConsumer_generatedPositionFor(aArgs){for(var i=0;i<this._sections.length;i++){var section=this._sections[i];if(section.consumer.sources.indexOf(util.getArg(aArgs,'source'))===-1){continue;}var generatedPosition=section.consumer.generatedPositionFor(aArgs);if(generatedPosition){var ret={line:generatedPosition.line+(section.generatedOffset.generatedLine-1),column:generatedPosition.column+(section.generatedOffset.generatedLine===generatedPosition.line?section.generatedOffset.generatedColumn-1:0)};return ret;}}return{line:null,column:null};};IndexedSourceMapConsumer.prototype._parseMappings=function IndexedSourceMapConsumer_parseMappings(aStr,aSourceRoot){this.__generatedMappings=[];this.__originalMappings=[];for(var i=0;i<this._sections.length;i++){var section=this._sections[i];var sectionMappings=section.consumer._generatedMappings;for(var j=0;j<sectionMappings.length;j++){var mapping=sectionMappings[j];var source=section.consumer._sources.at(mapping.source);if(section.consumer.sourceRoot!==null){source=util.join(section.consumer.sourceRoot,source);}this._sources.add(source);source=this._sources.indexOf(source);var name=section.consumer._names.at(mapping.name);this._names.add(name);name=this._names.indexOf(name);var adjustedMapping={source:source,generatedLine:mapping.generatedLine+(section.generatedOffset.generatedLine-1),generatedColumn:mapping.generatedColumn+(section.generatedOffset.generatedLine===mapping.generatedLine?section.generatedOffset.generatedColumn-1:0),originalLine:mapping.originalLine,originalColumn:mapping.originalColumn,name:name};this.__generatedMappings.push(adjustedMapping);if(typeof adjustedMapping.originalLine==='number'){this.__originalMappings.push(adjustedMapping);}}}quickSort(this.__generatedMappings,util.compareByGeneratedPositionsDeflated);quickSort(this.__originalMappings,util.compareByOriginalPositions);};exports.IndexedSourceMapConsumer=IndexedSourceMapConsumer;},{'./array-set':104,'./base64-vlq':105,'./binary-search':107,'./quick-sort':109,'./util':113}],111:[function(require,module,exports){var base64VLQ=require('./base64-vlq');var util=require('./util');var ArraySet=require('./array-set').ArraySet;var MappingList=require('./mapping-list').MappingList;function SourceMapGenerator(aArgs){if(!aArgs){aArgs={};}this._file=util.getArg(aArgs,'file',null);this._sourceRoot=util.getArg(aArgs,'sourceRoot',null);this._skipValidation=util.getArg(aArgs,'skipValidation',false);this._sources=new ArraySet();this._names=new ArraySet();this._mappings=new MappingList();this._sourcesContents=null;}SourceMapGenerator.prototype._version=3;SourceMapGenerator.fromSourceMap=function SourceMapGenerator_fromSourceMap(aSourceMapConsumer){var sourceRoot=aSourceMapConsumer.sourceRoot;var generator=new SourceMapGenerator({file:aSourceMapConsumer.file,sourceRoot:sourceRoot});aSourceMapConsumer.eachMapping(function(mapping){var newMapping={generated:{line:mapping.generatedLine,column:mapping.generatedColumn}};if(mapping.source!=null){newMapping.source=mapping.source;if(sourceRoot!=null){newMapping.source=util.relative(sourceRoot,newMapping.source);}newMapping.original={line:mapping.originalLine,column:mapping.originalColumn};if(mapping.name!=null){newMapping.name=mapping.name;}}generator.addMapping(newMapping);});aSourceMapConsumer.sources.forEach(function(sourceFile){var content=aSourceMapConsumer.sourceContentFor(sourceFile);if(content!=null){generator.setSourceContent(sourceFile,content);}});return generator;};SourceMapGenerator.prototype.addMapping=function SourceMapGenerator_addMapping(aArgs){var generated=util.getArg(aArgs,'generated');var original=util.getArg(aArgs,'original',null);var source=util.getArg(aArgs,'source',null);var name=util.getArg(aArgs,'name',null);if(!this._skipValidation){this._validateMapping(generated,original,source,name);}if(source!=null){source=String(source);if(!this._sources.has(source)){this._sources.add(source);}}if(name!=null){name=String(name);if(!this._names.has(name)){this._names.add(name);}}this._mappings.add({generatedLine:generated.line,generatedColumn:generated.column,originalLine:original!=null&&original.line,originalColumn:original!=null&&original.column,source:source,name:name});};SourceMapGenerator.prototype.setSourceContent=function SourceMapGenerator_setSourceContent(aSourceFile,aSourceContent){var source=aSourceFile;if(this._sourceRoot!=null){source=util.relative(this._sourceRoot,source);}if(aSourceContent!=null){if(!this._sourcesContents){this._sourcesContents=Object.create(null);}this._sourcesContents[util.toSetString(source)]=aSourceContent;}else if(this._sourcesContents){delete this._sourcesContents[util.toSetString(source)];if(Object.keys(this._sourcesContents).length===0){this._sourcesContents=null;}}};SourceMapGenerator.prototype.applySourceMap=function SourceMapGenerator_applySourceMap(aSourceMapConsumer,aSourceFile,aSourceMapPath){var sourceFile=aSourceFile;if(aSourceFile==null){if(aSourceMapConsumer.file==null){throw new Error('SourceMapGenerator.prototype.applySourceMap requires either an explicit source file, '+'or the source map\'s "file" property. Both were omitted.');}sourceFile=aSourceMapConsumer.file;}var sourceRoot=this._sourceRoot;if(sourceRoot!=null){sourceFile=util.relative(sourceRoot,sourceFile);}var newSources=new ArraySet();var newNames=new ArraySet();this._mappings.unsortedForEach(function(mapping){if(mapping.source===sourceFile&&mapping.originalLine!=null){var original=aSourceMapConsumer.originalPositionFor({line:mapping.originalLine,column:mapping.originalColumn});if(original.source!=null){mapping.source=original.source;if(aSourceMapPath!=null){mapping.source=util.join(aSourceMapPath,mapping.source);}if(sourceRoot!=null){mapping.source=util.relative(sourceRoot,mapping.source);}mapping.originalLine=original.line;mapping.originalColumn=original.column;if(original.name!=null){mapping.name=original.name;}}}var source=mapping.source;if(source!=null&&!newSources.has(source)){newSources.add(source);}var name=mapping.name;if(name!=null&&!newNames.has(name)){newNames.add(name);}},this);this._sources=newSources;this._names=newNames;aSourceMapConsumer.sources.forEach(function(sourceFile){var content=aSourceMapConsumer.sourceContentFor(sourceFile);if(content!=null){if(aSourceMapPath!=null){sourceFile=util.join(aSourceMapPath,sourceFile);}if(sourceRoot!=null){sourceFile=util.relative(sourceRoot,sourceFile);}this.setSourceContent(sourceFile,content);}},this);};SourceMapGenerator.prototype._validateMapping=function SourceMapGenerator_validateMapping(aGenerated,aOriginal,aSource,aName){if(aOriginal&&typeof aOriginal.line!=='number'&&typeof aOriginal.column!=='number'){throw new Error('original.line and original.column are not numbers -- you probably meant to omit '+'the original mapping entirely and only map the generated position. If so, pass '+'null for the original mapping instead of an object with empty or null values.');}if(aGenerated&&'line'in aGenerated&&'column'in aGenerated&&aGenerated.line>0&&aGenerated.column>=0&&!aOriginal&&!aSource&&!aName){return;}else if(aGenerated&&'line'in aGenerated&&'column'in aGenerated&&aOriginal&&'line'in aOriginal&&'column'in aOriginal&&aGenerated.line>0&&aGenerated.column>=0&&aOriginal.line>0&&aOriginal.column>=0&&aSource){return;}else{throw new Error('Invalid mapping: '+JSON.stringify({generated:aGenerated,source:aSource,original:aOriginal,name:aName}));}};SourceMapGenerator.prototype._serializeMappings=function SourceMapGenerator_serializeMappings(){var previousGeneratedColumn=0;var previousGeneratedLine=1;var previousOriginalColumn=0;var previousOriginalLine=0;var previousName=0;var previousSource=0;var result='';var next;var mapping;var nameIdx;var sourceIdx;var mappings=this._mappings.toArray();for(var i=0,len=mappings.length;i<len;i++){mapping=mappings[i];next='';if(mapping.generatedLine!==previousGeneratedLine){previousGeneratedColumn=0;while(mapping.generatedLine!==previousGeneratedLine){next+=';';previousGeneratedLine++;}}else{if(i>0){if(!util.compareByGeneratedPositionsInflated(mapping,mappings[i-1])){continue;}next+=',';}}next+=base64VLQ.encode(mapping.generatedColumn-previousGeneratedColumn);previousGeneratedColumn=mapping.generatedColumn;if(mapping.source!=null){sourceIdx=this._sources.indexOf(mapping.source);next+=base64VLQ.encode(sourceIdx-previousSource);previousSource=sourceIdx;next+=base64VLQ.encode(mapping.originalLine-1-previousOriginalLine);previousOriginalLine=mapping.originalLine-1;next+=base64VLQ.encode(mapping.originalColumn-previousOriginalColumn);previousOriginalColumn=mapping.originalColumn;if(mapping.name!=null){nameIdx=this._names.indexOf(mapping.name);next+=base64VLQ.encode(nameIdx-previousName);previousName=nameIdx;}}result+=next;}return result;};SourceMapGenerator.prototype._generateSourcesContent=function SourceMapGenerator_generateSourcesContent(aSources,aSourceRoot){return aSources.map(function(source){if(!this._sourcesContents){return null;}if(aSourceRoot!=null){source=util.relative(aSourceRoot,source);}var key=util.toSetString(source);return Object.prototype.hasOwnProperty.call(this._sourcesContents,key)?this._sourcesContents[key]:null;},this);};SourceMapGenerator.prototype.toJSON=function SourceMapGenerator_toJSON(){var map={version:this._version,sources:this._sources.toArray(),names:this._names.toArray(),mappings:this._serializeMappings()};if(this._file!=null){map.file=this._file;}if(this._sourceRoot!=null){map.sourceRoot=this._sourceRoot;}if(this._sourcesContents){map.sourcesContent=this._generateSourcesContent(map.sources,map.sourceRoot);}return map;};SourceMapGenerator.prototype.toString=function SourceMapGenerator_toString(){return JSON.stringify(this.toJSON());};exports.SourceMapGenerator=SourceMapGenerator;},{'./array-set':104,'./base64-vlq':105,'./mapping-list':108,'./util':113}],112:[function(require,module,exports){var SourceMapGenerator=require('./source-map-generator').SourceMapGenerator;var util=require('./util');var REGEX_NEWLINE=/(\r?\n)/;var NEWLINE_CODE=10;var isSourceNode='$$$isSourceNode$$$';function SourceNode(aLine,aColumn,aSource,aChunks,aName){this.children=[];this.sourceContents={};this.line=aLine==null?null:aLine;this.column=aColumn==null?null:aColumn;this.source=aSource==null?null:aSource;this.name=aName==null?null:aName;this[isSourceNode]=true;if(aChunks!=null)this.add(aChunks);}SourceNode.fromStringWithSourceMap=function SourceNode_fromStringWithSourceMap(aGeneratedCode,aSourceMapConsumer,aRelativePath){var node=new SourceNode();var remainingLines=aGeneratedCode.split(REGEX_NEWLINE);var remainingLinesIndex=0;var shiftNextLine=function(){var lineContents=getNextLine();var newLine=getNextLine()||'';return lineContents+newLine;function getNextLine(){return remainingLinesIndex<remainingLines.length?remainingLines[remainingLinesIndex++]:undefined;}};var lastGeneratedLine=1,lastGeneratedColumn=0;var lastMapping=null;aSourceMapConsumer.eachMapping(function(mapping){if(lastMapping!==null){if(lastGeneratedLine<mapping.generatedLine){addMappingWithCode(lastMapping,shiftNextLine());lastGeneratedLine++;lastGeneratedColumn=0;}else{var nextLine=remainingLines[remainingLinesIndex];var code=nextLine.substr(0,mapping.generatedColumn-lastGeneratedColumn);remainingLines[remainingLinesIndex]=nextLine.substr(mapping.generatedColumn-lastGeneratedColumn);lastGeneratedColumn=mapping.generatedColumn;addMappingWithCode(lastMapping,code);lastMapping=mapping;return;}}while(lastGeneratedLine<mapping.generatedLine){node.add(shiftNextLine());lastGeneratedLine++;}if(lastGeneratedColumn<mapping.generatedColumn){var nextLine=remainingLines[remainingLinesIndex];node.add(nextLine.substr(0,mapping.generatedColumn));remainingLines[remainingLinesIndex]=nextLine.substr(mapping.generatedColumn);lastGeneratedColumn=mapping.generatedColumn;}lastMapping=mapping;},this);if(remainingLinesIndex<remainingLines.length){if(lastMapping){addMappingWithCode(lastMapping,shiftNextLine());}node.add(remainingLines.splice(remainingLinesIndex).join(''));}aSourceMapConsumer.sources.forEach(function(sourceFile){var content=aSourceMapConsumer.sourceContentFor(sourceFile);if(content!=null){if(aRelativePath!=null){sourceFile=util.join(aRelativePath,sourceFile);}node.setSourceContent(sourceFile,content);}});return node;function addMappingWithCode(mapping,code){if(mapping===null||mapping.source===undefined){node.add(code);}else{var source=aRelativePath?util.join(aRelativePath,mapping.source):mapping.source;node.add(new SourceNode(mapping.originalLine,mapping.originalColumn,source,code,mapping.name));}}};SourceNode.prototype.add=function SourceNode_add(aChunk){if(Array.isArray(aChunk)){aChunk.forEach(function(chunk){this.add(chunk);},this);}else if(aChunk[isSourceNode]||typeof aChunk==='string'){if(aChunk){this.children.push(aChunk);}}else{throw new TypeError('Expected a SourceNode, string, or an array of SourceNodes and strings. Got '+aChunk);}return this;};SourceNode.prototype.prepend=function SourceNode_prepend(aChunk){if(Array.isArray(aChunk)){for(var i=aChunk.length-1;i>=0;i--){this.prepend(aChunk[i]);}}else if(aChunk[isSourceNode]||typeof aChunk==='string'){this.children.unshift(aChunk);}else{throw new TypeError('Expected a SourceNode, string, or an array of SourceNodes and strings. Got '+aChunk);}return this;};SourceNode.prototype.walk=function SourceNode_walk(aFn){var chunk;for(var i=0,len=this.children.length;i<len;i++){chunk=this.children[i];if(chunk[isSourceNode]){chunk.walk(aFn);}else{if(chunk!==''){aFn(chunk,{source:this.source,line:this.line,column:this.column,name:this.name});}}}};SourceNode.prototype.join=function SourceNode_join(aSep){var newChildren;var i;var len=this.children.length;if(len>0){newChildren=[];for(i=0;i<len-1;i++){newChildren.push(this.children[i]);newChildren.push(aSep);}newChildren.push(this.children[i]);this.children=newChildren;}return this;};SourceNode.prototype.replaceRight=function SourceNode_replaceRight(aPattern,aReplacement){var lastChild=this.children[this.children.length-1];if(lastChild[isSourceNode]){lastChild.replaceRight(aPattern,aReplacement);}else if(typeof lastChild==='string'){this.children[this.children.length-1]=lastChild.replace(aPattern,aReplacement);}else{this.children.push(''.replace(aPattern,aReplacement));}return this;};SourceNode.prototype.setSourceContent=function SourceNode_setSourceContent(aSourceFile,aSourceContent){this.sourceContents[util.toSetString(aSourceFile)]=aSourceContent;};SourceNode.prototype.walkSourceContents=function SourceNode_walkSourceContents(aFn){for(var i=0,len=this.children.length;i<len;i++){if(this.children[i][isSourceNode]){this.children[i].walkSourceContents(aFn);}}var sources=Object.keys(this.sourceContents);for(var i=0,len=sources.length;i<len;i++){aFn(util.fromSetString(sources[i]),this.sourceContents[sources[i]]);}};SourceNode.prototype.toString=function SourceNode_toString(){var str='';this.walk(function(chunk){str+=chunk;});return str;};SourceNode.prototype.toStringWithSourceMap=function SourceNode_toStringWithSourceMap(aArgs){var generated={code:'',line:1,column:0};var map=new SourceMapGenerator(aArgs);var sourceMappingActive=false;var lastOriginalSource=null;var lastOriginalLine=null;var lastOriginalColumn=null;var lastOriginalName=null;this.walk(function(chunk,original){generated.code+=chunk;if(original.source!==null&&original.line!==null&&original.column!==null){if(lastOriginalSource!==original.source||lastOriginalLine!==original.line||lastOriginalColumn!==original.column||lastOriginalName!==original.name){map.addMapping({source:original.source,original:{line:original.line,column:original.column},generated:{line:generated.line,column:generated.column},name:original.name});}lastOriginalSource=original.source;lastOriginalLine=original.line;lastOriginalColumn=original.column;lastOriginalName=original.name;sourceMappingActive=true;}else if(sourceMappingActive){map.addMapping({generated:{line:generated.line,column:generated.column}});lastOriginalSource=null;sourceMappingActive=false;}for(var idx=0,length=chunk.length;idx<length;idx++){if(chunk.charCodeAt(idx)===NEWLINE_CODE){generated.line++;generated.column=0;if(idx+1===length){lastOriginalSource=null;sourceMappingActive=false;}else if(sourceMappingActive){map.addMapping({source:original.source,original:{line:original.line,column:original.column},generated:{line:generated.line,column:generated.column},name:original.name});}}else{generated.column++;}}});this.walkSourceContents(function(sourceFile,sourceContent){map.setSourceContent(sourceFile,sourceContent);});return{code:generated.code,map:map};};exports.SourceNode=SourceNode;},{'./source-map-generator':111,'./util':113}],113:[function(require,module,exports){function getArg(aArgs,aName,aDefaultValue){if(aName in aArgs){return aArgs[aName];}else if(arguments.length===3){return aDefaultValue;}else{throw new Error('"'+aName+'" is a required argument.');}}exports.getArg=getArg;var urlRegexp=/^(?:([\w+\-.]+):)?\/\/(?:(\w+:\w+)@)?([\w.]*)(?::(\d+))?(\S*)$/;var dataUrlRegexp=/^data:.+\,.+$/;function urlParse(aUrl){var match=aUrl.match(urlRegexp);if(!match){return null;}return{scheme:match[1],auth:match[2],host:match[3],port:match[4],path:match[5]};}exports.urlParse=urlParse;function urlGenerate(aParsedUrl){var url='';if(aParsedUrl.scheme){url+=aParsedUrl.scheme+':';}url+='//';if(aParsedUrl.auth){url+=aParsedUrl.auth+'@';}if(aParsedUrl.host){url+=aParsedUrl.host;}if(aParsedUrl.port){url+=':'+aParsedUrl.port;}if(aParsedUrl.path){url+=aParsedUrl.path;}return url;}exports.urlGenerate=urlGenerate;function normalize(aPath){var path=aPath;var url=urlParse(aPath);if(url){if(!url.path){return aPath;}path=url.path;}var isAbsolute=exports.isAbsolute(path);var parts=path.split(/\/+/);for(var part,up=0,i=parts.length-1;i>=0;i--){part=parts[i];if(part==='.'){parts.splice(i,1);}else if(part==='..'){up++;}else if(up>0){if(part===''){parts.splice(i+1,up);up=0;}else{parts.splice(i,2);up--;}}}path=parts.join('/');if(path===''){path=isAbsolute?'/':'.';}if(url){url.path=path;return urlGenerate(url);}return path;}exports.normalize=normalize;function join(aRoot,aPath){if(aRoot===''){aRoot='.';}if(aPath===''){aPath='.';}var aPathUrl=urlParse(aPath);var aRootUrl=urlParse(aRoot);if(aRootUrl){aRoot=aRootUrl.path||'/';}if(aPathUrl&&!aPathUrl.scheme){if(aRootUrl){aPathUrl.scheme=aRootUrl.scheme;}return urlGenerate(aPathUrl);}if(aPathUrl||aPath.match(dataUrlRegexp)){return aPath;}if(aRootUrl&&!aRootUrl.host&&!aRootUrl.path){aRootUrl.host=aPath;return urlGenerate(aRootUrl);}var joined=aPath.charAt(0)==='/'?aPath:normalize(aRoot.replace(/\/+$/,'')+'/'+aPath);if(aRootUrl){aRootUrl.path=joined;return urlGenerate(aRootUrl);}return joined;}exports.join=join;exports.isAbsolute=function(aPath){return aPath.charAt(0)==='/'||!!aPath.match(urlRegexp);};function relative(aRoot,aPath){if(aRoot===''){aRoot='.';}aRoot=aRoot.replace(/\/$/,'');var level=0;while(aPath.indexOf(aRoot+'/')!==0){var index=aRoot.lastIndexOf('/');if(index<0){return aPath;}aRoot=aRoot.slice(0,index);if(aRoot.match(/^([^\/]+:\/)?\/*$/)){return aPath;}++level;}return Array(level+1).join('../')+aPath.substr(aRoot.length+1);}exports.relative=relative;var supportsNullProto=function(){var obj=Object.create(null);return!('__proto__'in obj);}();function identity(s){return s;}function toSetString(aStr){if(isProtoString(aStr)){return'$'+aStr;}return aStr;}exports.toSetString=supportsNullProto?identity:toSetString;function fromSetString(aStr){if(isProtoString(aStr)){return aStr.slice(1);}return aStr;}exports.fromSetString=supportsNullProto?identity:fromSetString;function isProtoString(s){if(!s){return false;}var length=s.length;if(length<9){return false;}if(s.charCodeAt(length-1)!==95||s.charCodeAt(length-2)!==95||s.charCodeAt(length-3)!==111||s.charCodeAt(length-4)!==116||s.charCodeAt(length-5)!==111||s.charCodeAt(length-6)!==114||s.charCodeAt(length-7)!==112||s.charCodeAt(length-8)!==95||s.charCodeAt(length-9)!==95){return false;}for(var i=length-10;i>=0;i--){if(s.charCodeAt(i)!==36){return false;}}return true;}function compareByOriginalPositions(mappingA,mappingB,onlyCompareOriginal){var cmp=mappingA.source-mappingB.source;if(cmp!==0){return cmp;}cmp=mappingA.originalLine-mappingB.originalLine;if(cmp!==0){return cmp;}cmp=mappingA.originalColumn-mappingB.originalColumn;if(cmp!==0||onlyCompareOriginal){return cmp;}cmp=mappingA.generatedColumn-mappingB.generatedColumn;if(cmp!==0){return cmp;}cmp=mappingA.generatedLine-mappingB.generatedLine;if(cmp!==0){return cmp;}return mappingA.name-mappingB.name;}exports.compareByOriginalPositions=compareByOriginalPositions;function compareByGeneratedPositionsDeflated(mappingA,mappingB,onlyCompareGenerated){var cmp=mappingA.generatedLine-mappingB.generatedLine;if(cmp!==0){return cmp;}cmp=mappingA.generatedColumn-mappingB.generatedColumn;if(cmp!==0||onlyCompareGenerated){return cmp;}cmp=mappingA.source-mappingB.source;if(cmp!==0){return cmp;}cmp=mappingA.originalLine-mappingB.originalLine;if(cmp!==0){return cmp;}cmp=mappingA.originalColumn-mappingB.originalColumn;if(cmp!==0){return cmp;}return mappingA.name-mappingB.name;}exports.compareByGeneratedPositionsDeflated=compareByGeneratedPositionsDeflated;function strcmp(aStr1,aStr2){if(aStr1===aStr2){return 0;}if(aStr1>aStr2){return 1;}return-1;}function compareByGeneratedPositionsInflated(mappingA,mappingB){var cmp=mappingA.generatedLine-mappingB.generatedLine;if(cmp!==0){return cmp;}cmp=mappingA.generatedColumn-mappingB.generatedColumn;if(cmp!==0){return cmp;}cmp=strcmp(mappingA.source,mappingB.source);if(cmp!==0){return cmp;}cmp=mappingA.originalLine-mappingB.originalLine;if(cmp!==0){return cmp;}cmp=mappingA.originalColumn-mappingB.originalColumn;if(cmp!==0){return cmp;}return strcmp(mappingA.name,mappingB.name);}exports.compareByGeneratedPositionsInflated=compareByGeneratedPositionsInflated;},{}],114:[function(require,module,exports){exports.SourceMapGenerator=require('./lib/source-map-generator').SourceMapGenerator;exports.SourceMapConsumer=require('./lib/source-map-consumer').SourceMapConsumer;exports.SourceNode=require('./lib/source-node').SourceNode;},{'./lib/source-map-consumer':110,'./lib/source-map-generator':111,'./lib/source-node':112}],115:[function(require,module,exports){module.exports=Stream;var EE=require('events').EventEmitter;var inherits=require('inherits');inherits(Stream,EE);Stream.Readable=require('readable-stream/readable.js');Stream.Writable=require('readable-stream/writable.js');Stream.Duplex=require('readable-stream/duplex.js');Stream.Transform=require('readable-stream/transform.js');Stream.PassThrough=require('readable-stream/passthrough.js');Stream.Stream=Stream;function Stream(){EE.call(this);}Stream.prototype.pipe=function(dest,options){var source=this;function ondata(chunk){if(dest.writable){if(false===dest.write(chunk)&&source.pause){source.pause();}}}source.on('data',ondata);function ondrain(){if(source.readable&&source.resume){source.resume();}}dest.on('drain',ondrain);if(!dest._isStdio&&(!options||options.end!==false)){source.on('end',onend);source.on('close',onclose);}var didOnEnd=false;function onend(){if(didOnEnd)return;didOnEnd=true;dest.end();}function onclose(){if(didOnEnd)return;didOnEnd=true;if(typeof dest.destroy==='function')dest.destroy();}function onerror(er){cleanup();if(EE.listenerCount(this,'error')===0){throw er;}}source.on('error',onerror);dest.on('error',onerror);function cleanup(){source.removeListener('data',ondata);dest.removeListener('drain',ondrain);source.removeListener('end',onend);source.removeListener('close',onclose);source.removeListener('error',onerror);dest.removeListener('error',onerror);source.removeListener('end',cleanup);source.removeListener('close',cleanup);dest.removeListener('close',cleanup);}source.on('end',cleanup);source.on('close',cleanup);dest.on('close',cleanup);dest.emit('pipe',source);return dest;};},{'events':60,'inherits':74,'readable-stream/duplex.js':116,'readable-stream/passthrough.js':125,'readable-stream/readable.js':126,'readable-stream/transform.js':127,'readable-stream/writable.js':128}],116:[function(require,module,exports){module.exports=require('./lib/_stream_duplex.js');},{'./lib/_stream_duplex.js':117}],117:[function(require,module,exports){'use strict';var pna=require('process-nextick-args');var objectKeys=Object.keys||function(obj){var keys=[];for(var key in obj){keys.push(key);}return keys;};module.exports=Duplex;var util=Object.create(require('core-util-is'));util.inherits=require('inherits');var Readable=require('./_stream_readable');var Writable=require('./_stream_writable');util.inherits(Duplex,Readable);{var keys=objectKeys(Writable.prototype);for(var v=0;v<keys.length;v++){var method=keys[v];if(!Duplex.prototype[method])Duplex.prototype[method]=Writable.prototype[method];}}function Duplex(options){if(!(this instanceof Duplex))return new Duplex(options);Readable.call(this,options);Writable.call(this,options);if(options&&options.readable===false)this.readable=false;if(options&&options.writable===false)this.writable=false;this.allowHalfOpen=true;if(options&&options.allowHalfOpen===false)this.allowHalfOpen=false;this.once('end',onend);}Object.defineProperty(Duplex.prototype,'writableHighWaterMark',{enumerable:false,get:function(){return this._writableState.highWaterMark;}});function onend(){if(this.allowHalfOpen||this._writableState.ended)return;pna.nextTick(onEndNT,this);}function onEndNT(self){self.end();}Object.defineProperty(Duplex.prototype,'destroyed',{get:function(){if(this._readableState===undefined||this._writableState===undefined){return false;}return this._readableState.destroyed&&this._writableState.destroyed;},set:function(value){if(this._readableState===undefined||this._writableState===undefined){return;}this._readableState.destroyed=value;this._writableState.destroyed=value;}});Duplex.prototype._destroy=function(err,cb){this.push(null);this.end();pna.nextTick(cb,err);};},{'./_stream_readable':119,'./_stream_writable':121,'core-util-is':16,'inherits':74,'process-nextick-args':93}],118:[function(require,module,exports){'use strict';module.exports=PassThrough;var Transform=require('./_stream_transform');var util=Object.create(require('core-util-is'));util.inherits=require('inherits');util.inherits(PassThrough,Transform);function PassThrough(options){if(!(this instanceof PassThrough))return new PassThrough(options);Transform.call(this,options);}PassThrough.prototype._transform=function(chunk,encoding,cb){cb(null,chunk);};},{'./_stream_transform':120,'core-util-is':16,'inherits':74}],119:[function(require,module,exports){(function(process,global){(function(){'use strict';var pna=require('process-nextick-args');module.exports=Readable;var isArray=require('isarray');var Duplex;Readable.ReadableState=ReadableState;var EE=require('events').EventEmitter;var EElistenerCount=function(emitter,type){return emitter.listeners(type).length;};var Stream=require('./internal/streams/stream');var Buffer=require('safe-buffer').Buffer;var OurUint8Array=(typeof global!=='undefined'?global:typeof window!=='undefined'?window:typeof self!=='undefined'?self:{}).Uint8Array||function(){};function _uint8ArrayToBuffer(chunk){return Buffer.from(chunk);}function _isUint8Array(obj){return Buffer.isBuffer(obj)||obj instanceof OurUint8Array;}var util=Object.create(require('core-util-is'));util.inherits=require('inherits');var debugUtil=require('util');var debug=void 0;if(debugUtil&&debugUtil.debuglog){debug=debugUtil.debuglog('stream');}else{debug=function(){};}var BufferList=require('./internal/streams/BufferList');var destroyImpl=require('./internal/streams/destroy');var StringDecoder;util.inherits(Readable,Stream);var kProxyEvents=['error','close','destroy','pause','resume'];function prependListener(emitter,event,fn){if(typeof emitter.prependListener==='function')return emitter.prependListener(event,fn);if(!emitter._events||!emitter._events[event])emitter.on(event,fn);else if(isArray(emitter._events[event]))emitter._events[event].unshift(fn);else emitter._events[event]=[fn,emitter._events[event]];}function ReadableState(options,stream){Duplex=Duplex||require('./_stream_duplex');options=options||{};var isDuplex=stream instanceof Duplex;this.objectMode=!!options.objectMode;if(isDuplex)this.objectMode=this.objectMode||!!options.readableObjectMode;var hwm=options.highWaterMark;var readableHwm=options.readableHighWaterMark;var defaultHwm=this.objectMode?16:16*1024;if(hwm||hwm===0)this.highWaterMark=hwm;else if(isDuplex&&(readableHwm||readableHwm===0))this.highWaterMark=readableHwm;else this.highWaterMark=defaultHwm;this.highWaterMark=Math.floor(this.highWaterMark);this.buffer=new BufferList();this.length=0;this.pipes=null;this.pipesCount=0;this.flowing=null;this.ended=false;this.endEmitted=false;this.reading=false;this.sync=true;this.needReadable=false;this.emittedReadable=false;this.readableListening=false;this.resumeScheduled=false;this.destroyed=false;this.defaultEncoding=options.defaultEncoding||'utf8';this.awaitDrain=0;this.readingMore=false;this.decoder=null;this.encoding=null;if(options.encoding){if(!StringDecoder)StringDecoder=require('string_decoder/').StringDecoder;this.decoder=new StringDecoder(options.encoding);this.encoding=options.encoding;}}function Readable(options){Duplex=Duplex||require('./_stream_duplex');if(!(this instanceof Readable))return new Readable(options);this._readableState=new ReadableState(options,this);this.readable=true;if(options){if(typeof options.read==='function')this._read=options.read;if(typeof options.destroy==='function')this._destroy=options.destroy;}Stream.call(this);}Object.defineProperty(Readable.prototype,'destroyed',{get:function(){if(this._readableState===undefined){return false;}return this._readableState.destroyed;},set:function(value){if(!this._readableState){return;}this._readableState.destroyed=value;}});Readable.prototype.destroy=destroyImpl.destroy;Readable.prototype._undestroy=destroyImpl.undestroy;Readable.prototype._destroy=function(err,cb){this.push(null);cb(err);};Readable.prototype.push=function(chunk,encoding){var state=this._readableState;var skipChunkCheck;if(!state.objectMode){if(typeof chunk==='string'){encoding=encoding||state.defaultEncoding;if(encoding!==state.encoding){chunk=Buffer.from(chunk,encoding);encoding='';}skipChunkCheck=true;}}else{skipChunkCheck=true;}return readableAddChunk(this,chunk,encoding,false,skipChunkCheck);};Readable.prototype.unshift=function(chunk){return readableAddChunk(this,chunk,null,true,false);};function readableAddChunk(stream,chunk,encoding,addToFront,skipChunkCheck){var state=stream._readableState;if(chunk===null){state.reading=false;onEofChunk(stream,state);}else{var er;if(!skipChunkCheck)er=chunkInvalid(state,chunk);if(er){stream.emit('error',er);}else if(state.objectMode||chunk&&chunk.length>0){if(typeof chunk!=='string'&&!state.objectMode&&Object.getPrototypeOf(chunk)!==Buffer.prototype){chunk=_uint8ArrayToBuffer(chunk);}if(addToFront){if(state.endEmitted)stream.emit('error',new Error('stream.unshift() after end event'));else addChunk(stream,state,chunk,true);}else if(state.ended){stream.emit('error',new Error('stream.push() after EOF'));}else{state.reading=false;if(state.decoder&&!encoding){chunk=state.decoder.write(chunk);if(state.objectMode||chunk.length!==0)addChunk(stream,state,chunk,false);else maybeReadMore(stream,state);}else{addChunk(stream,state,chunk,false);}}}else if(!addToFront){state.reading=false;}}return needMoreData(state);}function addChunk(stream,state,chunk,addToFront){if(state.flowing&&state.length===0&&!state.sync){stream.emit('data',chunk);stream.read(0);}else{state.length+=state.objectMode?1:chunk.length;if(addToFront)state.buffer.unshift(chunk);else state.buffer.push(chunk);if(state.needReadable)emitReadable(stream);}maybeReadMore(stream,state);}function chunkInvalid(state,chunk){var er;if(!_isUint8Array(chunk)&&typeof chunk!=='string'&&chunk!==undefined&&!state.objectMode){er=new TypeError('Invalid non-string/buffer chunk');}return er;}function needMoreData(state){return!state.ended&&(state.needReadable||state.length<state.highWaterMark||state.length===0);}Readable.prototype.isPaused=function(){return this._readableState.flowing===false;};Readable.prototype.setEncoding=function(enc){if(!StringDecoder)StringDecoder=require('string_decoder/').StringDecoder;this._readableState.decoder=new StringDecoder(enc);this._readableState.encoding=enc;return this;};var MAX_HWM=8388608;function computeNewHighWaterMark(n){if(n>=MAX_HWM){n=MAX_HWM;}else{n--;n|=n>>>1;n|=n>>>2;n|=n>>>4;n|=n>>>8;n|=n>>>16;n++;}return n;}function howMuchToRead(n,state){if(n<=0||state.length===0&&state.ended)return 0;if(state.objectMode)return 1;if(n!==n){if(state.flowing&&state.length)return state.buffer.head.data.length;else return state.length;}if(n>state.highWaterMark)state.highWaterMark=computeNewHighWaterMark(n);if(n<=state.length)return n;if(!state.ended){state.needReadable=true;return 0;}return state.length;}Readable.prototype.read=function(n){debug('read',n);n=parseInt(n,10);var state=this._readableState;var nOrig=n;if(n!==0)state.emittedReadable=false;if(n===0&&state.needReadable&&(state.length>=state.highWaterMark||state.ended)){debug('read: emitReadable',state.length,state.ended);if(state.length===0&&state.ended)endReadable(this);else emitReadable(this);return null;}n=howMuchToRead(n,state);if(n===0&&state.ended){if(state.length===0)endReadable(this);return null;}var doRead=state.needReadable;debug('need readable',doRead);if(state.length===0||state.length-n<state.highWaterMark){doRead=true;debug('length less than watermark',doRead);}if(state.ended||state.reading){doRead=false;debug('reading or ended',doRead);}else if(doRead){debug('do read');state.reading=true;state.sync=true;if(state.length===0)state.needReadable=true;this._read(state.highWaterMark);state.sync=false;if(!state.reading)n=howMuchToRead(nOrig,state);}var ret;if(n>0)ret=fromList(n,state);else ret=null;if(ret===null){state.needReadable=true;n=0;}else{state.length-=n;}if(state.length===0){if(!state.ended)state.needReadable=true;if(nOrig!==n&&state.ended)endReadable(this);}if(ret!==null)this.emit('data',ret);return ret;};function onEofChunk(stream,state){if(state.ended)return;if(state.decoder){var chunk=state.decoder.end();if(chunk&&chunk.length){state.buffer.push(chunk);state.length+=state.objectMode?1:chunk.length;}}state.ended=true;emitReadable(stream);}function emitReadable(stream){var state=stream._readableState;state.needReadable=false;if(!state.emittedReadable){debug('emitReadable',state.flowing);state.emittedReadable=true;if(state.sync)pna.nextTick(emitReadable_,stream);else emitReadable_(stream);}}function emitReadable_(stream){debug('emit readable');stream.emit('readable');flow(stream);}function maybeReadMore(stream,state){if(!state.readingMore){state.readingMore=true;pna.nextTick(maybeReadMore_,stream,state);}}function maybeReadMore_(stream,state){var len=state.length;while(!state.reading&&!state.flowing&&!state.ended&&state.length<state.highWaterMark){debug('maybeReadMore read 0');stream.read(0);if(len===state.length)break;else len=state.length;}state.readingMore=false;}Readable.prototype._read=function(n){this.emit('error',new Error('_read() is not implemented'));};Readable.prototype.pipe=function(dest,pipeOpts){var src=this;var state=this._readableState;switch(state.pipesCount){case 0:state.pipes=dest;break;case 1:state.pipes=[state.pipes,dest];break;default:state.pipes.push(dest);break;}state.pipesCount+=1;debug('pipe count=%d opts=%j',state.pipesCount,pipeOpts);var doEnd=(!pipeOpts||pipeOpts.end!==false)&&dest!==process.stdout&&dest!==process.stderr;var endFn=doEnd?onend:unpipe;if(state.endEmitted)pna.nextTick(endFn);else src.once('end',endFn);dest.on('unpipe',onunpipe);function onunpipe(readable,unpipeInfo){debug('onunpipe');if(readable===src){if(unpipeInfo&&unpipeInfo.hasUnpiped===false){unpipeInfo.hasUnpiped=true;cleanup();}}}function onend(){debug('onend');dest.end();}var ondrain=pipeOnDrain(src);dest.on('drain',ondrain);var cleanedUp=false;function cleanup(){debug('cleanup');dest.removeListener('close',onclose);dest.removeListener('finish',onfinish);dest.removeListener('drain',ondrain);dest.removeListener('error',onerror);dest.removeListener('unpipe',onunpipe);src.removeListener('end',onend);src.removeListener('end',unpipe);src.removeListener('data',ondata);cleanedUp=true;if(state.awaitDrain&&(!dest._writableState||dest._writableState.needDrain))ondrain();}var increasedAwaitDrain=false;src.on('data',ondata);function ondata(chunk){debug('ondata');increasedAwaitDrain=false;var ret=dest.write(chunk);if(false===ret&&!increasedAwaitDrain){if((state.pipesCount===1&&state.pipes===dest||state.pipesCount>1&&indexOf(state.pipes,dest)!==-1)&&!cleanedUp){debug('false write response, pause',state.awaitDrain);state.awaitDrain++;increasedAwaitDrain=true;}src.pause();}}function onerror(er){debug('onerror',er);unpipe();dest.removeListener('error',onerror);if(EElistenerCount(dest,'error')===0)dest.emit('error',er);}prependListener(dest,'error',onerror);function onclose(){dest.removeListener('finish',onfinish);unpipe();}dest.once('close',onclose);function onfinish(){debug('onfinish');dest.removeListener('close',onclose);unpipe();}dest.once('finish',onfinish);function unpipe(){debug('unpipe');src.unpipe(dest);}dest.emit('pipe',src);if(!state.flowing){debug('pipe resume');src.resume();}return dest;};function pipeOnDrain(src){return function(){var state=src._readableState;debug('pipeOnDrain',state.awaitDrain);if(state.awaitDrain)state.awaitDrain--;if(state.awaitDrain===0&&EElistenerCount(src,'data')){state.flowing=true;flow(src);}};}Readable.prototype.unpipe=function(dest){var state=this._readableState;var unpipeInfo={hasUnpiped:false};if(state.pipesCount===0)return this;if(state.pipesCount===1){if(dest&&dest!==state.pipes)return this;if(!dest)dest=state.pipes;state.pipes=null;state.pipesCount=0;state.flowing=false;if(dest)dest.emit('unpipe',this,unpipeInfo);return this;}if(!dest){var dests=state.pipes;var len=state.pipesCount;state.pipes=null;state.pipesCount=0;state.flowing=false;for(var i=0;i<len;i++){dests[i].emit('unpipe',this,{hasUnpiped:false});}return this;}var index=indexOf(state.pipes,dest);if(index===-1)return this;state.pipes.splice(index,1);state.pipesCount-=1;if(state.pipesCount===1)state.pipes=state.pipes[0];dest.emit('unpipe',this,unpipeInfo);return this;};Readable.prototype.on=function(ev,fn){var res=Stream.prototype.on.call(this,ev,fn);if(ev==='data'){if(this._readableState.flowing!==false)this.resume();}else if(ev==='readable'){var state=this._readableState;if(!state.endEmitted&&!state.readableListening){state.readableListening=state.needReadable=true;state.emittedReadable=false;if(!state.reading){pna.nextTick(nReadingNextTick,this);}else if(state.length){emitReadable(this);}}}return res;};Readable.prototype.addListener=Readable.prototype.on;function nReadingNextTick(self){debug('readable nexttick read 0');self.read(0);}Readable.prototype.resume=function(){var state=this._readableState;if(!state.flowing){debug('resume');state.flowing=true;resume(this,state);}return this;};function resume(stream,state){if(!state.resumeScheduled){state.resumeScheduled=true;pna.nextTick(resume_,stream,state);}}function resume_(stream,state){if(!state.reading){debug('resume read 0');stream.read(0);}state.resumeScheduled=false;state.awaitDrain=0;stream.emit('resume');flow(stream);if(state.flowing&&!state.reading)stream.read(0);}Readable.prototype.pause=function(){debug('call pause flowing=%j',this._readableState.flowing);if(false!==this._readableState.flowing){debug('pause');this._readableState.flowing=false;this.emit('pause');}return this;};function flow(stream){var state=stream._readableState;debug('flow',state.flowing);while(state.flowing&&stream.read()!==null){}}Readable.prototype.wrap=function(stream){var _this=this;var state=this._readableState;var paused=false;stream.on('end',function(){debug('wrapped end');if(state.decoder&&!state.ended){var chunk=state.decoder.end();if(chunk&&chunk.length)_this.push(chunk);}_this.push(null);});stream.on('data',function(chunk){debug('wrapped data');if(state.decoder)chunk=state.decoder.write(chunk);if(state.objectMode&&(chunk===null||chunk===undefined))return;else if(!state.objectMode&&(!chunk||!chunk.length))return;var ret=_this.push(chunk);if(!ret){paused=true;stream.pause();}});for(var i in stream){if(this[i]===undefined&&typeof stream[i]==='function'){this[i]=function(method){return function(){return stream[method].apply(stream,arguments);};}(i);}}for(var n=0;n<kProxyEvents.length;n++){stream.on(kProxyEvents[n],this.emit.bind(this,kProxyEvents[n]));}this._read=function(n){debug('wrapped _read',n);if(paused){paused=false;stream.resume();}};return this;};Object.defineProperty(Readable.prototype,'readableHighWaterMark',{enumerable:false,get:function(){return this._readableState.highWaterMark;}});Readable._fromList=fromList;function fromList(n,state){if(state.length===0)return null;var ret;if(state.objectMode)ret=state.buffer.shift();else if(!n||n>=state.length){if(state.decoder)ret=state.buffer.join('');else if(state.buffer.length===1)ret=state.buffer.head.data;else ret=state.buffer.concat(state.length);state.buffer.clear();}else{ret=fromListPartial(n,state.buffer,state.decoder);}return ret;}function fromListPartial(n,list,hasStrings){var ret;if(n<list.head.data.length){ret=list.head.data.slice(0,n);list.head.data=list.head.data.slice(n);}else if(n===list.head.data.length){ret=list.shift();}else{ret=hasStrings?copyFromBufferString(n,list):copyFromBuffer(n,list);}return ret;}function copyFromBufferString(n,list){var p=list.head;var c=1;var ret=p.data;n-=ret.length;while(p=p.next){var str=p.data;var nb=n>str.length?str.length:n;if(nb===str.length)ret+=str;else ret+=str.slice(0,n);n-=nb;if(n===0){if(nb===str.length){++c;if(p.next)list.head=p.next;else list.head=list.tail=null;}else{list.head=p;p.data=str.slice(nb);}break;}++c;}list.length-=c;return ret;}function copyFromBuffer(n,list){var ret=Buffer.allocUnsafe(n);var p=list.head;var c=1;p.data.copy(ret);n-=p.data.length;while(p=p.next){var buf=p.data;var nb=n>buf.length?buf.length:n;buf.copy(ret,ret.length-n,0,nb);n-=nb;if(n===0){if(nb===buf.length){++c;if(p.next)list.head=p.next;else list.head=list.tail=null;}else{list.head=p;p.data=buf.slice(nb);}break;}++c;}list.length-=c;return ret;}function endReadable(stream){var state=stream._readableState;if(state.length>0)throw new Error('"endReadable()" called on non-empty stream');if(!state.endEmitted){state.ended=true;pna.nextTick(endReadableNT,state,stream);}}function endReadableNT(state,stream){if(!state.endEmitted&&state.length===0){state.endEmitted=true;stream.readable=false;stream.emit('end');}}function indexOf(xs,x){for(var i=0,l=xs.length;i<l;i++){if(xs[i]===x)return i;}return-1;}}.call(this));}.call(this,require('_process'),typeof global!=='undefined'?global:typeof self!=='undefined'?self:typeof window!=='undefined'?window:{}));},{'./_stream_duplex':117,'./internal/streams/BufferList':122,'./internal/streams/destroy':123,'./internal/streams/stream':124,'_process':94,'core-util-is':16,'events':60,'inherits':74,'isarray':75,'process-nextick-args':93,'safe-buffer':129,'string_decoder/':130,'util':11}],120:[function(require,module,exports){'use strict';module.exports=Transform;var Duplex=require('./_stream_duplex');var util=Object.create(require('core-util-is'));util.inherits=require('inherits');util.inherits(Transform,Duplex);function afterTransform(er,data){var ts=this._transformState;ts.transforming=false;var cb=ts.writecb;if(!cb){return this.emit('error',new Error('write callback called multiple times'));}ts.writechunk=null;ts.writecb=null;if(data!=null)this.push(data);cb(er);var rs=this._readableState;rs.reading=false;if(rs.needReadable||rs.length<rs.highWaterMark){this._read(rs.highWaterMark);}}function Transform(options){if(!(this instanceof Transform))return new Transform(options);Duplex.call(this,options);this._transformState={afterTransform:afterTransform.bind(this),needTransform:false,transforming:false,writecb:null,writechunk:null,writeencoding:null};this._readableState.needReadable=true;this._readableState.sync=false;if(options){if(typeof options.transform==='function')this._transform=options.transform;if(typeof options.flush==='function')this._flush=options.flush;}this.on('prefinish',prefinish);}function prefinish(){var _this=this;if(typeof this._flush==='function'){this._flush(function(er,data){done(_this,er,data);});}else{done(this,null,null);}}Transform.prototype.push=function(chunk,encoding){this._transformState.needTransform=false;return Duplex.prototype.push.call(this,chunk,encoding);};Transform.prototype._transform=function(chunk,encoding,cb){throw new Error('_transform() is not implemented');};Transform.prototype._write=function(chunk,encoding,cb){var ts=this._transformState;ts.writecb=cb;ts.writechunk=chunk;ts.writeencoding=encoding;if(!ts.transforming){var rs=this._readableState;if(ts.needTransform||rs.needReadable||rs.length<rs.highWaterMark)this._read(rs.highWaterMark);}};Transform.prototype._read=function(n){var ts=this._transformState;if(ts.writechunk!==null&&ts.writecb&&!ts.transforming){ts.transforming=true;this._transform(ts.writechunk,ts.writeencoding,ts.afterTransform);}else{ts.needTransform=true;}};Transform.prototype._destroy=function(err,cb){var _this2=this;Duplex.prototype._destroy.call(this,err,function(err2){cb(err2);_this2.emit('close');});};function done(stream,er,data){if(er)return stream.emit('error',er);if(data!=null)stream.push(data);if(stream._writableState.length)throw new Error('Calling transform done when ws.length != 0');if(stream._transformState.transforming)throw new Error('Calling transform done when still transforming');return stream.push(null);}},{'./_stream_duplex':117,'core-util-is':16,'inherits':74}],121:[function(require,module,exports){(function(process,global,setImmediate){(function(){'use strict';var pna=require('process-nextick-args');module.exports=Writable;function WriteReq(chunk,encoding,cb){this.chunk=chunk;this.encoding=encoding;this.callback=cb;this.next=null;}function CorkedRequest(state){var _this=this;this.next=null;this.entry=null;this.finish=function(){onCorkedFinish(_this,state);};}var asyncWrite=!process.browser&&['v0.10','v0.9.'].indexOf(process.version.slice(0,5))>-1?setImmediate:pna.nextTick;var Duplex;Writable.WritableState=WritableState;var util=Object.create(require('core-util-is'));util.inherits=require('inherits');var internalUtil={deprecate:require('util-deprecate')};var Stream=require('./internal/streams/stream');var Buffer=require('safe-buffer').Buffer;var OurUint8Array=(typeof global!=='undefined'?global:typeof window!=='undefined'?window:typeof self!=='undefined'?self:{}).Uint8Array||function(){};function _uint8ArrayToBuffer(chunk){return Buffer.from(chunk);}function _isUint8Array(obj){return Buffer.isBuffer(obj)||obj instanceof OurUint8Array;}var destroyImpl=require('./internal/streams/destroy');util.inherits(Writable,Stream);function nop(){}function WritableState(options,stream){Duplex=Duplex||require('./_stream_duplex');options=options||{};var isDuplex=stream instanceof Duplex;this.objectMode=!!options.objectMode;if(isDuplex)this.objectMode=this.objectMode||!!options.writableObjectMode;var hwm=options.highWaterMark;var writableHwm=options.writableHighWaterMark;var defaultHwm=this.objectMode?16:16*1024;if(hwm||hwm===0)this.highWaterMark=hwm;else if(isDuplex&&(writableHwm||writableHwm===0))this.highWaterMark=writableHwm;else this.highWaterMark=defaultHwm;this.highWaterMark=Math.floor(this.highWaterMark);this.finalCalled=false;this.needDrain=false;this.ending=false;this.ended=false;this.finished=false;this.destroyed=false;var noDecode=options.decodeStrings===false;this.decodeStrings=!noDecode;this.defaultEncoding=options.defaultEncoding||'utf8';this.length=0;this.writing=false;this.corked=0;this.sync=true;this.bufferProcessing=false;this.onwrite=function(er){onwrite(stream,er);};this.writecb=null;this.writelen=0;this.bufferedRequest=null;this.lastBufferedRequest=null;this.pendingcb=0;this.prefinished=false;this.errorEmitted=false;this.bufferedRequestCount=0;this.corkedRequestsFree=new CorkedRequest(this);}WritableState.prototype.getBuffer=function getBuffer(){var current=this.bufferedRequest;var out=[];while(current){out.push(current);current=current.next;}return out;};(function(){try{Object.defineProperty(WritableState.prototype,'buffer',{get:internalUtil.deprecate(function(){return this.getBuffer();},'_writableState.buffer is deprecated. Use _writableState.getBuffer '+'instead.','DEP0003')});}catch(_){}}());var realHasInstance;if(typeof Symbol==='function'&&Symbol.hasInstance&&typeof Function.prototype[Symbol.hasInstance]==='function'){realHasInstance=Function.prototype[Symbol.hasInstance];Object.defineProperty(Writable,Symbol.hasInstance,{value:function(object){if(realHasInstance.call(this,object))return true;if(this!==Writable)return false;return object&&object._writableState instanceof WritableState;}});}else{realHasInstance=function(object){return object instanceof this;};}function Writable(options){Duplex=Duplex||require('./_stream_duplex');if(!realHasInstance.call(Writable,this)&&!(this instanceof Duplex)){return new Writable(options);}this._writableState=new WritableState(options,this);this.writable=true;if(options){if(typeof options.write==='function')this._write=options.write;if(typeof options.writev==='function')this._writev=options.writev;if(typeof options.destroy==='function')this._destroy=options.destroy;if(typeof options.final==='function')this._final=options.final;}Stream.call(this);}Writable.prototype.pipe=function(){this.emit('error',new Error('Cannot pipe, not readable'));};function writeAfterEnd(stream,cb){var er=new Error('write after end');stream.emit('error',er);pna.nextTick(cb,er);}function validChunk(stream,state,chunk,cb){var valid=true;var er=false;if(chunk===null){er=new TypeError('May not write null values to stream');}else if(typeof chunk!=='string'&&chunk!==undefined&&!state.objectMode){er=new TypeError('Invalid non-string/buffer chunk');}if(er){stream.emit('error',er);pna.nextTick(cb,er);valid=false;}return valid;}Writable.prototype.write=function(chunk,encoding,cb){var state=this._writableState;var ret=false;var isBuf=!state.objectMode&&_isUint8Array(chunk);if(isBuf&&!Buffer.isBuffer(chunk)){chunk=_uint8ArrayToBuffer(chunk);}if(typeof encoding==='function'){cb=encoding;encoding=null;}if(isBuf)encoding='buffer';else if(!encoding)encoding=state.defaultEncoding;if(typeof cb!=='function')cb=nop;if(state.ended)writeAfterEnd(this,cb);else if(isBuf||validChunk(this,state,chunk,cb)){state.pendingcb++;ret=writeOrBuffer(this,state,isBuf,chunk,encoding,cb);}return ret;};Writable.prototype.cork=function(){var state=this._writableState;state.corked++;};Writable.prototype.uncork=function(){var state=this._writableState;if(state.corked){state.corked--;if(!state.writing&&!state.corked&&!state.bufferProcessing&&state.bufferedRequest)clearBuffer(this,state);}};Writable.prototype.setDefaultEncoding=function setDefaultEncoding(encoding){if(typeof encoding==='string')encoding=encoding.toLowerCase();if(!(['hex','utf8','utf-8','ascii','binary','base64','ucs2','ucs-2','utf16le','utf-16le','raw'].indexOf((encoding+'').toLowerCase())>-1))throw new TypeError('Unknown encoding: '+encoding);this._writableState.defaultEncoding=encoding;return this;};function decodeChunk(state,chunk,encoding){if(!state.objectMode&&state.decodeStrings!==false&&typeof chunk==='string'){chunk=Buffer.from(chunk,encoding);}return chunk;}Object.defineProperty(Writable.prototype,'writableHighWaterMark',{enumerable:false,get:function(){return this._writableState.highWaterMark;}});function writeOrBuffer(stream,state,isBuf,chunk,encoding,cb){if(!isBuf){var newChunk=decodeChunk(state,chunk,encoding);if(chunk!==newChunk){isBuf=true;encoding='buffer';chunk=newChunk;}}var len=state.objectMode?1:chunk.length;state.length+=len;var ret=state.length<state.highWaterMark;if(!ret)state.needDrain=true;if(state.writing||state.corked){var last=state.lastBufferedRequest;state.lastBufferedRequest={chunk:chunk,encoding:encoding,isBuf:isBuf,callback:cb,next:null};if(last){last.next=state.lastBufferedRequest;}else{state.bufferedRequest=state.lastBufferedRequest;}state.bufferedRequestCount+=1;}else{doWrite(stream,state,false,len,chunk,encoding,cb);}return ret;}function doWrite(stream,state,writev,len,chunk,encoding,cb){state.writelen=len;state.writecb=cb;state.writing=true;state.sync=true;if(writev)stream._writev(chunk,state.onwrite);else stream._write(chunk,encoding,state.onwrite);state.sync=false;}function onwriteError(stream,state,sync,er,cb){--state.pendingcb;if(sync){pna.nextTick(cb,er);pna.nextTick(finishMaybe,stream,state);stream._writableState.errorEmitted=true;stream.emit('error',er);}else{cb(er);stream._writableState.errorEmitted=true;stream.emit('error',er);finishMaybe(stream,state);}}function onwriteStateUpdate(state){state.writing=false;state.writecb=null;state.length-=state.writelen;state.writelen=0;}function onwrite(stream,er){var state=stream._writableState;var sync=state.sync;var cb=state.writecb;onwriteStateUpdate(state);if(er)onwriteError(stream,state,sync,er,cb);else{var finished=needFinish(state);if(!finished&&!state.corked&&!state.bufferProcessing&&state.bufferedRequest){clearBuffer(stream,state);}if(sync){asyncWrite(afterWrite,stream,state,finished,cb);}else{afterWrite(stream,state,finished,cb);}}}function afterWrite(stream,state,finished,cb){if(!finished)onwriteDrain(stream,state);state.pendingcb--;cb();finishMaybe(stream,state);}function onwriteDrain(stream,state){if(state.length===0&&state.needDrain){state.needDrain=false;stream.emit('drain');}}function clearBuffer(stream,state){state.bufferProcessing=true;var entry=state.bufferedRequest;if(stream._writev&&entry&&entry.next){var l=state.bufferedRequestCount;var buffer=new Array(l);var holder=state.corkedRequestsFree;holder.entry=entry;var count=0;var allBuffers=true;while(entry){buffer[count]=entry;if(!entry.isBuf)allBuffers=false;entry=entry.next;count+=1;}buffer.allBuffers=allBuffers;doWrite(stream,state,true,state.length,buffer,'',holder.finish);state.pendingcb++;state.lastBufferedRequest=null;if(holder.next){state.corkedRequestsFree=holder.next;holder.next=null;}else{state.corkedRequestsFree=new CorkedRequest(state);}state.bufferedRequestCount=0;}else{while(entry){var chunk=entry.chunk;var encoding=entry.encoding;var cb=entry.callback;var len=state.objectMode?1:chunk.length;doWrite(stream,state,false,len,chunk,encoding,cb);entry=entry.next;state.bufferedRequestCount--;if(state.writing){break;}}if(entry===null)state.lastBufferedRequest=null;}state.bufferedRequest=entry;state.bufferProcessing=false;}Writable.prototype._write=function(chunk,encoding,cb){cb(new Error('_write() is not implemented'));};Writable.prototype._writev=null;Writable.prototype.end=function(chunk,encoding,cb){var state=this._writableState;if(typeof chunk==='function'){cb=chunk;chunk=null;encoding=null;}else if(typeof encoding==='function'){cb=encoding;encoding=null;}if(chunk!==null&&chunk!==undefined)this.write(chunk,encoding);if(state.corked){state.corked=1;this.uncork();}if(!state.ending)endWritable(this,state,cb);};function needFinish(state){return state.ending&&state.length===0&&state.bufferedRequest===null&&!state.finished&&!state.writing;}function callFinal(stream,state){stream._final(function(err){state.pendingcb--;if(err){stream.emit('error',err);}state.prefinished=true;stream.emit('prefinish');finishMaybe(stream,state);});}function prefinish(stream,state){if(!state.prefinished&&!state.finalCalled){if(typeof stream._final==='function'){state.pendingcb++;state.finalCalled=true;pna.nextTick(callFinal,stream,state);}else{state.prefinished=true;stream.emit('prefinish');}}}function finishMaybe(stream,state){var need=needFinish(state);if(need){prefinish(stream,state);if(state.pendingcb===0){state.finished=true;stream.emit('finish');}}return need;}function endWritable(stream,state,cb){state.ending=true;finishMaybe(stream,state);if(cb){if(state.finished)pna.nextTick(cb);else stream.once('finish',cb);}state.ended=true;stream.writable=false;}function onCorkedFinish(corkReq,state,err){var entry=corkReq.entry;corkReq.entry=null;while(entry){var cb=entry.callback;state.pendingcb--;cb(err);entry=entry.next;}state.corkedRequestsFree.next=corkReq;}Object.defineProperty(Writable.prototype,'destroyed',{get:function(){if(this._writableState===undefined){return false;}return this._writableState.destroyed;},set:function(value){if(!this._writableState){return;}this._writableState.destroyed=value;}});Writable.prototype.destroy=destroyImpl.destroy;Writable.prototype._undestroy=destroyImpl.undestroy;Writable.prototype._destroy=function(err,cb){this.end();cb(err);};}.call(this));}.call(this,require('_process'),typeof global!=='undefined'?global:typeof self!=='undefined'?self:typeof window!=='undefined'?window:{},require('timers').setImmediate));},{'./_stream_duplex':117,'./internal/streams/destroy':123,'./internal/streams/stream':124,'_process':94,'core-util-is':16,'inherits':74,'process-nextick-args':93,'safe-buffer':129,'timers':131,'util-deprecate':132}],122:[function(require,module,exports){'use strict';function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor)){throw new TypeError('Cannot call a class as a function');}}var Buffer=require('safe-buffer').Buffer;var util=require('util');function copyBuffer(src,target,offset){src.copy(target,offset);}module.exports=function(){function BufferList(){_classCallCheck(this,BufferList);this.head=null;this.tail=null;this.length=0;}BufferList.prototype.push=function push(v){var entry={data:v,next:null};if(this.length>0)this.tail.next=entry;else this.head=entry;this.tail=entry;++this.length;};BufferList.prototype.unshift=function unshift(v){var entry={data:v,next:this.head};if(this.length===0)this.tail=entry;this.head=entry;++this.length;};BufferList.prototype.shift=function shift(){if(this.length===0)return;var ret=this.head.data;if(this.length===1)this.head=this.tail=null;else this.head=this.head.next;--this.length;return ret;};BufferList.prototype.clear=function clear(){this.head=this.tail=null;this.length=0;};BufferList.prototype.join=function join(s){if(this.length===0)return'';var p=this.head;var ret=''+p.data;while(p=p.next){ret+=s+p.data;}return ret;};BufferList.prototype.concat=function concat(n){if(this.length===0)return Buffer.alloc(0);var ret=Buffer.allocUnsafe(n>>>0);var p=this.head;var i=0;while(p){copyBuffer(p.data,ret,i);i+=p.data.length;p=p.next;}return ret;};return BufferList;}();if(util&&util.inspect&&util.inspect.custom){module.exports.prototype[util.inspect.custom]=function(){var obj=util.inspect({length:this.length});return this.constructor.name+' '+obj;};}},{'safe-buffer':129,'util':11}],123:[function(require,module,exports){'use strict';var pna=require('process-nextick-args');function destroy(err,cb){var _this=this;var readableDestroyed=this._readableState&&this._readableState.destroyed;var writableDestroyed=this._writableState&&this._writableState.destroyed;if(readableDestroyed||writableDestroyed){if(cb){cb(err);}else if(err){if(!this._writableState){pna.nextTick(emitErrorNT,this,err);}else if(!this._writableState.errorEmitted){this._writableState.errorEmitted=true;pna.nextTick(emitErrorNT,this,err);}}return this;}if(this._readableState){this._readableState.destroyed=true;}if(this._writableState){this._writableState.destroyed=true;}this._destroy(err||null,function(err){if(!cb&&err){if(!_this._writableState){pna.nextTick(emitErrorNT,_this,err);}else if(!_this._writableState.errorEmitted){_this._writableState.errorEmitted=true;pna.nextTick(emitErrorNT,_this,err);}}else if(cb){cb(err);}});return this;}function undestroy(){if(this._readableState){this._readableState.destroyed=false;this._readableState.reading=false;this._readableState.ended=false;this._readableState.endEmitted=false;}if(this._writableState){this._writableState.destroyed=false;this._writableState.ended=false;this._writableState.ending=false;this._writableState.finalCalled=false;this._writableState.prefinished=false;this._writableState.finished=false;this._writableState.errorEmitted=false;}}function emitErrorNT(self,err){self.emit('error',err);}module.exports={destroy:destroy,undestroy:undestroy};},{'process-nextick-args':93}],124:[function(require,module,exports){module.exports=require('events').EventEmitter;},{'events':60}],125:[function(require,module,exports){module.exports=require('./readable').PassThrough;},{'./readable':126}],126:[function(require,module,exports){exports=module.exports=require('./lib/_stream_readable.js');exports.Stream=exports;exports.Readable=exports;exports.Writable=require('./lib/_stream_writable.js');exports.Duplex=require('./lib/_stream_duplex.js');exports.Transform=require('./lib/_stream_transform.js');exports.PassThrough=require('./lib/_stream_passthrough.js');},{'./lib/_stream_duplex.js':117,'./lib/_stream_passthrough.js':118,'./lib/_stream_readable.js':119,'./lib/_stream_transform.js':120,'./lib/_stream_writable.js':121}],127:[function(require,module,exports){module.exports=require('./readable').Transform;},{'./readable':126}],128:[function(require,module,exports){module.exports=require('./lib/_stream_writable.js');},{'./lib/_stream_writable.js':121}],129:[function(require,module,exports){arguments[4][12][0].apply(exports,arguments);},{'buffer':14,'dup':12}],130:[function(require,module,exports){'use strict';var Buffer=require('safe-buffer').Buffer;var isEncoding=Buffer.isEncoding||function(encoding){encoding=''+encoding;switch(encoding&&encoding.toLowerCase()){case'hex':case'utf8':case'utf-8':case'ascii':case'binary':case'base64':case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':case'raw':return true;default:return false;}};function _normalizeEncoding(enc){if(!enc)return'utf8';var retried;while(true){switch(enc){case'utf8':case'utf-8':return'utf8';case'ucs2':case'ucs-2':case'utf16le':case'utf-16le':return'utf16le';case'latin1':case'binary':return'latin1';case'base64':case'ascii':case'hex':return enc;default:if(retried)return;enc=(''+enc).toLowerCase();retried=true;}}};function normalizeEncoding(enc){var nenc=_normalizeEncoding(enc);if(typeof nenc!=='string'&&(Buffer.isEncoding===isEncoding||!isEncoding(enc)))throw new Error('Unknown encoding: '+enc);return nenc||enc;}exports.StringDecoder=StringDecoder;function StringDecoder(encoding){this.encoding=normalizeEncoding(encoding);var nb;switch(this.encoding){case'utf16le':this.text=utf16Text;this.end=utf16End;nb=4;break;case'utf8':this.fillLast=utf8FillLast;nb=4;break;case'base64':this.text=base64Text;this.end=base64End;nb=3;break;default:this.write=simpleWrite;this.end=simpleEnd;return;}this.lastNeed=0;this.lastTotal=0;this.lastChar=Buffer.allocUnsafe(nb);}StringDecoder.prototype.write=function(buf){if(buf.length===0)return'';var r;var i;if(this.lastNeed){r=this.fillLast(buf);if(r===undefined)return'';i=this.lastNeed;this.lastNeed=0;}else{i=0;}if(i<buf.length)return r?r+this.text(buf,i):this.text(buf,i);return r||'';};StringDecoder.prototype.end=utf8End;StringDecoder.prototype.text=utf8Text;StringDecoder.prototype.fillLast=function(buf){if(this.lastNeed<=buf.length){buf.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed);return this.lastChar.toString(this.encoding,0,this.lastTotal);}buf.copy(this.lastChar,this.lastTotal-this.lastNeed,0,buf.length);this.lastNeed-=buf.length;};function utf8CheckByte(byte){if(byte<=127)return 0;else if(byte>>5===6)return 2;else if(byte>>4===14)return 3;else if(byte>>3===30)return 4;return byte>>6===2?-1:-2;}function utf8CheckIncomplete(self,buf,i){var j=buf.length-1;if(j<i)return 0;var nb=utf8CheckByte(buf[j]);if(nb>=0){if(nb>0)self.lastNeed=nb-1;return nb;}if(--j<i||nb===-2)return 0;nb=utf8CheckByte(buf[j]);if(nb>=0){if(nb>0)self.lastNeed=nb-2;return nb;}if(--j<i||nb===-2)return 0;nb=utf8CheckByte(buf[j]);if(nb>=0){if(nb>0){if(nb===2)nb=0;else self.lastNeed=nb-3;}return nb;}return 0;}function utf8CheckExtraBytes(self,buf,p){if((buf[0]&192)!==128){self.lastNeed=0;return'\uFFFD';}if(self.lastNeed>1&&buf.length>1){if((buf[1]&192)!==128){self.lastNeed=1;return'\uFFFD';}if(self.lastNeed>2&&buf.length>2){if((buf[2]&192)!==128){self.lastNeed=2;return'\uFFFD';}}}}function utf8FillLast(buf){var p=this.lastTotal-this.lastNeed;var r=utf8CheckExtraBytes(this,buf,p);if(r!==undefined)return r;if(this.lastNeed<=buf.length){buf.copy(this.lastChar,p,0,this.lastNeed);return this.lastChar.toString(this.encoding,0,this.lastTotal);}buf.copy(this.lastChar,p,0,buf.length);this.lastNeed-=buf.length;}function utf8Text(buf,i){var total=utf8CheckIncomplete(this,buf,i);if(!this.lastNeed)return buf.toString('utf8',i);this.lastTotal=total;var end=buf.length-(total-this.lastNeed);buf.copy(this.lastChar,0,end);return buf.toString('utf8',i,end);}function utf8End(buf){var r=buf&&buf.length?this.write(buf):'';if(this.lastNeed)return r+'\uFFFD';return r;}function utf16Text(buf,i){if((buf.length-i)%2===0){var r=buf.toString('utf16le',i);if(r){var c=r.charCodeAt(r.length-1);if(c>=55296&&c<=56319){this.lastNeed=2;this.lastTotal=4;this.lastChar[0]=buf[buf.length-2];this.lastChar[1]=buf[buf.length-1];return r.slice(0,-1);}}return r;}this.lastNeed=1;this.lastTotal=2;this.lastChar[0]=buf[buf.length-1];return buf.toString('utf16le',i,buf.length-1);}function utf16End(buf){var r=buf&&buf.length?this.write(buf):'';if(this.lastNeed){var end=this.lastTotal-this.lastNeed;return r+this.lastChar.toString('utf16le',0,end);}return r;}function base64Text(buf,i){var n=(buf.length-i)%3;if(n===0)return buf.toString('base64',i);this.lastNeed=3-n;this.lastTotal=3;if(n===1){this.lastChar[0]=buf[buf.length-1];}else{this.lastChar[0]=buf[buf.length-2];this.lastChar[1]=buf[buf.length-1];}return buf.toString('base64',i,buf.length-n);}function base64End(buf){var r=buf&&buf.length?this.write(buf):'';if(this.lastNeed)return r+this.lastChar.toString('base64',0,3-this.lastNeed);return r;}function simpleWrite(buf){return buf.toString(this.encoding);}function simpleEnd(buf){return buf&&buf.length?this.write(buf):'';}},{'safe-buffer':129}],131:[function(require,module,exports){(function(setImmediate,clearImmediate){(function(){var nextTick=require('process/browser.js').nextTick;var apply=Function.prototype.apply;var slice=Array.prototype.slice;var immediateIds={};var nextImmediateId=0;exports.setTimeout=function(){return new Timeout(apply.call(setTimeout,window,arguments),clearTimeout);};exports.setInterval=function(){return new Timeout(apply.call(setInterval,window,arguments),clearInterval);};exports.clearTimeout=exports.clearInterval=function(timeout){timeout.close();};function Timeout(id,clearFn){this._id=id;this._clearFn=clearFn;}Timeout.prototype.unref=Timeout.prototype.ref=function(){};Timeout.prototype.close=function(){this._clearFn.call(window,this._id);};exports.enroll=function(item,msecs){clearTimeout(item._idleTimeoutId);item._idleTimeout=msecs;};exports.unenroll=function(item){clearTimeout(item._idleTimeoutId);item._idleTimeout=-1;};exports._unrefActive=exports.active=function(item){clearTimeout(item._idleTimeoutId);var msecs=item._idleTimeout;if(msecs>=0){item._idleTimeoutId=setTimeout(function onTimeout(){if(item._onTimeout)item._onTimeout();},msecs);}};exports.setImmediate=typeof setImmediate==='function'?setImmediate:function(fn){var id=nextImmediateId++;var args=arguments.length<2?false:slice.call(arguments,1);immediateIds[id]=true;nextTick(function onNextTick(){if(immediateIds[id]){if(args){fn.apply(null,args);}else{fn.call(null);}exports.clearImmediate(id);}});return id;};exports.clearImmediate=typeof clearImmediate==='function'?clearImmediate:function(id){delete immediateIds[id];};}.call(this));}.call(this,require('timers').setImmediate,require('timers').clearImmediate));},{'process/browser.js':94,'timers':131}],132:[function(require,module,exports){(function(global){(function(){module.exports=deprecate;function deprecate(fn,msg){if(config('noDeprecation')){return fn;}var warned=false;function deprecated(){if(!warned){if(config('throwDeprecation')){throw new Error(msg);}else if(config('traceDeprecation')){console.trace(msg);}else{console.warn(msg);}warned=true;}return fn.apply(this,arguments);}return deprecated;}function config(name){try{if(!global.localStorage)return false;}catch(_){return false;}var val=global.localStorage[name];if(null==val)return false;return String(val).toLowerCase()==='true';}}.call(this));}.call(this,typeof global!=='undefined'?global:typeof self!=='undefined'?self:typeof window!=='undefined'?window:{}));},{}]},{},[1])(1);}));